  @echo off
setlocal enabledelayedexpansion enableextensions


	REM ######################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

goto :SETUP



	
	REM ######################################################
:SETUP

		rem set bat_logdir= blanks out the bat_logdir variable, triggering it to be
		rem use "..\Logs".  
	set bat_logdir=
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	if not defined bat_calftppassword (
		set bat_calftppassword=.
	)
	
rem	!bat_CALL! "!bat_exedir!\ReadConfig.bat"

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	
		REM Get bat_DriveLetter and the ftp connection parameters
	!bat_CALL! "!bat_exedir!\ReadRemoteConfig.bat"	

	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! `     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_returncode=0

	
	call :PARSEARGS %*

:SETUP_END


goto :MAIN




	


	REM ###############################################################################
	REM
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %*

	call :GET_SERVER_FILE_LIST
	
	call :FILTER_LIST



:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [!bat_returncode!]
!bat_log!
!bat_WAIT! 3
goto :DONE !bat_returncode!




	REM ######################################################
	REM 
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	echo.%*|find /i "autonomous"
	if !errorlevel! equ 0 (
		!bat_logexeclog!set bat_autonomous=autonomous
	)

	REM This section parses the command line argument switches
:PARSEARGS_LOOP
 !bat_log! :PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" goto :PARSEARGS_LOOPBREAK
	

	if /i "%~1" equ "/targetdir" (
		!bat_logexeclog! set bat_targetdir=%~2

		shift
		shift
		goto :PARSEARGS_LOOP

	)
	


	
:PARSEARGS_LOOPBREAK
	!bat_log!
	!bat_log! [GOTO !bat_batchfile!:PARSEARGS_LOOPBREAK] %*
	!bat_log!

	!bat_logexeclog! set bat_ftp_tempdir=!bat_targetdir!
	!bat_logexeclog! set bat_ftp_dest_dir=!bat_targetdir!
	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt


	set bat_caldir=!bat_exedir!\Cal
	rem	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

	!bat_logexeclog! set bat_autocal_remote_queue_dir=!bat_camsdir!\AutoCal_Remote_Queue
	!bat_logexeclog! set bat_autocal_remote_queue=!bat_autocal_remote_queue_dir!\AutoCal_Remote_Queue.txt



		rem CALSTARS0758_2016_01_29_14_36_20_02
		rem The _Results.zip file will contain the resulting cal files, detect file, and autocalupdate.log file.
		rem The _Results.txt file will contain the first line being the md5 hash of the zip file. The remaining lines will contain error text if any occured and autocal failed.
		rem                  This md5 hash will be used on the client side to check the md5 hash of the downloaded file to verify that the zip file was downloaded ok before trying
		rem                  to unzip the zip file.
	!bat_logexeclog!        set bat_zipfile=CALSTARS????_*.zip
	!bat_logexeclog! set bat_zipresultsfile=CALSTARS????_????_??_??_??_??_??_??_Results.zip
	!bat_logexeclog!     set bat_zipmd5file=CALSTARS????_????_??_??_??_??_??_??_Results.txt
	!bat_logexeclog! set bat_zip=!bat_zipfile!


:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [
!bat_log! `                                      bat_ftp_dest_dir=!bat_ftp_dest_dir!
!bat_log! `                                      bat_ftp_tempdir=!bat_ftp_tempdir!
!bat_log! `                                      bat_ftpfile=!bat_ftpfile!
!bat_log! `                                      bat_ftpfile2=!bat_ftpfile2!
!bat_log! `                                      bat_ftp_tempfile5=!bat_ftp_tempfile5!
!bat_log! `                                      bat_ftp_tempResults2=!bat_ftp_tempResults2!
!bat_log! `                                      bat_ftp_tempfile3=!bat_ftp_tempfile3!
!bat_log! `                                      bat_zipfile=!bat_zipfile!
!bat_log! `                                      bat_zipresultsfile=!bat_zipresultsfile!
!bat_log! `                                      bat_zipmd5file=!bat_zipmd5file!
!bat_log! `                                      bat_zip=!bat_zip!
!bat_log! `                                      bat_autonomous=!bat_autonomous!
!bat_log! `                                      bat_targetdir=!bat_targetdir!
!bat_log! `                                      bat_workdir=!bat_workdir!
!bat_log! `                                      bat_excludespec=!bat_excludespec!]
!bat_log!
!bat_WAIT! 3
!bat_return!  !bat_returncode!









	REM ######################################################
	REM 
:GET_SERVER_FILE_LIST
	!bat_pushlog! [CALL !bat_batchfile!:GET_SERVER_FILE_LIST] [%1, %2, %3]

	!bat_logexec! set bat_ftpfile2="!bat_targetdir!\ftp.temp_2.txt"
	

	!bat_echolog! Now download a list of files using the "ls" ftp command file "!bat_ftpfile!"...
	!bat_pushecho!
	!bat_log! `    Note: Building the "..\ftp.temp.txt" file...

		REM Get a list of all CALSTARS0*_Deletable.txt	files into "ftp.temp_2.txt"
	echo.user !bat_calftpuser!>"!bat_ftpfile!"
	echo.!bat_calftppassword!>>"!bat_ftpfile!"
	echo.bin>>"!bat_ftpfile!"
	echo.cd !bat_calftpdir!>>"!bat_ftpfile!"
	echo.literal pasv>>"!bat_ftpfile!"
	echo.lcd "!bat_ftp_tempdir!">>!bat_ftpfile!"
	echo.literal pasv>>"!bat_ftpfile!"
	echo.ls "CALSTARS0*">>!bat_ftpfile!"
	echo.quit>>"!bat_ftpfile!"

	!bat_logexec! TYPE "!bat_ftpfile!"
	
	

	!bat_log!
	!bat_log! Fetching a complete list of all files that we need to interrogate into bat_ftpfile2 ["..\ftp.temp_2.txt"]...
	!bat_log!
	!bat_log! FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"][FINDSTR /r /i "^calstars0..._.*\..*"}"!bat_ftpfile2!"
			  FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"| FINDSTR /r /i "^calstars0..._.*\..*">"!bat_ftpfile2!"
		REM FTP doesn't produce an errorlevel like it should so don't bother checking it.
	!bat_log!

	!bat_logexeclog! TYPE "!bat_ftpfile2!"
	set bat_returncode=!errorlevel!

:GET_SERVER_FILE_LIST_END
!bat_poplog! [RETURN !bat_batchfile!:GET_SERVER_FILE_LIST] [!bat_returncode!]
!bat_log!
!bat_WAIT! 3
!bat_return! !bat_returncode!



	REM ###############################################################################
	REM 
:FILTER_LIST
	set bat_resultsflagfile=_Deletable.txt

	echo user !bat_calftpuser!>"!bat_ftp_tempdir!\FTP_delete.txt"
	echo !bat_calftppassword!>>"!bat_ftp_tempdir!\FTP_delete.txt"
	echo bin>>"!bat_ftp_tempdir!\FTP_delete.txt"
	echo cd !bat_calftpdir!>>"!bat_ftp_tempdir!\FTP_delete.txt"
	echo literal pasv>>"!bat_ftp_tempdir!\FTP_delete.txt"
	
				
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`FINDSTR /i /r /c:"CALSTARS0..._...._.._.._.._.._.._.._Deletable\.txt" "!bat_ftpfile2!"`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`FINDSTR /i /r /c:"CALSTARS0..._...._.._.._.._.._.._.._Deletable\.txt" "!bat_ftpfile2!"`) do (

		!bat_logexec! set bat_download=%%a
			
		!bat_log! **** "_Deletable.txt" file: "%%a"...
		
		!bat_echolog! Now download "!bat_download!"...
		!bat_pushecho!
		!bat_log! `    Note: Building the "..\ftp.temp.txt" file...

			REM Get a list of all CALSTARS0*_Deletable.txt	files into "ftp.temp_2.txt"
		echo.user !bat_calftpuser!>"!bat_ftpfile!"
		echo.!bat_calftppassword!>>"!bat_ftpfile!"
		echo.bin>>"!bat_ftpfile!"
		echo.cd !bat_calftpdir!>>"!bat_ftpfile!"
		echo.literal pasv>>"!bat_ftpfile!"
		echo.lcd "!bat_ftp_tempdir!">>!bat_ftpfile!"
		echo.literal pasv>>"!bat_ftpfile!"
		echo.get "!bat_download!">>!bat_ftpfile!"
		echo.quit>>"!bat_ftpfile!"

		!bat_logexec! TYPE "!bat_ftpfile!"
		
		

		!bat_echolog! ================================================

			REM ==========RUN THE FTP COMMAND to download the "_Deletable.txt" file, BUT IT DOESN'T SHOW ANYTHING UNTIL IT'S ALL DONE =================
		!bat_logexec! call FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"
		set bat_returncode=!bat_logexec_returncode!

		!bat_echolog!
		!bat_echolog! `    FTP exit code=!bat_returncode!
		!bat_echolog!
					
		FOR /F "usebackq tokens=*" %%i in ("!bat_ftp_tempdir!\!bat_download!") DO (
			echo mdelete %%i>>"!bat_ftp_tempdir!\FTP_delete.txt"
		)

		echo quit>>"!bat_ftp_tempdir!\FTP_delete.txt"

			REM Display and log the new command file contents so that there is 
			REM a track record of what will be attempted...
		!bat_logexec! TYPE "!bat_ftp_tempdir!\FTP_delete.txt"
				   
		!bat_echolog! `..............................................
					
		!bat_popecho!
		!bat_pushecho! Execute the FTP command file...==========================
						
		!bat_logexec! CALL FTP -i -n -s:"!bat_ftp_tempdir!\FTP_delete.txt" !bat_calftpsite!
		set bat_returncode=!bat_logexec_returncode!
		
		REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		!bat_popecho! ...DONE~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			
		!bat_poplog!............................
	)
	!bat_poplog! ^) end of: for               /f "usebackq tokens=*" %%a in  (`FINDSTR /r /i /c:"!bat_resultsflagfile!" "!bat_ftpfile2!"`)


:FILTER_LIST_END
!bat_poplog! [RETURN !bat_batchfile!:FILTER_LIST] [!bat_returncode!]
!bat_log!
!bat_WAIT! 3
!bat_return! !bat_returncode!



:HELP
	echo.%~0 - Batch Script
	echo.
	echo.Usage: %~0 /targetdir "dir to work in"
	echo.
	echo.
	echo.
	echo.

exit /b 99




:DONE
		!bat_popecho! ...DONE~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
