@echo off
setlocal enableextensions enabledelayedexpansion


	REM #################################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*



	REM #################################################################################
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	CALL "!bat_exedir!\ReadParams.bat"
	
	%bat_TITLE% %~nx0
	
	!bat_logexeclog! bat_ftpfile=!bat_camsdir!\ftp.temp.txt

	set bat_returncode=0

	call :PARSEARGS %*
	
	call :MAIN %*


goto :DONE



	REM #################################################################################
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %*

	if "!bat_TempCalFromZipName!" equ "" (
		set bat_returncode=1
		!bat_echolog! 
		!bat_echolog! ERROR - [bat_returncode=!bat_returncode!] No source zip file specified [!bat_TempCalFromZipFull!]
		!bat_echolog! 
		goto :MAIN_END
	)
	
	if "!bat_TempCalFromZipExt!" neq ".zip" (
		set bat_returncode=2
		!bat_echolog! 
		!bat_echolog! ERROR - [bat_returncode=!bat_returncode!] File specified is not a zip file [!bat_TempCalFromZipExt!]
		!bat_echolog! 
		goto :MAIN_END
	)



	call :WAIT_FOR_ZIP

	call :SETUP_DIRS 
	if /i "!bat_returncode!" neq "0" (
		goto :MAIN_END
	)

if exist "!bat_cams_root!\Temp\BinFiles" (
	!bat_echolog! #########################################################
	!bat_echolog! #####  "!bat_cams_root!\Temp\BinFiles" 
	!bat_echolog! #########################################################
	!bat_pause!
)
	
	call :UNZIP_RESULTS
	

	call :CLEANUP
	

:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:MAIN] []
!bat_log!
!bat_WAIT! 1
!bat_return! !bat_returncode!



	REM #################################################################################
	REM This AutoCal_Remote.bat script was called typically because the MonitorDir.bat script
	REM called it due to a new CALSTARS000750_2016_01_16_13_01_00.zip showing up. 
	REM This routine's job is to wait for the upload of the zip to finish, in case this
	REM script is called when the file first appears, but before it is done uploading th
	REM entire file.
	REM That zip file will contain everything that is needed for this to run.  It might 
	REM need to include camerasites.txt and a few others, possibly the most recent cal file 
	REM for each camera from that site and maybe the camera files.  
	REM 
:WAIT_FOR_ZIP
!bat_pushlog! [CALL !bat_batchfile!:WAIT_FOR_ZIP] %* [%1, %~dp1, %~nx1]

	!bat_echolog!
	!bat_pushecho! Waiting for the zip file to complete its upload, thus releasing the file: "!bat_TempCalFromZipFull!"...
		!bat_echolog! call WaitForFile.EXE rw "!bat_TempCalFromZipFull!"...
		!bat_echolog!
		!bat_logexeclog! WaitForFile.EXE rw "!bat_TempCalFromZipFull!"
	!bat_popecho! ...It's now ready to process.
	!bat_echolog!


:WAIT_FOR_ZIP_END
!bat_popecho! [RETURN !bat_batchfile!:WAIT_FOR_ZIP] [!bat_TempCalFromZipFull!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!



	REM #################################################################################
:SETUP_DIRS
!bat_pushlog! [CALL !bat_batchfile!:SETUP_DIRS] %* [%1, %~dp1, %~nx1]

	set bat_returncode=0

	if /i "!bat_calstarsdir!" equ "!bat_exedir!" (
		!bat_echolog! 
		!bat_echolog! ERROR - DANGEROUS delete command [del /Q "!bat_calstarsdir!"]
		!bat_echolog!
		!bat_pause!
		set bat_returncode=20
		exit /b !bat_returncode!
	)

	if not exist "!bat_calstarsdir!\zip" (
		!bat_logexeclog! MD "!bat_calstarsdir!\zip"
	)
	
	if exist "!bat_calstarsdir!\zip\*.*" (
		!bat_logexeclog! del /q "!bat_calstarsdir!\zip\*.*"
	)

	if exist "!bat_calstarsdir!\*.*" (
		!bat_logexeclog! del /q "!bat_calstarsdir!\*.*"
	)

	!bat_log! if exist "!bat_calstarsdir!\CapturedFiles"...
	if exist "!bat_calstarsdir!\CapturedFiles" (
		!bat_logexeclog! RD /s /q "!bat_calstarsdir!\CapturedFiles" 
	)

	!bat_log! if exist "!bat_calstarsdir!\ArchivedFiles"...
	if exist "!bat_calstarsdir!\ArchivedFiles" (
		!bat_logexeclog! RD /s /q "!bat_calstarsdir!\ArchivedFiles" 
	)
	
	!bat_log! if exist "!bat_calstarsdir!\stage"...
	if exist "!bat_calstarsdir!\stage" (
		!bat_logexeclog! RD /s /q "!bat_calstarsdir!\stage" 
	)

%bat_COMMENT_BEGIN%
	if not exist "!bat_calstarsdir!\CapturedFiles" (
		!bat_logexeclog! MD "!bat_calstarsdir!\CapturedFiles"
	)

	if not exist "!bat_calstarsdir!\ArchivedFiles" (
		!bat_logexeclog! MD "!bat_calstarsdir!\ArchivedFiles"
	)
%bat_COMMENT_END%


:SETUP_DIRS_END
!bat_popecho! [RETURN !bat_batchfile!:SETUP_DIRS] []
!bat_log!
rem !bat_WAIT! 3
!bat_return! !bat_returncode!




	REM #################################################################################
:UNZIP_RESULTS
!bat_pushlog! [CALL !bat_batchfile!:UNZIP_RESULTS] %*


		REM Unzip the zip file to the bat_calstarsdir
	!bat_CALL! "!bat_exedir!\7unzip.bat" -y -output "!bat_cams_root!" "!bat_ZipFull!" "*"
        set bat_returncode=!bat_logexec_returncode!

	call :REINTRODUCE_FILES
	
	REM ""C:\Cams\Autocams.bat" "c:\CAMS\CapturedFiles\2016_01_06_16_51_42" "c:\CAMS\ArchivedFiles\2016_01_06_16_51_42" "385" autonomous /remote"
	
		REM Convert: "CALSTARS000750_2016_12_31_14_37_59_01_Results" 
		REM to:      "CALSTARS000750_2016_12_31_14_37_59_01.zip"
		REM 
	!bat_logexeclog! set bat_TempCalQueueZipName=!bat_TempCalFromZipName:_Results=.zip!
    
	
	
	for  /f "usebackq tokens=4* delims=," %%a in  (`FINDSTR /I /R /C:"!bat_TempCalQueueZipName!" "!bat_autocal_remote_queue!"`) do (
	
		set bat_cmdline=%%a
		set bat_cmdline=!bat_cmdline:~1,-1!
		
		!bat_echolog! !bat_cmdline!
rem		pause
			REM Run autocams.bat 13, 16, 17
		!bat_CALL! !bat_cmdline!	
		
		
	)
	
	rem !bat_CALL! "!bat_exedir!\AutoCams.bat" "!bat_cams_root!\CapturedFiles\!bat_captureddatetime!" "!bat_cams_root!\ArchivedFiles\!bat_captureddatetime!" "!bat_camera!" autonomous /remote
	
	



:UNZIP_RESULTS_END
!bat_popecho! [RETURN !bat_batchfile!:UNZIP_RESULTS] [!bat_getdirname!, !bat_mainspec!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!






	REM ############################################################################################
	REM Re-introduce the files into the capture session directories.  The capture session is determined
	REM by matching the downloaded Results.zip file with an entry in the queue. 
	REM 
	REM 
	REM 
:REINTRODUCE_FILES
!bat_pushlog! [CALL !bat_batchfile!:REINTRODUCE_FILES] [%*]

	!bat_echolog!
	!bat_echolog! We need to also copy the FF files for the CAL files into the "!bat_cams_root!\Cal\BinFiles" dir
	!bat_echolog!

	call :COPY_CALIBRATED_FF_FILES



		REM builing bat_archivedfilesdir
	!bat_logexeclog! set bat_archivedfilesdir=!bat_cams_root!\ArchivedFiles\!bat_captureddatetime!
	
		REM building FTPdetectinfoFile
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat"   bat_detectfile   "!bat_archivedfilesdir!"

	!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"

	!bat_logexec! findstr /i /c:"Meteor Count = " /c:"FF  folder = " /c:"CAL folder =" /c:"file processed"  "!bat_detectfile!"

:REINTRODUCE_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:REINTRODUCE_FILES] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!



	REM #######################################################################################
	REM Scans the AutoCalUpdate.log file that came back with the _Results.zip.  For each
	REM successful new calibration, copy its corresponding FF file from the 
	REM capturedfiles dir to the "bat_cams_root\Cal\BinFiles\" dir.
	REM 
:COPY_CALIBRATED_FF_FILES
!bat_pushlog! [CALL !bat_batchfile!:COPY_CALIBRATED_FF_FILES] %*

	set bat_returncode=0

		REM ================================================================================
		REM Extract the calibrated info from AutoCalUpdate.log to display, and log it.
		REM
		REM One of the things to do in this section is to determine, from the AutoCalUpdate.log
		REM file which FF file pertains to the new CAL file.
		REM
		REM Here is what an entry will look like in the AutoCalUpdate.log file:
		REM     Camera 758  0   40       1.97  FF758_20160216_183439_723_0340992.bin  CAL758_20160216_183444_010.txt
		REM
	if exist "!bat_cams_root!\Temp\AutoCalUpdate.txt" (
			!bat_logexeclog! DEL /q "!bat_cams_root!\Temp\AutoCalUpdate.txt"
	)
	
		REM Create a list file that contains all the camera results from the AutocalUpdate.log file so we can parse it for those with a success code of "0"
		REM The resulting list will be store into AutoCalUpdate.txt
		REM
	!bat_log! for /f "usebackq tokens=*" ..a in ^(`findstr /i /r /c:"^Camera ... *"  "!bat_cams_root!\CapturedFiles\!bat_captureddatetime!\AutoCalUpdate.log"`) do ...
	for           /f "usebackq tokens=*" %%a in  (`findstr /i /r /c:"^Camera ... *"  "!bat_cams_root!\CapturedFiles\!bat_captureddatetime!\AutoCalUpdate.log"`) do (

		echo.%%a>>"!bat_cams_root!\Temp\AutoCalUpdate.txt"
	)

	!bat_logexeclog! TYPE "!bat_cams_root!\Temp\AutoCalUpdate.txt"
	
		REM For each camera in the AutoCalUpdate.txt list file, copy its FF file [the name is provided in 
		REM the AutoCalUpdate.log file] to the ".\CAMS\Cal\BinFiles" dir.
		REM 
	!bat_log! for /f "usebackq tokens=*" ..a in ^(`findstr /i /r /c:"^Camera ...  0.*"  "!bat_cams_root!\CapturedFiles\!bat_captureddatetime!\AutoCalUpdate.log"`^) do ...
	for           /f "usebackq tokens=*" %%a in  (`findstr /i /r /c:"^Camera ...  0.*"  "!bat_cams_root!\CapturedFiles\!bat_captureddatetime!\AutoCalUpdate.log"`) do (

		!bat_echo! %%a
		set bat_line=%%a

		FOR /F "tokens=6 delims= " %%z IN ("!bat_line!") DO (
rem			echo %%z
			set bat_CalBinFileName=%%z
			!bat_logexeclog! COPY /y "!bat_cams_root!\CapturedFiles\!bat_captureddatetime!\!bat_CalBinFileName!" "!bat_cams_root!\Cal\BinFiles\"
		)
	)


:COPY_CALIBRATED_FF_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:COPY_CALIBRATED_FF_FILES] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!




	REM #######################################################################################
	REM Removes all the files and directories downloaded and/or created during the 
	REM AutoCal_LocalUpload.bat, MonitorDir_Poll_Client.bat, and AutoCal_LocalDownload.bat
	REM 
	REM We may also need to remove the "_Results.zip" and "_Results.txt" from the 
	REM "!bat_calstarsdir!\calstars_client" dir. 
	REM 
:CLEANUP
!bat_pushlog! [CALL !bat_batchfile!:CLEANUP] %*

		REM ===============================================================================
		REM Set the variables related to the queue.  The queue entry will need to be 
		REM removed.  Also, there are a few files related to the queue entry that 
		REM need to be deleted.
		REM
	!bat_logexeclog! set bat_autocal_remote_queue_dir=!bat_cams_root!\AutoCal_Remote_Queue
	!bat_logexeclog! set bat_autocal_remote_queue=!bat_autocal_remote_queue_dir!\AutoCal_Remote_Queue.txt
	
		REM ================================================================================
		REM Set the variables for the results files that need to be deleted
		REM 
	!bat_echolog! bat_TempCalFromZipName=!bat_TempCalFromZipName!
	
		REM Convert: "CALSTARS000750_2016_12_31_14_37_59_01_Results" 
		REM to:      "CALSTARS000750_2016_12_31_14_37_59_01.zip"
		REM 
	!bat_logexeclog! set bat_TempCalQueueZipName=!bat_TempCalFromZipName:_Results=.zip!
	
		REM Convert: "CALSTARS000750_2016_12_31_14_37_59_01_Results" 
		REM to:      "CALSTARS000750_2016_12_31_14_37_59_01_MD5.txt"
		REM 
	!bat_logexeclog! set bat_TempCalQueueMD5Name=!bat_TempCalFromZipName:_Results=_md5.txt!

	REM #############################################################################
	REM This section removes:
	REM    The queue entry from "..\AutoCal_Remote_Queue\AutoCal_Remote_Queue.txt"
	REM    The corresponding "..\AutoCal_Remote_Queue\!bat_TempCalQueueZipName!"
	REM    The corresponding "..\AutoCal_Remote_Queue\!bat_TempCalQueueMD5Name!"
	REM 
:REPLACE
!bat_log! [!bat_batchfile!:CLEANUP::REPLACE] 

		REM ===============================================================================
		REM Remove the queue item from the AutoCal_Remote_Queue.txt file...
		REM 
	!bat_logexeclog! set bat_InputFile=!bat_autocal_remote_queue!
	!bat_logexeclog! set bat_OutputFile=!bat_autocal_remote_queue!.new
	!bat_logexeclog! set bat_strFind=!bat_TempCalQueueZipName!

		REM This command outputs a new queue.txt file with everything but those lines
		REM that have the matching CALSTARS*.zip file name in it.
		REM
	!bat_log! FINDSTR /v /i "!bat_TempCalQueueZipName!" "!bat_autocal_remote_queue!" }} "!bat_autocal_remote_queue!.new"
	          FINDSTR /v /i "!bat_TempCalQueueZipName!" "!bat_autocal_remote_queue!" > "!bat_autocal_remote_queue!.new"
	
	!bat_logexeclog! MOVE /y "!bat_autocal_remote_queue!.new" "!bat_autocal_remote_queue!"

	if exist "!bat_OutputFile!" (
			REM Delete the temporary file if it still exists...  You should never get here because the MOVE command will avoid it. 
		!bat_logexeclog! DEL /q "!bat_autocal_remote_queue!.new"
	)
	



		REM ================================================================================
		REM Delete the following two files:
		REM    Original CALSTARS*.zip
		REM    Original CALSTARS*_md5.txt
		REM 
		
		REM Remove the "CALSTARS000750_2016_12_31_14_37_59_01.zip" from the queue folder
		REM
	if exist "!bat_autocal_remote_queue_dir!\!bat_TempCalQueueZipName!" (
		!bat_logexeclog! DEL /q "!bat_autocal_remote_queue_dir!\!bat_TempCalQueueZipName!"
	)

		REM Remove the "CALSTARS000750_2016_12_31_14_37_59_01_MD5.txt" from the queue folder
		REM 
	if exist "!bat_autocal_remote_queue_dir!\!bat_TempCalQueueMD5Name!" (
		!bat_logexeclog! DEL /q "!bat_autocal_remote_queue_dir!\!bat_TempCalQueueMD5Name!"
	)
	
		REM ================================================================================
		REM Remove the temporary work dirs...
		REM 
	!bat_logexeclog! RD /s /q "!bat_capturedfilesdir!"
	!bat_logexeclog! RD /s /q "!bat_archivedfilesdir!"
	!bat_logexeclog! RD /s /q "!bat_calstarsdir!\stage!"
	!bat_logexeclog! RD /s /q "!bat_calstarsdir!\zip!"


		
	REM ###########################################################################################
	REM Create the _deletable.bat file
	REM 
:DELETABLE
!bat_log! [!bat_batchfile!:CLEANUP::DELETABLE] 

		REM Convert: "CALSTARS000750_2016_12_31_14_37_59_01_Results" 
		REM to:      "CALSTARS000750_2016_12_31_14_37_59_01_Deletable.txt"
		REM 
	!bat_logexeclog! set bat_DeleteFileName=!bat_TempCalFromZipName:_Results=_Deletable.txt!
	!bat_logexeclog! set bat_DeleteFileFull=!bat_CalStarsDir!\!bat_TempCalFromZipName:_Results=_Deletable.txt!
	
	echo."!bat_TempCalQueueZipName!">"!bat_DeleteFileFull!"
	echo."!bat_TempCalQueueMD5Name!">>"!bat_DeleteFileFull!"
	echo."!bat_TempCalFromZipName!.zip">>"!bat_DeleteFileFull!"
	echo."!bat_TempCalFromZipName!.txt">>"!bat_DeleteFileFull!"
	echo."!bat_DeleteFileName!">>"!bat_DeleteFileFull!"
	
	
		!bat_log! `    Note: Building the "..\ftp.temp.txt" file...

			REM Put _Deletable.txt on the ftp
		echo.user !bat_calftpuser!>"!bat_ftpfile!"
		echo.!bat_calftppassword!>>"!bat_ftpfile!"
		echo.bin>>"!bat_ftpfile!"
		echo.cd !bat_calftpdir!>>"!bat_ftpfile!"
		echo.literal pasv>>"!bat_ftpfile!"
		echo.lcd "!bat_CalStarsDir!">>!bat_ftpfile!"
		echo.literal pasv>>"!bat_ftpfile!"
		echo.put "!bat_DeleteFileName!">>"!bat_ftpfile!"
		echo.quit>>"!bat_ftpfile!"

		!bat_logexec! TYPE "!bat_ftpfile!"

		!bat_logexec! call FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"
		set bat_returncode=!bat_logexec_returncode!

		!bat_echolog!
		!bat_echolog! '    FTP exit code=!bat_returncode!
		!bat_echolog!

		REM =============================================================================
		REM Delete the _deleted.txt file...
		REM
	if exist "!bat_DeleteFileFull!" (
		!bat_logexeclog! DEL /q "!bat_DeleteFileFull!"
	)
	
	!bat_echolog!
	!bat_echolog! The Cleanup is finished...
	!bat_logexec! DIR "!bat_calstarsdir! /s/b /on
	
:CLEANUP_END
!bat_popecho! [RETURN !bat_batchfile!:CLEANUP] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!









	REM ############################################################################################
	REM This routine iterates through all the remaining files in the bat_TempCalFrom
	REM dir.  We have to do this because
	REM
	REM Maybe this routine would be better off being a standalone script ["Monitor_ProcessQueue.bat"] 
	REM that is launched as a Scheduled Task as soon as (a) boot; (b) manually.
	REM The reason is so that the queue is emptied before MonitorDir.exe is launched
	REM
:PROCESS_REMAINING_QUEUE
!bat_pushlog! [CALL !bat_batchfile!:PROCESS_REMAINING_QUEUE] %*


:PROCESS_REMAINING_QUEUE_LOOP
	!bat_CALL! "!bat_exedir!\GetFileCount.bat" "!bat_TempCalFrom!\CALSTARS????_????_??_??_??_??_??.zip"
	set bat_CountFrom=!errorlevel!
	
	if not defined bat_CountFrom (
		goto :PROCESS_REMAINING_QUEUE_END
	)

	if !bat_CountFrom! LSS 1 (
		goto :PROCESS_REMAINING_QUEUE_END
	)
	
		REM Convert: "CALSTARS000750_2016_12_31_14_37_59_01_Results" 
		REM to:      "CALSTARS000750_2016_12_31_14_37_59_01_Deletable.txt"
		REM 
	!bat_logexeclog! set bat_DeleteFileName=!bat_TempCalFromZipName:_Results=_Deletable.txt!
	!bat_logexeclog! set bat_DeleteFileFull=!bat_CalStarsDir!\!bat_TempCalFromZipName:_Results=_Deletable.txt!
	
	set bat_TempCalFromZipFull=
	set bat_capturedfilesdir=
	set bat_TempCalFromZipName=
	set bat_TempCalFromZipExt=
rem	set bat_TempCalFrom=!bat_TempCalFrom!
	set bat_captureddate=
	set bat_capturedtime=
	set bat_captureddatetime=
	set bat_calstarsdir=
	set bat_capturedfilesdir=
	set bat_archivedfilesdir=
	set bat_TempCalResults=





	
		REM Loop through the remaining files and skip all but the oldest one...
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_TempCalFrom!\CALSTARS????_????_??_??_??_??_??.zip" /a-d /b /o-d`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_TempCalFrom!\CALSTARS????_????_??_??_??_??_??.zip" /a-d /b /o-d`) do (
		!bat_logexeclog! set bat_TempCalFromZipFull=!bat_TempCalFrom!\%%a
	)
	!bat_poplog! ^)
	

	
	call :PARSEZIP "!bat_TempCalFromZipFull!"

	call :MAIN

	
		REM Go back to the counter section in case new files have arrived...
		REM If we had used a FOR loop, it would not accommodate new files arriving
		REM after the loop started.
	goto :PROCESS_REMAINING_QUEUE_LOOP

	

:PROCESS_REMAINING_QUEUE_END
!bat_popecho! [RETURN !bat_batchfile!:PROCESS_REMAINING_QUEUE] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!






	REM #################################################################################
	REM This routine re-launches the MonitorDirs.exe program to begin monitoring for new
	REM uploads.  This script should be used to launch the monitor in the first place
	REM just in case new files were uploaded while the monitor was not running. 
:RELAUNCH_MONITOR
!bat_pushlog! [CALL !bat_batchfile!:RELAUNCH_MONITOR] %*

	process | Find /i "monitordir.exe"
	if !errorlevel! equ 0 (
		goto :RELAUNCH_MONITOR_END
	)

	!bat_echolog! Relaunching the MonitorDir.exe program...
	!bat_echolog!
	!bat_echolog! start /low /min monitordir.exe  "!bat_camsdir!\Temp\TempCal\From" "!bat_camsdir!\AutoCal_Remote.bat /results !bat_camsdir!\Temp\TempCal\From /calstars !bat_camsdir!\Temp\TempCal /zip" /FilenameChange /RunOnce /AddFileName /Creation /Activate
                  start /low /min monitordir.exe  "!bat_camsdir!\Temp\TempCal\From" "!bat_camsdir!\AutoCal_Remote.bat /results !bat_camsdir!\Temp\TempCal\From /calstars !bat_camsdir!\Temp\TempCal /zip" /FilenameChange /RunOnce /AddFileName /Creation /Activate


:RELAUNCH_MONITOR_END
!bat_popecho! [RETURN !bat_batchfile!:RELAUNCH_MONITOR] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!





	REM #################################################################################
	REM This script will be called like this:
	REM   AutoCal_Remote.bat /results "C:\CAMS\Temp\TempCal\calstars_client" 
	REM                      /calstars "C:\CAMS\Temp\TempCal"
	REM                      /zip "C:\CAMS\Temp\TempCal\calstars_client\CALSTARS0750_2016_01_16_13_00_00.zip"
	REM 
	REM I use the following naming convention for variable names:
	REM    - Full                   - means fully qualified path\file.ext
	REM    - Name                   - means file with no path or extent
	REM    - File                   - means file with no path but with an extent
	REM
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_returncode=0

		REM Set the DEFAULT working dirs
	!bat_logexeclog! set bat_calstarsdir=!bat_cams_root!\Temp\TempCal
	!bat_logexeclog! set bat_TempCalFrom=& rem !bat_calstarsdir!\calstars_client
	!bat_logexeclog! set bat_TempCalResults=& rem !bat_calstarsdir!\calstars_client

:PARSEARGS_LOOP
!bat_log! :PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" goto :PARSEARGS_LOOPBREAK
	
	if /i "%~1" equ "/Results" (
		!bat_logexeclog! set bat_TempCalResults=%~2
		!bat_logexeclog! set bat_TempCalFrom=%~2
		shift
		shift
		goto :PARSEARGS_LOOP
	)

	if /i "%~1" equ "/calstars" (
		!bat_logexeclog! set bat_calstarsdir=%~2
		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	if /i "%~1" equ "/zip" (
		!bat_logexeclog! set bat_TempCalFromZipFull=%~2
		!bat_logexeclog! set bat_TempCalFromZipName=%~n2
		!bat_logexeclog! set bat_TempCalFromZipExt=%~x2
		!bat_logexeclog! set bat_captureddatetime=!bat_TempCalFromZipName:~15,19!
		!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
		!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!
		!bat_logexeclog! set bat_capturedfilesdir=!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!
		!bat_logexeclog! set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!
		!bat_logexeclog! set bat_camera=!bat_TempCalFromZipName:~9,3!
		
			REM strip off the trailing "\"
		                 set bat_TempCalFrom=%~dp2::
		                 set bat_TempCalFrom=!bat_TempCalFrom:\::=!
		!bat_logexeclog! set bat_TempCalFrom=!bat_TempCalFrom:::=!
		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	

:PARSEARGS_LOOPBREAK

		REM Since AutoCal_LocalDownload.bat runs in a subdir, this section
		REM fetches the bat_cams_root
	!bat_logexeclog! set bat_cams_root=!bat_camsdir!
	
		REM This script will check to see if the "!bat_AutoCams_lock_full!" indicates
		REM that a user is running an autocams.bat menu option and we need to block
		REM until it's done.  As soon as the user returns to the menu, the
		REM lock is released and we can continue here. 
	!bat_CALLecho! "!bat_exedir!\WaitFor_Autocams_Lock.bat"

	if not defined bat_TempCalFromZipFull (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog! ERROR - Unable to proceed because /zip argument is missing:
		!bat_echolog!
		goto :PARSEARGS_END
	)
	
	call :PARSEZIP "!bat_TempCalFromZipFull!"
	

	!bat_logexeclog! set bat_DirListingCalStars=!bat_CalStarsDir!\DirListingCalstars.txt"
	
	if not defined bat_TempCalFrom (
		!bat_logexeclog! set bat_TempCalFrom=!bat_calstarsdir!\calstars_client
	)
	
	if not defined bat_TempCalResults (
		!bat_logexeclog! set bat_TempCalFrom=!bat_calstarsdir!\calstars_client
	)
	
		REM Convert: "CALSTARS000750_2016_12_31_14_37_59_01_Results" 
		REM to:      "CALSTARS000750_2016_12_31_14_37_59_01.zip"
		REM 
	!bat_logexeclog! set bat_TempCalQueueZipFile=!bat_TempCalFromZipName:_Results=.zip!
	
	echo !bat_TempCalQueueZipFile!>"!bat_cams_root!\Temp\RemoteSession_Busy.txt"
	
	if exist "!bat_cams_root!\Temp\Autocams_Busy.txt" (
		!bat_echolog! "waiting for autocams to finish, do not close MonitorDir"
		!bat_log! start "MonitorDir - [!bat_cams_root!\Temp\Autocams_Busy.txt]" /low /min /wait "!bat_camsdir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_cams_root!\Temp" "!bat_cams_root!\Temp\Autocams_Busy.txt"
		          start "MonitorDir - [!bat_cams_root!\Temp\Autocams_Busy.txt]" /low /min /wait "!bat_camsdir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_cams_root!\Temp" "!bat_cams_root!\Temp\Autocams_Busy.txt"
		!bat_echolog! "waiting for autocams finished"
	) 

	
	
:PARSEARGS_END
!bat_popecho! [RETURN !bat_batchfile!:PARSEARGS] [bat_TempCalFromZipFull=!bat_TempCalFromZipFull!,
!bat_log! `                                      bat_TempCalResults=!bat_TempCalResults!,
!bat_log! `                                      bat_CalStarsDir=!bat_calstarsdir!,
!bat_log! `                                      bat_TempCalFrom=!bat_TempCalFrom!,
!bat_log! `                                      bat_capturedfilesdir=!bat_capturedfilesdir!]
!bat_log!
rem !bat_WAIT! 3
!bat_return! !bat_returncode!




	REM ############################################################################################
	REM Called with bat_TempCalFromZipFull
	REM Returns:
	REM   bat_TempCalResults
	REM   bat_TempCalDir
	REM   bat_CalStarsDir
	REM   bat_TempCalFrom
	REM   bat_TempCalFromZipFull
	REM   bat_TempCalFromZipName
	REM   bat_TempCalFromZipExt
	REM   bat_capturedfilesdir
	REM   bat_captureddate
	REM   bat_capturedtime
	REM   bat_captureddatetime
	REM   
:PARSEZIP
!bat_pushlog! [CALL !bat_batchfile!:PARSEZIP] %*

	!bat_logexeclog! set bat_TempCalFromZipName=%~n1
	!bat_logexeclog! set bat_TempCalFromZipExt=%~x1
	
	                 set bat_TempCalFrom=%~dp1::
	                 set bat_TempCalFrom=!bat_TempCalFrom:\::=!
	!bat_logexeclog! set bat_TempCalFrom=!bat_TempCalFrom:::=!
	
	!bat_logexeclog! set bat_ZipFull=!bat_TempCalFromZipFull!


	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_TempCalFrom!"
	!bat_logexeclog! set bat_TempCalFrom=!bat_retval1!\calstars_client

	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_TempCalFrom!"
	!bat_log! if not defined bat_calstarsdir...
	if not defined bat_calstarsdir (
		!bat_logexeclog! set bat_calstarsdir=!bat_retval1!
	) else (!bat_log! bat_calstarsdir=!bat_calstarsdir!)

	!bat_logexeclog! set bat_TempCalResults=!bat_calstarsdir!\calstars_client

	!bat_logexeclog! set bat_captureddatetime=!bat_TempCalFromZipName:~15,19!
	!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
	!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!


	
	!bat_logexeclog! set bat_capturedfilesdir=!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!
	!bat_logexeclog! set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!

	if not defined bat_TempCalResults (
		!bat_logexeclog! set bat_TempCalResults=!bat_calstarsdir!\calstars_client
	)
	

:PARSEZIP_END
!bat_popecho! [RETURN !bat_batchfile!:PARSEZIP] [bat_capturedfilesdir=!bat_capturedfilesdir!,
!bat_log! `                                     bat_TempCalFromZipName=!bat_TempCalFromZipName!
!bat_log! `                                     bat_TempCalFromZipExt=!bat_TempCalFromZipExt!
!bat_log! `                                     bat_TempCalFrom=!bat_TempCalFrom!
!bat_log! `                                     bat_captureddate=!bat_captureddate!
!bat_log! `                                     bat_calstarsdir=!bat_calstarsdir!
!bat_log! `                                     bat_capturedfilesdir=!bat_capturedfilesdir!
!bat_log! `                                     bat_archivedfilesdir=!bat_archivedfilesdir!
!bat_log! `                                     bat_TempCalResults=!bat_TempCalResults!
!bat_log!
rem !bat_WAIT! 3
!bat_return!







	REM #################################################################################
:HELP
	@echo off
	echo.
	@echo off
	echo.
	echo.%~nx0
	echo.
	echo Usage: %~nx0 /source "!bat_capturedfilesdir!" /caldir "!bat_caldir!" /server "!bat_autocal_remote_server!" /user "!bat_user!" /pwd "!bat_pwd!" /share "!bat_share!"
	echo.   
	echo.Performs the third phase of the AutoCal_Remote calibration by downloading the zip file
	echo.from the remote server, which contains the CAL files based on the CALSTARS files you
	echo.sent from the local system.  This script needs to inject those new CAL files into 
	echo.the current AutoCams session and continue with the local AutoCal as it usually does.
	echo.
	echo.QUEUE FORMAT:
	echo.   Queue Name: ".\CAMS\AutoCal_Remote_Queue\AutoCal_Remote_Queue.txt"
	echo.      The queue items will be entered as follows:
	echo.         CALSTARS??????_????????_??????.zip,"^<bat_capturedfilesdir^>","^<bat_caldir^>","^<command line^>""
	echo.
	echo.   The original source zip file that got uploaded will remain in the queue folder
	echo.   until after its results have been safely downloaded.  That way, if necessary, it
	echo.   can be resubmitted easier. 
	echo.
	echo.Steps involved:
	echo.PHASE P
	echo.    1)  The monitor triggers this script when a file appears in the dir [remember, it may not
	echo.        be a file that pertains to one of the local queue items]
	echo.    2)  This script first checks to see if the triggered item pertains to the local queue items.  
	echo.    3)  If it does not pertain to any of the queue items, then it should go back and relaunch
	echo.        MonitorDir to wait for more results
	echo.    4)  If it does pertain to at least one of the queue items, then it should do the following steps...
	echo.        A)  It must download the file
	echo.        B)  Remove the file from the server
	echo.        C)  Unzip the file to a temp dir
	echo.        D)  Move the contents to their appropriate areas [.\Cal, .\Cal\BinFiles, .\{capturedfilesdir}]
	echo.        E)  Remove the downloaded file and any temp files used to do the work
	echo.     *  F)  Run the script specified in the queue item to complete the autonomous processing. 
	echo.        G)  Loop back to step 2 above to process any remaining queue items. There can be a lot of 
	echo.            reasons why they didn't get processed before. 
	echo.

exit /b 99

- This script needs to be able to run hourly or something like that [as a scheduled task]
- We need to work out how to pass the dir name and the zip file info from Phase 1 to Phase 3 scripts. 
- I'm thinking that when this script starts, it just starts downloading all the results files that 
  pertain to any of the cameras on this system.  How to determine those is another issue.
- Another possible way is to create a queue file that contains a list of all the CALSTARS*.zip files
  that were uploaded.  That way, the results could be picked up at any time.  
  - What might be beneficial is if this list contained the capturedfiles settings [or the 
    Autocams.bat.ini values], along with the CALSTARS*.zip file name.  
  - So, whenever this script runs, it iterates the list of files on the remote server and only
    downloads those that match what's in the local queue.
  - The queue file should contain a signal as to where, if any, the program should continue
    with AutoCams.bat processing.  Perhaps, just the command line that causes the script to
    run as is neeed.
  - When a queue item is downloaded:
	echo.    1)  The monitor triggers this script when a file appears in the dir [remember, it may not
	echo.        be a file that pertains to one of the local queue items]
	echo.    2)  This script first checks to see if the triggered item pertains to the local queue items.  
	echo.    3)  If it does not pertain to any of the queue items, then it should go back and relaunch
	echo.        MonitorDir to wait for more results
	echo.    4)  If it does pertain to at least one of the queue items, then it should do the following steps...
	echo.        A)  It must download the file
	echo.        B)  Remove the file from the server
	echo.        C)  Unzip the file to a temp dir
	echo.        D)  Move the contents to their appropriate areas [.\Cal, .\Cal\BinFiles, .\{capturedfilesdir}]
	echo.        E)  Remove the downloaded file and any temp files used to do the work
	echo.     *  F)  Run the script specified in the queue item to complete the autonomous processing. 
	echo.        G)  Loop back to step 2 above to process any remaining queue items. There can be a lot of 
	echo.            reasons why they didn't get processed before. 
  


	REM #################################################################################
:DONE
!bat_CALL! "!bat_exedir!\Unlock_RemoteSession.bat"

exit /b !bat_returncode!
