@echo off
setlocal enableextensions enabledelayedexpansion


	REM #################################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*




	REM #################################################################################
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
	set bat_pushstring=

	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

		REM first thing to do is to stop the scheduled task
	!bat_CALL! call SCHTASKS 	/End /TN MonitorDir_Poll_Server
			  
	set bat_returncode=0

	call :PARSEARGS %*
	
	if /i "%~1" equ "" (
			
			REM Skip processing the first zip passed as the argument because the argument is missing. 
			REM Therefore, skip to SETUP_2 to go directly to the section where it starts processing the 
			REM zip files that were there before hand.  After it's done, it will launch the monitor.
		GOTO :SETUP_2
	)
	
		REM This current iteration does not do PROCESS_REMAINING_QUEUE anymore.  Instead, it should
		REM process the file passed to it and then end.  
		REM 
		REM Remember, the MonitorDir_Poll_Server.bat already downloaded the .zip and _md5.txt files
		REM and then it calls this script synchronoushly. 
		REM
	call :MAIN %*


:SETUP_2
REM	call :PROCESS_REMAINING_QUEUE
	
REM	call :RELAUNCH_MONITOR

goto :DONE





	REM #################################################################################
	REM This script will be called like this:
	REM   AutoCal_Remote.bat /results "C:\CAMS\Temp\TempCal" 
	REM                      /calstars "C:\CAMS\Temp\TempCal"
	REM                      /zip "C:\CAMS\Temp\TempCal\CALSTARS0750_2016_01_16_13_00_00.zip"
	REM
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_returncode=0

		REM Set the DEFAULT working dirs
	!bat_logexeclog! set bat_calstarsdir=!bat_CALIBRATION.REMOTE_autocal_workdir!
	!bat_logexeclog! set bat_TempCalFrom=!bat_CALIBRATION.REMOTE_autocal_workdir!
	!bat_logexeclog! set bat_TempCalResults=!bat_CALIBRATION.REMOTE_autocal_workdir!

:PARSEARGS_LOOP
rem echo.:PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" goto :PARSEARGS_LOOPBREAK
	

	if /i "%~1" equ "/calstars" (
		!bat_logexeclog! set bat_calstarsdir=%~2
		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	if /i "%~1" equ "/zip" (
		!bat_logexeclog! set bat_TempCalFromZipFull=%~2
		!bat_logexeclog! set bat_TempCalFromZipName=%~n2
		!bat_logexeclog! set bat_TempCalFromZipExt=%~x2

		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	

:PARSEARGS_LOOPBREAK


%BAT_COMMENT_BEGIN%
		REM Handle defaults
	if not defined bat_TempCalFromZipFull (
		if not defined bat_calstarsdir (
			set bat_returncode=1
			!bat_echolog!
			!bat_echolog! ERROR - Unable to proceed because /zip argument is missing:
			!bat_echolog!
			goto :PARSEARGS_END
		) else (
			set bat_TempCalFromZipFull=!bat_calstarsdir!\CALSTARS0123_4567_89_01_23_45_79.zip
			set bat_TempCalFromZipName=CALSTARS0123_4567_89_01_23_45_79_##
			set bat_TempCalFromZipExt=.zip
		)
	)
%BAT_COMMENT_END%


	!bat_logexeclog! set bat_captureddate=!bat_TempCalFromZipName:~13,10!
echo.aaaaa
	!bat_logexeclog! set bat_capturedtime=!bat_TempCalFromZipName:~-11,8!
	!bat_logexeclog! set bat_captureddatetime=!bat_captureddate!_!bat_capturedtime!

	!bat_logexeclog! set bat_capturedfilesdir=!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!
	
	!bat_logexeclog! set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!

	call :PARSEZIP "!bat_TempCalFromZipFull!"
	

	!bat_logexeclog! set bat_DirListingCalStars=!bat_capturedfilesdir!\DirListingCalstars.txt"
	
	if not defined bat_TempCalFrom (
		!bat_logexeclog! set bat_TempCalFrom=!bat_calstarsdir!
	)
	
	if not defined bat_TempCalResults (
		!bat_logexeclog! set bat_TempCalResults=!bat_calstarsdir!
	)
	


:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_TempCalFromZipFull=!bat_TempCalFromZipFull!,
!bat_log! `                                      bat_TempCalResults=!bat_TempCalResults!,
!bat_log! `                                      bat_CalStarsDir=!bat_calstarsdir!,
!bat_log! `                                      bat_TempCalFrom=!bat_TempCalFrom!,
!bat_log! `                                      bat_capturedfilesdir=!bat_capturedfilesdir!]
!bat_log!
!bat_return! !bat_returncode!







	REM #################################################################################
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %*

	if "!bat_TempCalFromZipName!" equ "" (
		call :ZIPERROR 1 "[!bat_batchfile!:CHECK_MISSING_FILES]  ERROR - [bat_returncode=!bat_returncode!] - No Zip file specified [bat_TempCalFromZipName=!bat_TempCalFromZipName!]"
		goto :MAIN_END
	)
	
	if "!bat_TempCalFromZipExt!" neq ".zip" (
		set bat_returncode=2
		!bat_echolog! 
		!bat_echolog! !bat_batchfile!:CHECK_MISSING_FILESERROR - [bat_returncode=!bat_returncode!] File specified is not a zip file [!bat_TempCalFromZipExt!]
		!bat_echolog! 
		goto :MAIN_END
	)

	if exist "!bat_calstarsdir!\stage\ERRORS.txt" (
		!bat_logexeclog! del /q "!bat_calstarsdir!\stage\ERRORS.txt"
	)

	call :WAIT_FOR_ZIP
	
	call :SETUP_DIRS 
	if /i "!bat_returncode!" neq "0" (
		goto :MAIN_3
	)

if exist "C:\cam213\CAMS\Temp\BinFiles" (
	!bat_echolog! #########################################################
	!bat_echolog! #####  "C:\cam213\CAMS\Temp\BinFiles" 
	!bat_echolog! #########################################################
	!bat_pause!
)
	
	call :DOWNLOAD_ZIP "!bat_TempCalFromZipFull!"

	call :UNZIP_CALSTARS
	
	call :RECONSTITUTE_FF

	call :CHECK_MISSING_FILES
	if /i "!bat_returncode!" neq "0" (
		goto :MAIN_3
	)
	
	call :AUTOCAL
	if /i "!bat_returncode!" neq "0" (
		rem
	)
	
	call :APPLYCAL
	if /i "!bat_returncode!" neq "0" (
		rem
	)
	
	call :PACKAGE_RESULTS

	call :UPLOAD_ZIP "!bat_ZipFileNameFull!"
	if !errorlevel! neq 0 (goto :MAIN_END)

	
rem	call :UPLOAD_ZIP "!bat_MD5FileNameFull!"
rem	if !errorlevel! neq 0 (goto :MAIN_END)
	
:MAIN_3
!bat_log! [GOTO !bat_batchfile!:MAIN_3] %~1 %~2 %~3 %~4

	call :CLEANUP

:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:MAIN] []
!bat_log!
rem !bat_WAIT! 3	:MAIN_END
!bat_return! !bat_returncode!





	REM #################################################################################
	REM This AutoCal_Remote.bat script was called typically because the MonitorDir.bat script
	REM called it due to a new CALSTARS0750_2016_01_16_13_01_00.zip showing up. 
	REM This routine's job is to wait for the upload of the zip to finish, in case this
	REM script is called when the file first appears, but before it is done uploading th
	REM entire file.
	REM That zip file will contain everything that is needed for this to run.  It might 
	REM need to include camerasites.txt and a few others, possibly the most recent cal file 
	REM for each camera from that site and maybe the camera files.  
	REM 
:WAIT_FOR_ZIP
!bat_pushlog! [CALL !bat_batchfile!:WAIT_FOR_ZIP] %* [%1, %~dp1, %~nx1]

	!bat_echolog!
	!bat_pushecho! Waiting for the zip file to complete its upload, thus releasing the file: "!bat_TempCalFromZipFull!"...
		!bat_echolog! call WaitForFile.EXE rw "!bat_TempCalFromZipFull!"...
		!bat_echolog!
		!bat_logexeclog! WaitForFile.EXE rw "!bat_TempCalFromZipFull!"
	!bat_popecho! ...It's now ready to process.
	!bat_echolog!


:WAIT_FOR_ZIP_END
!bat_popecho! [RETURN !bat_batchfile!:WAIT_FOR_ZIP] [!bat_TempCalFromZipFull!]
!bat_log!
rem !bat_WAIT! 3	:WAIT_FOR_ZIP_END
!bat_return!





	REM #################################################################################
:SETUP_DIRS
!bat_pushlog! [CALL !bat_batchfile!:SETUP_DIRS] %* [%1, %~dp1, %~nx1]

	set bat_returncode=0

	if /i "!bat_calstarsdir!" equ "!bat_exedir!" (
		call :ZIPERROR 21  "[!bat_batchfile!:SETUP_DIRS] - DANGEROUS delete command [del /q "!bat_calstarsdir!"]
		!bat_pause!
		goto :SETUP_DIRS_END
	)

	if /i "!bat_calstarsdir!" equ "" (
		call :ZIPERROR 22  "[!bat_batchfile!:SETUP_DIRS] - DANGEROUS delete command [del /q "!bat_calstarsdir!"]
		!bat_pause!
		goto :SETUP_DIRS_END
	)

	if exist "!bat_calstarsdir!\zip\*.*" (
		!bat_logexeclog! del /q "!bat_calstarsdir!\zip\*.*"
	)

	if exist "!bat_calstarsdir!\*.*" (
		!bat_logexeclog! del /q "!bat_calstarsdir!\*.*"
	)

	!bat_log! if exist "!bat_calstarsdir!\CapturedFiles"...
	if exist "!bat_calstarsdir!\CapturedFiles" (
		!bat_logexeclog! RD /s /q "!bat_calstarsdir!\CapturedFiles" 
	)

	!bat_log! if exist "!bat_calstarsdir!\ArchivedFiles"...
	if exist "!bat_calstarsdir!\ArchivedFiles" (
		!bat_logexeclog! RD /s /q "!bat_calstarsdir!\ArchivedFiles" 
	)
	
	!bat_log! if exist "!bat_calstarsdir!\stage"...
	if exist "!bat_calstarsdir!\stage" (
		!bat_logexeclog! RD /s /q "!bat_calstarsdir!\stage" 
	)
	
	if not exist "!bat_calstarsdir!\zip" (
		!bat_logexeclog! MD "!bat_calstarsdir!\zip\"
	)
	
	if not exist "!bat_calstarsdir!\CapturedFiles" (
		!bat_logexeclog! MD "!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!\"
	)

	if not exist "!bat_calstarsdir!\ArchivedFiles" (
		!bat_logexeclog! MD "!bat_calstarsdir!\ArchivedFiles\!bat_captureddatetime!\"
	)

	if not exist "!bat_calstars_caldir!" (
		!bat_logexeclog! MD "!bat_calstars_caldir!\"
	)

:SETUP_DIRS_END
!bat_popecho! [RETURN !bat_batchfile!:SETUP_DIRS] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:SETUP_DIRS_END
!bat_return! !bat_returncode!






	REM #################################################################################
	REM This routine copies the zip file [which was downloaded by monitordir_poll_server 
	REM to a local work area {bat_calstarsdir\calstars_server}].
	REM
:DOWNLOAD_ZIP
!bat_pushlog! [CALL !bat_batchfile!:DOWNLOAD_ZIP] %~1

	if not exist "!bat_calstarsdir!" (
		!bat_logexeclog! MD "!bat_calstarsdir!"
	)
	
	if not exist "!bat_calstarsdir!\zip" (
		!bat_logexeclog! MD "!bat_calstarsdir!\zip\"
	)

	!bat_logexeclog! copy /y "!bat_serverZipFileFull!" "!bat_calstarsdir!\zip\"
	

:DOWNLOAD_ZIP_END
!bat_popecho! [RETURN !bat_batchfile!:DOWNLOAD_ZIP] [!bat_TempCalFromZipFull!]
!bat_log!
rem !bat_WAIT! 3	:DOWNLOAD_ZIP_END
!bat_return!







	REM #################################################################################
:UNZIP_CALSTARS
!bat_pushlog! [CALL !bat_batchfile!:UNZIP_CALSTARS] %*

		REM In order to establish defaults, copy some  files from the "..\Cal" dir
		REM before unzipping.
	!bat_logexeclog! copy /y "!bat_camsdir!\Cal\camerasites.txt" "!bat_calstars_caldir!\"

	!bat_logexeclog! set bat_ZipFull=!bat_calstarsdir!\zip\!bat_TempCalFromZipName!!bat_TempCalFromZipExt!


		REM Unzip the zip file to the bat_calstarsdir
	!bat_CALL! "!bat_exedir!\7unzip.bat" -y -output "!bat_calstarsdir!" "!bat_ZipFull!"  "*"
        set bat_returncode=!bat_logexec_returncode!

	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" bat_detectfile "!bat_archivedfilesdir!"
	!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
	!bat_CALL! "!bat_exedir!\FixMeteorCount.bat" "!bat_detectfile!"

	!bat_logexec! FINDSTR /i /c:"Meteor Count = " /c:"FF  folder = " /c:"CAL folder =" /c:"file processed"  "!bat_detectfile!"

:UNZIP_CALSTARS_END
!bat_popecho! [RETURN !bat_batchfile!:UNZIP_CALSTARS] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:UNZIP_CALSTARS_END
!bat_return!




	REM #################################################################################
:RECONSTITUTE_FF
!bat_pushlog! [CALL !bat_batchfile!:RECONSTITUTE_FF] %*

	if not exist "!bat_capturedfilesdir!" (
		!bat_logexeclog! MD "!bat_capturedfilesdir!\"
	)
	if not exist "!bat_archivedfilesdir!" (
		!bat_logexeclog! MD "!bat_archivedfilesdir!\"
	)
	
	
		REM This section is a workaround for a bug in FTP_CalStarsReconstitution.exe that
		REM builds the DirListingCalStars.txt file that's supposed to be built by
		REM the program, but it has an issue when used from a command line.
		
	!bat_logexeclog! del /q "!bat_DirListingCalStars!"

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_capturedfilesdir!\CALSTARS*.txt" /b /on" /b /on`^)...
	for           /f "usebackq tokens=*" %%a in  (`dir "!bat_capturedfilesdir!\CALSTARS*.txt" /b /on`) do (
		echo.====== %%a ========
		echo.%%a>>"!bat_DirListingCalStars!"
	)
	
	!bat_pushecho!
		!bat_echolog! Getting ready to begin reconstituting the FF files...
		!bat_echolog!

		!bat_log! START /WAIT "Reconstituting FF files to [!bat_capturedfilesdir!]" "!bat_exedir!\FTP_CalStarsReconstitution.exe" "!bat_capturedfilesdir!"
		          START /WAIT "Reconstituting FF files to [!bat_capturedfilesdir!]" "!bat_exedir!\FTP_CalStarsReconstitution.exe" "!bat_capturedfilesdir!"
	
		!bat_echolog!
		!bat_echolog! ... Back from reconstituting the FF files.
	!bat_popecho!

	
		REM Now move the real FF files over the top of the fake ones...
	!bat_logexeclog! MOVE /y "!bat_calstarsdir!\FF*.bin" "!bat_capturedfilesdir!"


:RECONSTITUTE_FF_END
!bat_popecho! [RETURN !bat_batchfile!:RECONSTITUTE_FF] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:RECONSTITUTE_FF_END
!bat_return!




	REM #################################################################################
	REM This routine checks that all the files were included. 
	REM  - Needs to create the GCGC.log file, which is a list of cameras based on
	REM    the FF files. 
	REM  - Then ensure that there is at least one CAL file for each camera
	REM 
	REM bat_FFfirst=FF267_20160115_015045_469_0000000.bin
	REM bat_FFlast=FF267_20160115_144110_703_1379072.bin
	REM 
	REM 
:CHECK_MISSING_FILES
!bat_pushlog! [CALL !bat_batchfile!:CHECK_MISSING_FILES] %*

	set bat_returncode=0
	set bat_retval=success

	if exist "!bat_GCFC_tempfile!" (
		!bat_logexeclog! del /q "!bat_GCFC_tempfile!"
	)

		REM Create the GCFC.log file as bat_GCFC_tempfile
	!bat_START! /wait "Please Wait - CreateCameraListFile.bat - [!bat_capturedfilesdir!]" /low cmd /c ""!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!""

	rem Usage %~0 "^<var_firstfile^>"    "^<var_lastfile^>"   "^<target directory path^>" ["^<camera^>"]
	!bat_CALL! "!bat_exedir!\GetFirstLastFF_filenames.bat" bat_FFfirst bat_FFlast "!bat_capturedfilesdir!"

	!bat_echolog! dir "!bat_calstars_caldir!\CAL_??????_????????_??????_???.txt" /a-d /b /on } "!bat_calfilelist!"
	              dir "!bat_calstars_caldir!\CAL_??????_????????_??????_???.txt" /a-d /b /on > "!bat_calfilelist!"

	!bat_logexeclog! type "!bat_calfilelist!"
	
	!bat_pushecho!
		for /f "usebackq tokens=*" %%a in (`type "!bat_GCFC_tempfile!"`) do (
			!bat_log! find /i "CAL%%a_" "!bat_calfilelist!">nul:
			find           /i "CAL%%a_" "!bat_calfilelist!">nul:
			if /i "!errorlevel!" neq "0" (
				call :ZIPERROR 51  "[!bat_batchfile!:CHECK_MISSING_FILES] - The following camera was not included and will cause an error when running "FTP_MeteorCal_AutoUpdate.exe". [%%a]
			)
		)

		if not exist "!bat_calstars_caldir!\camerasites.txt" (
				set bat_returncode=2
				call :ZIPERROR  52 "[!bat_batchfile!:CHECK_MISSING_FILES] - "camerasites.txt" is missing from the zip file.
		)
	!bat_popecho!
	
:CHECK_MISSING_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:CHECK_MISSING_FILES] [bat_returncode=!bat_returncode!, bat_calfilelist=!bat_calfilelist!]
!bat_log!
rem !bat_WAIT! 3	:CHECK_MISSING_FILES_END
!bat_return!





	REM #################################################################################
	REM AutoCal.bat needs:
	REM    bat_archivedfilesdir
	REM    bat_caldir
	REM 
	REM One problem that we might need to consider handling is if AutoCal.bat
	REM either crashes or doesn't produce any calibrations.  Such a condition
	REM might mean that a manual calibration needs to be re-run. 
:AUTOCAL
!bat_pushlog! [CALL !bat_batchfile!:AUTOCAL] %*

		REM This loop finds the most recent file in the working directory before
		REM autocal is run so that after it is run, we can determine what autocal
		REM produced, if anything.  We need to be able to differentiate between
		REM previous CAL files that were placed there to make it so that autocal
		REM could run.  
	for /f "usebackq tokens=*" %%a in (`dir "!bat_calstars_caldir!\CAL_??????_????????_??????_???.txt" /a-d /b /od`) do (
		set bat_calfile_last=%%a
	)
	
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "bat_detectfile" "!bat_archivedfilesdir!" "!bat_capturedfilesdir!"
	
	!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
	

		REM This routine performs autocal against the reconstituted FF files.
		REM
		REM For Remote non-USA calibration, fake the bat_archivedfilesdir variable
		REM by substituting the part of bat_capturedfilesdir that is "CapturedFiles"
		REM with "ArchivedFiles". 
rem	set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!
	set bat_caldir=!bat_calstars_caldir!


		REM ###############################################################################
		REM Call AutoCal.bat to perform the autocal procedure.  Returns errorlevel...
		REM 
	!bat_CALL! "!bat_exedir!\AutoCal.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! !bat_calnstars! !bat_caloc! autonomous /remote
	set bat_returncode=!errorlevel!
	
:AUTOCAL_END
!bat_popecho! [RETURN !bat_batchfile!:AUTOCAL] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:AUTOCAL_END
!bat_return!






	REM #################################################################################
	REM ApplyCal.bat needs:
	REM    bat_targetdir
	REM 
:APPLYCAL
!bat_pushlog! [CALL !bat_batchfile!:APPLYCAL] %*

	if not defined bat_detectfile (
		call :ERROR ":APPLYCAL" 51 "detect file not specified"
		goto :APPLYCAL_END
	)
	
	if not exist "!bat_detectfile!" (
		call :ERROR ":APPLYCAL" 52 "Detect file is missing: [!bat_detectfile!]"
		goto :APPLYCAL_END
	)

	!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
	


		REM This loop finds the most recent file in the working directory before
		REM autocal is run so that after it is run, we can determine what autocal
		REM produced, if anything.  We need to be able to differentiate between
		REM previous CAL files that were placed there to make it so that autocal
		REM could run.  
	for /f "usebackq tokens=*" %%a in (`dir "!bat_calstarsdir!\CAL_??????_????????_??????_???.txt" /a-d /b /od`) do (
		set bat_calfile_last=%%a
	)
	

		REM This routine performs autocal against the reconstituted FF files.
		REM
		REM For Remote non-USA calibration, fake the bat_archivedfilesdir variable
		REM by substituting the part of bat_capturedfilesdir that is "CapturedFiles"
		REM with "ArchivedFiles". 
	set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!
	set bat_caldir=!bat_calstars_caldir!

	rem Call AutoCal.bat to perform the autocal procedure.  Returns errorlevel...
	!bat_CALL! "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous /remote
	set bat_returncode=!errorlevel!
	
:APPLYCAL_END
!bat_popecho! [RETURN !bat_batchfile!:APPLYCAL] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:APPLYCAL_END
!bat_return!






	REM ############################################################################################
	REM This routine packages all the CAL*.txt files in the CapturedFiles dir
	REM 
	REM 
	REM 
	REM 
:PACKAGE_RESULTS
!bat_pushlog! [CALL !bat_batchfile!:PACKAGE_RESULTS] [%*]

	if exist                      "!bat_results_stage!" (
		!bat_logexeclog! RD /s /q "!bat_results_stage!"
	)

	if NOT exist            "!bat_results_stage!\Cal" (
		!bat_logexeclog! md "!bat_results_stage!\Cal"
	)

	if NOT exist            "!bat_results_stage!\Cal\BinFiles" (
		!bat_logexeclog! md "!bat_results_stage!\Cal\BinFiles"
	)
	
	
	if /i "!bat_CALIBRATION.REMOTE_keep_cal_files" EQU "true" (
		!bat_log! if /i "!bat_CALIBRATION.REMOTE_keep_cal_files" EQU "true"...
		if exist                     "!bat_capturedfilesdir!\BinFiles\CAL_??????_????????_??????_???.txt" (
			!bat_logexeclog! copy /y "!bat_calstars_caldir!\BinFiles\CAL_??????_????????_??????_???.txt" "!bat_camsdir!\Cal\"
			!bat_logexeclog! copy /y "!bat_calstars_caldir!\BinFiles\CAL_??????_????????_??????_???.txt" "!bat_camsdir!\Cal\BinFiles\"
		)
	)
	
	if /i "!bat_CALIBRATION.REMOTE_keep_FF_files" EQU "true" (
		!bat_log! if /i "!bat_CALIBRATION.REMOTE_keep_FF_files" EQU "true"...
		if exist                     "!bat_calstars_caldir!\BinFiles\FF*.bin" (
			!bat_logexeclog! copy /y "!bat_calstars_caldir!\BinFiles\FF*.bin" "!bat_camsdir!\Cal\"
		)
	)
	
		REM Copy the resulting CAL files into the "stage\Cal" dir	
	!bat_logexeclog! copy /y "!bat_calstars_caldir!\BinFiles\CAL_??????_????????_??????_???.txt" "!bat_results_stage!\Cal\"
	!bat_logexeclog! move /y "!bat_calstars_caldir!\BinFiles\CAL_??????_????????_??????_???.txt" "!bat_results_stage!\Cal\BinFiles\"

		REM Since the AutoCalUpdate.log file contains all the error messages and important information
		REM about the AutoCal run, we will also pass that back.  When the site operator downloads
		REM and unzips the results, this file should be moved into the CapturedFiles dir.
		REM
	
	if not exist "!bat_results_stage!\CapturedFiles\!bat_captureddatetime!" (
		!bat_logexeclog! MD "!bat_results_stage!\CapturedFiles\!bat_captureddatetime!\"
	)
	
	!bat_logexeclog! copy /y "!bat_capturedfilesdir!\AutoCalUpdate.log" "!bat_results_stage!\CapturedFiles\!bat_captureddatetime!\"
	
	if not exist "!bat_results_stage!\ArchivedFiles\!bat_captureddatetime!" (
		!bat_logexeclog! MD "!bat_results_stage!\ArchivedFiles\!bat_captureddatetime!\"
	)
	
		REM Copy the detect file into the ArchivedFiles dir..
	!bat_logexeclog! copy /y "!bat_detectfile!" "!bat_results_stage!\ArchivedFiles\!bat_captureddatetime!\"
	
	
		REM These next two lines, place into the log the names of all the files that are 
		REM included in the zip file.
		REM
	!bat_logexeclog! tree /a /f "!bat_results_stage!"
	!bat_logexeclog! dir "!bat_results_stage!" /s/b
	
		REM Now create the zip Results file.  It will be temporarily created in the "stage" dir. 
		REM
	!bat_CALL! "!bat_exedir!\7zip.bat" -r "!bat_results_stage!\!bat_TempCalFromZipName!_Results!bat_TempCalFromZipExt!" "!bat_results_stage!\*"
	
		REM Now create the flag file to signal that the calibration has completed with a CALSTARS0*_calibrated.txt file...
	echo.!bat_TempCalFromZipName!_Results!bat_TempCalFromZipExt!>"!bat_results_stage!\!bat_TempCalFromZipName!_Results.txt"

	if exist "!bat_results_stage!\!bat_TempCalFromZipName!_*.*" (
			REM Delete the results files on the Results folder before moving the results files 
			REM to the Results folder.  Otherwise, it won't trigger the MonitorDir event
			REM Note: It shouldn't be there, so it should produce a "Could Not Find " error...
		!bat_logexeclog! del /q "!bat_TempCalResults!\!bat_TempCalFromZipName!_Results.zip"
	)
	
	if exist "!bat_TempCalResults!\!bat_TempCalFromZipName!_Results.txt" (
			REM Delete the "?_calibrated.txt" files on the Results folder before moving the results files 
			REM to the Results folder.  Otherwise, it won't trigger the MonitorDir event
			REM Note: It shouldn't be there, so it should produce a "Could Not Find " error...
		!bat_logexeclog! del /q "!bat_TempCalResults!\!bat_TempCalFromZipName!_Results.txt"
	)
	
	

		REM Now move the resulting zip file into the Results dir.  This will trigger
		REM anyone monitoring the Results dir to awaken so they can download and process.
		REM 
	!bat_logexeclog! copy /y "!bat_results_stage!\!bat_TempCalFromZipName!_*.*" "!bat_TempCalResults!\"
	!bat_logexeclog! set bat_ZipFileNameFull=!bat_results_stage!\!bat_TempCalFromZipName!_Results!bat_TempCalFromZipExt!
	
	!bat_logexeclog! set bat_MD5FileNameFull=!bat_results_stage!\!bat_TempCalFromZipName!_Results.txt
	!bat_CALL! "!bat_exedir!\md5.exe" -o"!bat_MD5FileNameFull!" "!bat_ZipFileNameFull!"

:PACKAGE_RESULTS_END
!bat_popecho! [RETURN !bat_batchfile!:PACKAGE_RESULTS] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:PACKAGE_RESULTS_END
!bat_return!



	REM ############################################################################################
:UPLOAD_ZIP
!bat_pushlog! [CALL !bat_batchfile!:UPLOAD_ZIP] %*

	rem !bat_logexeclog! copy /y "!bat_autocal_remote_queue_dir!\!bat_TempCalFromZipName!!bat_TempCalFromZipExt!" "!bat_mapped_From!"
	rem set bat_returncode=!errorlevel!
	

	!bat_CALL! "!bat_exedir!\ReadRemoteConfig.bat"
	
	
	
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

		REM Set these variables so that the ftp_transfer_seti.bat script can use them.
	!bat_logexeclog! set bat_ftpsite=!bat_calftpsite!
	!bat_logexeclog! set bat_ftpuser=!bat_calftpuser!
	!bat_logexeclog! set bat_ftppassword=!bat_calftppassword!
	!bat_logexeclog! set bat_ftpdir=!bat_calftpdir!
	
	!bat_logexeclog! set bat_file=%~1

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	                 set bat_ftpfile=!bat_exedir!\ftp.temp.txt

	!bat_CALL! "!bat_exedir!\ftp_transfer_seti.bat" FTPTRANSFER "!bat_file!"
	
	REM Now create the ftp command file that contains all the commands to execute after
        	REM connecting to the ftp server... Uploading MD5 file
        !bat_pushecho!

                echo user !bat_ftpuser!>"!bat_ftpfile!"
                echo !bat_ftppassword!>>"!bat_ftpfile!"
                echo bin>>"!bat_ftpfile!"
                echo cd !bat_ftpdir!>>"!bat_ftpfile!"
                echo literal pasv>>"!bat_ftpfile!"
                echo put "!bat_MD5FileNameFull!">>"!bat_ftpfile!"
                echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
                echo literal pasv>>"!bat_ftpfile!"
                echo get "!bat_zip!">>!bat_ftpfile!"
                echo quit>>"!bat_ftpfile!"

					REM Display and log the new command file contents so that there is 
					REM a track record of what will be attempted...
                !bat_logexec! TYPE "!bat_ftpfile!"
                           
                !bat_echolog! `..............................................
        !bat_popecho!
		!bat_pushecho! Execute the FTP command file...==========================
        			
                !bat_logexec! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
                set bat_returncode=!bat_logexec_returncode!
                
				REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			!bat_popecho! ...DONE~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ENDLOCAL (set bat_returncode=%bat_returncode%)

:UPLOAD_ZIP_END
!bat_popecho! [RETURN !bat_batchfile!:UPLOAD_ZIP] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:UPLOAD_ZIP_END
!bat_return!



	REM #################################################################################
:CLEANUP
!bat_pushlog! [CALL !bat_batchfile!:CLEANUP] %*

	set bat_returncode=0

		REM Cleanup the working folders by simply removing them. 
	!bat_logexeclog! RD /s /Q "!bat_calstarsdir!\CapturedFiles"
	!bat_logexeclog! RD /s /Q "!bat_calstarsdir!\ArchivedFiles"
	!bat_logexeclog! RD /s /q "!bat_calstarsdir!\stage!"
	!bat_logexeclog! RD /s /q "!bat_calstarsdir!\zip!"
	!bat_logexeclog! RD /s /Q "!bat_calstarsdir!\Cal"
	
		REM Cleanup the TempCal dir. 
	if exist "!bat_calstarsdir!\*.*" (
		!bat_logexeclog! del /q "!bat_calstarsdir!\*.*"
	)
	
:CLEANUP_END
!bat_popecho! [RETURN !bat_batchfile!:CLEANUP] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:CLEANUP_END
!bat_return!






	REM ############################################################################################
	REM This routine iterates through all the remaining ZIP files in the bat_TempCalFrom
	REM dir.  We have to do this because some of these files may have come into the dir
	REM either before MonitorDir.exe was run or after it triggered its first event. 
	REM
	REM Maybe this routine would be better off being a standalone script ["Monitor_ProcessQueue.bat"] 
	REM that is launched as a Scheduled Task as soon as (a) boot; (b) manually Run.
	REM The reason is so that the queue is emptied before MonitorDir.exe is re-launched. 
	REM
:PROCESS_REMAINING_QUEUE
!bat_pushlog! [CALL !bat_batchfile!:PROCESS_REMAINING_QUEUE] %*

	set bat_returncode=0

:PROCESS_REMAINING_QUEUE_LOOP
!bat_log! [GOTO !bat_batchfile!:PROCESS_REMAINING_QUEUE_LOOP] %*

		REM Count the number of CALSTARS zip files that have been uploaded that still need
		REM to be processed. 
		REM 
	!bat_CALL! "!bat_exedir!\GetFileCount.bat" "!bat_TempCalFrom!\CALSTARS??????_????_??_??_??_??_??_??.zip"
	set bat_CountFrom=!errorlevel!
	
	if not defined bat_CountFrom (
		goto :PROCESS_REMAINING_QUEUE_END
	)

	if !bat_CountFrom! LSS 1 (
		goto :PROCESS_REMAINING_QUEUE_END
	)
	
	!bat_echolog!
	!bat_echolog! ######################################################
	!bat_echolog! There are "!bat_CountFrom!" files to process...
	!bat_echolog!
	
	set bat_TempCalFromZipFull=
	set bat_capturedfilesdir=
	set bat_TempCalFromZipName=
	set bat_TempCalFromZipExt=
rem	set bat_TempCalFrom=!bat_TempCalFrom!
	set bat_captureddate=
	set bat_capturedtime=
	set bat_captureddatetime=
	set bat_calstarsdir=
	set bat_capturedfilesdir=
	set bat_archivedfilesdir=
	set bat_TempCalResults=




	set bat_loop_CONTINUE=
	set /a bat_found_count=0
	
		REM Loop through the list of CALSTARS*.zip and skip all but the oldest 
		REM
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_TempCalFrom!\CALSTARS????_????_??_??_??_??_??_??.zip" /a-d /b /o-d`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_TempCalFrom!\CALSTARS????_????_??_??_??_??_??_??.zip" /a-d /b /o-d`) do (
		if NOT defined bat_loop_CONTINUE (

			!bat_logexeclog! set bat_TempCalFromZipFull=!bat_TempCalFrom!\%%a


			if /i "!bat_TempCalFromZipFull!" EQU "" (

!bat_log! Means there are no more found to process... So we are done with PROCESS_REMAINING_QUEUE routine...
				!bat_logexeclog! set bat_loop_CONTINUE=break
			)

			if NOT defined bat_loop_CONTINUE (



				call :PARSEZIP "!bat_TempCalFromZipFull!"
!bat_log! if NOT exist "!bat_TempCalFrom!\!bat_TempCalFromZipName!_Results.txt"

				if NOT exist     "!bat_TempCalFrom!\!bat_TempCalFromZipName!_Results.txt" (


					!bat_log! [!date! !time! !bat_batchfile!:PROCESS_REMAINING_QUEUE_LOOP] - Found a queue item: "!bat_TempCalFromZipFull!"
					!bat_logexeclog! set bat_loop_CONTINUE=true
					set /a bat_found_count+=1
					!bat_log! set /a bat_found_count+=1 [!bat_found_count!]
				) else (
					!bat_log!
					!bat_log! [!date! !time! !bat_batchfile!:PROCESS_REMAINING_QUEUE_LOOP [647]] - Already processed so skipping [!bat_TempCalFromZipFull!]
					REM
				)
			)
		)
	)
	!bat_popecho! ^)... End of PROCESS_REMAINING_QUEUE for loop


!bat_log! .... bat_loop_CONTINUE=!bat_loop_CONTINUE!, bat_found_count=!bat_found_count!


	if !bat_found_count! equ 0 (
		goto :PROCESS_REMAINING_QUEUE_END
	)
	
	if /i "!bat_loop_CONTINUE!" neq "break" (
	
		call :MAIN 
		
		!bat_log! ... Back from MAIN for [!bat_TempCalFromZipFull!]
	)

	
	REM Go back to the counter section in case new files have arrived...
	REM If we had used a FOR loop, it would not accommodate new files arriving
	REM after the loop started.
goto :PROCESS_REMAINING_QUEUE_LOOP

	

:PROCESS_REMAINING_QUEUE_END
!bat_popecho! [RETURN !bat_batchfile!:PROCESS_REMAINING_QUEUE] [bat_returncode=!bat_returncode!]
!bat_log!
rem rem !bat_WAIT! 3
!bat_return!



	REM This routine re-launches the MonitorDirs.exe program to begin monitoring for new
	REM uploads.  This script should be used to launch the monitor in the first place
	REM just in case new files were uploaded while the monitor was not running. 
:RELAUNCH_MONITOR
!bat_pushlog! [CALL !bat_batchfile!:RELAUNCH_MONITOR] %*

	process | Find /i "monitordir.exe"
	if !errorlevel! equ 0 (
		goto :RELAUNCH_MONITOR_END
	)

	!bat_echolog! Relaunching the MonitorDir.exe program...
	!bat_echolog!


    	REM       start /low /min monitordir.exe  "C:\cam213\cams\Temp\TempCal\From" "c:\cam213\CAMS\AutoCal_Remote.bat /zip" /FilenameChange /RunOnce /AddFileName /Creation /Activate
    !bat_echolog! !bat_CALIBRATION.REMOTE_autocal_remote_cmdline!
                  !bat_CALIBRATION.REMOTE_autocal_remote_cmdline!
    !bat_echolog!

	REM restarting polling
    !bat_CALL! call SCHTASKS  /Run /TN MonitorDir_Poll_Server

:RELAUNCH_MONITOR_END
!bat_popecho! [RETURN !bat_batchfile!:RELAUNCH_MONITOR] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3
!bat_return!





	REM #################################################################################
	REM This routine will do the following:
	REM  - display an error msg
	REM  - Add the error message to the ERRORS.txt file
	REM  - Zip the file into the bat_capturedfilesdir
	REM 
:ZIPERROR
!bat_pushlog! [CALL !bat_batchfile!:ZIPERROR] %*
	set bat_returncode=%~1
	set bat_retval=%~2
	
	!bat_echolog! 
	!bat_echolog! [!date! !time!] ERROR [%~1] - !bat_retval!
	!bat_echolog! 
	
	!bat_echolog! echo.[!date! !time!] ERROR [%~1] - !!bat_retval! }} "!bat_calstarsdir!\ERRORS.txt"
	echo.[!date! !time!] ERROR [%~1] - !!bat_retval!>>"!bat_calstarsdir!\ERRORS.txt"

	if not exist "!bat_results_stage!" (
		!bat_logexeclog! MD "!bat_results_stage!"
	)
	
	!bat_CALL! "!bat_exedir!\7zip.bat" "!bat_results_stage!\!bat_TempCalFromZipName!_Results!bat_TempCalFromZipExt!" "!bat_calstarsdir!\ERRORS.txt"

	!bat_logexeclog! tree /a /f "!bat_results_stage!"


:ZIPERROR_END
!bat_popecho! [RETURN !bat_batchfile!:ZIPERROR] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!






	REM ############################################################################################
	REM Called with bat_TempCalFromZipFull
	REM       "C:\CAMS\Temp\TempCal\CALSTARS0750_2016_01_16_13_00_00.zip"
	REM Returns:
	REM   bat_serverZipFileFull          The full path to the file triggering/invoking this script
	REM   bat_serverPath                 Folder on server where the zip source is downloaded from
	REM   bat_TempCalFrom                The folder parsed from "bat_serverZipFileFull"
	REM   bat_TempCalFromZipName
	REM   bat_TempCalFromZipExt
	REM   bat_TempCalFromZipSeq
	REM   bat_camera
	REM   bat_archivedfilesdir
	REM   bat_capturedfilesdir
	REM   bat_captureddate
	REM   bat_capturedtime
	REM   bat_captureddatetime
	REM   bat_calstarsdir
	REM   bat_calstars_caldir
	REM   bat_calstars_capturedfilesdir
	REM   bat_calstars_archivedfilesdir
	REM   bat_calfilelist
	REM   bat_GCFC_tempfile
	REM   bat_results_stage
	REM   
	REM   
:PARSEZIP [IN "!bat_TempCalFromZipFull!" ]
!bat_pushlog! [CALL !bat_batchfile!:PARSEZIP] %*

		REM Parse the server zip file and the server FROM folder name
	!bat_logexeclog! set    bat_serverZipFileFull=%~1
	!bat_logexeclog! set    bat_TempCalFromZipName=%~n1
	!bat_logexeclog! set    bat_TempCalFromZipExt=%~x1
	!bat_logexeclog! set /a bat_TempCalFromZipSeq=!bat_TempCalFromZipName:~-2!
	!bat_logexeclog! set    bat_camera=!bat_TempCalFromZipName:~9,3!
	
	                 set bat_serverPath=%~dp1::
	                 set bat_serverPath=!bat_serverPath:\::=!
	!bat_logexeclog! set bat_serverPath=!bat_serverPath:::=!

	
		REM Now set bat_TempCalFrom to: "Z:\From"
		REM bat_TempCalFrom will be where we download from and upload the results to.
	                 set bat_TempCalFrom=%~dp1::
	                 set bat_TempCalFrom=!bat_TempCalFrom:\::=!
	!bat_logexeclog! set bat_TempCalFrom=!bat_TempCalFrom:::=!
	
	if /i "!bat_TempCalFrom!" NEQ "!bat_CALIBRATION.REMOTE_server_dir!" (
		!bat_pushlog! 
			!bat_log! ERROR 
			!bat_log! bat_TempCalFrom NEQ bat_CALIBRATION.REMOTE_server_dir
			!bat_log! "!bat_TempCalFrom!" NEQ "!bat_CALIBRATION.REMOTE_server_dir!"
			!bat_log! They really need to match because Phase 1 will upload to the
			!bat_log! to "!bat_CALIBRATION.REMOTE_server_dir!", Phase 2 will download
			!bat_log! it from "!bat_TempCalFrom!", and Phase 3 will download from
			!bat_log! "!bat_CALIBRATION.REMOTE_server_dir!".
		!bat_poplog!
	)
	

		REM Now reroute the variable to use the REMOTE_autocal_workdir to copy the zip file from the server
		REM to and then to do all the remaining work in. This will be the file name from which the base
		REM work dir [bat_calstarsdir] will be derived.
	!bat_logexeclog! set bat_TempCalFromZipFull=!bat_CALIBRATION.REMOTE_autocal_workdir!\zip\!bat_TempCalFromZipName!!bat_TempCalFromZipExt!
	
	!bat_log! The server download folder is: "!bat_CALIBRATION.REMOTE_server_dir!"
	
	!bat_log! bat_CALIBRATION.REMOTE_autocal_workdir=!bat_CALIBRATION.REMOTE_autocal_workdir!
	
	!bat_logexeclog! set bat_calstarsdir=!bat_CALIBRATION.REMOTE_autocal_workdir!

	!bat_logexeclog! set bat_TempCalResults=!bat_calstarsdir!

		REM CALSTARS0999_2016_12_31_13_00_00_##.zip 
		REM 0123456789a123456789b123456798c123456798d
	!bat_logexeclog! set bat_captureddate=!bat_TempCalFromZipName:~13,10!
	!bat_logexeclog! set bat_capturedtime=!bat_TempCalFromZipName:~-11,8!
	!bat_logexeclog! set bat_captureddatetime=!bat_captureddate!_!bat_capturedtime!
	
	!bat_logexeclog! set bat_capturedfilesdir=!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!
	!bat_logexeclog! set bat_archivedfilesdir=!bat_calstarsdir!\ArchivedFiles\!bat_captureddatetime!
	
	!bat_logexeclog! set bat_calstars_caldir=!bat_calstarsdir!\Cal
	!bat_logexeclog! set bat_calstars_capturedfilesdir=!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!
	!bat_logexeclog! set bat_calstars_archivedfilesdir=!bat_calstarsdir!\ArchivedFiles\!bat_captureddatetime!

	
	!bat_logexeclog! set bat_calfilelist=!bat_calstars_archivedfilesdir!\CalFileList.log
	!bat_logexeclog! set bat_GCFC_tempfile=!bat_calstars_capturedfilesdir!\GCFC.log
	!bat_logexeclog! set bat_results_stage=!bat_calstarsdir!\stage


:PARSEZIP_END
!bat_popecho! [RETURN !bat_batchfile!:PARSEZIP] [
!bat_log! `                                     bat_TempCalFromZipFull=!bat_TempCalFromZipFull!
!bat_log! `                                     bat_TempCalFromZipName=!bat_TempCalFromZipName!
!bat_log! `                                     bat_TempCalFromZipExt=!bat_TempCalFromZipExt!
!bat_log! `                                     bat_TempCalFromZipSeq=!bat_TempCalFromZipSeq!
!bat_log! `                                     bat_camera=!bat_camera!
!bat_log! `                                     bat_archivedfilesdir=!bat_archivedfilesdir!
!bat_log! `                                     bat_capturedfilesdir=!bat_capturedfilesdir!
!bat_log! `                                     bat_captureddate=!bat_captureddate!
!bat_log! `                                     bat_capturedtime=!bat_capturedtime!
!bat_log! `                                     bat_captureddatetime=!bat_captureddatetime!
!bat_log! `                                     bat_calstarsdir=!bat_calstarsdir!
!bat_log! `                                     bat_calstars_caldir=!bat_calstars_caldir!
!bat_log! `                                     bat_calstars_capturedfilesdir=!bat_calstars_capturedfilesdir!
!bat_log! `                                     bat_calstars_archivedfilesdir=!bat_calstars_archivedfilesdir!
!bat_log! `                                     bat_TempCalFrom=!bat_TempCalFrom!
!bat_log! `                                     bat_TempCalResults=!bat_TempCalResults!
!bat_log! `                                     bat_calfilelist=!bat_calfilelist!
!bat_log! `                                     bat_GCFC_tempfile=!bat_GCFC_tempfile!
!bat_log! `                                     bat_results_stage=!bat_results_stage!
!bat_log! `                                     ]
!bat_log!
rem rem !bat_WAIT! 3
!bat_return!






	REM #################################################################################
	REM called like this: 
	REM   call :ERROR "{routine name}" {error code}" "error string"
	REM 
	REM example:
	REM   call :ERROR "APPLYCAL" 31 "Can't find detect file: [!bat_detectfile!]"
	REM
:ERROR [IN bat_returncode IN "error string"]
!bat_log! [CALL !bat_batchfile!:ERROR] %*

	set bat_returncode=%~2
	!bat_echolog!
	!bat_echolog! [!date! !time! !bat_batchfile!:%~1] ERROR [%~2] - %~3
	!bat_echolog!
	
	!bat_WAIT! 15


:ERROR_END
!bat_poplog! [RETURN !bat_batchfile!:ERROR] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!






	REM #################################################################################
:HELP
	@echo off
	echo.
	echo.%~nx0
	echo.
	echo Usage: %~nx0 [/results "^<tempCalResults dir^>"] [/calstars "^<working dir^>"] /zip "^<zip file^>" 
	echo.   
	echo.Performs the second phase of AutoCal_Remote using the CALSTARS contained in the 
	echo.specified zip file.  When it is done processing the first file, it then looks at the 
	echo.dir and processes all remaining files until the FROM dir is empty.  Then it 
	echo.re-launches the MonitorDir program. 
	echo.
	echo.It might also need to communicate back to the waiting operator by giving  them a zip file
	echo.but the zip file contains an ERRORS.txt file that explains what went wrong.  If the 
	echo.ERRORS.txt file is not present, then it was successful. 
	echo.
	echo.The zip file should contain:
	echo.  - One CALSTARS file for each camera
	echo.  - A copy of ..\Cal\CameraSites.txt 
	echo.  - A copy of ..\Cal\LASTSETTINGS.txt 
	echo.  - A copy of the most recent CAL file for each camera prior to the date/time of the capturesession
	echo.  - An md5.output.txt for each of the files in the zip.
	echo.  - Possibly, a file containing any additional settings [to be read by ReadAutoCal_Remote.bat], such as:
	echo.       autocams.params.ini [CALIBRATION]    bat_calnstars=50
	echo.       autocams.params.ini [CALIBRATION]    bat_caloc=2.50
	echo.       autocams.params.ini [CALIBRATION]    bat_starcountthreshold=50
rem	echo.       autocams.params.ini [CALIBRATION]    remote_skip=71
rem	echo.       autocams.params.ini [CALIBRATION]    remote_nstars=200
	echo.
	echo.     [Note: These will be written by: "SaveAutoCal_Remote.bat"]
	echo.
	echo.Where:
	echo.  /zip             is the CALSTARS*.zip file that was uploaded
	echo.
	echo.  /results         is where to place the results that the person uploading will look for them to download.
	echo.                   DEFAULT: !bat_calstarsdir!
	echo.
	echo.  /calstars        is where the CALSTARS*.txt files will be unzipped to and also where
	echo.                   the CAL files will be created by AutoCal.bat. 
	echo.                   DEFAULT: !bat_exedir!\Temp\TempCal
	echo.
	echo.
	echo.Example:
	echo.  AutoCal_Remote.bat /from "C:\CAMS\Temp\TempCal" 
	echo.                     /results "C:\CAMS\Temp\TempCal" 
	echo.                     /calstars "C:\CAMS\Temp\TempCal"
	echo.                     /zip "C:\CAMS\Temp\TempCal\CALSTARS0750_2016_01_16_13_00_00.zip"
	echo.
	echo. start /low /min monitordir.exe "C:\cam213\cams\Temp\TempCal" "c:\cam213\CAMS\AutoCal_Remote.bat /results C:\cam213\cams\Temp\TempCal /calstars C:\cam213\cams\Temp\TempCal /zip" /FilenameChange /RunOnce /AddFileName /Creation /Activate

exit /b 99




	REM #################################################################################
:DONE
	!bat_popecho!
	!bat_echolog! [!bat_batchfile!:DONE]Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! [!bat_batchfile!:DONE] exit /b !bat_returncode!

exit /b !bat_returncode!

