@echo off
setlocal enableextensions enabledelayedexpansion


	Rem ===========================================================================================
	Rem                     :CHECKHELP
	Rem ===========================================================================================
	Rem   Check command line for request for help 
	Rem ===========================================================================================

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
goto :SETUP



	Rem ===========================================================================================
	Rem                     :SETUP
	Rem ===========================================================================================
	Rem   Set up application variables and get command line arguments
	Rem ===========================================================================================

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	if /i "%~1" equ "" (
		set bat_returncode=90
		!bat_echolog!
		!bat_echolog! .    ERROR - You must provide the duration as the first command line argument
		!bat_echolog!
		goto :DONE
	)
	
	
	!bat_echolog!  call "!bat_exedir!\ReadParams_capture16.bat"
	               call "!bat_exedir!\ReadParams_capture16.bat"


	if not defined bat_RUN.number_of_boards (
		set bat_number_of_boards=1
	)

	set bat_board=0
	set bat_sensoray_config_file_full=Sensoray812_config_board_!bat_board!.txt
	set bat_archive_mode=2
	set bat_camera_first=!bat_firstcamera!
	set bat_duration=%~1

	set bat_capture8_exe_filename=FTP_Capture8AndDetect_!bat_board!.exe
	set bat_capture8_exe_full=!bat_exedir!\!bat_capture8_exe_filename!
	
	
	
goto :MAIN %*




	Rem ===========================================================================================
	Rem                     :MAIN
	Rem ===========================================================================================
	Rem   Call all the subroutines.  
	Rem ===========================================================================================

:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] [%*]

	rem Returns !bat_capturesession_precapture!
	call :GET_PRECAPTUREFOLDER
	if !errorlevel! neq 0 (
		rem No previous directories exist in the CapturedFiles dir. This should be the normal case. 
rem		goto :MAIN_END
	)

	
	!bat_echolog! copy /y "!bat_exedir!\FTP_Capture8AndDetect.exe" "!bat_capture8_exe_full!"
	              copy /y "!bat_exedir!\FTP_Capture8AndDetect.exe" "!bat_capture8_exe_full!"

	!bat_echolog! start "!bat_capture8_exe_full!" "!bat_capture8_exe_full!" "!bat_sensoray_config_file_full!" !bat_archive_mode!  !bat_camera_first!  !bat_numdetectproc%bat_board%! !bat_duration! "!bat_CAMS_directory!"
	              start "!bat_capture8_exe_full!" "!bat_capture8_exe_full!" "!bat_sensoray_config_file_full!" !bat_archive_mode!  !bat_camera_first!  !bat_numdetectproc%bat_board%! !bat_duration! "!bat_CAMS_directory!"

		REM Now wait three seconds so that the new capture process can start and so that the process.exe can manipulate the affinity mask. 
	!bat_WAIT!  3

		rem Workaround for Windows 8 seems to limit the process affinity to cpus 4 and 5 and allow it to 
		rem run on all 8 processors
	for /f "usebackq tokens=1-3" %%a in (`process^|find /i "!bat_capture8_exe_filename!"`) do (
			process|find /i "!bat_capture8_exe_filename!"
			process -a %%b !bat_RUN.processor_affinity_mask!
	)
	
		Rem After 3 seconds, it should have created the folder for the new capture session.  We need to determine
		rem that capture session folder BEFORE the second board's capture session starts...
		rem 
		rem Returns: bat_capturesession
		rem          bat_capturedfilesdir
	call :GET_POSTCAPTUREFOLDER
	if !errorlevel! neq 0 (
		rem No directories were created by capture 
		goto :MAIN_END
	)
	
		rem This should wait for the capture session to finish. At which time, we can do some other post-capture processing.
	!bat_echolog! Waiting for "!bat_capture8_exe_full!" to finish.......
	call WaitForFile rw "!bat_capture8_exe_full!"
	
	!bat_echolog! [!bat_batchfile!:MAIN] -----------------------------------------------------------------
	!bat_echolog! [!bat_batchfile!:MAIN] -----------------------------------------------------------------
	!bat_echolog! [!bat_batchfile!:MAIN] -----------------------------------------------------------------
	!bat_echolog! [!bat_batchfile!:MAIN] [!date! !time!] Capture Finished
	!bat_echolog! [!bat_batchfile!:MAIN] bat_archivedfilesdir=!bat_archivedfilesdir!
	!bat_echolog! [!bat_batchfile!:MAIN] bat_capturesession=!bat_capturesession!
	!bat_echolog!

	call :CLEANUP_DETECT_FILES
	
	call :GETDETECTFILE  "bat_detectfile" "!bat_archivedfilesdir!"

	call :AUTOCAL
	
	call :APPLYAUTO
	

:MAIN_END
!bat_popecho! [END-!bat_batchfile!:MAIN] - goto :DONE
!bat_echolog!
goto :DONE











	Rem ===========================================================================================
	Rem                     :GET_PRECAPTUREFOLDER
	Rem ===========================================================================================
	Rem   Identify the most recently run CapturedFiles subfolder by sorting on folder name (date)
	Rem   from earliest created to most recent.  We do this before starting the capture program.
	REM   As soon as the capture program starts, it wil reate another new capture directory and
	Rem   this routine will detect that folder. 
	Rem ===========================================================================================

:GET_PRECAPTUREFOLDER
!bat_pushecho! [CALL   !bat_batchfile!:GET_PRECAPTUREFOLDER] [%*]

	set bat_returncode=0

	set bat_capturesession_precapture=2000_01_01_00_00_00


	for /f "usebackq tokens=*" %%a in (`dir "!bat_CAMS_capturefolder!\????_??_??_??_??_??" /ad /s/b /on`) do (

		set bat_capturesession_precapture=%%~na
	)
	
	if not defined bat_capturesession_precapture (
		set bat_returncode=0
		!bat_echolog! .   ### - No previous directories in the CapturedFiles directory.
		set bat_capturesession_precapture=2000_01_01_00_00_00
	)
	
	if /i "!bat_capturesession_precapture!" equ "2000_01_01_00_00_00" (
		set bat_returncode=0
		!bat_echolog! .   ### - No previous directories in the CapturedFiles directory.
	)
	
	


:GET_PRECAPTUREFOLDER_END
!bat_popecho! [RETURN !bat_batchfile!:GET_PRECAPTUREFOLDER]   [exitcode=!bat_returncode!, Before capture session: "!bat_capturesession_precapture!"]
!bat_echolog!
exit /b !bat_returncode!


	




	Rem ===========================================================================================
	Rem                     :GET_POSTCAPTUREFOLDER
	Rem ===========================================================================================
	Rem   Identify newly generated CapturedFiles subfolder by sorting on folder name (date) from
	Rem   earliest created to most recent.
	Rem ===========================================================================================

:GET_POSTCAPTUREFOLDER
!bat_pushecho! [CALL   !bat_batchfile!:GET_POSTCAPTUREFOLDER] [%*]

	set bat_returncode=1
	set bat_capturesession=2000_01_01_00_00_00
	set bat_archivedfilesdir=


	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_CAMS_capturefolder!\????_??_??_??_??_??" /ad /s/b /on`^) do ^(
	              for /f "usebackq tokens=*" %%a in  (`dir "!bat_CAMS_capturefolder!\????_??_??_??_??_??" /ad /s/b /on`) do (
		set bat_capturesession=%%~na
		
		if "!bat_capturesession!" neq "!bat_capturesession_precapture!" (
			set bat_capturedfilesdir=%%a

			set bat_archivedfilesdir=%%a
			rem !bat_echolog! !bat_archivedfilesdir!

			set bat_archivedfilesdir=!bat_CAMS_archivefolder!\!bat_capturesession!

			set bat_returncode=0
		)
	)

	if "!bat_returncode!" neq "0" (
		!bat_echolog! .   ###ERROR - No New Captured Files Folder ###ERROR
		goto :GET_POSTCAPTUREFOLDER_END
	)
	


:GET_POSTCAPTUREFOLDER_END
!bat_popecho! [RETURN !bat_batchfile!:GET_POSTCAPTUREFOLDER]  [exitcode=!bat_returncode!, Capture session = "!bat_capturesession!"
!bat_echolog!                                           bat_capturedfilesdir="!bat_capturedfilesdir!"
!bat_echolog!                                           bat_archivedfilesdir="!bat_archivedfilesdir!"
!bat_echolog!                                           bat_detectfile="!bat_detectfile!"]
!bat_echolog!
exit /b !bat_returncode!




	Rem ===========================================================================================
	Rem                     :CLEANUP_DETECT_FILES
	Rem ===========================================================================================
	Rem   Clean up the left-over temporary detect files used by the background detect processes
	Rem ===========================================================================================

:CLEANUP_DETECT_FILES
!bat_pushecho! [CALL !bat_batchfile!:CLEANUP_DETECT_FILES] [%*]

	set bat_returncode=0

	if not exist "!bat_archivedfilesdir!\FTPdetectinfo_??????.txt" (
		set bat_returncode=1
		!bat_echolog! .    ###ERROR - not found: "!bat_archivedfilesdir!\FTPdetectinfo_??????.txt"
		goto CLEANUP_DETECT_FILES_END
	)

	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_??????.txt" /b /a-d /on`) do (
		!bat_logexec! move /y "!bat_archivedfilesdir!\%%a"  "!bat_archivedfilesdir!\xxx%%a" 
	)

:CLEANUP_DETECT_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:CLEANUP_DETECT_FILES] [bat_returncode=!bat_returncode!]
exit /b !bat_returncode!




	Rem ===========================================================================================
	Rem                     :CLEANUP_DETECT_FILES
	Rem ===========================================================================================
	Rem   Clean up the left-over temporary detect files used by the background detect processes
	Rem
	Rem 7b. Cal Auto Update ********************************************
	Rem ===========================================================================================

:AUTOCAL
!bat_pushecho! [CALL !bat_batchfile!:AUTOCAL] %* [AUTOCAL... bat_archivedmeteorcount=!bat_archivedmeteorcount!]

	set bat_returncode=0
	set bat_retval=success



	set bat_returncode=0
	set bat_retval=failed


	rem Should be something like:
	rem   call ""autocal.bat" 100 1.00 "!bat_caldir!" "!bat_capturedfilesdir!"
	rem
	rem And then check the autocal log for success/failure



	if /i "!bat_archivedmeteorcount!" equ "-1" (
		!bat_push!
			set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - Meteor Count is 0. Nothing to calibrate.
			!bat_echolog! !bat_recent_error_msg!
			call :SAVECONFIG

			set bat_retval=failed
			set bat_returncode=1
		!bat_pop!
		goto :AUTOCAL_END
	) else (
		!bat_push!
		
			rem Call AutoCal.bat to perform the autocal procedure.  Returns errorlevel...
			!bat_log! call "!bat_exedir!\AutoCal.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera_first! !bat_calnstars! !bat_caloc! !bat_autonomous!
			          call "!bat_exedir!\AutoCal.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera_first! !bat_calnstars! !bat_caloc! !bat_autonomous!
			set bat_returncode=!errorlevel!

			!bat_echolog! Return code from FTP_MeteorCal_AutoUpdate.exe is: !bat_returncode!
			set bat_retval=executed
		!bat_pop!
	)
	
	!bat_echolog!
	!bat_echolog! "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
	!bat_echolog!
	
	set bat_calfilelist.created=

	!bat_pushecho! Validate the AutoCalUpdate.log file for each camera...
	set bat_camera_temp=
	for /f "usebackq tokens=1-12 skip=2" %%a in (`find /i "camera " "!bat_capturedfilesdir!\AutoCalUpdate.log"`) do (
		set bat_autocal_success=0

		if /i "%%a" neq "Auto-Calibrating" (
			!bat_echolog! %%a %%b %%c %%d, %%e %%f %%g %%h %%i

			if /i "%%a" equ "camera" (
				set bat_autocal_camera=%%b
				set bat_autocal_success=%%c
				set bat_autocal_nstars=%%d
				set bat_autocal_oc=%%e
				set bat_autocal_fffile=%%f
				set bat_autocal_calfile=%%g

				if !bat_autocal_oc! GTR !bat_caloc! (
					set bat_autocal_success=1
					set bat_returncode=1
					set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - ERROR   O-C !bat_autocal_oc! GTR !bat_caloc!
					call :SAVECONFIG
					!bat_push!
						!bat_echolog!
						!bat_echolog! !bat_recent_error_msg!
						!bat_echolog!
						!bat_echolog! Camera:	!bat_autocal_camera!
						!bat_echolog! Success:	FAILED
						!bat_echolog! nStars:	!bat_autocal_nstars!
						!bat_echolog! O-C:	!bat_autocal_oc!
						!bat_echolog! FF file:	!bat_autocal_fffile!
						!bat_echolog! calfile:	!bat_autocal_calfile!
						!bat_echolog!
					!bat_pop!

					rem Delete the cal file if the O-C value is too high, even though
					rem the .exe program thinks it's ok. 
					if "!bat_autocal_calfile!" neq "" (
						if exist "!bat_caldir!\!bat_autocal_calfile!" (
							if defined bat_caldir (
								if defined bat_autocal_calfile (
									!bat_logexec! del "!bat_caldir!\!bat_autocal_calfile!"
								) else (
									!bat_echolog! ERROR [!bat_batchfile!:CALUPDATEAUTO] Dangerous command: del "!bat_caldir!\!bat_autocal_calfile!" 
								)
							) else (
								!bat_echolog! ERROR [!bat_batchfile!:CALUPDATEAUTO] Dangerous command: del "!bat_caldir!\!bat_autocal_calfile!" 
							)
						)
					)

					!bat_echolog! '    !bat_recent_error_msg!
				)& rem !bat_autocal_oc! GTR !bat_caloc!
	
				if /i "!bat_autocal_success!" neq "0" (
					set bat_returncode=1
					!bat_echolog! '    set bat_returncode=[!bat_returncode!]
					set bat_recent_error_msg=ERROR - 7b.a. Auto Calibration failed
					call :SAVECONFIG
					!bat_echolog! '    !bat_recent_error_msg!
				) else (
					!bat_push!
						!bat_echolog!
						!bat_echolog! Camera:	!bat_autocal_camera!
						!bat_echolog! Success:	SUCCESS
						!bat_echolog! nStars:	!bat_autocal_nstars!
						!bat_echolog! O-C:		!bat_autocal_oc!
						!bat_echolog! FF file:	!bat_autocal_fffile!
						!bat_echolog! calfile:	!bat_autocal_calfile!
						!bat_echolog!
					!bat_pop!
					set bat_recent_error_msg=SUCCESS - 7b. Auto Calibration successful [!bat_autocal_calfile!, !bat_autocal_nstars!, !bat_autocal_oc!]
					call :SAVECONFIG
					!bat_echolog! '    !bat_recent_error_msg!
					
					if not defined bat_calfilelist.created (
						call :CREATECALFILELIST "!bat_detectfile!"
						call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
						call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
						set bat_calfilelist.create=true
					)

				)
	
				!bat_echolog!
			)
		)
	)
	!bat_popecho! End of validation...
	

:AUTOCAL_END
!bat_popecho! [RETURN !bat_batchfile!:AUTOCAL] [!bat_retval!, !bat_returncode!]
!bat_echolog!
set bat_calfilelist.created=
!bat_return!





	rem 9. Apply cal to detectinfo *******************************
:APPLYAUTO
!bat_echolog! [CALL !bat_batchfile!:APPLYAUTO] %*
	set bat_retval=failed
	set bat_latestcal=

	if "!bat_archivedmeteorcount!" equ "0" (
		!bat_errorlog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous
				    call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous>nul:
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			!bat_echolog! '    ERROR ApplyCal.bat failed
			goto :APPLYAUTO_END
		)

	if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
		!bat_echolog! '    ERROR - Can't find detect file: "!bat_archivedfilesdir!\!bat_detectfile!"
		goto :APPLYAUTO_END
	)

		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...>>"!bat_logfile!"
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
		for      /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
			if not defined bat_latestcal (
				set bat_latestcal=%%a
			)
		)
	)

	!bat_echolog! '    Cal file in "!bat_archivedfilesdir!\!bat_detectfile!":
	!bat_echolog! '    "!bat_latestcal!"
	if defined bat_latestcal (
		set bat_retval=success
	)
	
:APPLYAUTO_END
!bat_echolog! [RETURN !bat_batchfile!:APPLYAUTO] [!bat_retval!, "!bat_latestcal!"]
!bat_log!
!bat_return!










	rem Calls the GetDetectFile.bat script, passing along the two arguments passed.
	rem [out] The first parameter is used as the target variable where the discovered
	rem       detect file in the source dir [specified in the 2nd argument] is stored.
	rem [in]  The source directory.  Typically, either bat_archivedfilesdir
	rem       or bat_confirmedfilesdir.  Could also be directories in the
	rem       SubmissionFiles dir.
:GETDETECTFILE [out] "bat_detectfile" [in] "!bat_archivedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_returncode=0
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "%~1" "%~2"

	if not defined %~1 (
		set bat_returncode=1
		!bat_log! '    ERROR - Unable to locate detect file [%~1].
		goto :GETDETECTFILE_END
	) else (
		call :GETDETECTFILE_PARSE "!%~1!"
	)

	if not exist "!%~1!" (
		set bat_returncode=2
		!bat_log! '    ERROR - Unable to locate detect file [%~1].
		goto :GETDETECTFILE_END
	)

:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode, %~1=!%~1!]
!bat_log!
!bat_return!




	rem Take the specified detect fiel and produce four variables out of it as follows:
	rem   bat_detectfile1    full detectfile name
	rem   bat_detectfile3    Just the filename w/o extent
	rem   bat_detectfile4    The filename w/ extent
:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE_PARSE] %*
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE_PARSE] [bat_detectfile1=!bat_detectfile1!, 
!bat_log! `                                          bat_detectfile3=!bat_detectfile3!,
!bat_log! `                                          bat_detectfile4=!bat_detectfile4!]
!bat_log!
!bat_return!




:GETMETEORCOUNTARCHIVED [in] bat_archivedmeteorcount "!bat_archivedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETMETEORCOUNTARCHIVED] [%*]
	set bat_temp=%~1
	!bat_log! argv[1]="%~1"

	if /i "!bat_temp!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_temp=%~2
	!bat_log! bat_argv[2]="%~2"
	if /i "!bat_temp!" equ "" (
		!bat_log! '    ERROR - !bat_batchfile!:GETMETEORCOUNTARCHIVED - 2nd argument is missing.
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_temp=%~2
	set bat_temp2=%~nx2
	if not defined bat_capturedtime (
		if defined bat_capturedfilesdir (
				rem Parse the bat_capturedfilesdir and extract the time segment
			for /f "usebackq tokens=*" %%x in (`echo "!bat_capturedfilesdir!"`) do (
				set bat_temp3=%%~nxx
				set bat_capturedtime=!bat_temp3:~11,8!
			)
		) else (
			!bat_echolog! '    ERROR !bat_batchfile!:GETMETEORCOUNTARCHIVED - bat_capturedfilesdir isn't defined yet.
			goto :GETMETEORCOUNTARCHIVED_END
		)
	)

	if not defined bat_detectfile (
		!bat_echolog! '    Not defined: bat_detectfile, setting to "!bat_detectfile!"
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set %~1=
	set bat_latestcal=

	if /i "%~2" equ "" (
		!bat_echolog! '    WARNING - !bat_batchfile!:GETMETEORCOUNTARCHIVED - No ArchivedFiles directory
		goto :GETMETEORCOUNTARCHIVED_END
	)

	if not defined bat_detectfile (
		call :FINDDETECT "bat_detectfile" "bat_archivedfilesdir"
	)

	
	set /a %~1=0
	rem !bat_log! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_detectfile!"`^) do ...
	rem for           /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile!"`) do (
	!bat_log! for /f "usebackq tokens=1-3 skip=1 delims=:" ..a in ^(`find /i /c ".txt" "!bat_detectfile!"`^) do ...
	for           /f "usebackq tokens=1-3 skip=1 delims=:" %%a in  (`find /i /c ".txt" "!bat_detectfile!"`) do (
		rem set /a %~1+=1
		set bat_temp=%%c
		set bat_temp=!bat_temp:~1,20!
		set /a %~1=!bat_temp!
		set bat_temp=
	)

	call :GETLATESTCAL "!bat_captureddate!"

	!bat_logexeclog! type "!bat_archivedfilesdir!\CalFileList.log"

	!bat_pushlog! Perform ValidateCal.bat for each file in: "!bat_archivedfilesdir!\CalFileList.log"...
	for /f "usebackq tokens=*" %%X in (`type "!bat_archivedfilesdir!\CalFileList.log"`) do (
		set bat_temp=%%X
		if /i "!bat_temp:~4,6!" equ "!bat_camera!" (
			set bat_detectcal=%%X
		)
		
		!bat_echolog! Validating Cal files..."%%X"
		!bat_log! call "!bat_exedir!\ValidateCal.bat" /cal "%%X"
		          call "!bat_exedir!\ValidateCal.bat" /cal "%%X"
		!bat_echolog!
	)
	!bat_pop!
!bat_log! /////////////  bat_latestcal=!bat_latestcal!, bat_detectcal=!bat_detectcal!

:GETMETEORCOUNTARCHIVED_END
!bat_poplog! [RETURN !bat_batchfile!:GETMETEORCOUNTARCHIVED] [bat_archivedmeteorcount=!bat_archivedmeteorcount!, bat_latestcal=!bat_latestcal!, bat_detectcal=!bat_detectcal!]
!bat_log!
!bat_return!







	rem Creates the "CalFileList.log" in the ArchivedFiles dir.  The file
	rem contains a list of all the Cal files found in the detect file
	rem [one for each camera in the detect file]. 
:CREATECALFILELIST
!bat_pushlog! [CALL !bat_batchfile!:CREATECALFILELIST] %*
	!bat_log! call "!bat_exedir!\CreateCalFileList.bat" "!bat_detectfile!"
	          call "!bat_exedir!\CreateCalFileList.bat" "!bat_detectfile!"

:CREATECALFILELIST_END
!bat_poplog! [RETURN !bat_batchfile!:CREATECALFILELIST] [!bat_camera_list!]
!bat_log!
!bat_return!






	rem 48. Save Configuration ************************************
:SAVECONFIG
!bat_pushlog! [CALL !bat_batchfile!:SAVECONFIG] [%*]
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
	echo bat_recent_error_msg=!bat_recent_error_msg!>>"!bat_configfile!"
:SAVECONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:SAVECONFIG] []
!bat_log!
!bat_return!




:HELP
	echo.%~0	Batch Script
	echo.Usage: %~0 ^<duration^> 
	echo.
	echo.Where:
	echo.   duration        is either a positive number of hours to record or
	echo.                   a negative number representing the sun angle.  
	echo.                   Specifying a negative number causes the program to
	echo.                   use the absolute value of the sun angle as the number
	echo.                   of degrees below the horizon to start/stop capture.
	echo.
	echo.Example:
	echo.   %~0   0.1          to capture both cameras for 6 minutes.
	echo.   %~0   -8           to capture when between astronomical dusk to dawn.
	echo.
exit /b 99







:DONE
	!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! Done with %0 %*
	!bat_echolog!
	
exit /b !bat_returncode!


