  @echo off
setlocal enabledelayedexpansion enableextensions

	REM ###########################################################
	REM 

:CHECKHELP
	rem CONSTANTS

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
goto :SETUP

	REM ###########################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"


	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_push!

	call "!bat_exedir!\ReadParams.bat"
	
	set bat_caldir=%~1
	set bat_targetdir=%~2
	set bat_code=%3


	call :COPYCAMERASFROMSITESFILE

goto :DONE


	REM ###########################################################
	REM 

:COPYCAMERASFROMSITESFILE [IN bat_caldir, IN bat_targetdir]
!bat_pushlog! [call !bat_batchfile!:COPYCAMERASFROMSITESFILE %*]



	set bat_code= !bat_code! 
	
	if not defined bat_code (
		set bat_switches=/v
	) else (
		set bat_switches=/i
	)

	!bat_pushlog! for /f "usebackq tokens=1-9* skip=4" ..b in ^(`find !bat_switches! "!bat_code!" "!bat_caldir!\CameraSites.txt"`^) do ^(
	for               /f "usebackq tokens=1-9* skip=4" %%b in  (`find !bat_switches! "!bat_code!" "!bat_caldir!\CameraSites.txt"`) do (
		if not exist "!bat_targetdir!\%%f" (
			!bat_logexec! COPY /Y "!bat_caldir!\%%f" "!bat_targetdir!\%%f"
		)
	)
	!bat_poplog! ^)


:COPYCAMERASFROMSITESFILE
!bat_poplog! [return !bat_batchfile!:COPYCAMERASFROMSITESFILE] []
!bat_log!
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_return!



	REM ###########################################################
	REM 

:HELP
	echo.
	echo.%~nx0
	echo.
	echo.Usage: %~nx0  ^<cal dir^>  ^<target dir^> [code]
	echo.
	echo.Copies the camera files matching [code], such as "W902H2U_12mm.txt", as listed from the camerasites.txt file
	echo.to the target dir. 
	echo.
	echo.This script was designed for use prior to coincidence processing, which needs these files. 
	echo.
	echo.Where: 
	echo.       cal dir			is the "..\CAMS\Cal" dir
	echo.       target dir			is the copy destination to copy the files to
	echo.       code			is the code column from the CameraSites.txt file 
	echo.
	echo.Examples:
	echo.   To copy all the camera files used at the Forest Hill station [code=FH], enter this command:
	echo.      %~nx0 "D:\cams16\CAMS\cal"   "d:\cams16\CAMS\Temp"  FH
	echo.
	echo.   To copy ALL the camera files referenced in the CameraSites.txt files from all sites/stations, enter this command:
	echo.      %~nx0 "D:\cams16\CAMS\cal"   "d:\cams16\CAMS\Temp"
	echo.
	echo.    
!bat_return! 99


	REM ###########################################################
	REM 

:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!
                  exit /b !bat_returncode!


