@echo off

setlocal enableextensions enabledelayedexpansion

:CHECKHELP
	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	if /i "%~1" equ "" goto :HELP
	if /i "%~2" equ "" goto :HELP

	set bat_capturedfilesdir=%~1

	set bat_detectfile=%~nx2

	set bat_archivedfilesdir=%~dp2::
	set bat_archivedfilesdir=!bat_archivedfilesdir:\::=!
	set bat_archivedfilesdir=!bat_archivedfilesdir:::=!

goto :MAIN



:MAIN

		REM This loop copies all the FF files that are referenced in the detect file from
		REM from the bat_capturedfilesdir to the bat_archivedfilesdir.
		REM Because the loop is kind of crude, it skips any files that already exist. This can 
		REM happend because there can be multiple events in a single FF file, especially 
		REM noise-related false-positive events. 
		REM
	set bat_counter=0
	!bat_echolog! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".bin" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ^(
	              for /f "usebackq tokens=* skip=2" %%a in  (`find /i ".bin" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
	    if not exist "!bat_archivedfilesdir!\%%~a" (
			set /a bat_counter+=1
			echo     copy /y "!bat_capturedfilesdir!\%%~a" "!bat_archivedfilesdir!"
					 copy /y "!bat_capturedfilesdir!\%%~a" "!bat_archivedfilesdir!"
	    ) else (
	    	echo.                        Already exists - Skipping: "!bat_archivedfilesdir!\%%a"
	    )
	)
	echo.
	echo Total copied=!bat_counter!
goto :DONE



:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo     Usage: %~nx0 ^<capturedfilesdir^>  ^<full detect file path and filename^>
	echo.
	echo     This script copies each FF file mentioned in the 
	echo     "detect file" file from the 
	echo     ^<capturedfilesdir^> directory to the ^<archivedfilesdir^>
	echo     directory. 
	echo.
	echo    NOTE:
	echo     This script was created for those situations where the 
	echo     FTPdetectinfo_0*.txt file is good, but the FF*.bin files 
	echo     in the ArchivedFiles directory are missing.  Therefore, 
	echo     this script restores the ArchivedFiles directory, but it
	echo     depends on a valid FTPdetectinfo_0*.txt file.
	echo.
	echo     If you don't have a valid FTPdetectinfo_*.txt file, you will
	echo     need to re-run the MakeCaseListing.bat script in order to
	echo     rerun the Reprocess function. 
	echo.
	echo     Example: 
	echo         %~n0  "c:\CAMS\CapturedFiles\2014_04_09_03_13_59" "c:\CAMS\ArchivedFiles\2014_04_09_03_13_59\FTPdetectinfo_09980999_2014_04_09_03_13_59.txt"
	echo.
exit /b 99


:DONE
!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b 0
