  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	if /i "%~1" equ "" (goto :HELP)

goto :SETUP

		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
rem	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "%~2" neq "" (
		rem We're creating the cal file list in a different area, probably for Coincidence...
		
		!bat_logexeclog! set bat_capturedfilesdir=%~2
		!bat_logexeclog! set bat_caldir=%~3

		!bat_logexeclog! set bat_GCFC_tempfile=!bat_detectdir!\SortDetect_CameraList.txt
	) else (
		set bat_GCFC_tempfile=!bat_detectdir!\SortDetect_CameraList.txt
		set bat_caldir=!bat_startlocation!\Cal
	)
	
	

	!bat_logexeclog! set bat_detectfile_temp=%~1
	!bat_logexeclog! set bat_detectfile_filename=%~nx1
	!bat_logexeclog! set bat_detectfile_name=%~n1
	                 set bat_detectfile_dir=%~dp1::
	                 set bat_detectfile_dir=!bat_detectfile_dir:\::=!
	!bat_logexeclog! set bat_detectfile_dir=!bat_detectfile_dir:::=!

	set bat_cameralist_file=!bat_detectfile_dir!\SortDetect_CameraList.txt

	set bat_calfilelist=!bat_detectfile_dir!\CalFileList.log
	set bat_junkfile=!bat_detectfile_dir!\junk.txt

	(echo.%*|find /i "/force") && (
		!bat_log! [!bat_batchfile!:SETUP] ***** [FORCING REBUILD]
		!bat_logexeclog! set bat_force_rebuild=/force
		goto :MAIN %*
	)

		REM if "CalFileList.log" exists AND "SortDetect_CameraList.txt" exists then don't rebuild them.
		REM 
	!bat_log! (dir "!bat_calfilelist!" /b /a-d /on}nul: 2>&1) $$ (dir "!bat_cameralist_file!"}nul: 2>&1) ...
	(dir "!bat_calfilelist!" /b /a-d /on>nul: 2>&1) && (dir "!bat_cameralist_file!">nul: 2>&1) && (
		REM -IF-
		!bat_log!
		!bat_log! `[!bat_batchfile!:SETUP] **** OK - ALREADY EXISTS - USING THOSE... **** 
		!bat_log!
		goto :DONE

	) || (
		REM -ELSE-
		!bat_log!
		!bat_log! `[!bat_batchfile!:SETUP] **** OK - DOESN'T ALREADY EXIST - REBUILD THEM... **** 
		!bat_log!
	)


goto :MAIN %*



:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] [%*]

	!bat_log! bat_cameralist_file=!bat_cameralist_file!
	if not exist "!bat_cameralist_file!" (

		!bat_CALL! "!bat_exedir!\CreateCameraListFileFromDetectFile.bat" "!bat_detectfile_temp!"
		set bat_returncode=!errorlevel!
		
	) else (
	
		!bat_log! Already exists - CreateCameraListFileFromDetectFile.bat "!bat_detectfile_temp!"
		set bat_returncode=0
		
	)

	
	call :DISPLAYCAMERALIST

	set bat_returncode=0
	
	if not exist "!bat_calfilelist!" (
		call :READFILE "!bat_detectfile_temp!"

		if /i "!bat_detectfile_dir!" neq "" (
			if exist "!bat_junkfile!" (
				!bat_logexeclog! del /q "!bat_junkfile!"
			)
		)
	) else (
		!bat_log!
		!bat_log! Already exists: "!bat_calfilelist!" 
		!bat_log!                 Skipping creation...
		!bat_log!
	)

goto :DONE





	rem Loop to read the detect file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:READFILE
!bat_pushlog! [CALL !bat_batchfile!:READFILE] "!bat_detectfile_temp!" [%*]
	set bat_retval=success

	if not exist "!bat_detectfile_temp!" (
		!bat_echolog! '    ERROR 1 - Detect file "%~1" not found...
	)
	
	if not exist "!bat_detectfile_temp!" (
		!bat_echolog! '    [:READFILE] detect file "!bat_detectfile_temp!" does not exist
		!bat_echolog! '  ERROR 2 - cannot continue without an FTPdetectinfo file.
		!bat_echolog!
		!bat_echolog! '  The files have already been moved... you will need to move 
		!bat_echolog! '  them back and start over after resolving the problems.
		!bat_echolog!
		!bat_echolog! '  [:READFILE] ERROR - "!bat_readfile!" does not exist
		set bat_retval=failed
		goto :READFILE_END
	)
	
	
	set bat_calfilename=
	set bat_calfilename_prev=
	if exist "!bat_calfilelist!" (
		if defined bat_detectfile_dir (
			!bat_logexeclog! del /q "!bat_calfilelist!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:READFILE] Dangerous command: del "!bat_calfilelist!"
		)
	)
	
	set bat_cameralist=
	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	!bat_echolog!
	!bat_echolog! This next step could take a long time if the meteor count is
	!bat_echolog! greater than 1,000.  Over that number, it gets exponentially
	!bat_echolog! longer to process. 



	set bat_temp=

	if /i "!bat_detectfile_dir!" neq "" (
		if exist "!bat_junkfile!" (
			!bat_logexeclog! del /q "!bat_junkfile!"
		)
	)
	
		REM This creates a list of all .txt files, which are CAL files, in the junk file. 
		REM Each CAL file name has a camera number in it. 
		REM There will be duplicate entries that will be removed later. 
	!bat_log! find /i ".txt" "!bat_detectfile_temp!"}"!bat_junkfile!"
	          find /i ".txt" "!bat_detectfile_temp!">"!bat_junkfile!"
	
		REM This loop counts the number of ".bin" entries in the junk file to get a detect count. 
	!bat_log!     for /f "usebackq tokens=1-3 delims=:" ..a in ^(`find /c "CAL" "!bat_junkfile!"`^) do ^(
	              for /f "usebackq tokens=1-3 delims=:" %%a in  (`find /c "CAL" "!bat_junkfile!"`) do (
		set bat_temp=%%c
		set bat_temp=!bat_temp: =!
	)


	!bat_echolog!
	!bat_echolog! There are [!bat_temp!] entries in the detect file, please wait... 
	!bat_echolog!

	set bat_temp=
	
	!bat_pushecho! [!time!] !bat_batchfile!:READFILE

		REM This loop iterates through the junk file to create the bat_calfilelist file
		REM so that it contains only the unique cal file names.  
		REM
	set /a bat_camerainstance=0
		REM                                              "SortDetect_CameraList.txt"
	!bat_pushlog!  for /f "usebackq tokens=*" ..x in ^(`type "!bat_cameralist_file!"`^) do ^(
	for                /f "usebackq tokens=*" %%x in  (`type "!bat_cameralist_file!"`) do (
			set /a bat_linecount=0
			rem !bat_pushlog!  for /f "usebackq tokens=* skip=2" ..a in ^(`find /i "cal_%%x_" "!bat_junkfile!"`^) do ^(
			for                    /f "usebackq tokens=* skip=2" %%a in  (`find /i "cal_%%x_" "!bat_junkfile!"`) do (
				set bat_temp=%%a
				set /a bat_linecount+=1
				set bat_calfilename=%%a
				set bat_camera_temp=!bat_temp:~4,6!
				
				if !bat_linecount! equ 1 (
					set /a bat_camerainstance+=1
					!bat_log! '  !bat_camerainstance!. ADDING: "!bat_calfilename!" TO: "!bat_calfilelist!"

					set bat_cameralist2=!bat_camera_temp!

					if !bat_camerainstance! equ 1 (
						echo !bat_calfilename!>"!bat_calfilelist!"
					) else (
						echo !bat_calfilename!>>"!bat_calfilelist!"
					)
				)
			)
				!echolog! !bat_calfilename!
			rem !bat_poplog! ^)
	)
	!bat_popecho! [!time!]
	!bat_echolog!


	if !bat_linecount! equ 0 (
		!bat_log!
		!bat_log! '  !bat_batchfile!:READFILEERROR - Failed to process the detect file: !bat_detectfile_temp!
		!bat_log! '  Put them back and start over after resolving the problems.
		!bat_log!
		!bat_log! '  ABORTING
		!bat_log!
		!bat_log! '  [This program could do that in a future update]
		!bat_log! '  [:READFILE] ERROR - ABORTING - Failed to process "!bat_detectfile_temp!"
		set bat_retval=failed
	) else (
		set bat_retval=success
	)

:READFILE_END
!bat_poplog! [RETURN !bat_batchfile!:READFILE] [!bat_retval!, output file=="!bat_calfilelist!"]
!bat_log!
!bat_return!










	rem Check "CalFileList.log" to see if %~1 already exists in the list
	rem Returns: bat_calfilelist_found=true if found, otherwise, it is undefined
:CHECK_CALFILELIST [in]  "!bat_calfilename!"
               rem [out] bat_calfilelist_found
rem echo [CALL !bat_batchfile!:CHECK_CALFILELIST] [%*]
	set bat_calfilelist_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_calfilelist!"`) do (
		if /i "%~1"  equ "%%x" (
			set bat_calfilelist_found=true
		)
	)
:CHECK_CALFILELIST_END
rem echo [RETURN !bat_batchfile!:CHECK_CALFILELIST] [%~1, bat_calfilelist_found=!bat_calfilelist_found!]
!bat_return!








	rem Displays the list of cameras.  Depends on GCFC.log file
	rem already being populated with the sorted list of cameras.
:DISPLAYCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:DISPLAYCAMERALIST] %*

		rem Display the list of cameras...
	!bat_log! List of unique cameras in the detect file...
	set bat_camera_list=
	set bat_camera_first=
	set bat_camera_last=
	
	rem                                "...\SortDetect_CameraList.txt"
	for /f "usebackq tokens=*" %%a in ("!bat_cameralist_file!") do (
		!bat_log! %%a
		if /i "%%a" neq "" (
			if not defined bat_camera_list (
				set bat_camera_list=000%%a
				set bat_camera_first=%%a
			) else (
				set bat_camera_list=!bat_camera_list!000%%a
				set bat_camera_last=%%a
			)
		)
	)
	
		REM When number.of.cameras GTR 4, then it's a Sensoray capture card which requires sequential camera numbering
	if !bat_CAPTURE.number.of.cameras GTR 4 (
		set bat_camera_list=000!bat_camera_first!000!bat_camera_last!
	)

:DISPLAYCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAYCAMERALIST] [!bat_camera_list!]
!bat_log!
!bat_return!













:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_CALL! "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<detect file^>" ["^<captured files dir^>" "^<cal file dir^>"] [/force]
	echo.
	echo.Creates the CalFileList.log file, which is a text file containing
	echo.a sorted list of unique cal file names found in the specified 
	echo.detect file.
	echo.
	echo.If running it for Coincidence processing, you might want to run it like
	echo.this:
	echo.    %~nx0 "^<detect file^>" "^<captured files dir^>" "^<cal file dir^>"
	echo.
	echo.Example:
	echo.    %~nx0 "c:\cam213\CAMS\Temp\Coincidence\2014_11_30" "c:\cam213\CAMS\Temp\Coincidence\2014_11_30" "c:\cam213\CAMS\Temp\Coincidence\2014_11_30"
	echo.
	echo.The outcome results in:
	echo.    SortDetect_CameraList.txt file
	echo.    CalFileList.log
	echo.
exit /b -99



:DONE
!bat_poplog! :DONE with %~f0 %*
!bat_log! ENDLOCAL bat_retval=%bat_retval%, bat_camera_list=%bat_camera_list%
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
rem dir "!bat_calfilelist!"
rem type "!bat_calfilelist!"

	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
		SET bat_camera_list=%bat_cameralist2%
	) ELSE ( echo.%bat_retval%)
exit /b 0