@echo off
setlocal enableextensions enabledelayedexpansion

goto :CHECKHELP




	REM #################################################################################
	REM 
:CHECKHELP
	rem CONSTANTS

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	if /i "%~1" equ "" (goto :HELP)
	
goto :SETUP

	



	REM #################################################################################
	REM 
:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
	!bat_logexeclog! set bat_capturedfilesdir=%~1
	
goto :MAIN %*




	REM #################################################################################
	REM 
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %* 


	if not exist "!bat_capturedfilesdir!\GCFC.log" (
		!bat_START! /wait "Please Wait - CreateCameraListFile.bat - [!bat_capturedfilesdir!]" /low cmd /c ""!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!""
	)

	for /f "usebackq tokens=*" %%x in (`type "!bat_capturedfilesdir!\GCFC.log"`) do (
	
		set bat_temp=
		
			REM for each camera, list all the files.  The last one is the one to delete.
		!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_capturedfilesdir!\FF%%x_*.bin" /s/b /a-d /on`^) do ^(
		for               /f "usebackq tokens=*" %%a in  (`dir "!bat_capturedfilesdir!\FF%%x_*.bin" /s/b /a-d /on`) do (
			set bat_temp=%%~a
			set bat_tempdir=%%~dpa
			set bat_tempfile=%%~nxa

			!bat_TITLE! %%~a
		)
		!bat_poplog! ^)
		
		if defined bat_temp (

			!bat_echolog!
			!bat_echolog! Reviewing:  "!bat_temp!"
			!bat_echolog!
			!bat_echolog! start /w "!bat_temp!" "!bat_exedir!\SPFF_SingleFileViewer.exe" "!bat_temp!"
						  start /w "!bat_temp!" "!bat_exedir!\SPFF_SingleFileViewer.exe" "!bat_temp!"
			!bat_logexeclog! set bat_returncode=!errorlevel!
			
			if /i "!bat_returncode!" neq "0" (
				!bat_echolog!
				!bat_echolog! Do you want to Rename: "!bat_temp!"    "!bat_tempdir!zzz-CORRUPT-!bat_tempfile!"
				!bat_echolog!
				if not defined bat_autonomous (
					!bat_prompt! "Do you want to remove? Y/N " 
				)

				if /i "!bat_choice!" equ "y" (
					!bat_echolog!  MOVE /Y "!bat_temp!" "!bat_tempdir!zzz-CORRUPT-!bat_tempfile!"
								   MOVE /Y "!bat_temp!" "!bat_tempdir!zzz-CORRUPT-!bat_tempfile!"
				)

				if /i "!bat_choice!" equ "q" (
					set bat_returncode=1
					goto :MAIN_END
				)
			)
			

		)
	)


:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!







	REM #################################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "bat_capturedfilesdir"
	echo.
	echo Run this program if the capture session may have been interrupted in the middle 
	echo.of capture. This is to avoid the issue where the last FF file is corrupt due
	echo.to the interruption.  There also may be an issue where the detect files are
	echo.also corrupt and they may need to be regenerated using option 44. 
	echo.
	echo Example:
	echo    %~nx0 "C:\CAMS\CapturedFiles\2011_12_25_01_33_46"
	echo.
exit /b 99







	REM #################################################################################
	REM 
:DONE
	!bat_popecho!
	!bat_echolog! [!bat_batchfile!:DONE]Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! [!bat_batchfile!:DONE] exit /b !bat_returncode!

exit /b !bat_returncode!
