 @echo off
setlocal enabledelayedexpansion enableextensions

REM THIS SHOULD NOT BE CALLED USING !BAT_LOGEXEC!

	REM #############################################################################################
	REM 
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	
	REM #############################################################################################
	REM 
:SETUP

	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

		rem Get the SaveConfig.bat bat_captureddate, bat_capturedtime
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
	if /i "%~2" equ "" (
		!bat_echolog! `    !bat_batchfile!:SETUP - ERROR - Missing command line argument:
		!bat_echolog! `        "%~f0" %*
		exit /b 95
	)
	
	!bat_logexeclog! set bat_capturedfilesdir=%~1
	!bat_logexeclog! set bat_archivedfilesdir=%~2
	
	set bat_returncode=0

goto :MAIN %*






	REM #############################################################################################
	REM 
:MAIN [in] "bat_detectfile" "!bat_archivedfilesdir!"
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	if defined bat_archivedfilesdir (
		if exist "!bat_archivedfilesdir!" (
			call :REMOVE_FILE "!bat_archivedfilesdir!\CalFileList.log"
			call :REMOVE_FILE "!bat_archivedfilesdir!\SortDetect_Sorted.txt"
			call :REMOVE_FILE "!bat_archivedfilesdir!\SortDetect_CameraList.txt"
			call :REMOVE_FILE "!bat_archivedfilesdir!\GCFC.log"
			call :REMOVE_FILE "!bat_archivedfilesdir!\GetFirstLastFF_filenames.bat.txt"
			call :REMOVE_FILE "!bat_archivedfilesdir!\AutoCams2.bat.log"
			call :REMOVE_FILE "!bat_archivedfilesdir!\NudgeCalUpdate.log"
			call :REMOVE_FILE "!bat_archivedfilesdir!\FFdirectorylisting_*.txt"
		)
	)

	if defined bat_capturedfilesdir (
		if exist "!bat_capturedfilesdir!" (
			call :REMOVE_FILE "!bat_capturedfilesdir!\GetFirstLastFF_filenames.bat.txt"
			call :REMOVE_FILE "!bat_capturedfilesdir!\GCFC.log"
			call :REMOVE_FILE "!bat_capturedfilesdir!\FFdirectorylisting_All.txtg"
			call :REMOVE_FILE "!bat_capturedfilesdir!\FFdirectorylisting_Viewer.txt"
			call :REMOVE_FILE "!bat_capturedfilesdir!\NudgeCalUpdate.log"
		)
	)


:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!




	REM #############################################################################################
	REM 
:REMOVE_FILE [IN file]
!bat_pushlog! [CALL !bat_batchfile!:REMOVE_FILE] %*

	if exist "%~1" (
		!bat_logexeclog! DEL /q "%~1"
	) ELSE (
		!bat_log! OK - Doesn't exist:  "%~1"
	)

:REMOVE_FILE_END
!bat_popecho! [RETURN !bat_batchfile!:REMOVE_FILE] [errorlevel=!errorlevel!]
!bat_log!
!bat_return!





	REM #############################################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "bat_capturedfilesdir" "bat_archivedfilesdir"
	echo.
	echo Deletes the temporary files left around to improve performance by not having to
	echo.rebuild them each time the information they contains is needed.
	echo.
	echo.Example 1:
	echo.    call "%~0"   "bat_detectfile"     "C:\CAMS\ArchivedFiles\2016_02_09_02_16_00"
	echo.
	echo.Returns:
	echo.    bat_returncode=0,,
	echo.
	echo.
exit /b 99



	REM #############################################################################################
	REM
:DONE
!bat_poplog ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_log!   [!bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]

exit /b !bat_returncode!



