
   @echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	CALL "%~dp0indent_setup.bat"

	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=
	)

    if not defined bat_LOCALIZE.format.date (
    	call "!bat_exedir!\ReadParams.bat"
    )
 
	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!


	
	if /i "%~1" equ "" (
		!bat_logexeclog! set bat_date_os=!date!

	) else (
		!bat_logexeclog! set bat_date_os=%~1
		
			rem If there is a manually entered date, then strip the weekday parsing from the format.date string.
		echo.!bat_LOCALIZE.format.date!|find /i "www ">nul:
		if !errorlevel! equ 0 (
			!bat_logexeclog! set bat_LOCALIZE.format.date=!bat_LOCALIZE.format.date:www =!
		)
		
		
		echo.!bat_LOCALIZE.format.date!|find /i " www">nul:
		if !errorlevel! equ 0 (
			!bat_logexeclog! set bat_LOCALIZE.format.date=!bat_LOCALIZE.format.date: www=!
		)
	)
	
	call :GETDATEINFO !bat_date_os!

goto :DONE



	Rem Parse the date based on the format of the "bat_LOCALIZE.format.date" value from autocams.bat.ini
:GETDATEINFO
!bat_pushlog! [CALL !bat_batchfile!:GETCURDATEINFO] %*

	set bat_curryyyy=
	set bat_currmm=
	set bat_currdd=
	set bat_currdate=



	if not defined bat_LOCALIZE.delimiter.date (
		!bat_echolog!
		!bat_echolog! !bat_batchfile!:GETCURDATEINFO    WARNING - Missing bat_LOCALIZE.delimiter.date from autocams.params.ini.  Using the default date delimeter as "/".
		!bat_echolog!
		set bat_LOCALIZE.delimeter.date=/
	)

	Rem Attempt to use WMIC...
	set bat_date_temp=
%bat_COMMENT_BEGIN%
		REM first attempt to get the date using the wmic way.
	for /f "usebackq skip=1 tokens=*" %%a in  (`call WMIC OS GET LocalDateTime`) do (
		if %%a gtr 0 (
			!bat_logexeclog! set bat_date_temp=%%a
		)
	)
%bat_COMMENT_END%

	if defined bat_date_temp (
		REM WMIC worked
		
		!bat_log! Using WMIC.bat_date_temp=!bat_date_temp!
	
		set bat_curryyyy=!bat_date_temp:~0,4!
		set   bat_currmm=!bat_date_temp:~4,2!
		set   bat_currdd=!bat_date_temp:~6,2!
		
	) else (
		REM WMIC didn't work
		
		if not defined bat_LOCALIZE.format.date (
			!bat_echolog!
			!bat_echolog! !bat_batchfile!:GETCURDATEINFO    WARNING - Missing bat_LOCALIZE.date.format from autocams.params.ini.  Using the default date format of "www yyyy/mm/dd"
			!bat_echolog!
			set bat_LOCALIZE.format.date=www yyyy/mm/dd
		)

		!bat_logexeclog! set bat_date_temp=!bat_date_os!

		for /L %%a in (0,1,14) do (
			if /i "!bat_LOCALIZE.format.date:~%%a,2!" == "dd" (set bat_currdd=!bat_date_temp:~%%a,2!)
			if /i "!bat_LOCALIZE.format.date:~%%a,2!" == "mm" (set bat_currmm=!bat_date_temp:~%%a,2!)
			if /i "!bat_LOCALIZE.format.date:~%%a,4!" == "yyyy" (set bat_curryyyy=!bat_date_temp:~%%a,4!)
			if /i "!bat_LOCALIZE.format.date:~%%a,3!" == "www" (set bat_currww=!bat_date_temp:~%%a,3!)
		)
		
	)
	
	if defined bat_currmm (
		rem set bat_currdate=!bat_currmm!!bat_LOCALIZE.delimiter.date!!bat_currdd!!bat_LOCALIZE.delimiter.date!!bat_curryyyy!
		set bat_currdate=!bat_date_os:~-10!
		
		rem the bat_date_cams return value is in the worldwide ISO 8601 standard format except that it uses
		rem underscores "_" instead of dashes "-".  ISO 8601 would look like this: 2014-12-13, where the cams
		rem format looks like this: 2014_12_13. 
		set bat_date_cams=!bat_curryyyy!_!bat_currmm!_!bat_currdd!
	)
	

:GETDATEINFO_END
rem for October 5, 2013, it should return [2013, 10, 05, 10/05/2013]
!bat_poplog! [RETURN !bat_batchfile!:GETDATEINFO] [bat_curryyyy=%bat_curryyyy%, bat_currmm=!bat_currmm!, bat_currdd=!bat_currdd!, bat_currdate=!bat_currdate!, bat_date_cams=!bat_date_cams!]
!bat_log!
!bat_return!





:HELP
	echo.Usage: call "%~nx0" [local date]
	echo.
	echo.Returns:
	echo.  environment variables: bat_curryyyy, bat_currmm, bat_currdd, bat_currdate, bat_date_cams
	echo.
	echo.The returned date is in the format of the current locale.
	echo.
	echo.Example:
	echo.  Current locale is en-US and the current date is 12/13/2013:
	echo.     %~nx0 
	echo.  Results:
	echo.    bat_curryyyy=2013
	echo.    bat_currmm=12
	echo.    bat_currdd=13
	echo.    bat_currdate=12/13/2013
	echo.    bat_date_cams=2013_12_13
	echo.
	echo.Example:
	echo.  Current locale is nl_BE and the current date is 13/12/2013:
	echo.     %~nx0 
	echo.  Results:
	echo.    bat_curryyyy=2013
	echo.    bat_currmm=12
	echo.    bat_currdd=13
	echo.    bat_currdate=13/12/2013
	echo.    bat_date_cams=2013_12_13
	echo.
	echo.REQUIRED:
	echo.    autocams.params.ini file settings for 
	echo.      [LOCALIZE]
	echo.      date.delimeter=
	echo.      format.date=
	echo.
	echo.       the bat_date_cams return value is in the worldwide ISO 8601 
	echo.       standard format except that it uses underscores "_" instead 
	echo.       of dashes "-".  ISO 8601 would look like this: 2014-12-13, 
	echo.       where the cams format looks like this: 2014_12_13. 
	echo.
	
	
exit /b 99


:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!
	ENDLOCAL & (
		set bat_curryyyy=%bat_curryyyy%
		set bat_currmm=%bat_currmm%
		set bat_currdd=%bat_currdd%
		set bat_currdate=%bat_currdate%
		set bat_date_cams=%bat_date_cams%
	)

exit /b 0
