@echo off
setlocal enableextensions enabledelayedexpansion

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	set bat_batchfile_temp=!bat_batchfile!
	set bat_batchfile=%~nx0

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
	
	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	

	set bat_GCFC_tempfile=%~1\GCFC.log

	rem Gets the camera list from the GCFC.log file in the CapturedFiles dir.
	rem The full path to the GCFC.log file is passed as argv1.
	rem Returns: bat_camera_list
:GETCAMERALIST [in] "!bat_capturedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*

	set bat_camera_list=
	set bat_camera_first=
	set bat_camera_last=

	set bat_camera_temp=


	set /a bat_CAPTURE.number.of.cameras=0
	if exist "!bat_GCFC_tempfile!" (
		for /f "usebackq tokens=*" %%a in ("!bat_GCFC_tempfile!") do (
			!bat_log! %%a

			if /i "%%a" neq "" (
				set /a bat_CAPTURE.number.of.cameras+=1
				if not defined bat_camera_list (
					!bat_logexeclog! set bat_camera_list=%%a
					!bat_logexeclog! set bat_camera_first=%%a
					!bat_logexeclog! set bat_camera_last=%%a
					!bat_logexeclog! set bat_camera_temp=%%a
				) else (
					!bat_logexeclog! set bat_camera_list=!bat_camera_list!%%a
					!bat_logexeclog! set bat_camera_last=%%a
				)
			)
		)
	)
	
	if !bat_CAPTURE.number.of.cameras! GTR 1 (
		!bat_logexeclog! set bat_camera_list=!bat_camera_first!!bat_camera_last!
	) ELSE (
		!bat_logexeclog! set bat_camera_list=!bat_camera_first!
	)

	if defined bat_camera_temp (
		!bat_logexeclog! set bat_camera=!bat_camera_temp!
	)


:GETCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERALIST] 
!bat_log! `                           [bat_camera_list=!bat_camera_list!, 
!bat_log! `                            bat_camera=!bat_camera!, 
!bat_log! `                            bat_camera_first=!bat_camera_first!,
!bat_log! `                            bat_camera_last=!bat_camera_last!,
!bat_log! `                            bat_GCFC_tempfile="!bat_GCFC_tempfile!"]
set bat_batchfile=!bat_batchfile_temp!
set bat_batchfile_temp=
!bat_log!

ENDLOCAL & (
	SET bat_camera_list=%bat_camera_list%
	set bat_camera=%bat_camera%
	set bat_camera_first=%bat_camera_first%
	set bat_camera_last=%bat_camera_last%
)
!bat_return!




:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0 "<dir>"
	echo.
	echo.Gets the camera list from the GCFC.log file in the CapturedFiles dir.
	echo.
	echo.Returns:
	echo.     bat_camera_list        - Contains a list of camera numbers in this format:
	echo.                              000998000999
	echo.     bat_camera
	echo.     bat_camera_first
	echo.     bat_camera_last
	echo.
	echo.The list of cameras actually comes from the GCFC.log file in the CapturedFiles dir.
	echo.
	echo.To build the GCFC.log file, run: CreateCameraListFile.bat or CreateCameraListFileFromDetectFile.bat
	echo.
	
exit /b -99
