 @echo off
setlocal enabledelayedexpansion enableextensions

REM THIS SHOULD NOT BE CALLED USING !BAT_LOGEXEC!

	REM #############################################################################################
	REM 
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	if /i "%~1" equ "" (goto :HELP)

	goto :SETUP %*

:CHECKHELP_END

	
	REM #############################################################################################
	REM 
:SETUP

	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	call "!bat_exedir!\ReadParams.bat"

		rem Get the SaveConfig.bat bat_captureddate, bat_capturedtime
	call "!bat_exedir!\ReadConfig.bat"
	
	!bat_logexeclog! set bat_capturedfilesdir=
	
 	!bat_logexeclog! set bat_startlocation=!bat_camsdir!&					rem C:\CAMS
	!bat_logexeclog! set bat_startdrive=%~d0&				rem C:
	
	
		REM If there aren't at least two command line arguments, then 
	if /i "%~2" equ "" (
		!bat_echolog! `    !bat_batchfile!:SETUP - ERROR - Missing command line argument:
		!bat_echolog! `        "%~f0" %*
		exit /b 95
	)
	
	!bat_logexeclog! set bat_can_rename=true
	
	!bat_logexeclog! set bat_caldir=!bat_camsdir!\Cal

		REM **************************
	!bat_logexeclog! set bat_GDF_retvar=%~1
	
		REM **************************
	                 set bat_archivedfilesdir=%~2::
	                 set bat_archivedfilesdir=!bat_archivedfilesdir:\::=!
	!bat_logexeclog! set bat_archivedfilesdir=!bat_archivedfilesdir:::=!

	if not exist "!bat_archivedfilesdir!" (
		set bat_returncode=3
		!bat_echolog!
		echo.!bat_archivedfilesdir!|find /i "confirmedfiles"
		if !errorlevel! equ 0 (
			!bat_echolog! `   **** OK WARNING [!bat_returncode!] = Specified dir doesn't exist: "!bat_archivedfilesdir!"
		) else (
			!bat_echolog! `   ****    ERROR [!bat_returncode!] = Specified dir doesn't exist: "!bat_archivedfilesdir!"
		)
		!bat_echolog!
		
		goto :DONE
	)
	
		REM **************************
	if /i "%~3" neq "" (
		!bat_log! `    Using command line argument for bat_capturedfilesdir [!bat_capturedfilesdir!] instead of autocams.bat.ini as:
		!bat_logexeclog! set bat_capturedfilesdir=%~3
	) else (
			REM If a CapturedFiles dir exists with the same dirname as the bat_archivedfilesdir, then set bat_capturedfiles to that dir.
		set bat_temp=!bat_archivedfilesdir:\ArchivedFiles=\CapturedFiles!
		!bat_log! if exist "!bat_temp!" ...
		if           exist "!bat_temp!" (
			!bat_logexeclog! set bat_capturedfilesdir=!bat_temp!
		)
	)
	

		REM if the first argument isn't a variable to return the detectfile into, then do this...
	if /i "!bat_GDF_retvar:~0,4!" NEQ "bat_" (
		!bat_echolog! `    !bat_batchfile!:SETUP - ERROR - the first argument isn't a variable to return the detectfile into
		!bat_echolog! `        bat_GDF_retvar=!bat_GDF_retvar!
		exit /b 96
	)

		REM The jist of this section is to be compatible with some older legacy detect file naming convention.
		REM The legacy method was to pass the value of the detect dir as the name of the 
		REM "bat_archivedfilesdir" variable as opposed to passing in the actual value, such
		REM as "!bat_archivedfilesdir!".
		REM
		REM In all cases, forgetting to pass in the return variable name is treated as an error.
		REM 
	if /i "!bat_archivedfilesdir:~0,4!" equ "bat_" (
		!bat_log! converting the old way. [!%~2!]

		!bat_logexeclog! set bat_archivedfilesdir=!%~2!
	)
	
	
	if /i "!bat_capturedfilesdir!" equ "" (
		echo.!bat_archivedfilesdir!|find /i "\ArchivedFiles">nul: 2>&1
		if !errorlevel! equ 0 (
			!bat_log! `    Fabricating the bat_capturedfilesdir from the specified ArchivedFiles dir...
			!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir:\ArchivedFiles=\CapturedFiles!
		)
		
		echo.!bat_archivedfilesdir!|find /i "\ConfirmedFiles">nul: 2>&1
		if !errorlevel! equ 0 (
			!bat_log! `    Fabricating the bat_capturedfilesdir from the specified ConfirmedFiles dir...
			!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir:\ConfirmedFiles=\CapturedFiles!
		)
	)
	
	if not exist "!bat_capturedfilesdir!" (
		!bat_log! `    Fabricating the bat_capturedfilesdir by assuming that the capturedfiles dir is the same as the archivedfiles dir
		!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir!
	)


		REM If CaptureAndDetect is still actively capturing, then we must quit
	call :CHECK_CAPTURE_ACTIVE
	set bat_returncode=!errorlevel!
	if /i "!bat_returncode!" equ "1000" (
		 !bat_log! if /i "!bat_returncode!" equ "1000"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `**** ERROR [!bat_returncode!] - Capture Session is still active: "!bat_capturedfilesdir!"
		!bat_echolog!
		!bat_echolog!
		!bat_WAIT! 10 "!bat_pushstring!**** ERROR [!bat_returncode!] - Capture Session is still active: [!bat_capturedfilesdir!]"
		goto :DONE
	)


	if not exist "!bat_capturedfilesdir!\GCFC.log" (
		!bat_CALL! "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
		
	)
	
	if exist "!bat_capturedfilesdir!" (
		if not defined bat_camera_first (
			!bat_CALL! "!bat_exedir!\GetFirstLastFF_filenames.bat" 	bat_camera_first    bat_camera_last   "!bat_capturedfilesdir!"
		)
	)

	
		REM ***********************************************************************
		REM ********    CALL :QUICK_CHECK                                 *********
		rem ***********************************************************************
		
	call :QUICK_CHECK
	set bat_returncode=!errorlevel!
	if "!bat_returncode!" EQU "0" (goto :GETDETECTFILE_END)
	if "!bat_returncode!" equ "1000" (
		 !bat_log! if /i "!bat_returncode!" equ "1000"
		!bat_echolog!
		!bat_echolog! `   ERROR [!bat_returncode!
		!bat_echolog!
		!bat_echolog!
		goto :GETDETECTFILE_END
	)
	
	

	!bat_logexeclog! set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	!bat_log! if not exist "!bat_GCFC_tempfile!" ...
	if not exist "!bat_GCFC_tempfile!" (
		!bat_log! a GCFC.log [camera list file] file doesn't exist, so building one in "!bat_capturedfilesdir!"...
		!bat_START! /wait "Please Wait - CreateCameraListFile.bat - [!bat_capturedfilesdir!]" /low cmd /c ""!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!""
		
		if /i "!bat_camera_list!" equ "0" (
			!bat_log! 
			!bat_log! `   WARNING: CreateCameraListFile.bat failed.  
		)
	)
	
	
	!bat_log! Reading the GCFC.log file...
	!bat_CALL! "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
	


		rem Fetch: bat_camera, bat_camera_list, bat_camera_first, bat_camera_last
rem	call :DISPLAYCAMERALIST
	
	set bat_returncode=0

goto :GETDETECTFILE %*






	REM #############################################################################################
	REM 
:GETDETECTFILE [in] "bat_detectfile" "!bat_archivedfilesdir!"
!bat_pushlog! [GOTO !bat_batchfile!:GETDETECTFILE] %*


	if "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		!bat_echolog! `    !bat_batchfile!:GETDETECTFILE - ERROR 1 - No dir specified in argument 2
		goto :GETDETECTFILE_END
	)

		rem Results in bat_temp having a dirname, such as: "2012_08_11_03_42_01"
	set bat_temp=


	set %~1=
	set bat_detectfile_found=
	set bat_detectfile1=
	set bat_detectfile2=
	set bat_detectfile3=
	set bat_detectfile4=
	set bat_detect_rename=


		REM Rename all the: "FTPdetectinfo_??????_Subset.txt "
		REM To:             "zzzFTPdetectinfo_??????.txt"
		REM
	CALL :FIX_TEMP_DETECT
	if /i "!bat_returncode!" neq "0" (goto :DONE)



		REM Now look at the remaining detect files...
		REM
	set bat_skip=
	!bat_pushlog! if exist "!bat_archivedfilesdir!\FTPdetectinfo*.txt" ^(
	if               exist "!bat_archivedfilesdir!\FTPdetectinfo*.txt"  (
			!bat_log!
			!bat_log! `Note: The following FOR loop is sorted in ascending date order so that
			!bat_log! `      the last item in the list is the most recently created detect file.
			!bat_log!
			!bat_pushlog! for /f "usebackq tokens=*"   a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo*.txt" /b /od /a-d`^) do ^(
			for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo*.txt" /b /od /a-d`) do (
					!bat_log! ---------%%~a-------------

					!bat_logexeclog! set bat_detectfilename_temp=%%~nxa
					
					if /i "!bat_detectfilename_temp:~14,4!" equ "Case" (
						set bat_skip=true
					)
					
					if /i "!bat_detectilfename_temp:~21,6!" equ "Subset" (
						set bat_skip=true
					)

						rem Skip "ftpdetectinfo_Case###" and "ftpdetectinfo_CaseHeader" 
						rem and "ftpdetectinfo_######_Subset" instances
					if not defined bat_skip (
						!bat_logexeclog! set bat_detectfile_found=%%~a

						!bat_logexeclog! set bat_detectfile3=%%~na
						!bat_logexeclog! set bat_detectfile2=%%~nxa
						!bat_logexeclog! set bat_detectfile1=!bat_archivedfilesdir!\!bat_detectfile2!
						!bat_logexeclog! set bat_detectfile4=!bat_archivedfilesdir!\!bat_detectfile2!
						!bat_logexeclog! set %~1=!bat_detectfile4!


					)
			)
			!bat_poplog! ^)

	)
	!bat_poplog! ^)

	if not defined bat_detectfile_found (
		set bat_returncode=4
		!bat_echolog! `   !bat_batchfile!:GETDETECTFILE - WARNING 4 - Can't find detect file in [bat_archivedfilesdir="!bat_archivedfilesdir!"]
		!bat_echolog! `    NO DETECT FILES FOUND IN: "!bat_archivedfilesdir!"
		!bat_echolog!

		!bat_echolog!
		!bat_echolog! Now making sure that the directory name value has "ArchivedFiles" or "ConfirmedFiles" in it somewhere...
		!bat_echolog! Question though: What is supposed to happen when it's a detect file in the coincidence dir?
		!bat_echolog!

		!bat_echolog! "!bat_archivedfilesdir!" ^| FINDSTR /L /i /c:"ArchivedFiles" /c:"ConfirmedFiles"}nul: 2}^@1
				 echo."!bat_archivedfilesdir!"  | FINDSTR /L /i /c:"ArchivedFiles" /c:"ConfirmedFiles">nul: 2>&1
		if /i "!errorlevel!" equ "0" (
			!bat_echolog!
			!bat_echolog! `    !bat_batchfile!:GETDETECTFILE ERROR
			!bat_echolog!
			!bat_echolog! `    If this is for ConfirmedFiles and you haven't yet run confirmation, then you can
			!bat_echolog! `    ignore this warning.
			!bat_echolog!
			!bat_echolog! `    There may be a possibility that the CaptureAndDetect didn't finish all the way.
			!bat_echolog! `    Another possibility is that the file is misnamed somehow.  Check the 
			!bat_echolog! `    "!bat_archivedfilesdir!" directory.  If the directory isn't found or there are
			!bat_echolog! `    no FF*.bin files, or there isn't a FTPdetectinfo*.txt file there, you may
			!bat_echolog! `    need to run option 44 to rebuild the detect from the capture session again.
			!bat_echolog! `    
		)


		goto :GETDETECTFILE_END
	)



		rem Going into this section, the bat_detectfile1 variable should be read-only as the source
		rem detect file in case it needs to be renamed.
	if defined bat_detectfile_found (
		!bat_pushlog!
			!bat_log! ---------------------------------------------------------
			!bat_log! This section is about determining whether to rename the detect file
			!bat_log!
			!bat_log! Note: The following loop parses the detect file name to see what the
			!bat_log! `       format of the file name is.  If it matches an old naming convention, it will be
			!bat_log! `       converted/renamed to the new convention. This is accomplished by parsing the file
			!bat_log! `       by the "_" and "." delimiters.  
			!bat_log! `       1. If the "txt" is the 2nd token [b], then it's in "FTPdetectinfo.txt" format and its 
			!bat_log! `          missing the camera, date, and time.  
			!bat_log! `       2. If "txt" is the 6th token [f], then it's in the "FTPdetectinfo_CCCC_YYYY_MM_DD.txt" 
			!bat_log! `          or the "FTPdetectinfo_0CCC0CCC_YYYY_MM_DD.txt" format and it's missing the 
			!bat_log! `          time.  
			!bat_log! `       3. Otherwise, no conversion is necessary. 
			!bat_log! `
			!bat_log! `       4. Cams2 has a different naming convention which seems to be something like:
			!bat_log! `          "FTPdetectinfo_000CCC000CCC_YYYY_MM_DD_hh_mm_ss.txt". 
			!bat_log! `          But the ".txt" section will 9th token [i]. 
			!bat_log!
			!bat_log! `     One issue we may find with this is if the file name cointains "Coinc".  In that
			!bat_log! `     we need to not do a conversion. However, in that case, "txt" will be the
			!bat_log! `     3rd token.
			!bat_log!
			!bat_log! `     We also need to accommodate when the detect file in  the submission dirs has a suffix
			!bat_log! `     like "_scanned" or "_confirmed".  If  that is the case, it won't be renamed. 

			echo.!bat_detectfile4!|findstr /L /i /c:"\EmailFiles" /c:"_scanned" /c:"_confirmed"
			if !errorlevel! equ 0 (
				REM Don't rename if  "_scanned" or "_confirmed"
				
				!bat_logexeclog! set bat_can_rename=
				!bat_log! !bat_detectfile4!][findstr /L /i /c:"\EmailFiles" /c:"_scanned" /c:"_confirmed"
				goto :CONTINUE
			)


			call :GET_CAPTUREDFILESDIR "!bat_archivedfilesdir!"

			set bat_done=

				rem Parse the detect file name without the path in to 12 separate parts so
				rem that we can check or where the "txt" element is placed

			!bat_pushlog! for /f "usebackq tokens=1-12 delims=_." ..a in ^('!bat_detectfile2!'^) do ^(
			for               /f "usebackq tokens=1-12 delims=_." %%a in  ('!bat_detectfile2!') do (
				
				!bat_log! "!bat_detectfile2!" parsed as:
				!bat_log! a=%%a, b=%%b, c=%%c, d=%%d, e=%%e, f=%%f, g=%%g, h=%%h, i=%%i, j=%%j, k=%%k, l=%%l

					REM In order to save time, if bat_done is defined, then there is nothing more to determine within this loop.
				if not defined bat_done (
				
						REM FTPdetectinfo_00001.txt
						REM There is also this from Pete G:
						REM   Temp and combined files during CaptureDongles, Capture8 and DetectMultipleFF
						REM   (NOTE for CaptureDongles and DetectMultipleFF the board # is always zero):
						REM      FTP_Detectinfo_######_Subset.txt    
						REM      where:   
						REM              ###### = 800001 + 100 * board# + daughter_process#
						REM
						REM      These are merged at the end of processing into:   
						REM              FTP_Detectinfo_CCCCCCcccccc_YYYY_MM_DD_HH_MM_SS.txt
						REM      where:  
						REM              CCCCCC = lowest unique camera number in the list of FF files  
						REM              cccccc = highest unique camera number in the list of FF files 
						REM              (or first and last of the 8 for Capture8)

					if /i "%%b" equ "00" (
						REM It's probably one of the many types of temp files used for detection subprocesses
						REM such as "
						!bat_logexeclog! set bat_detect_rename=true
						
						REM  Notice that bat_done is not set
					)
					
						REM FTPdetectinfo.txt
						REM Ideally, we can determine the capture session date/time from the detect file.
						REM However, in this case we can't, so we have to get it from the dirname
					if /i "%%b" equ "txt" (
						!bat_log!  "%%~b" equ "txt"
						set bat_done=true

						set bat_detect_rename=true
						set bat_can_rename=true

						call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
						call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
					)
					

					
						REM FTPdetectinfo_0001.txt, FTPdetectinfo_Coinc.txt
					if /i "%%c" equ "txt" (
						!bat_log!  "%%~c" equ "txt"
						set bat_done=true

						set bat_temp=%%b
						
						if "!bat_temp:~0,2!" equ "00" (
							!bat_log! Not renaming "%%a_%%b.%%c"
							!bat_logexeclog! set bat_detect_rename=false
							!bat_logexeclog! set bat_can_rename=
						)
						
						if /i "%%~b" NEQ "Coinc" (
							set bat_detect_rename=true
							set bat_can_rename=true

							call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
							call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
						) else (
							set bat_detect_rename=
							set bat_can_rename=
						)
					)
					
						REM FTPdetectinfo_0


					
						REM FTPdetectinfo_0000_YYYY_MM_DD.txt, FTPdetectinfo_0ccc_YYYY_MM_DD.txt, FTPdetectinfo_0ccc0xxx_YYYY_MM_DD.txt, 
					if /i "%%~f" equ "txt" (
						!bat_log!  "%%~f" equ "txt"
						set bat_done=true
						set bat_detect_rename=true
						set bat_can_rename=true
						
						set bat_temp=%%~b
						
						if /i "%%~b" equ "0000" (
							call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
							call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
						) else (
							call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
							call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
						)
						
					)
					


					rem FTPdetectinfo_0ccc_YYYY_MM_DD_hh_mm_ss.txt, with 0000, 000000, 0ccc0CCC, 0ccc0CCC0xxx0XXX
					rem FTPdetectinfo_000ccc000CCC_YYYY_MM_DD_hh_mm_ss.txt
					rem FTPdetectinfo_000000_YYYY_MM_DD_hh_mm_ss.txt
					if /i "%%~i" equ "txt" (
						
						!bat_log!  "%%~i" equ "txt"
						
						set bat_done=true
						!bat_logexeclog! set bat_detect_rename=true
						!bat_logexeclog! set bat_can_rename=true
						
						set bat_temp=%%~b&			REM camera section from file name

						call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
						call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
					)
					

					rem FTPdetectinfo_0ccc_YYYY_MM_DD_hh_mm_ss_scanned.txt, FTPdetectinfo_0ccc_YYYY_MM_DD_hh_mm_ss_confirmed.txt. with 0000, 0ccc0CCC, 0ccc0CCC0xxx0XXX
					rem Essentially, only those with "_scanned" or "_confirmed" suffixes will have "txt" in %%j
					if /i "%%~j" equ "txt" (
						!bat_log!  "%%~J" equ "txt"
						set bat_done=true
						!bat_logexeclog! set bat_detect_rename=
						!bat_logexeclog! set bat_can_rename=
						
						set bat_temp=%%~b&			REM should be the camera
						

							REM if %%i is either "scanned" or "confirmed" then don't change the name. 
						(echo.%%~i|find /i "scanned") || (echo.%%~i|find /i "confirmed") && (
								REM If you get here, then the detect file came from the EmailFiles dir and it shouldn't be renamed. 
							if /i "%%~b" equ "000000" (
								!bat_logexeclog! set bat_detect_rename=true
								!bat_logexeclog! set bat_can_rename=true
								call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
								call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
							) else (
								call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
								call :GET_CAMERA_FROM_FILENAME "!bat_temp!"
							)
						) || (
								!bat_logexeclog! set bat_detect_rename=true
								!bat_logexeclog! set bat_can_rename=true
								call :GET_DATETIME_FROM_DIRNAME "!bat_archivedfilesdir!"
								call :GET_CAMERA_FROM_GCFC "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
						)
					)
				)
			)
		!bat_poplog! ^)

 :CONTINUE
    !bat_log! [!bat_batchfile!:CONTINUE] bat_detect_rename="!bat_detect_rename!", bat_can_rename="!bat_can_rename!"


				if defined bat_detect_rename (
				
						REM IF DEFINED bat_captureddatetime AND IF DEFINED bat_camera_first THEN...
						REM
					!bat_log! bat_captureddatetime=!bat_captureddatetime!
					!bat_log! bat_camera=!bat_camera!
					!bat_log! if defined bat_captureddatetime [!bat_captureddatetime!] AND if defined bat_camera [!bat_camera!]
					(set bat_captureddatetime>nul: 2>&1) && (set bat_camera>nul: 2>&1) && (
						!bat_logexeclog! set bat_detectfile3=FTPdetectinfo_!bat_camera!_!bat_captureddatetime!
					)
				
					!bat_logexeclog! set bat_detectfile2=!bat_detectfile3!.txt
					!bat_logexeclog! set bat_detectfile4=!bat_archivedfilesdir!\!bat_detectfile2!
					!bat_logexeclog! set %~1=!bat_detectfile4!


					rem bat_detectfile1 is the source detect file so don't assign it a new value
					
					if not defined bat_camera_first (
						set bat_camera_first=!bat_camera!
					)


					call :RENAME_DETECT

				) else (
					!bat_log! `  It's in this format: "FTPdetectinfo_CCCCCC_YYYY_MM_DD_hh_mm_ss.txt" instead of "FTPdetectinfo_0CCC0CCC_YYYY_MM_DD_hh_mm_ss.txt
					!bat_log! `    No conversion necessary.
					!bat_log!
				)
	) else (
		set bat_returncode=5
		goto :GETDETECTFILE_END
	)


:GETDETECTFILE_END
	call :RENAME_CAMERATIMEOFFSETS "!bat_capturedfilesdir!" "!bat_archivedfilesdir!"
	
	!bat_popecho! Returning value in the [%~1] variable using ENDLOCAL: "!bat_detectfile4!"

	!bat_log! `[ENDLOCAL-!bat_batchfile!:GETDETECTFILE] [
	!bat_log! `                   bat_GDF_retvar=!bat_GDF_retvar!=!%bat_GDF_retvar%!,
	!bat_log! `                   bat_GDF_retvar=!bat_GDF_retvar!=!bat_junk!,
	!bat_log! `                   bat_returncode=!bat_returncode!,
	!bat_log! `                   bat_camera_list=!bat_camera_list!, 
	!bat_log! `                   bat_camera=!bat_camera!, 
	!bat_log! `                   bat_camera_first=!bat_camera_first!,
	!bat_log! `                   bat_camera_last=!bat_camera_last!,
	!bat_log! `                   %bat_GDF_retvar%Dir=!bat_archivedfilesdir!
	!bat_log! `                   %bat_GDF_retvar%File=%bat_detectfile2%
	!bat_log! `                   %bat_GDF_retvar%Full=%bat_detectfile4%
	!bat_log! `                   %bat_GDF_retvar%Name=%bat_detectfile3%
	!bat_log! `                   bat_GCFC_tempfile=%bat_GCFC_tempfile%]
	!bat_log!
	!bat_poplog! !bat_batchfile!:GETDETECTFILE - EXIT /B !bat_returncode!
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

	ENDLOCAL & IF "%~1" NEQ "" (
		SET %bat_GDF_retvar%=%bat_detectfile4%
		set bat_returncode=%bat_returncode%
		set bat_camera_list=%bat_camera_list%
		set bat_camera=%bat_camera%
		set bat_camera_first=%bat_camera_first%
		set bat_camera_last=%bat_camera_last%
		set %bat_GDF_retvar%Dir=!bat_archivedfilesdir!
		set %bat_GDF_retvar%File=%bat_detectfile2%
		set %bat_GDF_retvar%Full=%bat_detectfile4%
		set %bat_GDF_retvar%Name=%bat_detectfile3%
		set bat_GCFC_tempfile=%bat_GCFC_tempfile%
		
		

	) ELSE (
		echo.%bat_detectfile4%
	)
	
EXIT /B !bat_returncode!




	REM #############################################################################################
	REM If it is determined that and existing detect file is not named according to the current
	REM naming convention, then this routine will rename it to match. 
	REM 
:RENAME_DETECT
!bat_pushlog! [CALL !bat_batchfile!:RENAME_DETECT] [bat_can_rename=!bat_can_rename!, 
!bat_log! `                                         bat_detect_rename=!bat_detect_rename!, 
!bat_log! `                                         bat_detectfile4=!bat_detectfile4!, 
!bat_log! `                                         bat_detectfile_found=!bat_detectfile_found!]

!bat_logexeclog! set bat_detect

	if /i "!bat_detectfile_found:~14,4!" equ "Case" (
		set bat_can_rename=
	)

	call :RENAME_CAMERATIMEOFFSETS "!bat_capturedfilesdir!"  "!bat_archivedfilesdir!"
	

	!bat_echolog! ` [!bat_batchfile!:GETDETECTFILE] - Trying to rename: "!bat_detectfile_found!

	!bat_log! bat_captureddatetime=!bat_captureddatetime!
	!bat_log! bat_captureddate=!bat_captureddate!
	!bat_log! bat_capturedtime=!bat_capturedtime!
	!bat_log! bat_camera=!bat_camera!
	!bat_log! bat_camera_list=!bat_camera_list!
	!bat_log! bat_camera_first=!bat_camera_first!

	if not defined bat_captureddate  (!bat_logexeclog! set bat_can_rename=)
	if not defined bat_capturedtime  (!bat_logexeclog! set bat_can_rename=)
	if not defined bat_camera  (!bat_logexeclog! set bat_can_rename=)
	
	
		REM Construct a new name based on FTPdetectinfo_0ccc_YYYY_MM_DD_hh_mm_ss.txt
		REM
		REM The AutoCams naming convention is "FTPdetectinfo_CCCCCC_YYYY_MM_DD_hh_mm_ss[_optional].txt"
		REM where: CCCCCC     means the six digit number of the first camera for the site
		REM        optional   means suffix text, such as "_scanned" or "_confirmed". 
		REM
	if defined bat_camera (
		
			REM If there are more than one camera in the bat_camera var, then normalize it to bat_camera_first. 
		if /i "!bat_camera:~6,1!" neq "" (
			if defined bat_camera_first (
				set bat_camera=bat_camera_first
			) else (
				set bat_camera=!bat_camera:~0,6!
			)
		)

				REM Rename: "C:\CAMS\ArchivedFiles\2016_02_10_02_16_13\FTPdetectinfo_0250265_2016_02_10_02_16_13_blahhhhh.txt" 
				REM Cams2:  "C:\CAMS\ArchivedFiles\2016_02_10_02_16_13\FTPdetectinfo_00025000265_2016_02_10_02_16_13_blahhhhh.txt" 
				REM to:     "C:\CAMS\ArchivedFiles\2016_02_10_02_16_13\FTPdetectinfo_000266_2016_02_10_02_16_13.txt" 
				REM 
			!bat_logexeclog! set bat_detectfile3=FTPdetectinfo_!bat_camera!_!bat_captureddatetime!
			!bat_logexeclog! set bat_detectfile2=!bat_detectfile3!.txt
			!bat_logexeclog! set bat_detectfile4=!bat_archivedfilesdir!\!bat_detectfile2!
			!bat_logexeclog! set bat_detectfile=!bat_detectfile4!
	)

	
	if defined bat_detect_rename (
		if defined bat_can_rename (
				!bat_ECHOlog! `RENAMING to: "!bat_detectfile2!"
				!bat_echolog!
				!bat_logexeclog! MOVE /y "!bat_archivedfilesdir!\!bat_detectfile_found!" "!bat_detectfile4!"
				!bat_echolog!
			)

		) else (
			!bat_echolog! `    [!bat_batchfile!:RENAME_DETECT] - can't rename because file name is too complex:
			!bat_echolog! `                        !bat_GDF_retvar!=!bat_detectfile4!
		)
	)

!bat_logexeclog! set bat_detect

:RENAME_DETECT_END
!bat_poplog! [RETURN !bat_batchfile!:RENAME_DETECT] [bat_can_rename=!bat_can_rename!, bat_detct_rename=!bat_detect_rename!]
!bat_log!
!bat_return!




	REM #############################################################################################
	REM 
:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_return!





	REM #############################################################################################
	rem Parses the specified path [like "bat_archivedfilesdir"] and extracts
	rem just the directory name of the last directory in the path.  For example:
	rem   C:\CAMS\ArchivedFiles\2012_08_11_03_42_01
	rem results in:
	rem   2012_08_11_03_42_01
	rem 
	rem Note: The value must be assigned by the calling batch file.
	REM
:PARSETEMP
!bat_pushlog! [CALL !bat_batchfile!:PARSETEMP] %*
	set bat_temp=%~nx1
!bat_poplog! [RETURN !bat_batchfile!:PARSETEMP] [!bat_temp!]
!bat_log!
!bat_return!






	REM #############################################################################################
	rem ***********************************************************************
	rem *******                  :DISPLAYCAMERALIST                    ********
	rem********                                                        ********
	rem Displays the list of cameras.  Depends on GCFC.log file
	rem already being populated with the sorted list of cameras.
	rem
	rem also remember that sometimes bat_capturedfilesdir might be
	rem pointing to a coincidence or an emailfiles dir.
	rem 
	rem Results:
	rem 
	rem    bat_camera_list 
	rem    bat_camera 
	rem    bat_camera_first
	rem    bat_camera_last
	rem 
:DISPLAYCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:DISPLAYCAMERALIST] %*

		rem Display the list of cameras...
	!bat_log! Get list of cameras found in the camera list file: "!bat_capturedfilesdir!"

	!bat_CALL! "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
	

:DISPLAYCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAYCAMERALIST] [
!bat_log! `                            bat_camera_list=!bat_camera_list!, 
!bat_log! `                            bat_camera=!bat_camera!, 
!bat_log! `                            bat_camera_first=!bat_camera_first!,
!bat_log! `                            bat_camera_last=!bat_camera_last!,
!bat_log! `                            bat_GCFC_tempfile=!bat_GCFC_tempfile!]
!bat_log!
!bat_return!





	REM #############################################################################################
	REM Fixup the temporary detect files [FTPdetectinfo_0001.txt] that are produced by either capture programs or the
	REM MakeCaseListing.bat script [which will soon be based on FTP_DetectMultipleFF.exe]. 
	REM 
	REM The problem to solve is this... The programs produce one FTPdetectinfo_00000?_Subset.txt file
	REM for each CPU configured to do parallel detections.  Example: FTPdetectinfo_800001_Subset.txt.   
	REM 
	REM What needs to happen is this:
	REM    - If a normal FTPdetectinfo_*_????_??_??_??_??_??*.txt DOES NOT exist, and if these temp files exist, 
	REM      we need to call FTP_CombineDetectinfo.exe to combine/merge them into a single
	REM      detect file with the proper naming convention. 
	REM
	REM      - Problem with the FTP_CombineDetectinfo.exe is that it produces a camera segment
	REM        as "000000"
	REM
	REM    - If a normal FTPdetectinfo_*_????_??_??_??_??_??*.txt DOES exist, and if these temp files exist,
	REM      we need to rename the temp files with a "zzz" prefix to avoid them being combined again.
	REM
	REM    - Then, the combined detect file needs to be renamed with the first camera number
	REM      from the GCFC.log file. 
	REM
	REM    - Of course, we'll need to run FixDetectPaths.bat on the detect file.
	REM
:FIX_TEMP_DETECT
!bat_pushlog! [CALL !bat_batchfile!:FIX_TEMP_DETECT] %*

	set bat_temp=No need to merge
	
	if EXIST "!bat_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt" (
	
			REM Combine temp detect files into a single "FTPdetectinfo_000000_YYYY_MM_DD_hh_mm_ss.txt"
			REM When FTP_CombineDetectInfo.exe is done, "MergeListing_FTPdetectinfo.txt" will contain the resulting merged file name and then all the subset file names. 
			REM You can read the Merge... file like this:
			REM    FINDSTR /i /r /c:"FTPdetectinfo_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*.*" "!bat_archivedfilesdir!\MergeListing_FTPdetectinfo.txt"
rem		!bat_CALLecho! "!bat_exedir!\FTP_CombineDetectInfo.exe" "!bat_archivedfilesdir!"
rem		set bat_returncode=!errorlevel!

			REM Now that the temp subset files have been combined into a "FTPdetectinfo_000000_YYYY_MM_DD_hh_mm_ss.txt"
			REM file, they should not be needed to combine again, so let's renaming them out of the way...
		!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt" /b /a-d /on`^) do ...
		for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt" /b /a-d /on`) do (
			!bat_logexeclog! MOVE /y "!bat_archivedfilesdir!\%%a"   "!bat_archivedfilesdir!\zzz%%a"
		)
		!bat_poplog!
		
	)

	if exist "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" (

			!bat_log! Prevent files that don't match the pattern: FTPdetectinfo_[any number of numbers]_YYYY_MM_DD_hh_mm_ss*.txt
			!bat_log! uses: FINDSTR /i /r /c:"FTPdetectinfo_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*.*\.txt", which
			!bat_log!       which uses regexp and translates to:
			!bat_log!         FTPdetectinfo_[any number of numbers]_YYYY_MM_DD_hh_mm_ss*.txt
			!bat_log!       If the file doesn't match that naming convention, then it is renamed
			!bat_log!       with prefix "zzz". What remains is only those detectfiles that match the current
			!bat_log!       naming convention... could be more than one. 
			!bat_log!

		!bat_echolog! for /f "usebackq tokens=*" ..A in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" /b /o-d /a-d`^) do ^(
		for               /f "usebackq tokens=*" %%A in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" /b /o-d /a-d`) do (
			!bat_echolog! ------------- %%A ---------------------

			echo.%%A|findstr /i /r /c:"FTPdetectinfo_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*_[0-9]*.*\.txt">nul: 2>&1
			if !errorlevel! NEQ 0 (
				!bat_log! Renaming ...
				!bat_logexec! MOVE /y "!bat_archivedfilesdir!\%%A"    "!bat_archivedfilesdir!\zzz%%A"
			) else (
				!bat_log! Not Renaming "%%A" with "zzz" prefix...
			)
		)
	)
	
		REM There is a problem that comes up when a capture session is interrupted by
		REM power outage or something like that.  The Detect files are full of nulls.
		REM So, the workaround is to delete the detect file if you can't find the following 
		REM text in one:
		REM    "Meteor Count = "

	if exist "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" (
		if exist "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??*.txt" (
		
			set bat_corrupt_temp_files=false
			
				REM First handle the workaround mentioned above...
			for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??*.txt" /s/b /a-d /on`) do (
			
					REM If errorlevel EQU 0 then the detect file is not corrupt...
				findstr /i /r /c:"Meteor Count = "   "%%a">nul: 2>&1
				if "!errorlevel!" NEQ "0" (

					!bat_logexec! set bat_corrupt_temp_files=true
					!bat_logexeclog! set bat_returncode=20
					
					REM If text isn't found, then delete the file.
					
					!bat_echolog! 
					!bat_echolog! ERROR [!bat_returncode!] - corrupt temp detect file: "%%a"
					!bat_echolog!
					!bat_echolog! `       You may need to run option 44 to rebuild the detect files
					!bat_echolog!
					!bat_wait! 20
					!bat_logexec! MOVE /y "%%a"   "!bat_archivedfilesdir!\zzz-CORRUPT-%%~nxa"
				)
			)

%bat_COMMENT_BEGIN%
echo.################### YOU SHOULD NEVER SEE THIS #########################
				REM If the detect file is corrupt, then rename the zzz files to normal, combine, and rename them back.
			if defined bat_corrupt_temp_files (
					REM Now that the temp subset files have been combined into a "FTPdetectinfo_000000_YYYY_MM_DD_hh_mm_ss.txt"
					REM file, they should not be needed to combine again, so let's renaming them out of the way...
				!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!\zzzFTPdetectinfo_??????_Subset.txt" /b /a-d /on`^) do ...
				for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\zzzFTPdetectinfo_??????_Subset.txt" /b /a-d /on`) do (
					set bat_temp=%%a
					set bat_temp=!bat_temp:zzz=!
					!bat_logexeclog! MOVE /y "!bat_archivedfilesdir!\%%a"   "!bat_archivedfilesdir!\!bat_temp!"
				)
				!bat_poplog!

				!bat_log! if /i "!bat_corrupt_temp_files!" NEQ "true" 
				if           /i "!bat_corrupt_temp_files!" NEQ "true" (
						REM When FTP_CombineDetectInfo.exe is done, "MergeListing_FTPdetectinfo.txt" will contain the resulting merged file name and then all the subset file names. 
					!bat_logexeclog! CALL "!bat_exedir!\FTP_CombineDetectInfo.exe" "!bat_archivedfilesdir!"
					set bat_returncode=!errorlevel!
				)

					REM Now that the temp subset files have been combined into a "FTPdetectinfo_000000_YYYY_MM_DD_hh_mm_ss.txt"
					REM file, they should not be needed to combine again, so let's renaming them out of the way...
				!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt" /b /a-d /on`^) do ...
				for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt" /b /a-d /on`) do (
					!bat_logexeclog! MOVE /y "!bat_archivedfilesdir!\%%a"   "!bat_archivedfilesdir!\zzz%%a"
				)
				!bat_poplog!
			)
%bat_COMMENT_END%
		)
		
		REM set bat_temp variable to the most recently touched detect file.
		for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" /b /a-d /od`) do (
			set bat_temp=%%a
		)
		
		!bat_log!
		!bat_log! ***** Detect file:"!bat_archivedfilesdir!\!bat_temp!"
		!bat_log!
		
		
	)


:FIX_TEMP_DETECT_END
!bat_poplog! [RETURN !bat_batchfile!:FIX_TEMP_DETECT] [Merged detect file:!bat_temp!]
!bat_log!
set bat_temp=
!bat_return!







	REM #############################################################################################
	REM    Returns:
	REM       bat_captureddatetime			- YYYY_MM_DD_hh_mm_ss
	REM       bat_captureddate			- YYYY_MM_DD
	REM       bat_capturedtime			- hh_mm_ss
	REM 
:GET_DATETIME_FROM_DIRNAME [IN "bat_archivedfilesdir" ] 
!bat_pushlog! [CALL !bat_batchfile!:GET_DATETIME_FROM_DIRNAME]

	for %%f in (!bat_archivedfilesdir!) do (
		set bat_captureddatetime=%%~nxf
	)
	
	!bat_log! bat_captureddatetime=!bat_captureddatetime!

	!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
	!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!

:GET_DATETIME_FROM_DIRNAME_END
!bat_poplog! [RETURN !bat_batchfile!:GET_DATETIME_FROM_DIRNAME] [bat_captureddatetime=!bat_captureddatetime!, !bat_captureddate!, !bat_capturedtime!]
!bat_log!
!bat_return!






	REM #############################################################################################
	REM 
:GET_DATETIME_FROM_FILENAME [IN c d e f g h ]
!bat_pushlog! [CALL !bat_batchfile!:GET_DATETIME_FROM_FILENAME]  [IN 1=YYYY 2=MM 3=DD 4=hh 5=mm 6=ss]

	!bat_logexeclog! set bat_captureddatetime=%~1_%~2_%~3_%~4_%~5_%~6
	!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
	!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!

:GET_DATETIME_FROM_FILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GET_DATETIME_FROM_FILENAME] [bat_captureddatetime=!bat_captureddatetime!, !bat_captureddate!, !bat_capturedtime!]
!bat_log!
!bat_return!







	REM #############################################################################################
	REM 
:GET_CAMERA_FROM_GCFC [IN "bat_capturedfilesdir" ]
!bat_pushlog! [CALL !bat_batchfile!:GET_CAMERA_FROM_GCFC] %*


	if exist "!bat_capturedfilesdir!" (
		if exist "!bat_capturedfilesdir!\GCFC.log!" (
		
				REM Returns bat_camera, bat_camera_first, bat_camera_list in its ENDLOCAL
				REM Where bat_camera is the first camera.  

			!bat_CALL! "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
			
		) else (
			if exist "!bat_capturedfilesdir!\FF*.bin" (

					REM Create the GCFC.log file as bat_GCFC_tempfile unless it already exists
					REM This GCFC.log file is a simple text file in the bat_capturedfilesdir that
					REM contains a list of cameras found in the CapturedFiles dir
					REM
				!bat_START! /wait "Please Wait - CreateCameraListFile.bat - [!bat_capturedfilesdir!]" /low cmd /c ""!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!""
			) else (

					REM if we get here, then we have a situation where the FF files have been purged from the CapturedFiles dir
					REM So, the next option is to get the camera from the detect file
				if exist "!bat_archivedfilesdir!\GCFC.log" (
				
					!bat_CALL! "!bat_exedir!\GetCameraList.bat" "!bat_archivedfilesdir!"
					
				) else (

						REM If you get here, then there is no GCFC.log file, so we try to read the SortDetect_CameraList.txt
						REM file.  This is a file that is similar to a GCFC.log file, but it's a list of camera numbers
						REM as found in the detect file. So, it might be missing some of the camera numbers, but that's ok.
					if exist "!bat_archivedfilesdir!\SortDetect_CameraList.txt" (

						call :READ_SORTDETECT_CAMERALIST

					) ELSE (

							REM If we get here, we have to build the camera list from the detect file
						!bat_CALL! "!bat_exedir!\CreateCameraListFileFromDetectFile.bat" "!bat_detectfile1!"
						
						call :READ_SORTDETECT_CAMERALIST
					)
				)
			)
		)

	)

:GET_CAMERA_FROM_GCFC_END
!bat_poplog! [RETURN !bat_batchfile!:GET_CAMERA_FROM_GCFC] [bat_returncode=!bat_returncode!, bat_camera=!bat_camera!]
!bat_log!
!bat_return!




	REM #############################################################################################
	REM 
:READ_SORTDETECT_CAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:READ_SORTDETECT_CAMERALIST] %*

	set bat_camera_list=

	for /f "usebackq tokens=*" %%A in (`type "!bat_archivedfilesdir!\SortDetect_CameraList.txt"`) do (
		!bat_log! ................!bat_camera_list!......%%A
		set bat_camera=%%A
		set bat_camera_last=%%A
		set bat_camera_list=!bat_camera_list!!bat_camera!
	)

	for /f "usebackq tokens=*" %%A in (`type "!bat_archivedfilesdir!\SortDetect_CameraList.txt"^|sort /R`) do (
		set bat_camera=%%A
		set bat_camera_first=%%A
	)

:READ_SORTDETECT_CAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:READ_SORTDETECT_CAMERALIST] [bat_camera=!bat_camera!, bat_camera_list=!bat_camera_list!]
!bat_log!
!bat_return!





	REM #############################################################################################
	REM 
:GET_CAMERA_FROM_FILENAME [ IN "camera" ]
!bat_pushlog! [CALL !bat_batchfile!:GET_CAMERA_FROM_FILENAME] %*

	set bat_camera=%~1

:GET_CAMERA_FROM_FILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GET_CAMERA_FROM_FILENAME] [bat_camera=!bat_camera!]
!bat_log!
!bat_return!







	REM #############################################################################################
	REM Set the bat_capturedfilesdir variable by using the same value of the ArchivedFiles dir
	REM name for this capture session by substituting/replacing "\ArchivedFiles\" with "\CapturedFiles\".
	REM 
:GET_CAPTUREDFILESDIR [IN "bat_archivedfilesdir"]
!bat_pushlog! [CALL !bat_batchfile!:GET_CAPTUREDFILESDIR] %*

	!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir:\ArchivedFiles\=\CapturedFiles\!
	
	if not exist "!bat_capturedfilesdir!" (
		!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir!
	)


:GET_CAPTUREDFILESDIR_END
!bat_poplog! [RETURN !bat_batchfile!:GET_CAPTUREDFILESDIR] [bat_capturedfilesdir=!bat_capturedfilesdir!]
!bat_log!
!bat_return!










	REM #############################################################################################
	REM Perform a quick check and return bat_detectilfe and the other variables quickly.
	REM
	REM Basically, it works like this.  If there is ONLY one file that EXACTLY matches this filespec
	REM     "FTPdetectinfo_??????_????_??_??_??_??_??.txt"
	REM
	REM then return all the variables and exit without going through all the renaming code and stuff.
	REM Mostly because in order to do the renaming, you have to create the GCFC.log and a whole bunch
	REM of other time-consuming stuff.
	REM 
:QUICK_CHECK
!bat_pushlog! [CALL !bat_batchfile!:QUICK_CHECK] %*

	set bat_returncode=1
	
	set bat_found=


	if exist "!bat_archivedfilesdir!" (
	
			REM We can determine if there is exactly 1 file matching the name, by doing a DIR 
			REM command and checking for the text: "1 File^(s^)"
			REM
		!bat_log! ^(DIR "!bat_archivedfilesdir!\ftpdetectinfo*.txt" ][ FINDSTR /i /c:"1 File(s) "}nul: 2}$1^) $$ ^(
		(           DIR "!bat_archivedfilesdir!\ftpdetectinfo*.txt"|   FINDSTR /i /c:"1 File(s) ">nul: 2>&1) && (
			REM -IF- There is EXACTLY ONLY ONE detect file. So we should qualify for QUICK_CHECK
			
			if exist "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??_confirmed.txt" (
				for /f "usebackq tokens=*" %%a in (`DIR "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??.txt" /b /a-d /o-n`) do (
					CALL :QUICK_CHECK_FOUND "%%a"
				
				)
			)


			if exist "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??*.txt" (
				for /f "usebackq tokens=*" %%a in (`DIR "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??_scanned.txt" /b /a-d /o-n`) do (
					CALL :QUICK_CHECK_FOUND "%%a"
				
				)
			)


			if exist "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??*.txt" (
				for /f "usebackq tokens=*" %%a in (`DIR "!bat_archivedfilesdir!\FTPdetectinfo_*_????_??_??_??_??_??_confirmed.txt" /b /a-d /o-n`) do (
					CALL :QUICK_CHECK_FOUND "%%a"
				
				)
			)

		) || (
			REM -ELSE- There are more than one file 
			
			
			
			REM -ELSE- so it doesn't qualify for QUICK_CHECK
			!bat_logexeclog! set bat_returncode=1
			!bat_logexeclog! set bat_retval2=QUICK_CHECK fail - must do it the normal way...
			goto :QUICK_CHECK_END
		)
	)

:QUICK_CHECK_END
!bat_poplog! [RETURN !bat_batchfile!:QUICK_CHECK] 
	!bat_log! `                   bat_returncode=!bat_returncode!, bat_retval2=!bat_retval2!,
	!bat_log! `                   !bat_GDF_retvar!=!%bat_GDF_retvar%!,
	!bat_log! `                   bat_camera_list=!bat_camera_list!, 
	!bat_log! `                   bat_camera=!bat_camera!, 
	!bat_log! `                   bat_camera_first=!bat_camera_first!,
	!bat_log! `                   bat_camera_last=!bat_camera_last!,
	!bat_log! `                   %bat_GDF_retvar%Dir=!bat_archivedfilesdir!
	!bat_log! `                   %bat_GDF_retvar%File=%bat_detectfile2%
	!bat_log! `                   %bat_GDF_retvar%Full=%bat_detectfile4%
	!bat_log! `                   %bat_GDF_retvar%Name=%bat_detectfile3%
	!bat_log! `                   bat_GCFC_tempfile=%bat_GCFC_tempfile%]
	!bat_log!
	!bat_poplog! !bat_batchfile!:QUICK_CHECK - EXIT /B !bat_returncode!
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!
!bat_return! !bat_returncode!




	REM #############################################################################################
	REM Continue the quick check and return bat_detectilfe and the other variables quickly.
	REM
	REM Given the a specific detect file, which does NOT have the full path, it returns all the info 
	REM related to the found one.
	REM 
	REM It needs to establish a precedence order:
	REM   FTPdetectinfo_000258_2017_11_30_03_00_00_confirmed.txt
	REM   FTPdetectinfo_000258_2017_11_30_03_00_00_scanned.txt
	REM   FTPdetectinfo_000258_2017_11_30_03_00_00.txt
	REM 

:QUICK_CHECK_FOUND
!bat_pushlog! [CALL !bat_batchfile!:QUICK_CHECK_FOUND] %*
	!bat_log! ***** FOUND **** [!bat_archivedfilesdir!\%%a]

	set bat_tempDir=!bat_archivedfilesdir!
	set bat_tempFile=%%~a
	set bat_tempName=%%~na
	set bat_tempExt=%%~xa
	set bat_tempFull=!bat_tempDir!\!bat_tempFile!
	

		REM FTPdetectinfo_000258_2017_11_30_03_00_00
		REM              321c987654321b987654321a987654321
		
	set bat_captureddatetime=!bat_tempName:~-19,19!

		REM FTPdetectinfo_000258_2017_11_30_03_00_00_confirmed
		REM                        321c987654321b987654321a987654321
		
	(echo.!bat_tempName!|find /i "_confirmed") && (
		set bat_captureddatetime=!bat_tempName:~-29,19!
	)

		REM FTPdetectinfo_000258_2017_11_30_03_00_00_scanned
		REM                      321c987654321b987654321a987654321
		
	(echo.!bat_tempName!|find /i "_scanned") && (
		set bat_captureddatetime=!bat_tempName:~-27,19!
	)


	set bat_captureddate=!bat_captureddatetime:~0,10!
	set bat_capturedtime=!bat_captureddatetime:~-8!

		REM Can't do quick check because it's not named right format, probably because
		REM it has FTPdetectinfo_FirstLast_... instead of FTPdetectinfo_First_...
		
	!bat_log! bat_tempName="!bat_tempName!"    if /i "!bat_tempName:~20,1!" neq "_" ^(
	if           /i "!bat_tempName:~20,1!" neq "_" (
		!bat_log! ` CAN'T QUICK_CHECK, Needs rename
		!bat_logexec! set bat_returncode=1
		rem goto :QUICK_CHECK_END
	) else (
			REM bat_camera without leading zeros
		!bat_logexeclog! set bat_camera=!bat_tempName:~14,6!

			REM If the file is the one made by FTP_CombineDetectinfo.exe, then signal that it needs to be renamed.
		!bat_logexeclog! set bat_camera_list=!bat_camera!
		!bat_logexeclog! set bat_camera_first=!bat_camera!
		!bat_logexeclog! set bat_camera_last=!bat_camera!

			REM Note about the following statement.  If the dir is the EmailFiles or anything else,
			REM then it will not be renamed and the capturedfiles dir will be the EmailFiles dir
			
		!bat_logexeclog! set bat_capturedfilesdir=!bat_archivedfilesdir:\ArchivedFiles\=\CapturedFiles\!
		!bat_logexeclog! set !bat_GDF_retvar!=!bat_tempFull!
		!bat_logexeclog! set bat_detectfile2=!bat_tempFile!
		!bat_logexeclog! set bat_detectfile3=!bat_tempName!
		!bat_logexeclog! set bat_detectfile4=!bat_tempFull!

		if "!bat_camera!" equ "000000" (
			!bat_logexeclog! set bat_returncode=1
			!bat_logexeclog! set bat_retval2=QUICK_CHECK - must do it the normal way...
		) else (
			!bat_logexeclog! set bat_returncode=0
			!bat_logexeclog! set bat_retval2=QUICK_CHECK success
		)
	)



:QUICK_CHECK_FOUND_END
!bat_poplog! [RETURN !bat_batchfile!:QUICK_CHECK_FOUND] 
	!bat_log! `                   bat_returncode=!bat_returncode!, bat_retval2=!bat_retval2!,
	!bat_log!
!bat_return! !bat_returncode!



	REM #############################################################################################
	REM This routine checks whether there is an active capture session currently capturing files
	REM and writing to the detect file.  
	REM
	REM We do this by examining the "CaptureStats.log" file.  Fortunately, this file is locked [essentially
	REM by opening for WRITE without sharing] by the capture program during capture and it is not released 
	REM until the capture program is completed.  Therefore, if the file does not exist or if it does exist
	REM but we can't rename it, the Capture must still be active. 
	REM
	REM Since the new capture8AndDetect program unlocks the temp detect files between detections, 
	REM we can't depend on the file being locked and preventing GetDetectFile.bat from renaming those
	REM temp detect files.  If we allow the temp detect files to be renamed, we ruin the ongoing detect
	REM file writing procedure.
	REM
	REM Returns:
	REM   1000 if the capture session is still active.
	REM      0 if the capture session is NOT active. 
	REM
:CHECK_CAPTURE_ACTIVE
!bat_pushlog! [CALL !bat_batchfile!:CHECK_CAPTURE_ACTIVE] %*

	set bat_returncode=0
	
	set bat_temp_filecount1=
	set bat_temp_filecount2=

	if not exist "!bat_capturedfilesdir!\CaptureStats*.log" (
		!bat_log! 
		!bat_log! OK - File doesn't exist so it must not be an active session... "!bat_capturedfilesdir!\CaptureStats.log"
		!bat_log!
		set bat_returncode=0
		goto :CHECK_CAPTURE_ACTIVE_END
	) else (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\CaptureStats*.log" /b /a-d /od`) do (
			if /i "%%a" neq "CaptureStats.log" (
				!bat_logexec! MOVE /Y "!bat_capturedfilesdir!\%%a" "!bat_capturedfilesdir!\CaptureStats.log"
			)
		)
	)
	
		REM If we can't rename or move the file, capture must still be active. 
		
	!bat_logexeclog! MOVE /y  "!bat_capturedfilesdir!\CaptureStats.log"   	  "!bat_capturedfilesdir!\CaptureStats.log.bak"
	if "!errorlevel!" neq "0" (
			REM The capture session is still active because the CaptureStatus.log file seems to be locked
		set bat_returncode=1000
		!bat_log! `**** ERROR [!bat_returncode!] -  The capture session is still active because the CaptureStatus.log file seems to be locked
		goto :CHECK_CAPTURE_ACTIVE_END
	) else (
			REM If the log file is not locked, then we need to move it back
		 !bat_logexeclog! MOVE /y  "!bat_capturedfilesdir!\CaptureStats.log.bak" "!bat_capturedfilesdir!\CaptureStats.log"
		goto :CHECK_CAPTURE_ACTIVE_END
	)


:CHECK_CAPTURE_ACTIVE_END

if /i "!bat_returncode!" NEQ "0" (
	!bat_poplog! [RETURN !bat_batchfile!:CHECK_CAPTURE_ACTIVE] [bat_returncode=!bat_returncode!, bat_temp_filecount1=!bat_temp_filecount1!, bat_temp_filecount2=!bat_temp_filecount2!]
	!bat_log!
) else (
	!bat_poplog! [RETURN !bat_batchfile!:CHECK_CAPTURE_ACTIVE] [bat_returncode=!bat_returncode!]
	!bat_log!
)
set bat_temp_filecount1=
set bat_temp_filecount2=
!bat_return! !bat_returncode!









	REM #############################################################################################
	REM Rename CameraTimeOffsets in both dirs to a unique name matching the detect file naming convention.
	REM Same should be true for AutoCalUpdate.log and NudgeCalUpdate.log.
	REM
:RENAME_CAMERATIMEOFFSETS
!bat_pushlog! [CALL !bat_batchfile!:RENAME_CAMERATIMEOFFSETS] [bat_capturedfilesdir=%1, bat_archivedfilesdir=%2] 

	if exist "%~1\CameraTimeOffsets.txt" (
		!bat_logexeclog! MOVE /Y "%~1\CameraTimeOffsets.txt" "%~1\CameraTimeOffsets_!bat_camera!_!bat_captureddatetime!.txt"
	)

	if exist "%~2\CameraTimeOffsets.txt" (
		!bat_logexeclog! MOVE /Y "%~2\CameraTimeOffsets.txt" "%~2\CameraTimeOffsets_!bat_camera!_!bat_captureddatetime!.txt"
	)
	
	if exist "%~1\AutoCalUpdate.log" (
		!bat_logexeclog! MOVE /Y "%~1\AutoCalUpdate.log" "%~1\AutoCalUpdate_!bat_camera!_!bat_captureddatetime!.log"
	)

	if exist "%~2\AutoCalUpdate.log" (
		!bat_logexeclog! MOVE /Y "%~2\AutoCalUpdate.log" "%~2\AutoCalUpdate_!bat_camera!_!bat_captureddatetime!.log"
	)
	
	if exist "%~1\NudgeCalUpdate.log" (
		!bat_logexeclog! MOVE /Y "%~1\NudgeCalUpdate.log" "%~1\NudgeCalUpdate_!bat_camera!_!bat_captureddatetime!.log"
	)

	if exist "%~2\NudgeCalUpdate.log" (
		!bat_logexeclog! MOVE /Y "%~2\NudgeCalUpdate.log" "%~2\NudgeCalUpdate_!bat_camera!_!bat_captureddatetime!.log"
	)
	

:RENAME_CAMERATIMEOFFSETS_END
!bat_poplog! [RETURN !bat_batchfile!:RENAME_CAMERATIMEOFFSETS]
!bat_log!
!bat_return!





	REM #############################################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "bat_detectfile" "%%bat_archivedfilesdir%%" ["%%bat_capturedfilesdir%%"]
	echo.
	echo Returns the detect file found in the given directory in the second
	echo argument.  If found, the full path/filename is returned in the 
	echo environment variable passed as the first argument. 
	echo.
	echo.IMPORTANT: The name of the first arg must begin with "bat_".
	echo.
	echo.Example 1:
	echo.    call "%~0"   "bat_detectfile"     "C:\CAMS\ArchivedFiles\2016_02_09_02_16_00"
	echo.
	echo.Returns:
	echo.    bat_returncode=0,,
	echo.	 [bat_detectfile]=C:\CAMS\ArchivedFiles\2016_02_09_02_16_00\FTPdetectinfo_02660267_2016_02_09_02_16_13.txt,
	echo.        [where "bat_detectfile" is the name of the variable passed as the first argument]
	echo.	 bat_camera_list=02660267,
	echo.	 bat_camera=266,
	echo.	 bat_camera_first=266,
	echo.	 bat_camera_last=267,
	echo.	 bat_detectfileDir=C:\CAMS\ArchivedFiles\2016_02_09_02_16_00
	echo.	 bat_detectfileFile=FTPdetectinfo_02660267_2016_02_09_02_16_13.txt
	echo.	 bat_detectfileFull=C:\CAMS\ArchivedFiles\2016_02_09_02_16_00\FTPdetectinfo_02660267_2016_02_09_02_16_13.txt
	echo.	 bat_detectfileName=FTPdetectinfo_02660267_2016_02_09_02_16_13
	echo.	 bat_GCFC_tempfile=C:\CAMS\CapturedFiles\2016_02_09_02_16_00\GCFC.log]
	echo.
	echo.
	echo Example 2:
	echo    set bat_archivedfilesdir=c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfile"     "bat_archivedfilesdir"
	echo Results: bat_detectfile=
	echo    "c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Example 3:
	echo    set bat_confirmedfilesdir=c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfileconf" "bat_confirmedfilesdir"
	echo Results: bat_detectfile=
	echo    c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Notice how the environment variable names are passed an not their
	echo values.  
	echo.
	echo.
	echo.
	echo.
exit /b 99

[1]             a="FTPdetectinfo, b=txt", c=, d=, e=, f=, g=, h=, i=, J=, k=, L=, m=%m

[2]             a="FTPdetectinfo, b=0001, c=txt", d=, e=, f=, g=, h=, i=, J=, k=, L=, m=%m
[3]             a="FTPdetectinfo, b=Coinc, c=txt", d=, e=, f=, g=, h=, i=, J=, k=, L=, m=%m

[4]             a="FTPdetectinfo, b=0000, c=YYYY, d=MM, e=DD, f=txt", g=, h=, i=, J=, k=, L=, m=%m
[5]             a="FTPdetectinfo, b=0ccc, c=YYYY, d=MM, e=DD, f=txt", g=, h=, i=, J=, k=, L=, m=%m
[6]             a="FTPdetectinfo, b=0ccc0xxx, c=YYYY, d=MM, e=DD, f=txt", g=, h=, i=, J=, k=, L=, m=%m

[7]             a="FTPdetectinfo, b=00000, c=YYYY, d=MM, e=DD, f=hh, g=mm, h=ss, i=txt", J=, k=, L=, m=%m
[8]             a="FTPdetectinfo, b=0ccc, c=YYYY, d=MM, e=DD, f=hh, g=mm, h=ss, i=txt", J=, k=, L=, m=%m
[9]             a="FTPdetectinfo, b=0ccc0CCC, c=YYYY, d=MM, e=DD, f=hh, g=mm, h=ss, i=txt", J=, k=, L=, m=%m
[10]            a="FTPdetectinfo, b=0ccc0CCC0xxx0XXX, c=YYYY, d=MM, e=DD, f=hh, g=mm, h=ss, i=txt", J=, k=, L=, m=%m

[11]            a="FTPdetectinfo, b=0ccc, c=YYYY, d=MM, e=DD, f=hh, g=mm, h=ss, i=scanned, J=txt", k=, L=, m=%m
[12]            a="FTPdetectinfo, b=0ccc, c=YYYY, d=MM, e=DD, f=hh, g=mm, h=ss, i=confirmed, J=txt", k=, L=, m=%m





	REM #############################################################################################
	REM
:DONE
!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog! [DONE !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
!bat_echolog!
exit /b !bat_returncode!



