@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
    
    if "%~3" equ "" goto :HELP

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	
	!bat_title! "%~dpnx0" "%*"

	set bat_var_firstfile=%~1
	set bat_var_lastfile=%~2
	
		REM The 3rd argument is is  the sourcedir, typically the CapturedFiles dir
	set bat_sourcedir=%~3
	set bat_sourcedrive=!bat_sourcedir:~0,2!
	if /i "!bat_sourcedrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! Invalid path ["!bat_sourcedir!"]
		set bat_returncode=1
		goto :DONE
	)
	
		REM The 4th argument is to specify a specific camera.  This section pads whatever value
		REM was provided with left-leading zeros such as: 000255
	set bat_camera_target=%~4
	if defined bat_camera_target (
		set bat_camera_target=000000!bat_camera_target!
		set bat_camera_target=!bat_camera_target:~-6!
	)

		REM bat_tempfile_name=GetFirstLastFF_filenames.bat.txt
	set bat_tempfile_name=!bat_batchfile!.txt
	set bat_tempfile_full=!bat_sourcedir!\!bat_tempfile_name!
	
		REM bat_tempfile_name_camera=GetFirstLastFF_filenames.bat_000255.txt
	set bat_tempfile_name_camera=!bat_batchfile!_!bat_camera_target!.txt
		REM bat_tempfile_full_camera=C:\CAMS\CapturedFiles\2017_08_12_03_00_00\GetFirstLastFF_filenames.bat_000255.txt
	set bat_tempfile_full_camera=!bat_sourcedir!\!bat_tempfile_name_camera!
	
		REM bat_camerafile_full=C:\CAMS\CapturedFiles\2017_08_12_03_00_00\GCFC.log
	set bat_camerafile_full=!bat_sourcedir!\GCFC.log!

goto :MAIN %*




:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0
	
		REM Delete the "GetFirstLastFF_filenames.bat.txt" file if it exists so that it can be rebuilt. 
	call :CHECKTEMPFILE
	
		REM "GetFirstLastFF_filenames.bat.txt"
	if exist "!bat_tempfile_full!" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_tempfile_full!" /s/b /a-d`) do (
			!bat_logexeclog! echo.size=%%~za, "%%~a"
		)
	)
	
		REM "GetFirstLastFF_filenames.bat.txt"
	if not exist "!bat_tempfile_full!" (

		!bat_log!
		!bat_log! Not Exist - Creating a new file: "!bat_tempfile_full!"
		!bat_log!

:MAIN2
!bat_log! [GOTO !bat_batchfile!:MAIN2] %*

		call :GETFIRSTFILENAME bat_var_firstfile "!bat_sourcedir!"

		call :GETLASTFILENAME bat_var_lastfile "!bat_sourcedir!"

			rem The original reason for deleting the tempfile was to keep from polluting
			rem the directory.  However, because, for the 16 camera systems, which produce
			rem over 80,000 files in a session, it is best to keep the file around.
	rem	if exist "!bat_tempfile_full!" (
	rem		!bat_logexeclog! del /q "!bat_tempfile_full!"
	rem	)

	) else (
		
		!bat_log!
		!bat_log! Already Exists - Just reading instead of creating: "!bat_tempfile_full!"
		!bat_log!


		set /a bat_count=0
		!bat_pushlog! for /f "usebackq tokens=1,2* delims==" ..a in ^(`type "!bat_tempfile_full!"`^) do ...
		for               /f "usebackq tokens=1,2* delims==" %%a in  (`type "!bat_tempfile_full!"`) do (
			set /a bat_count+=1
			
			if !bat_count! equ 1 (
				!bat_logexeclog! set bat_var_firstfile=%%b
			)

			if !bat_count! equ 2 (
				!bat_logexeclog! set bat_var_lastfile=%%b
			)
		)
		!bat_poplog! ^)
	)

	if /i "!bat_var_firstfile!" NEQ "%~1" (
		!bat_log! echo.%~1=!bat_var_firstfile!}"!bat_tempfile_full!"
		!bat_log! echo.%~2=!bat_var_lastfile!}}"!bat_tempfile_full!"
		echo.%~1=!bat_var_firstfile!>"!bat_tempfile_full!"
		echo.%~2=!bat_var_lastfile!>>"!bat_tempfile_full!"
	) else (
		set bat_returncode=3
		!bat_echolog! 
		!bat_echolog! ERROR [!bat_returncode!] - Unable to build "!bat_tempfile_full!"
		!bat_echolog! 
		goto :MAIN_END
	)

	!bat_logexeclog! set bat_archivedfilesdir=!bat_sourcedir:\CapturedFiles\=\ArchivedFiles\!
	if exist "!bat_archivedfilesdir!" (
		!bat_logexeclog! COPY /Y "!bat_tempfile_full!"   "!bat_archivedfilesdir!"
	)
:MAIN_END
!bat_log! [ENDLOCAL-!bat_batchfile!:MAIN] [%~1=%bat_var_firstfile%, %~2=%bat_var_lastfile%]
!bat_log! - goto :DONE
!bat_log!


( ENDLOCAL & IF "%bat_returncode%" NEQ "3" (
	rem echo.SET %~1=%bat_var_firstfile%
	rem echo.SET %~2=%bat_var_lastfile%

	SET %~1=%bat_var_firstfile%
	SET %~2=%bat_var_lastfile%
	set bat_returncode=%bat_returncode%
	)
)

goto :DONE









	rem *************************************************************
	rem ***** Routine to get first filename [sorted REVERSE]   ******
	rem *************************************************************
	
:GETFIRSTFILENAME [IN bat_var_firstfile] [in sourcedir]
!bat_pushlog! [CALL !bat_batchfile!:GETFIRSTFILENAME] %*

	set bat_returncode=0

		REM If no camera specified on the command line, then include all cameras
	if defined bat_camera_target (
		set bat_searchspec=FF_!bat_camera_target!_????????_??????_???_0000000.bin
	) else (
		set bat_searchspec=FF_??????_????????_??????_???_0000000.bin
		
	)
	
		REM The first FF file always has frame number 0000000 as the last element of the FF file's name.
		REM If one of those can't be found, then the directory has had them removed for some reason.
		REM If that is the case, then look for the first file in a different way. 
	if not exist "!bat_sourcedir!\FF_??????_????????_??????_???_0000000.bin" (
		set bat_searchspec=FF_??????_????????_??????_???_???????.bin
	)

		REM Can't solve the FIRST file becaue the files don't exist.
	if not exist "!bat_sourcedir!\!bat_searchspec!" (
		set bat_returncode=10
		!bat_echolog!
		!bat_echolog! ERROR [!bat_returncode!] - not exist: "!bat_sourcedir!\!bat_searchspec!"
		!bat_echolog!
		goto :GETFIRSTFILENAME_END
	)

	!bat_titlewait! !bat_batchfile!:GETFIRSTFILENAME
	
			REM Search backward and output the results into "GetFirstLastFF_filenames.bat.txt"
			REM such as: 
			REM     bat_camera_first=FF_000250_20170915_024932_962_0000000.bin

		!bat_log! dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /o-n^}"!bat_tempfile_full!"
		          dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /o-n>"!bat_tempfile_full!"

	!bat_title!
	              
	set /a bat_temp_filesize=0

	call :GETFILELEN "!bat_tempfile_full!"  "!bat_searchspec!"

		REM returns FF filename in variable "%~1", such as bat_var_firstfile
	call :LOOP "%~1" "!bat_linecount!" "!bat_tempfile_full!"

:GETFIRSTFILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GETFIRSTFILENAME] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        %~1=!%~1!]
!bat_log!
!bat_return!








	rem *************************************************************
	rem ***** Routine to get first filename sorted FORWARD     ******
	rem *************************************************************
	
:GETLASTFILENAME [out var_firstfile] [out var_lastfile] [in path]
!bat_pushlog! [CALL !bat_batchfile!:GETLASTFILENAME] %*

	set bat_returncode=0

	if defined bat_camera_target (
		set bat_searchspec=FF_!bat_camera_target!_*.bin
	) else (
		set bat_searchspec=FF_??????_*.bin
	)

	if not exist "!bat_sourcedir!\!bat_searchspec!" (
		set bat_returncode=10
		goto :GETLASTFILENAME_END
	)


	!bat_titlewait!
			REM Search Forward
		!bat_log! dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /on^}"!bat_tempfile_full!"
		          dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /on>"!bat_tempfile_full!"
	              
	!bat_title!
	
	set /a bat_temp_filesize=0
	              
	call :GETFILELEN "!bat_tempfile_full!" "!bat_searchspec!"

	rem returns value in variable "%~1", such as bat_var_firstfile
	call :LOOP "%~1" "!bat_linecount!" "!bat_tempfile_full!"


:GETLASTFILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GETLASTFILENAME] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        %~1=!%~1!]
!bat_log!
!bat_return!



	REM ################################################
	REM GETFILELEN
	REM Return the size of the file in bytes...
	REM 
:GETFILELEN
!bat_pushlog! [CALL :GETFILELEN] [%*]

	!bat_titlewait!

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "%~1"][FIND /c /i ".bin"^) do ^(
	          for /f "usebackq tokens=*" %%a in  (`type "%~1"^|FIND /c /i ".bin"`)  do (
		set /a bat_linecount=%%~a
	)
	
	!bat_title!
	
	!bat_log! Matching entries: bat_linecount="!bat_linecount!"
	
:GETFILELEN_END
!bat_poplog! [RETURN !bat_batchfile!:GETFILELEN] [bat_returncode=!bat_returncode!, bat_linecount=!bat_linecount!]
!bat_log!
!bat_return!




:LOOP
!bat_pushlog! [CALL !bat_batchfile!:LOOP] [%*]
	set bat_returncode=0
	
	!bat_titlewait! !bat_linecount!

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "%~3"`^) do ^(
	          for /f "usebackq tokens=*" %%a in  (`type "%~3"`)  do (
		set %~1=%%~a
	)

	!bat_title!
	
:LOOP_END
!bat_poplog! [RETURN !bat_batchfile!:LOOP] [bat_returncode=!bat_returncode!, %~1=!%~1!, %~3=!%~3!]
!bat_log!
!bat_return!





	rem *************************************************************
	rem ***** Routine to check whether the specified camera    ******
	rem ***** is found only once or multiple times in the file ******
	rem *************************************************************

:CHECKTEMPFILE
!bat_pushlog! [CALL !bat_batchfile!:CHECKTEMPFILE] [%*]

	call :CHECKCAMERACOUNT
	!bat_logexeclog! set bat_cameracount=!bat_returncode!
	set bat_returncode=0


	if /i "!bat_cameracount!" neq "1" (
	
			REM If no camera was specified, then do it for all cameras
		if not defined bat_camera_target (
		
				REM if GetFirstLastFF_filenames.bat.txt exists...
			if exist "!bat_tempfile_full!" (
				rem In this section, we will attempt to determine if we need to rebuild the
				rem first/last file in the case where there are multiple cameras in the capture
				rem session and the first/last file has only one of those cameras.

				rem read the first/last file to get the first camera in the list.  %%a value
				rem in the loop is the variable and the %%b value is the value of the variable. 
				set bat_returncode=
				set bat_temp_cam=
				!bat_log! for /f "usebackq tokens=1-2* delims==" ..a in ^(`type "!bat_tempfile_full!"`^) do 
				for           /f "usebackq tokens=1-2* delims==" %%a in  (`type "!bat_tempfile_full!"`) do (
					if not defined bat_returncode (
rem						!bat_echolog! 11111111 set bat_returncode=%%b
						set bat_returncode=%%b
						set bat_temp_cam=!bat_returncode:~3,6!
					) else (
rem						!bat_echolog! 22222222 set bat_returncode=%%b
						set bat_returncode=%%b
						set bat_returncode=!bat_returncode:~3,6!

							REM If this is the same as the previously line in the file, then it's a single
							REM camera file.  So delete to force rebuild.  
						if /i "!bat_temp_cam!" equ "!bat_returncode!" (
							!bat_log!
							!bat_log! Already exists, but the existing one is a filtered list containing only one camera 
							!bat_log! and there are multiple cameras in the detect file.
							!bat_log! Therefore, need to delete to force rebuild...
							!bat_log!
							!bat_logexeclog! del /q "!bat_tempfile_full!"
						)
					)
				)
			)
		) else (
			rem a camera was specified... and there are multiple cameras
			!bat_log! Already exists, but the command line wants to filter the list 
			!bat_log! by a single camera.  Therefore, need to delete to force rebuild...
			!bat_log!
			!bat_logexeclog! del /q "!bat_tempfile_full!"
		)
		
	)


:CHECKTEMPFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CHECKTEMPFILE] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!



	rem *************************************************************
	rem ***** Routine to count the number of cameras found     ******
	rem ***** in the GCFC.log file in the ArchivedFiles dir    ******
	rem *************************************************************

:CHECKCAMERACOUNT
!bat_pushlog! [CALL !bat_batchfile!:CHECKCAMERACOUNT] [%*]

		REM If GCFC.log doesn't exist, then build it
	if not exist "!bat_camerafile_full!" (
		!bat_START! /wait "Please Wait - CreateCameraListFile.bat - [!bat_capturedfilesdir!]" /low cmd /c ""!bat_exedir!\CreateCameraListFile.bat" "!bat_sourcedir!"" 
	)

	if exist "!bat_camerafile_full!" (
			REM Get the number of cameras listed in the GCFC file
			REM if there is only 1 then we treat it different than if there are more than one
		for /f "usebackq skip=1 tokens=1-3 delims=:" %%a in  (`find /i /c /v "" "!bat_camerafile_full!"`) do (
			set bat_returncode=%%c
			!bat_logexeclog! set bat_returncode=!bat_returncode: =!
		)
	)

	if /i "!bat_returncode!" equ "0" (
		set bat_returncode=-1
	)

:CHECKCAMERACOUNT_END
!bat_poplog! [RETURN !bat_batchfile!:CHECKCAMERACOUNT] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!




:STRIPWHITESPACE
	set %~1=!%~1!
!BAT_RETURN!




:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"

%bat_COMMENT_BEGIN%
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_CALL! "!bat_exedir!\Readini.bat" "!bat_configfile!" "CAMSMENU" bat_capturedfilesdir /q
	if !bat_logexec_returncode! equ 0 (
		set bat_capturedfilesdir=!RetVal1!
	)
%bat_COMMENT_END%

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [!bat_capturedfilesdir!]
!bat_log!
!bat_return!






:HELP
	echo %~0      Batch Script
	echo.
	echo.     Usage %~0 "^<var_firstfile^>"    "^<var_lastfile^>"   "^<target directory path^>" ["^<camera^>"]
	echo.
	echo.     Example: 
	echo.        %~0 bat_firstfile bat_lastfile "C:\CAMS\CapturedFiles\2011_10_21_01_58_22"
	echo.
	echo.     This script will examine the specified directory and return, into the variable names
	echo.     specified on the command line, the file names of the first and last FF files in the 
	echo.     dir.
	echo.
	echo.     The ^<camera^> variable is optional.  If it is defined, the search will be limited to only
	echo.     the specified camera. 
	echo.
	echo.     The original purpose of this script was help to determine the date/time range of the 
	echo.     capture session so that we can determine if there are missing CAL files.  A CAL
	echo.     file is considered missing if none of the cal files for the date of the capture
	echo.     session fall between the date/time of  the first/last range. In such a case,
	echo.     the option "9. ApplyCal2Detectfile"  would fail update the detect file with
	echo.     a current cal file, so it will choose to use a previous capture session's CAL
	echo.     file.
	echo.
	echo.     If the "camera" argument is omitted, then the file should be copied to the ArchivedFiles
	echo.     and ConfirmedFiles dirs, if they exist.  
	echo.
	echo.     RETURN CODES:
	echo.        0 = success, %%var_firstfile%%,  %%var_lastfile%%
	echo.        1 = Invalid dir specification. [!bat_sourcedir!]
exit /b -99



:DONE
	!bat_log! goto %~nx0:DONE [!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:DONE2
	exit /b %bat_returncode%
