
   @echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=
	)

    if not defined bat_LOCALIZE.format.date (
    	call "!bat_exedir!\ReadParams.bat"
    )
 
	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!
	
	set bat_retval=

	if not defined bat_localize.dow_6 (
		!bat_echolog!
		!bat_echolog! '    !bat_batchfile!:SETUP ERROR - autocams.params.ini is missing the
		!bat_echolog! '                          the translated days of the week as:
		!bat_echolog! '                          [LOCALIZE]
		!bat_echolog! '                          dow_0=Sunday
		!bat_echolog! '                          dow_1=Monday
		!bat_echolog! '                          etc...
		!bat_echolog!
		exit /b 2
	)
	
	if /i "%~1" equ "" (
		!bat_logexeclog! set bat_date_os=!date!
	) else (
		!bat_logexeclog! set bat_date_os=%~1
		
		echo."!bat_LOCALIZE.format.date!"|find /i "www ">nul:
		if !errorlevel! equ 0 (
			!bat_log! "www "
			!bat_logexeclog! set bat_LOCALIZE.format.date=!bat_LOCALIZE.format.date:www =!
		)
		
		
		echo."!bat_LOCALIZE.format.date!"|find /i " www">nul:
		if !errorlevel! equ 0 (
			!bat_log! " www"
			!bat_logexeclog! set bat_LOCALIZE.format.date=!bat_LOCALIZE.format.date: www=!
		)
	)
	
	call :GETLOCALIZED_DOW !bat_date_os!

goto :DONE




        rem *********************************************************
        rem ****                  GETLOCALIZED_DOW               ****
        rem 
        rem Gets the localized name of the day of the week 
        rem according to the dow_number day index passed as the 1st
        rem argument.
        rem
        rem Returns: 
        rem    errorlevel        0 means success. Otherwise fail.
        rem    bat_weekday       The text value of the weekday
        rem                      in the loclazed language, as
        rem                      translated into autocams.params.ini
        rem
        rem This routine requires a parameter be passed
        rem
        rem [LOCALIZE]
        rem dow_0=Sunday
        rem dow_1=Monday
        rem dow_2=Tuesday
        rem dow_3=Wednesday
        rem dow_4=Thursday
        rem dow_5=Friday
        rem dow_6=Saturday
        rem
        rem *********************************************************
 
:GETLOCALIZED_DOW [IN] dow_number
!bat_pushlog! [CALL !bat_batchfile!:GETLOCALIZED_DOW] [%*]
 
        set bat_returncode=1
        set bat_weekday=
 
        if /i "%~1" equ "" (goto :GETLOCALIZED_DOW_END)

		!bat_log! bat_localize.dow_%~1=!bat_localize.dow_%`!
        !bat_logexeclog! set bat_weekday=!bat_localize.dow_%~1!
        
        set bat_returncode=0
 
:GETLOCALIZED_DOW_END
!bat_poplog! [RETURN !bat_batchfile!:GETLOCALIZED_DOW] [bat_weekday=%bat_weekday%]
!bat_log!
!bat_return!
 




:HELP
	echo.Usage: call "%~nx0" ^<day index^>
	echo.
    echo.Gets the localized name of the day of the week 
    echo.according to the dow_number value passed as the 1st
    echo.argument.
    echo.
    echo.Where:
    echo.   day index         Is the index of the weekday, where
    echo.                     Monday=0 and Sunday=6
    echo.Returns: 
    echo.   errorlevel        0 means success. Otherwise fail.
    echo.   bat_retval        The text value of the weekday
    echo.                     in the loclazed language, as
    echo.                     translated into autocams.params.ini
    echo.
    echo.This routine requires a parameter be passed
    echo.
    echo.  [LOCALIZE]
    echo.  dow_0=Sunday
    echo.  dow_1=Monday
    echo.  dow_2=Tuesday
    echo.  dow_3=Wednesday
    echo.  dow_4=Thursday
    echo.  dow_5=Friday
    echo.  dow_6=Saturday
    echo.
    echo.*********************************************************
	
exit /b -99


:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!
        ENDLOCAL & (set bat_retval=%bat_weekday%)

 

exit /b !bat_returncode!

