@echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP
	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
    
	if "%~1" equ "" (goto :HELP)

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog!


rem
rem	if exist "!bat_exedir!\Cams2Global.ini" (
rem		REM Needs to be able to handle if there are multiple CAMS instances, e.g. Fremont Peak, Forest Hill, etc. 
rem		CALL "!bat_exedir!\ReadCams2Global.bat"
rem		
rem		set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
rem		!bat_echolog! set bat_boards_max=!bat_boards_max!
rem	)
	

	CALL :PARSEARGS %*
	if !errorlevel! neq 0 goto :HELP
	
	if not defined bat_caldir (
		!bat_logexeclog! set bat_caldir=!bat_camsdir!\Cal
	)
	
rem	set bat_date=%~1
		REM Normal date format to yyyymmdd [without "_", "/", or "." delimiters]
	set bat_date=!bat_date:_=!
	set bat_date=!bat_date:/=!
	set bat_date=!bat_date:.=!

	set bat_spacer=                                                  

	!bat_logexeclog! set bat_outputfile_name=Pointing_!bat_date!.txt
	!bat_logexeclog! set bat_outputfile=!bat_caldir!\!bat_outputfile_name!
	
	!bat_echolog! "!bat_outputfile!"
	echo.>"!bat_outputfile!"

	echo.>"!bat_outputfile!"
	echo.=============================================================>>"!bat_outputfile!"
	echo.%date% %time% - Version: !bat_vers! - %~dpnx0 %*>>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"
	

	!bat_echolog! `                           Height    Cam                              Focal Fov    Fov               
	!bat_echolog! `  Lat         Long          WGS84     ID  Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  O-C   Accuracy           File                                Comments                         
	!bat_echolog! `--------- ----------- ----------- ------ -------- ------- --------- ------- ---------- --------- ------ ----- -----------------  ----------------------------------   --------------------------------   

	echo.                           Height    Cam                              Focal Fov    Fov               >>"!bat_outputfile!"
	echo.  Lat         Long          WGS84     ID  Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  O-C   Accuracy           File                                Comments                         >>"!bat_outputfile!"
	echo.--------- ----------- ----------- ------ -------- ------- --------- ------- ---------- --------- ------ ----- -----------------  ----------------------------------   --------------------------------   >>"!bat_outputfile!"

rem	!bat_echolog! for  /f "usebackq tokens=*" ..a in ^(`dir "!bat_caldir!\cal_??????_!bat_date!_*.txt" /a-d /b /on`^) do ^(
	for            /f "usebackq tokens=*" %%a in  (`dir "!bat_caldir!\cal_??????_!bat_date!_*.txt" /a-d /b /on`) do (
		
		set bat_filename=%%a
		
		set /a bat_count=0
		rem echo.for /f "useback tokens=1-10 delims==" ..b in ^(`findstr /i /c:"Camera number" /c:"azim" /c:"elev" /c:"calibration date" /c:"calibration time" /c:"fov dimension" /c:"plate scale" /c:"cam tilt" /c:"camera description" /c:"focal length" /c:"focal ratio"   "cal\%%a"`^) do ^(

		rem echo.for  /f "useback tokens=1-2 delims==" ..b in ^(`find /i /v"" "!bat_caldir!\%%a"`^) do ^(
		for      /f "useback tokens=1-2 delims==" %%b in  (`type "!bat_caldir!\%%a"`) do (
			set /a bat_count+=1
			set bat_temp=%%c
			
rem			echo.!bat_count!	[!bat_temp!]	[%%b, %%c]
			
			if !bat_count! equ 1 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_CameraNumber=!bat_retval!
			)
			
			if !bat_count! equ 2 (
				call :FILL_LEFT "!bat_temp!" 10
				set bat_CalDate=!bat_retval!
			)
			
			if !bat_count! equ 3 (
				call :FILL_LEFT "!bat_temp!" 12
				set bat_CalTime=!bat_retval!
			)
			
			if !bat_count! equ 4 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Long=!bat_retval!
			)
			
			if !bat_count! equ 5 (
				call :FILL_RIGHT "!bat_temp!" 9
				set bat_Lat=!bat_retval!
			)
			
			if !bat_count! equ 6 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Height=!bat_retval!
			)
			
			if !bat_count! equ 7 (
				for /f "tokens=1,2 delims=x" %%k in ("!bat_temp!") do (
					call :FILL_RIGHT "%%k" 5
					set bat_FovH=!bat_retval!
					
					call :FILL_RIGHT "%%l" 5
					set bat_FovW=!bat_retval!
				)
			)
			
			if !bat_count! equ 8 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_Scale=!bat_retval!
			)
			
			if !bat_count! equ 9 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_roll=!bat_retval!
			)
			
			if !bat_count! equ 10 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Tilt=!bat_retval!
			)
			
			if !bat_count! equ 14 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Az=!bat_retval!
			)
			
			if !bat_count! equ 15 (
				call :FILL_RIGHT "!bat_temp!" 7
				set bat_Elev=!bat_retval!
			)
			
			if !bat_count! equ 19 (
				call :STRIP_WHITESPACE "!bat_temp!" 30
				set bat_Descr=!bat_retval!
			)
			
			if !bat_count! equ 21 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalLength=!bat_retval!
			)
			
			if !bat_count! equ 22 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalRatio=!bat_retval!
			)
			
			if !bat_count! equ 23 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchH=!bat_retval! um
			)
			
			if !bat_count! equ 24 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchV=!bat_retval! um
			)
			
			if !bat_count! equ 47 (
				call :FILL_RIGHT "!bat_temp!" 23
				set bat_OC=!bat_retval!
			)
			
		)
		
		set bat_output=!bat_Lat! !bat_Long! !bat_Height! !bat_CameraNumber! !bat_Az! !bat_Elev!            !bat_FocalLength! !bat_FovW! !bat_FovH! !bat_Tilt! !bat_scale! !bat_OC!  !bat_filename!  !bat_Descr! !bat_PitchH! x !bat_PitchV! ^(um^)
		!bat_echolog! `!bat_output!
		echo.!bat_output!>>"!bat_outputfile!"
		
	)


echo.
echo.
echo.Output is found in: "!bat_outputfile!"

goto :DONE




:FILL_RIGHT 
	set bat_retval=!bat_spacer!%~1
rem	echo.[[[[set bat_retval=!bat_retval:~-%~2!]]]]]]]]]
	set bat_retval=!bat_retval:~-%~2!
exit /b 0



:FILL_LEFT 
	set bat_retval=%~1!bat_spacer!
	set bat_retval=!bat_retval:~0,%~2!
	
exit /b 0


:STRIP_WHITESPACE 
	set bat_retval=
	
	set bat_retval=%~1

exit /b 0


 	Az	Elev	Color	Lens	fov	Tilt/Roll	Scale	Comments
114	25.2	28.7	00E6B8 cyan	12	30.2 x 22.1	-3	2.8	watec



	REM #################################################################################
	REM This script will be called like this:
	REM 
	REM   GetPointingForDate.bat ^<yyyymmdd^> /camsdir "camsdir"
	REM
	REM bat_capturedfilesdir should not be expected to be correct when this script is
	REM launched. 
	REM
	REM The /camsdir argument indicates that the next argument overrides the camsdir.
	REM
	REM Returns:
	REM    bat_returncode			0=OK.
	REM                                     any other value means failure
	REM
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_returncode=1


		REM ==================================================================================
		REM Set defaults that might be missing from autocams.params.ini
		REM

	

:PARSEARGS_LOOP
rem echo.:PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" (
		goto :PARSEARGS_LOOPBREAK
	)
	
	if /i "%~1" equ "/camsdir" (
		!bat_logexeclog! set bat_camsdir=%~2

		shift
		shift
		goto :PARSEARGS_LOOP
	)
	
	if /i "%~1" equ "/all" (
		set bat_all=true
	) else (
		set bat_all=false
	)


	echo.%~1|findstr /i /r /c:"\<[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]">nul
	if !errorlevel! equ 0 (
			REM use FOR to capture the results...
		for /f "usebackq tokens=1" %%a in (`echo.%~1^|findstr /i /r /c:"\<[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]"`) do (
			!bat_logexeclog! set bat_date=%%a
			SHIFT
		)
		
		if defined bat_date (set bat_returncode=0)
		
		goto :PARSEARGS_LOOP
	)

	

:PARSEARGS_LOOPBREAK
!bat_log! [CALL !bat_batchfile!:PARSEARGS_LOOPBREAK] %*

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_returncode=!bat_returncode!,
!bat_log! `                                      bat_date=!bat_date!,
!bat_log! `                                      bat_camsdir=!bat_camsdir!,
!bat_log! `                                      bat_exedir=!bat_exedir!,
!bat_log! `                                     ]
!bat_log!
rem !bat_WAIT! 3	:PARSEARGS_END
!bat_return! !bat_returncode!





:HELP
	echo.
	echo.Usage: %~nx0 [date] [/camsdir ^<directory^>]
	echo.
	echo.Returns a list of pointing information for each calibration file found for the 
	echo.specified date.  
	echo.
	echo.Note: The columns are presented in the order they are input into the 
	echo.      CAMS Pointing Tool to facilitate date entry to create your laydowns.
	echo.
	echo.      http://www.davesamuels.com/cams/camspointing/scripts/latlong.html
	echo.
	echo.Where:
	echo.   date      is the date in the date in the following format
	echo.             yyyymmdd [with no delimiters].
	echo.
	echo.Example:
	echo.    %~nx0 20151222
	echo.
exit /b 99

:DONE

