@echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	if "%~1" equ "" (goto :HELP)

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog!

	CALL :PARSEARGS %*
	if !errorlevel! neq 0 (goto :HELP)


	!bat_logexeclog! set bat_cameralist_file=!bat_detectfile_dir!\SortDetect_CameraList.txt
	!bat_logexeclog! set bat_calfilelist=!bat_detectfile_dir!\CalFileList.log

	!bat_logexeclog! set bat_outputfile=!bat_detectfile_dir!\Pointing_!bat_detectfile_filename!

	set bat_spacer=                                                  

	if not defined bat_caldir (
		set bat_caldir=!bat_camsdir!\Cal
	)

	!bat_echo! Output file: "!bat_outputfile!"
	!bat_echo!

	echo.>"!bat_outputfile!"
	echo.=============================================================>>"!bat_outputfile!"
	echo.%date% %time% - Version: !bat_vers! - %~dpnx0 %*>>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"
	
	echo.Output file: "!bat_outputfile!" >>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"
	
	!bat_logexeclog! TYPE "!bat_calfilelist!"
	!bat_echolog! `

	!bat_echolog! `                           Height    Cam                              Focal Fov    Fov               
	!bat_echolog! `  Lat         Long          WGS84     ID  Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  O-C   Accuracy           File                                Comments                         
	!bat_echolog! `--------- ----------- ----------- ------ -------- ------- --------- ------- ---------- --------- ------ ----- -----------------  ----------------------------------   --------------------------------   

	echo.                           Height    Cam                              Focal Fov    Fov               >>"!bat_outputfile!"
	echo.  Lat         Long          WGS84     ID   Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  O-C   Accuracy           File                                Comments                         >>"!bat_outputfile!"
	echo.--------- ----------- ----------- ------  -------- ------- --------- ------- ---------- --------- ------ ----- -----------------  ----------------------------------   --------------------------------   >>"!bat_outputfile!"

rem	!bat_echolog! for      /f "usebackq tokens=* skip=2" ..a in ^(`FIND /i /v"" "!bat_calfilelist!"`^) do ^(
	for                    /f "usebackq tokens=* skip=2" %%a in  (`FIND /i /v"" "!bat_calfilelist!"`) do (
rem		echo.>>"!bat_outputfile!"  [%%a]
rem		echo.%%a>>"!bat_outputfile!"  [%%a]
rem		echo.%%a
		
		set bat_filename=%%a
		
		set /a bat_count=0

rem		!bat_echolog! for      /f "useback tokens=1-2 delims== skip=2" ..b in ^(`find /i /v"" "!bat_caldir!\%%a"`^) do ^(
		for                    /f "useback tokens=1-2 delims== skip=2" %%b in  (`find /i /v"" "!bat_caldir!\%%a"`) do (
			set /a bat_count+=1
			set bat_temp=%%c
			
rem			echo.!bat_count!	[!bat_temp!]	[%%b, %%c]
			
			if !bat_count! equ 1 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_CameraNumber=!bat_retval!
			)
			
			if !bat_count! equ 2 (
				call :FILL_LEFT "!bat_temp!" 10
				set bat_CalDate=!bat_retval!
			)
			
			if !bat_count! equ 3 (
				call :FILL_LEFT "!bat_temp!" 12
				set bat_CalTime=!bat_retval!
			)
			
			if !bat_count! equ 4 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Long=!bat_retval!
			)
			
			if !bat_count! equ 5 (
				call :FILL_RIGHT "!bat_temp!" 9
				set bat_Lat=!bat_retval!
			)
			
			if !bat_count! equ 6 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Height=!bat_retval!
			)
			
			if !bat_count! equ 7 (
				for /f "tokens=1,2 delims=x" %%k in ("!bat_temp!") do (
					call :FILL_RIGHT "%%k" 5
					set bat_FovH=!bat_retval!
					
					call :FILL_RIGHT "%%l" 5
					set bat_FovW=!bat_retval!
				)
			)
			
			if !bat_count! equ 8 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_Scale=!bat_retval!
			)
			
			if !bat_count! equ 9 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_roll=!bat_retval!
			)
			
			if !bat_count! equ 10 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Tilt=!bat_retval!
			)
			
			if !bat_count! equ 14 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Az=!bat_retval!
			)
			
			if !bat_count! equ 15 (
				call :FILL_RIGHT "!bat_temp!" 7
				set bat_Elev=!bat_retval!
			)
			
			if !bat_count! equ 19 (
				call :STRIP_WHITESPACE "!bat_temp!" 30
				set bat_Descr=!bat_retval!
			)
			
			if !bat_count! equ 21 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalLength=!bat_retval!
			)
			
			if !bat_count! equ 22 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalRatio=!bat_retval!
			)
			
			if !bat_count! equ 23 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchH=!bat_retval! um
			)
			
			if !bat_count! equ 24 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchV=!bat_retval! um
			)
			
			if !bat_count! equ 47 (
				call :FILL_RIGHT "!bat_temp!" 23
				set bat_OC=!bat_retval!
			)
			
		)
		
		set bat_output=!bat_Lat! !bat_Long! !bat_Height! !bat_CameraNumber! !bat_Az! !bat_Elev!            !bat_FocalLength! !bat_FovW! !bat_FovH! !bat_Tilt! !bat_scale! !bat_OC!  !bat_filename!  !bat_Descr! !bat_PitchH! x !bat_PitchV! ^(um^)
		!bat_echolog! `!bat_output!
		echo.!bat_output!>>"!bat_outputfile!"
		rem set bat_
		
	)


echo.
echo.
rem echo.Output is found in: "!bat_outputfile!"

goto :DONE




:FILL_RIGHT 
	set bat_retval=!bat_spacer!%~1
rem	echo.[[[[set bat_retval=!bat_retval:~-%~2!]]]]]]]]]
	set bat_retval=!bat_retval:~-%~2!
exit /b 0



:FILL_LEFT 
	set bat_retval=%~1!bat_spacer!
	set bat_retval=!bat_retval:~0,%~2!
	
exit /b 0


:STRIP_WHITESPACE 
	set bat_retval=
	
	set bat_retval=%~1

exit /b 0


 	Az	Elev	Color	Lens	fov	Tilt/Roll	Scale	Comments
114	25.2	28.7	00E6B8 cyan	12	30.2 x 22.1	-3	2.8	watec




	REM #################################################################################
	REM This script will be called like this:
	REM 
	REM   GetPointingForDate.bat ^<yyyymmdd^> /camsdir "camsdir"
	REM
	REM bat_capturedfilesdir should not be expected to be correct when this script is
	REM launched. 
	REM
	REM The /camsdir argument indicates that the next argument overrides the camsdir.
	REM
	REM Returns:
	REM    bat_returncode			0=OK.
	REM                                     any other value means failure
	REM
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_returncode=1


		REM ==================================================================================
		REM Set defaults that might be missing from autocams.params.ini
		REM

	

:PARSEARGS_LOOP
rem echo.:PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" (
		goto :PARSEARGS_LOOPBREAK
	)
	
	if /i "%~1" equ "/camsdir" (
		!bat_logexeclog! set bat_camsdir=%~2

		shift
		shift
		goto :PARSEARGS_LOOP
	)


	!bat_logexeclog! set bat_detectfile_temp=%~1
	!bat_logexeclog! set bat_detectfile_filename=%~nx1
	!bat_logexeclog! set bat_detectfile_name=%~n1
			 set bat_detectfile_dir=%~dp1::
			 set bat_detectfile_dir=!bat_detectfile_dir:\::=!
	!bat_logexeclog! set bat_detectfile_dir=!bat_detectfile_dir:::=!
	
	if "!bat_detectfile_name:~20,1!" equ "_" (
			rem for first camera only: FTPdetectinfo_000525_2017_12_24_01_32_08.txt
		!bat_logexeclog! set bat_date=!bat_detectfile_name:~21,10!
	) else (
			rem for first/last camera: FTPdetectinfo_000525000541_2017_12_24_01_32_08.txt
		!bat_logexeclog! set bat_date=!bat_detectfile_name:~27,10!
	)
	
	set bat_returncode=0
	SHIFT


    
		
	goto :PARSEARGS_LOOP

	

:PARSEARGS_LOOPBREAK
!bat_log! [CALL !bat_batchfile!:PARSEARGS_LOOPBREAK] %*

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_returncode=!bat_returncode!,
!bat_log! `                                      bat_date=!bat_date!,
!bat_log! `                                      bat_camsdir=!bat_camsdir!,
!bat_log! `                                      bat_exedir=!bat_exedir!,
!bat_log! `                                     ]
!bat_log!
rem !bat_WAIT! 3	:PARSEARGS_END
!bat_return! !bat_returncode!






:HELP
	echo.
	echo.Usage: %~nx0 [detect file]   [/camsdir "^<cams directory^>"]
	echo.
	echo.Returns a list of pointing information for each calibration file found for the 
	echo.specified detect file.  
	echo.
	echo.Note: The columns are presented in the order they are input into the 
	echo.      CAMS Pointing Tool to facilitate date entry to create your laydowns.
	echo.
	echo.      http://www.davesamuels.com/cams/camspointing/scripts/latlong.html
	echo.
	echo.
	echo.Example:
	echo.    %~nx0 "C:\CAMS\ArchivedFiles\2017_09_06_03_05_57\FTPdetectinfo_000258_2017_09_06_03_05_57.txt"
	echo.
	echo.    %~nx0 "C:\CAMS\ArchivedFiles\2017_09_06_03_05_57\FTPdetectinfo_000258_2017_09_06_03_05_57.txt" /camsdir "D:\Cams_Board0\CAMS"
	echo.
exit /b 99


:DONE

