  @echo off

echo %date% %time% %0 %*>"%~0.log"
echo %date% %time% %0 %*
echo.

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
    set bat_return=goto :EOF

	setlocal enableextensions enabledelayedexpansion

:GETARGS
	set bat_camera=%~1
	set bat_delaytemp=%~2
	set bat_targetlocation=%~3

:PARSEDATE
	set ftp_wmdy=%date%
	set ftp_hhmmssdd=%time%

	set ftp_year=%ftp_wmdy:~-4%
	set ftp_mo=%ftp_wmdy:~4,2%
	set ftp_mo2=%ftp_mo%
	if %ftp_mo% LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=%ftp_wmdy:~7,2%
	set ftp_da2=%ftp_da%
	if %ftp_da% LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

:PARSETIME
	set ftp_hr=%ftp_hhmmssdd:~0,2%
	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,5%

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2

:GETSEARCHDIR
	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
	
:GETSCHEDSTART
	set bat_scheduledstarttime=ERROR
	for /f "usebackq tokens=1*" %%a in (`find /i "Delay will be from the earliest" "sunsettable.txt"%>nul:`) do (
		set bat_scheduledstarttime=%%a
	)

:GETSTARTTIME
	for /f "usebackq tokens=1-16 skip=1" %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "sunsettable.txt"%>nul:`) do (
		if "%%a" neq "----------" (
			set bat_duration=%%d
			set bat_delay=%%e
			set bat_date=%%a
			set bat_off=%%b
			set bat_on=%%c
			set bat_dst=%%f
			set bat_duskutc=%%g
			set bat_dusklocal=%%h %%i
			set bat_dawnutc=%%j
		)
	)


:MAIN
	call :CALCDELAY "!bat_on!" "!ftp_hhmmssdd!"
	call :CALCDURATION "!bat_ON!" "!bat_OFF!"



:REVIEW
	echo     find /i "Delay will be from the earliest" "sunsettable.txt"
	echo 	Task Scheduler Start Time=!bat_scheduledstarttime!
	echo.

	set bat_duration=0
	rem Determine the duration by looking up in the SunsetTable.txt file

	echo            	         	         	    	   	   	Dusk   	Dusk     	Dawn						
	echo            	         	         	    	   	   	(UTC at	(LDT at   	(UTC at						
	echo            	Dawn OFF	Dusk ON  	Dur-	    	     	8obelow	8o below   	10o below						
	echo   Date    	8o       	8o       	ation	Delay  	DST	horizon	horizon   	horizon   	date    	sunrise	sunset  	Day #
	echo   ====    	======== 	=======  	=====	=====  	===========	=======   	=======   	======= 	=======	======= 	=====
	for /f "usebackq tokens=*" %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "sunsettable.txt"^|find /i /v "sunsettable.txt"`) do (
		echo   %%a
	)
	rem find /i "!bat_curm!/!bat_curd!/!bat_cury!" "sunsettable.txt"|find /i /v "sunsettable.txt"
	echo.
	echo   for /f "usebackq tokens=1-16 skip=2" %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "sunsettable.txt"`) do ...
	for /f "usebackq tokens=1-16 skip=1" %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "sunsettable.txt"%>nul:`) do (
	echo.
		if "%%a" neq "----------" (
			echo    Date              %%a   - Date of these calculations
			echo    Day number        %%p       - Day of the year ^(number of days, plus 1, since 12/31/!bat_prevy!^)
			echo    Task Sched Start  !bat_scheduledstarttime!     - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time      !ftp_hhmmssdd:~0,8!     - Current local time
			echo.
			echo    Camera ON UTC     %%g      - UTC time ^(camera time^) of the first frame
			echo    Camera ON         %%c     - Local time Task Scheduler should start capture
			echo    Camera ON Local   %%h %%i   - Local time of the first frames, Use this to set our wall timer.
			echo    Sunset Local      %%n %%o   - Local sunset time
			echo.
			echo    Camera OFF UTC    %%j     - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local  %%b     - Local time capture should end in the morning
			echo    Sunrise Local     %%l %%m      - Local sunrise time ^(next morning^)
			echo.
			echo    Duration ^(table^)  %%d        - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Duration ^(calc'd^) !bat_dur!        - Number of hours to capture in decimal hours
			echo    Delay ^(table^)     %%e         - Number of seconds to delay from the scheduled start time
			echo    Delay ^(calc'd^)    !bat_delaycalc!        - Number of seconds to delay from the current time !ftp_hhmmssdd:~0,8!
			echo    DST=              %%f            - 1 if this date uses DST.  0 if not
			echo                                       Note: Dawn is calculated for the next morning
			echo.
			echo    Camera number     !bat_camera!          - Camera number
			echo    Target location   !bat_targetlocation!           - Target location
			echo.
			
			set bat_duration=%%d
			set bat_delay=%%e
			set bat_date=%%a
			set bat_off=%%b
			set bat_on=%%c
			set bat_dst=%%f
			set bat_duskutc=%%g
			set bat_dusklocal=%%h %%i
			set bat_dawnutc=%%j
		)
	)


	rem start the execution of the meteor detection pass in background priority

	rem start /min sndrec32 /play /close %windir%\media\ding.wav

:GETDELAY
	rem set /a bat_waituntil=!bat_delay!
	rem set /a bat_startmin=!ftp_mi!+1
	set /a bat_delayhh=!bat_delaycalc!/3600
	set bat_delayhh=00!bat_delayhh:~-2!
	set bat_delayhh=!bat_delayhh:~-2!
	set /a bat_delaymm=(!bat_delaycalc!-(!bat_delayhh!*3600))/60
	set bat_delaymm=00!bat_delaymm:~-2!
	set bat_delaymm=!bat_delaymm:~-2!
	set /a bat_delayss=(!bat_delaycalc!-(!bat_delayhh!*3600))-(!bat_delaymm!*60)
	set bat_delayss=00!bat_delayss:~-2!
	set bat_delayss=!bat_delayss:~-2!

	set bat_unique=ftp_capture_!ftp_year!!ftp_mo!!ftp_da!!ftp_hr!!bat_startmin!

	echo.
	echo     This script is designed to be launched at the same time of the day
	echo     all year ^(!bat_scheduledstarttime!^).  Then it waits a different number of seconds before starting
	echo     capture, based on the calculation of dusk, based on your LAT/LONG. 
	echo     Then it launches FTP_Capture.exe with the specified camera number, the 
	echo     calculated duration (dusk to dawn from the sunsettable.txt file), and 
	echo     the specified storage location. 
	echo.
	echo     If you are running this manually, check the "sunsettable.txt" file
	echo     for the dusk and dawn values and set the duration according to the
	echo     current launch time. 
	echo.
	Echo     Waiting !bat_delaycalc! seconds ^(delay of !bat_delayhh!:!bat_delaymm!:!bat_delayss!^) from the current time of 
	echo     !ftp_hr!:!ftp_mi!:!ftp_se! local time until !bat_dusklocal!.
	echo.
	echo     Then running: call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	echo.
	title %0- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	set bat_>>"%~0.log"
	set ftp_>>"%~0.log"

:WAITDELAY
	echo start /w wait !bat_delaycalc!
	set /a bat_tenth=(!bat_delay!)/10
             title %0- ---------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- X--------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XX-------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXX------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXX------ Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXX----- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXX---- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXX--- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXXX-- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXXXX- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXXXXX Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	echo %date% %time%
	
	call process -k ftp_capture.exe 1>nul 2>nul
	
	echo "FTP_Capture start" !bat_camera! !bat_duration! !bat_targetlocation! %4>>"%~0.log"
	title "FTP_CAPTURE" !bat_camera! !bat_duration! !bat_targetlocation! %4
	echo call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4
	     call "ftp_capture.bat" !bat_camera! !bat_duration! !bat_targetlocation! %4

echo %0 %*
exit /b

	EXIT

goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0



:CALCDURATION
	call :PARSEOFFTIME "!bat_off!"
	call :PARSEONTIME "!bat_on!"
	
	set /a bat_temp=!bat_onsec!-!bat_cursec!
	
	rem                       bat_onh   bat_onm   bat_ons bat_offh  bat_offm  bat_offs
	rem                        %1        %2        %3        %4       %5         %6
	rem call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th4! !bat_tm4! !bat_ts4!
	
	set /a bat_durtotalsecs=(86400-!bat_onsec!)+!bat_offsec!
	set /a (86400-!bat_onsec!)+!bat_offsec!
	echo Total duration=(86400-!bat_onsec!)+!bat_offsec!=!bat_durtotalsecs! seconds
	set /a bat_temp=(!bat_durtotalsecs!*100)/3600
	set /a bat_temph=!bat_temp:~0,2!
	set /a bat_tempm=!bat_temp:~-2!
	set bat_dur=!bat_temph!.!bat_tempm!
	
	set /a bat_durh=!bat_durtotalsecs!/3600
	set /a bat_durm=(!bat_durtotalsecs!-(!bat_durh!*3600))/60
	set /a bat_durs=(!bat_durtotalsecs!-(!bat_durh!*3600))-(!bat_durm!*60)
	
	call :PADZERO bat_offh
	call :PADZERO bat_offewm
	call :PADZERO bat_offews
	call :PADZERO bat_durh
	call :PADZERO bat_durm
	call :PADZERO bat_durs

	echo    !bat_offh!:!bat_offm!:!bat_offs!	Camera OFF time (next morning)
	echo -  !bat_ONh!:!bat_ONm!:!bat_ONs!	Current ON time
	echo -----------------
	echo    !bat_durh!:!bat_durm!:!bat_durs!   !bat_msg! ^<---- duration h:mm:ss ^(!bat_duration! hours^)
	echo.
!bat_return!

:CALCDELAY
	call :PARSECURTIME "%~2"
	call :PARSEONTIME "%~1"
	
	set /a bat_temp=!bat_onsec!-!bat_cursec!
	
	rem                       bat_onh   bat_onm   bat_ons bat_curh  bat_curm  bat_curs
	rem                        %1        %2        %3        %4       %5         %6
	call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th3! !bat_tm3! !bat_ts3!
	
	set /a bat_delay=!bat_newh!*3600+!bat_newm!*60+!bat_news!
	set bat_delaycalc=!bat_delay!
	echo Delay=!bat_delaycalc! seconds
	set bat_msg= 
	
	if !bat_delay! lss 0 (
		rem                       bat_curh  bat_curm  bat_curs bat_onh   bat_onm   bat_ons
		rem                        %1        %2        %3        %4       %5         %6
		call :SUBTRACTONMINUSCUR !bat_th3! !bat_tm3! !bat_ts3! !bat_th1! !bat_tm1! !bat_ts1!
		set /a bat_delay=0
		echo Delay=!bat_delay! seconds
		set bat_msg=   IMMEDIATE (we're starting late)   
	)
	
	
	call :PADZERO bat_ONh
	call :PADZERO bat_ONm
	call :PADZERO bat_ONs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
	
	call :DISPLAY
rem 	CALL :WAITDELAY !bat_delay!
!bat_return!

:PARSECURTIME
	set bat_curtime=%~1
	set bat_curh=!bat_curtime:~0,2!
	set bat_curm=!bat_curtime:~3,2!
	set bat_curs=!bat_curtime:~6,2!!bat_curtime:~-2!

	for /f "tokens=* delims=0" %%m in ("!bat_curs!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_curs=0
	) else (
		set bat_curs=!bat_nz!
	)

	rem round up to the next second
	set /a bat_curs=!bat_curs!+50
	set /a bat_curs/=100
	call :PADZERO bat_curs
	
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_curh! bat_th1
	
	set /a bat_cursec=!bat_th1!*3600+!bat_tm1!*60+!bat_ts1!	
!bat_return!


:PARSEONTIME
	set bat_ontime=%~1
	set bat_onh=!bat_ontime:~0,2!
	set bat_onm=!bat_ontime:~3,2!
	set bat_ons=!bat_ontime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_ons! bat_ts3
	call :STRIPZEROS !bat_onm! bat_tm3
	call :STRIPZEROS !bat_onh! bat_th3
	
	set /a bat_onsec=!bat_th3!*3600+!bat_tm3!*60+!bat_ts3!	
!bat_return!

:PARSEOFFSET
	set /a bat_delay=%~1
	set /a bat_OFFh=!bat_delay!/3600
	set /a bat_OFFr=!bat_delay!-(!bat_OFFh!*3600)
	set /a bat_OFFm=!bat_OFFr!/60
	set /a bat_OFFs=!bat_OFFr!-(!bat_OFFm!*60)
!bat_return!

:PARSEOFFTIME
	set bat_offtime=%~1
	set bat_offh=!bat_offtime:~0,2!
	set bat_offm=!bat_offtime:~3,2!
	set bat_offs=!bat_offtime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_offs! bat_ts4
	call :STRIPZEROS !bat_offm! bat_tm4
	call :STRIPZEROS !bat_offh! bat_th4
	
	set /a bat_offsec=!bat_th4!*3600+!bat_tm4!*60+!bat_ts4!	
	
!bat_return!

:SUBTRACTONMINUSCUR
	rem echo :SUBTRACTONMINUSCUR %1:%2:%3    %4:%5:%6
	set /a bat_remainder=0

	set /a bat_news=%6-%3
	if !bat_news! lss 0 (
		set /a bat_news=!bat_news!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newm=%5-%2-!bat_borrow!
	if !bat_newm! lss 0 (
		set /a bat_newm=!bat_newm!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newh=%4-%1-!bat_borrow!
	if !bat_newh! lss 0 (
		set /a bat_newh=!bat_newh!
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
!bat_return!

:DISPLAY
	echo    !bat_ONh!:!bat_ONm!:!bat_ONs!	Camera ON time
	rem echo +  !bat_OFFh!:!bat_OFFm!:!bat_OFFs!	Current Time
	echo -  !bat_curh!:!bat_curm!:!bat_curs!	Current time
	echo -----------------
	echo    !bat_newh!:!bat_newm!:!bat_news! LT  !bat_msg! ^<---- Waiting h:mm:ss
	echo.
!BAT_RETURN!

:ADDTIMEPLUSOFFSET
	set /a bat_remainder=0

	set bat_ts1=0&set bat_ts2=0
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_OFFs! bat_ts2

	set /a bat_news=!bat_ts1!+!bat_ts2!
	if !bat_news! gtr 59 (
		set /a bat_news=!bat_news!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_OFFm! bat_tm2
	set /a bat_newm=!bat_tm1!+!bat_carry!+!bat_tm2!
	if !bat_newm! gtr 59 (
		set /a bat_newm=!bat_newm!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curh! bat_th1
	call :STRIPZEROS !bat_OFFh! bat_th2
	set /a bat_newh=!bat_th1!+!bat_carry!+!bat_th2!
	if !bat_newh! gtr 23 (
		set /a bat_newh=!bat_newh!-24
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :PADZERO bat_OFFh
	call :PADZERO bat_OFFm
	call :PADZERO bat_OFFs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
!bat_return!

:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b

:WAITDELAY
	set /a bat_tenth=(!bat_delay!)/10
	echo start /w wait !bat_delay!
             title ----------
	     start /w wait !bat_tenth!
             title X---------
	     start /w wait !bat_tenth!
             title XX--------
	     start /w wait !bat_tenth!
             title XXX-------
	     start /w wait !bat_tenth!
             title XXXX------
	     start /w wait !bat_tenth!
             title XXXXX-----
	     start /w wait !bat_tenth!
             title XXXXXX----
	     start /w wait !bat_tenth!
             title XXXXXXX---
	     start /w wait !bat_tenth!
             title XXXXXXXX--
	     start /w wait !bat_tenth!
             title XXXXXXXXX-
	     start /w wait !bat_tenth!
             title XXXXXXXXXX
	rem      start /w wait 0
	echo %date% %time%
goto :DONE

:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
goto :EOF


:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 [cameranumber] [duration] ["targetdirectory"] [/?]
    echo.
    echo     %~n0 can be run by double-clicking on the program from 
    echo     Windows or from a command line.
    echo.
    echo     Starting it from Windows, it will run it in interactive mode 
    echo     where it will prompt the user for the camera number and the 
    echo     duration of the capture in hours.  
    echo.
    echo     If the duration entered is zero, then the user is prompted to 
    echo     manually start and stop the capture process.  If the duration 
    echo     is greater than zero, the program automatically starts the 
    echo     capture and stops after the designated time has elapsed. 
    echo.
    echo     If you run it from a command shell or batch script, you 
    echo     can specify the camera number and duration as command-line 
    echo     arguments.  If the command-line arguments don't provide all 
    echo     the necessary parameters, the missing parameters will be 
    echo     prompted for.
    echo.    
    echo     Examples:
    echo         FTP_Capture
    echo                                          The user is prompted for 
    echo                                          camera number, duration, 
    echo                                          and base target dir.
    echo.
    echo         FTP_Capture 000299                  The user is prompted for 
    echo                                          capture duration and base 
    echo                                          target dir.
    echo.
    echo         FTP_Capture 000299 0.0              The user is prompted for 
    echo                                          for the base target dir and
    echo                                          prompted to start and stop. 
    echo.
    echo         FTP_Capture 000299 9.5              The user is prompted for 
    echo                                          the base target dir. 
    echo.
    echo         FTP_Capture 000213 8.5 "h:"   The capture for camera 000299
    echo                                          starts and runs for 9 hrs  
    echo                                          and 30 mins and saves the
    echo                                          data to a directory like:
    echo                      D:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05
    echo.
    echo     Note: Directory names should be surrounded by quotes.
    echo.
    echo     A folder is created for saving the FF files based on the date and 
    echo     universal time (UTC) at the start of the capture.  The higher level 
    echo     directory is always user specified and the \CAMs\CapturedFiles\ is 
    echo     appended along with the start date and time.  For example, a 
    echo     capture that starts on Aug 14, 2011, 5:11:05 UTC and the target 
    echo     directory specified was "C:", the target directory would be created 
    echo     as C:\CAMS\CapturedFiles\2011_08_14_05_11_05.  If the target dir
    echo     of "D:\2011" is specified, the target directory would be created as:
    echo     C:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05.  
    echo.
EXIT /b -99
    
goto :DONE


:DONE
echo %date% %time%>>1"ftp_capture.log"
