@echo off
setlocal enableextensions enabledelayedexpansion


	REM #################################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*



	REM #################################################################################
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_returncode=0

	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	!bat_CALL! "!bat_exedir!\ReadCams2Global.bat"

	!bat_logexec! set bat_cams2
	
	!bat_WAIT! 3	"!bat_batchfile!:SETUP"
	
	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	
rem	call :PARSEARGS %*
rem	if !errorlevel! neq 0 (
rem		goto :DONE
rem	)

	call :MAIN %*

rem	!bat_log! start /low /min SCHTASKS /Run /tn LaunchCapture_Kill
rem	          start /low /min SCHTASKS /Run /tn LaunchCapture_Kill

goto :DONE



	REM #################################################################################
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %*

	call :KILL_INSTANCES
	if !errorlevel! neq 0 (goto :MAIN_END)
	

	call :RESTORE_INI
	if !errorlevel! neq 0 (goto :MAIN_END)

	!bat_WAIT! 10	[!bat_batchfile!:MAIN_END]
goto :MAIN_END
	


:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:MAIN] []
!bat_log!
!bat_return! !bat_returncode!






	REM #################################################################################
	REM Kill all remaining instances of processes that need to be killed before new night
	REM of capture starts.
	REM 
	REM RETURNS:
	REM     Nothing
	REM 
:KILL_INSTANCES
!bat_pushlog! [CALL !bat_batchfile!:SETUP_DIRS] %*

	set bat_returncode=0

	!bat_echolog!
	!bat_pushecho! [!date! !time! !bat_batchfile!:KILL_INSTANCES] ... Ready to kill old instances...
	!bat_echolog!
	

	for /f "usebackq tokens=1* delims==" %%a in (`set bat_CAMS2PROCESSES`) do (
echo..................................%%a, %%b, ===========!%%b!==========
		echo.............................call process -k %%b
	)
	

	for /f "usebackq tokens=1* delims==" %%a in (`set bat_CAMS2TASKS`) do (
		!bat_echolog! start /low /min SCHTASKS /End /tn %%b
		              start /low /min SCHTASKS /End /tn %%b
	)
	
	!bat_echolog!	

:KILL_INSTANCES_END
!bat_popecho! [RETURN !bat_batchfile!:KILL_INSTANCES] [bat_returncode=!bat_returncode!]
!bat_echolog!
rem !bat_WAIT! 3	:KILL_INSTANCES_END
!bat_return! !bat_returncode!





	REM #################################################################################
	REM     
:RESTORE_INI
!bat_pushlog! [CALL !bat_batchfile!:MAKE_CALSTARS] %*

	set bat_returncode=0
	
	for /L %%a in (0,1,!bat_boards_max!) do (
		!bat_logexec! COPY /y "!bat_CAMS2INIFILE.%%a!.bak"   "!bat_CAMS2INIFILE.%%a!"
	)
	



:RESTORE_INI_END
!bat_popecho! [RETURN !bat_batchfile!:RESTORE_INI] [bat_returncode=!bat_returncode!, ]
!bat_log!
rem !bat_WAIT! 3	:RESTORE_INI_END
!bat_return! !bat_returncode!







	REM #################################################################################
	REM This script will be called like this:
	REM 
	REM   AutoCal_LocalUpload.bat /capturedir "^<bat_capturedfilesdir^>" "^<bat_caldir^>"
	REM
	REM bat_capturedfilesdir should not be expected to be correct when this script is
	REM launched. 
	REM
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_returncode=0

		REM Set the DEFAULT working dirs
	!bat_logexeclog! set bat_capturedfilesdir=
	!bat_logexeclog! set bat_captureddirname=
	!bat_logexeclog! set bat_caldir=
	!bat_logexeclog! set bat_camera=&	rem 
	!bat_logexeclog! set bat_archivedfilesdir=


		REM Set default for bat_calstarsdir.  bat_calstarsdir is the base
		REM directory for all the work is done in this routine.
		REM
	!bat_logexeclog! set bat_calstarsdir=

		REM ==================================================================================
		REM Set defaults that might be missing from autocams.params.ini
		REM
	if not defined bat_CALIBRATION.REMOTE_skip (
	
			REM Set the default for FTP_CalStarsExtraction.exe to skip at least 5 minutes 
			REM between sampled FF files [71 for NTSC and 59 for PAL]
			REM 5 minutes in the equation below is 305 seconds.  The extra 5 seconds 
			REM helps round it up to the next second.
			REM
		set /a bat_CALIBRATION.REMOTE_skip=305 * !bat_CAPTURE.fps! / 25600
		!bat_logexeclog! set bat_CALIBRATION.REMOTE_skip=71
	)

	if not defined bat_CALIBRATION.REMOTE_nstars (
			REM Set the number of stars to include in the CALSTARS and reconsituted FF files at 300
		!bat_logexeclog! set bat_CALIBRATION.REMOTE_nstars=300
	)

	if not defined bat_CALIBRATION.REMOTE_autocal_enabled (
		set bat_CALIBRATION.REMOTE_autocal_enabled=true
	)

	if not defined bat_CALIBRATION.REMOTE_autocal_remote_cmdline (
		!bat_logexeclog! set bat_CALIBRATION.remote_autocal_remote_cmdline=start "" /low /min "!bat_exedir!\MonitorDir.exe"        /FilenameChange /RunOnce /AddFileName /Creation /Activate     "!bat_calstarsdir!" "!bat_exedir!\AutoCal_Remote.bat /zip"
	)

	if not defined remote_autocal_localupload_cmdline (
		!bat_logexeclog! set bat_CALIBRATION.REMOTE_autocal_localupload_cmdline=start "" /low /min "!bat_exedir!\monitordir.exe"   /FilenameChange /RunOnce /AddFileName /Creation /Activate     "!bat_calstarsdir!" "!bat_exedir!\AutoCal_LocalDownload.bat /zip"
	)

		REM This config file contains details of connecting to a remote autocal server
	if not defined bat_CALIBRATION.REMOTE_config_file (
		!bat_logexeclog! set bat_CALIBRATION.REMOTE_config_file=AutoCal_Remote_config.txt
	)

	

:PARSEARGS_LOOP
rem echo.:PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" (
		goto :PARSEARGS_LOOPBREAK
	)
	
	if /i "%~1" equ "/capturedir" (
		!bat_logexeclog! set bat_capturedfilesdir=%~2

		shift
		shift
		goto :PARSEARGS_LOOP
	)

	if /i "%~1" equ "/caldir" (
		!bat_logexeclog! set bat_caldir=%~2
		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	if /i "%~1" equ "/detect" (
		!bat_logexeclog! set bat_detectfile=%~2
		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
		REM /session can be used when the bat_capturedfilesdir does not have a dirname that actually is a CAMS date
	if /i "%~1" equ "/session" (
		!bat_logexeclog! set bat_captureddirname=%~2
		shift
		shift
		goto :PARSEARGS_LOOP

	)
	

:PARSEARGS_LOOPBREAK
!bat_log! [CALL !bat_batchfile!:PARSEARGS_LOOPBREAK] %*


		REM bat_capturedfilesdir should be a date_time in the format:
		REM    "C:\CAMS\CapturedFiles\2016_01_26_14_36_59"
		REM      or 
		REM    "C:\CAMS\SubmissionFiles\750\CapturedFiles\2016_01_26_14_36_59"
		REM    
	if not defined bat_capturedfilesdir (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `    ERROR [!bat_returncode!] - bat_capturedfilesdir is not defined.
		!bat_echolog!
		!bat_echolog!
		!bat_WAIT! 10
		goto :PARSEARGS_END
	)
	
	
	if not defined bat_captureddirname (
		!bat_logexeclog! set bat_captureddirname=!bat_capturedfilesdir:~-19!
	)

	!bat_logexeclog! set bat_captureddate=!bat_captureddirname:~0,10!
	!bat_logexeclog! set bat_capturedtime=!bat_captureddirname:~-8!
	!bat_logexeclog! set bat_captureddatetime=!bat_captureddate!_!bat_capturedtime!
	
	!bat_logexeclog! set bat_archivedfilesdir=!bat_capturedfilesdir:CapturedFiles=ArchivedFiles!

	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" bat_detectfile "!bat_archivedfilesdir!" "!bat_capturedfilesdir!"
	!bat_TITLE!

		REM Set up the variables for the working directories
	!bat_logexeclog! set bat_calstarsdir=!bat_capturedfilesdir!\CALSTARS
	!bat_logexeclog! set bat_calstars_capturedfilesdir=!bat_calstarsdir!\CapturedFiles\!bat_captureddatetime!
	!bat_logexeclog! set bat_calstars_archivedfilesdir=!bat_calstarsdir!\ArchivedFiles\!bat_captureddatetime!
	!bat_logexeclog! set bat_calstars_caldir=!bat_calstarsdir!\Cal

	if not defined bat_capturedfilesdir (
		set bat_returncode=2
		!bat_echolog!
		!bat_echolog! ERROR - Unable to preceed because /capturedir argument is missing.
		!bat_echolog!
		goto :PARSEARGS_END
	)
	
	if not defined bat_caldir (
		set bat_returncode=3
		!bat_echolog!
		!bat_echolog! ERROR - Unable to preceed because /caldir argument is missing.
		!bat_echolog!
		goto :PARSEARGS_END
	)
	

	!bat_logexeclog! set bat_DirListingCalStars=!bat_calstars_capturedfilesdir!\DirListingCalstars.txt"

	!bat_logexeclog! set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	
	!bat_logexeclog! set bat_autocal_remote_queue_dir=!bat_camsdir!\AutoCal_Remote_Queue
	!bat_logexeclog! set bat_autocal_remote_queue=!bat_autocal_remote_queue_dir!\AutoCal_Remote_Queue.txt
	!bat_logexeclog! set bat_ftp_tempfile5=!bat_camsdir!\ftp.temp_queue.txt

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt



:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_returncode=!bat_returncode!,
!bat_log! `                                      bat_capturedfilesdir=!bat_capturedfilesdir!,
!bat_log! `                                      bat_caldir=!bat_caldir!,
!bat_log! `                                      bat_captureddatetime=!bat_captureddatetime!,
!bat_log! `                                      bat_capturedfilesdir=!bat_capturedfilesdir!,
!bat_log! `                                      bat_archivedfilesdir=!bat_archivedfilesdir!,
!bat_log! `                                      bat_detectfile=!bat_detectfile!,
!bat_log! `                                      bat_autocal_remote_queue_dir=!bat_autocal_remote_queue_dir!,
!bat_log! `                                      bat_autocal_remote_queue=!bat_autocal_remote_queue_dir!\AutoCal_Remote_Queue.txt
!bat_log! `                                      bat_calstarsdir=!bat_calstarsdir!,
!bat_log! `                                      bat_calstars_capturedfilesdir=!bat_calstars_capturedfilesdir!,
!bat_log! `                                      bat_calstars_archivedfilesdir=!bat_calstars_archivedfilesdir!,
!bat_log! `                                      bat_calstars_caldir=!bat_calstars_caldir!,
!bat_log! `                                      bat_DirListingCalStars=!bat_DirListingCalStars!,
!bat_log! `                                     ]
!bat_log!
rem !bat_WAIT! 3	:PARSEARGS_END
!bat_return! !bat_returncode!








	REM ########################################################################
	REM 
:ERROR [IN bat_returncode IN "error string"]
!bat_log! [CALL !bat_batchfile!:ERROR] %*

	set bat_returncode=%~1
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! [!date! !time! !bat_batchfile!:SETUP_DIRS] ERROR [!%~1!] - %~2
	!bat_echolog!
	!bat_echolog!
	
	!bat_WAIT! 15


:ERROR_END
!bat_poplog! [RETURN !bat_batchfile!:ERROR] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!





	REM #################################################################################
	REM 
	REM 
	REM 
	REM 
	REM 
	REM 
	REM 
	REM 
	REM 
:HELP
	@echo off
	echo.
	echo.%~nx0
	echo.
	echo Usage: %~nx0 /capturedir "bat_capturedfilesdir" /caldir "!bat_caldir!" /detect "!bat_detectfile!" /session "!bat_capturedfilesdir!"
	echo.   
	echo.Kills all the existing LaunchCapture.exe instances as well as all Email_Cams.exe instances. 
	echo.In addition, it replaces the CamsGUI.ini files with backup copies.  
	echo.
	echo.The idea behind script is to prep the system for another 5pm start of capture. 
	echo.
	echo.The argument pairs can be placed in any order.  [Note: Way may need to add a new argument "/submitted"]
	echo.  arg1             /capturedir bat_capturedfilesdir
	echo.  arg2             /caldir bat_caldir
	echo.
	echo.Cams2Global.ini is used to configure this script.  It's shared among all instances of CamsGUI and LaunchCapture. 
	echo.
	echo.This script needs to be called from a scheduled task around 4:45pm.
	echo.

exit /b 99




	REM #################################################################################
:DONE

	
	!bat_popecho! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
	
	

exit /b !bat_returncode!
