@echo off
setlocal enableextensions enabledelayedexpansion

REM ListMissingFFfiles.bat


	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	
	if "%~1" equ "" goto :HELP
	
goto :SETUP

	
:SETUP


	echo.
	echo.=============================================================
	echo.%date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	echo.[!bat_batchfile!:SETUP %*]  Please wait...
	echo.
	

	set bat_temp_dir=%~1

	set bat_camera_old=
	set /a bat_frame_old=0
	set /a bat_counter_frame=-256
	set /a bat_temp_number=0

	for /f "usebackq tokens=*" %%a in (`dir /b /on /a-d "!bat_temp_dir!\FF_??????_*.bin"`) do (

		rem	echo.
		rem	echo.

		set bat_temp=%%a
		set bat_temp_camera=!bat_temp:~3,6!

		set bat_temp_frame=!bat_temp:~-11!
		set bat_temp_frame=!bat_temp_frame:.bin=!

		call "\cams16\cams\stripzeros.bat" "!bat_temp_frame!" bat_temp_number

		if /i "!bat_camera_old!" neq "!bat_temp_camera!" (
			set bat_camera_old=!bat_temp_camera!
			set bat_frame_old=!bat_temp_frame!

			set /a bat_counter_frame=-256
		)

		set /a bat_counter_frame+=256

		TITLE !bat_temp!     !bat_temp_number! = !bat_counter_frame!

rem 		echo.!bat_temp!      !bat_temp_number! = !bat_counter_frame!
		if /i !bat_temp_number! neq !bat_counter_frame! (
			echo.!bat_temp!

			set /a bat_counter_frame+=256
		)
	)


goto :DONE



:HELP

	@echo off
	echo.
	echo %~nx0
	echo.
	echo.   Usage: %~nx0 "<capturedfilesdir>"
	echo.
	echo.   Checks the specified CapturedFiles dir for missing FF*.bin files.  The script
	echo.   is only useful for CapturedFiles directories because of the way it works.
	echo.
	echo.   This script identifies missing FF*.bin files by taking advantange of the knowledge
	echo.   that each FF file has a frame counter suffix.  Each FF file has a frame counter
	echo.   value that is supposed to be 256 higher than the previous FF file.  
	echo.
	echo.   While it is running, the TITLE bar shows the files it is working on and their 
	echo.   counters.  In the console window, a list of file names will appear. 
	echo.
	echo.   You can redirect the output 
	echo    Where:
	echo      capturedfilesdir			is the full CapturedFiles dir path
	echo.

exit /b 99




:DONE
	echo.
	echo.[!bat_batchfile!:DONE]Done with %0 %*
	echo.~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	echo.[!bat_batchfile!:DONE] exit /b !bat_returncode!

	exit /b !bat_returncode!
