@echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*


	REM #########################################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	CALL "!bat_exedir!\ReadParams.bat"

	CALL "!bat_exedir!\ReadCams2Global.bat"
	
	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_echolog! set bat_boards_max=!bat_boards_max!

rem set bat_

goto :MAIN


	REM #########################################################################
	REM 	:MAIN
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail - don't attempt to upload it. 
	REM

:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN]  %*
	set bat_returncode=0

	CALL :LISTSUBMITTED
	
	
	CALL :LISTTRANSMITTED


	CALL :LISTCAPTURED

:MAIN_END
!bat_poplog! [:MAIN_END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:MAIN_END
goto :DONE






	REM #########################################################################
	REM Lists all the zip files in the Submitted dir	:LISTSUBMITTED
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail - don't attempt to upload it. 
	REM
	REM !bat_CAMS2DIR.0!

:LISTSUBMITTED
!bat_pushlog! [CALL !bat_batchfile!:LISTSUBMITTED]  %*

	set bat_returncode=0
set bat_indent_log_debug=false
		!bat_echolog!
		!bat_echolog! `   Listing files in all the "Submitted" directories. 
	for               /L %%a in  (0,1,!bat_boards_max!) do   (
	
		if exist "!bat_CAMS2DIR.%%a!\Submitted\*.zip" (
			for      /f "usebackq tokens=*" %%b in  (`DIR /s /b /a-d "!bat_CAMS2DIR.%%a!\Submitted\*.zip"`) do   (
				!bat_echolog! `    "%%b"
			)
		) else (
			!bat_echolog! `       No matching files found in "!bat_CAMS2DIR.%%a!\Submitted\*.zip"
		)
	
	)
	

	set bat_returncode=0

:LISTSUBMITTED_END
!bat_poplog! [RETURN !bat_batchfile!:LISTSUBMITTED] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:LISTSUBMITTED_END
!bat_return! !bat_returncode!







	REM #########################################################################
	REM Lists all the zip files in the Transmitted dir	:LISTTRANSMITTED
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail - don't attempt to upload it. 
	REM
	REM 

:LISTTRANSMITTED
!bat_pushlog! [CALL !bat_batchfile!:LISTTRANSMITTED]  %*

	set bat_returncode=1
	set bat_returncode=0

		!bat_echolog! ------------------------------------------------------------------------
		!bat_echolog!
		!bat_echolog! `   Listing files in all the "Transmitted" directories. 
	for /L %%a in (0,1,!bat_boards_max!) do (
	
		if exist "!bat_CAMS2DIR.%%a!\Transmitted\*.zip" (
rem			dir "D:\cams_board%%a\cams\capturedfiles" /s |findstr /i /c:"Dir(s)" /c:"Directory of" /c:"File(s)"

			for /f "usebackq tokens=*" %%b in (`DIR /s /b /a-d "!bat_CAMS2DIR.%%a!\Transmitted\*.zip"`) do (
				!bat_echolog! `    "%%b"
			)
		) else (
			!bat_echolog! `       No matching files found in "!bat_CAMS2DIR.%%a!\Transmitted\*.zip"
		)
	)
	
	set bat_returncode=0

	


:LISTTRANSMITTED_END
!bat_poplog! [RETURN !bat_batchfile!:LISTTRANSMITTED] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:LISTTRANSMITTED_END
!bat_return! !bat_returncode!







	REM #########################################################################
	REM List all the dirs in all the CapturedFiles dirs	:LISTCAPTURED
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail - don't attempt to upload it. 
	REM
	REM 

:LISTCAPTURED
!bat_pushlog! [CALL !bat_batchfile!:LISTCAPTURED

	set bat_returncode=0

		!bat_echolog! ------------------------------------------------------------------------
		!bat_echolog!
		!bat_echolog! `   Listing files in all the "CapturedFiles" directories. 
	for /L %%a in (0,1,!bat_boards_max!) do (
	
		if exist "!bat_CAMS2DIR.%%a!\CapturedFiles\*.*" (
			for /f "usebackq tokens=*" %%b in (`DIR /s /b /ad "!bat_CAMS2DIR.%%a!\CapturedFiles"`) do (
				!bat_echolog! `    "%%b"
			)
		) else (
			!bat_echolog! `       No matching directories found in "!bat_CAMS2DIR.%%a!\CapturedFiles"
		)
	)
	
	set bat_returncode=0

	
	


:LISTCAPTURED_END
!bat_poplog! [RETURN !bat_batchfile!:LISTCAPTURED] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:LISTCAPTURED_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.Usage %~0 
	echo.
	echo.Lists all the ZIP files in the Submitted and Transmitted dirs of all the dirs
	echo.listed in the "!bat_CAMS2DIR.^<n^>!" list from the "Cams2Global.ini" file. 
	echo.
	echo.At the end is a list of all the dirs ^(capture sessions^) in all the CapturedFiles dirs. 
	echo.
	echo.The main purpose is to identify which zip files need to be uploaded.
	echo.
	echo.Depends on the Cams2Global.ini file. 
	echo.
	echo.
	
exit /b 99


	REM #########################################################################
	REM 

:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!

!bat_WAIT! 300  "Press RETURN when you're done."

exit /b !bat_returncode!

