
@echo off
setlocal enableextensions enabledelayedexpansion

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	
	if /i "%~1" EQU "" (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP
	if "%~1" equ "" goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	!bat_CALL! "!bat_exedir!\ReadCams2Global.bat"
	
	set bat_sourcefilefull=%~1&				REM e.g. "D:\cams_board0\CAMS\Submitted\2017_12_24_000533_01_29_10_01.zip"
	
	    REM %~1 e.g. "D:\cams_board0\CAMS\Submitted\2017_12_24_000533_01_29_10_01.zip"
	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_sourcefilefull!"
	set bat_sourcefilename=!bat_retval2!&			REM e.g. "2017_12_24_000533_01_29_10_01.zip"
	set bat_sourcebasedir=!bat_retval1!&			REM e.g. "D:\cams_board0\CAMS\Submitted"
	
	set bat_md5filename=!bat_sourcefilename!.md5.txt
	set bat_md5filefull=!bat_sourcefilefull!.md5.txt&	REM e.g. "D:\cams_board0\CAMS\Submitted\2017_12_24_000533_01_29_10_01.zip.md5.txt"
	
	set bat_submissionsession=!bat_sourcefilename:~0,-7!&   REM e.g. "2017_12_24_000533_01_29_10"
	set bat_camera_first=!bat_submissionsession:~11,6!&	REM e.g. "000525"
	set bat_capturesession=!bat_submissionsession:~0,10!_!bat_submissionsession:~-8!&	REM e.g. "2017_12_24_01_29_10"
	
	set  bat_capturedfilesdir=!bat_camsdir!\SubmissionFiles\!bat_submissionsession!\CapturedFiles\!bat_capturesession!
	set  bat_archivedfilesdir=!bat_camsdir!\SubmissionFiles\!bat_submissionsession!\ArchivedFiles\!bat_capturesession!
	set bat_confirmedfilesdir=!bat_camsdir!\SubmissionFiles\!bat_submissionsession!\ConfirmedFiles\!bat_capturesession!
	
	set bat_hash=
	

goto :MAIN %*




	REM #########################################################################
	REM 

:MAIN
!bat_pushlog! [!bat_batchfile!:MAIN] [%*]

	
	CALL :MAKEMD5
	

:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
rem !bat_WAIT! 0	:MAIN_END
goto :DONE







	REM #########################################################################
	REM Create the md5.txt file, read it, and return the hashcode in the bat_hash variable. 
	rem
	rem for a split zip, we also want to create an md5 control file. So, if the 
	rem zip file is "2018_01_15_000525_01_02_03_01.zip" then we will end up with a bunch of 
	rem segment files, like "2018_01_15_000525_01_02_03_01.zip.001", "2018_01_15_000525_01_02_03_01.zip.002", etc.
	rem Each will get it's own .md5 file. but we also need an md5 ctl file that contains all the
	rem names in the split zip so that the recipient of the split zip knows when they've gotten all the 
	rem parts of the zip.  I think that the ctl file should be sent before the segment files.
	rem "2018_01_15_000525_01_02_03_01.zip.ctl.txt"
	rem
	rem To make the control file, use MD5 without quotes around source filespec -o"controlfile" ^<zipfilename.???^>
	rem EXAMPLE:
	rem    md5 -o"2018_01_15_000525_01_02_03_01.zip.ctl.txt"   2018_01_15_000525_01_02_03_01.zip.???
	rem
	REM
	REM RETURNS:
	REM     bat_returncode     0=ok
	REM                        All other values means fail. 
	

:MAKEMD5
!bat_pushlog! [CALL !bat_batchfile!:MAKEMD5] %*

	set bat_returncode=0

	!bat_log! bat_sourcefilename=!bat_sourcefilename!
	
	!bat_log! Current DIR before PUSHD=!CD!
	
	!bat_logexeclog! PUSHD "!bat_sourcebasedir!"
	
		!bat_log! Current DIR after PUSHD=!CD!

		if exist "!bat_sourcefilename!.001" (
			!log! if exist "!bat_sourcefilename!.001"
		
			REM This block handles hashing each of the md5 files of a split zip...


				if /i "!bat_sourcefilename:~-7!" equ "_01.zip" (
				
					!bat_log! if /i "!bat_sourcefilename:~-7!" equ "_01.zip"

					set bat_tempfilename=!bat_sourcefilename:~0,-4!

					!bat_echolog! for /f "usebackq tokens=*" ..b in ^(`dir /b /a-d /on "!bat_sourcebasedir!\!bat_tempfilename!.zip.???"`^) do ^(
					for               /f "usebackq tokens=*" %%b in  (`dir /b /a-d /on "!bat_sourcebasedir!\!bat_tempfilename!.zip.???"`) do (

						set bat_tempfile=%%b

							REM IF the md5 file already exists
						if /i "!bat_tempfile:~-8!" NEQ ".md5.txt" (
							set bat_md5filefull=!bat_sourcebasedir!\%%b.md5.txt

							!bat_log! "!bat_exedir!\MD5.exe"  -o"%%b.md5.txt"  "%%b" 
								  "!bat_exedir!\MD5.exe"  -o"%%b.md5.txt"  "%%b"

							if EXIST "%%b.md5.txt" (
								for /f "usebackq tokens=1,2*" %%a in (`type "%%b.md5.txt"`) do (
									set bat_hash=%%a
								)
							) else (
								set bat_returncode=2
								!bat_echolog!
								!bat_echolog! `   ERROR [!bat_returncode!] - Failed to create MD5 output file: "%%b.md5.txt"
								!bat_echolog!
								goto :MAKEMD5_10
							)
						)
						
					)&	rem for /f "usebackq tokens=*" &b in ...
				)&	rem if /i "!bat_sourcefilename:~-7!" equ "_01.zip"
		) else (
			if exist "!bat_sourcefilename!" (
				!bat_log! if exist "!bat_sourcefilename!"
				REM This block handles non-split zip hashing

				!bat_log! "!bat_exedir!\MD5.exe"  -o"!bat_md5filename!"  "!bat_sourcefilename!" 
					  "!bat_exedir!\MD5.exe"  -o"!bat_md5filename!"  "!bat_sourcefilename!"

				if NOT EXIST "!bat_md5filename!" (
					set bat_returncode=2
					!bat_echolog!
					!bat_echolog! `   ERROR [!bat_returncode!] - Failed to create MD5 output file: "!bat_md5filename!"
					!bat_echolog!
					goto :MAKEMD5_END
				)

				for /f "usebackq tokens=1,2*" %%a in (`type "!bat_md5filename!"`) do (
					!bat_logexeclog! set bat_hash=%%a
				)
			)
		)

	POPD
	
	!bat_log! Current DIR after POPD=!CD!
	

:MAKEMD5_END
!bat_poplog! [RETURN !bat_batchfile!:MAKEMD5] [bat_returncode=!bat_returncode!, bat_hash=!bat_hash!,
!bat_log! `                                   bat_sourcefilename=!bat_sourcefilename!,
!bat_log! `                                   bat_md5filefull=!bat_md5filefull!]
!bat_log!
rem !bat_WAIT! 0	:MAKEMD5_END
!bat_return! !bat_returncode!







	REM #########################################################################
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.    Usage %~0 ^<fully qualified zip file^>  
	echo.
	echo.    Creates an MD5 file from the specified file. The new md5 file is placed
	echo.    in the same directory as the source file. 
	echo.
	echo.    IMPORTANT: It needs to support the split zip files.  The current thinking on this
	echo.               is for there to be a matching md5.txt file for each split sequence
	echo.               file.  This is done so that we can tell which sequence files have
	echo.               finished uploading.  Therefore, this script needs to be modified so
	echo.               that it takes the fully qualified zip file name that it is passed
	echo.               and then check to see if there is a "file.zip.001".  If there is,
	echo.               then it needs to md5 each of those files.
	echo.
	echo.     Example: 
	echo.        %~0 "C:\CAMS\Submitted\2017_12_24_000525_01_29_10_01.zip"
	echo.
	echo.     RETURNS:
	echo.        bat_hash		Using ENDLOCAL
	echo.        bat_md5filefull    Fully qualified file name for the resulting MD5.txt file. 
	echo.
	echo.        bat_returncode     0=ok
	echo.                           All other values means fail. 
	echo.
!bat_return! 99






	REM #########################################################################
	REM 

:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!
	!bat_log! ` ENDLOCAL & (
	!bat_log! ` 	SET bat_hash=%bat_hash%
	!bat_log! ` 	SET bat_md5filefull=%bat_md5filefull%
	!bat_log! ` )
	!bat_log!
	!bat_log! exit /b !bat_returncode!


ENDLOCAL & (

	SET bat_hash=%bat_hash%
	SET bat_md5filefull=%bat_md5filefull%
)


exit /b !bat_returncode!
