@echo off
setlocal enableExtensions enableDelayedExpansion

	REM ########################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM ########################################################################
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!


	!bat_CALL! "!bat_exedir!\ReadParams.bat"

		REM Get bat_DriveLetter and the ftp connection parameters
		REM Remember, the bat_DriveLetter gets overwritten. 
	!bat_CALL! "!bat_exedir!\ReadRemoteConfig.bat"

	!bat_logexeclog! set bat_strFind=bat_DriveLetter=!bat_DriveLetter!


:SETUP_END
goto :MAIN


	REM ########################################################################
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] [%*]
	call :CHECK_ALREADY_CONNECTED
	if /i "!bat_returncode!" EQU "0" (
		goto :DONE
	)

	call :GET_AVAIL_DRIVELTR
	if /i "!bat_returncode!" neq "0" (
		!bat_echolog! ERROR - Could not find availabe drive letter.
		goto :MAIN_END
	)
	
	call :DRIVELETTER !bat_driveletter!
	
	call :VARIABLES !bat_driveletter!
	
	call :REPLACE "!bat_strFind!" "!bat_strReplace!"


:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!, bat_DriveLetter=!bat_DriveLetter!]
!bat_log!
goto :DONE
	




	REM ########################################################################
	REM If ListDrives.bat shows the FileSystem as FTPUSE, then it's the drive we are looking for...
	REM If no FTPUse drive mappings are found, then this script should continue and make one.
:CHECK_ALREADY_CONNECTED
!bat_pushlog! [CALL !bat_batchfile!:CHECK_ALREADY_CONNECTED] [%*]

	set bat_tempdrive=
	set bat_returncode=

	!bat_pushlog! for /f "usebackq tokens=1-2 skip=1" ..a in ^(`wmic logicaldisk get deviceid, filesystem ][ FIND /i "FTPUSE"`^) do ^(
	for               /f "usebackq tokens=1-2 skip=1" %%a in  (`wmic logicaldisk get deviceid, filesystem`) do (
		if /i "%%b" EQU "FTPUSE" (
			!bat_logexeclog! set bat_tempdrive=%%a
		)
	)
	!bat_poplog! ^)
	

	if defined bat_tempdrive (
		!bat_logexeclog! set bat_DriveLetter=!bat_tempdrive!
		!bat_echolog! FTP drive "!bat_tempdrive!" already connected
		set bat_returncode=0
	) else (
		set bat_returncode=1
	)
	
	goto :CHECK_ALREADY_CONNECTED_END


:CHECK_ALREADY_CONNECTED_END

!bat_poplog! [RETURN !bat_batchfile!:CHECK_ALREADY_CONNECTED] [bat_returncode=!bat_returncode!, bat_DriveLetter=!bat_DriveLetter!]
!bat_log!
!bat_return!





	REM ########################################################################
:GET_AVAIL_DRIVELTR
!bat_pushlog! [CALL !bat_batchfile!:GET_AVAIL_DRIVELTR] [%*]

	set bat_returncode=1

	!bat_log! Current remote drive letter=!bat_tempdrive!
		
	!bat_pushlog! call FTPUSE !bat_driveletter! /DELETE>nul: 2>&1
	              call FTPUSE !bat_driveletter! /DELETE>nul: 2>&1
	
	!bat_poplog!
	
		REM Output to a temp file in reverse order to list all the drive letters and their FileSystem values
	!bat_logexeclog! WMIC logicaldisk get deviceid, filesystem
	
    if exist "junk.txt" ( del /q "junk.txt" ) 
    
	!bat_pushlog! for /f "usebackq tokens=* skip=1" %a in ^(`"wmic logicaldisk get deviceid, filesystem"`^) do ^(
	for               /f "usebackq tokens=* skip=1" %%a in (`"wmic logicaldisk get deviceid, filesystem"`) do (
		echo.%%a>>"junk.txt"
	)
	!bat_poplog! ^)
	
!bat_logexeclog! type junk.txt

		REM Sort the list in reverse order
	!bat_logexeclog! SORT /r "junk.txt" /O "junk2.txt"

	
!bat_logexeclog! type junk2.txt

		REM This is funky logic.  For each drive letter, check 
	!bat_log! for .a in ^(Z Y X W V U T S R Q P O N M L K J I H G F E D ^) do ^(
	for           %%a in (Z Y X W V U T S R Q P O N M L K J I H G F E D ) do (
		!bat_log! Vol %%a: ][ Net Use %%a:
		rem Vol %%a: || Net Use %%a:
		find /i "%%a: " "junk2.txt" || net use %%a:
	) >NUL: 2>&1 || (
		!bat_logexeclog! set bat_DriveLetter=%%a:
		set bat_returncode=0
		!bat_log! Found available drive letter: !bat_driveletter!
		!bat_log! GOTO :GET_AVAIL_DRIVELTR_END
		GOTO :GET_AVAIL_DRIVELTR_END
	)


:GET_AVAIL_DRIVELTR_END
!bat_poplog! [RETURN !bat_batchfile!:GET_AVAIL_DRIVELTR] [bat_returncode=!bat_returncode!, bat_DriveLetter=!bat_DriveLetter!]
!bat_log!
!bat_return! !bat_returncode!





	REM ########################################################################
:DRIVELETTER
!bat_pushlog! [CALL !bat_batchfile!:DRIVELETTER] [%*]

	!bat_logexec!     FTPUSE !bat_driveletter! !bat_calftpsite! !bat_calftppassword! /USER:!bat_calftpuser!
	!bat_WAIT! 10

	!bat_log! Before PUSHD "!bat_driveletter!", current drive is: "!cd!"
	(!bat_CALL! PUSHD "!bat_driveletter!") && (
			!bat_log! PUSHD success if PUSHD was successful
		!bat_log! "FTPUSE succes"
	) || (
			REM report failure of the PUSHD command.  Most likely because the drive letter isn't mapped to anything. 
		!bat_log! "FTPUSE fail"
		!bat_logexeclog! set bat_driveletter=
	)

	!bat_log! currentdir=!cd!
	

:DRIVELETTER_END
!bat_poplog! [RETURN !bat_batchfile!:DRIVELETTER] [bat_returncode=!bat_returncode!, bat_DriveLetter=!bat_DriveLetter!]
!bat_log!
!bat_return! !bat_returncode!







	REM ########################################################################
:VARIABLES
!bat_pushlog! [CALL !bat_batchfile!:VARIABLES] [%*]


	!bat_logexeclog! set bat_InputFile=!bat_exedir!\autocal_remote_config.txt
	!bat_logexeclog! set bat_OutputFile=!bat_exedir!\autocal_remote_config.txt.new

	!bat_logexeclog! set bat_strFind
	!bat_logexeclog! set bat_DriveLetter
	!bat_logexeclog! set bat_strReplace=bat_DriveLetter=!bat_DriveLetter!
	

:VARIABLES_END
!bat_poplog! [RETURN !bat_batchfile!:VARIABLES] [bat_returncode=!bat_returncode!, bat_DriveLetter=!bat_DriveLetter!, bat_strReplace=!bat_strReplace!]
!bat_log!
!bat_return! !bat_returncode!





	REM ########################################################################
:REPLACE
!bat_pushlog! [CALL !bat_batchfile!:REPLACE] [bat_strFind=%~1, bat_strReplace=%~2]

	!bat_logexeclog! type "!bat_InputFile!"

		REM For some stupid unknown reason, this command line works outside the batch but not in this script!!!!
	!bat_logexeclog! "!bat_exedir!\ReplaceText.exe" -i -n "!bat_InputFile!" "%~1" "%~2"
	
	
	
	!bat_logexeclog! del /q "!bat_InputFile!.new"
	
	!bat_log! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i /v "" "!bat_camsdir!\autocal_remote_config.txt"`^) do ^(
	for /f "usebackq tokens=* skip=2" %%a in (`find /i /v "" "!bat_camsdir!\autocal_remote_config.txt"`) do (
		if /i "%%~a" NEQ "%~1" (
			echo.%%~a>>!bat_InputFile!.new"
		) else (
			echo.!bat_strReplace!>>!bat_InputFile!.new
		)
	)

	!bat_logexeclog! move /y "!bat_InputFile!.new" "!bat_InputFile!"
	!bat_logexeclog! type "!bat_InputFile!"

	!bat_log! POPD
	POPD

	!bat_log! currentdir=!cd!
	
:REPLACE_END
!bat_poplog! [RETURN !bat_batchfile!:REPLACE] [bat_returncode=!bat_returncode!, bat_DriveLetter=!bat_DriveLetter!]
!bat_log!
!bat_return! !bat_returncode!





	REM ########################################################################
:HELP
	echo.%~0 - Batch Script
	echo.
	echo.This script maps a drive to the first availble drive letter.  It uses FTPUSE to
	echo.map the drive letter.  The original purpose was for use in the AutoCal_Remote 
	echo.series of scripts to support monitoring of a remote drive on a server for
	echo.when a file appears.  MonitorDir.exe was designed to run a script when a
	echo.new file appears in the targeted dir. 
	echo.
	echo.When it's done, it will update the bat_DriveLetter variable in the 
	echo.AutoCal_Remote_Config.txt file. 
	echo.
exit /b 99




	REM ########################################################################
:DONE
	!bat_log! Done with %~0
	!bat_poplog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b !bat_returncode!
