  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	SET bat_returncode=0
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_logfile=!bat_exedir!\Logs\MergeDetect.bat.log
	set bat_mergedetectfiles_ini_file=!bat_exedir!\MergeDetectFiles.ini
	
	
	set bat_returncode=0

	call :PARSEARGS %*

goto :MAIN

	
:PARSEARGS [in=%*]
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	if /i "%~1" equ "" goto :HELP
	
	set bat_sourcedate=%~1
	set bat_temp_yyyy=!bat_sourcedate:~0,4!
	set bat_temp_mm=!bat_sourcedate:~5,2!
	set bat_temp_dd=!bat_sourcedate:~8,2!
	set bat_captureddate=!bat_temp_yyyy!_!bat_temp_mm!_!bat_temp_dd!


::READ_MERGEINI_FILE
	rem This routine reads the ini file, which is configured like this:
	rem    bat_caldir=C:\cam213\CAMS\Cal
	rem    bat_1sourcedir=C:\cam213\CAMS\temp\coincidence\2013\08_12
	rem    bat_2targetdir=\Merged
	rem    bat_3sourcefilespec=FTPdetectinfo_0*.txt
	rem    bat_date_sep=-
	rem

	set bat_caldir=!bat_startlocation!\Cal
	for /f "usebackq tokens=*" %%a in (`type "!bat_mergedetectfiles_ini_file!"`) do (
		!bat_logexeclog! set %%a
	)
	!bat_echolog!
:::::::::::::::::::::::::::::::::::::::


	!bat_logexeclog! set bat_sourcedir=!bat_1sourcedir!\!bat_sourcedate!
	!bat_logexeclog! set bat_targetdir=!bat_1sourcedir!\!bat_sourcedate!!bat_2targetdir!
	!bat_logexeclog! set bat_sourcefilespec=!bat_3sourcefilespec!
	for /f %%W in (":::\!bat_sourcefilespec!") do (
		!bat_logexeclog! set bat_sourcefilespecname=%%~nW
	)
	
	!bat_logexeclog! set bat_tempdir=!bat_exedir!\Temp
	!bat_logexeclog! set bat_coincidencedir=!bat_sourcedir!
	
	!bat_logexeclog! set bat_targetname=FTPdetectinfo_Coinc.txt
	!bat_logexeclog! set bat_targetfilefull=!bat_targetdir!\!bat_targetname!


!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_captureddate=!bat_captureddate!]
!bat_log!
!return!


:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*
	if not exist "!bat_sourcedir!" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    ERROR - Source directory does not exist:
		!bat_echolog! '            "!bat_sourcedir!"
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END
	)


	if not exist "!bat_targetdir!" (
		!bat_logexec! md "!bat_targetdir!"
	)

	!bat_pushecho! call "!bat_exedir!\MergeDetectFiles.bat" "!bat_sourcedir!" "!bat_targetdir!" "!bat_3sourcefilespec!" "!bat_captureddate!" "!bat_sourcedate!"
	               call "!bat_exedir!\MergeDetectFiles.bat" "!bat_sourcedir!" "!bat_targetdir!" "!bat_3sourcefilespec!" "!bat_captureddate!" "!bat_sourcedate!"
	!bat_popecho! Returned from MergeDetectFiles.bat... ending... %*

	if exist "!bat_targetfilefull!" (
		if /i "!bat_targetfilefull!" neq "!bat_sourcedir!\!bat_targetname!" (
			!bat_logexec! copy /y "!bat_targetfilefull!" "!bat_sourcedir!"
		)
		
		call :FIXFFFOLDER "!bat_targetfilefull!" "!bat_sourcedir!"
	)
	
	if "!bat_sourcedir!" neq "!bat_targetdir!" (
		if defined bat_targetdir (
			!bat_logexec! del /q "!bat_targetdir!"

			!bat_logexec! rd /q "!bat_targetdir!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command:  del /q "!bat_targetdir!"
		)
	)

:MAIN_END
!bat_poplog! [END !bat_batchfile!:MAIN] %*
!bat_log!
goto :DONE






:UNZIP
!bat_pushecho! [CALL !bat_batchfile!:UNZIP] %*

	if not exist "!bat_coincidencedir!" (
		!bat_logexec! md "!bat_coincidencedir!"
	)
	
	rem UNZIP...
	!bat_echolog! '    call "!bat_exedir!\7unzip.bat" -y -output "!bat_coincidencedir!" "!bat_tempdir!\!bat_captureddate!*.zip" "*.*"
	                   call "!bat_exedir!\7unzip.bat" -y -output "!bat_coincidencedir!" "!bat_tempdir!\!bat_captureddate!*.zip" "*.*"
	set bat_returncode=!errorlevel!
!bat_popecho! return !bat_batchfile!:UNZIP [bat_returncode=!bat_returncode!]
!bat_echolog!
%bat_return%


:MERGEDETECT
!bat_pushlog! [CALL !bat_batchfile!:MERGEDETECT] %*
	set bat_returncode=0
	call :CREATECASEHEADER %*
	call :STRIPHEADERS %*
	call :TEMPCONCAT %*
	call :GETMETEORCOUNT %*
	call :GETFFFOLDER
	call :GETCALFOLDER
	call :REBUILDHEADER %*
	call :CONCATFINAL %*
!bat_poplog! [RETURN !bat_batchfile!:MERGEDETECT] []
!bat_log!
%bat_return%



	rem This routine puts a header file into the targetdir. If it can't copy one from 
	rem C:\CAMS, it creates a new one.
:CREATECASEHEADER
!bat_pushlog! [CALL !bat_batchfile!:CREATECASEHEADER] %*

	if exist "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" (
		echo '    copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
		          copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
	) else (
		echo Meteor Count = 000000>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Processed with FTP 1.3 on Tue Feb 28 00:00:00 2012>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  folder = c:\d\CAMS\ArchivedFiles\2011_12_29_10_05_22\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL folder = c:\d\CAMS\Cal\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Cam# Meteor# #Segments fps hnr mle bin Pix/fm Rho Phi>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Per segment:  Frame# Col Row RA Dec Azim Elev Inten>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"

	)
!bat_poplog! [RETURN !bat_batchfile!:CREATECASEHEADER] ["!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"]
!bat_log!
!bat_return!







:STRIPHEADERS
!bat_pushlog! [CALL !bat_batchfile!:STRIPHEADERS] [%*]
	if exist "!bat_targetfilefull!" (
		if defined bat_targetfilefull (
			del /q "!bat_targetfilefull!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:STRIPHEADERS] Dangerous command: del /q "!bat_targetfilefull!"
		)
	)
	!bat_pushlog! '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_sourcedir!\!bat_sourcefilespec!" /b /a-d /on`^) do ^(
	for           /f "usebackq tokens=*" %%a in  (`dir "!bat_sourcedir!\!bat_sourcefilespec!" /b /a-d /on`) do (
		set bat_temp_filename=%%~nxa
		set bat_temp_fullfilename_src=!bat_sourcedir!\!bat_temp_filename!
		set bat_temp_fullfilename_tar=!bat_targetdir!\!bat_temp_filename!
		set bat_temp_headerfull=!bat_targetdir!\header.txt
		set bat_temp_stripped=%%~na_stripped%%~xa

		if /i "!bat_temp_filename!" neq "FTPdetectinfo.txt" (
			if /i "!bat_temp_filename!" neq "!bat_targetname!" (
				if /i "!bat_temp_filename:~-13!" neq "_stripped.txt" (
					if /i "!bat_temp_filename!" neq "FTPdetectinfo_CaseHeader.txt" (
						!bat_echolog! '    call "!bat_exedir!\StripHeaderNASA.bat" "!bat_temp_fullfilename_src!" "!bat_temp_headerfull!" "!bat_targetdir!\!bat_temp_stripped!"
										   call "!bat_exedir!\StripHeaderNASA.bat" "!bat_temp_fullfilename_src!" "!bat_temp_headerfull!" "!bat_targetdir!\!bat_temp_stripped!"
					)
				)
			)
		)
	)
	!bat_poplog! ^)


:STRIPHEADERS_END
!bat_poplog! [RETURN !bat_batchfile:STRIPHEADERS] []
!bat_log!
!bat_return!





	rem temporary concat to fix the meteor count
	rem This section concats without the header
	rem Result: New "FTPdetectinfo.txt" file n the target dir.
:TEMPCONCAT
!bat_pushlog! [CALL !bat_batchfile!:TEMPCONCAT] %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetdir!\!bat_sourcefilespec!" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetdir!\!bat_sourcefilespec!" /b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%bat_targetdir%\%%~a"
		) else (
			set bat_string=!bat_string!+"%bat_targetdir%\%%~a"
		)
	)
	!bat_poplog! ^)

	!bat_logexec! copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"

	set bat_caseheaderfile=!bat_targetdir!\FTPdetectinfo_CaseHeader.txt

!bat_poplog! [RETURN !bat_batchfile!:TEMPCONCAT] [!bat_string!]
!bat_log!
%bat_return%




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT [out=bat_count]
!bat_pushlog! [CALL !bat_batchfile!:GETMETEORCOUNT] %*
	if not exist "!bat_targetdir!\!bat_targetname!" (
		!bat_echolog! '    ERROR - file not found: "!bat_targetdir!\!bat_targetname!"
		set bat_returncode=1
		goto :ABORT
	)
	
	
	!bat_pushlog! '    for /f "usebackq tokens=1-4" ..a in ^(`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`^) do ^(
	for                     /f "usebackq tokens=1-4" %%a in  (`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`) do (
		!bat_log! '    set bat_count=%%c
		                    set bat_count=%%c
	)
	!bat_poplog! ^)

	!bat_pushlog! '    for /f "usebackq tokens=*" a in ^(`type "!bat_caseheaderfile!" find /i "Meteor Count = "`^) do ^(
	for                     /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"^|find /i "Meteor Count = "`) do (
		!bat_log! '    set bat_countsrc=%%a
		                    set bat_countsrc=%%a
	)
	!bat_poplog! ^)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
	set bat_countdest=Meteor Count = !bat_count!


!bat_poplog! [RETURN !bat_batchfile!:GETMETEORCOUNT] [!bat_countdest!]
!bat_log!
%bat_return%



:FIXFFFOLDER [out=bat_fffoldersrc]
!bat_pushlog! [CALL !bat_batchfile!:FIXFFFOLDER] %*
	set bat_fffoldersrc=
	!bat_pushlog! '    for /f "usebackq tokens=* skip=2"   a in ^(`find /i "FF  folder = " "!bat_sourcedir!\!bat_targetname!"`^) do ^(
	                    for /f "usebackq tokens=* skip=2" %%a in  (`find /i "FF  folder = " "!bat_sourcedir!\!bat_targetname!"`) do (
		!bat_logexeclog! set bat_fffoldersrc=%%a
	)
	!bat_poplog! ^)
	
	!bat_echolog! '    bat_fffoldersrc=!bat_fffoldersrc!
	
	if not defined bat_fffoldersrc (
		goto :FIXFFFOLDER_END
	)
	
	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_sourcedir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=!bat_sourcedir!\!bat_targetname!
	
	
	!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_detectfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	
:FIXFFFOLDER_END
!bat_poplog! [RETURN !bat_batchfile!:FIXFFFOLDER] ["!bat_fffoldersrc!"]
!bat_log!
!bat_return!


:GETCALFOLDER [out=bat_calfoldersrc]
!bat_pushlog! [CALL !bat_batchfile!:GETCALFOLDER] %*
	!bat_pushlog! '    for /f "usebackq tokens=*" a in ^(`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`^) do ^(
	for                    /f "usebackq tokens=*" %%a in (`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`) do (
		set bat_calfoldersrc=%%a
	)
	!bat_poplog! ^)
	
!bat_poplog! [RETURN !bat_batchfile!:GETCALFOLDER] ["!bat_calfoldersrc!"]
!bat_log!
!bat_return!



	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
!bat_pushlog! [CALL !bat_batchfile!:REBUILDHEADER] %*

	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_targetdir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	set bat_calfolder=!bat_targetdir!\

	set bat_findstr=!bat_calfoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=CAL folder = !bat_caldir!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"

	set bat_findstr_c=!bat_countsrc!

	set bat_replstr_c=!bat_countdest!

	!bat_logexec! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"

	echo.
	echo.
	echo type "!bat_caseheaderfile!"
	echo.
	for /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"`) do (
		echo     %%~a
	)
	echo.
	echo.
!bat_poplog! [RETURN !bat_batchfile!:REBUILDHEADER] [see output above from the command: type "!bat_caseheaderfile!"]
!bat_log!
%bat_return%




:CONCATFINAL
!bat_echolog! [CALL !bat_batchfile!:CONCATFINAL] [!bat_caseheaderfile!, !bat_string!, !bat_targetfilefull!]
	!bat_logexec! copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"

	if defined bat_caseheaderfile (
		!bat_logexec! del "!bat_caseheaderfile!"
	) else (
		!bat_echolog! ERROR [!bat_batchfile!:CONCATFINAL] Dangerous command: del "!bat_caseheaderfile!"
	)
rem
	!bat_echolog!
	if not exist "!bat_targetfilefull!" (
:CONCATPROMPT
		!bat_echolog! Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		!bat_echolog! file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		!bat_echolog! the following command:
		!bat_echolog! .    %~0 %*
		set bat_choice=
		!bat_log! set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE
:CONCATFINAL_END
!bat_poplog! [RETURN !bat_batchfile!:CONCATFINAL] ["!bat_targetfilefull!"]
!bat_log!
%bat_return%




		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"

		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_pushlog! [CALL !bat_batchfile!:FIXDETECTPATHS] [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)
	
	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	set bat_calfolder=!bat_targetdir!\Cal

	rem convert bat_fffoldersrc to C-style string
	set bat_fffoldersrc_c=!bat_fffoldersrc:\=\\!
	set bat_fffoldersrc_c=!bat_fffoldersrc_c::=\:!
	
	set bat_fffolderdest=!bat_targetdir!\ArchivedFiles\
	set bat_fffolderdest_c=!bat_fffolderdest:\=\\!
	set bat_fffolderdest_c=!bat_fffolderdest_c::=\\!

	!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"


	!bat_logexec! call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!

	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_poplog! [RETURN !bat_batchfile!:FIXDETECTPATHS] [!bat_recent_error_msg!]
!bat_log!
!bat_return!


:COPYPARAMFILES
!bat_pushlog! [CALL !bat_batchfile!:COPYPARAMFILES] %*
	!bat_logexec! copy /y "!bat_exedir!\CoincidenceParameters.txt" "!bat_exedir!\versionHistory"

	!bat_logexec! copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!"

	!bat_logexec! copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!\Cal"

	!bat_logexec! copy /y "!bat_exedir!\CameraTimeOffsets.txt" "!bat_targetdir!"

	!bat_logexec! copy /y "!bat_caldir!\w902*.txt" "!bat_targetdir!"

	!bat_logexec! copy /y "!bat_caldir!\CameratimeOffsets.txt" "!bat_targetdir!"

!bat_poplog! [RETURN !bat_batchfile!:COPYPARAMFILES] []
!bat_log!
!bat_return!






:COINCIDENCE
!bat_pushlog! [CALL !bat_batchfile!:COINCIDENCE] %*
	!bat_echolog! '    call "!bat_exedir!\versionHistory\FTP_Coincidence.exe" "!bat_targetfilefull!"
	                   call "!bat_exedir!\versionHistory\FTP_Coincidence.exe" "!bat_targetfilefull!"

!bat_poplog! [RETURN !bat_batchfile!:COINCIDENCE] []
!bat_log!
!bat_return!

























































:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF_??????_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF_??????_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~3,6!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! [CALL !bat_batchfile!:GETMETEORCOUNTARCHIVED] %*
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
           
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				set bat_latestcal=
				set /a bat_archivedmeteorcount=0
				
				goto :GETMETEORCOUNTARCHIVED_END
			)
		)
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! [RETURN !bat_batchfile!:GETMETEORCOUNTARCHIVED] [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%




:GETCONFIRMEDCOUNT
!bat_PUSHlog! [CALL !bat_batchfile!:GETCONFIRMEDCOUNT] %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
				goto :GETCONFIRMEDCOUNT_END
			)
		)
	)


	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_POPlog! [RETURN !bat_batchfile!:GETCONFIRMEDCOUNT] [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, !bat_confirmdetect!]
!BAT_POP!
%bat_return%




:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_PUSHlog! [CALL !bat_batchfile!:GETFILECOUNT] "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_POPlog! [RETURN !bat_batchfile!:GETFILECOUNT] [%~1=!%1!]
!BAT_LOG!
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF_??????_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~3,6!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%






:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%







:VARIABLES
	set bat_
	pause
%return%


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_PUSHlog! [CALL !bat_batchfile!:FIXDETECTPATHS] [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)

	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!
	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_POPlog! [RETURN !bat_batchfile!:FIXDETECTPATHS] [!bat_recent_error_msg!]
!BAT_LOG!
!bat_return!



:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!






:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo. Usage: %~nx0 "<date>" 
	echo.
	echo. Example: 
	echo.    MergeDetect.bat "2012_01_31" "C:\CAMS\data\2012_01_31" "FTPdetectinfo_0*.txt" "2013_01_31"
	echo.
	echo. - Strips the header section from each detect file matching the 
	echo.   bat_sourcefilespec setting in the MergeDetectFiles.ini file [typically it is 
	echo.   something like: FTPdetectinfo_0*.txt]. 
	echo. - Then it combines the remaining data into a single detect file, 
	echo.   "FTPdetectinfoCoinc.txt", that can be used during coicidence processing 
	echo.   with a new header. 
	echo.
	echo. All this is accomplished by calling MergeDetectFiles.bat using the following
	echo. syntax:
	echo.   MergeDetectFiles.bat "C:\CAMS\data\<date>" [["C:\CAMS\data\<date>\Merged" "FTPdetectinfo_0*.txt" "<date>"]]
	echo.
	echo.     bat_sourcedate=%~1
	echo.     bat_temp_yyyy=!bat_sourcedate:~0,4!
	echo.     bat_temp_mm=!bat_sourcedate:~5,2!
	echo.     bat_temp_dd=!bat_sourcedate:~8,2!
	echo.     bat_captureddate=!bat_temp_yyyy!_!bat_temp_mm!_!bat_temp_dd!
	echo.
	echo.
	echo. The MergeDetectFiles.ini file can be used to configure some of the settings, such as the 
	echo. Cal directory. 
	echo.
	echo.Use the "MergeDetectFiles.ini" file to configure the following settings:
	echo.   bat_caldir=C:\CAMS\temp\coincidence
	echo.   bat_1sourcedir=C:\CAMS\temp\coincidence
	echo.   bat_2targetdir=\Merged
	echo.   bat_3sourcefilespec=FTPdetectinfo_0*.txt
	echo.   bat_date_sep=_
	echo.
	echo. Where:
	echo.   bat_caldir           is the directory where to expect the CAL files.  I think
	echo.                        we should probably just use the source directory. 
	echo.   bat_1sourcedir       is the prefix path for the source directory.  It is used
	echo.                        when dynamically determining the source dir by 
	echo.                        appending the provided date to it:
	echo.                          e.g. source dir = "C:\CAMS\temp\coincidence\2013_01_31"
	echo.   bat_2targetdir       Is the temporary working directory [typically "\Merged"] to append
	echo.                        to the source dir.  This is used when stripping the headers
	echo.                        and other stuff.  This directory is temporary and it is 
	echo.                        removed before the script ends. 
	echo.   bat_3sourcefilespec  Filespec to use when searching for the detect files in the 
	echo.                        source dir.  The filespec should result in ONLY those detect
	echo.                        files that should be included in this coincidence session.
	echo.   bat_date_sep         The date separation character used when specifying the source
	echo.                        date in the command-line.  NASA uses "-".  AutoCams uses "_". 
	echo.

exit /b 99

Needs:
	- 
	
:ABORT
	!bat_echolog! '    ABORTING
	!bat_echolog! '    bat_returncode=!bat_returncode!
	pause
exit /b !bat_returncode!

:DONE
	rem call :SAVECONFIG
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! Done with %0 %*
	!bat_log!
exit /b !bat_returncode!
