@echo off
setlocal enableextensions enabledelayedexpansion

	REM ########################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM ########################################################
:SETUP
	if "%~1" equ "" goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
		rem Get the bat_capturedfilesdir value

	set bat_source_cams2_basedir=%~1
	set bat_dest_cams1_basedir=%~2
	set bat_capturesession=%~3
	set bat_first_camera=%~4
	set bat_source_cams2_caldir=%~5

	echo.bat_source_cams2_basedir=!bat_source_cams2_basedir!
	echo.bat_dest_cams1_basedir=!bat_dest_cams1_basedir!
	echo.bat_capturesession=!bat_capturesession!
	echo.bat_first_camera=!bat_first_camera!
	echo.bat_source_cams2_caldir=!bat_source_cams2_caldir!


		REM set the source variables	
		
		REM Set the bat_source_archivedfilesdir variable.  If there isn't a matching
		REM ArchivedFiles dir, then assume that the ArchivedFiles are in the
		REM CapturedFiles dir [Like they are in New Zealand].
	
	if not exist "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!" (
		set bat_source_archivedfilesdir=!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!
	) else (
		set bat_source_archivedfilesdir=!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!
	)
	
		REM set the bat_source_capturedfilesdir variable
	set bat_source_capturedfilesdir=!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!
	
	if not exist "!bat_source_capturedfilesdir!" (
		!bat_echolog!
		!bat_echolog! `    ERROR   Capture directory for Cams2 not found 
		!bat_echolog! `            bat_source_capturedfilesdir="!bat_source_capturedfilesdir!"
		!bat_echolog!
		goto :DONE
	)
	
	if not defined bat_source_cams2_caldir (
		set bat_source_cams2_caldir=!bat_source_cams2_basedir!\Cal
	)
	
		REM set the target variables
		
	set bat_target_caldir=!bat_dest_cams1_basedir!\Cal
	set bat_target_archivedfilesdir=!bat_dest_cams1_basedir!\ArchivedFiles\!bat_capturesession!
	set bat_target_capturedfilesdir=!bat_dest_cams1_basedir!\CapturedFiles\!bat_capturesession!
	
	
		REM Create a batch script to undo this script
	echo."!bat_exedir!\Undo_migrate.bat" "%~1" "%~2" "%~3" "%~4" "%~5"}"!bat_exedir!\Migrate_CamsGUI2_to_AutoCams_undo.bat"
	echo."!bat_exedir!\Undo_migrate.bat" "%~1" "%~2" "%~3" "%~4" "%~5">"!bat_exedir!\Migrate_CamsGUI2_to_AutoCams_undo.bat"
	
	echo."!bat_exedir!\Migrate_CamsGUI2_to_AutoCams.bat" "%~1" "%~2" "%~3" "%~4" "%~5"}"!bat_exedir!\Migrate_CamsGUI2_to_AutoCams_redo.bat"
	echo."!bat_exedir!\Migrate_CamsGUI2_to_AutoCams.bat" "%~1" "%~2" "%~3" "%~4" "%~5">"!bat_exedir!\Migrate_CamsGUI2_to_AutoCams_redo.bat"
	
	
goto :MAIN




	REM ########################################################
	REM Main loop for the programs logic
	
:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	call :MOVE_CAMS2_DIRS


	call :RENAME_ARCHIVED_BIN_FILES


	call :RENAME_CAPTURED_BIN_FILES
	
	CALL :RENAME_DETECT_FILE


	CALL :RENAME_SUBSET_FILES
	


	CALL :ADJUST_DETECT
	

	call :DELETE_PERFORMANCE_FILES
	

	start "autocal_migrate2x_to_1x.bat"   /w cmd /c "!bat_exedir!\autocal_migrate2x_to_1x.bat"


	"!bat_exedir!\AutoCams.bat" 
	
	
goto :DONE





	REM ########################################################
	REM       - Move all the CapturedFiles, ArchivedFiles, and Cal files that pertain to "C:\Cams2_0" 
	REM         SubmissionFiles to the working dirs under "C:\cams16\CAMS"
:MOVE_CAMS2_DIRS
!bat_pushecho! [CALL !bat_batchfile!:MOVE_CAMS2_DIRS] %*



	echo.
	echo.######## ArchivedFiles
	
	if not exist "!bat_dest_cams1_basedir!\ArchivedFiles" (!bat_logexec! MD "!bat_dest_cams1_basedir!\ArchivedFiles")
	if not exist "!bat_dest_cams1_basedir!\CapturedFiles" (!bat_logexec! MD "!bat_dest_cams1_basedir!\CapturedFiles")

	echo.^(call :MOVE "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!" "!bat_dest_cams1_basedir!\ArchivedFiles\!bat_capturesession!"^) ][ ^(set bat_returncode=!errorlevel!$goto :DONE^)
	      (call :MOVE "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!" "!bat_dest_cams1_basedir!\ArchivedFiles\!bat_capturesession!") || (set bat_returncode=!errorlevel!&goto :DONE)

	!bat_echo! ROBOCOPY "!bat_source_cams2_basedir!\ArchivedFiles"   "!bat_dest_cams1_basedir!\ArchivedFiles"  /E /IS /MOVE ][ find /i "*EXTRA Dir"
	           ROBOCOPY "!bat_source_cams2_basedir!\ArchivedFiles"   "!bat_dest_cams1_basedir!\ArchivedFiles"  /E /IS /MOVE |  find /i "*EXTRA Dir"

	echo.
	!bat_logexec! tree "!bat_dest_cams1_basedir!\ArchivedFiles" /a
	echo.




	echo.
	echo.######## CapturedFiles
	!bat_logexec! MD "!bat_dest_cams1_basedir!\CapturedFiles"
	
	echo.(call :MOVE "!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!" "!bat_dest_cams1_basedir!\CapturedFiles\!bat_capturesession!") ][ (goto :DONE)
	     (call :MOVE "!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!" "!bat_dest_cams1_basedir!\CapturedFiles\!bat_capturesession!") || (goto :DONE)

	!bat_echo! ROBOCOPY "!bat_source_cams2_basedir!\CapturedFiles"   "!bat_dest_cams1_basedir!\CapturedFiles"  /E /IS /MOVE ][ find /i "*EXTRA Dir"
	           ROBOCOPY "!bat_source_cams2_basedir!\CapturedFiles"   "!bat_dest_cams1_basedir!\CapturedFiles"  /E /IS /MOVE |  find /i "*EXTRA Dir"

	echo.
	!bat_logexec! tree "!bat_dest_cams1_basedir!\CapturedFiles" /a
	echo.




	echo.
	echo.######## FTP and Logs
	!bat_logexec! MD "!bat_dest_cams1_basedir!\Cams2"
	
	!bat_echo! ROBOCOPY "!bat_source_cams2_basedir!\FTP"   "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP"  /E /IS /MOVE ][ find /i "*EXTRA Dir"
	           ROBOCOPY "!bat_source_cams2_basedir!\FTP"   "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP"  /E /IS /MOVE |  find /i "*EXTRA Dir"
	

	!bat_echo! ROBOCOPY "!bat_source_cams2_basedir!\Logs"   "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\Logs"  /E /IS /MOVE ][ find /i "*EXTRA Dir"
	           ROBOCOPY "!bat_source_cams2_basedir!\Logs"   "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\Logs"  /E /IS /MOVE |  find /i "*EXTRA Dir"
	
	
	(!bat_logexec! XCOPY /s/e/c/f/r/g/h/i/y "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP\CAL_000???_*.txt"   "!bat_target_caldir!") || (
		!bat_echo! 
		!bat_echo! ` ERROR - failed to copy files
		!bat_echo! `         XCOPY /s/e/c/f/r/g/h/i "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP\CAL_000???_*.txt"   "!bat_target_caldir!"
		!bat_echo!
		goto :DONE)

	(!bat_logexec! XCOPY /s/e/c/f/r/g/h/i/y "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP\FF_000???_*.bin"   "!bat_target_caldir!\BinFiles") || (
		!bat_echo! 
		!bat_echo! ` ERROR - failed to copy files
		!bat_echo! `         XCOPY /s/e/c/f/r/g/h/i "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP\CAL_000???_*.txt"   "!bat_target_caldir!"
		!bat_echo!
		goto :DONE)
		
	!bat_logexec! RD /Q "!bat_source_cams2_basedir!"



:MOVE_CAMS2_DIRS_END
!bat_popecho! [RETURN !bat_batchfile!:MOVE_CAMS2_DIRS] []
!bat_log!
!bat_return!



	REM ########################################################
	REM       - Rename all the "FF_000???_*.bin" files in the Captured dir to "FF???_*.bin"
:RENAME_CAPTURED_BIN_FILES
!bat_pushecho! [CALL !bat_batchfile!:RENAME_CAPTURED_BIN_FILES] %*

	call :RENAME_FF_FILES "!bat_target_capturedfilesdir!"


:RENAME_CAPTURED_BIN_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:RENAME_CAPTURED_BIN_FILES] []
!bat_log!
!bat_return!
	

	
	
	
	REM ########################################################
	REM       - Rename all the "FF_000???_*.bin" files in the Archived dir to "FF???_*.bin"
:RENAME_ARCHIVED_BIN_FILES
!bat_pushecho! [CALL !bat_batchfile!:RENAME_ARCHIVED_BIN_FILES] %*

	call :RENAME_FF_FILES "!bat_target_archivedfilesdir!"


:RENAME_ARCHIVED_BIN_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:RENAME_ARCHIVED_BIN_FILES] []
!bat_log!
!bat_return!
	
	
	
	
	
	
	REM ########################################################
	REM       - Rename the detect file from "FTPdetectinfo_000^<first camera^>???000^<last camera^>_*.txt" 
	REM         to "FTPdetectinfo_^0<first camera^>_*.txt"
:RENAME_DETECT_FILE
!bat_pushecho! [CALL !bat_batchfile!:RENAME_DETECT_FILE] %*


	if exist "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!_*.txt" (
		!bat_echo! 1. exist "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!_*.txt"
		for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!_*.txt"`) do (
			!bat_logexec! set bat_target_detectfilename=!bat_target_archivedfilesdir!\%%a
			goto :RENAME_DETECT_FILE_END
		)
	)
	
	if exist "!bat_target_archivedfilesdir!\FTPdetectinfo_000???_*.txt" (
		!bat_echo! 2. exist "!bat_target_archivedfilesdir!\FTPdetectinfo_000???_*.txt"
		for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_archivedfilesdir!\FTPdetectinfo_000???_*.txt"`) do (
			!bat_logexec! set bat_tempfile_orig=!bat_target_archivedfilesdir!\%%a
			!bat_logexec! set bat_tempfile=FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!.txt
			!bat_logexec! set bat_target_detectfilename=!bat_target_archivedfilesdir!\!bat_tempfile!
			goto :RENAME_DETECT_FILE_2
		)
	)
	
	if exist "!bat_target_archivedfilesdir!\FTPdetectinfo_000???*.txt" (
		!bat_echo! 3. exist "!bat_target_archivedfilesdir!\FTPdetectinfo_000???*.txt"
		for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_archivedfilesdir!\FTPdetectinfo_000???*.txt"`) do (
			!bat_logexec! set bat_tempfile_orig=!bat_target_archivedfilesdir!\%%a
			!bat_logexec! set bat_tempfile=FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!.txt
			!bat_logexec! set bat_target_detectfilename=!bat_target_archivedfilesdir!\!bat_tempfile!
			goto :RENAME_DETECT_FILE_2
		)
	)

:RENAME_DETECT_FILE_2
!bat_echo! [CALL !bat_batchfile!:RENAME_DETECT_FILE_2]

		REM Rename the original detect file with the "zzz" prefix so that it can be 
		REM easily undone. 
	!bat_CALLecho! "!bat_exedir!\ParseDir.bat" "!bat_tempfile_orig!"
	!bat_logexec! set bat_retval
	!bat_TITLE!
	
	!bat_logexec! COPY /y   "!bat_tempfile_orig!"  "!bat_RetVal1!\zzz!bat_RetVal2!"

	!bat_logexec! MOVE /y   "!bat_tempfile_orig!"  "!bat_target_detectfilename!"

	
:RENAME_DETECT_FILE_END 
!bat_popecho! [RETURN !bat_batchfile!:RENAME_DETECT_FILE] [bat_target_detectfilename=!bat_target_detectfilename!]
!bat_log!
!bat_return!


	
	
	REM ########################################################
	REM  Rename the temporary detection thread files
	REM  This routine renames the files names like this: FTPdetectinfo_800001_Subset.txt, FTPdetectinfo_800002_Subset.txt, etc.
	REM  to xxxFTPdetectinfo_800001_Subset.txt, xxxFTPdetectinfo_800002_Subset.txt, etc.
:RENAME_SUBSET_FILES
!bat_pushecho! [CALL !bat_batchfile!:RENAME_SUBSET_FILES] %*

	set bat_temp=NO SUBSET FILES FOUND
	!bat_echo! dir /b /a-d "!bat_target_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt"

	for /f "usebackq tokens=*" %%a in (`dir /on /b /a-d "!bat_target_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt"`) do (
		set bat_temp=!bat_target_archivedfilesdir!\xxx%%a
		!bat_logexec! MOVE /y "!bat_target_archivedfilesdir!\%%a"  "!bat_temp!"
	)
	
:RENAME_SUBSET_FILES_END 
!bat_popecho! [RETURN !bat_batchfile!:RENAME_SUBSET_FILES] [Last Subset File:"!bat_temp!"]
!bat_log!
!bat_return!

	
	
	
	
	

	REM ########################################################
	REM      MODIFY THE DETECT FILE
:ADJUST_DETECT
!bat_pushecho! [CALL !bat_batchfile!:ADJUST_DETECT] [%*] [bat_target_detectfilename="!bat_detectfilename!"]

	REM    Replace "FF  folder" with "FX  folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FF  folder" "FX  folder"
	
	REM    Replace "CAL folder" with "CXL folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CAL folder" "CXL folder"
	
	REM    Replace "FF  file processed" with "FX  file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FF  file processed" "FX  file processed"
	
	REM    Replace "CAL file processed" with "CXL file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CAL file processed" "CXL file processed"
	



	REM         - Replace all instances of "FF_000" with "FF"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FF_000" "FF"
	set bat_returncode=!errorlevel!

	REM         - Replace all instances of "CAL_000" with "CAL"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CAL_000" "CAL"
	set bat_returncode=!bat_returncode!!errorlevel!
	
	REM         - Adjust the "FF  folder" path to match where the file is sitting
	REM         - Adjust the "CAL folder" path to match where the 1.x Cal files are
	!bat_logexec! "!bat_exedir!\FixDetectPaths.bat" "!bat_target_archivedfilesdir!"
	set bat_returncode=!bat_returncode!!errorlevel!



	REM    Replace "FF  folder" with "FX  folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FX  folder" "FF  folder"
	
	REM    Replace "CAL folder" with "CXL folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CXL folder" "CAL folder"
	
	REM    Replace "FF  file processed" with "FX  file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FX  file processed" "FF  file processed"
	
	REM    Replace "CAL file processed" with "CXL file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CXL file processed" "CAL file processed"
	




:ADJUST_DETECT_END
!bat_popecho! [RETURN !bat_batchfile!:ADJUST_DETECT] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!

	


	REM ########################################################
:DELETE_PERFORMANCE_FILES
!bat_pushecho! [CALL !bat_batchfile!:DELETE_PERFORMANCE_FILES] %*
	
	REM Delete target performance files [like GCFC, etc.]
	REM       - Delete the Cams2 "CapturedFiles\GCFC.log" file
	!bat_logexec! MOVE /Y "!bat_target_capturedfilesdir!\GCFC.log" "!bat_target_capturedfilesdir!\xxxGCFC.log" 
	
	REM       - Delete the Cams2 "CapturedFiles\"GetFirstLastFF_filenames.txt" 
	!bat_logexec! MOVE /Y "!bat_target_capturedfilesdir!\GetFirstLastFF_filenames.txt"  "!bat_target_capturedfilesdir!\xxxGetFirstLastFF_filenames.txt" 

	!bat_logexec! MOVE /Y "!bat_target_archivedfilesdir!\CalFileList.log" "!bat_target_archivedfilesdir!\xxxCalFileList.log"
	
	!bat_logexec! MOVE /Y "!bat_target_archivedfilesdir!\SortDetect_CameraList.txt" "!bat_target_archivedfilesdir!\xxxSortDetect_CameraList.txt"
	!bat_logexec! MOVE /Y "!bat_target_archivedfilesdir!\SortDetect_Sorted.log" "!bat_target_archivedfilesdir!\xxxSortDetect_Sorted.log"


:DELETE_PERFORMANCE_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:DELETE_PERFORMANCE_FILES] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!







	REM ########################################################
:RENAME_FF_FILES [dir]
!bat_pushecho! [CALL !bat_batchfile!:RENAME_FF_FILES] %*
REM					where: dir is the directory contianing FF files to be renamed

	!bat_echo!
	!bat_echo!
	!bat_echo! This could take a long time.  It's renaming all the FF*.bin files in the 
	!bat_echo! "%~1" directory...
	dir /a-d "%~1\FF_000???_*.bin">nul:|find /i "File(s)"
	!bat_echo!
	!bat_echo! Please wait...
	!bat_echo!

	for /f "usebackq tokens=*" %%a in (`dir /s/b /a-d "%~1\FF_000???_*.bin"`) do (
		
			rem path\file
		set bat_temp=%%a
		
			rem path
		set bat_tempdir=%%~dpa::
		set bat_tempdir=!bat_tempdir:\::=!
		set bat_tempdir=!bat_tempdir:::=!
		
		set bat_tempfile=%%~nxa
		set bat_tempcamera=!bat_tempfile:~6,3!
		set bat_tempfile_new=FF!bat_tempcamera!_!bat_tempfile:~-31!
		
		!bat_echo! MOVE /Y   "!bat_temp!"   "%~1\!bat_tempfile_new!"
		           MOVE /Y   "!bat_temp!"   "%~1\!bat_tempfile_new!">nul:
		set bat_retval=!errorlevel!
	)
	
:RENAME_FF_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:RENAME_FF_FILES] ["%~1"]
!bat_log!
!bat_return! !bat_retval!



	REM ########################################################
	REM This routine moves the specified file or dir and then checks to
	REM see if it is still in the source location.  If it is, the move 
	REM failed. 
:MOVE [source dir or file]   [target]

dir "%~1"|find /i "File(s)"

	(!bat_logexec! MOVE /Y "%~1"   "%~2") || (
		!bat_echo!
		!bat_echo! ` ERROR - The MOVE command failed by returning a non-zero errorlevel [!bat_logexec_returncode!]. 
		!bat_echo! `   MOVE /Y  "%~1"   "%~2"
		!bat_echo!
		set bat_retval=1
		goto :MOVE_END
	) && (
		(!bat_logexec! dir /ad "%~1">nul: 2>&1) || (
rem					set bat_retval=2
rem					goto :ERROR "%~1"
		)
	)
	
	
	
	

:MOVE_END
!bat_popecho! [RETURN !bat_batchfile!:MOVE] ["%~1", "%~2"]
!bat_log!
!bat_return! !bat_retval!




	REM ########################################################
:ERROR_MOVE [dir]
	!bat_echo!
	!bat_echo! ` ERROR - MOVE Failed - The following file or dir was supposed to be moved but it still exists after the command.
	!bat_echo! `    "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!"
	!bat_echo!
:ERROR_END
!bat_return! !bat_retval!








	REM #############################################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<source_cams2^>"  "^<destination_cams1^>"  "^<capture session^>"  "^<first camera^>" ["^<cams2 cal dir^>"]
	echo.
	echo.Converts the specified Cams2 capture session from the Cams2 source into 
	echo.Cams1 compatibility and places the results into the working dirs specified.
	echo.
	echo.Where:
	echo.
	echo.   source_cams2              The "source_cams2" directory is a base directory that contains 
	echo.                             the Cams2 CapturedFiles, ArchivedFiles, and Cal directories. 
	echo.                             If you are migrating a Cams2 capture session that is in the 
	echo.                             SubmissionFiles state, then it migrates the CapturedFiles, 
	echo.                             ArchivedFiles, and Cal files from that base directory to the 
	echo.                             corresponding Cams 1 working dirs specified in the 
	echo.                             "destination_cams1" argument. 
	echo.   destination_cams1         This argument specifies the base dir of the target Cams1 
	echo.                             working dirs. 
	echo.   capture session           This is the date and time of the start of the capture session.
	echo.   first camera              First camera for this capture session
	echo.   cams2 cal dir             Option - Cams2 Cal dir.  Useful for SubmissionFiles and other
	echo.                             kinds of Cams2 source where the Cal directory isn't directly
	echo.                             under the base dir.
	echo.
	echo.Note: When the "source_cams2" argument is going to refer to a Cams2 SubmissionFiles session, 
	echo.      then you must specify the path to the base dir of the SubmissionFiles session that houses the 
	echo.      CapturedFiles, ArchivedFiles, and Cal dirs.  
	echo.
	echo.      When the "source_cams2" argument is going to refer to a Cams2 working dirs session, 
	echo.      Then you must specify the path to the base of the Cams2 directory (example "C:\Cams2_0\CAMS").
	echo.
	echo.Examples:
	echo.    call "%~0"   "C:\Cams2_0\CAMS\SubmissionFiles\2017_09_17_000250_02_46_10\000250"  "C:\cams16\CAMS" "2017_09_17_02_46_10" "C:\Cams2_0\CAMS\Cal"
	echo.     -or-
	echo.    call "%~0"   "C:\Cams2_0\CAMS\"  "C:\cams16\CAMS"
	echo.     -or-
	echo.    call "%~0"   "C:\Cams2_0\CAMS\
	echo.
	echo.    Does the following:
	echo.      - Moves all the CapturedFiles, ArchivedFiles, and Cal files that pertain to "C:\Cams2_0" 
	echo.        SubmissionFiles to the working dirs under "C:\cams16\CAMS"
	echo.      - Renames all the "FF_000???_*.bin" files in the Archived dir to "FF???_*.bin"
	echo.      - Renames the detect file from "FTPdetectinfo_000^<first camera^>???000^<last camera^>_*.txt" 
	echo.        to "FTPdetectinfo_^<first camera^>_*.txt"
	echo.      - Adjusts the detect file as follows:
	echo.        - Adjusts the "FF  folder" path to match where the file is sitting
	echo.        - Adjusts the "CAL folder" path to match where the 1.x Cal files are
	echo.        - Replaces all instances of "FF_000" with "FF"
	echo.        - Replaces all instances of "CAL_000" with "CAL"
	echo.      - Deletes the Cams2 "CapturedFiles\GCFC.log" file
	echo.      - Deletes the Cams2 "CapturedFiles\"GetFirstLastFF_filenames.txt" 
	echo.      - Renames all the "FF_000???_*.bin" files in the Archived dir to "FF???_*.bin"
	echo.      - Converts all 2.x cal files to 1.x by calling "autocal_migrate2x_to_1x.bat"
	echo.
	echo.Example 2:
	echo.    call "%~0"   "C:\Cams2_0\CAMS\SubmissionFiles\2017_09_17_000250_02_46_10\000250"  "C:\cams16\CAMS"
	echo.
	echo.
	echo.
	echo.
exit /b 99



	REM ########################################################
:DONE
!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog! [DONE !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
!bat_echolog!
exit /b !bat_returncode!

