  @echo off
setlocal enabledelayedexpansion enableextensions


	REM ######################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

goto :SETUP



	
	REM ######################################################
:SETUP

		rem set bat_logdir= blanks out the bat_logdir variable, triggering it to be
		rem use "..\Logs".  
	set bat_logdir=
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	if not defined bat_calftppassword (
		set bat_calftppassword=.
	)
	
rem	!bat_CALL! "!bat_exedir!\ReadConfig.bat"

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	
		REM Get bat_DriveLetter and the ftp connection parameters
	!bat_CALL! "!bat_exedir!\ReadRemoteConfig.bat"	

	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! `     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_returncode=0

	
	call :PARSEARGS %*

	goto :MAIN
	
:SETUP_END




	REM ######################################################
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] [%*]

	!bat_logexeclog! set bat_retval=failed

		rem Handle the case where the FTP file has already been downloaded. 
		rem No sense in downloaded over the top of an existing file.  
		rem So, we need to list all the existing zip files on the server (in 
		rem ascending date order), check each against whether it exists locally, 
		rem then download the remaining ones.

	call :FTPTRANSFER

		REM Run the archive script in the background. 
	!bat_echolog! start /wait "archive_allbut_n_sessions.bat" /low /min "cmd.exe" /c "!bat_cams_root!\archive_allbut_n_sessions.bat"
	              start /wait "archive_allbut_n_sessions.bat" /low /min "cmd.exe" /c "!bat_cams_root!\archive_allbut_n_sessions.bat"

:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3  :MAIN_END

goto :DONE






	
	REM ######################################################################
	REM bat_targetdir            The directory where the client downloads should be 
	REM                          downloaded to.
	REM 
	REM bat_workdir              The base directory where any temporary work needs 
	REM                          to be done. 
	REM 
	REM bat_ftpfile              is used as the temp file to hold the command listing 
	REM                          for ftp commands that use: 
	REM                             call FTP -n -s:"!bat_ftpfile!" !bat_calftpsite! 
	REM 
	REM bat_ftp_tempdir          is used as the !bat_exedir!\Temp. This is the base dir
	REM                          to download the file to.  It is copied later to:
	REM                          !bat_exedir!\Temp\Zip and then it is unzipped from
	REM                          there to check to see if the zip file unzips ok.
	REM 
	REM bat_ftpfile2             ftp.temp_2.txt  
	REM                          List of all the files to check for that exist on the
	REM                          server.  This file will be parsed for specific
	REM                          filespec filters.
	REM 
	REM bat_ftp_tempfile3        ftp.temp_3.txt
	REM 
	REM bat_ftp_tempfile5        ftp.temp_queue.txt
	REM 
	REM bat_ftp_tempResults2     ftp.tempResults_2.txt
	REM 
	REM bat_zipfile              CALSTARS????_*.zip
	REM 
	REM bat_zipresultsfile       CALSTARS????_????_??_??_??_??_??_??_Results.zip
	REM 
	REM bat_zipmd5file           CALSTARS????_????_??_??_??_??_??_??_Results.txt
	REM 
	REM bat_zip                  CALSTARS????_*.zip
	REM 
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	echo.%*|find /i "autonomous"
	if !errorlevel! equ 0 (
		!bat_logexeclog!set bat_autonomous=autonomous
	)

	REM This section parses the command line argument switches
:PARSEARGS_LOOP
rem !bat_log! :PARSEARGS_LOOP [%1] [%2]

	if /i "%~1" equ "" goto :PARSEARGS_LOOPBREAK
	

	if /i "%~1" equ "/targetdir" (
		!bat_logexeclog! set bat_targetdir=%~2

		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	if /i "%~1" equ "/workdir" (
		!bat_logexeclog! set bat_workdir=%~2

		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
	
	if /i "%~1" equ "/exclude" (
		!bat_logexeclog! set bat_excludespec=%~2

		shift
		shift
		goto :PARSEARGS_LOOP

	)
	
:PARSEARGS_LOOPBREAK
!bat_log!
!bat_log! [GOTO !bat_batchfile!:PARSEARGS_LOOPBREAK] %*
!bat_log!

	pushd ..\..
	!bat_logexeclog! set bat_cams_root=!CD!
	popd

	!bat_logexeclog! set bat_ftp_tempdir=!bat_targetdir!
	!bat_logexeclog! set bat_ftp_dest_dir=!bat_targetdir!
	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	!bat_logexeclog! set bat_ftpfile2=!bat_exedir!\ftp.temp_2.txt
	!bat_logexeclog! set bat_ftp_tempfile5=!bat_cams_root!\ftp.temp_queue.txt
	!bat_logexeclog! set bat_ftp_tempResults2=!bat_exedir!\ftp.tempResults_2.txt
	!bat_logexeclog! set bat_ftp_tempfile3=!bat_exedir!\ftp.temp_3.txt
	
	
	
	set bat_caldir=!bat_exedir!\Cal
rem	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

	!bat_logexeclog! set bat_autocal_remote_queue_dir=!bat_cams_root!\AutoCal_Remote_Queue
	!bat_logexeclog! set bat_autocal_remote_queue=!bat_autocal_remote_queue_dir!\AutoCal_Remote_Queue.txt



		rem CALSTARS0758_2016_01_29_14_36_20_02
		rem The _Results.zip file will contain the resulting cal files, detect file, and autocalupdate.log file.
		rem The _Results.txt file will contain the first line being the md5 hash of the zip file. The remaining lines will contain error text if any occured and autocal failed.
		rem                  This md5 hash will be used on the client side to check the md5 hash of the downloaded file to verify that the zip file was downloaded ok before trying
		rem                  to unzip the zip file.
	!bat_logexeclog!        set bat_zipfile=CALSTARS????_*.zip
	!bat_logexeclog! set bat_zipresultsfile=CALSTARS????_????_??_??_??_??_??_??_Results.zip
	!bat_logexeclog!     set bat_zipmd5file=CALSTARS????_????_??_??_??_??_??_??_Results.txt
	!bat_logexeclog! set bat_zip=!bat_zipfile!


:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [
!bat_log! `                                      bat_ftp_dest_dir=!bat_ftp_dest_dir!
!bat_log! `                                      bat_ftp_tempdir=!bat_ftp_tempdir!
!bat_log! `                                      bat_ftpfile=!bat_ftpfile!
!bat_log! `                                      bat_ftpfile2=!bat_ftpfile2!
!bat_log! `                                      bat_ftp_tempfile5=!bat_ftp_tempfile5!
!bat_log! `                                      bat_ftp_tempResults2=!bat_ftp_tempResults2!
!bat_log! `                                      bat_ftp_tempfile3=!bat_ftp_tempfile3!
!bat_log! `                                      bat_zipfile=!bat_zipfile!
!bat_log! `                                      bat_zipresultsfile=!bat_zipresultsfile!
!bat_log! `                                      bat_zipmd5file=!bat_zipmd5file!
!bat_log! `                                      bat_zip=!bat_zip!
!bat_log! `                                      bat_autonomous=!bat_autonomous!
!bat_log! `                                      bat_targetdir=!bat_targetdir!
!bat_log! `                                      bat_workdir=!bat_workdir!
!bat_log! `                                      bat_excludespec=!bat_excludespec!]
!bat_log!
!bat_WAIT! 1	:PARSEARGS_END
!bat_return!  !bat_returncode!









	REM ######################################################
	REM Check for existing files on the server and download only those
	REM that don't match file names locally. 
	REM 
	REM RETURNS:
	REM     bat_ftpfile2                
	REM     bat_ftp_tempfile5          ftp.temp_queue.txt - _Results suffix as determined by
	REM                                entries that still exist in the queue. 
	REM     bat_capturedzipfile        c:\CAMS\CapturedFiles\2016_12_31_14_37_59\CALSTARS0750_2016_12_31_14_37_59_01_Results.zip
	REM     bat_capturedfilesdir       C:\CAMS\CapturedFiles\2016_12_31_14_37_59
	REM     bat_tempzipfile            C:\CAMS\Temp\TempCal\CALSTARS0750_2016_12_31_14_37_59_01_Results.zip
	REM     bat_tempzipname            CALSTARS0750_2016_12_31_14_37_59_01_Results.zip
	REM     bat_zipmd5file             CALSTARS0750_2016_12_31_14_37_59_01_md5.txt
	REM     bat_downloadedflagfile     CALSTARS0750_2016_12_31_14_37_59_01_downloaded.txt
	REM     bat_captureddatetime
	REM     bat_captureddate
	REM     bat_capturedtime
	REM     bat_sequence
	REM     bat_camera
	REM     
:FTPTRANSFER
!bat_pushlog! [CALL !bat_batchfile!:FTPTRANSFER] [%*]

	!bat_logexeclog! set bat_retval=failed

		rem The downloaded files go to this dir.
	if not exist "!bat_ftp_tempdir!" (
		!bat_logexeclog! MD "!bat_ftp_tempdir!"
	)

	if exist "!bat_ftp_tempfile5!" (
		!bat_logexeclog! DEL /q "!bat_ftp_tempfile5!"
	)
		
	if exist "!bat_ftp_tempResults2!" (
		!bat_logexeclog! DEL /q "!bat_ftp_tempResults2!"
	)
		REM Create the ftp command file for listing the existing
		REM files that match the spec.
	if exist "!bat_ftpfile2!" (
		 if defined bat_ftpfile2 (
			!bat_logexeclog! DEL /q "!bat_ftpfile2!"
		 ) else (
		 	!bat_echolog! ERROR [!bat_batchfile!:FTPTRANSFER] Dangerous command: del /q "!bat_ftpfile2!"
		 )
	)
	
	CALL :GET_SERVER_FILE_LIST


			REM making downloadlist from queue
	CALL :GET_QUEUE_ITEMS
	

		REM making downloadlist from queue
	CALL :FILTER_LIST

	!bat_popecho!
		
!bat_log! ...Done downloading all the files...

goto :FTPTRANSFER_END	




:FTPTRANSFER_END
!bat_popecho! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
rem !bat_WAIT! 1	:FTPTRANSFER_END
!bat_return! !bat_returncode!






	REM ######################################################################
	REM
:GET_SERVER_FILE_LIST
!bat_pushlog! [CALL !bat_batchfile!:GET_SERVER_FILE_LIST] [%1, %2, %3]


	!bat_logexeclog! set bat_ftpfile2
	!bat_echolog!

	!bat_echolog! Now download a list of files using the "ls" ftp command file "!bat_ftpfile!"...
	!bat_pushecho!
		!bat_log! `    Note: Building the "..\ftp.temp.txt" file...

			REM Get a list of all CALSTARS0*.*	files into "ftp.temp_2.txt"
		echo.user !bat_calftpuser!>"!bat_ftpfile!"
		echo.!bat_calftppassword!>>"!bat_ftpfile!"
		echo.bin>>"!bat_ftpfile!"
		echo.cd !bat_calftpdir!>>"!bat_ftpfile!"
		echo.literal pasv>>"!bat_ftpfile!"
		echo.lcd "!bat_ftp_tempdir!">>!bat_ftpfile!"
		echo.literal pasv>>"!bat_ftpfile!"
		echo.ls "CALSTARS0*.*">>!bat_ftpfile!"
		echo.quit>>"!bat_ftpfile!"

		!bat_logexec! TYPE "!bat_ftpfile!"

		!bat_echolog!
		!bat_echolog! Fetching a complete list of all files that we need to interrogate into bat_ftpfile2 ["..\ftp.temp_2.txt"]...
		!bat_echolog!
		!bat_echolog! FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"][FINDSTR /r /i "^calstars0..._.*\..*"}"!bat_ftpfile2!"
				      FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"| FINDSTR /r /i "^calstars0..._.*\..*">"!bat_ftpfile2!"
			REM FTP doesn't produce an errorlevel like it should so don't bother checking it.
		!bat_echolog!

		!bat_logexec! TYPE "!bat_ftpfile2!"
		set bat_returncode=!errorlevel!

:GET_SERVER_FILE_LIST_END
!bat_poplog! [RETURN !bat_batchfile!:GET_SERVER_FILE_LIST] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:GET_SERVER_FILE_LIST_END
!bat_return! !bat_returncode!



	REM ######################################################################
	REM
:GET_QUEUE_ITEMS
!bat_pushlog! [CALL !bat_batchfile!:GET_QUEUE_ITEMS] [%1, %2, %3]

			REM making downloadlist from queue

			REM If ftp.temp_queue.txt already exists, delete it...
		if exist "!bat_ftp_tempfile5!" (
			!bat_logexeclog! DEL /q "!bat_ftp_tempfile5!"
		)

			REM The first field in the queue is the original zip file [without the _Results suffix] 
			REM and save all the queue entries into a "ftp.temp_queue.txt" file.  That file 
			REM contains the name of all the "*_Results.zip" files to search for. 
			REM 
		!bat_pushlog! for /f "usebackq tokens=1* delims=," ..A in ^("!bat_autocal_remote_queue!"^) do ^(
		for               /f "usebackq tokens=1* delims=," %%A in  ("!bat_autocal_remote_queue!") do (
		  set bat_temp=%%~dpnA
		  !bat_logexeclog! set bat_search=!bat_temp!_Results.zip
		  echo.!bat_search!>>!bat_ftp_tempfile5!
		)
		!bat_poplog! ^)

			REM Output the resulting list of "_Results.zip" files to process...
		!bat_logexec! TYPE "!bat_ftp_tempfile5!"
		set bat_returncode=!errorlevel!
		

:GET_QUEUE_ITEMS_END
!bat_poplog! [RETURN !bat_batchfile!:GET_QUEUE_ITEMS] [!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:GET_QUEUE_ITEMS_END
!bat_return! !bat_returncode!





	REM ######################################################################
	REM
:FILTER_LIST
!bat_pushlog! [CALL !bat_batchfile!:FILTER_LIST] [%1, %2, %3]




		REM Now iterate the list of source files and exclude those with ".zip" for the master list of zip files.  Some of those may
		REM need to be excluded because of the presence of matching "_Results" files. 
		REM 
		REM For each "_Results.zip" file found on the server, 
		REM
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`FINDSTR /i /r /c:"CALSTARS0..._...._.._.._.._.._.._.._Results\.zip" "!bat_ftp_tempfile5!"`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`FINDSTR /i /r /c:"CALSTARS0..._...._.._.._.._.._.._.._Results\.zip" "!bat_ftp_tempfile5!"`) do (
		!bat_pushlog! [[[[ %%~na ]]]]

			REM	c:\CAMS\CapturedFiles\2016_12_31_14_37_59\CALSTARS0750_2016_12_31_14_37_59_01_Results.zip
		!bat_logexeclog! set bat_capturedzipfile=%%a

						 set bat_capturedfilesdir=%%~dpa::
						 set bat_capturedfilesdir=!bat_capturedfilesdir:\::=!
		!bat_logexeclog! set bat_capturedfilesdir=!bat_capturedfilesdir:::=!

			REM	C:\CAMS\Temp\CALSTARS0750_2016_12_31_14_37_59_01_Results.zip
		!bat_logexeclog! set bat_tempzipfile=!bat_ftp_tempdir!\%%~nxa
		!bat_logexeclog! set bat_tempzipname=%%~na&	rem	CALSTARS0750_2016_12_31_14_37_59_01_Results

			REM Convert: "CALSTARS0750_2016_12_31_14_37_59_01_Results" 
			REM to:      "CALSTARS0750_2016_12_31_14_37_59_01_Results.txt"
			REM 
		!bat_logexeclog! set bat_resultsflagfile=!bat_tempzipname:_Results=_Results.txt!

			REM Convert: "CALSTARS0750_2016_12_31_14_37_59_01_Results" 
			REM to:      "CALSTARS0750_2016_12_31_14_37_59_01_downloaded.txt"
			REM 
		!bat_logexeclog! set bat_downloadedflagfile=!bat_tempzipname:_Results=_Deletable.txt!



			REM First, check if there is an MD5 file [which is named as "CALSTARS0*_Results.txt"] to see if it's finished uploading. 
			REM
			REM Only download if there is [A] a "*_Results.txt" flag file and [B] if there is NOT a "*_downloaded.txt" flag file.

		!bat_log!
		!bat_logexeclog! FINDSTR /r /i /c:"!bat_resultsflagfile!" "!bat_ftpfile2!"
		if /i "!errorlevel!" NEQ "0" (

			!bat_log! **** SKIP no "_Results.txt" file: "!bat_resultsflagfile!"...
			!bat_log!

		) else (

			
				REM Now check if the "*_downloaded.txt" flag file is there. If it is, it's already been handled...
			!bat_logexeclog! FINDSTR /r /i /c:"!bat_downloadedflagfile!" "!bat_ftpfile2!"

			if /i "!errorlevel!" EQU "0" (

				!bat_log! **** SKIP already downloaded: "!bat_capturedfilesdir!\!bat_downloadedflagfile!"...
				!bat_log!

			) else (
				!bat_echolog! **** MATCH - Processing results: "!bat_tempzipfile!"...
				!bat_echolog!

				!bat_logexeclog! set bat_captureddatetime=!bat_tempzipname:~13,19!
				!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
				!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!
				!bat_logexeclog! set bat_sequence=!bat_tempzipname:~33,2!
				!bat_logexeclog! set bat_camera=!bat_tempzipname:~9,3!

				call :GET_FILE "!bat_tempzipfile!" "!bat_tempzipname!"
				set bat_returncode=!errorlevel!
				if !bat_returncode! equ 0 (

						REM Launch "AutoCal_LocalDownload.bat" to have it upload the 
						REM file and its "*_md5.txt" file to the FTP server. Then
						REM wait for it to finish...
						REM 
					!bat_CALLecho! "!bat_exedir!\AutoCal_LocalDownload.bat" /zip "!bat_tempzipfile!"
					set bat_returncode=!errorlevel!
				)
			)
			
		)

		!bat_poplog!............................
	)
	!bat_poplog! ^) end of: for /f "usebackq tokens=*" ..a in ^(`FINDSTR /i /r /c:"CALSTARS0..._...._.._.._.._.._.._.._Results.zip" "!bat_ftpfile2!"`^) 

	!bat_log! End of list


:FILTER_LIST_END
!bat_popecho! [RETURN !bat_batchfile!:FILTER_LIST] [!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:FILTER_LIST_END
!bat_return! !bat_returncode!






	REM ######################################################################
	REM This routine unzips the newly downloaded file to the "..\Temp\Zip" dir. 
	REM
	REM Technically, this routine preps the "..Temp\Zip" dir to get ready for 
	REM unzipping to that dir.  If the unzip command returns errorlevel=0,
	REM then it must be ok. 
	REM
	REM %~1 is the fully qualified zip file name
	REM %~2 is just the zip file name without the path
	REM
:CHECK_GET [IN "!bat_ftp_tempdir!\!bat_zip!" IN "!bat_zipfile!"  IN "!bat_zipfilename!"]
!bat_pushlog! [CALL !bat_batchfile!:CHECK_GET] [%1, %2, %3]

	!bat_logexeclog! set bat_checkget_zip=%~1&						REM C:\CAMS\Temp\CALSTARS0750_2016_01_16_14_36_59_01_Results.zip
	!bat_logexeclog! set bat_checkget_zipfile=%~nx1&				REM CALSTARS0750_2016_01_16_14_36_59_01_Results.zip
	!bat_logexeclog! set bat_checkget_zipfilename=%~n1&				REM CALSTARS0750_2016_01_16_14_36_59_01_Results
	!bat_logexeclog! set bat_checkget_md5file=%~dp1%~n1.txt&		REM C:\CAMS\Temp\CALSTARS0750_2016_01_16_14_36_59_01_Results.txt
	
		REM If the zip file doesn't exist by now, display an error and abort.
	if not exist "!bat_checkget_zip!" (
		set bat_returncode=10
		set bat_recent_error_msg= ERROR - Failed FTP download of "!bat_checkget_zipfile!" - can't find it in "!bat_ftp_tempdir!".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	)
	
		REM If the md5 file doesn't exist by this point, then display an error and abort
	if not exist "!bat_checkget_md5file!" (
		set bat_returncode=11
		set bat_recent_error_msg= ERROR - Failed FTP download of "!bat_checkget_md5file!" - can't find it in "!bat_ftp_tempdir!".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	)
	
	call :MD5_CHECK "!bat_checkget_zip!" "!bat_checkget_md5file!"
	if /i "!bat_returncode!" neq "0" (
		set bat_returncode=12
		set bat_recent_error_msg= ERROR - Failed MD5 hashcheck of "!bat_checkget_md5file!".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	)


		REM Now make sure the target dir of the unzip exists before unzipping...
	if not exist "!bat_ftp_tempdir!\Zip" (
		md "!bat_ftp_tempdir!\Zip"
	)

		REM If the directory already exists, which it will by now, clean it up by
		REM removing the entire dir and then rebuilding it. 
		REM
	if exist "!bat_ftp_tempdir!\Zip" (
		!bat_log! // Cleaning up before unzipping...
		
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_ftp_tempdir!\Zip"
			!bat_logexeclog! rd  /s /q "!bat_ftp_tempdir!\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /s /q "!bat_ftp_tempdir!\Zip"
			set bat_returncode=11
		)
	)
	
	!bat_logexeclog! MD "!bat_ftp_tempdir!\Zip"
	
rem !bat_pause! Check if this dir exists: "!bat_ftp_tempdir!\Zip"

		REM Before unzipping, copy it to the temp\zip dir for testing to unzip
	!bat_logexeclog! copy /y "!bat_checkget_zip!" "!bat_ftp_tempdir!\Zip"
	
rem !bat_pause! Check if this file exists: "!bat_ftp_tempdir!\Zip\!bat_checkget_zipfile!"


	call :FTP_TESTZIP "!bat_ftp_tempdir!\Zip\!bat_checkget_zipfile!"
	set bat_returncode=!errorlevel!
	
	if /i "!bat_returncode!" neq "0" (
	
		if defined bat_ftp_tempdir (
			if defined bat_checkget_zip (
				del /q /f "!bat_ftp_tempdir!\Zip\!bat_checkget_zip!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q /f "!bat_ftp_tempdir!\Zip\!bat_checkget_zip!"
			)
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q /f "!bat_ftp_tempdir!\Zip\!bat_checkget_zip!"
		)
		goto :CHECK_GET_END
	)


	!bat_log!

	set bat_retval=success
	set bat_returncode=0
	set bat_recent_error_msg= SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a download of the same file via MD5 hash check.
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! `    !bat_recent_error_msg!
	!bat_echolog!
	!bat_echolog!


:CHECK_GET_END
!bat_popecho! [RETURN !bat_batchfile!:CHECK_GET] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:CHECK_GET_END
!bat_return! !bat_returncode!






	REM ######################################################################
	REM This routine tests the zip file after downloading to ensure that it's 
	REM good.
	REM
	REM The test involves:
	REM   - The zip file must exist;
	REM   - The hash code must not be the empty zip file hash
	REM     If so, the zip file will be deleted.
	REM   - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
	REM     is cleaned out before unzipping]
	REM   - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
	REM   - If there are no other errors, the 
	REM 
:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

	!bat_echolog! `Test the zip file after downloading to ensure that it's good.
	!bat_echolog! `The test involves:
	!bat_echolog! `  - The zip file must exist.
	!bat_echolog! `  - The MD5 hash code must not be the "empty zip" file hash.
	!bat_echolog! `    If so, the zip file will be deleted.
	!bat_echolog! `  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
	!bat_echolog! `    is cleaned out before unzipping]
	!bat_echolog! `  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
	!bat_echolog! `  - If there are no other errors, it we can be sure that it was 
	!bat_echolog! `    downloaded OK.  Otherwise, the download failed. 

	if not exist "%~1" (
		set bat_returncode=98
		set bat_recent_error_msg=ERROR - Not found: "%~1"
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

	call :FTPHASH "%~1"
	
		rem The hash code below is a hash for an empty 22 byte zip file. 
	if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
		set bat_returncode=99
		set bat_retval=failed
		set bat_recent_error_msg=ERROR - Empty zip file: "%~1"
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
		
		if "%~1" neq "" (
			!bat_logexec! del /q "%~1"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /q "%~1"
		)
		goto :FTP_TESTZIP_END
	) else (
		!bat_echolog! `    OK - because it's not a blank zip file...
	)


	!bat_log!
	!bat_log! // Unzipping the file to "..\Temp\Zip" and checking the errorlevel.  If the errorlevel
	!bat_log! // is not "0", then it's a corrupt zip file. [There is also the possibility that it's encrypted]

	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_ftp_tempdir!\Zip" "%~1" "*.*"
	set bat_returncode=!bat_logexec_returncode!
	!bat_echolog! bat_returncode=!bat_returncode!

	!bat_log! // Cleanup after unzipping...
	if exist "!bat_ftp_tempdir!\Zip" (
		!bat_logexeclog! move /y "%~1" "!bat_ftp_tempdir!"
		
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_ftp_tempdir!\Zip"
			!bat_logexeclog! rd /s /q "!bat_ftp_tempdir!\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /s /q "!bat_ftp_tempdir!\Zip"
		)
	)

	!bat_log! // Comparing the hash codes...
	if /i !bat_returncode! equ 0 (
		set bat_retval=success
		set bat_recent_error_msg=SUCCESS - Zip file is OK as it is not empty, and not corrupt: "%~1"
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
	) else (
		set bat_retval=failed
		set bat_recent_error_msg=ERROR - Corrupt zip file: "%~1"
		!bat_echolog!
		!bat_echolog! `    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
rem !bat_WAIT! 3	:FTP_TESTZIP_END
!bat_return! !bat_returncode!







	REM ######################################################
	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)

%bat_COMMENT_BEGIN%		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
%bat_COMMENT_END%

	)

	if exist "!bat_exedir!\Logs\md5.output.log" (
		if defined bat_exedir (
			!bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTPHASH] Dangerous command: del /q "!bat_exedir!\Logs\md5.output.log"
		)
	)

:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
rem !bat_WAIT! 3	:FTPHASH_END
!bat_return! !bat_retval!












	REM ######################################################################
	REM This routine is only called when the .zip file doesn't have a matching
	REM _Results.zip entry and it does have a matching md5.txt file.
	REM
	REM %~1 is "C:\CAMS\Temp\TempCal\From\CALSTARS0750_2016_01_16_14_36_59_01_Results.zip"
	REM %~2 is "CALSTARS0750_2016_01_16_14_36_59_01_Results"
	REM 
:GET_FILE [IN "!bat_tempzipfile!" IN "bat_tempzipname"]
!bat_pushlog! [CALL !bat_batchfile!:GET_FILE] [%*]

	set bat_returncode=1

rem !bat_pause! CHECK THE ZIP FILES AND THE ZIP DIR

	!bat_pushecho! Now download the files that don't exist locally to ".\Temp" and test them...

		if not exist "%~1" (
			!bat_pushecho! Downloading "%~1"...
			
				echo.user !bat_calftpuser!>"!bat_ftpfile!"
				echo.!bat_calftppassword!>>"!bat_ftpfile!"
				echo.bin>>"!bat_ftpfile!"
				echo.cd !bat_calftpdir!>>"!bat_ftpfile!"
				echo.literal pasv>>"!bat_ftpfile!"
				echo.lcd "!bat_ftp_tempdir!">>!bat_ftpfile!"
				echo.literal pasv>>"!bat_ftpfile!"
				echo.get "%~2.zip">>!bat_ftpfile!"
				echo.get "%~2.txt">>!bat_ftpfile!"
				echo.quit>>"!bat_ftpfile!"

				!bat_logexec! TYPE "!bat_ftpfile!"

				!bat_echolog! ================================================

					REM ==========RUN THE FTP COMMAND to download the "_Results.zip" file, BUT IT DOESN'T SHOW ANYTHING UNTIL IT'S ALL DONE =================
				!bat_logexec! call FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"
				set bat_returncode=!bat_logexec_returncode!

				!bat_echolog!
				!bat_echolog! `    FTP exit code=!bat_returncode!
				!bat_echolog!

rem by this point, you have the file.  so call CHECK_GET on the files that you have. 

				call :CHECK_GET "%~1"
				set bat_returncode=!errorlevel!

				if /i "!bat_returncode!" equ "0" (

%bat_COMMENT_BEGIN%
						REM I think the "downloaded" flag file should be moved until after it's been integrated... or at least later.
				
					!bat_echolog! ================================================
					!bat_echolog! The "*_downloaded.txt" flag file must now be uploaded... 

						REM First, create the name of the "*_downloaded.txt" file by removing the "_Results" portion of it and adding the "_downloaded" part to it
					!bat_logexeclog! set bat_downloadedconf=!bat_ftp_tempdir!\%~2.txt
					!bat_logexeclog! set bat_downloadedconf=!bat_downloadedconf:_Results=_downloaded!
					!bat_logexeclog! set bat_search=!bat_downloadedconf!
					echo.!date! !time! "%~1">"!bat_downloadedconf!"

					!bat_pushecho! Uploading the flag file: "!bat_downloadedconf!"...
						echo user !bat_calftpuser!>"!bat_ftpfile!"
						echo !bat_calftppassword!>>"!bat_ftpfile!"
						echo bin>>"!bat_ftpfile!"
						echo cd !bat_calftpdir!>>"!bat_ftpfile!"
						echo literal pasv>>"!bat_ftpfile!"
						echo lcd "!bat_ftp_tempdir!">>!bat_ftpfile!"
						echo literal pasv>>"!bat_ftpfile!"
						echo put "!bat_downloadedconf!">>!bat_ftpfile!"
						echo quit>>"!bat_ftpfile!"

						!bat_logexec! TYPE "!bat_ftpfile!"

						!bat_echolog! '..............................................

						!bat_logexec! call FTP -n -s:"!bat_ftpfile!" "!bat_calftpsite!"
						set bat_returncode=!bat_logexec_returncode!

						!bat_echolog!
						!bat_echolog! '    FTP exit code=!bat_returncode!
						!bat_echolog!

					!bat_pop!
%bat_COMMENT_END%

				)&	REM	if /i "!bat_retval!" equ "success"
				
			!bat_pop!
		) else (
			rem set bat_returncode=20
			set bat_returncode=0
			!bat_echolog! Already exists [!bat_returncode!] - Skipping redundant download for: "!bat_ftp_tempdir!\%%a"
			goto :GET_FILE_END
			if /i "!bat_retval!" equ "failed" (
				rem 
			)
		)
		
	!bat_pop!
	!bat_echolog!
	!bat_echolog! Done with downloading the new files: %~1
	!bat_echolog!
rem !bat_pause! CHECK THE TEMP DIR [type "!bat_ftp_tempdir!\%~1]



:GET_FILE_END
!bat_popecho! [RETURN !bat_batchfile!:GET_FILE] [!bat_retval!, !bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:GET_FILE_END
!bat_return! !bat_returncode!






	REM ######################################################################
	REM The "*_Results.txt" file has the md5 hashcode in the firstline of the 
	REM file.  There may be other text in the file after that line.
	REM 
:MD5_CHECK [IN "zipfile"  IN "md5file"]
!bat_pushlog! [CALL !bat_batchfile!:MD5_CHECK] [%*]
	
	set bat_returncode=0
	
	set bat_md5_1=
	set bat_md5_2=
	
		REM Get the md5 from the uploaded md5 flag file from the first line in the file...
	set /a bat_count=0
	for /f "usebackq tokens=1* skip=2" %%b in (`find /i /v "" "%~2"`) do (
		set /a bat_count+=1
		
		if /i "!bat_count!" equ "1" (
			!bat_logexeclog! set bat_md5_1=%%~b
		)
	)
	
		REM Get the md5 from the uploaded zip file to compare with the flag file's md5
	!bat_log! for /f "usebackq tokens=1*" ..b in ^(`md5 "%~1"`^) do ...
	for           /f "usebackq tokens=1*" %%b in (`md5 "%~1"`) do (
		!bat_logexeclog! set bat_md5_2=%%~b
	)

	!bat_log! if /i "!bat_md5_1!" neq "!bat_md5_2!" 
	if /i "!bat_md5_1!" neq "!bat_md5_2!" (
		set bat_returncode=31
		!bat_log!
		!bat_log! ERROR [!bat_returncode!] - MD5 hashcodes don't match.  Corrupt zip file: "%~1"
		!bat_log!
		if /i "%~1" neq "!bat_exedir!" (
			if /i "%~1" neq "!bat_ftp_tempdir!" (
				!bat_logexeclog! del /q "%~1"
			)
		)
	) else (
		set bat_returncode=0
	)

	

:MD5_CHECK_END
!bat_popecho! [RETURN !bat_batchfile!:MD5_CHECK] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 3	:MD5_CHECK_END
!bat_return! !bat_returncode!






	REM ######################################################
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0 /targetdir "^<target dir^>" /workdir "^<work dir^>" /exclude "exclude spec"
	echo.
	echo.This script needs to download only the zip files matching the specified filespec
	echo.to the "work dir" that haven't already been processed.  The flag for whether it
	echo.has been processed is the presence of a corresponding "*_calibrated.txt" or a 
	echo."*_Results.zip" file.  
	echo.
	echo.We need to figure out how to tell this script that it's going to be used to
	echo.download original CALSTARS or results. Maybe we just use different modes.
	echo./calstars or /results or /any.
	echo.
	echo.
exit /b 99


	REM ######################################################
:DONE
!bat_pop!
	!bat_popecho!
	!bat_echolog! [!date! !time!] !bat_batchfile!:DONE with %0 %* [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!
