@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"
	
	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=
	)

	!bat_log!
	!bat_log! =============================================================
	!bat_log! [!date! !time!] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	if not defined bat_LOCALIZE.locale (
		call "!bat_exedir!\ReadParams.bat"
	)


		REM fetch the sShortDate from the registry.  Example, in en-US it is sometimes "M/d/yyyy".
	set bat_sShortDate=
rem	!bat_pushlog! FOR /F "tokens=2* skip=2" ..A IN ^('REG.exe query "HKCU\Control panel\international" /v "sShortDate"') ...
	FOR               /F "tokens=2* skip=2" %%A IN  ('REG.exe query "HKCU\Control panel\international" /v "sShortDate"') DO (
		set bat_sShortDate=%%B
	)
rem	!bat_pop!


	if defined bat_sShortDate (
		set bat_LOCALIZE.format.date=!bat_sShortDate!
	) else (
		!bat_echolog!
		!bat_echolog! ERROR - Unable to read sShortDate from REG.exe query "HKCU\Control panel\international" /v "sShortDate"
		!bat_echolog!
	)

		REM Isolate the www part of the date format from the MM/dd/yyyy part
	FOR /F "tokens=1-2 delims= " %%a IN ("!bat_sShortDate!") DO (

		set bat_part_1=%%a
		set bat_part_2=%%b
		
		IF "!bat_part_2!"=="" (
			rem If you get here, there is no www part of the date  format
			set bat_sShortDate.date=!bat_part_1! 
		) ELSE (
			set bat_sShortDate.weekday=!bat_part_1!
			set bat_sShortDate.date=!bat_part_2!
		)

	)

rem echo bat_sShortDate.date=!bat_sShortDate.date!

		REM extrapolate  the "/" delimiter from the M/d/yyyy string
	set bat_LOCALIZE.delimiter.date=!bat_sShortDate.date!
	set bat_LOCALIZE.delimiter.date=!bat_LOCALIZE.delimiter.date:d=!
	set bat_LOCALIZE.delimiter.date=!bat_LOCALIZE.delimiter.date:M=!
	set bat_LOCALIZE.delimiter.date=!bat_LOCALIZE.delimiter.date:y=!
	
	set bat_LOCALIZE.delimiter.date=!bat_LOCALIZE.delimiter.date:~0,1!

rem	!bat_pushlog! FOR /F "tokens=1-3 delims=%bat_LOCALIZE.delimiter.date%" ..a IN ^("!bat_sShortDate.date!"^) do ^(
	FOR               /F "tokens=1-3 delims=%bat_LOCALIZE.delimiter.date%" %%a IN  ("!bat_sShortDate.date!") DO (
rem		!bat_log! a=%%a, b=%%b, c=%%c
		set bat_date.order.1=%%a
		set bat_date.order.2=%%b
		set bat_date.order.3=%%c
	)
rem	!bat_poplog! ^)

	set bat_date.order.1=!bat_date.order.1:~0,1!
	set bat_date.order.2=!bat_date.order.2:~0,1!
	set bat_date.order.3=!bat_date.order.3:~0,1!

	rem fetch the local system date only once
	set bat_date=!date!
	if /i "%~1" neq "" (

		REM If you get here, a date was passed to the program without the weekday stuff.
		REM In that case, we need to strip all the W's from the format.date string to
		REM make it compatible with the PARSEDATE code. 

		set bat_date_parameter=%~1
		set bat_other_date=true

	) else (
		REM If you get here, a date is determined by using the %DATE% variable, which may or may not
		REM contain the weekday.

		set bat_date_parameter=!bat_date!
		set bat_other_date=
rem		!bat_log! set bat_other_date=
	)
rem echo.format.date=!bat_LOCALIZE.format.date!

	call :PARSEDATE

goto :DONE



   rem When run on 10/03/2013, it should result in:
   rem    ftp_da=03
   rem    ftp_mo=10
   rem    ftp_wmdy=Thu 10/03/2013
   rem    ftp_year=2013

:PARSEDATE
rem !bat_pushlog! [CALL !bat_batchfile!:PARSEDATE] %*

	SET ftp_wmdy=
	set ftp_year=
	set ftp_mo=
	set ftp_da=
	set bat_twilight_searchstr=

	set ftp_wmdy=!bat_date_parameter!
	set bat_date_temp=!bat_date_parameter!

	if not defined bat_LOCALIZE.delimiter.date (
		!bat_echolog!
		!bat_echolog! !bat_batchfile!:PARSEDATE    WARNING - Missing bat_LOCALIZE.delimiter.date from autocams.params.ini.  Using the default date delimiter as "/".
		!bat_echolog!
		set bat_LOCALIZE.delimiter.date=/
	)

	call :NON_WMIC

	set ftp_mo2=!ftp_mo!
	set ftp_da2=!ftp_da!

:PARSEDATE_END
rem !bat_poplog! [RETURN !bat_batchfile!:PARSEDATE] [ftp_wmdy=!ftp_wmdy!, ftp_year=!ftp_year!, ftp_mo=!ftp_mo!, ftp_da=!ftp_da!, bat_twilight_searchstr=!bat_twilight_searchstr!, ftp_LocalDate=!ftp_LocalDate!]
rem !bat_log!
!bat_return!




:NON_WMIC
rem !bat_pushlog! [CALL !bat_batchfile!:NON_WMIC] %*

rem	!bat_pushlog! FOR /F "tokens=1-2 delims= " ..a IN ^("!ftp_wmdy!"^) do ^(
	FOR               /F "tokens=1-2 delims= " %%a IN  ("!ftp_wmdy!") DO (

		set bat_part_1=%%a
		set bat_part_2=%%b

		IF "!bat_part_2!"=="" (
				rem		ECHO bat_part_2 is NOT defined
				rem		echo there is no weekday display
			set bat_partdate=!bat_part_1! 
		) ELSE (
			rem		echo bat_part_2 is defined
			rem		echo there is a weekday display
			IF "!bat_part_1:~5,1!"=="" (
				set ftp_www=!bat_part_1!
				set bat_partdate=!bat_part_2!
				set bat_twilight_searchstr=!ftp_wmdy:~-10!
			) ELSE (
				set ftp_www=!bat_part_2!
				set bat_partdate=!bat_part_1!
				set bat_twilight_searchstr=!ftp_wmdy:~0,10!
			)
		)
	)
rem	!bat_poplog! ^)
rem	!bat_logexeclog! set bat_part

rem	!bat_logexeclog! set bat_date.order
rem	!bat_logexeclog! set bat_partdate
	
REM	!bat_pushlog! FOR /F "tokens=1-3 delims=%bat_LOCALIZE.delimiter.date%" ..a IN ^("!bat_partdate!"^) DO ^(
	FOR               /F "tokens=1-3 delims=%bat_LOCALIZE.delimiter.date%" %%a IN  ("!bat_partdate!") DO (
rem		!bat_log! %%a, %%b, %%c
rem		set bat_date.order
		if /i "!bat_date.order.1!"=="d" (set ftp_da=0%%a)
		if /i "!bat_date.order.2!"=="d" (set ftp_da=0%%b)
		if /i "!bat_date.order.3!"=="d" (set ftp_da=0%%c)
		if /i "!bat_date.order.1!"=="M" (set ftp_mo=0%%a)
		if /i "!bat_date.order.2!"=="M" (set ftp_mo=0%%b)
		if /i "!bat_date.order.3!"=="M" (set ftp_mo=0%%c)
		if /i "!bat_date.order.1!"=="y" (set ftp_year=20%%a)
		if /i "!bat_date.order.2!"=="y" (set ftp_year=20%%b)
		if /i "!bat_date.order.3!"=="y" (set ftp_year=20%%c)
	)
REM	!bat_poplog! ^)
	
	set ftp_da=!ftp_da:~-2!
	set ftp_mo=!ftp_mo:~-2!
	set ftp_year=!ftp_year:~-4!
	
rem	!bat_logexeclog! set ftp_
	set ftp_LocalDate=!bat_partdate!

:NON_WMIC_END
rem !bat_poplog! [RETURN !bat_batchfile!:NON_WMIC_END] [bat_partdate=!bat_partdate!, ftp_LocalDate=!ftp_LocalDate!, ftp_www=!ftp_www!
rem !bat_log! `                                     ftp_da=!ftp_da!, ftp_mo=!ftp_mo!, ftp_year=!ftp_year!]
rem !bat_log!
!bat_return!



:USING_WMIC
	set ftp_wmdy=
		REM first attempt to get the date using the wmic way.
	for /f "usebackq skip=1 tokens=*" %%a in  (`call WMIC OS GET LocalDateTime`) do (
		if "%%a" gtr "0" (
			set ftp_wmdy=%%a
		)
	)


:USING_WMIC_END
!bat_return!




:HELP
	echo.Usage: call "%~dpnx0" [date]
	echo.
	echo.Parses the date in the current locale and separates the
	echo.values into separate year, month, and day variables so
	echo.that the presentation of the date value can be displayed 
	echo.according to the user's locale settings.  
	echo.
	echo.Note: The input date cannot be ^%date^% because it messing things
	echo.      up with the weekday.  
	echo.
	echo.Returns:
	echo.  environment variables:
	echo.	ftp_wmdy                 Source value, e.g. %%date%% or wmic localdatetime
	echo.
	echo.	ftp_year                 The 4 digit year with leading zeros
	echo.
	echo.	ftp_mo                   The two digit month with leading zeros
	echo.
	echo.	ftp_mo2=%ftp_mo2%        Numeric month value [no leading zero]
	echo.
	echo.	ftp_da=%ftp_da%          Two digit day with leading zeros
	echo.
	echo.	ftp_da2=%ftp_da2%        Numeric day value [no leading zero]
	echo.
	echo.   ftp_LocalDate            date in the user's locale [e.g. 12/25/2014]
	echo.
	echo.	bat_twilight_searchstr   e.g. 12/25/2014
	echo.
	echo.The returned date  is localized current locale format 
	ecgi.where the local date is returned according to: bat_LOCALIZE.format.date
	echo.
	echo.Example:
	echo.  If the date is October 5, 2013, this routine should result with:
	echo.    ftp_year=2013
	echo.    ftp_mo=10
	echo.    ftp_da=05
	echo.
	echo.This routine does not need to be localized, since it was written in a way to
	echo.avoid that requirement.
	echo.
	echo.The trick is in the construct of the ENDLOCAL command, where it passes
	echo.back variables that are local to this routine.
	echo.




:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!


	rem Note: It isn't necessary to return the ftp_wmdy value
	ENDLOCAL & (
		SET ftp_wmdy=%ftp_wmdy%
		set ftp_year=%ftp_year%
		set ftp_mo=%ftp_mo%
		set ftp_mo2=%ftp_mo2%
		set ftp_da=%ftp_da%
		set ftp_da2=%ftp_da2%
		set bat_twilight_searchstr=%bat_twilight_searchstr%
		set ftp_LocalDate=%ftp_LocalDate%
	)

	REM Display the output.  Once you get this working, REM out this line
	

exit /b 0
