
TITLE "%~dpnx0"

:SETUP
	rem echo.if /i "!bat_pause!!bat_prompt!!bat_exedir!" equ "" ^(
	if      /i "!bat_pause!!bat_prompt!!bat_exedir!" equ "" (
			  @echo off
			echo.call "%~dp0AutoCams.setup.bat" "%~dpnx0"
			     call "%~dp0AutoCams.setup.bat" "%~dpnx0"
			
			echo.call "%~dp0indent_setup.bat"
			     call "%~dp0indent_setup.bat"
	)


        rem This reads the "AutoCams.Params.ini" file for 
        rem sections, keys, and values.  The keys and values
        rem are in the format of autonomouslevel=cal.  
        rem 
        rem If the environment variable is not a [section] then it
        rem is either a key or a comment.  
        rem 
        rem A comment is any line that starts with "//" or "rem ". 
        rem 
        rem If the key starts with "bat_", then the environment variable
        rem will bet set without the section prefix.  Otherwise, the
        rem environment variable will be set with the section 
        rem prefix.
        rem
        rem Examples:
        rem  [AUTOCAMS]
        rem  autonomouslevel=apply
        rem
        rem This would result in the following command being executed:
        rem set AUTOCAMS.autonomouslevel=apply
        rem
        rem  [CALIBRATION]
        rem  bat_calnstars=80
        rem
        rem This would result in the following command being executed:
        rem set bat_calnstars=80
        rem
        rem The reason for the different treatment is to make the ini file
        rem compatible with some script variables that were in use before
        rem the AutoCams system was expanded to using this AutoCams.Params.ini 
        rem file. 
        rem
        rem Place this section of code into:
        rem             AutoCams.bat
        rem     StageFromConfirmed.bat
        rem     ValidateCal.bat
        rem
:READPARAMS_BAT
rem !bat_log! [call ReadParams.bat:READPARAMS] [%*]
	set bat_retval=1
	set bat_paramsfile=%~dp0AutoCams.Params.ini


	if not exist "!bat_paramsfile!" (
		echo.
		echo.     ERROR - Cannot find params file: "!bat_paramsfile!"
		echo.
		!bat_log!
		!bat_log! '[ReadParams.bat:READPARAMS]    ERROR - Cannot read params file: "!bat_paramsfile!"
		!bat_log!
		goto :READPARAMS_BAT_END
	)

rem	!bat_log! for /f "usebackq tokens=*" ..x in ^(`type "!bat_paramsfile!"`^) do ^(
	for /f "usebackq tokens=*" %%x in (`type "!bat_paramsfile!"`) do (
			set bat_retval=0
			set bat_temp=%%x
rem			!bat_log! set bat_temp=%%x
		if /i "!bat_temp!" neq "" (
			if /i "!bat_temp:~0,1!" neq " " (
				if /i "!bat_temp:~0,1!" neq "	" (
					if /i "!bat_temp:~0,2!" neq "//" (
						rem It's not a single-line comment "//"

						if /i "!bat_temp:~0,3!" neq " rem " (
							rem It's not a single line comment " rem "

							if /i "!bat_temp:~0,4!" neq "rem " (
								rem It's not a comment "rem "

								if /i "!bat_temp:~0,1!" equ "[" (
									rem It's a [section]
									set bat_temp=!bat_temp:~1,99!
rem									!bat_log! '    set bat_inisection=bat_!bat_temp:~0,-1!
												   set bat_inisection=bat_!bat_temp:~0,-1!
								) else (
									rem It's a bat_key=value
									if "!bat_temp:~0,4!" equ "bat_" (
rem									!bat_log! '    set !bat_temp!
											       set !bat_temp!
									) else (
										rem It's a key=value
rem										!bat_log! '    set !bat_inisection!.!bat_temp!
													   set !bat_inisection!.!bat_temp!
									)
								)
							)
						)
					)
				)
			)
		)
rem !bat_echolog! '    bat_temp=!bat_temp!
	)


	
	for /f "usebackq tokens=*" %%x in (`type "!bat_exedir!\AutoCams.vers.ini"`) do (
		set %%~x
	)

	if not defined bat_AUTOCAMS.locale (
		set bat_AUTOCAMS.locale=en-US
	)
	
	set bat_retval=0

:READPARAMS_END_BAT
rem !bat_log! [RETURN ReadParams.bat:READPARAMS [bat_retval=!bat_retval!, bat_paramsfile=!bat_paramsfile!]
	set bat_temp=
	set bat_inisection=
exit /b !bat_retval!	
!bat_return!


