

call "%~dp0AutoCams.setup.bat" "%~dpnx0"


rem===========================================================================================================
rem This reads the "capture16.params.ini" file for rem sections, keys, and values.  The keys and values
rem are in the format of autonomouslevel=cal.  
rem 
rem If the environment variable is not a [section] then it rem is either a key or a comment.  
rem 
rem A comment is any line that starts with "//" or "rem ". 
rem 
rem If the key starts with "bat_", then the environment variable rem will be set without the [SECTION] prefix.  
rem Otherwise, the rem environment variable will be set with the section rem prefix.
rem
rem
rem Examples:
rem  [AUTOCAMS]
rem  autonomouslevel=apply
rem
rem This would result in the following command being executed:
rem set bat_AUTOCAMS.autonomouslevel=apply
rem
rem
rem  [CALIBRATION]
rem  bat_calnstars=80
rem
rem This would result in the following command being executed:
rem set bat_calnstars=80
rem
rem
rem The reason for the different treatment is to make the ini file rem compatible with some script variables 
rem that were in use before rem the AutoCams system was expanded to using this AutoCams.Params.ini file. 
rem ==========================================================================================================

:READPARAMS_BAT

rem !bat_log! call :READPARAMS %*
	set bat_retval=1
	set bat_paramsfile=!bat_exedir!\capture16.params.ini

rem	echo.for /f "usebackq tokens=*" ..x in (^`type "!bat_paramsfile!"`^) do ^(
	for /f "usebackq tokens=*" %%x in (`type "!bat_paramsfile!"`) do (
		set bat_retval=0
		set bat_temp=%%x

		if /i "!bat_temp!" neq "" (
			if /i "!bat_temp:~0,1!" neq " " (
				if /i "!bat_temp:~0,1!" neq "	" (
					if /i "!bat_temp:~0,2!" neq "//" (
						rem It's not a single-line comment "//"

						if /i "!bat_temp:~0,3!" neq "rem" (
							rem It's not a single line comment "rem"

							if /i "!bat_temp:~0,4!" neq "rem " (
								rem It's not a comment "rem "

								if /i "!bat_temp:~0,1!" equ "[" (
									rem It's a [section]
									set bat_temp=!bat_temp:~1,99!
									rem !bat_log! '    set bat_inisection=bat_!bat_temp:~0,-1!
										set bat_inisection=bat_!bat_temp:~0,-1!
								) else (
									rem It's a bat_key=value
									if "!bat_temp:~0,4!" equ "bat_" (
									rem !bat_log! '    set !bat_temp!
										set !bat_temp!
									) else (
										rem It's a key=value
										rem !bat_log! '    set !bat_inisection!.!bat_temp!
										set !bat_inisection!.!bat_temp!
									)
								)
							)
						)
					)
				)
			)
		)
rem !bat_echolog! '    bat_temp=!bat_temp!
	)
	
	
	if not defined bat_locale (
		set bat_locale=en-US
	)

:READPARAMS_END_BAT
rem !bat_log! return-:READPARAMS [!bat_paramsfile!=!bat_retval!]
	set bat_temp=
	set bat_inisection=
exit /b !bat_retval!	
!bat_return!


