  @echo off
setlocal enabledelayedexpansion enableextensions


	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"
	
	set bat_startlocation=!bat_camsdir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	SET bat_returncode=0
	
rem	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
rem		echo     ERROR: You must start from x:\CAMS directory. 
rem		exit /b 1
rem	)
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!BAT_TITLE! %~nx0
	
	set bat_returncode=0
	call :PARSEARGS %*

goto :MAIN

	
:PARSEARGS [in=%*]
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_detectfilefull=%~1
	
	set bat_detectdir=%~dp1::
	set bat_detectdir=!bat_detectdir:\::=!
	set bat_detectdir=!bat_detectdir:::=!
	
	set bat_detectfile=%~nx1
	set bat_detectfile_name=%~n1
	
	set bat_save_detectfile=!bat_detectdir!\!bat_detectfile_name!_ORIGINAL.txt
	
		rem the bat_sorted_mark file is a file that, if it is there, the sortdetect.bat
		rem script should ignore the sort and no do it again.  If you want to 
		rem for a sort, then delete that file.
	set bat_sorted_mark_file=!bat_detectdir!\SortDetect_Sorted.log
	
	set bat_cameralist_file=!bat_detectdir!\SortDetect_CameraList.txt
	set bat_temp_meteorcountfile=!bat_detectdir!\meteorcount.txt
	set bat_temp_headerfile=!bat_detectdir!\SortDetect_header.txt
	set bat_temp_strippeddetectfile=!bat_detectdir!\SortDetect_detectfile.txt


	set bat_caldir=!bat_startlocation!\Cal
	
	
		rem What you need to know is that the first camera keeps the original date/time
		rem CapturedFile name and the second camera uses 61 seconds as the last two digits.
	call :GETPARENTDIR "!bat_detectdir!"
	set bat_parentdir=!bat_retval!
	set bat_dirdate=!bat_retval2!
	
		REM There is no need to accommodate long camera numbers [firstlast] because it uses the 
		REM directory name for the session date.  Problems will occur if the detect file is not 
		REM in a directory named after the session. 
	set bat_captureddate=!bat_dirdate:~0,19!
	
	echo.%*|find /i "/forcesort"
	if !errorlevel! equ 0 (
		!bat_logexec! set bat_forcesort=true
	) else (
		!bat_logexec! set bat_forcesort=
	)

:PARSEARGS_END
!bat_poplog! RETURN !bat_batchfile!:PARSEARGS [bat_captureddate=!bat_captureddate!]
!bat_log!
%return%




:GETPARENTDIR
	set bat_retval=%~dp1::
	set bat_retval=!bat_retval:\::=!
	set bat_retval=!bat_retval:::=!
	set bat_retval2=%~nx1
!BAT_RETURN!


:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] %*

	if not exist "!bat_detectfilefull!" (
		set bat_returncode=2
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `    ERROR - Does not exist:
		!bat_echolog! `            "!bat_detectfilefull!"
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END
	)
	
	if defined bat_forcesort (
		if exist "!bat_sorted_mark_file!" (
			!bat_logexeclog! del /q "!bat_sorted_mark_file!"
		)
	)
	
	if exist "!bat_sorted_mark_file!" (
		!bat_echolog!
		!bat_echolog! ....Already sorted, aborting sort as unnecessawry.  Use /forcesort option if you want
		!bat_echolog! `    to force it to sort or just delete the file: "!bat_sorted_mark_file!". 
		!bat_echolog!
		
		goto :MAIN_END
	)
	
	!bat_echolog! if not exist "!bat_cameralist_file!" ^(
	if               not exist "!bat_cameralist_file!" (
		!bat_CALL! "!bat_exedir!\CreateCameraListFileFromDetectFile.bat" "!bat_detectfilefull!"
	)

	call :DELETE_LEFTOVERS

	call :SAVEDETECTFILE


	rem call :EXTRACTHEADER

	call :SPLITDETECTFILE

	call :TEMPCONCAT "!bat_detectfilefull!" "!bat_detectdir!"

	call :GETMETEORCOUNT "!bat_detectfilefull!" "!bat_detectdir!"

	call :REBUILDHEADER "!bat_detectfilefull!" "!bat_detectdir!"

	call :CONCATFINAL "!bat_temp_meteorcountfile!" "!bat_string!" "!bat_detectfilefull!"
	call :PREVIEW
	CALL :CLEANUP
	
	CALL :MARK_AS_SORTED

goto :MAIN_END


:MAIN_END
!bat_popecho! [end of :MAIN] %*
goto :DONE




:DELETE_LEFTOVERS
!bat_pushecho! [CALL !bat_batchfile!:DELETE_LEFTOVERS] [%*]

	for /f "usebackq tokens=*" %%a in (`type "!bat_cameralist_file!"`) do (
		if exist "!bat_detectdir!\SortDetect_%%a.txt" (
			!bat_logexec! del /q "!bat_detectdir!\SortDetect_%%a.txt"
		)
	)
	
	if exist "!bat_detectdir!\SortDetect_detectfile.txt" (
		!bat_logexec! del /q "!bat_detectdir!\SortDetect_detectfile.txt"
	)

	if exist "!bat_detectdir!\SortDetect_header.txt" (
		!bat_logexec! del /q "!bat_detectdir!\SortDetect_header.txt"
	)
	
	if exist "!bat_save_detectfile!" (
		!bat_logexec! MOVE /Y "!bat_save_detectfile!"   "!bat_detectfilefull!"
	)
	

:DELETE_LEFTOVERS_END
!bat_popecho! [RETURN !bat_batchfile!:DELETE_LEFTOVERS] [source detectfile=!bat_save_detectfile!]
!bat_echolog!
!bat_return!




:SAVEDETECTFILE
!bat_pushecho! [CALL !bat_batchfile!:SAVEDETECTFILE] [%*]
	
	!bat_logexec! copy /y "!bat_detectfilefull!" "!bat_save_detectfile!"

:SAVEDETECTFILE_END
!bat_popecho! [RETURN !bat_batchfile!:SAVEDETECTFILE] [saved source detectfile=!bat_save_detectfile!]
!bat_echolog!
!bat_return!


	rem Extracts the first 11 lines from the original detect file so it can be placed back later.
:EXTRACTHEADER
!bat_pushecho! [call !bat_batchfile!:EXTRACTHEADER] [%*]

	!bat_echolog! [!date! !time!]
	call "!bat_exedir!\StripHeaderNASA.bat" "!bat_detectfilefull!" "!bat_temp_headerfile!" "!bat_temp_strippeddetectfile!"


:EXTRACTHEADER_END
!bat_popecho! [RETURN !bat_batchfile!:EXTRACTHEADER] [!date! !time!, bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return!




	rem Copies each track 
:SPLITDETECTFILE
!bat_pushecho! [CALL !bat_batchfile!:SPLITDETECTFILE] [%*]

	!bat_echolog! [!date! !time!] Starting Split operation
		
	!bat_logexec! call cscript //nologo "SortDetect_Split.vbs" "!bat_detectfilefull!"
	
	!bat_echolog! [!date! !time!] Done with Split operation
	
	!bat_logexec! dir "!bat_detectdir!\SortDetect_??????.txt" /b /a-d /on

rem :SPLITDETECTFILE_END
!bat_popecho! [RETURN !bat_batchfile!:SPLITDETECTFILE] [!date! !time!, bat_track_count=!bat_track_count!]
!bat_echolog!
!bat_return!


	set bat_temp_seg_file=
	set bat_new_track=
	set /a bat_track_count=0
	set /a bat_track_linecount=0
	!bat_pushecho! for /f "usebackq tokens=* skip=11" ..a in ^(`type "!bat_detectfilefull!"`^) do ^(
	for                /f "usebackq tokens=* skip=11" %%a in  (`type "!bat_detectfilefull!"`) do (
		set bat_temp=%%a
		
		if "%%a" equ "-------------------------------------------------------" (
			rem New Track
			set bat_new_track=true
			set bat_temp_track_file=
			set /a bat_track_count+=1
			set /a bat_track_linecount=1
			set bat_save_line=!bat_temp!
			title !bat_track_count!


		) else (
			rem Part of a Track
			set bat_new_track=false
			set /a bat_track_linecount+=1
			

			if /i "!bat_track_linecount!" equ "2" (
				rem The FF*.bin line
				set bat_camera_temp=!bat_temp:~3,6!
				set bat_temp_track_file=!bat_detectdir!\SortDetect_!bat_camera_temp!.txt
				
				if not exist "!bat_temp_track_file!" (
					echo.!bat_save_line!>"!bat_temp_track_file!"
					echo.!bat_temp!>>"!bat_temp_track_file!"
				) else (
					echo.!bat_save_line!>>"!bat_temp_track_file!"
					echo.!bat_temp!>>"!bat_temp_track_file!"
				)
			) else (
				rem The rest of the track
				set /a bat_track_linecount+=1
				echo.!bat_temp!>>"!bat_temp_track_file!"
			)
		)
	)
	!bat_popecho! ^)
	
rem :SPLITDETECTFILE_END
!bat_popecho! [RETURN !bat_batchfile!:SPLITDETECTFILE] [!date! !time!, bat_track_count=!bat_track_count!]
!bat_echolog!
!bat_return!





REM THIS NEXT ROUTINE MAY COME ACROSS SOME PROBLEMS BECAUSE THE COMMAND LINE FOR THE COPY
REM WILL GET TOO BIG.  It may need to be merged two files at a time.
rem copy /y file1 outfile
rem move /y outfile infile
rem copy /y infile + file2 outfile
rem move /y outfile infile
rem copy /y infile+file3 outfile
rem move /y outfile infile
rem etc.

	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT [IN bat_detectfilefull  IN bat_detectdir]
!bat_pushecho! [CALL !bat_batchfile!:TEMPCONCAT] [%*]

	!bat_logexeclog! set bat_targetdir=%~2
	
	!bat_logexeclog! set bat_string= &	rem The result will be "000001"+"000002"+"000003"...

	set /a bat_linecount=0
	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetdir!\SortDetect_??????.txt" /b /a-d /on`^) do ...
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_targetdir!\SortDetect_??????.txt" /b /a-d /on`) do (
		if /i "%%a" neq "SortDetect_header.txt" (
			set /a bat_linecount+=1
			!bat_echolog! !bat_linecount!.  %%a

			if "!bat_linecount!" equ "1" (
				set bat_string="!bat_targetdir!\%%~a"
			) else (
				set bat_string=!bat_string!+"!bat_targetdir!\%%~a"
			)
		)
	)
	!bat_popecho! ^)
	
	!bat_logexec! COPY /y !bat_string!  "!bat_detectfilefull!"
	set bat_returncode=%errorlevel%


:TEMPCONCAT_END
!bat_popecho! [RETURN !bat_batchfile!:TEMPCONCAT] [bat_returncode=!bat_returncode!,
!bat_echolog! `                                         Copy String=!bat_string!]
!bat_echolog!
!bat_return!






	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETMETEORCOUNT] []
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "!bat_detectfilefull!"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
:GETMETEORCOUNT
!bat_popecho! [RETURN !bat_batchfile!:GETMETEORCOUNT] [Meteor Count=!bat_count!]
!bat_echolog!
!bat_return!









	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
!bat_pushecho! [CALL !bat_batchfile!:REBUILDHEADER] [%*]


	!bat_echolog! bat_temp_meteorcountfile="!bat_temp_meteorcountfile!"
	!bat_logexec! TYPE "!bat_temp_headerfile!"
	echo.

	set /a bat_linecount=0
	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`TYPE "!bat_temp_headerfile!"`^) do ^(
	for                /f "usebackq tokens=*" %%a in  (`TYPE "!bat_temp_headerfile!"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!
			echo Meteor Count = !bat_count!>"%bat_temp_meteorcountfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_detectdir!\
				echo !bat_FFfolder!>>"%bat_temp_meteorcountfile%"
				set bat_FFfolder=!bat_FFfolder:~13!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_exedir!\Cal\
					echo !bat_CALfolder!>>"%bat_temp_meteorcountfile%"
					set bat_CALfolder=!bat_CALfolder:~13!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_temp_meteorcountfile%"
				)
			)
		)
	)
	!bat_popecho! ^)

:REBUILDHEADER_END
!bat_popecho! [RETURN !bat_batchfile!:REBUILDHEADER] [Meteor Count = !bat_count!, bat_linecount=!bat_linecount!, "!bat_temp_meteorcountfile!"]
!bat_echolog!
!bat_return!









:CONCATFINAL
!bat_pushecho! [CALL !bat_batchfile!:CONCATFINAL] [!bat_temp_meteorcountfile!, !bat_string!, !bat_detectfilefull!]

	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`COPY /y /b "!bat_temp_meteorcountfile!"+!bat_string! "!bat_detectfilefull!"`^)
	for                /f "usebackq tokens=*" %%a in  (`COPY /y /b "!bat_temp_meteorcountfile!"+!bat_string! "!bat_detectfilefull!"`) do (
		!bat_echolog! `      %%a
	)
	!!bat_popecho! ^)


	if defined bat_temp_meteorcountfile (
		!bat_logexec! DEL /Q "!bat_temp_meteorcountfile!"
	) else (
		!bat_echolog! ERROR [!bat_batchfile!:CONCATFINAL] Dangerous command: DEL /Q "!bat_temp_meteorcountfile!"
	)
	!bat_echolog!

	if not exist "!bat_detectfilefull!" (
:CONCATPROMPT
		!bat_echolog!
		!bat_echolog! Merging the split files seems to have failed and there is not an "!bat_detectfilefull!"
		!bat_echolog! file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		!bat_echolog! the following command:
		!bat_echolog! %~0 %*
		!bat_echolog!
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" (set bat_returncode=7&goto :CONCATFINAL_END)
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" (set bat_returncode=8&goto :CONCATFINAL_END)
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_detectdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE

:CONCATFINAL_END

!bat_popecho! [RETURN !bat_batchfile!:CONCATFINAL] [bat_detectfile=!bat_detectfile!]
!bat_echolog!
!bat_return!







:PREVIEW
!bat_pushecho! [CALL !bat_batchfile!:PREVIEW] [!bat_temp_meteorcountfile!, !bat_string!, !bat_detectfile!]

	!bat_pushecho!
	!bat_echolog! `     Date/Time           Size           File name
	!bat_echolog! `     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfilefull!" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		!bat_echolog! `     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	!bat_echolog!

	!bat_echolog! `    Excerpt from "!bat_detectfile!". Please review the
	!bat_echolog! `    information obtained from the "!bat_detectfile!" file: 
	!bat_echolog! `       - Meteor Count   [should be !bat_count!]
	!bat_echolog! `       - FF folder      [should be "!bat_targetdir!"]
	!bat_echolog! `       - CAL folder     [should match the drive and dir where your Cal files are stored]
	!bat_echolog! `       - Cal file       [May not be correct, if not, Don't skip the Apply process]
	!bat_echolog!
	!bat_echolog! `    Please wait while opening and displaying the first 14 lines from 
	!bat_echolog! `    the "!bat_detectfile!" file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_temp_headerfile!"`) do (
rem	for /f "usebackq tokens=*" %%a in (`type "!bat_detectfile!"`) do 
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			!bat_echolog! `         %%a
		) else (
			if !bat_counter! equ 15 (
				!bat_echolog!
				!bat_echolog! `     Please wait while skipping the rest of the file... [!time!]
			)
		)
	)
	!bat_popecho!


:PREVIEW_END
!bat_popecho! [RETURN !bat_batchfile!:PREVIEW] [bat_detectfile=!bat_detectfile!]
!bat_echolog!
!bat_return!



:CLEANUP
!bat_pushecho! [CALL !bat_batchfile!:CLEANUP] [!bat_temp_meteorcountfile!, !bat_string!, !bat_detectfile!]

	!bat_logexec! MOVE /y "!bat_detectdir!\SortDetect_CameraList.txt" "!bat_detectdir!\CameraList.txt"

	!bat_logexec! DEL /q "!bat_detectdir!\SortDetect*.*"
	
	!bat_logexec! DEL /q "!bat_save_detectfile!"

	!bat_logexec! MOVE /y "!bat_detectdir!\CameraList.txt"  "!bat_detectdir!\SortDetect_CameraList.txt" 

:CLEANUP_END
!bat_popecho! [RETURN !bat_batchfile!:CLEANUP] [bat_detectfile=!bat_detectfile!]
!bat_echolog!
!bat_return!






:MARK_AS_SORTED
!bat_pushecho! [CALL !bat_batchfile!:MARK_AS_SORTED] [%1 %2 %3 %4 %5 %6]

	echo.!date! !time!>"!bat_sorted_mark_file!"

:MARK_AS_SORTED_END
!bat_popecho! [RETURN !bat_batchfile!:MARK_AS_SORTED] [bat_sorted_mark_file=!bat_sorted_mark_file!]
!bat_echolog!
!bat_return!





:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
:STRIPZEROS_END
EXIT /b
!bat_return!






	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
	rem		IN	"!bat_fffoldersrc!"
	rem		IN	"!bat_detect?dir!"
	rem		IN	"!bat_countsrc!"
	rem		IN	"!bat_countdest!"
:REBUILDHEADER
!bat_echolog! call :REBUILDHEADER %*
setlocal enabledelayedexpansion enableextensions
	set bat_fffoldersrc=%~1
	set bat_targetdir=%~2
	set bat_countsrc=%~3
	set bat_countdest=%~4

	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_targetdir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	!bat_echolog! `    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	set bat_findstr_c=!bat_countsrc!

	set bat_replstr_c=!bat_countdest!

	!bat_echolog! `    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	set bat_findstr=!bat_calfoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=CAL folder = !bat_caldir!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	!bat_echolog! `    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	echo.
	echo.
	echo  type "!bat_caseheaderfile!"
	echo.
	for /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"`) do (
		echo     %%~a
	)
	echo.
	echo.
!bat_echolog! return-:REBUILDHEADER [see output above from the command: type "!bat_caseheaderfile!"]
endlocal
%bat_return%






:CONCATFINAL
!bat_echolog! call :CONCATFINAL [%*]
	set bat_targetdir=%~1
	set bat_targetname=%~2
	set bat_targetfilefull=%~3
	set bat_temp_camera=%~4
	set bat_temp_captureddir=%~5

	echo     copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"
	         copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"

	if defined bat_caseheaderfile (
		echo '    del "!bat_caseheaderfile!"
				  del "!bat_caseheaderfile!"
	) else (
			!bat_echolog! ERROR [!bat_batchfile!:CONCATFINAL] Dangerous command:  del "!bat_caseheaderfile!"
	)
	
	if defined bat_targetdir (
		if defined bat_temp_targetfilename (
			echo '    del "!bat_targetdir!\!bat_temp_targetfilename!"
					  del "!bat_targetdir!\!bat_temp_targetfilename!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CONCATFINAL] Dangerous command: del "!bat_targetdir!\!bat_temp_targetfilename!" 
		)
	) else (
			!bat_echolog! ERROR [!bat_batchfile!:CONCATFINAL] Dangerous command:  del "!bat_targetdir!\!bat_temp_targetfilename!"
	)
	          
	if /i "!bat_targetdir!" neq "!bat_detectdir!" (
		!bat_echolog! `    move /y "!bat_detectdir!\FF!bat_temp_camera!_*.bin" "!bat_targetdir!"
		                   move /y "!bat_detectdir!\FF!bat_temp_camera!_*.bin" "!bat_targetdir!"

		!bat_echolog! `    copy /y "!bat_detectdir!\CameraTimeOffsets.txt" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\CameraTimeOffsets.txt" "!bat_targetdir!"

		!bat_echolog! `    copy /y "!bat_detectdir!\CaptureStats.log" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\CaptureStats.log" "!bat_targetdir!"

		!bat_echolog! `    copy /y "!bat_detectdir!\ReprocessParameters.txt" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\ReprocessParameters.txt" "!bat_targetdir!"

		!bat_echolog! `    copy /y "!bat_detectdir!\LASTSETTINGS.txt" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\LASTSETTINGS.txt" "!bat_targetdir!"

		if not exist "!bat_temp_captureddir!" (
			md "!bat_temp_captureddir!"
		)
		
		!bat_echolog! `    move /y "!bat_capturedfilesdirA!\FF!bat_temp_camera!_*.bin" "!bat_temp_captureddir!"
		                   move /y "!bat_capturedfilesdirA!\FF!bat_temp_camera!_*.bin" "!bat_temp_captureddir!"
	)
	
set bat_

	echo.
	if not exist "!bat_targetfilefull!" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command:
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE
:CONCATFINAL_END
!bat_echolog! return-:CONCATFINAL ["!bat_targetfilefull!"]
%bat_return%






















































	rem This routine puts a header file into the targetdir. If it can't copy one from 
	rem C:\CAMS, it creates a new one.
:CREATECASEHEADER
!bat_echolog! call :CREATECASEHEADER %*

	if exist "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" (
		echo '    copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
		          copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
	) else (
		echo Meteor Count = 000000>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Processed with FTP 1.3 on Tue Feb 28 00:00:00 2012>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  folder = c:\d\CAMS\ArchivedFiles\2011_12_29_10_05_22\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL folder = c:\d\CAMS\Cal\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Cam# Meteor# #Segments fps hnr mle bin Pix/fm Rho Phi>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Per segment:  Frame# Col Row RA Dec Azim Elev Inten>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"

	)
!bat_echolog! return-:CREATECASEHEADER ["!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"]
!bat_return!






		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"

		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)
	
	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	set bat_calfolder=!bat_targetdir!\Cal

	rem convert bat_fffoldersrc to C-style string
	set bat_fffoldersrc_c=!bat_fffoldersrc:\=\\!
	set bat_fffoldersrc_c=!bat_fffoldersrc_c::=\:!
	
	set bat_fffolderdest=!bat_targetdir!\ArchivedFiles\
	set bat_fffolderdest_c=!bat_fffolderdest:\=\\!
	set bat_fffolderdest_c=!bat_fffolderdest_c::=\\!

	!bat_echolog! `    call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"


	!bat_echolog! `    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!

	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! `    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! `    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!



	rem temporary concat to fix the meteor count
	rem This section concats without the header
	rem Result: New "FTPdetectinfo.txt" file n the target dir.
:TEMPCONCAT
!bat_echolog! call :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetdir!\!bat_sourcefilespecname!_stripped.txt" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetdir!\!bat_sourcefilespecname!_stripped.txt" /b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%bat_targetdir%\%%~a"
		) else (
			set bat_string=!bat_string!+"%bat_targetdir%\%%~a"
		)
	)
	!bat_echolog! `    copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"
	                   copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"

	set bat_caseheaderfile=!bat_targetdir!\FTPdetectinfo_CaseHeader.txt

!bat_echolog! return-:TEMPCONCAT [!bat_string!]
%bat_return%




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT [out=bat_count]
!bat_echolog! call :GETMETEORCOUNT %*
	if not exist "!bat_targetdir!\!bat_targetname!" (
		!bat_echolog! `    ERROR - file not found: "!bat_targetdir!\!bat_targetname!"
		set bat_returncode=1
		goto :ABORT
	)
	
	
	!bat_echoonly! `    for /f "usebackq tokens=1-4" ..a in ^(`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`^) do ^(
	for                     /f "usebackq tokens=1-4" %%a in  (`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`) do (
		!bat_echoonly! `    set bat_count=%%c
		                    set bat_count=%%c
	)

	!bat_echoonly! `    for /f "usebackq tokens=*" a in ^(`type "!bat_caseheaderfile!" find /i "Meteor Count = "`^) do ^(
	for                     /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"^|find /i "Meteor Count = "`) do (
		!bat_echoonly! `    set bat_countsrc=%%a
		                    set bat_countsrc=%%a
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
	set bat_countdest=Meteor Count = !bat_count!


!bat_echolog! return-:GETMETEORCOUNT [!bat_countdest!]
%bat_return%



:FIXFFFOLDER [out=bat_fffoldersrc]
!bat_echolog! call :FIXFFFOLDER %*
	set bat_fffoldersrc=
	!bat_echoonly! `    for /f "usebackq tokens=* skip=2"   a in ^(`find /i "FF  folder = " "!bat_sourcedir!\!bat_targetname!"`^) do ^(
	                    for /f "usebackq tokens=* skip=2" %%a in  (`find /i "FF  folder = " "!bat_sourcedir!\!bat_targetname!"`) do (
		set bat_fffoldersrc=%%a
	)
	
	!bat_echolog! `    bat_fffoldersrc=!bat_fffoldersrc!
	
	if not defined bat_fffoldersrc (
		goto :FIXFFFOLDER_END
	)
	
	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_sourcedir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=!bat_sourcedir!\!bat_targetname!
	
	
	!bat_echolog! `    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_detectfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_detectfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	
:FIXFFFOLDER_END
!bat_echolog! return-:FIXFFFOLDER ["!bat_fffoldersrc!"]
!bat_return!


:GETCALFOLDER [out=bat_calfoldersrc]
!bat_echolog! call :GETCALFOLDER %*
	!bat_echoonly! `    for /f "usebackq tokens=*" a in ^(`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`^) do ^(
	for                    /f "usebackq tokens=*" %%a in (`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`) do (
		set bat_calfoldersrc=%%a
	)
!bat_echolog! return-:GETCALFOLDER ["!bat_calfoldersrc!"]
!bat_return!






















































:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF_??????_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF_??????_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~3,6!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! call :GETMETEORCOUNTARCHIVED %*
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
           
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				set bat_latestcal=
				set /a bat_archivedmeteorcount=0
				
				goto :GETMETEORCOUNTARCHIVED_END
			)
		)
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! return-:GETMETEORCOUNTARCHIVED [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%




:GETCONFIRMEDCOUNT
!bat_echolog! call :GETCONFIRMEDCOUNT %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
				goto :GETCONFIRMEDCOUNT_END
			)
		)
	)


	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_echolog! return-:GETCONFIRMEDCOUNT [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, !bat_confirmdetect!]
%bat_return%




:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF_??????_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~3,6!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%






:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%







:VARIABLES
	set bat_
	pause
%return%


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)

	!bat_echolog! `    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!
	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! `    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! `    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!




:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "<detect file>" "<capture dir>"
	echo.
	echo Example: 
	echo   sortdetect "c:\CAMS\ArchivedFiles\2012_07_14_05_12_29\FTPdetectinfo_02160213_2012_07_14.txt" "C:\CAMS\CapturedFiles\2012_07_14_04_34_59"
	echo.
	echo Reorganizes the detect file in camera order. 
	echo.
	echo.The script will not run if it detets that a SortDetect_sorted.log file
	echo.already exists in the detect file's directory.  To force a sort, the 
	echo.user can either delete the "SortDetect_Sorted.log" file or
	echo.use the /forcesort flag. 
	echo.
	echo.There is no need to accommodate long camera numbers [firstlast] because it uses the 
	echo.directory name for the session date.  Problems will occur if the detect file is not 
	echo.in a directory named after the session. 
	echo.
	echo.

exit /b -99

Needs:
	- 
	
:ABORT
	!bat_popecho! [!date!, !time!] !bat_batchfile!:DONE] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! `    ABORTING
	!bat_echolog! `    bat_returncode=!bat_returncode!
	echo Done with %0 %*
	echo.
	!bat_prompt! Press Enter to continue [ddd to debug]: 
exit /b !bat_returncode!

:DONE
	!bat_popecho! [!date!, !time!] !bat_batchfile!:DONE] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	rem call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
exit /b !bat_returncode!