@echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem
rem StageFromConfirmed.bat


	REM #################################################################
	REM 
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	
	REM #################################################################
	REM 
:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
	)

	if not defined bat_autonomous (
		!bat_echolog! Running in normal [non-autonomous] mode
		set bat_archivedfilesdir=%~1
		set bat_capturedfilesdir=%~2
		set bat_camera=%~3
		rem set bat_confirmedfilesdir=%~3
		rem set bat_camera=%~4

		set bat_archiveddirname=%~nx1

		set bat_captureddirname=%~nx2
	) else (
		!bat_echolog! Running in autonomous mode

		set bat_archivedfilesdir=%~1
		set bat_archiveddirfull=!bat_archivedfilesdir!

		set bat_temp_dirname=%~nx1
		set bat_temp_date=!bat_temp_dirname:~0,10!
		set bat_temp_time=!bat_temp_dirname:~11,8!
		set bat_temp_path1=%~dp1&	rem C:\CAMS\ArchivedFiles\
		set bat_temp_path2=!bat_temp_path1:~0,-15!
		
		set bat_archiveddirname=!bat_temp_dirname!

		if "%~2" neq "" (
			set bat_capturedfilesdir=%~2
			set bat_captureddirname=%~nx2
		) else (
			!bat_echolog! `   ERROR - 2nd command line argument missing - should contain the path to the CapturedFiles dir
			goto :HELP
		)
		
		if /i "%~3" neq "" (
			set bat_camera=%~3
		) else (
			!bat_echolog! `    Missing camera in 3rd command line argument.
			goto :HELP
		)
	)& rem // else // if not defined bat_autonomous


	set bat_archiveddate=!bat_archiveddirname:~0,10!
	set bat_archivedtime=!bat_archiveddirname:~-8!

	set bat_captureddate=!bat_captureddirname:~0,10!
	set bat_capturedtime=!bat_captureddirname:~-8!

	!bat_log!

	!bat_log! goto !bat_batchfile!:SETUP %*
	
rem	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
rem	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
rem		!bat_echolog! `     ERROR: You must start from x:\CAMS directory. 
rem		exit /b 1
rem	)
	

	call :PARSEARGS %*
	
	!bat_logexeclog! set bat_caldir=!bat_startlocation!\Cal
	!bat_logexeclog! set bat_caldir_BinFiles=!bat_startlocation!\Cal\BinFiles

	set bat_validatefile=!bat_logdir!\%~nx0.validate.log
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	
	if not exist "!bat_mainspec!\!bat_getdirname!" (
		!bat_echolog! `     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		!bat_log! `     bat_mainspec=!bat_mainspec!
	)
	
	rem call :READPARAMS

goto :MAIN %*







	REM #################################################################
	REM 
:PARSEARGS 
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*
	set bat_arg1=%~1
	set bat_getdirname=%~nx1
	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_mainfilter=^|find /i "!bat_getdirname!"

	
	!bat_log! `     bat_autonomous=!bat_autonomous!

	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			!bat_log! `     Format 1: x:\CAMS\ArchivedFiles\datetime
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			rem set bat_startdrive=!bat_arg1:~0,2!
			rem set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			!bat_log! `     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			echo.%~1|find /i /c "ArchivedFiles\"
			set bat_returncode=!errorlevel!
			!bat_log! `     !bat_returncode!
			if !bat_returncode! equ 0 (
				!bat_log! `     Format 2: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				!bat_log! `     Format 3: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
	
	
	set bat_dirname=!bat_getdirname!
	set bat_dirdate=!bat_dirname:~0,10!
	set bat_dirtime=!bat_dirname:~11,8!
	
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] bat_dirname=!bat_dirname!, bat_mainspec=!bat_mainspec!]
!bat_return!





	REM #################################################################
	REM 
:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	rem start the execution of the detection pass in background priority
	set bat_returncode=0
	set bat_retval=failed

	!bat_log! [!date! !time!]
	!bat_logexeclog! set bat_

	call :GETDIRNAMES "!bat_mainspec!"
	
!bat_logexec! set bat_
exit /b 0

	!bat_log! [!date! !time!] !bat_batchfile!:MAIN
	
	!bat_log! ---------------------------------------------------
	!bat_logexeclog! set bat_
	!bat_logexeclog! type "!bat_paramsfile!"
	!bat_logexeclog! type "!bat_configfile!"

	!bat_poplog!

	if "!bat_retval!" equ "success" (
		!bat_echolog!
		!bat_echolog! Done with %~nx0 %*
		!bat_echolog! `    SUCCESS


		!bat_logexec! set bat_submissionlogsdir=!bat_submissionfilesdir!\!bat_camera!\Logs
		!bat_logexec! MD "!bat_submissionlogsdir!"

		rem Change the settings so that log files belong to the captureddate from now on...
		!bat_CALLecho! "!bat_exedir!\RedirectLogs.bat" "!bat_logdir!" "!bat_submissionlogsdir!"
		
		!bat_echolog! MOVE /y "!bat_camsdir!\Logs\*.*"    "!bat_submissionlogsdir!"
		              MOVE /y "!bat_camsdir!\Logs\*.*"    "!bat_submissionlogsdir!"
		!bat_poplog!

		set bat_returncode=0
	) else (
		!bat_echolog!
		!bat_echolog! Done with %0 %*
		!bat_echolog! `    FAILED [bat_returncode=!bat_returncode!]
		!bat_echolog!

		set bat_returncode=1
	)
:MAIN_END
!bat_poplog! [END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!, goto :DONE]
	if exist "junk.txt" (del /q "junk.txt")
!bat_log!
goto :DONE








	REM #################################################################
	REM 
:GETDIRNAMES
!bat_pushlog! [CALL !bat_batchfile!:GETDIRNAMES] [%*]

	set bat_retval=failed
	set bat_camera_save=!bat_camera!

		rem Loop to iterate through all directory names under the ..\ArchivedFiles structure.
		rem For example, this FOR loop command will be something like:
		rem     ^(`dir "c:\cam213\CAMS\ArchivedFiles\2015_01_04_02_10_01*" /s/b /ad /on`^)
		rem Because of the asterisk "*", the value returned will be:
		rem     c:\cam213\CAMS\ArchivedFiles\2015_01_04_02_10_01
		rem 
		rem Without the asterisk, the whole directory would be skipped.  The * is
		rem being used to support a case where someone may have renamed the dir
		rem with some kind of suffix, like 
		rem     c:\cam213\CAMS\ArchivedFiles\2015_01_04_02_10_01_backup
		rem 
		rem It will likely always enter the loop.

	!bat_log!
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!*" /s/b /ad /on`^) do xxx
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!*" /s/b /ad /on`) do (
		REM The variable %%a will be something like this: c:\CAMS\ArchivedFiles\2017_09_15_03_00_00
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_log! %%~a
					!bat_log!


					set bat_archiveddirfull=%%a&		rem C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
					set bat_dirname=%%~nxa&				rem 2011_08_15_04_28_20
					set bat_dirdate=!bat_dirname:~0,10!
					set bat_dirtime=!bat_dirname:~11,8!
					set bat_dir_datetime=!bat_dirname:~0,19!
rem					set bat_captureddate=!bat_dirdate!

!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 0 - bat_archiveddirfull="!bat_archiveddirfull!"
					call :GETDETECTFILE "bat_detectfile" "!bat_archiveddirfull!"
					if !bat_returncode! neq 0 (
						!bat_log! `  aborting.
						goto :GETDIRNAMES_END
					)
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 1 - bat_caldir="!bat_caldir!"

					call :GETDETECTFILE_PARSE "!bat_detectfile!"
					set bat_detectfile=!bat_detectfile1!
					set bat_detectfile_filename=!bat_detectfile4!
					set bat_detectfile_file=!bat_detectfile3!

					if not defined bat_camera (
						call :GETCAMERAFROMDETECT "bat_archiveddirfull"
					)

!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 2 - bat_caldir="!bat_caldir!"

					set bat_confirmeddirfull=!bat_archiveddirfull!
					set bat_confirmeddirfull=!bat_confirmeddirfull:ArchivedFiles=ConfirmedFiles!
					call :GETDETECTFILECONF "bat_detectfileconf" "!bat_confirmeddirfull!"
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 3 - bat_caldir="!bat_caldir!"

					if not defined bat_detectfileconf (
						!bat_log! `  WARNING [!bat_returncode!]- No detect file found in "!bat_confirmeddirfull!"
						!bat_log! `            Continuing anyway..."!bat_detectfileconf!"
					) else (
						if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
							!bat_log! `  WARNING - No detect file found in "!bat_confirmeddirfull!". 
							!bat_log! `            Continuing anyway..."!bat_detectfileconf!"
							!bat_log!
						) else (
							call :GETDETECTFILE_PARSE "!bat_detectfileconf!"
							set bat_detectfileconf=!bat_detectfile1!
							set bat_detectfileconf_filename=!bat_detectfile4!
							set bat_detectfileconf_file=!bat_detectfile3!
						)
					)
					
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 4 - bat_caldir="!bat_caldir!"



						rem Note: The date/time in the CapturedFiles directory will be different
						rem       than the date/time in the ArchivedFiles directory.  This is 
						rem       because the date/time of the CapturedFiles directory is 
						rem       the date/time when the directory was created, which is
						rem       several seconds before the end of the first 8 second video
						rem       section.  The date/time of the ConfirmedFiles and ArchivedFiles
						rem       directory is the date/time of the first file in the CapturedFiles
						rem       directory.
					set bat_yyyymmdd=!bat_dirname:~0,10!&	rem 2015_01_04_02_10_01
					set bat_captureddir=%bat_startlocation%\CapturedFiles\!bat_dirdate!&	rem C:\CAMS\CapturedFiles\2015_01_04_02_10_01
					if /i "!bat_capturedfilesdir!" neq "" (
						set bat_captureddir=!bat_capturedfilesdir!
					)

					!bat_logexeclog! set bat_submissionfilesdir=%bat_startlocation%\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!
					set bat_submissiondir=!bat_submissionfilesdir!\!bat_camera!
					set bat_submitcapturedbase=!bat_submissiondir!\CapturedFiles
					
					set bat_submitarchived=!bat_submissiondir!\ArchivedFiles\!bat_dirname!
					set bat_submitconfirmed=!bat_submissiondir!\ConfirmedFiles\!bat_dirname!
					set bat_submitcal=!bat_submissiondir!\Cal
					
					set bat_submissionlogsdir=!bat_submissiondir!\Logs\!bat_captureddate!_!bat_capturedtime!

					set bat_confirmeddirfull=%bat_startlocation%\ConfirmedFiles\!bat_dirname!
					set bat_emailfilesdir=!bat_submissiondir!\EmailFiles


					if "!bat_dirname!" equ "" (
						set bat_retval=failed
						set bat_returncode=1
						!bat_log!
						!bat_log!
						!bat_log! `  ERROR - bat_dirname="!bat_dirname!"   ArchivedFiles dir="%%a"
						!bat_log!
						!bat_log!
					) else (
						call :CREATEDIRS "!bat_dirname!"
					
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 5 - bat_caldir="!bat_caldir!"

						call :MOVEFILES "!bat_dirname!"
						if "!bat_retval!" equ "failed" (
							set bat_returncode=1
							goto :GETDIRNAMES_END
						)
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 6 - bat_caldir="!bat_caldir!"

						set bat_GCFC_tempfile=!bat_submitcapturedbase!\!bat_captureddirname!\GCFC.log
						
						if not exist "!bat_GCFC_tempfile!" (
							!bat_START! /wait "Please Wait - CreateCameraListFile.bat - [!bat_capturedfilesdir!]" /low cmd /c ""!bat_exedir!\CreateCameraListFile.bat" "!bat_submitcapturedbase!\!bat_captureddirname!""
							!bat_TITLE!
						)

						call :READFILE
						if "!bat_retval!" equ "failed" (
							set bat_returncode=1
							goto :GETDIRNAMES_END
						)


!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 7 - bat_caldir="!bat_caldir!"
						!bat_log!
						!bat_log! `...Still in :GETDIRNAMES
						
							!bat_echolog! Now, iterate through the CalFileList.log to copy the cal files
							!bat_echolog! and their corresponding FF files...
						!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`type "!bat_emailfilesdir!\CalFileList.log"`^) do...
						for               /f "usebackq tokens=*" %%a in  (`type "!bat_emailfilesdir!\CalFileList.log"`) do (
							set bat_calfilename=%%a
							rem set bat_camera=!bat_calfilename:~4,6!
							!bat_log! call :COPYCALFILE "!bat_calfilename!" "!bat_calfilename:~4,6!"
							          call :COPYCALFILE "!bat_calfilename!" "!bat_calfilename:~4,6!"
						)
						!bat_poplog!
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 8 - `    !bat_batchfile!:GETDIRNAMES.PROCESS_CALFILES_END
						set bat_countconfirmed=0
						if exist "!bat_submitconfirmed!" (

							call :STRIPHEADER bat_countconfirmed "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "confirmed" "!bat_confirmedmeteorcount!"

							call :GETEVENTCOUNT "!bat_emailfilesdir!\FTPdetectinfo_!bat_camera!_!bat_dir_datetime!_confirmed.txt"

						)
						
!bat_echolog! !bat_batchfile!:GETDIRNAMES Step 9 - bat_caldir="!bat_caldir!"

						set bat_countarchived=0
						call :STRIPHEADER bat_countarchived  "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "scanned" "!bat_archivedmeteorcount!"

						call :GETEVENTCOUNT "!bat_readfile!"


						call :COUNTFILE !bat_archivedcount! !bat_countconfirmed!


						!bat_CALL! "!bat_exedir!\GetDetectFile.bat" bat_detect_submit "!bat_submitarchived!"

%bat_COMMENT_BEGIN%
						if exist "!bat_submitarchived!\FTPdetectinfo.txt" (
							!bat_logexeclog! move /y "!bat_submitarchived!\FTPdetectinfo.txt" "!bat_submitarchived!\FTPdetectinfo_!bat_camera!_!bat_dir_datetime!.txt"
						)
						
						if exist "!bat_submitarchived!\FTPdetectinfo_!bat_camera!_!bat_dirdate!.txt" (
							!bat_logexeclog! move /y "!bat_submitarchived!\FTPdetectinfo_!bat_camera!_!bat_dirdate!.txt" "!bat_submitarchived!\FTPdetectinfo_!bat_camera!_!bat_dir_datetime!.txt"
						)
						
						if exist "!bat_submitconfirmed!\FTPdetectinfo.txt" (
							!bat_logexeclog! move /y "!bat_submitconfirmed!\FTPdetectinfo.txt" "!bat_submitconfirmed!\FTPdetectinfo_!bat_camera!_!bat_dir_datetime!.txt"
						)
						
						if exist "!bat_submitconfirmed!\FTPdetectinfo_!bat_camera!_!bat_dirdate!.txt" (
							!bat_logexeclog! move /y "!bat_submitconfirmed!\FTPdetectinfo_!bat_camera!_!bat_dirdate!.txt" "!bat_submitconfirmed!\FTPdetectinfo_!bat_camera!_!bat_dir_datetime!.txt"
						)
%bat_COMMENT_END%

						!bat_echolog!
						!bat_echolog!
						!bat_echolog!
						!bat_echolog!
						!bat_echolog!
						!bat_echolog!
						!bat_echolog!
						!bat_echolog! Now copying files to the "Submitted" dir for the session...
						!bat_echolog!
						!bat_CALLecho! "!bat_exedir!\submit.email.bat" "!bat_dirdate!" "!bat_camera!" "!bat_submissionfilesdir!" !bat_autonomous!
						set bat_returncode=!errorlevel!
						!bat_TITLE!
						!bat_echolog!

						if "!bat_returncode!" neq "0" (
							!bat_log! set bat_retval=failed
							rem goto :GETDIRNAMES_END
						)
REM REMOVING THE ELSE CLAUSE AS A QUICK WORKAROUND FOR AUTONOMOUS PROCESSING						
							!bat_log! !bat_batchfile!:GETDIRNAMES returned from submit.email.bat

							call :VALSUBMIT %*
							!bat_log! ` [!bat_batchfile!:GETDIRNAMES] returned from VALSUBMIT
						
					)& rem else
				)& rem if /i "%%~nxa" neq "gefdat"
			)& rem if /i "%%~nxa" neq "displayJPEGS"
		)& rem if /i "%%~nxa" neq "movies"
	)&	rem end of for /f %%a in ^(`dir "!bat_mainspec!" /s/b /ad /on ^!bat_mainfilter! 2^>nul`^)
	!bat_pop!
	
	set bat_retval=success

:GETDIRNAMES_END
!bat_poplog! [RETURN !bat_batchfile!:GETDIRNAMES] [bat_retval=!bat_retval!, bat_returncode=!bat_returncode!, bat_submissiondir=!bat_submissiondir!]
!bat_log!
!bat_return!




	REM #################################################################
	REM 
:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_return!





	REM #################################################################
	REM 
	rem usage: call :CREATEDIRS "!bat_dirname!"
:CREATEDIRS
!bat_pushlog! [CALL !bat_batchfile!:CREATEDIRS] %*

	if not exist "!bat_emailfilesdir!" (
		REM 08/11/2017 !bat_logexeclog! md "!bat_emailfilesdir!"
	)
		     
rem	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!" (
rem		REM 08/11/2017 !bat_logexeclog! md "!bat_emailfilesdir!\Cal-!bat_camera!"
rem	)

	if not exist "!bat_submissiondir!\ArchivedFiles" (
		!bat_logexeclog! md "!bat_submissiondir!\ArchivedFiles"
	)
	     
	if not exist "!bat_submissiondir!\ConfirmedFiles" (
		!bat_logexeclog! md "!bat_submissiondir!\ConfirmedFiles"
	)
	     
	if not exist "!bat_submitcal!" (
		!bat_logexeclog! md "!bat_submitcal!"
	)
	     
	if not exist "!bat_submitcapturedbase!" (
		!bat_logexeclog! md "!bat_submitcapturedbase!"
	)
	
	if not exist "!bat_submissionlogsdir!" (
		!bat_logexeclog! md "!bat_submissionlogsdir!"
	)
!bat_poplog! [CALL !bat_batchfile!:CREATEDIRS] []
!bat_log!
!bat_return!





	REM #################################################################
	REM 
:GETCALFILENSTARS [in] "C:\CAMS\Cal\CAL299_20120101_015800_519.txt"
!bat_pushlog! [CALL !bat_batchfile!:GETCALFILENSTARS] [in] "C:\CAMS\Cal\CAL299_20120101_015800_519.txt"
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "%~1"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	!bat_log! Cal stars used: !bat_calfilestars!

!bat_poplog! [RETURN !bat_batchfile!:GETCALFILENSTARS] [!bat_calfilestars!]
!bat_log!
!bat_return!





	REM #################################################################
	REM 
:MOVEFILES
!bat_pushlog! [CALL !bat_batchfile!:MOVEFILES] %*

	set bat_retval=success

	if not exist "!bat_emailfilesdir!" (
		!bat_echolog!
		!bat_echolog! ******* Making the target EmailFiles dir   *************
		!bat_echolog! ******* "!bat_emailfilesdir!"

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_logexeclog! MKDIR "!bat_emailfilesdir!"
		
		!bat_echolog!
	)


	!bat_CALLecho! "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs\!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!" 

	
	!bat_echolog!
	!bat_echolog! ******* Checking for ArchivedFiles Detect file   *************

	!bat_logexeclog! set bat_detect

	!bat_pushlog! if not exist "!bat_detectfile!" ^(
		if           not exist "!bat_detectfile!"  (
			!bat_push!
				!bat_echolog!
				!bat_echolog! `    NOT FOUND: "!bat_detectfile!"
				!bat_echolog!
				!bat_echolog! `    Sometimes you may fail to be able to have any scanned 
				!bat_echolog! `    meteors or tracks ^(e.g. completely overcast^). 
				!bat_echolog!

				if not defined bat_autonomous (
:MOVEFILES_ASK0
					!bat_prompt! If that is the case, [C]ontinue, otherwise [Q]uit and fix the problem. 
					!bat_echolog!

					if /i "!bat_choice!" equ "q" (
						set bat_retval=failed
						!bat_echolog! [:MOVEFILES] FAILED - NOT FOUND: "!bat_detectfile!"
							!bat_pop! //Extra pops due to early exit
							!bat_pop!
						goto :MOVEFILESEND
					)

					if /i "!bat_choice!" neq "c" (
						goto :MOVEFILES_ASK0
					)
				)

				rem If you get to here, the user pressed "c" to continue without the detect file 
				rem OR it's running int autonomous mode and we need to continue anyway without the
				rem detect file...

			!bat_poplog!
		) else (
			!bat_push!
				!bat_log! ...it exists.
			!bat_popecho!
		)
    !bat_poplog!

:MOVEFILES1A
!bat_log! [!bat_batchfile!:MOVEFILES1A]

	!bat_echolog!
	!bat_pushecho! ******* Checking for ConfirmedFiles Detect file   *************

    set bat_detectfileconf=!bat_confirmeddirfull!\!bat_detectfile4!
    set bat_detectfileconf2=!bat_detectfile4!

	!bat_log! bat_confirmeddirfull=!bat_confirmeddirfull!
	!bat_logexeclog! set bat_detectfileconf

	!bat_pushlog! if not exist "!bat_detectfileconf!" ^(
		if               not exist "!bat_detectfileconf!" (
				!bat_push!
					!bat_echolog!
					!bat_echolog! `  OK - NOT FOUND: "!bat_detectfileconf!"
					!bat_echolog!
					!bat_echolog! `       Sometimes you may fail to be able to have any confirmed 
					!bat_echolog! `       meteors or tracks ^(e.g. completely overcast^). 
					!bat_echolog!

					goto :MOVEFILES_ASK2
					if not defined bat_autonomous (
:MOVEFILES_ASK1
						!bat_prompt! If that is the case, [C]ontinue, otherwise [Q]uit and fix the problem. 

						if /i "!bat_choice!" equ "q" (
							set bat_retval=failed
							!bat_pop! // Extra pops due to early exit
							!bat_popecho! Aborting :MOVEFILES
							goto :MOVEFILESEND
						)

						if /i "!bat_choice!" neq "c" (
							goto :MOVEFILES_ASK1
						)
					)

:MOVEFILES_ASK2
				rem If you get to here, the user pressed "c" to continue without the detectconf file 
				rem OR it's running int autonomous mode and we need to continue anyway without the
				rem detectconf file...

			!bat_popecho!
			
				rem Since the confirmed dir isn't there, skip the copy/rename, and RadiantAssoc steps...
			goto :MOVEFILES2

			rem if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!"...
		) else (
			!bat_push!
				!bat_log! ...it exists.
			!bat_popecho!
		)
	!bat_poplog! ^)
	
	!bat_pushecho! ***********  Copying Confirmed Detect and renaming with "_confirmed" suffix. *********
		for /f "usebackq tokens=*" %%a in (`dir "!bat_confirmeddirfull!\FTPdetectinfo*.txt" /b /a-d /od`) do (
			set bat_tempfilefull=!bat_confirmeddirfull!\%%~nxa
			set bat_tempfilename=%%~na
			set bat_tempfile=%%~nxa

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
			!bat_logexeclog! COPY /Y "!bat_tempfilefull!" "!bat_emailfilesdir!\!bat_tempfilename!_confirmed.txt"

			if not exist "!bat_emailfilesdir!\!bat_tempfilename!_confirmed.txt" (
				!bat_echolog! `  Failed to copy
				set bat_retval=failed
				!bat_echolog! `  [:MOVEFILES] FAILED TO COPY "!bat_emailfilesdir!\!bat_tempfilename!_confirmed.txt"
			) else (
					rem Fix the "FF  folder = " and "CAL folder = " paths to the new detect file location. 
				!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_emailfilesdir!" "!bat_tempfilename!_confirmed.txt"
							!bat_TITLE!
			)
		)
	!bat_popecho!

	!bat_echolog!
	!bat_echolog!

	if /i "!bat_retval!" EQU "failed" (
		goto :MOVEFILESEND
	)



:MOVEFILES2
!bat_log! [!bat_batchfile!:MOVEFILES2]

	!bat_pushecho! ***********  Confirmed RadiantAssoc.txt file - Rename and Copy to EmailFiles dir  *********

		if exist "!bat_confirmeddirfull!\RadiantAssoc*.txt" (
		
				rem Renaming the file using the MOVE command				
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
			!bat_logexeclog! MOVE /y    "!bat_confirmeddirfull!\RadiantAssoc.txt" "!bat_confirmeddirfull!\RadiantAssoc_!bat_camera_list!_!bat_captureddirname!.txt"
			!bat_logexeclog! MOVE /y    "!bat_confirmeddirfull!\RadiantAssoc*.txt" "!bat_confirmeddirfull!"

				rem Copy the renamed RadiantAssoc_*.txt files to the EmailFiles dir...
			for /f "usebackq tokens=*" %%a in (`dir "!bat_confirmeddirfull!\RadiantAssoc_*.txt" /b /a-d /on`) do (
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				!bat_logexeclog! COPY /y    "!bat_confirmeddirfull!\%%a"    "!bat_emailfilesdir!\%%a"
			)
		) else (
			!bat_echolog! `    OK - but none found. 
		)
	
	!bat_popecho!


	!bat_echolog! ********** THUMBNAILS ConfirmedFiles section *********************
	!bat_echolog!

	rem If there are FF*.bin files in the ConfirmedFiles dir, create them in 
	rem the "bat_THUMBNAILS.confirmed.email" format, BUT only if the 
	rem "bat_STAGE.include.thumbnails.confirmed" is true.  If the confirmed 
	rem thumbnails weren't included, and the "bat_STAGE.include.thumbnails.archived"
	rem is true, then include the "bat_THUMBNAILS.
	rem
	rem However, if any thumbnail is larger than the size specified in
	rem bat_STAGE.thumbnails.maxsize (usually about 2mb) then don't upload it.
	
	!bat_logexeclog! set bat_thumbnails.done=false

	!bat_logexeclog! set bat_capturedtime=!bat_submissionfilesdir:~-8!
	!bat_logexeclog! set bat_captureddatetime=!bat_captureddate!_!bat_capturedtime!
rem	!bat_logexeclog! set bat_capturedfilesdir=!bat_submitcapturedbase!\!bat_captureddatetime!
rem	!bat_logexeclog! set bat_archivedfilesdir=!bat_submitarchived!
	!bat_logexeclog! set bat_archivedcount=!bat_archivedmeteorcount!
rem	!bat_logexeclog! set bat_confirmedfilesdir=!bat_archivedfilesdir!
rem	!bat_logexeclog! set bat_confirmedfilesdir=!bat_confirmedfilesdir:ArchivedFiles=ConfirmedFiles!
	!bat_CALL! "!bat_exedir!\SaveConfig.bat"
	
	
	if /i "!bat_thumbnails.done!" neq "true" (
		if /i "!bat_STAGE.include.thumbnails.confirmed!" equ "true" (
			rem Build the thumbnails in the "bat_THUMBNAILS.confirmed.email" format
rem			!bat_CALLecho! "!bat_exedir!\thumbnails.bat" /confirmeddir "!bat_confirmedfilesdir!" /mode=bat_THUMBNAILS.confirmed.staged              /delete=no /interactive=no
			!bat_CALLecho! "!bat_exedir!\thumbnails.bat" /captureddir  "!bat_capturedfilesdir!"  /mode=bat_THUMBNAILS.captured.weather.LowRes.5mins /delete=no /interactive=no
			set bat_returncode=!errorlevel!
			!bat_log! bat_returncode=[!bat_returncode!]
			!bat_TITLE!

			if !bat_returncode! neq 0 (
				!bat_echolog!
				!bat_echolog! !bat_batchfile!::MOVEFILES2 - OK - WARNING - Confirmed thumbnails failed. [!bat_returncode!]. Continuing anyway...
				!bat_echolog!
			) else (
				!bat_logexec! MOVE /Y "!bat_capturedfilesdir!\Thumbnails*.bmp"   "!bat_confirmeddirfull!"
			)
			


				REM This section attempts to move the newly created thumbnails to the EmailFiles dir...

			!bat_pushlog! if exist "!bat_confirmeddirfull!\Thumbnails??????_????????_??????.bmp" ^(
				if           exist "!bat_confirmeddirfull!\Thumbnails??????_????????_??????.bmp" (
					!bat_pushlog! if not exist "!bat_emailfilesdir!" ^(
						if           not exist "!bat_emailfilesdir!" (
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							!bat_logexeclog! MKDIR "!bat_emailfilesdir!"
						)
					!bat_poplog! ^) // if not exist "!bat_emailfilesdir!"...

					!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_confirmeddirfull!\Thumbnails??????_????????_??????.bmp" /b /a-d /on`^) do ^(
						for           /f "usebackq tokens=*" %%a in  (`dir "!bat_confirmeddirfull!\Thumbnails??????_????????_??????.bmp" /b /a-d /on` ) do  (
							!bat_log! "size: [%%~za]       !bat_confirmeddirfull!\%%~nxa"

							!bat_logexeclog! set bat_temp_size=%%~za
							call :GETFILESIZE "!bat_confirmeddirfull!\%%~a"
							if "!bat_temp_size!" equ "" (
								!bat_logexeclog! set bat_temp_size=999999999
								!bat_log! ERROR - bat_temp_size=[!bat_temp_size!] of "%%~a"
								
									rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
									rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
									rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								!bat_logexec! DIR "!bat_confirmeddirfull!\Thumbnails??????_????????_??????.bmp" /a-d /on
								
								!bat_echolog! ERROR - Empty returnval from GETFILESIZE - bat_temp_size=[!bat_temp_size!] of "%%~a"
							)

							!bat_pushlog! if !bat_temp_size! leq !bat_STAGE.thumbnails.maxsize! ^(
								if           !bat_temp_size! leq !bat_STAGE.thumbnails.maxsize! (
										rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
										rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
										rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
									!bat_logexeclog! MOVE /y    "!bat_confirmeddirfull!\%%a" "!bat_emailfilesdir!\%%a"
									!bat_logexeclog! set bat_thumbnails.done=true
								) else (
									!bat_log!
									!bat_log! WARNING - ConfirmedFiles Thumbnail file too large to include [!bat_temp_size!  %%~a].  Continuing anyway...
									!bat_log!
								)
							!bat_poplog! ^)
							!bat_log! ... next for[] loop item...
						)
					!bat_poplog! ^)
					!bat_logexeclog! set bat_thumbnails.done=true
				) else (
			!bat_poplog! ^) ELSE ^(
			!bat_push!
					!bat_echolog!
					!bat_echolog! No Thumbnails found in [!bat_confirmeddirfull!]
					!bat_echolog!
				)
			!bat_poplog! ^) // if exist confirmed thumbnails...
		)
	)

:MOVE_THUMB_CONF_END
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! ********** THUMBNAILS ArchivedFiles section *********************
	!bat_echolog! **** but only if no thumbnails for ConfirmedFiles...
	!bat_echolog! ****
	!bat_echolog! **** Changed to a simpler weather set of thumbnails from capturedfilesdir
	
	!bat_pushlog! if /i "!bat_thumbnails.done!" neq "true" ^(
	if               /i "!bat_thumbnails.done!" neq "true" (

		!bat_pushlog! if /i "!bat_STAGE.include.thumbnails.archived!" equ "true" ^(
		if               /i "!bat_STAGE.include.thumbnails.archived!" equ "true" (
			rem Build the thumbnails in the "bat_THUMBNAILS.archived.staged" format
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem
				rem vvvvvv   changed to a simpler weather set of thumbnails from capturedfilesdir
			!bat_CALLecho! "!bat_exedir!\thumbnails.bat" /captureddir "!bat_capturedfilesdir!" /mode=bat_THUMBNAILS.captured.weather.LowRes.5mins /delete=no /interactive=no
			set bat_returncode=!errorlevel!
			!bat_log! bat_returncode=[!bat_returncode!]
			!bat_TITLE!
			!bat_echolog!
			!bat_echolog!

			if !bat_returncode! neq 0 (
				!bat_echolog!
				!bat_echolog! !bat_batchfile!::MOVEFILES2 - OK - WARNING - Weather thumbnails failed. [!bat_returncode!]
				!bat_echolog!
			)

			!bat_logexec! MOVE /y "!bat_capturedfilesdir!\Thumbnails??????_????????_??????.bmp"   "!bat_archivedfilesdir!"

			!bat_pushlog! if exist "!bat_archiveddirfull!\Thumbnails??????_????????_??????.bmp" ^(
				if       exist "!bat_archiveddirfull!\Thumbnails??????_????????_??????.bmp"  (
					!bat_pushlog! if not exist "!bat_emailfilesdir!" ^(
						if       not exist "!bat_emailfilesdir!"  (
							!bat_logexeclog! md "!bat_emailfilesdir!"
						)
					!bat_poplog! ^) // if not exist...

						REM Now determine which files fit within the thumbnail size specified in the INI file 
						REM and move those to the EmailFiles subdir...
					!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archiveddirfull!\Thumbnails??????_????????_??????.bmp" /b /a-d /on`^) do ^(
						for       /f "usebackq tokens=*" %%a in  (`dir "!bat_archiveddirfull!\Thumbnails??????_????????_??????.bmp" /b /a-d /on` ) do  (
							!bat_log! "size: [%%~za]       !bat_archiveddirfull!\%%~nxa"

							!bat_logexeclog! set bat_temp_size=%%~za
							call :GETFILESIZE "!bat_archiveddirfull!\%%~a"
							if "!bat_temp_size!" equ "" (
								!bat_logexeclog! set bat_temp_size=999999999
								!bat_log! ERROR - bat_temp_size=[!bat_temp_size!] of "%%~a"
									rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
									rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
									rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								!bat_logexec! DIR "!bat_archiveddirfull!\Thumbnails??????_????????_??????.bmp" /a-d /on
								!bat_echolog!  ERROR - bat_temp_size=[!bat_temp_size!] of "%%~a"
							)

							!bat_pushlog! if !bat_temp_size! leq !bat_STAGE.thumbnails.maxsize! ^(
								if           !bat_temp_size! leq !bat_STAGE.thumbnails.maxsize! (
										rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
										rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
										rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
									!bat_logexeclog! MOVE /y    "!bat_archiveddirfull!\%%a" "!bat_emailfilesdir!\%%a"
									!bat_logexeclog! set bat_thumbnails.done=true
								) else (
									!bat_log!
									!bat_log! WARNING - ArchivedFiles Thumbnail file too large to include [!bat_temp_size!  %%~a]
									!bat_log!
								)
							!bat_poplog! ^)
						)
					!bat_poplog! ^)
					!bat_logexeclog! set bat_thumbnails.done=true
				) else (
			!bat_poplog! ^) ELSE ^(
			!bat_push!
					!bat_echolog!
					!bat_echolog! No Thumbnails found in [!bat_archiveddirfull!]
					!bat_echolog!
				)
			!bat_poplog! ^) // if exist archived thumbnails...
		)
		!bat_poplog! ^)
	)
	!bat_poplog! ^)



:MOVE_THUMB_ARCH_END
	!bat_echolog! ********** THUMBNAILS section END *********************
	!bat_echolog!
	!bat_echolog!


	!bat_echolog! ********** Comments section  *********************
	!bat_echolog!

	if exist "!bat_confirmeddirfull!\comments_!bat_camera!.txt" (
		!bat_push!

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
			!bat_logexeclog! COPY /Y "!bat_confirmeddirfull!\comments_*.txt"   "!bat_emailfilesdir!\comments_!bat_camera!_!bat_dir_datetime!.txt"

			if not exist "!bat_emailfilesdir!\comments_!bat_camera!_!bat_dir_datetime!.txt" (
				!bat_echolog! `  Failed to copy
				set bat_retval=failed
				!bat_echolog! `  [!bat_batchfile!:MOVEFILES] FAILED TO COPY: "!bat_emailfilesdir!\comments_!bat_camera!_!bat_dir_datetime!.txt"

				!bat_pop! // Early exit
				goto :MOVEFILESEND
			)

		!bat_pop!
	) else (
		!bat_push!
			!bat_echolog! `  OK - but not found: "!bat_confirmeddirfull!\comments_!bat_camera!.txt"
		!bat_pop!
	)
		  

	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! ********** Move the ConfirmedFiles dir  *********************
	!bat_echolog!
	
	!bat_push!

		if exist "!bat_confirmeddirfull!" (

					rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
					rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
					rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				!bat_logexeclog! MOVE /Y "!bat_confirmeddirfull!" "!bat_submissiondir!\ConfirmedFiles"

				if !bat_logexec_returncode! neq 0 (
					!bat_echolog! `  Failed to move
					set bat_retval=failed
					!bat_echolog! `  [:MOVEFILES] FAILED [!bat_logexec_returncode!]: MOVE /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
					!bat_poplog!	// early exit
					goto :MOVEFILESEND
				)

				if exist "!bat_confirmeddirfull!" (
					!bat_echolog! `  Failed to move - The original directory is still there.  Check to see if you have any files open
					!bat_echolog! `                   in the source directory. 
					set bat_retval=failed
					!bat_echolog! `  [:MOVEFILES] FAILED: MOVE /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
					!bat_poplog!	// early exit
					goto :MOVEFILESEND
				)
				
				if exist "!bat_submitconfirmed!\FTPdetectinfo*.txt" (
					for /f "usebackq tokens=*" %%a in (`dir "!bat_submitconfirmed!\FTPdetectinfo*.txt" /b /a-d /on`) do (
						!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_submitconfirmed!" "%%a"
							!bat_TITLE!
					)
				)

		) else (
			!bat_push!
				!bat_echolog! `  OK - but not found: "!bat_confirmeddirfull!"
			!bat_pop!
		)
	
	!bat_pop!


	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! ********** ArchivedFiles section      *********************
	!bat_echolog!

	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archiveddirfull!\FTPdetectinfo_0*.txt" /b /a-d /od`^) do ^(
		for           /f "usebackq tokens=*" %%a in  (`dir "!bat_archiveddirfull!\FTPdetectinfo_0*.txt" /b /a-d /od`) do (
			set bat_tempfilefull=!bat_archiveddirfull!\%%~nxa
			set bat_tempfilename=%%~na
			set bat_tempfile=%%~nxa

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
			!bat_logexeclog! COPY /Y "!bat_tempfilefull!" "!bat_emailfilesdir!\!bat_tempfilename!_scanned.txt"

			if not exist "!bat_emailfilesdir!\!bat_tempfilename!_scanned.txt" (
				!bat_echolog!
				!bat_echolog! `    ERROR - Tried to copy !bat_tempfilename! to "!bat_emailfilesdir!\!bat_tempfilename!_scanned.txt"
				!bat_echolog! `            but it isn't there afterward.
				!bat_echolog!
				!bat_echolog! `            The copy command returned an exit code of: "!bat_logexec_returncode!"
				!bat_echolog!
			)
		)
	!bat_poplog! ^)
	
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
    !bat_echolog! `    Packaged for submission on [!date! !time!] "!bat_emailfilesdir!\submit_!bat_camera!.txt"
    
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_pushecho! ********** Copying Parameters files section      *********************
		!bat_echolog!

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_logexeclog! COPY /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_logexeclog! COPY /Y "!bat_archiveddirfull!\CameraTimeOffsets*.txt" "!bat_emailfilesdir!"

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_logexeclog! COPY /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_logexeclog! COPY /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"

	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_pushecho! ********** Moving ArchivedFiles dir section      *********************
	!bat_echolog! **** Moving  the ArchivedFiles dir 
	!bat_echolog!

				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem Example:
				rem  MOVE /Y "C:\CAMS\ArchivedFiles\2017_09_15_03_00_00"   "C:\CAMS\SubmissionFiles\2017_09_15_03_00_00\250\ArchivedFiles"
		!bat_logexeclog! MOVE /Y "!bat_archiveddirfull!" "!bat_submissiondir!\ArchivedFiles"

		set bat_errorcode=!bat_logexec_returncode!
		!bat_log! `  bat_errorcode=!bat_errorcode!

		if !bat_errorcode! neq 0 (
			!bat_echolog! `  Failed to move - Move command returned: "!bat_errorcode!"
			set bat_retval=failed
			!bat_echolog! `  [:MOVEFILES] FAILED TO MOVE /Y "!bat_archiveddirfull!" "!bat_submitarchived!". 
			!bat_echolog! `               Move command returned: "!bat_errorcode!"
			set bat_errorcode=
			if not defined bat_autonomous (!bat_prompt! Press ENTER to continue . . .)
			goto :MOVEFILESEND
		) else (
			!bat_echolog! `  OK - bat_errorcode=!bat_errorcode! - Move succeeded.
		)

		if exist "!bat_archiveddirfull!" (
			!bat_echolog! `  Failed to move "!bat_archiveddirfull!" to "!bat_submitarchived!"
			set bat_retval=failed
			!bat_echolog! `  [:MOVEFILES] FAILED TO MOVE /Y "!bat_archiveddirfull!" to "!bat_submitarchived!"
			!bat_echolog! `               Still exists: "!bat_archiveddirfull!"
			if not defined bat_autonomous (!bat_prompt! Press ENTER to continue . . .)
			goto :MOVEFILESEND
		) else (
			!bat_log! `  OK - move succeeded: "!bat_archiveddirfull!"
		)
		
		
			rem Fix the detect file paths
		if exist "!bat_submitarchived!\FTPdetectinfo_*.txt" (
			for /f "usebackq tokens=*" %%a in (`dir "!bat_submitarchived!\FTPdetectinfo_*.txt" /b /a-d /on`) do (
				!bat_CALL! "!bat_exedir!\FixDetectPaths.bat" "!bat_submitarchived!" "%%a"
							!bat_TITLE!
				!bat_popecho!
			)
		)

	!bat_popecho!

	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! **********      CapturedFiles section      *********************
	!bat_echolog! **** Moving all the directories matching the same capture session
	!bat_echolog! **** to the target dir.
	!bat_echolog!

	if not exist "!bat_submitcapturedbase!" (
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
				rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_logexeclog! MKDIR "!bat_submitcapturedbase!"
	) else (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `  OK - Already exists: "!bat_submitcapturedbase!"
		!bat_echolog!
		!bat_echolog!
	)

									rem echo robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
									rem  robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	!bat_echolog! This next step could take a long time due to !bat_capturedcount!...
	!bat_pushlog! for /f "usebackq tokens=*" ..b in ^(`dir "!bat_captureddir!*" /s/b /ad /on`^) do ...
		for       /f "usebackq tokens=*" %%b in  (`dir "!bat_captureddir!*" /s/b /ad /on`) do (
			if /i "%%~nxb" neq "movies" (
				if /i "%%~nxb" neq "displayJPEGS" (
					if /i "%%~nxb" neq "gefdat" (

						if exist "%%~dpnxb\FF_!bat_camera!*.bin" (
						
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							!bat_logexeclog! MOVE /y "%%~dpnxb" "!bat_submitcapturedbase!"

							if exist "%%~dpnxb" (
								set bat_retval=failed
								!bat_echolog! `  Failed to move "%%~dpnxb" to "!bat_submitcapturedbase!"
								!bat_echolog! `    [:MOVEFILES] FAILED TO MOVE /Y "%%~dpnxb" to "!bat_submitcapturedbase!"
								!bat_echolog! `                 Still exists: "%%~dpnxb" to "!bat_submitcapturedbase!"
								if not defined bat_autonomous (
:MOVEFILES_CAP_ASK
									set /p bat_choice=.  [C]ontinue or [Q]uit? 
									if /i "!bat_choice!" equ "q" (goto :MOVEFILESEND)
								)
							)
							
							if exist "!bat_captureddir!*" (
								!bat_echolog! ` OK - Verified the move was successful since the source dir doesn't exist
								!bat_echolog! `      and the destination dir does [!bat_captureddir!*].
							)
							
							
						) else (
							!bat_echolog! `  Failed to move "%%~dpnxb" to "!bat_submitcapturedbase!"
							!bat_echolog! `    No FF*.bin files exist in "%%~dpnxb"
							!bat_echolog! `    [:MOVEFILES] FAILED TO MOVE /Y "%%~dpnxb" to "!bat_submitcapturedbase!"
							!bat_echolog! `                 Still exists: "%%~dpnxb" to "!bat_submitcapturedbase!"
						)
					)
				)
			)
		)
	!bat_poplog!

	if /i "!bat_retval!" equ "failed" goto :MOVEFILESEND

:MOVEFILESEND
!bat_poplog! [RETURN !bat_batchfile!:MOVEFILES] [bat_retval=!bat_retval!]
!bat_log!
!bat_return!



	REM #################################################################
	REM 
:GETFILESIZE [in] fullpath
!bat_pushlog! [CALL !bat_batchfile!:GETFILESIZE] [%*]

	for /f %%b in ("%~1") do (
		!bat_logexeclog! set bat_temp_size=%%~zb
	)

:GETFILESIZE_END
!bat_poplog! [RETURN !bat_batchfile!:GETFILESIZE] [bat_temp_size=!bat_temp_size!]
!bat_log!
!bat_return!


****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
NEEDS TO BE REPLACED WITH THIS TO SPEED THINGS UP..................
set bat_linecount=0&for /f "usebackq tokens=*" %a in (`find /i "Meteor Count" "ftpdetectinfo.3.txt"`) do (set /a bat_linecount+=1)

set bat_linecount=0&for /f "usebackq tokens=*" %a in (`find /i "FF  Folder" "ftpdetectinfo.3.txt"`) do (set /a bat_linecount+=1)

set bat_linecount=0&for /f "usebackq tokens=*" %a in (`find /i "CAL Folder" "ftpdetectinfo.3.txt"`) do (set /a bat_linecount+=1)

set bat_linecount=0&for /f "usebackq tokens=*" %a in (`find /i ".txt" "ftpdetectinfo.3.txt"`) do (set /a bat_linecount+=1)
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************
****************************************************************





	REM #################################################################
	REM 
:READFILE
!bat_pushlog! [CALL !bat_batchfile!:READFILE] "!bat_emailfilesdir!\!bat_tempfilename!_scanned.txt", %*
	set bat_retval=success


	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! ************ Reading the Detect file *****************************
	!bat_echolog! ****  "!bat_emailfilesdir!\FTPdetectinfo_??????_scanned.txt"
	!bat_echolog!

	if not exist "!bat_readfile!" (
		set bat_readfile=!bat_emailfilesdir!\FTPdetectinfo_??????_*_scanned.txt
	)
	
	for /f "usebackq tokens=*" %%a in (`dir "!bat_emailfilesdir!\FTPdetectinfo_??????_*_scanned.txt" /b /a-d /od`) do (
		set bat_readfile=!bat_emailfilesdir!\%%a
	)

	!bat_log! bat_readfile=!bat_readfile!

	if not exist "!bat_readfile!" (
		!bat_log! `    [:READFILE] "!bat_readfile!" does not exist
		if not exist "!bat_readfile!" (
			!bat_log! `  ERROR cannot continue without an FTPdetectinfo file.
			!bat_log!
			!bat_log! `  The files have already been moved... you will need to move 
			!bat_log! `  them back and start over after resolving the problems.
			!bat_log!
			!bat_log! `  [:READFILE] ERROR - "!bat_readfile!" does not exist
			set bat_retval=failed
			goto :READFILE_END
		)
	)
	
	
	set bat_calfilename=
	set bat_calfilename_prev=
%BAT_COMMENT_BEGIN%
	if exist "!bat_exedir!\Logs\CalFileList.log" (
		if defined bat_exedir (
			del /Q "!bat_exedir!\Logs\CalFileList.log"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:READFILE] Dangerous command: del "!bat_exedir!\Logs\CalFileList.log"
		)
	)
%BAT_COMMENT_END%

	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0

	!bat_echolog! This next step could take a long time  when detect file has over 1000 entries...
	!bat_echolog!
	
	
	!bat_pushecho! METEOR COUNT
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "Meteor Count" "!bat_readfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETMETEORCOUNT bat_countscanned %%b
	)
	!bat_popecho! Meteor Count=!bat_countscanned!
	!bat_echolog!
	
	!bat_pushecho! FF DIR
		for /f "usebackq tokens=* skip=2" %%b in (`find /i "FF  folder" "!bat_readfile!"`) do (
			set bat_temp=%%b
			set bat_temp=!bat_temp:~0,7!
			set bat_tempcal=!bat_temp:~0,7!

			call :GETFFDIR "%%b"
		)
	!bat_popecho! FF  folder=!bat_ffdir!
	!bat_echolog!
	
	!bat_pushecho! CAL DIR
		for /f "usebackq tokens=* skip=2" %%b in (`find /i "CAL folder" "!bat_readfile!"`) do (
			set bat_temp=%%b
			set bat_temp=!bat_temp:~0,7!
			set bat_tempcal=!bat_temp:~0,7!

			call :GETCALDIR "%%b"
		)
	!bat_popecho! CAL folder = !bat_calfolder!
	!bat_echolog!

	!bat_log! if /i "!bat_countscanned!" equ "0" [goto :READFILE_END]
	if           /i "!bat_countscanned!" equ "0" (
		!bat_log! NOTE: Meteor Count is !bat_countscanned!.  So skipping the reading of the detect file. [with bat_retval=!bat_retval!]
		goto :READFILE_END
	)
	
	!bat_pushecho! CalFileList
		set bat_calfilename=
		set bat_calfilename_prev=
		set bat_detectfile_dir=!bat_submitarchived!

		if defined bat_detectfile_dir (
			if exist "!bat_detectfile_dir!\CalFileList.log" (
					rem this will force it to be rebuilt later
rem				del /Q "!bat_detectfile_dir!\CalFileList.log"
			) else (
rem				!bat_echolog! WARNING [!bat_batchfile!:READFILE] Dangerous command because the CalFileList.log file does not exist, so not executing it: del "!bat_detectfile_dir!\CalFileList.log"
			)
		)

		set bat_cameralist=
		set bat_msg= 
		set /a bat_linecount=0
		set /a bat_filecount=0
		!bat_echolog!
		!bat_echolog! This next step could take a long time if the meteor count is
		!bat_echolog! greater than 1,000.  Over that number, it gets exponentially
		!bat_echolog! longer to process. 


		!bat_echolog!
		set bat_temp=
			rem Scan the detect file and output the count.  
		!bat_log! for /f "usebackq tokens=1-3 delims=:" ..a in ^(`find /i /c ".bin" "!bat_readfile!"`^) do ^(
		for           /f "usebackq tokens=1-3 delims=:" %%a in  (`find /i /c ".bin" "!bat_readfile!"`) do (
			set bat_temp=%%~c
		)
		!bat_echolog! There are !bat_temp! entries in the detect file, please wait... 


		if exist "junk.txt" (del /q "junk.txt")
		if exist "junk.txt" (
			set bat_returncode=
			!bat_echolog!
			!bat_echolog! !bat_batchfile!:READFILE:ERROR [!bat_returncode!] - Unable to delete "junk.txt". Aborting...
			!bat_echolog!
			!bat_echolog!
			!bat_WAIT! !bat_batchfile!:READFILE:ERROR [!bat_returncode!] - Unable to delete "junk.txt". Aborting...
			goto :READFILE_END
		)

			rem Output all the CAL files to junk.txt so we can scan it quicker
rem		!bat_log! find /i ".txt" "!bat_readfile!"][sort}"junk.txt"
rem				  find /i ".txt" "!bat_readfile!"|sort>"junk.txt"

		set bat_temp=
		!bat_echolog!

		!bat_CALL! "!bat_exedir!\CreateCalFileList.bat" "!bat_readfile!"

		!bat_logexec! type "!bat_emailfilesdir!\CalFileList.log"

%bat_COMMENT_BEGIN%

			rem Create a CalFileList.log for each camera...
		!bat_pushecho! [!time!]
			set /a bat_camerainstance=0
			rem !bat_pushlog! for /f "usebackq tokens=*" ..x in ^(`type "!bat_GCFC_tempfile!"`^) do ^(
			for                   /f "usebackq tokens=*" %%x in  (`type "!bat_GCFC_tempfile!"`) do (
					set /a bat_linecount=0
					rem !bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i "cal%%x_" "junk.txt"`^) do ^(
					for                   /f "usebackq tokens=* skip=2" %%a in  (`find /i "cal%%x_" "junk.txt"`) do (
						set bat_temp=%%a
						set /a bat_linecount+=1
						set bat_calfilename=%%a
						set bat_camera_temp=!bat_temp:~4,6!

						if !bat_linecount! equ 1 (
							set /a bat_camerainstance+=1
							!bat_echolog! `  1. ADDING: "!bat_calfilename!" TO: "!bat_detectfile_dir!\CalFileList.log"
							set bat_cameralist2=!bat_camera_temp!

							if !bat_camerainstance! equ 1 (
								echo !bat_calfilename!>"!bat_detectfile_dir!\CalFileList.log"
							) else (
								echo !bat_calfilename!>>"!bat_detectfile_dir!\CalFileList.log"
							)
						)
					)& rem for ..a in {find /i "cal..x_" "junk.txt"}... //iterating CAL files matching camera

					!echolog! !bat_calfilename!
					rem !bat_poplog! ^)
			)& rem for ..x in {type "bat_GCFC_tempfile!"}... //iterating through cameralist
		!bat_popecho! [!time!]
		!bat_echolog!
	!bat_popecho!
	
%bat_COMMENT_END%	
	
%bat_COMMENT_BEGIN%
	set /a bat_linecount=0
	for /f "usebackq tokens=* skip=2" %%b in (`find /i ".txt" "!bat_readfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!

		set /a bat_linecount+=1

		if !bat_linecount! equ 1 (
			call :GETCALNAME "%%b"
			!bat_echolog! `  bat_calfilename="!bat_calfilename!"
			!bat_echolog! `1.  ADDING TO "CalFileList.log": !bat_calfilename!
			echo.!bat_calfilename!>"!bat_exedir!\Logs\CalFileList.log"
			!bat_echolog! !bat_calfilename!
			!bat_logexeclog! set bat_calfilename_prev=!bat_calfilename!
		) else (
			if !bat_linecount! gtr 1 (
				if "!bat_tempcal:~0,3!" equ "CAL" (
					if "!bat_tempcal:~6,1!" equ "_" (
						!bat_logexeclog! set bat_camera_temp=!bat_tempcal:~4,6!
						call :GETCALNAME "%%b"
						rem echo `      !bat_calfilename!

						call :CHECK_CALFILELIST "!bat_calfilename!"
						if not defined bat_calfilelist_found (
							!bat_echolog! `  bat_calfilename="!bat_calfilename!"
							!bat_echolog! `2.  ADDING TO "CalFileList.log": !bat_calfilename!
							echo.!bat_calfilename!>>"!bat_exedir!\Logs\CalFileList.log"
							!bat_logexeclog! set bat_calfilename_prev=!bat_calfilename!
						)
					)
				)
			) else (
				if "!bat_temp!" equ "Cal!bat_camera_temp!" (
					set bat_fffilename=%%b
					title working on Cal file: "!bat_fffilename!"
					set /a bat_filecount+=1
				)
			)
		)
	)
	!bat_popecho!
%BAT_COMMENT_END%
	

:READFILE_END
!bat_poplog! [RETURN !bat_batchfile!:READFILE] [!bat_retval!]
!bat_log!
!bat_return!













	REM #################################################################
	REM 
	rem Check "CalFileList.log" to see if %~1 already exists in the list
	rem Returns: bat_calfilelist_found=true if found, otherwise, it is undefined
:CHECK_CALFILELIST [in]  "!bat_calfilename!"
               rem [out] bat_calfilelist_found
rem echo [CALL !bat_batchfile!:CHECK_CALFILELIST] [%*]
	set bat_calfilelist_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_exedir!\Logs\CalFileList.log"`) do (
		if /i "%~1"  equ "%%x" (
			set bat_calfilelist_found=true
		)
	)
:CHECK_CALFILELIST_END
rem echo [RETURN !bat_batchfile!:CHECK_CALFILELIST] [%~1, bat_calfilelist_found=!bat_calfilelist_found!]
!bat_return!






	REM #################################################################
	REM 
:GETMETEORCOUNT
!bat_pushlog! [CALL !bat_batchfile!:GETMETEORCOUNT] %*
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
!bat_poplog! [RETURN !bat_batchfile!:GETMETEORCOUNT] [!%1!] [%*] 
!bat_log!
!bat_return!





	REM #################################################################
	REM 
	rem ***********          :GETEVENTCOUNT                       *************
	rem 
	rem Usage: call :GETEVENTCOUNT "any full detectfile name"
	rem	
	
:GETEVENTCOUNT [in]detectfile [out]bat_returncode
!bat_pushlog! [CALL !bat_batchfile!:GETEVENTCOUNT] [%*]

	set bat_tempfile=%~1
	set bat_returncode=0
	
	!bat_CALL! "!bat_exedir!\GetMeteorCount.bat" "%~1"
	set /a bat_returncode=!errorlevel!
							!bat_TITLE!
	
	set /a bat_countdashes=!bat_returncode!
	set bat_countdashes=000000!bat_countdashes!
	set bat_countdashes=!bat_countdashes:~-6!
	!bat_log! Meteor Count = !bat_countdashes!
	%bat_TITLE% Meteor Count = !bat_countdashes!  "!bat_tempfile!" 

	if exist "!bat_tempfile!" (
		set /a bat_countdashes=0
	    !bat_pushlog! for /f "usebackq tokens=1-3 delims=: skip=1" ..X in ^(`find /i /c  ".bin" "!bat_tempfile!"`^) ...
		for               /f "usebackq tokens=1-3 delims=: skip=1" %%X in  (`find /i /c  ".bin" "!bat_tempfile!"` ) do (
			if "%%X" neq "" (
				set bat_countdashes=%%Z
				set /a bat_countdashes=bat_countdashes+1-1
				title !bat_countdashes!
				!bat_log! !bat_countdashes!
			)
		)
		!bat_poplog!

		set bat_countdashes=000000!bat_countdashes!
		set bat_countdashes=!bat_countdashes:~-6!
		!bat_log! Meteor Count = !bat_countdashes!
		title Meteor Count = !bat_countdashes!  "!bat_tempfile!" 
		set bat_returncode=!bat_countdashes!
	) else (
		!bat_log! `  File not found - "!bat_tempfile!"
		set bat_returncode=-1
	)

!bat_poplog! [RETURN !bat_batchfile!:GETEVENTCOUNT] [!bat_returncode!]
!bat_log!
!bat_return!






	REM #################################################################
	REM 
:STRIPHEADER
!bat_log! [CALL !bat_batchfile!:STRIPHEADER] %*
!bat_log! `    !bat_batchfile!:STRIPHEADER is no longer required - skipping
goto :STRIPHEADER_END

	rem Usage: call STRIPHEADER bat_variable sourcefile targetfile
	rem Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to 
	rem "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[bat_camera]-[meteor count].txt" 
	rem with the header stripped from it.
	
	echo     Stripping header to: "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
	
	set bat_sourcefile=%~5
	
	set /a bat_countscan=0
	set /a bat_countevent=0
	
	set /a bat_remain=0
	TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
	
	set bat_tempsource=!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!.txt
	set bat_tempheader=!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!_header.txt
	set bat_tempstripped=!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-%~6.txt
	
	!bat_CALLecho! "!bat_exedir!\StripHeaderVBS.bat" "!bat_tempsource!" "!bat_tempheader!" "!bat_tempstripped!"
							!bat_TITLE!
	GOTO :STRIPHEADER_END

:STRIPHEADER_END
!bat_log! [RETURN !bat_batchfile!:STRIPHEADER] []
!bat_log!
!bat_return!








	REM #################################################################
	REM 
:GETFFDIR
!bat_pushlog!  [CALL !bat_batchfile!:GETFFDIR] %*
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d&					REM full path to the right of "FF  folder = "
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_poplog!  [RETURN !bat_batchfile!:GETFFDIR] %*  [!bat_ffdir!]
!bat_log!
!bat_return!






	REM #################################################################
	REM 
:GETCALDIR
!bat_pushlog!  [CALL !bat_batchfile!:GETCALDIR] %*
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	set bat_getcaldir_temp=%~1
	set bat_getcaldir_temp=!bat_getcaldir_temp:~0,-1!
	!bat_log! for /f "tokens=1,2* delims=\= " ..b in ^("!bat_getcaldir_temp!"^) do ^(
	for           /f "tokens=1,2* delims=\= " %%b in  ("!bat_getcaldir_temp!") do (
		set bat_temp2=%%d
		!bat_logexeclog! set bat_calfolder=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_poplog!  [RETURN !bat_batchfile!:GETCALDIR] [!bat_calfolder!] [%*] 
!bat_log!
set bat_getcaldir_temp=
!bat_return!






	REM #################################################################
	REM 
:GETCAMERA
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERA] %*
	set bat_camera_temp=!bat_temp:~3,6!
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERA] [!bat_camera_temp!]
!bat_log!
!bat_return!


	REM #################################################################
	REM 
	rem Strip the trailing space from the file name
:GETFFFILENAME
	set bat_fffilename=%~1

:GETFFFILENAME_END
!bat_return!




	REM #################################################################
	REM 
:GETCALNAME
rem !bat_pushlog!  [CALL !bat_batchfile!:GETCALNAME] %*
	rem 
	set bat_calfilename=%~1
rem !bat_poplog!  [RETURN !bat_batchfile!:GETCALNAME] %*  [!bat_calfilename!]
!bat_return!





	REM #################################################################
	REM 
:COUNTFILE
!bat_pushlog! [CALL !bat_batchfile!:COUNTFILE] %1 %2
	rem Create a file that has the meteorcounts
	rem set bat_countfile=!bat_emailfilesdir!\!bat_camera!_archived=%1, confirmed=%2.txt
	set bat_countfile=!bat_emailfilesdir!\!bat_camera!.txt

	set bat_temp1=0
	set bat_temp2=0

	if /i "%~1" neq "" (
		set bat_temp1=%~1
	)

	if /i "%~2" neq "" (
		set bat_temp2=%~2
	)

	!bat_log! Meteor Counts:  Archived="!bat_temp1!"   Confirmed="!bat_temp2!"
	 echo     Meteor Counts:  Archived="!bat_temp1!"   Confirmed="!bat_temp2!">"!bat_countfile!"

	!bat_logexeclog! copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments_!bat_camera!.txt" "!bat_countfile!.temp"
	!bat_logexeclog! move /y "!bat_countfile!.temp" "!bat_countfile!"

	echo.>>"!bat_countfile!"

	!bat_logexeclog! type "!bat_countfile!"

	set bat_LocalDate=
	if defined bat_dirdate (
	    !bat_CALL! "!bat_exedir!\ParseCamsDate.bat" !bat_dirdate!
	    
	    set bat_LocalDate=!ftp_LocalDate!
	)

	!bat_CALL! "%~dp0CheckTwilight.bat" !bat_LocalDate!>>"!bat_countfile!"
							!bat_TITLE!

!bat_poplog! [RETURN !bat_batchfile!:COUNTFILE] [!bat_countfile!]
!bat_log!
!bat_return!





	REM #################################################################
	REM 
	REM ********                      :COPYCALFILE                    *********
	REM ********                                                      *********
	REM Called by :GETDIRNAMES Step 7, which loops through the CalFileList.log 
	REM file, copies each Cal file listed to the ________ directories, and
	REM then locates the FF file used for this cal file in the CapturedFiles
	REM dir or if it's not found there, in the .\Cal\BinFiles dir.
	REM 
	REM The BIN files to also include should be as follows:
	REM    BIN file for each successful CAL file
	REM    BIN file for each failed CAL file according to:
	REM       bat_CALIBRATION.local_midnight_1=07000?
	REM       bat_CALIBRATION.local_midnight_2=08000?
	REM 
	REM The success or failure of calibration for a particular camera is determined
	REM if the CAL file date/time falls between the first/last FF file date/time
	REM from the CapturedFiles dir, and stored in the "GetFirstLastFF_filenames.bat.txt"
	REM file. 

:COPYCALFILE [in] bat_calfilename="CAL_000250_20170915_103045_826.txt" [in] "000250"
!bat_pushlog! [CALL !bat_batchfile!:COPYCALFILE] %*
	set bat_cal_temp=%~1
	set bat_camera_temp=%~2


	if not exist "!bat_submitcal!" (
		!bat_logexeclog! MKDIR "!bat_submitcal!"
	)
	
	!bat_logexeclog! COPY /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"

	
rem	!bat_logexeclog! COPY /Y /b "!bat_caldir!\CameraSites-!bat_camera_temp!.txt" "!bat_emailfilesdir!\Cal-!bat_camera_temp!"

rem	!bat_logexeclog! COPY /Y /b "!bat_caldir!\CameraSites-!bat_camera_temp!.txt" "!bat_submitcal!"


	set bat_temp_calffname=
	if defined bat_calfilename (
		!bat_logexeclog! COPY /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!"

		!bat_logexeclog! COPY /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"

		call :COPYCALFF "!bat_calfilename!" "!bat_camera_temp!"
		set bat_temp_calffname=!bat_calffname!
	)
	
	
	if NOT defined bat_temp_calffname (
			rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		!bat_log! Copy the local_midnight bin files for calibration in case this calibration is invalid.
		!bat_log! This gives the coincidence processor the ability to calibrate just in case. 
		!bat_log! bat_tempsearchdir=[!bat_tempsearchdir!]

		!bat_echolog! bat_submitcapturedbase=!bat_submitcapturedbase!
		!bat_log! bat_captureddatetime=!bat_captureddatetime!
		!bat_log! bat_camera_temp=!bat_camera_temp!

	REM ------------- This whole section needs to be change to handle only those CAL files that are within the CapturedFiles first/last time frame ----------------


			REM Show the local_midnight_1 file if it exists [for debugging purposes]
		if  exist "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin" (
			!bat_logexeclog! dir /s/b "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin"
		)

			REM 
		set bat_temp_calbin=
		if exist "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin" (

				REM In case there are more than a single file that match the filespec, setting the bat_temp_calbin var and then copying the last one guarantees that we only copy the last one
			for /f "usebackq tokens=*" %%c in (`dir /s/b "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin"`) do (
				!bat_logexeclog! set bat_temp_calbin=%%c
			)

			if defined bat_temp_calbin (
				!bat_logexeclog! COPY /Y /b "!bat_temp_calbin!" "!bat_emailfilesdir!"
			)

		) else (
			!bat_echolog!
			!bat_echolog! `   WARNING - Not Exist BIN file: "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin"
			!bat_echolog! `   !bat_batchfile!:COPYCALFILE
			!bat_echolog!
		)

			REM Show the local_midnight_2 file if it exists [for debugging purposes]
		!bat_logexeclog! dir /s/b "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_2!_*.bin"

		set bat_temp_calbin=
		if exist "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_2!_*.bin" (

				REM In case there are more than a single file that match the filespec, setting the bat_temp_calbin var and then copying the last one guarantees that we only copy the last one
			for /f "usebackq tokens=*" %%c in (`dir /s/b "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_2!_*.bin"`) do (
				!bat_logexeclog! set bat_temp_calbin=%%c
			)

			if defined bat_temp_calbin (
				!bat_logexec! COPY /Y /b "!bat_temp_calbin!" "!bat_emailfilesdir!"
			)
		) else (
			!bat_echolog!
			!bat_echolog! `   WARNING - Not Exist BIN file: "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_2!_*.bin"
			!bat_echolog! `   !bat_batchfile!:COPYCALFILE
			!bat_echolog!
	)

	)
	
	
rem	!bat_logexec! COPY /Y /b "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin" "!bat_emailfilesdir!\Cal-!bat_camera_temp!"
rem	!bat_logexec! COPY /Y /b "!bat_submitcapturedbase!\!bat_captureddatetime!\FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_2!_*.bin" "!bat_emailfilesdir!\Cal-!bat_camera_temp!"

REM ================ This whole section needs to be change to handle only those CAL files that are within the CapturedFiles first/last time frame =================


:COPYCALFILE_END
!bat_poplog! [RETURN !bat_batchfile!:COPYCALFILE] "bat_calfilename=!bat_calfilename!"
!bat_log!
!bat_return!






	REM #################################################################
	REM 
	rem read the cal file and use the date on line 2 and the time on 
	rem line 3 to create a search for the cal file.  To use the following
	rem example, the search will search in reverse order for the ff*.bin
	rem files from the CapturedFiles directory.
	REM BTW - THE DATE AND TIME INSIDE THE FILE ALWAYS MATCH EXACTLY WHAT THE
	REM       DATE AND TIME OF THE CAMS TIMESTAMP EXCEPT FOR THE DECIMALS.
	REM       THEREFORE, THERE IS NO NEED TO OPEN THE FILE AND READ IT.
	rem Here is the format of a cal file CAL213_20110818_033809_187.txt
	rem 	1	 Camera number            = 213
	rem 	2	 Calibration date         = 08/18/2011
	rem 	3	 Calibration time (UT)    = 03:38:09.187
	rem
	rem IMPROVEMENTS NEEDED:
	rem   1) We need to figure out a way to be able to use an FF file
	rem   from a previous date in order to handle those cases where the
	rem   calibration for the current night was not possible.
	rem   ANSWER) Copy the FF file to the cal dir.
	rem
	rem   2) Performance - improve by creating a file containing a listing
	rem      of all the FF files. Then compare that. It should be faster.
	rem

:COPYCALFF [in] "!bat_calfilename!" "!bat_camera_temp!"
!bat_pushlog! [CALL !bat_batchfile!:COPYCALFF] %*

	set bat_returncode=1

	set bat_calfilename=%~1
	set bat_camera_temp=%~2
	
	set bat_calffname=

	!bat_echolog! Scanning for the FF file used to create the cal file...
	!bat_echolog!
	!bat_pushecho! This next step could take a long time when more than 1,000 entries in the detect file, please wait...
		
			REM Get the count just for displaying how long it will take...
		set bat_temp=
		for /f "usebackq tokens=1-3 delims=:" %%a in (`find /i /c ".bin" "!bat_readfile!"`) do (
			set bat_temp=%%c
		)
		
		!bat_echolog! There are !bat_temp! entries in the detect file, please wait... [!time!]
		set bat_temp=
	!bat_popecho! [!time!]

	set /a bat_calff_line=0
	if defined bat_calfilename (
		if not exist "!bat_emailfilesdir!\!bat_calfilename!" (
		
			set bat_returncode=1
			!bat_echolog! `    File Not Found: "!bat_emailfilesdir!\!bat_calfilename!"
			
			if not defined bat_autonomous (
				!bat_prompt! Press ENTER to continue . . .
			)
			
			goto :COPYCALFF_END
		)
		
			rem This first loop obtains the date/time from within the cal file in
			rem preparation for the second loop, which uses that date/time to iterate
			rem backward through the capturedfiles dir looking for the FF*.bin file
			rem that immediately preceeds this date/time.
			rem  IMPROVEMENT: This could be faster if just the filename were parsed for the
			rem               calibration date, time, and camera of the given bat_calfilename. 
		!bat_pushlog! `    for /f "usebackq skip=2 tokens=1-11" ..f in ^(`find /i "Calibration " "!bat_emailfilesdir!\!bat_calfilename!"`^) do ...
		for                    /f "usebackq skip=2 tokens=1-11" %%f in  (`find /i "Calibration " "!bat_emailfilesdir!\!bat_calfilename!"`) do (
			set /a bat_calff_line+=1
			!bat_log! TITLE "Reading "!bat_calfilename!" for date/time of FF file used for calibration: [!bat_calff_line!: %%f %%g %%h %%i %%j]"
			          TITLE "Reading  !bat_calfilename!  for date/time of FF file used for calibration: [!bat_calff_line!: %%f %%g %%h %%i %%j]"
			          
				REM The first entry containing "Calibration " of the cal file is the date
			if !bat_calff_line! equ 1 (
				rem date
				!bat_log! %%f, %%g, %%h, %%i, %%j
				set bat_calffdate=%%i
				set bat_calffyyyy=!bat_calffdate:~-4!
				set bat_calffmm=!bat_calffdate:~0,2!
				set bat_calffdd=!bat_calffdate:~3,2!
			) else (
					REM The second entry containing "Calibration " of the cal file is the UTC time
				if !bat_calff_line! equ 2 (
					rem time
					!bat_log! %%f, %%g, %%h, %%i, %%j
					set bat_calfftime=%%j
					set bat_calffhh=!bat_calfftime:~0,2!
					set bat_calffm=!bat_calfftime:~3,2!
					set bat_calffss=!bat_calfftime:~6,2!
				) else (
					rem ignore 
				)
			)
		)
		!bat_poplog!


		set bat_filespec=!bat_calffhh!!bat_calffm!!bat_calffss!
		rem Note: bat_searchspec should not contain the time portion, only the date
rem		!bat_logexeclog! set bat_searchspec=FF_!bat_camera_temp!_!bat_calffyyyy!!bat_calffmm!!bat_calffdd!_
		!bat_logexeclog! set bat_searchspec=FF_!bat_camera_temp!_????????_

			REM Search in the SubmissionFiles\camera\capturedfiles\captureddatetime\
		!bat_logexeclog! set bat_tempsearchdir=!bat_submitcapturedbase!\!bat_dir_datetime!
		!bat_log! if not exist "!bat_tempsearchdir!\!bat_searchspec!*.bin" (
		if           not exist "!bat_tempsearchdir!\!bat_searchspec!*.bin" (
			!bat_echolog!
			!bat_echolog! `    OK - Can't find the !bat_searchspec!*.bin in "!bat_tempsearchdir!", 
			!bat_echolog! `         so going to search in the Cal\BinFiles dir...
			
			!bat_logexeclog! set bat_tempsearchdir=!bat_caldir_BinFiles!
		) 
		
		
		rem This loop iterates backward through the CapturedFiles directory [or ..\Cal\BinFiles] and
		rem looks for a file that immediately preceeds the Cal file's date/time.
		rem   NOTE: This allows for the condition where the staging is being 
		rem         done after a 61 archive operation has executed [where has purged
		rem         all the .bin files from the CapturedFiles dir] because it uses
		rem         the backup in ..\Cal\BinFiles.
		set bat_calff_found=0
		
		!bat_log! if not exist "!bat_tempsearchdir!\!bat_searchspec!*.bin" 
		if           not exist "!bat_tempsearchdir!\!bat_searchspec!*.bin" (
			!bat_echolog!
			!bat_echolog! `    ERROR - Can't find the !bat_searchspec!*.bin in "!bat_tempsearchdir!", 
		) else (
			!bat_pushlog! for /f "usebackq tokens=*" ..f in ^(`dir "!bat_tempsearchdir!\!bat_searchspec!*.bin" /s/b /a-d /o-n`^) do 
			for               /f "usebackq tokens=*" %%f in  (`dir "!bat_tempsearchdir!\!bat_searchspec!*.bin" /s/b /a-d /o-n`) do (
				rem
				set bat_tempfilefull=%%f
				set bat_tempfilename=%%~nxf
				set bat_tempdir=%%~dpf
				set bat_tempyyyy=!bat_tempfilename:~10,4!
				set bat_tempmm=!bat_tempfilename:~14,2!
				set bat_tempdd=!bat_tempfilename:~16,2!
				set bat_temphh=!bat_tempfilename:~19,2!
				set bat_tempmin=!bat_tempfilename:~21,2!
				set bat_tempsec=!bat_tempfilename:~23,2!

				set bat_tempspec=!bat_temphh!!bat_tempmin!!bat_tempsec!

				if !bat_calff_found! equ 0 (
					TITLE "Scanning for FF file used in [!bat_calfilename!]: %%~nxf"
					if !bat_tempspec! lss !bat_filespec! (
						set bat_calff_found=!bat_tempfilefull!
						set bat_calffname=!bat_tempfilefull!

							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
						!bat_echolog!
						!bat_echolog! `                     "!bat_calfilename!"
						!bat_echolog! `    ########### FOUND "!bat_tempfilename!" in "!bat_tempdir!"
						!bat_echolog!
						!bat_logexeclog! COPY /Y /b "!bat_calffname!" "!bat_emailfilesdir!"
						
						!bat_echolog!

						if not exist "!bat_caldir!\BinFiles" (
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
								rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							!bat_logexeclog! MKDIR "!bat_caldir!\BinFiles"
						)

							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
						!bat_pushlog! if not exist "!bat_caldir_BinFiles!\!bat_tempfilename!" ^(
							if           not exist "!bat_caldir_BinFiles!\!bat_tempfilename!" (
								!bat_echolog! Making sure a backup copy exists in "!bat_caldir!\BinFiles" for when and in case the CapturedFiles get purged.
						!bat_echolog!
						!bat_echolog! `                     "!bat_calfilename!"
						!bat_echolog! `    ########### FOUND "!bat_tempfilename!" in "!bat_tempdir!"
						!bat_echolog!
						!bat_logexeclog! COPY /Y /b "!bat_tempsearchdir!\!bat_tempfilename!" "!bat_caldir!\BinFiles"

							rem vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
						!bat_echolog! Copy the local_midnight bin files for calibration to the ..\Cal\BinFiles folder. 
						!bat_logexec! COPY /Y /b "!bat_tempsearchdir!FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_1!_*.bin" "!bat_caldir!\BinFiles"
						!bat_logexec! COPY /Y /b "!bat_tempsearchdir!FF_!bat_camera_temp!_????????_!bat_CALIBRATION.local_midnight_2!_*.bin" "!bat_caldir!\BinFiles"
						
						!bat_echolog!
							)
						!bat_poplog! ^)
					) else (
						rem echo NOT FOUND YET
						rem set bat_
						rem !bat_prompt! Press ENTER to continue . . .
					)
					
				)
				

			)
			!bat_poplog!
		)


		rem if cant find the ff file in capturedfiles, find it in Cal\BinFiles
		if /i "!bat_calff_found!" equ 0 (
		
			!bat_echolog! TITLE "Not Found - Scanning .\Cal\BinFiles for FF file used in [!bat_calfilename!]: %%~nxf"
			              TITLE "Not Found - Scanning .\Cal\BinFiles for FF file used in [!bat_calfilename!]: %%~nxf"
		
			if not exist "!bat_caldir\BinFiles\!bat_searchspec!*.bin" (
				!bat_echolog!
				!bat_echolog! `    !bat_batchfile!:COPYCALFF - ERROR - Can't find the !bat_searchspec!*.bin in "bat_caldir\BinFiles" either, 
				!bat_echolog!
			) else (
				set bat_tempspec=CAL!bat_camera_temp!_!bat_tempspec!
				set bat_calff_found=0
				for /f "usebackq tokens=*" %%f in (`dir "!bat_caldir\BinFiles\!bat_searchspec!*.bin" /b /a-d /on`) do (
					set bat_tempfilefull=!bat_caldir\BinFiles\%%~f
					set bat_tempfilename=%%~nxf

					set bat_calff_found=!bat_tempfilefull!
					set bat_calffname=!bat_tempfilefull!
					!bat_echolog!
					!bat_echolog! `                     "!bat_calfilename!"
					!bat_echolog! `    ########### FOUND "!bat_tempfilename!" in ""!bat_caldir\BinFiles"
					!bat_echolog!
					!bat_logexecloglog! COPY /Y /b "!bat_calffname!" "!bat_emailfilesdir!"
					!bat_echolog!
				)
			)

		)
	) else (
		!bat_log! `  ERROR - bat_calfilename=[]
	)

:COPYCALFF_END
!bat_poplog! [RETURN !bat_batchfile!:COPYCALFF] bat_returncode=!bat_returncode!, 
!bat_log! `                                     Cal File FF name for "!bat_emailfilesdir!\!bat_calfilename!"  ["!bat_calffname!"]
!bat_log!
!bat_return! !bat_returncode!








	REM #################################################################
	REM 
:GETCAMERAFROMDETECT
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMDETECT] [%*]
	set bat_detectfile2=!bat_detectfile!
	set bat_detectfile1=!bat_detectfile2!

	if not defined bat_camera (
		rem Try FTPdetectinfoC.txt
		if exist "%~1\FTPdetectinfoC.txt" (	
			set bat_detectfile1=%~1\FTPdetectinfoC.txt
			!bat_log! bat_detectfile1=!bat_detectfile1!
			move /y "!bat_detectfile2!" "FTPdetectinfo.bak.txt"
			copy /y "!bat_detectfile1!" "!bat_detectfile2!"
		) else (
			if exist "%~1\FTPdetectinfo_0???_????_??_??.txt" ( 
				rem Try FTPdetectinfo_###_yyyy_mm_dd.txt
				!bat_log! if exist "%~1\FTPdetectinfo_0???_????_??_??.txt"
				for /f "usebackq tokens=*" %%b in (`dir "%~1\FTPdetectinfo_0???_????_??_??.txt" /a-d /s/b`) do (
					set bat_detectfile1=%%~dpnxb
				)
				move /y "!bat_detectfile2!" "FTPdetectinfo.bak.txt"
				move /y "!bat_detectfile1!" "!bat_detectfile2!"
			) else (
				set bat_detectfile1=!bat_detectfile2!
				!bat_log! bat_detectfile1=!bat_detectfile1!
			)
		)

		find /i ".bin" "!bat_detectfile2!"
		if !errorlevel! neq 0 (
			!bat_log! `  WARNING - Can't ascertain camera from "!bat_detectfile2!"
		) else (
			for /f "usebackq skip=2 tokens=*" %%b in (`find /i ".bin" "!bat_detectfile2!"`) do (
				set bat_camera=%%b
				set bat_camera=!bat_camera:~3,6!
			)
		)

		if "!bat_camera!" equ "" (
			!bat_pushlog! `  Trying to find it from "%~1\FFCorruptFilesLog_Case*.txt"
			for /f "usebackq tokens=*" %%b in (`find /i "is the reference" "%~1\FFCorruptFilesLog_Case*.txt"`) do (
			   set bat_camera=%%b
			   set bat_camera=!bat_camera:~3,6!
			   !bat_log! camera=!bat_camera!
			)
			!bat_poplog!
		)

		echo :GETCAMERAFROMDETECT-return [%*]   [camera=!bat_camera!] [!bat_detectfile1!]
		if "!bat_camera!" equ "" (
			!bat_log! `  ERROR: couldn't determine camera number
			set /p bat_camera=ENTER THE CAMERA NUMBER: 
		)
	)

:GETCAMERAFROMDETECT_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMDETECT] [camera=!bat_camera!, detectfile1=!bat_detectfile1!, detectilfe2=!bat_detectfile2!]
!bat_log!
!bat_return!






	REM #################################################################
	REM 
:GETDETECTFILE [in] "bat_detectfile" "!bat_archiveddirfull!"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*
	call :FINDDETECT "%~1" "%~2"
	if not defined bat_detectfile (
		!bat_log! `  ERROR - No detect file found in: "%~1"
		set bat_returncode=1
		set bat_retval=failed
		goto :GETDETECTFILE_END
	) else (
		set bat_returncode=0
	)
	
:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode!, bat_detectfile=!bat_detectfile!]
!bat_log!
!bat_return!








	REM #################################################################
	REM 
:FINDDETECT [in] bat_detectfile "!bat_archiveddirfull!"
!bat_pushlog! [CALL !bat_batchfile!:FINDDETECT] %*
	set bat_tempdir=%~2
	set bat_tempvar=%~1
	
	if not exist "!bat_tempdir!" (goto :FINDDETECT_END)
	if not exist "!bat_tempdir!\FTPdetectinfo*.txt" (goto :FINDDETECT_END)

	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "%~1" "%~2"

	!bat_logexeclog! set bat_detectfile
	!bat_logexeclog! set bat_archiveddirfull
	
	if not defined %~1 (
		!bat_log! `  !bat_batchfile!:FINDDETECT - WARNING - No detect file found
		goto :FINDDETECT_END
	)
	
:FINDDETECT_END
!bat_poplog! [RETURN !bat_batchfile!:FINDDETECT] [%~1=!%~1!]
!bat_log!
!bat_return!






	REM #################################################################
	REM 
:GETDETECTFILECONF [in] "bat_detectfileconf" "!bat_confirmeddirfull!"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILECONF] %*
	set %~1=

	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "%~1" "%~2"
							!bat_TITLE!

	if not defined %~1 (
		!bat_log! `  !bat_batchfile!:GETDETECTFILECONF - ERROR - No detect file found in: "%~1"
		set bat_returncode=1
		set bat_retval=failed
		goto :GETDETECTFILECONF_END
	)
	
if defined bat_commentedout (
	if /i "!bat_confirmeddirfull!" equ "" (
		goto :GETDETECTFILECONF_END
	)

	set bat_detectfileconf=FTPdetectinfo_!bat_camera!_!bat_captureddate!.txt

	if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
		set bat_detectfileconf=FTPdetectinfo.txt

		if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
			set bat_detectfileconf=
			!bat_log! `  !bat_batchfile!:GETDETECTFILECONF - NOT FOUND - FTPdetectinfo_!bat_camera!_!bat_captureddate!.txt
			goto :GETDETECTFILECONF_END
		)
	)
)& rem commented out

:GETDETECTFILECONF_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILECONF_END] [%~1=!%~1!]
!bat_log!
!bat_return!




















































	REM #################################################################
	REM 
:VALSUBMIT 
!bat_pushlog! [CALL !bat_batchfile!:VALSUBMIT] %*
	set bat_retval=success
	rem This code block should be converted to a standalone batch script.

	!bat_echolog! ***************************** VALIDATION ********************************
	!bat_echolog! [!date! !time!]
	echo.'!bat_pushstring![!date! !time!]>"!bat_validatefile!"
	
	!bat_echolog! bat_validatefile=!bat_validatefile!
	
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	set /a bat_valerrcount=0

	if /i "!bat_submissiondir!" equ "" (
		set /a bat_valerrcount+=1
		           !bat_log! `  !bat_batchfile!:VALSUBMIT - ERROR - bat_submissiondir="!bat_submissiondir!"
		echo.'!bat_pushstring!'  !bat_batchfile!:VALSUBMIT - ERROR - bat_submissiondir="!bat_submissiondir!">>"!bat_validatefile!"

		!bat_echolog!
		!bat_echolog!
		echo.>>"!bat_validatefile!"
		echo.>>"!bat_validatefile!"
	) else (
		        !bat_pushlog! Directory structure of the SubmissionFiles dir
		echo.'!bat_pushstring!Directory structure of the SubmissionFiles dir>>"!bat_validatefile!"
		!bat_echolog!
		echo.>>"!bat_validatefile!"
			!bat_logexec! CALL TREE /a "!bat_submissiondir!"
			!bat_echolog!

			echo.'!bat_pushstring!CALL TREE /a "!bat_submissiondir!">>"!bat_validatefile!"
			echo.>"!bat_validatefile!"
		    CALL TREE /a "!bat_submissiondir!">>"!bat_validatefile!"
		  
			!bat_log!
			echo.>>"!bat_validatefile!"
		!bat_poplog!
	)

	       !bat_pushecho! Directory structure of the Submitted dir...
	echo.'!bat_pushstring!Directory structure of the Submitted dir...>>"!bat_validatefile!"

	            echo.CALL TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!_!bat_capturedtime!">>"!bat_validatefile!"
	   !bat_logexec! CALL TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!_!bat_capturedtime!"
	                 CALL TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!_!bat_capturedtime!">>"!bat_validatefile!"
		!bat_echolog!
		echo.>>"!bat_validatefile!"
	!bat_poplog!
	!bat_pushecho! ` Validate EmailFiles...
	         echo.'!bat_pushstring!' Validate EmailFiles CAL files...>>"!bat_validatefile!"

		if not exist "!bat_emailfilesdir!\ff_!bat_camera!_*.bin" (
			set /a bat_valerrcount+=1
			!bat_log! `   !bat_batchfile!:VALSUBMIT - ERROR - missing "!bat_emailfilesdir!\ff_!bat_camera!_*.bin"
				 echo '   !bat_batchfile!:VALSUBMIT - ERROR - missing "!bat_emailfilesdir!\ff_!bat_camera!_*.bin">>"!bat_validatefile!"
		)

		if not exist "!bat_emailfilesdir!\CAL_!bat_camera!_*.txt" (
			set /a bat_valerrcount+=1
			!bat_log! `   !bat_batchfile!:VALSUBMIT - ERROR - missing "!bat_emailfilesdir!\CAL_!bat_camera!_*.txt"
				 echo '   !bat_batchfile!:VALSUBMIT - ERROR - missing "!bat_emailfilesdir!\CAL_!bat_camera!_*.txt">>"!bat_validatefile!"
		)

		if not exist "!bat_emailfilesdir!\CameraSites-!bat_camera!.txt" (
			set /a bat_valerrcount+=1
			!bat_log! `   !bat_batchfile!:VALSUBMIT - ERROR - missing "!bat_emailfilesdir!\CameraSites-!bat_camera.txt"
				 echo '   !bat_batchfile!:VALSUBMIT - ERROR - missing "!bat_emailfilesdir!\CameraSites-!bat_camera.txt">>"!bat_validatefile!"
		)

	!bat_poplog!
	!bat_log!
	echo.>>"!bat_validatefile!"

	!bat_pushlog! ` Validate EmailFiles dir...
	         echo.'!bat_pushstring!' Validate EmailFiles dir...>>"!bat_validatefile!"
		!bat_log!
		echo.>>"!bat_validatefile!"

		set /a bat_counter=0
		!bat_push!
		for /f "usebackq tokens=*" %%a in (`dir "!bat_emailfilesdir!" /b /a-d /on`) do (
			set /a bat_counter+=1
			!bat_log! `     %%a
			     echo.'!bat_pushstring!     %%a>>"!bat_validatefile!"
		)
	         echo.'!bat_pushstring!  Total files: !bat_counter!>>"!bat_validatefile!"
		!bat_log! `  Total files: !bat_counter!

		if !bat_counter! LSS 6 (
			set /a bat_valerrcount+=1
			!bat_log! `   !bat_batchfile!:VALSUBMIT - ERROR - Missing files from "!bat_emailfilesdir!". There should be
			!bat_log! `                               a minimum of 6 files unless there is actually a ConfirmedFiles
			!bat_log! `                               directory too, in which case there should be 7 or more files.
			!bat_log!

					 echo.'!bat_pushstring!   !bat_batchfile!:VALSUBMIT - ERROR - Missing files from "!bat_emailfilesdir!". There should be>>"!bat_validatefile!"
					 echo.'!bat_pushstring!                                       a minimum of 6 files unless there is actually a ConfirmedFiles>>"!bat_validatefile!"
					 echo.'!bat_pushstring!                                       directory too, in which case there should be 7 or more files.>>"!bat_validatefile!"
					 echo.>>"!bat_validatefile!"
		) else (
			!bat_log! OK
			echo.!bat_pushstring!OK>>"!bat_validatefile!"
			!bat_log!
			echo.>>"!bat_validatefile!"
		)

		!bat_log!
		echo.>>"!bat_validatefile!"
		!bat_poplog!


		!bat_pushlog! ` Validate Cal dir
		         echo.'!bat_pushstring! Validate Cal dir>>"!bat_validatefile!"


	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submitcal!" /b /a-d /on`) do (
		set /a bat_counter+=1
		!bat_log! `     %%a
		         echo.'!bat_pushstring!     %%a>>"!bat_validatefile!"
	)

	!bat_log! `   Total files: !bat_counter!
	     echo.'!bat_pushstring!   Total files: !bat_counter!>>"!bat_validatefile!"

	if !bat_counter! LSS 3 (
		set /a bat_valerrcount+=1
		!bat_log! `    !bat_batchfile!:VALSUBMIT - ERROR - missing files from "!bat_submitcal!". There should be 3 files.
		echo.'!bat_pushstring!    !bat_batchfile!:VALSUBMIT - ERROR - missing files from "!bat_submitcal!". There should be 3 files.>>"!bat_validatefile!"
	) else (
			!bat_log! OK
			echo.!bat_pushstring!OK>>"!bat_validatefile!"
			!bat_log!
			echo.>>"!bat_validatefile!"
	)

	!bat_log!
	echo.>>"!bat_validatefile!"
	!bat_poplog!

	!bat_pushecho! ` Validate Cal file^(s^) in "!bat_submitcal!"
	         echo.'!bat_pushstring! Validate Cal file^(s^) in "!bat_submitcal!">>"!bat_validatefile!"


	set bat_temp=!bat_dirdate:~0,4!!bat_dirdate:~5,2!!bat_dirdate:~8,2!

	!bat_push!
	!bat_log! for /f "usebackq tokens=*" ..x in ^(`type "!bat_emailfilesdir!\CalFileList.log"`^) do ^(
	for           /f "usebackq tokens=*" %%x in  (`type "!bat_emailfilesdir!\CalFileList.log"`) do (
		set /a bat_counter=0
				 echo.'!bat_pushstring!call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\%%x">>"!bat_validatefile!"
		!bat_echolog! call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\%%x"
			      call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\%%x">>"!bat_validatefile!"
		!bat_TITLE!
	)
	!bat_poplog!

	!bat_log! .......................................................
	      echo.......................................................>>"!bat_validatefile!"
	
	!bat_log!
	echo.>>"!bat_validatefile!"
	!bat_log!
	echo.>>"!bat_validatefile!"
	!bat_poplog!



	set /a bat_counter=0
	!bat_CALL! "!bat_exedir!\GetFileCount.bat" "!bat_submitarchived!" /s /a-d
	set bat_counter=!errorlevel!

	!bat_pushlog! `  Validate "!bat_submitarchived!" dir  [Total files=!bat_counter!]
	echo.'!bat_pushstring!  Validate "!bat_submitarchived!" dir  [Total files=!bat_counter!]>>"!bat_validatefile!"
	if !bat_counter! LSS 4 (
		set /a bat_valerrcount+=1
		!bat_log! `     !bat_batchfile!:VALSUBMIT - ERROR - Missing files from "!bat_submitarchived!".
		         echo.'!bat_pushstring!     !bat_batchfile!:VALSUBMIT - ERROR - Missing files from "!bat_submitarchived!".>>"!bat_validatefile!"
	) else (
			!bat_log! OK
			echo.!bat_pushstring!OK>>"!bat_validatefile!"
			!bat_log!
			echo.>>"!bat_validatefile!"
	)

	!bat_poplog!
		


	!bat_log!
	echo.>>"!bat_validatefile!"

	!bat_echolog!      `    Validate "!bat_submitcapturedbase!" dir^(s^)...
	echo.'!bat_pushstring! Validate "!bat_submitcapturedbase!" dir^(s^)...>>"!bat_validatefile!"

	set /a bat_counter=0
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submitcapturedbase!" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					!bat_log! "%%a"
					         echo.'!bat_pushstring!"%%a">>"!bat_validatefile!"
				)
			)
		)
	)
	!bat_poplog!
	echo.>>"!bat_validatefile!"



	!bat_echolog!      `   Total directories=!bat_counter!	in "!bat_submitcapturedbase!" dir  
	echo.'!bat_pushstring!Total directories=!bat_counter!	in "!bat_submitcapturedbase!" dir>>"!bat_validatefile!"

	if !bat_counter! LSS 1 (
		set /a bat_valerrcount+=1
		!bat_log! `             !bat_batchfile!:VALSUBMIT - ERROR - Missing dir from "!bat_submitcapturedbase!".
		echo.'!bat_pushstring!  !bat_batchfile!:VALSUBMIT - ERROR - Missing dir from "!bat_submitcapturedbase!".>>"!bat_validatefile!"
	) else (
			!bat_log! OK
			echo.!bat_pushstring!OK>>"!bat_validatefile!"
			!bat_log!
			echo.>>"!bat_validatefile!"
	)


	set /a bat_counter=0
	!bat_echolog!        `   Counting files in "!bat_submitcapturedbase!", please wait...
	!bat_CALL! "!bat_exedir!\GetFileCount.bat" "!bat_submitcapturedbase!" /s /a-d
	set bat_counter=!errorlevel!

	!bat_echolog!        `   Total files=!bat_counter!	in "!bat_submitcapturedbase!"
	echo.'!bat_pushstring!   Total files=!bat_counter!	in "!bat_submitcapturedbase!">>"!bat_validatefile!"
	
	if !bat_counter! LSS 4 (
		set /a bat_valerrcount+=1
		!bat_log! `    ERROR - Missing files from "!bat_submitcapturedbase!".
		         echo.'!bat_pushstring!    !bat_batchfile!:VALSUBMIT - ERROR - Missing files from "!bat_submitcapturedbase!".>>"!bat_validatefile!"
	) else (
			!bat_log! OK
			echo.!bat_pushstring!OK>>"!bat_validatefile!"
			!bat_log!
			echo.>>"!bat_validatefile!"
	)

	


	
	!bat_log!
	echo.>>"!bat_validatefile!"

	set /a bat_counter=0
	if exist "!bat_submitconfirmed!" (
		!bat_CALL! "!bat_exedir!\GetFileCount.bat" "!bat_submitconfirmed!" /s /a-d
		set bat_counter=!errorlevel!
	)
	!bat_echolog!        `  Validate "!bat_submitconfirmed!" dir  [Total files=!bat_counter!]
	echo.'!bat_pushstring!  Validate "!bat_submitconfirmed!" dir  [Total files=!bat_counter!]>>"!bat_validatefile!"

	if !bat_counter! LSS 1 (
		rem set /a bat_valerrcount+=1
		!bat_log! `    WARNING - Missing files from "!bat_submitconfirmed!".
		         echo.'!bat_pushstring!    !bat_batchfile!:VALSUBMIT - WARNING - Missing files from "!bat_submitconfirmed!".>>"!bat_validatefile!"
	) else (
			!bat_log! OK
			echo.!bat_pushstring!OK>>"!bat_validatefile!"
			!bat_log!
			echo.>>"!bat_validatefile!"
	)

	
	!bat_echolog!
	!bat_echolog! Total validation errors: !bat_valerrcount!
	!bat_echolog!
	
	echo.>>"!bat_validatefile!"
	echo.'!bat_pushstring!Total validation errors: !bat_valerrcount!>>"!bat_validatefile!"
	echo.>>"!bat_validatefile!"

	if defined autonomous (
		if /i "!bat_valerrcount!" neq "0" (
			rem If running in autonomous mode, don't continue..
			set bat_retval=failed
			set bat_returncode=1
			goto :VALSUBMIT_END
			rem exit /b 1
		)
	)
	!bat_pop!
:VALSUBMIT_END
!bat_poplog! [RETURN !bat_batchfile!:VALSUBMIT] Total validation errors: !bat_valerrcount!
	!bat_log! waiting !bat_stage.validatewait! seconds
!bat_WAIT!  !bat_stage.validatewait!
!bat_log!
!bat_return!










	REM #################################################################
	REM 
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] 
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!





	Flowchart:
		- Obtain the processed ".\ConfirmedFiles\<dirname>"
		- Create the target ".\SubmissionFiles\<dirname>" directory tree:
		  - EmailFiles
		  - BinFiles
		  - AviFiles
		- Copy the ".\ArchivedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_scanned-!bat_camera!.txt"
		- Copy the ".\ConfirmedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_confirmed.txt"
		- Copy the ".\ArchivedFiles\<dirname>\CameraTimeOffsets.txt" file 

		- Move the ".\ConfirmedFiles\<dirname>\*.bin" files to 
		  the ".\SubmissionFiles\<dirname>\BinFiles" directory.
		- Read the ".\SubmissionFiles\<dirname>\ftpdetectinfo.txt" file and 
		  get the following:
			- Meteor Count     from line number 1
			- FF  folder       from line number 5
			- CAL folder       from line number 6
			- calibration file from line number 14
			- camera number    from calibration file
	==============================================================		
	New changes 12/20/2011:
		(1) Fixed bugs
		
		(2) Added :VALSUBMIT.  This code block validates all the target
		    directories and files that are supposed to be the result of 
		    a successful submission run.  There are still a few areas that
		    can be validate more thoroughly, namely, the calibration files.

	New changes 09/21/2011:
		(1) Change these changes are to make it easier to restore the files to the 
		x:\CAMS basedir where they can be reprocessed by placing the files in a 
		subdir tree structure under .\SubmissionFiles\[date] that matches the source
		tree structure.
		
		(2) Copy the FF213_20110815_050001_207_0034816.bin type file that was the one used
		for calibration into the ".\SubmissionFiles\[date]\EmailFiles" directory.
		
		(3) 
		
	Note: All the examples will use the following sample names based on 08/15/2011 data:
	   C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
	   C:\CAMS\ArchivedFiles\2011_08_15_04_28_20\*.txt (ftpdetectinfo.txt, etc.)
	   C:\CAMS\CapturedFiles\2011_08_15_04_28_20
	   C:\CAMS\CapturedFiles\2011_08_15_04_28_20\FF213_20110815_050006_172_0057344.bin (calibration file)
	   C:\CAMS\ConfirmedFiles\2011_08_15_04_28_20

	New changes 09/08/2011:
		x Add a " [date/time]\EmailFiles\Cal-[camera]" directory and place the calibration files there.  (I obtain the calibration filename by actually reading the ftpdetectinfo.txt file and then copying the filename from the Cal directory). 
		
		x Copy the ".\Cal\[calfile date/time] to "[date/time]\EmailFiles\Cal-[camera]" but don't change the filename.
		
		x Copy the ".\Cal\CameraSites.txt" file to "[date/time]\EmailFiles\Cal-[camera]" and rename it to "CameraSites-[camera].txt"
		
		x Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[camera]-[meteor count].txt" with the header stripped from it.
		
		x Copy the ".\ArchivedFiles\[date/time]\FTPdetectinfo.txt" file to "[date/time]\EmailFiles\FTPdetectinfo_scanned-[camera]-[meteor count].txt" with the header stripped from it.
		
		x I think that I will also add a file with a name to reflect the meteor count "archived=[count], confirmed=[count].txt" to make it easier to see
		
		- Copy the comments.txt file
		
	Needed changes 02/07/2012:
		- Fix GETCAMERAFROMDETECT so it works if meteorcount is zero.
		- Fix COPYCALFF so it works if meteorcount is zero
		- Fix COPYCALFF so it stops copying the entire cal directory.
		- Test using 02/07/2012 data for no detections. 

	rem    





	REM #################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<archivedfilesdir^>"  "^<capturedfilesdir^>"  firstCamera   [autonomous]
	echo.
	echo.Returns:
	echo.       ERRORLEVEL        0 = success
	echo.                         1 = fail
	echo.Examples: 
	echo.       %~nx0 "C:\CAMS\ArchivedFiles\2011_08_01_05_00_19"  "C:\CAMS\CapturedFiles\2011_08_01_05_00_19"  250  autonomous
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to stage the collection of files that can be
	echo transmitted to the coordinator.  The transmissions need to be broken
	echo down into two different collections for the following purposes: 
	echo 	(1) Transmit the text files to them in a timely manner
	echo 	(2) Archive the FF*.bin files along with the text files
	echo.
	echo.The organization of these files needs to be under the following subdir
	echo.as its base subdir:
	echo.   .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213
	echo.      [Notice the camera subdir to differentiate multiple instances from different boards]
	echo.
	echo.Under that, the first four subdirs follow the same naming convention of the working files:
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\ArchivedFiles
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\Cal
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\CapturedFiles
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\ConfirmedFiles
	echo.
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\EmailFiles       contains:
	echo        - !bat_camera!_archived=56, confirmed=6.txt
	echo                            Contains meteor counts for archived and confirmed, 
	echo                            as well as the contents of the comments_!bat_camera!.txt file.
	echo.
	echo        - CameraSites.txt               From the Cal dir
	echo        - CameraTimeOffsets.txt         From ArchivedFiles
	echo        - comments.txt                  Comments file from the user from ConfirmedFiles dir.
	echo.
	echo        - FTPdetectinfo_confirmed-!bat_camera!.txt
	echo                            renamed from FTPdetectinfo.txt from the 
	echo                            \cams\ConfirmedFiles directory.
	echo                            Also, it should be patched to reflect where  
	echo                            the ff*.bin files are, relative from the 
	echo                            current dir
	echo.
	echo        - FTPdetectinfo_confirmed-213-6.txt
	echo                            Same as FTPdetecinfo_confirmed-!bat_camera!.txt but it has
	echo                            the headers stripped out to make it easier to
	echo                            concatenate.  The numbers are the camera and meteor count.
	echo.
	echo        - FTPdetectinfo_scanned-!bat_camera!.txt
	echo                            Same idea as the FTPdetectinfo_confirmed-!bat_camera!.txt file
	echo                            except that this one comes from the ArchivedFiles
	echo                            directory
	echo.
	echo        - FTPdetectinfo_scanned-213-56.txt
	echo                            Same as for the confirmed file except that this
	echo                            one has the meteor count the ArchivedFiles.
	echo.
	echo        - LASTSETTINGS.txt               From ArchivedFiles
	echo        - ReprocessParameters.txt        From ArchivedFiles
	echo        - submit_!bat_camera!.txt        File containing date of this procedure
	echo.
	echo        ..\EmailFiles\Cal-213
	echo            - CAL213_20110801_050019_514.txt
	echo            - CameraSites-213.txt
	echo            - FF213_20110801_050001_960_0023296.bin  (bin file used for calibration)
	echo.				 
	echo After the script verifies the movement of all these files, the user is ready to create a
	echo zip file of everything in the ".\Submitted\<datetime>_<camera>\EmailFiles" so that 
	echo they can be sent transmitted.  Running "submit.email.bat" will take care of copying
	echo the files to the .\Submit dir.  From there, you can create a zip file of the dirs
	echo that you haven't yet submitted.
	echo.
	echo Most of this can be automated in a script in batch mode. 
	echo.
	echo After a period of time, older SubmissionFiles sessions can be archived to
	echo.a different drive [typically removable].  The age is based on Autocams.params.ini
	echo.[STAGE].MaxDaysToKeep.  
	echo.
	echo.The archiving function "can" have the option to delete FF*.bin files from the
	echo.CapturedFiles under SubmissionFiles before making the archive zip, thus making the
	echo.archive zip smaller, allowing you to archive more sessions.  Remember, the FF*.bin files
	echo.are included in the archive zip. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
exit /b -99


	REM #################################################################
	REM 
:DONE
!bat_pop!
	!bat_poplog!
	!bat_echolog! Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!
	if "!bat_retval!" equ "success" (set bat_retval=0) else (set bat_retval=1)
exit /b !bat_returncode!
