@echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem
rem StageFromConfirmed.bat


	REM #################################################################
	REM 
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	
	REM #################################################################
	REM 
:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	CALL "!bat_exedir!\ReadParams.bat"

	rem	Usage: %~nx0 "^<SubmissionFiles dir^>"  [autonomous]


	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
	)
	
	set bat_temp_commandline=%*
	set bat_temp_commandline=!bat_temp_commandline:autonomous=!

	!bat_log!

rem	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
rem	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
rem		!bat_echolog! `     ERROR: You must start from x:\CAMS directory. 
rem		exit /b 1
rem	)
	

	call :PARSEARGS %*
	if !errorlevel! neq 0 (
		goto :HELP
	)
	

goto :MAIN %*







	REM #################################################################
	REM 
:PARSEARGS 
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] [%*]
	!bat_logexeclog! set bat_submissionfilesdir=%~1&			REM "C:\CAMS\SubmissionFiles\2017_09_05_000250_03_00_00"
	
	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_submissionfilesdir!"&	REM "C:\CAMS\SubmissionFiles\2017_09_05_000250_03_00_00"
	set bat_returncode=!errorlevel!
	
	set bat_temp=!bat_retval1!&						REM "C:\CAMS\SubmissionFiles"   "2017_09_05_000250_03_00_00"

	if /i "\SubmissionFiles" NEQ "!bat_temp:~-16!" (
		!bat_logexeclog! set bat_returncode=1
		!bat_echolog!
		!bat_echolog! `    ERROR - invalid SubmissionFiles argument
		!bat_echolog!
		goto :PARSEARGS_END
	)

	!bat_logexeclog! set bat_camera=!bat_retval2:~11,6!&					REM "2017_09_05_000250_03_00_00"  =  "000250"
	
	!bat_logexeclog! set bat_submissionsession=!bat_retval2!&			REM "2017_09_05_000250_03_00_00"
	!bat_logexeclog! set bat_captureddate=!bat_retval2:~0,10!&			REM "2017_09_05"
	!bat_logexeclog! set bat_capturedtime=!bat_retval2:~-8!&				REM "03_00_00"
	!bat_logexeclog! set bat_capturesession=!bat_captureddate!_!bat_capturedtime!&	REM "2017_09_05_03_00_00"
	
	!bat_logexeclog! !bat_log! `     bat_autonomous=!bat_autonomous!

	!bat_logexeclog! set bat_archivedfilesdir=!bat_camsdir!\ArchivedFiles\!bat_capturesession!
	!bat_logexeclog! set bat_capturedfilesdir=!bat_camsdir!\CapturedFiles\!bat_capturesession!
	!bat_logexeclog! set bat_confirmedfilesdir=!bat_camsdir!\ConfirmedFiles\!bat_capturesession!

	!bat_logexeclog! set bat_caldir=!bat_camsdir!\Cal
	!bat_logexeclog! set bat_caldir_BinFiles=!bat_camsdir!\Cal\BinFiles

	!bat_logexeclog! set bat_validatefile=!bat_logdir!\%~nx0.validate.log
	!bat_logexeclog! set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	

	
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] 
!bat_log! `               bat_submissionfilesdir=!bat_submissionfilesdir!, 
!bat_log! `               bat_archivedfilesdir=!bat_archivedfilesdir!,
!bat_log! `               bat_capturedfilesdir=!bat_capturedfilesdir!,
!bat_log! `               bat_confirmedfilesdir=!bat_confirmedfilesdir!,
!bat_log! `               bat_capturesession=!bat_capturesession!,
!bat_log! `               bat_submissionsession=!bat_submissionsession!]
!bat_log!
!bat_return! !bat_returncode!





	REM #################################################################
	REM 
:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	rem start the execution of the detection pass in background priority
	set bat_returncode=0
	set bat_retval=failed

	!bat_log! [!date! !time!]
rem	!bat_logexeclog! set bat_

	CALL :RESTORESUBMIT
	set bat_returncode=!errorlevel!



:MAIN_END
!bat_poplog! [END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!, goto :DONE]
!bat_log!
goto :DONE







	REM ########################################################################################################
	rem 15. Undo Submission ***************************************
	rem Restore the Archived, Captured, and Confirmed files from 
	rem the SubmissionFiles directory to the basic CAMS subdirs
	rem
	rem This routine's workflow as follows...
	rem  - Move the ..\SubmisionsFiles\..\CapturedFiles\[date/time] to ..\CapturedFiles
	rem  - Remove the ..\SubmissionFiles\..\CapturedFiles dir
	rem
	rem  - Move the ..\SubmisionsFiles\..\ArchivedFiles\[date/time] to ..\ArchivedFiles
	rem  - Remove the ..\SubmissionFiles\..\ArchivedFiles dir
	rem
	rem  - Move the ..\SubmisionsFiles\..\ConfirmedFiles\[date/time] to ..\ConfirmedFiles
	rem  - Remove the ..\SubmissionFiles\..\ConfirmedFiles dir
	rem
	rem  - Move the ..\SubmisionsFiles\..\EmailFiles\Thumbnails??????_????????_??????.bmp to ..\ConfirmedFiles
	rem
	rem  - Clear out and remove the ..\SubmissionFiles\..\Cal dir
	rem  - Clear out and remove the ..\SubmissionFiles\..\EmailFiles dir
	rem
	rem  - Copy the zip files for the [date] from the Transmitted dir back to Submitted
	rem
	rem  - Delete the Submitted dir and remove it
	rem
	rem  - 
:RESTORESUBMIT
!bat_pushlog! [CALL !bat_batchfile!:RESTORESUBMIT] [%*]

	set bat_returncode=0
	
	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog! Error - SubmissionFiles not set. Use "Package Working dirs into SubmissionFiles dirs" first: 
		          !bat_prompt! Press Enter to continue 
		goto :RESTORESUBMIT_END
	)
	
	if /i "!bat_capturedfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog! ERROR - bat_capturedfilesdir is blank
		          !bat_prompt! Press Enter to continue 
		goto :RESTORESUBMIT_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog! ERROR - bat_archivedfilesdir is blank
		          !bat_prompt! Press Enter to continue 
		goto :RESTORESUBMIT_END
	)

		REM These bat_temp_* variables will serve as where these dirs in the submissionfiles dir before moving them back to the working dirs.
	!bat_logexeclog! set bat_temp_cap=!bat_capturedfilesdir!
	!bat_logexeclog! set bat_temp_arch1=!bat_archivedfilesdir!
	!bat_logexeclog! set bat_temp_conf=!bat_confirmedfilesdir!
	!bat_logexeclog! set bat_temp_sub=!bat_submissionfilesdir!
	!bat_logexeclog! set bat_temp


		rem LOGS dir ******************************************
	!bat_pushecho! LOGS dir ******************************************
		!bat_echolog! Working on Logs next...
		call :SEARCHFORDIR "!bat_submissionfilesdir!\!bat_camera!\Logs"
		if !errorlevel! neq 0 (
			REM Error message already logged in SEARCHFORDIR.  So nothing else to do...
		) else (
			if defined bat_retval (
				if exist "!bat_submissionfilesdir!\!bat_camera!\Logs\*.*" (
					!bat_CALL! "!bat_exedir!\RedirectLogs.bat" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!" "!bat_camsdir!\Logs\!bat_captureddatetime!"
					!bat_logexec! MOVE /Y "!bat_submissionfilesdir!\!bat_camera!\Logs\*.*" "!bat_camsdir!\Logs"
					!bat_logexec! RD /S /Q "!bat_submissionfilesdir!\!bat_camera!\Logs"
				)
			)
		)
	!bat_popecho!





		rem CAPTUREDFILES dir ********************************
	!bat_pushecho! CAPTUREDFILES dir ********************************
		call :SEARCHFORDIR "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_capturesession!"
		if !errorlevel! neq 0 (goto :RESTORESUBMIT_END)
		if defined bat_retval (
rem			!bat_logexeclog! set bat_capturedfilesdir=!bat_camsdir!\CapturedFiles\!bat_capturesession!
			!bat_logexeclog! set bat_capdirname=!bat_capturesession!
			!bat_logexeclog! set bat_capbasedir=!bat_camsdir!\CapturedFiles
			!bat_logexeclog! set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

			!bat_logexec! MOVE /Y "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_capturesession!"    "!bat_camsdir!\CapturedFiles"

		) else (
			!bat_echolog!
			!bat_echolog! `    No CapturedFiles dir found - "!bat_capturedfilesdir!"
			!bat_echolog!
			set bat_returncode=3
			
			if "!bat_autonomous!" equ "" (
				!bat_pause!
				if /i "bat_indent_pause!" equ "q" goto :RESTORESUBMIT_END
			)
			
			set bat_capturedfilesdir=
			set bat_capdirname=
			set bat_GCFC_tempfile=
			
			
			
		)

			rem This section removes the remaining directory if it is still there and
			rem it's empty.  If it is not empty, an error message is displayed instead.
		!bat_logexeclog! set bat_temp=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_capturesession!
		!bat_pushecho! if not exist "!bat_temp!" ^(
		if                not exist "!bat_temp!" (
			!bat_echolog! `    OK - no longer exists as expected: "!bat_temp!" 
			!bat_logexeclog! RD /S /Q "!bat_retval2!"
		) else (
			echo !bat_pushstring!dir /s/b "!bat_temp!" 2>&1^|find /i "File Not Found"
			echo !bat_pushstring!dir /s/b"!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile!"
			echo !bat_pushstring!dir /s/b"!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile_full!"
			dir /s/b"!bat_temp!"2>&1|find /i "File Not Found"
			set bat_returncode=!errorlevel!

			if !bat_returncode! equ 0 (
				rem If it gets here, then the dir command resulted in File Not Found, 
				rem as it should be - the dir is empty.  So, just remove the directory.
				!bat_logexec! RD /S /Q "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_capturesession!" 
				!bat_logexec! RD /S /Q "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles"
			) else (
				!bat_echolog!
				!bat_echolog! `    ERROR - Seems that the dir didn't get completely moved back:
				!bat_echolog! `            The following number of files remain in
				!bat_echolog! `            "!bat_temp!"
				!bat_echolog!
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!"
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!">>!bat_logfile!
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!">>!bat_logfile_full!
			
				if not defined bat_autonomous ( 
					!bat_pause!
					if /i "bat_indent_pause!" equ "q" goto :RESTORESUBMIT_END
				)
			)
		)
		!bat_pop! ^)
	!bat_popecho!

		rem ARCHIVEDFILES DIR ********************************
	!bat_pushecho! ARCHIVEDFILES DIR ********************************
	   call :SEARCHFORDIR "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!"
		if !errorlevel! neq 0 (goto :RESTORESUBMIT_END)
		if defined bat_retval (
			!bat_logexeclog! set bat_archivedfilesdir=!bat_camsdir!\ArchivedFiles\!bat_capturesession!
			!bat_logexeclog! set bat_temp_arch2=!bat_capturesession!
			!bat_logexeclog! set bat_archdirname=!bat_capturesession!

			!bat_logexec! MOVE /Y "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!"     "!bat_camsdir!\ArchivedFiles"
		) else (
			!bat_echolog!
			!bat_echolog! `    NO ArchivedFiles dir found. "!bat_archivedfilesdir!"
			!bat_echolog!
			set bat_archivedfilesdir=
			set bat_temp_arch2=
			set bat_archdirname=
		)

		!bat_logexeclog! set bat_temp=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!
		if exist "!bat_temp!" (
			echo !bat_pushstring!dir /s/b "!bat_temp!" 2>&1^|find /i "File Not Found"
			echo !bat_pushstring!dir /s/b "!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile!"
			                     dir /s/b "!bat_temp!"2>&1|find /i "File Not Found"
			!bat_logexeclog! set bat_returncode=!errorlevel!

			if !bat_returncode! equ 0 (
				!bat_logexec! RD /S /Q "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!" 
				!bat_logexec! RD /S /Q "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles"

			) else (
				!bat_echolog!
				!bat_echolog! `    ERROR - Seems that the dir didn't get completely moved back:
				!bat_echolog! `            The following number of files remain in
				!bat_echolog! `            "!bat_temp!"
				!bat_echolog!
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!"
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!">>!bat_logfile!
			
				!bat_pause! rd /q "!bat_retval2!"
				if /i "bat_indent_pause!" equ "q" goto :RESTORESUBMIT_END

			)
		) else (
			!bat_echolog! `    OK - no longer exists as expected: "!bat_temp!"
			!bat_logexec! rd /s /q "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!"
			!bat_logexec! RD /S /Q "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles"
		)
	!bat_popecho!

		rem CONFIRMEDFILES dir ********************************
	!bat_pushecho! CONFIRMEDFILES dir ********************************
		call :SEARCHFORDIR "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!"
		if !errorlevel! neq 0 (
			REM We have already logged the error message.  And it's ok that ConfirmedFiles doesn't exist...
			rem goto :RESTORESUBMIT_END
		)
		
		if defined bat_retval (
			!bat_logexeclog! set bat_confirmedfilesdir=!bat_camsdir!\ConfirmedFiles\!bat_capturesession!
			!bat_logexeclog! set bat_confdirname=!bat_capturesession!
			
			!bat_logexec! MOVE /Y "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!"     "!bat_camsdir!\ConfirmedFiles"
rem !bat_pause! Check the following dirs: "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!"     "!bat_camsdir!\ConfirmedFiles"
		) else (
			!bat_echolog!
			!bat_echolog! `    NOT FOUND - "!bat_camsdir!\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles\!bat_captureddate!*"
			!bat_echolog!
			set bat_confirmedfilesdir=
			set bat_confdirname=
		)

		set bat_temp=!bat_temp_conf!
		!bat_logexeclog! set bat_temp=!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!
		if exist "!bat_temp!" (
			REM after the MOVE command, we want it to be "File Not Found"
			echo !bat_pushstring!dir /s/b "!bat_temp!" 2>&1^|find /i "File Not Found"
			echo !bat_pushstring!dir /s/b "!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile!"
			                     dir /s/b "!bat_temp!"2>&1|find /i "File Not Found"
			set bat_returncode=!errorlevel!
			echo !bat_returncode!
			
			
			if !bat_returncode! equ 0 (
				!bat_logexec! rd /S /Q "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!" 
				!bat_logexec! rd /s /q "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles"

			) else (
				!bat_echolog!
				!bat_echolog! `    ERROR - Seems that the dir didn't get completely moved back:
				!bat_echolog! `            The following number of files remain in
				!bat_echolog! `            "!bat_temp!"
				!bat_echolog!
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!"
				dir "!bat_temp!" 2>&1|find /i " !bat_LOCALIZE.dir.files!">>!bat_logfile!
			
			!bat_pause! rd /q "!bat_retval2!"
			if /i "bat_indent_pause!" equ "q" goto :RESTORESUBMIT_END
				rem
			)
		) else (
			!bat_echolog! `    OK - "!bat_temp!" no longer exists...
			!bat_logexec! rd /s /q "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!"
			!bat_logexec! rd /s /q "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles"
		)
		
		rem THUMBNAILS dir ******************************************
		!bat_echolog!  THUMBNAILS dir ******************************************
		!bat_logexeclog! set bat_temp_emailfiles=!bat_submissionfilesdir!\!bat_camera!\EmailFiles
		
		if defined bat_confirmedfilesdir (
			!bat_logexec! MOVE /y "!bat_temp_emailfiles!\Thumbnails??????_????????_??????.bmp" "!bat_confirmedfilesdir!"
		) else (
			!bat_logexec! MOVE /y "!bat_temp_emailfiles!\Thumbnails??????_????????_??????.bmp" "!bat_archivedfilesdir!"
		)

	!bat_popecho!



	
	!bat_pushecho! Deleting SubmissionFiles\EmailFiles... ******************************************
rem !bat_pause! bat_temp_sub="!bat_temp_sub!"
		!bat_log! if not exist "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_capturesession!" ^(
		if           not exist "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_capturesession!" (
			!bat_log! if not exist  "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!" ^(
			if           not exist  "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_capturesession!" (
				!bat_log! if not exist "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!" ^(
				if           not exist "!bat_submissionfilesdir!\!bat_camera!\ConfirmedFiles\!bat_capturesession!" (
					!bat_log! if defined bat_submissionfilesdir ^(
					if           defined bat_submissionfilesdir (
						!bat_logexec! DEL /Q /S "!bat_submissionfilesdir!\*.*"
						if !errorlevel! neq 0 (
							!bat_echolog! 
							!bat_echolog! `   ERROR - can't delete files from "!bat_temp_sub!"
							!bat_logexec! dir "!bat_submissionfilesdir!" /s/b /on
							!bat_echolog!
						)

						!bat_logexec! rd /q /s "!bat_submissionfilesdir!"
						if !errorlevel! neq 0 (
							!bat_echolog! 
							!bat_echolog! `   ERROR - can't remove dirs from "!bat_submissionfilesdir!"
							!bat_logexec! dir "!bat_submissionfilesdir!" /s/b /on
							!bat_echolog!
						)
					) else (
						!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous command: 
						!bat_pause!  del /q /s "!bat_temp_sub!"
						exit /b -98
					)

					!bat_log! if defined bat_temp_sub ^(
					if           defined bat_temp_sub (
						!bat_log! if defined bat_camera ^(
						if           defined bat_camera (
							!bat_logexec! del /q /s "!bat_temp_sub!\!bat_camera!\EmailFiles\*.*"
							if !errorlevel! neq 0 (
								!bat_echolog! 
								!bat_echolog! `   ERROR - can't delete files from "!bat_temp_sub!"
								!bat_logexec! dir "!bat_temp_sub!\!bat_camera!\EmailFiles\*.*" /s/b /on
								!bat_echolog!
							)
							!bat_logexec! rd /q /s "!bat_temp_sub!\!bat_camera!\EmailFiles"
							if !errorlevel! neq 0 (
								!bat_echolog! 
								!bat_echolog! `   ERROR - can't remove dirs from "!bat_temp_sub!\!bat_camera!\EmailFiles"
								!bat_logexec! dir "!bat_temp_sub!\!bat_camera!\EmailFiles" /s/b /on
								!bat_echolog!
							)
						) else (
							!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous arguments to delete command
							!bat_pause! del /q /s "!bat_temp_sub!\!bat_camera!\EmailFiles"
							exit /b -98
						)
					) else (
						!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous arguments to delete command
						!bat_pause! del /q /s "!bat_temp_sub!\!bat_camera!\EmailFiles"
						exit /b -98
					)

					!bat_log! if defined bat_temp_sub ^(
					if           defined bat_temp_sub (
						if defined bat_camera (
							!bat_logexec! del /q /s "!bat_submissionfilesdir!\!bat_camera!\Cal\*.*"
							if !errorlevel! neq 0 (
								!bat_echolog! 
								!bat_echolog! `   ERROR - can't delete files from "!bat_submissionfilesdir!\!bat_camera!\Cal\*.*"
								!bat_logexec! dir "!bat_submissionfilesdir!\!bat_camera!\Cal" /s/b /on
								!bat_echolog!
							)
							!bat_logexec! rd /q /s "!bat_submissionfilesdir!\!bat_camera!\Cal\!bat_camera!\Cal"
							if !errorlevel! neq 0 (
								!bat_echolog! 
								!bat_echolog! `   ERROR - can't remove dirs from "!bat_submissionfilesdir!\!bat_camera!\Cal"
								!bat_logexec! dir "!bat_submissionfilesdir!\!bat_camera!\Cal" /s/b /on
								!bat_echolog!
							)
						) else (
							!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous command: 
							!bat_pause! del /q /s "!bat_temp_sub!\!bat_camera!\Cal"
							exit /b -98
						)
					) else (
						!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous command: 
						!bat_pause!
						exit /b -98
					)

					!bat_log! if defined bat_camsdir ^(
					if           defined bat_camsdir (
						if defined bat_capturesession (
							if defined bat_camera (
								!bat_logexec! del /q /s "!bat_camsdir!\Submitted\!bat_submissionsession!\*.*"
								if !errorlevel! neq 0 (
									!bat_echolog! 
									!bat_echolog! `   ERROR - can't delete files from "!bat_camsdir!\Submitted\!bat_submissionsession!\*.*"
									!bat_logexec! dir "!bat_camsdir!\Submitted\!bat_submissionsession!" /s/b /on
									!bat_echolog!
								)
								!bat_logexec! rd /q /s "!bat_camsdir!\Submitted\!bat_submissionsession!"
								if !errorlevel! neq 0 (
									!bat_echolog! 
									!bat_echolog! `   ERROR - can't delete directories from "!bat_camsdir!\Submitted\!bat_submissionsession!"
									!bat_logexec! dir "!bat_camsdir!\Submitted\!bat_submissionsession!" /s/b /on
									!bat_echolog!
								)
								
							) else (
								!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous command: del /q /s "!bat_camsdir!\Submitted\!bat_captureddate!_!bat_camera!_!bat_capturedtime!"
								!bat_pause!
								exit /b -98
							)
						) else (
							!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous command: del /q /s "!bat_camsdir!\Submitted\!bat_captureddate!_!bat_camera!_!bat_capturedtime!"
							!bat_pause!
							exit /b -98
						)
					) else (
						!bat_echolog! ERROR [!bat_batchfile!:RESTORESUBMIT] Dangerous command: del /q /s "!bat_camsdir!\Submitted\!bat_captureddate!_!bat_camera!_!bat_capturedtime!"
						!bat_pause!
						exit /b -98
					)
				)
			)
		)
	!bat_popecho!


	!bat_echolog! Transmitted Zip files ******************************************
	!bat_logexeclog! set bat_zipfile_spec=!bat_captureddate!_!bat_camera!_!bat_capturedtime!*.zip
	!bat_logexec! copy /y "!bat_camsdir!\Transmitted\!bat_zipfile_spec!" "!bat_camsdir!\Submitted"

	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=



		!bat_echolog! bat_archivedfilesdir=!bat_archivedfilesdir!9999999999999999999+++++++++++++++++++++++++++++++++++++++++++++++
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat"    "bat_detectfile" "!bat_archivedfilesdir!"
	!bat_echolog! bat_detectfile=!bat_detectfile!
	if defined bat_detectfile (
		if exist "!bat_detectfile!" (
			if not exist "!bat_archivedfilesdir!\CalFileList.log" (
				!bat_CALL! "!bat_exedir!\CreateCalFileList.bat"  "!bat_detectfile!"
			)
		)
	)

	!bat_CALL! "!bat_exedir!\GetMeteorCount.bat"    "!bat_detectfile!"
	set bat_returncode=!errorlevel!
	if !bat_returncode! equ -1 (
		!bat_echolog! GetMeteorCount.bat failed
		goto :RESTORESUBMIT_END
	)

	!bat_echolog! bat_archivedmeteorcount=!bat_archivedmeteorcount!

	!bat_CALLecho! "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
	!bat_CALLecho! "!bat_exedir!\FixMeteorCount.bat" "!bat_detectfile!"
	set bat_calstatus_archived=
	!bat_CALLecho! "!bat_exedir!\GetApplyCalStatus.bat" "!bat_capturedfilesdir!" "!bat_detectfile!"
	!bat_logexeclog! set bat_calstatus_confirmed=!bat_retval!


	!bat_echolog! bat_confirmedfilesdir=!bat_confirmedfilesdir!aaaaaaaaaaaaaaaaa+++++++++++++++++++++++++++++++++++++++++++++++
	if exist "!bat_confirmedfilesdir!" (
		if exist "!bat_confirmedfilesdir!\FTPdetectinfo_!bat_camera!_!bat_capturesession!.txt" (
			call :GETDETECTFILE "bat_detectfileconf" "!bat_confirmedfilesdir!"
			!bat_echolog! bat_detectfileconf=!bat_detectfileconf!

			call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"
			!bat_echolog! bat_confirmedmeteorcount=!bat_confirmedmeteorcount!

			call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!
			!bat_CALLecho! "!bat_exedir!\FixMeteorCount.bat" "!bat_detectfileconf!"
			!bat_CALLecho! "!bat_exedir!\GetMeteorCount.bat" "!bat_detectfileconf!"
			set bat_confirmedmeteorcount=!errorlevel!
			set bat_calstatus_confirmed=
			!bat_CALLecho! "!bat_exedir!\GetApplyCalStatus.bat" "!bat_capturedfilesdir!" "!bat_detectfileconf!"
			!bat_logexeclog! set bat_calstatus_confirmed=!bat_retval!

			call :GETAPPLYCALSTATUS_CONF
		)
	) else (
		!bat_echolog!
		!bat_echolog! OK - ConfirmedFiles dir doesn't exist - "!bat_confirmedfilesdir!" 
	)

	rem This section checks to ensure that the source SubmissionFiles directory
	rem is empty of files, indicating that the move was successful.  If there 
	rem aren't " 0 File(s)", then it displays a message.


	set bat_recent_error_msg=15. [!bat_capturedfilesdir!]
	!bat_CALL! "!bat_exedir!\SaveConfig.bat"

:RESTORESUBMIT_END
!bat_poplog! [RETURN !bat_batchfile!:RESTORESUBMIT_END] [!bat_capturedfilesdir!, 
!bat_log! `                                      !bat_archivedfilesdir!,
!bat_log! `                                      !bat_confirmedfilesdir!,
!bat_log! `                                      !bat_detectfile!]
!bat_log!
	set bat_temp_cap=
	set bat_temp_arch1=
	set bat_temp_conf=
	set bat_temp_sub=
	set bat_temp_arch1=
	set bat_detectfileconf_name=
	set bat_capbasedir=
!bat_return!






	REM ########################################################################################################
	rem Search for the matching directory "...\ArchivedFiles\2012_08_11*"
	rem and parse it into the following three return values:
	rem RETURNS:
	rem 1} bat_retval
	rem    The fully qualified dir name   "...\ArchivedFiles\2012_08_12_03_35_00"
	rem 2} bat_retval2
	rem    The base path                  "...\ArchivedFiles"
	rem 3} bat_retval3  bat_basedir
	rem    The last dir name in the path  "2012_08_12_03_35_00"
:SEARCHFORDIR 
!bat_pushlog! [CALL !bat_batchfile!:SEARCHFORDIR] [%~1]
	rem [in] 
	rem	"!bat_camsdir!\SubmissionFiles\!bat_captureddate!\!bat_camera!\ArchivedFiles\!bat_captureddate!*"
	rem [out] bat_retval 				is a fully qualified directory name
	rem [out] bat_retval2				is that path not including the last dir name of the path	
	rem [out] bat_retval3 bat_basedir		is the last directory name in the path

	set bat_returncode=0
	set bat_retval=
	
	if not exist "%~1*" (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog! ERROR [!bat_returncode!] - Dir doesn't exist: "%~1"
		!bat_echolog!
		goto :SEARCHFORDIR_END
	)
	
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "%~1*" /s/b /ad`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "%~1*" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_log! `.............%%a
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)
	!bat_poplog!

:SEARCHFORDIR_END
!bat_poplog! [RETURN !bat_batchfile!:SEARCHFORDIR] [bat_returncode=!bat_returncode!,
!bat_log! `                                  bat_retval=!bat_retval!, 
!bat_log! `                                  bat_retval2=!bat_retval2!, 
!bat_log! `                                  bat_retval3=!bat_retval3!]
!bat_log!
!bat_return! !bat_returncode!

















	REM #################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<SubmissionFiles dir^>"  [autonomous]
	echo.
	echo.Returns:
	echo.       ERRORLEVEL        0 = success
	echo.                         1 = fail
	echo.Examples: 
	echo.       %~nx0 "C:\CAMS\SubmissionFiles\2017_09_15_000250_03_00_00"  "C:\CAMS\CapturedFiles\2017_09_15_03_00_00"  250  autonomous
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to undo the staging of the collection of files for transmission.  
	echo.
	echo.The organization of the source files needs to be under the following subdir
	echo.as its base subdir:
	echo.   .\CAMS\SubmissionFiles\2017_09_15_03_00_00\000250
	echo.      [Notice the camera subdir to differentiate multiple instances from different boards]
	echo.
	echo.Under that, the first four subdirs follow the same naming convention of the working directories:
	echo    .\CAMS\SubmissionFiles\2017_09_15_03_00_00\000250\ArchivedFiles
	echo    .\CAMS\SubmissionFiles\2017_09_15_03_00_00\000250\Cal
	echo    .\CAMS\SubmissionFiles\2017_09_15_03_00_00\000250\CapturedFiles
	echo    .\CAMS\SubmissionFiles\2017_09_15_03_00_00\000250\ConfirmedFiles
	echo.
	echo.ArchivedFiles, CapturedFiles, and ConfirmedFiles will be MOVEd back to the working directories and then removed.  The Cal
	echo.dir will remain until the rest of the submissionfiles folder is cleared and removed. 
	echo.
	echo    .\CAMS\SubmissionFiles\2017_09_15_03_00_00\000250\EmailFiles
	echo.				 
	echo After the script verifies the movement of all these files, the user is ready to do any of the standard
	echo.Autocams operations.  
	echo.
	echo.
exit /b -99


	REM #################################################################
	REM 
:DONE
!bat_pop!
	!bat_poplog!
	!bat_echolog! Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!
	if "!bat_retval!" equ "success" (set bat_retval=0) else (set bat_retval=1)
exit /b !bat_returncode!
