@echo off 
setlocal enabledelayedexpansion enableextensions

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	set bat_startlocation=!bat_camsdir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:

	set bat_caldir=!bat_camsdir!\Cal

	set bat_Header=11
	set bat_Trailer=0

	set bat_SourceDetectFile=%~1
	set bat_TargetHeaderFile=%~2
	set bat_TargetDetectFile=%~3

	set bat_Script=!bat_exedir!\StripHeader.vbs
	set VB=echo^>^>"%bat_Script%" 
goto :MAIN


:MAIN
	cd 1>nul 2>"%bat_Script%"

	%VB% SourceFile="!bat_SourceDetectFile!"
	%VB% HeaderFile="!bat_TargetHeaderFile!"
	%VB% TargetFile="!bat_TargetDetectFile!"
	%VB% FileName="!bat_SourceDetectFile!"
	%VB% WScript.Echo    "    SourceFile="+SourceFile
	%VB% WScript.Echo    "    HeaderFile="+HeaderFile
	%VB% WScript.Echo    "    TargetFile="+TargetFile
	%VB% WScript.Echo    "    FileName="+FileName
	%VB% Set oFSO = CreateObject("Scripting.FileSystemObject") 
	%VB% If oFSO.GetFile(FileName).Size ^> 0 Then 
	%VB%   sNewName = "!bat_TargetHeaderFile!" 
	%VB%   Set oInFile = oFSO.OpenTextFile(FileName) 
	%VB%   aData = Split(oInFile.ReadAll, VbCrLf) 
	%VB%   If UBound(aData) ^> !bat_Header! Then 
	%VB%     Set oOutFile = oFSO.OpenTextFile(sNewName, 2, True) 
	%VB%     For i = 0 To !bat_Header! - 1
	%VB%       oOutFile.WriteLine aData(i) 
	%VB%     Next 
	%VB%     oOutFile.Close 
	%VB%   End If 
	%VB%   oInFile.Close 
	%VB% End If 
	%VB% Set oFSO = CreateObject("Scripting.FileSystemObject") 
	%VB% If oFSO.GetFile(FileName).Size ^> 0 Then 
	%VB%   sNewName = "!bat_TargetDetectFile!" 
	%VB%   Set oInFile = oFSO.OpenTextFile(FileName) 
	%VB%   aData = Split(oInFile.ReadAll, VbCrLf) 
	%VB%   If UBound(aData) ^>= !bat_Header! Then 
	%VB%     Set oOutFile = oFSO.OpenTextFile(sNewName, 2, True) 
	%VB%     For i = !bat_Header! To UBound(aData) - 1
	%VB%       oOutFile.WriteLine aData(i) 
	%VB%     Next 
	%VB%     oOutFile.Close 
	%VB%   End If 
	%VB%   oInFile.Close 
	%VB% End If 

	!bat_logexec! call cscript //nologo "%bat_Script%"
	rem del "%bat_Script%"

goto :DONE


rem EXAMPLE to strip the headers from all the files in the 2012_05_20 directory
rem         of all FTPdetectinfo_scanned*.txt files:
rem 	for /f "usebackq tokens=*" %a in (`dir "C:\d\cams\Temp\Coincidence\2012_05_20\FTPdetectinfo_scanned*.txt" /s/b /a-d /on`) do ( 
rem 		call "c:\d\cams\stripHeaderVBS.bat" "%a" "%a_header.txt" "%a_stripped.txt"
rem 	)


	rem Usage: 
	rem 	%1="C:\CAMS\SubmissionFiles\2011_12_14\000213\FTPdetectinfo_scanned_000213.txt"
	rem 	%2="C:\CAMS\SubmissionFiles\2011_12_14\000213\FTPdetectinfo_scanned_000213_header.txt"
	rem 	%3="C:\CAMS\SubmissionFiles\2011_12_14\000213\FTPdetectinfo_scanned_000213_000282.txt"
	rem 



:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "<source file>" "<header file>" "<stripped file>"
	echo.
	echo Strips the header from the input detect file and saves the results in 
	echo the output file.  This prepares the files for coincidence processing
	echo which merges the files together and adds its own header.
	echo.
	echo Reads the detect file:   "<source file>"
	echo Outputs the detect file: "<header file>"
	echo Outputs the header:      "<stripped file>"
	echo.
	echo Example ^(This is what the Submission script runs^):
	echo     call "C:\CAMS\StripHeaderNASA.bat" "C:\CAMS\SubmissionFiles\2011_12_14\000214\ConfirmedFiles\FTPdetectinfo_0214_2011_12_14.txt" "C:\CAMS\SubmissionFiles\2011_12_14\000214\EmailFiles\FTPdetectinfo_0214_2011_12_14_confirmed.txt" "C:\CAMS\SubmissionFiles\2011_12_14\000214\EmailFiles\FTPdetectinfo_0214_2011_12_14_confirmed_header.txt"
	echo     call "C:\CAMS\StripHeaderNASA.bat" "C:\CAMS\SubmissionFiles\2011_12_14\000214\ArchivedFiles\FTPdetectinfo_0214_2011_12_14.txt"  "C:\CAMS\SubmissionFiles\2011_12_14\000214\EmailFiles\FTPdetectinfo_0214_2011_12_14_scanned.txt"   "C:\CAMS\SubmissionFiles\2011_12_14\000214\EmailFiles\FTPdetectinfo_0214_2011_12_14_scanned_header.txt"
	echo.
	echo The first command strips the header from the source detect files and 
	echo outputs the results and the stripped headers to a different name in 
	echo a different directory.
	echo.
	echo Source file:
	echo.
	echo.
	echo.
	echo.

exit /b -99

:DONE

