@echo off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

	REM ################################################
	REM
:CHECKHELP
	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	REM ################################################
	REM
:SETUP
	if "%~2" equ "" goto :HELP


	REM ################################################
	REM
	REM Strip any trailing backslashes from the variable. 
	REM Returns: value in the arg1 value.
:STRIPTRAILINGBACKSLASHES [in variable] [in path] [out variable]
!bat_pushlog! [CALL !bat_batchfile!:STRIPTRAILINGBACKSLASHES] %1  %2

	set bat_temp=%~2\\
	set bat_temp=!bat_temp:\\\=!
	set bat_temp=!bat_temp:\\=!

:STRIPTRAILINGBACKSLASHES_END
!bat_poplog! [RETURN !bat_batchfile!:STRIPTRAILINGBACKSLASHES] "%~1", 
!bat_log! `               "%~2", 
!bat_log! `               %~1=bat_temp="%bat_temp%"]
!bat_log!
	(ENDLOCAL & REM RETURN VALUES
		set %~1=%bat_temp%
	)
!bat_return! 0




	REM ################################################
	REM
:HELP
	echo %~nx0
	echo.
	echo Usage: %~n0 "variable" "path"
	echo.
	echo. This routine trims any trailing backslashes from a path and returns
	echo. the adjusted value in the variable as passed.  So, instead of 
	echo. making multiple set calls, just do this, for example:
	echo.
	echo. 	!bat_CALL! "!bat_exedir!\StripTrailingBackslashes.bat" bat_precapturedfilesdir "!bat_archivedfilesdir!"
	echo.
	echo. So, if the value of !bat_archivedfilesdir! is something like this:
	echo.    "D:\CAMS\ArchivedFiles\2017_10_22_08_00_00\"      [notice the traling backslash]
	echo. 
	echo. then the bat_precapturedfilesdir value will contain: "D:\CAMS\ArchivedFiles\2017_10_22_08_00_00"
	echo.
	echo.IMPORTANT: Must be called from within an AutoCams script that has used "autocams.setup.bat", such
	echo.           as TestScript.bat or AutoCams.bat, etc. Otherwise, many of the logging and other 
	echo.           macros, like !bat_return! and such won't work. 
	echo.
exit /b -99



