@echo off
setlocal enableextensions enabledelayedexpansion

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP


	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog! =============================================================
	!bat_echolog! [!date! !time!] %~0 [%*]
	!bat_pushlog!


	call :READCONFIG
	!bat_CALL! "!bat_exedir!\ReadParams.bat"




	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!

	set /a bat_count=0
	set bat_skip=
	set bat_decimationfactoroption=
	set bat_delete=
	set bat_interactive=
	set bat_skipoption=
	set bat_choice=
	set bat_thumbnail_mode=
	set bat_thumbnail_params=

	if /i "%~1" neq "" (
		rem This script was called with one or more command line arguments, so parse them out...
		set bat_thumbnails.targetdir=
		call :TEST0 %*
	) else (
		rem The user didn't specify any command line args, go into interactive mode and ask which thumbnails to build...
		call :ASK_MODE
		if /i "!bat_returncode!" equ "99" goto :DONE
	)
	
	if /i "!bat_thumbnail_mode!" neq "" (
		rem If there is a thumbnail_mode, such as bat_THUMBNAILS.archived.staged... 
		if /i "!bat_thumbnail_params!" equ "" (
			rem If there aren't any bat_thumbnail_params, then configure them...
			call :GET_MODE_PARAMS "!bat_thumbnail_mode!"
		)
	)
	
	if /i "!bat_thumbnails.targetdir!" NEQ "" (

		if not exist "!bat_thumbnails.targetdir!\FF*.bin" (
			call :ERRLOG "WARN OK - targetdir is empty: [!bat_thumbnails.targetdir!]"
			goto :DONE
		)
	) else (
		call :ERRLOG "ERROR - targetdir variable is empty: [bat_thumbnails.targetdir=!bat_thumbnails.targetdir!]"
		goto :DONE
	)


	call :THUMBNAILS_MODE

goto :DONE



	rem	Process the command line arguments.  See the :HELP section for details.
	rem It automatically parses values using equals and space.
:TEST0
!bat_pushlog! [CALL !bat_batchfile!::TEST0] [%*]
:TEST1
!bat_log! [GOTO !bat_batchfile!::TEST1] [%~1] [%~2]
	if /i "%~1" equ "" goto :TEST_END
	set /a bat_count+=1
	
	if /i "%~1" equ "/mode" (
		!bat_logexeclog! set bat_thumbnail_mode=%~2
        !bat_echolog! ..............detected "/mode" on the command line" - bat_thumbnail_mode=!bat_thumbnail_mode!		
		shift
		shift
		goto :TEST1
	)

	if /i "%~1" equ "/archiveddir" (
		set bat_archivedfilesdir=%~2
		!bat_logexeclog! set bat_thumbnails.targetdir=%~2
		set bat_choice=a
		!bat_log! bat_archivedfilesdir="!bat_archivedfilesdir!"
		shift
		shift
		goto :TEST1
	) else (
			if /i "%~1" equ "/captureddir" (
			set bat_capturedfilesdir=%~2
			!bat_logexeclog! set bat_thumbnails.targetdir=%~2
			set bat_choice=c
			!bat_log! bat_capturedfilesdir="!bat_capturedfilesdir!"
			shift
			shift
			GOTO :TEST1
		) else (
			if /i "%~1" equ "/confirmeddir" (
				set bat_confirmedfilesdir=%~2
				!bat_logexeclog! set bat_thumbnails.targetdir=%~2
				set bat_choice=f
				!bat_log! bat_confirmedfilesdir="!bat_confirmedfilesdir!"
				shift
				shift
				GOTO :TEST1
			)
		)
	)
	
	if /i "%~1" equ "/skip" (
		!bat_logexeclog! set bat_skipoption=%~2
		
		shift
		shift
		goto :TEST1
	)
	
	if /i "%~1" equ "/factor" (
		!bat_logexeclog! set bat_decimationfactoroption=%~2
		shift
		shift
		goto :TEST1
	)
	
	if /i "%~1" equ "/delete" (
		!bat_logexeclog! set bat_deletechoice=%~2
		shift
		shift
		goto :TEST1
	)

	if /i "%~1" equ "/interactive" (
		!bat_logexeclog! set bat_interactive=%~2
		shift
		shift
		goto :TEST1
	)

	shift
	goto :TEST1

:TEST_END
!bat_poplog! [RETURN !bat_batchfile!:TEST0] [bat_count=!bat_count!,
!bat_log! `                                 bat_archivedfilesdir=!bat_archivedfilesdir!,
!bat_log! `                                 bat_capturedfilesdir=!bat_capturedfilesdir!,
!bat_log! `                                 bat_confirmedfilesdir=!bat_confirmedfilesdir!,
!bat_log! `                                 bat_skipoption=!bat_skipoption!,
!bat_log! `                                 bat_decimationfactoroption=!bat_decimationfactoroption!,
!bat_log! `                                 bat_deletechoice=!bat_deletechoice!,
!bat_log! `                                 bat_interactive=!bat_interactive!,
!bat_log! `                                 bat_thumbnail_mode=!bat_thumbnail_mode!,
!bat_log! `                                 bat_thumbnail_params=!bat_thumbnail_params!]
!bat_log!
!bat_return!



:ASK_MODE
!bat_pushlog! [CALL !bat_batchfile!:ASK_MODE] [%*]
	set bat_returncode=99

	echo.
	echo.
	echo.Thumbnail Option                                Res  Skip		Command Line Arguments
	echo.------------------------------                  ---  --- 		----------------------------------------------------------
	rem List the bat_THUMBNAILS modes:
	set bat_padding=                                                 xxxx
	set /a bat_count=0
	rem Iterate through the environment variables from the [THUMBNAILS] section
	for /f "usebackq tokens=1,* delims==" %%a in (`set bat_THUMBNAILS.`) do (
		set bat_thumb_line=%%a

		set bat_thumb_key=
		set bat_thumb_val=
		set bat_thumb_cmd=
		set bat_thumb_res=
		set bat_thumb_skip=

		set bat_thumb_key=%%a
		set bat_thumb_val=%%b
		
		if /i "!bat_thumb_val!" neq "" (
			for /f "usebackq tokens=1-5" %%c in ('!bat_thumb_val!') do (

				set bat_thumb_cmd=%%c
				set bat_thumb_res=%%d
				set bat_thumb_skip=%%e

			)
		)


		set bat_temp=  !bat_thumb_key!               !bat_padding!

		if /i "!bat_thumb_key!" equ "bat_THUMBNAILS.ARCHIVED" (
			echo.
			echo.ARCHIVED
		) else (
			if /i "!bat_thumb_key!" equ "bat_THUMBNAILS.CAPTURED" (
				echo.
				echo.CAPTURED
			) else (
				if /i "!bat_thumb_key!" equ "bat_THUMBNAILS.CONFIRMED" (
					echo.
					echo.CONFIRMED
				) else (
					if /i "!bat_thumb_key!" neq "bat_THUMBNAILS.preview_cmd_line" (
						set /a bat_count+=1

						rem Strip off the "bat_THUMBNAILS." part of the env var and pad with spaces
						rem set bat_temp=!bat_temp:bat_THUMBNAILS.=!
						rem set bat_temp=!bat_temp:~0,51! %%b

						rem echo.!bat_count!.  !bat_temp!
						echo !bat_count! !bat_thumb_key!	!bat_thumb_res!    !bat_thumb_skip!		!bat_thumb_cmd! !bat_thumb_res! !bat_thumb_skip!
						
					)
				)
			)
		)
	)
	
:ASK_MODE1
	echo.
	set bat_choice=
	!bat_log! Enter the thumbnail mode or [Q]uit: 
	!bat_prompt! Enter the thumbnail mode or [Q]uit: 

	if /i "!bat_choice!" equ "" (set bat_choice=Q)
	if /i "!bat_choice!" equ "q" (goto :ASK_MODE_END)

	set bat_thumbnail_mode=
	set bat_thumbnail_params=

	set bat_returncode=0
	set /a bat_count=0
	set bat_found=

	for /f "usebackq tokens=1,* delims==" %%a in (`set bat_THUMBNAILS.`) do (
		set bat_thumb_line=%%a

		set bat_thumb_key=
		set bat_thumb_val=
		set bat_thumb_cmd=
		set bat_thumb_res=
		set bat_thumb_skip=

		set bat_thumb_key=%%a
		set bat_thumb_val=%%b

		if /i "!bat_thumb_val!" neq "" (
			for /f "usebackq tokens=1-5" %%c in ('!bat_thumb_val!') do (

				set bat_thumb_cmd=%%c
				set bat_thumb_res=%%d
				set bat_thumb_skip=%%e

			)
		)

		set bat_temp=  !bat_thumb_key!               !bat_padding!

		if /i "!bat_thumb_key!" equ "bat_THUMBNAILS.ARCHIVED" (
			rem
		) else (
			if /i "!bat_thumb_key!" equ "bat_THUMBNAILS.CAPTURED" (
				rem
			) else (
				if /i "!bat_thumb_key!" equ "bat_THUMBNAILS.CONFIRMED" (
					rem
				) else (
					if /i "!bat_thumb_key!" neq "bat_THUMBNAILS.preview_cmd_line" (
						set /a bat_count+=1

						rem echo.  !bat_count!.  %%a           = [%%b]
						if /i "!bat_count!" equ "!bat_choice!" (
							!bat_logexeclog! set bat_thumbnail_mode=!bat_thumb_key!
							!bat_logexeclog! set bat_thumbnail_params=!bat_thumb_val!
							!bat_logexeclog! set bat_found=true
						)
					)
				)
			)
		)
	)


%bat_COMMENT_BEGIN%
	for /f "usebackq tokens=1,* delims==" %%a in (`set bat_thumbnails.`) do (
		set /a bat_count+=1
		rem echo.  !bat_count!.  %%a           = [%%b]
		if /i "!bat_count!" equ "!bat_choice!" (
			!bat_logexeclog! set bat_thumbnail_mode=%%a
			!bat_logexeclog! set bat_thumbnail_params=%%b
			!bat_logexeclog! set bat_found=true
		)
	)
%bat_COMMENT_END%
	
	if not defined bat_found (goto :ASK_MODE1)
	
	if /i "!bat_thumbnail_params!" equ "" (goto :ASK_MODE1)
	rem Parse the params to get the directory
	call :GET_TARGETDIR !bat_thumbnail_params!



:ASK_MODE_END
!bat_poplog! [RETURN !bat_batchfile!:ASK_MODE] [bat_returncode=!bat_returncode!,
!bat_log!    `                                  bat_thumbnail_mode=!bat_thumbnail_mode!,
!bat_log!    `                                  bat_thumbnail_params=!bat_thumbnail_params!,
!bat_log!    `                                  bat_thumbnails.targetdir=!bat_thumbnails.targetdir!]
!bat_log!
!bat_return!



:GET_MODE_PARAMS [in=!bat_thumbnail_mode! out=[!bat_thumbnail_params!]
!bat_pushlog! [CALL !bat_batchfile!:GET_MODE_PARAMS] [%*]
	
	for /f "usebackq tokens=1,* delims==" %%a in (`set bat_thumbnails.`) do (
		if /i "%%~a" equ "!bat_thumbnail_mode!" (
			!bat_logexeclog! set bat_thumbnail_params=%%b
		)
	)
	
	rem Parse the params to get the directory
	call :GET_TARGETDIR !bat_thumbnail_params!

:GET_MODE_PARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:GET_MODE_PARAMS] [bat_returncode=!bat_returncode!,
!bat_log!    `                                         bat_thumbnail_mode=!bat_thumbnail_mode!,
!bat_log!    `                                         bat_thumbnail_params=!bat_thumbnail_params!]
!bat_log!
!bat_return!




:GET_TARGETDIR
!bat_pushlog! [CALL !bat_batchfile!:GET_TARGETDIR] [%*]
	!bat_logexeclog! set bat_thumbnails.targetdir=%~1

:GET_TARGETDIR_END
!bat_poplog! [RETURN !bat_batchfile!:GET_TARGETDIR] [bat_thumbnails.targetdir=!bat_thumbnails.targetdir!]
!bat_log!
!bat_return!




:THUMBNAILS_MODE
	!bat_pushlog! [CALL !bat_batchfile!::THUMBNAILS_MODE] [%*]
	setlocal enableextensions enabledelayedexpansion

	set bat_returncode=0

	!bat_echolog!
	!bat_echolog! Launching FTP_Thumbnails.exe asynchronously to build the thumbnails files...
	!bat_echolog! start /w "FTP_Thumbnails.exe /mode=!bat_thumbnail_mode!" "!bat_exedir!\FTP_Thumbnails.exe" !bat_thumbnail_params!
	              start /w "FTP_Thumbnails.exe /mode=!bat_thumbnail_mode!" "!bat_exedir!\FTP_Thumbnails.exe" !bat_thumbnail_params!

	set bat_returncode=!errorlevel!
	!bat_echolog! bat_returncode=!bat_returncode!
	if not defined bat_interactive (
		call :THUMBNAIL_PREVIEW !bat_thumbnails.targetdir!
	)
	
	rem Routine that deletes or not depending on logic and /delete parameter along with /interactive mode
	call :THUMBNAILS_DELETE !bat_thumbnails.targetdir!
	

:THUMBNAILS_MODE_END
!bat_poplog! [RETURN !bat_batchfile!:THUMBNAILS] []
!bat_log!
ENDLOCAL
!bat_return!


	rem ******************* DELETE OR KEEP ***********************
:THUMBNAILS_DELETE
	set bat_tempdir=%~1
	!bat_pushlog! [CALL !bat_batchfile!:THUMBNAILS_DELETE] [!bat_tempdir!]
:THUMBNAILS_DELETE2
	if not defined bat_interactive (
		!bat_echo!
		!bat_echo!
		set bat_choice=
		set /p bat_choice='!bat_pushstring![K]eep or [D]elete the files? [D] 

		if /i "!bat_choice!" equ "" set bat_choice=d
		if /i "!bat_choice!" equ "k" (goto :THUMBNAILS_DELETE_END)
		!bat_echo! [!bat_choice!]

		if defined bat_tempdir (
			if /i "!bat_choice!" equ "d" (
				!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_tempdir!\Thumbnails*.bmp" /b /a-d /on`^) do ^(
					for           /f "usebackq tokens=*" %%a in  (`dir "!bat_tempdir!\Thumbnails*.bmp" /b /a-d /on`) do (
						if /i "%%a" neq "" (
							!bat_logexec! del /q "!bat_tempdir!\%%a"
						) else (
							!bat_echolog! ERROR [!bat_batchfile!:THUMBNAILS_DELETE] Dangerous command: del /q "!bat_tempdir!\%%a"
						)
					)
				!bat_poplog! ^)
				goto :THUMBNAILS_DELETE_END
			)
			goto :THUMBNAILS_DELETE2
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:THUMBNAILS_DELETE] Dangerous command: del /q "!bat_tempdir!\%%a"
		)
	)
	rem ******************* end: DELETE OR KEEP *******************
:THUMBNAILS_DELETE_END
!bat_poplog! [RETURN:!bat_batchfile!:THUMBNAILS_DELETE] [!bat_tempdir!]
!bat_return!




:THUMBNAIL_PREVIEW
	!bat_pushlog! [CALL :THUMBNAIL_PREVIEW %~1]
	setlocal enableextensions enabledelayedexpansion
	
	if /i "%~1" equ "" goto :THUMBNAIL_PREVIEW_END

	set bat_tempdir=%~1
	
	if not exist "!bat_tempdir!\Thumbnails*.bmp" (
		!bat_echo! `    ERROR - No matching files exist: [!bat_tempdir!\Thumbnails*.bmp]
		!bat_echo!
		!bat_logexec! dir "!bat_tempdir!\Thumbnails*.bmp" /s/b
		!bat_echo!
		goto :THUMBNAIL_PREVIEW_END
	)
	
:THUMBNAIL_PREVIEW2
	if not defined bat_interactive (
		!bat_echo!
		!bat_echo!
		set /a bat_count=0
		for /f "usebackq tokens=*" %%a in (`dir "!bat_tempdir!\Thumbnails*.bmp" /s/b /a-d /on`) do (
			set /a bat_count+=1
			!bat_echo! !bat_count!. %%~tzfa
		)
		!bat_echo!

		set bat_choice=
		!bat_log! set /p bat_choice='!bat_pushstring!Choose the file to display, or [Q]uit: 
				  set /p bat_choice='!bat_pushstring!Choose the file to display, or [Q]uit: 
		if defined bat_choice (
			if /i "!bat_choice!" equ ""  (
				goto :THUMBNAIL_PREVIEW_END
			)

			if /i "!bat_choice!" equ "q" (
				goto :THUMBNAIL_PREVIEW_END
			)

			if !bat_choice! gtr 0 (
				if !bat_choice! leq !bat_count! (
					set /a bat_count=0
					for /f "useback tokens=*" %%a in (`dir "!bat_tempdir!\Thumbnails*.bmp" /b /a-d /on`) do (
						set /a bat_count+=1
						if !bat_choice! equ !bat_count! (
							rem This section performs the $file_name variable with a runtime value
							rem preview_cmd_line=start /w "" "$file_full"
							!bat_logexeclog! set bat_preview_file="!bat_tempdir!\%%a"
							!bat_logexeclog! set bat_temp_cmdline=%bat_THUMBNAILS.preview_cmd_line:"$file_full"=!bat_preview_file!%
							
							
							rem !bat_echolog! start /w "" "!bat_tempdir!\%%a"
							rem 		  start /w "" "!bat_tempdir!\%%a"
							!bat_echolog! !bat_temp_cmdline!
										  !bat_temp_cmdline!
							
						)
					)
				)
			)

			goto :THUMBNAIL_PREVIEW2
		) else (
			goto :THUMBNAIL_PREVIEW_END
		)
	)
	



:THUMBNAIL_PREVIEW_END
!bat_popecho! [RETURN !bat_batchfile!:THUMBNAIL_PREVIEW] [!bat_returncode!]
!bat_log!
ENDLOCAL
!bat_return!





	rem 6. SkippedFrames ******************************************
	rem    Lists the skipped frames and produces a summary.  The summary is 
	rem    saved in the current bat_logfile. 
:SKIPPEDFRAMES
	if /i "%~1" equ "" (set bat_args=) else (set bat_args=/v /ok) 
	!bat_CALLecho! "!bat_exedir!\SkippedFrames.bat" /camera !bat_camera! "!bat_capturedfilesdir!"

:SKIPPEDFRAMES_END
	if /i "%~1" equ "" (pause)
!bat_log!
!bat_return!





	rem 70u. Thumbnails / Contact Sheet
	rem      test example:
	rem        cls&call "thumbnails.bat" /skip=14 /archiveddir="c:\cam213\CAMS\SubmissionFiles\2013_05_02_213_03_37_47\213\ArchivedFiles\2013_05_02_03_37_47" /factor=4
:THUMBNAILS
	!bat_pushlog! [CALL :THUMBNAILS] [%*]
	setlocal enableextensions enabledelayedexpansion

!bat_pause! YOU SHOULD NOT BE ABLE TO GET TO THIS SECTION OF CODE 

:THUMBNAILS1
	if not defined bat_thumbnails.targetdir (
		if not defined bat_interactive (
			rem Note: bat_interactive is not defined unless /interact=anything on command line

			echo.
			echo.!bat_pushstring!Using the date/time from:
			echo.!bat_pushstring!      !bat_capturedfilesdir!
			echo.!bat_pushstring!      !bat_archivedfilesdir!
			echo.!bat_pushstring!      !bat_confirmedfilesdir!
			echo.
			set bat_choice=
			set /p bat_choice=.!bat_pushstring!Which directory to process [A]rchivedFiles, [C]apturedFiles, Con[f]irmedFiles, or [Q]uit [default=C]? 
			echo.Choice=[!bat_choice!]
			if /i "!bat_choice!" equ "q" (goto :THUMBNAILS_END)
			if /i "!bat_choice!" equ "" (set bat_choice=c)
			if /i "!bat_choice!" equ "vars" (
				set bat_
				goto :THUMBNAILS1
			)
		)
	)
	
	set /a bat_skip=1
	

	set /a bat_count=0
	if /i "!bat_choice!" equ "a" (
		set bat_choice=!bat_archivedfilesdir!
		for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\ff*.bin" /b /a-d /on`) do (
			set /a bat_count+=1
		)
	) else (
		if /i "!bat_choice!" equ "c" (
			set bat_choice=!bat_capturedfilesdir!
			for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\ff*.bin" /b /a-d /on`) do (
				set /a bat_count+=1
			)
			echo.
			call :SKIPPEDFRAMES nopause
			echo.

				rem Determine the skip factor...If there are fewer than 300 files, list each.
				rem Otherwise, divide so that it skips a max of every 2 minutes
			set /a bat_temp1=!bat_count! * 10 / !bat_CAPTURE.number.of.cameras!
			!bat_echo! set /a bat_temp1[!bat_temp1!]=!bat_count! * 10 / !bat_CAPTURE.number.of.cameras!
			if !bat_temp1! gtr 3000 (
				!bat_logexeclog! set /a bat_skip=14
			)
		) else (
			if /i "!bat_choice!" equ "f" (
				set bat_choice=!bat_confirmedfilesdir!
				for /f "usebackq tokens=*" %%a in (`dir "!bat_confirmedfilesdir!\ff*.bin" /b /a-d /on`) do (
					set /a bat_count+=1
				)
			) else (
				goto :THUMBNAILS1
			)
		)
	)

	
	set bat_tempdir=!bat_choice!

	if defined bat_decimationfactoroption (
		set bat_decimationfactor=!bat_decimationfactoroption!

	) else (
		set bat_decimationfactor=2
	)

	if defined bat_skipoption (
		set bat_skip=!bat_skipoption!
	)

	!bat_CALLecho! "!bat_exedir!\FTP_Thumbnails.exe" "!bat_tempdir!" !bat_decimationfactor! !bat_skip!
	set bat_returncode=0&rem	!errorlevel!
	!bat_echo! bat_returncode=!bat_returncode!
	
	if /i "!bat_returncode!" neq "0" (
		!bat_echolog! `    ERROR - FTP_Thumbnails.exe Failed 
		!bat_echolog! `            [returncode=!bat_returncode!] - Check if there are no FF*.bin files.
		!bat_echolog!
		goto :THUMBNAILS1
	)
	
	if not defined bat_interactive (
		call :THUMBNAIL_PREVIEW "!bat_tempdir!"
	)
	
:THUMBNAILS2
	if not defined bat_interactive (
		!bat_echo!
		!bat_echo!
		set bat_choice=
		set /p bat_choice='!bat_pushstring![K]eep or [D]elete the files? [D] 
		!bat_echo! [!bat_choice!]

		if /i "!bat_choice!" equ "" set bat_choice=d
		if /i "!bat_choice!" equ "k" (goto :THUMBNAILS_END)

		if defined bat_tempdir (
			if /i "!bat_choice!" equ "d" (
				for /f "usebackq tokens=*" %%a in (`dir "!bat_tempdir!\Thumbnails*.bmp" /b /a-d /on`) do (
					if /i "%%a" neq "" (
						!bat_logexec! del /q "!bat_tempdir!\%%a"
					) else (
						!bat_echolog! ERROR [!bat_batchfile!:THUMBNAILS] Dangerous command: del /q "!bat_tempdir!\%%a"
					)
				)

				goto :THUMBNAILS_END
			)

			goto :THUMBNAILS2
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:THUMBNAILS] Dangerous command: del /q "!bat_tempdir!\..."
		)
	)
	


	rem NEEDS:
	rem - Additional processing to determine if there are new .bmp files in the directory.  
	rem   Either that or scan the output and look for "Writing camera" or ".bmp".
	rem   - Check whether there is/are already .bmp files in the directory.  They will be 
	rem     overwritten, so you'll need to check the date/time stamp on the file to determine
	rem     if they are new.
	rem   - Another option is to ask the user if they would like to watch it work or to
	rem     work in the background.  If it uses bat_logexeclog, the user won't see the 
	rem     scrolling output until it is all done.  This may not be a bad thing since a lot
	rem     of text scrolls.  It might be best to filter the output by omitting the individual files
	rem     somehow (omitting "Pulling snapshort for file ...")
	rem - Ask the user if they would like to open the files for viewing?
	rem - Add menu items to open the .bmp files for viewing again after already built. (like 70a or 70v)

:THUMBNAILS_END
!bat_poplog! [RETURN !bat_batchfile!:THUMBNAILS] []
!bat_log!
ENDLOCAL
!bat_return!





:READCONFIG

	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
!bat_return!



:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_CALL! "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!



:ERRLOG
	!bat_pushecho! [CALL:!bat_batchfile!:ERRLOG] [%~1]
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! `   %~1
	!bat_echolog!
	!bat_echolog!
:ERRLOG_END
!bat_return!



:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0 /mode="<thumbnail mode>"
	echo.
	echo.  /mode         One of the thumbnail modes listed in the "Autocams.Params.ini" file.
	echo.
	echo.  /delete       yes means to delete without prompt.  no means to keep without prompt.
	echo.
	echo.  /interactive  no means to not prompt for any input
	echo.
	echo.  Generates thumbnails from the directory specified in the ini file entry.  If no 
	echo.  /mode is specified, then the user will be prompted for which directory to use 
	echo.  as the source.  If /mode is specified but it isn't configured properly, it will
	echo.  fail.  
	echo.
	echo.  If nothing is specified on the command line, the three possible source directories
	echo.  are determined by reading the "AutoCams.bat.ini" file to determine the 
	echo.  date/time to use. 
	echo.
	echo.  In the case that CapturedFiles is the source directory and if no
	echo.  /skip value is provided as a command-line option, the skip count will
	echo.  be adjusted to skip every two minutes, unless the number of files in the
	echo.  CapturedFiles dir is fewer than 300, in which case the skip count is set to
	echo.  "1" [where "1" adds each file in the dir to the thumbnail]
	echo.
	echo.  The default decimation factor is 2x (or half resolution), which produces
	echo.  file. You can override this default using the following additional command
	echo.  line argument:
	echo.      /factor=n
	echo.
	echo.  Where "n" is a positive whole number greater than 0
	echo.
	echo.  Examples:
	echo.      "%~0" 
	echo.
	echo.        Will offer the user the choice of creating thumbnails for either:
	echo.          ArchivedFiles, CapturedFiles, or ConfirmedFiles.
	echo.
	echo.      "%~0" /archivedir="C:\CAMS\ArchivedFiles\2013_08_11_04_32_11" /factor=2 /skip=1
	echo.
	echo.        Will create the thumbnails from the FF*.bin files in the ArchivedFiles
	echo.        directory.  It will skip no files and resample at 1:2.
	echo.
	echo.      "%~0" /factor=4 /skip=14
	echo.
	echo.        Will offer the user the choice of source directory and then it
	echo.        will create the thumbnails from the FF*.bin files in the selected
	echo.        directory using an image resample rate of 1:4 .  It will skip 
	echo.        every 2 minutes.  
	echo.
	echo.
	echo.  WEATHER CHECK:
	echo.    A good way to do a quick weather check is with /skip=70 [every 10 minutes) with
	echo.    very low resolution /factor=8 [thus small bitmap file]. Of course, you could
	echo.    choose either the CapturedFiles or ArchivedFiles directory for this.
	echo.
	echo.  FIREBALL SCAN:
	echo.    The only way to really do a fireball scan is to scan the CapturedFiles 
	echo.    directory instead of the ArchivedFiles or ConfirmedFiles diretories.
	echo.    This is because some fireballs are so bright that they are not detected
	echo.    in the normal meteor scan routine.  For this, you'd need to use
	echo.    /skip=1 and set /factor=7 [or whatever yields a resolution good enough
	echo.    to distinguish a fireball from an airplane].
	echo.    Tip: Typically a fireball won't span more than two image files, where
	echo.         an airplane will span several.
	echo.
	echo.deprecated usage...
	echo.  Usage: %~nx0 [/^<type^>="<sourcedir>"] [/skip=n] [/factor=n] [/delete=no] [/interactive=no]
	echo.  ^<type^>        Optional - specify either:
	echo.                    /archiveddir
	echo.                    /captureddir
	echo.                    /confirmeddir
	echo.  ^<sourcedir^>   The full path to the source directory
	echo.  /factor       Specify a resample rate ^> 0 where 1 is full resolution
	echo.
	echo.                  Note: The smaller the resample rate, the larger the 
	echo.                        thumbnail files.
	echo.  /skip         Specify 1-n ^(7.1 FF files per minute with NTSC, 6 for PAL^)
	echo.
	echo.                  Note: Using a small number on the CapturedFiles directory
	echo.                        take more time and produce larger thumbnail files.
	echo.
exit /b -99

	Flowchart:

	New as of: 05/04/2013:

	Needs:
		- 
	
:ABORT
	!bat_poplog! `    ABORTING
	!bat_echolog! `    bat_returncode=!bat_returncode!
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
	pause
exit /b !bat_returncode!

:DONE
	!bat_poplog!
	!bat_pop!
	!bat_echolog! Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!
