@echo off
setlocal enableextensions enabledelayedexpansion



	REM #####################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*



	REM #####################################
:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_CALLecho! "!bat_exedir!\ReadParams.bat"
	!bat_CALLecho! "!bat_exedir!\ReadConfig.bat"
	
		rem Get the bat_capturedfilesdir value

	!bat_logexec! set bat_source_cams2_basedir=%~1
	!bat_logexec! set bat_dest_cams1_basedir=%~2
	!bat_logexec! set bat_capturesession=%~3
	!bat_logexec! set bat_first_camera=%~4
	!bat_logexec! set bat_source_cams2_caldir=%~5


		REM set the source variables	
		
		REM Set the bat_source_archivedfilesdir variable.  If there isn't a matching
		REM ArchivedFiles dir, then assume that the ArchivedFiles are in the
		REM CapturedFiles dir [Like they are in New Zealand].
	
	if not exist "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!" (
		!bat_logexec! set bat_source_archivedfilesdir=!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!
	) else (
		!bat_logexec! set bat_source_archivedfilesdir=!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!
	)
	
		REM set the bat_source_capturedfilesdir variable
	!bat_logexec! set bat_source_capturedfilesdir=!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!
	
	if not defined bat_source_cams2_caldir (
		!bat_logexec! set bat_source_cams2_caldir=!bat_source_cams2_basedir!\Cal
	)
	
		REM set the target variables
		
	!bat_logexec! set bat_target_caldir=!bat_dest_cams1_basedir!\Cal
	!bat_logexec! set bat_target_archivedfilesdir=!bat_dest_cams1_basedir!\ArchivedFiles\!bat_capturesession!
	!bat_logexec! set bat_target_capturedfilesdir=!bat_dest_cams1_basedir!\CapturedFiles\!bat_capturesession!

	if not exist "!bat_target_capturedfilesdir!" (
		!bat_echolog!
		!bat_echolog! `    ERROR   Capture directory for Cams1 not found 
		!bat_echolog! `            bat_target_capturedfilesdir="!bat_target_capturedfilesdir!"
		!bat_echolog!
		goto :DONE
	)

	!bat_logexec! MD "!bat_source_cams2_basedir!"


goto :MAIN %*



	REM #####################################
:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*


	call :DELETE_PERFORMANCE_FILES
	

	(CALL :GETDETECTFILE) || (goto :DONE)
	

	CALL :ADJUST_DETECT
	

	CALL :RENAME_DETECT_FILE
	
	call :RENAME_ARCHIVED_BIN_FILES
	
	call :RENAME_CAPTURED_BIN_FILES
	
	call :MOVE_CAMS2_DIRS
	
goto :DONE





	REM #####################################
:DELETE_PERFORMANCE_FILES
!bat_pushecho! [CALL !bat_batchfile!:DELETE_PERFORMANCE_FILES] %*
	
	REM Delete target performance files [like GCFC, etc.]
	REM       - Delete the Cams2 "CapturedFiles\GCFC.log" file
	!bat_logexec! MOVE /Y "!bat_target_capturedfilesdir!\xxxGCFC.log" "!bat_target_capturedfilesdir!\GCFC.log" 
	
	REM       - Delete the Cams2 "CapturedFiles\"GetFirstLastFF_filenames.txt" 
	!bat_logexec! MOVE /Y "!bat_target_capturedfilesdir!\xxxGetFirstLastFF_filenames.txt"  "!bat_target_capturedfilesdir!\GetFirstLastFF_filenames.txt" 

	!bat_logexec! MOVE /Y "!bat_target_archivedfilesdir!\xxxCalFileList.log" "!bat_target_archivedfilesdir!\CalFileList.log"
	
	!bat_logexec! MOVE /Y "!bat_target_archivedfilesdir!\xxxSortDetect_CameraList.txt" "!bat_target_archivedfilesdir!\SortDetect_CameraList.txt"
	!bat_logexec! MOVE /Y "!bat_target_archivedfilesdir!\xxxSortDetect_Sorted.log" "!bat_target_archivedfilesdir!\SortDetect_Sorted.log"


:DELETE_PERFORMANCE_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:DELETE_PERFORMANCE_FILES] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!




	REM #####################################
	REM Locate and set the bat_target_detectfilename based on the AutoCams naming convention
:GETDETECTFILE
!bat_pushecho! [CALL !bat_batchfile!:GETDETECTFILE] [%*] [bat_target_archivedfilesdir="!bat_target_archivedfilesdir!"]
	set bat_returncode=1

	if exist "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!*.txt" (
		!bat_echo! 1. exist "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!*.txt"
		for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!*.txt"`) do (
			!bat_logexec! set bat_target_detectfilename=!bat_target_archivedfilesdir!\%%a
			set bat_returncode=0
			goto :GETDETECTFILE_END
		)
	) else (
		!bat_echo!
		!bat_echo! `    ERROR - NO DETECT FILE FOUND - "!bat_target_archivedfilesdir!\FTPdetectinfo_0!bat_first_camera!_!bat_capturesession!*.txt"
		!bat_echo!
		goto :GETDETECTFILE_END
	)


:GETDETECTFILE_END
!bat_popecho! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode!, bat_target_detectfilename=!bat_target_detectfilename!]
!bat_log!
!bat_return!

	

	REM #####################################
	REM      MODIFY THE DETECT FILE
:ADJUST_DETECT
!bat_pushecho! [CALL !bat_batchfile!:ADJUST_DETECT] [%*] [bat_target_detectfilename="!bat_detectfilename!"]

	REM    Replace "FF  folder" with "FX  folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FF  folder" "FX  folder"
	
	REM    Replace "CAL folder" with "CXL folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CAL folder" "CXL folder"
	
	REM    Replace "FF  file processed" with "FX  file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FF  file processed" "FX  file processed"
	
	REM    Replace "CAL file processed" with "CXL file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CAL file processed" "CXL file processed"
	

	REM Check to ensure that the FF_000 are not already there.  If they are, then skip this step...
	(find /c /i "FF_000" "!bat_target_detectfilename!") || (
		REM errorlevel NEQ 0, meaning "FF_000" wasn't already previously done, so replace...
		
		REM         - Replace all instances of "FF_000" with "FF"
		!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FF" "FF_000" 
		set bat_returncode=!errorlevel!
	)


	REM Check to ensure that the CAL_000 are not already there.  If they are, then skip this step...
	(find /c /i "CAL_000" "!bat_target_detectfilename!") || (
		REM errorlevel NEQ 0, meaning "CAL_000" wasn't already previously done, so replace...
		
		REM         - Replace all instances of "CAL_000" with "CAL"
		!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CAL" "CAL_000" 
		set bat_returncode=!errorlevel!
	)



	REM    Replace "FF  folder" with "FX  folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FX  folder" "FF  folder"
	
	REM    Replace "CAL folder" with "CXL folder"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CXL folder" "CAL folder"
	
	REM    Replace "FF  file processed" with "FX  file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "FX  file processed" "FF  file processed"
	
	REM    Replace "CAL file processed" with "CXL file processed"
	!bat_logexec! "!bat_exedir!\ReplaceText.exe" -V -- "!bat_target_detectfilename!" "CXL file processed" "CAL file processed"
	



:ADJUST_DETECT_END
!bat_popecho! [RETURN !bat_batchfile!:ADJUST_DETECT] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!



	
	
	REM #####################################
	REM  Rename the temporary detection thread files
	REM  This routine renames the files names like this: FTPdetectinfo_800001_Subset.txt, FTPdetectinfo_800002_Subset.txt, etc.
	REM  to xxxFTPdetectinfo_800001_Subset.txt, xxxFTPdetectinfo_800002_Subset.txt, etc.
:RENAME_SUBSET_FILES
!bat_pushecho! [CALL !bat_batchfile!:RENAME_SUBSET_FILES] %*

	rem There is no need to rename the subset files back because they don't belong 
	rem there after they are merged into a detect file
goto :RENAME_SUBSET_FILES_END

	set bat_temp=NO SUBSET FILES FOUND
	!bat_echo! dir /b /a-d "!bat_target_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt"

	for /f "usebackq tokens=*" %%a in (`dir /on /b /a-d "!bat_target_archivedfilesdir!\FTPdetectinfo_??????_Subset.txt"`) do (
		set bat_temp=!bat_target_archivedfilesdir!\xxx%%a
		!bat_logexec! MOVE /y "!bat_target_archivedfilesdir!\%%a"  "!bat_temp!"
	)
	
:RENAME_SUBSET_FILES_END 
!bat_popecho! [RETURN !bat_batchfile!:RENAME_SUBSET_FILES] [Last Subset File:"!bat_temp!"]
!bat_log!
!bat_return!

	
	

	
	
	
	
	REM #####################################
	REM       - Rename the detect file from "FTPdetectinfo_000^<first camera^>???000^<last camera^>_*.txt" 
	REM         to "FTPdetectinfo_^0<first camera^>_*.txt"
:RENAME_DETECT_FILE
!bat_pushecho! [CALL !bat_batchfile!:RENAME_DETECT_FILE] %*

	set bat_tempfile_orig=

	
	if exist "!bat_target_archivedfilesdir!\FTPdetectinfo_0*.txt" (
		!bat_echo! 1. exist "!bat_target_archivedfilesdir!\FTPdetectinfo_0*.txt"
		for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_archivedfilesdir!\FTPdetectinfo_0*.txt"`) do (
			!bat_logexec! set bat_tempfile_cams1=!bat_target_archivedfilesdir!\%%a
		)
	)

 dir /on /a-d /b "!bat_target_archivedfilesdir!\zzzFTPdetectinfo_*.txt"

	if exist "!bat_target_archivedfilesdir!\zzzFTPdetectinfo_*.txt" (
		!bat_echo! 1. exist "!bat_target_archivedfilesdir!\zzzFTPdetectinfo_*.txt"
		for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_archivedfilesdir!\zzzFTPdetectinfo_*.txt"`) do (
			!bat_logexec! set bat_tempfile_cams2=!bat_target_archivedfilesdir!\%%a
		)
	)
	
:RENAME_DETECT_FILE_2
!bat_echo! [CALL !bat_batchfile!:RENAME_DETECT_FILE_2]

	set bat_returncode=0
	
		REM Rename the original detect file with the "zzz" prefix so that it can be 
		REM easily undone. 
	!bat_CALLecho! "!bat_exedir!\ParseDir.bat" "!bat_tempfile_cams2!"
	!bat_TITLE!

		REM           bat_tempfile_cams2_name=FTPdetectinfo_000250000257_2017_09_15_02_49_28.txt
	!bat_logexec! set bat_tempfile_cams2_name=!bat_RetVal2!
	!bat_logexec! set bat_tempfile_cams2_name=!bat_tempfile_cams2_name:zzz=!
	
	(!bat_logexec! MOVE /y   "!bat_tempfile_cams1!"  "!bat_target_archivedfilesdir!\!bat_tempfile_cams2_name!") || (
		!bat_echolog!
		!bat_echolog! `    ERROR - Could not move the detect file
		!bat_echolog! `            MOVE /y   "!bat_tempfile_cams1!"  "!bat_target_archivedfilesdir!\!bat_tempfile_cams2_name!"
		!bat_echolog!
		set bat_returncode=1
	)


:RENAME_DETECT_FILE_END 
!bat_popecho! [RETURN !bat_batchfile!:RENAME_DETECT_FILE] [bat_returncode=!bat_returncode!, bat_target_detectfilename=!bat_target_detectfilename!]
!bat_log!
!bat_return!


	
	
	

	REM #####################################
	REM       - Rename all the "FF_000???_*.bin" files in the Captured dir to "FF???_*.bin"
:RENAME_CAPTURED_BIN_FILES
!bat_pushecho! [CALL !bat_batchfile!:RENAME_CAPTURED_BIN_FILES] %*

	call :RENAME_FF_FILES "!bat_target_capturedfilesdir!"


:RENAME_CAPTURED_BIN_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:RENAME_CAPTURED_BIN_FILES] []
!bat_log!
!bat_return!





	REM #####################################
	REM       - Rename all the "FF_000???_*.bin" files in the Archived dir to "FF???_*.bin"
:RENAME_ARCHIVED_BIN_FILES
!bat_pushecho! [CALL !bat_batchfile!:RENAME_ARCHIVED_BIN_FILES] %*

	call :RENAME_FF_FILES "!bat_target_archivedfilesdir!"


:RENAME_ARCHIVED_BIN_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:RENAME_ARCHIVED_BIN_FILES] []
!bat_log!
!bat_return!




	REM #####################################
:RENAME_FF_FILES [dir]
!bat_pushecho! [CALL !bat_batchfile!:RENAME_FF_FILES] %*
REM					where: dir is the directory contianing FF files to be renamed

	!bat_echo!
	!bat_echo!
	!bat_echo! This could take a long time.  It's renaming all the FF*.bin files in the 
	!bat_echo! "%~1" directory...
	dir /a-d "%~1\FF_000???_*.bin">nul:|find /i "File(s)"
	!bat_echo!
	!bat_echo! Please wait...
	!bat_echo!

	!bat_echo! for /f "usebackq tokens=*" ..a in ^(`dir /s/b /a-d "%~1\FF???_*.bin"`^) do ^(
	for            /f "usebackq tokens=*" %%a in  (`dir /s/b /a-d "%~1\FF???_*.bin"`) do (
		
			rem path\file
		set bat_temp=%%a
		
			rem path
		set bat_tempdir=%%~dpa::
		set bat_tempdir=!bat_tempdir:\::=!
		set bat_tempdir=!bat_tempdir:::=!
		
		set bat_tempfile=%%~nxa
		set bat_tempcamera=!bat_tempfile:~3,6!
		set bat_tempfile_new=FF_000!bat_tempcamera!_!bat_tempfile:~-31!
		
		!bat_echo! MOVE /Y   "!bat_temp!"   "%~1\!bat_tempfile_new!"
		           MOVE /Y   "!bat_temp!"   "%~1\!bat_tempfile_new!">nul:
		set bat_retval=!errorlevel!
	)
	
:RENAME_FF_FILES_END
!bat_popecho! [RETURN !bat_batchfile!:RENAME_FF_FILES] ["%~1"]
!bat_log!
!bat_return! !bat_retval!







	REM #####################################
	REM       - Move all the CapturedFiles, ArchivedFiles, and Cal files that pertain to "C:\Cams2_0" 
	REM         SubmissionFiles to the working dirs under "C:\cams16\CAMS"
:MOVE_CAMS2_DIRS
!bat_pushecho! [CALL !bat_batchfile!:MOVE_CAMS2_DIRS] %*

	set bat_returncode=1

	!bat_logexec! MD "!bat_source_cams2_basedir!\ArchivedFiles"
	!bat_logexec! MD "!bat_source_cams2_basedir!\CapturedFiles"

	!bat_logexec! ROBOCOPY "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\FTP"    "!bat_source_cams2_basedir!\FTP"  /E /IS /MOVE

	!bat_logexec! ROBOCOPY "!bat_dest_cams1_basedir!\Cams2\!bat_capturesession!\Logs"   "!bat_source_cams2_basedir!\Logs"  /E /IS /MOVE
	
	(call :MOVE "!bat_dest_cams1_basedir!\ArchivedFiles\!bat_capturesession!" "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!") || (
		goto :MOVE_CAMS2_DIRS_END
	)
	
	(call :MOVE "!bat_dest_cams1_basedir!\CapturedFiles\!bat_capturesession!" "!bat_source_cams2_basedir!\CapturedFiles\!bat_capturesession!") || (
		goto :MOVE_CAMS2_DIRS_END
	)


	REM NOW MOVE THE CAL FILES
	
	set bat_captureddate=!bat_capturesession:~0,10!
	set bat_captureddate=!bat_capturesession:_=!
	
	for /f "usebackq tokens=*" %%a in (`dir /on /a-d /b "!bat_target_caldir!\CAL???_!bat_captureddate!_*.txt"`) do (
		set bat_temp=%%a
		set bat_temp_camera=!bat_temp:~3,3!
		set bat_temp_captureddatetime=-23!
		
		set bat_temp_newname=CAL_000!bat_temp_camera!_!bat_temp_captureddatetime!

		(!bat_logexec! COPY /y "!bat_dest_cams1_basedir!\!bat_temp!" "!bat_temp_newname!") || (
			!bat_echo! 
			!bat_echo! ` ERROR - failed to copy CAL file: 
			!bat_echo! `         Source: "!bat_dest_cams1_basedir!\!bat_temp!"
			!bat_echo! `         Target: "!bat_temp!"
			!bat_echo!
			set bat_returncode=1
		)
	)

	set bat_returncode=0

:MOVE_CAMS2_DIRS_END
!bat_popecho! [RETURN !bat_batchfile!:MOVE_CAMS2_DIRS] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!





	REM #####################################
	REM This routine moves the specified file or dir and then checks to
	REM see if it is still in the source location.  If it is, the move 
	REM failed. 
:MOVE [source dir or file]   [target]
!bat_pushecho! [CALL !bat_batchfile!:MOVE] %*

	set bat_retval=0
	
	(!bat_logexec! MOVE /Y "%~1"   "%~2") || (
		!bat_echo!
		!bat_echo! ` ERROR - The MOVE command failed by returning a non-zero errorlevel. 
		!bat_echo! `   MOVE /Y  "%~1"   "%~2"
		!bat_echo!
		set bat_retval=1
		goto :MOVE_END
	) && (
		(!bat_logexec! dir /ad "%~1">nul: 2>&1) || (
					set bat_retval=2
					CALL :ERROR "%~1"
		)
	)
	
	

:MOVE_END
!bat_popecho! [RETURN !bat_batchfile!:MOVE] ["%~1", "%~2"]
!bat_log!
!bat_return! !bat_retval!




	REM #####################################
:ERROR_MOVE [dir]
	!bat_echo!
	!bat_echo! ` ERROR - MOVE Failed - The following file or dir was supposed to be moved but it still exists after the command.
	!bat_echo! `    "!bat_source_cams2_basedir!\ArchivedFiles\!bat_capturesession!"
	!bat_echo!
:ERROR_END
!bat_return! !bat_retval!







	REM #####################################
:FIXDETECTPATHS
!bat_popecho! [RETURN !bat_batchfile!:FIXDETECTPATHS] ["detectfile", "FF folder", "cal folder"]

	rem The ReplaceText.exe program was originally called FART.exe.  I renamed
	rem it so that its name would more adaquately describe its function.
:REPLACETEXT
!bat_log! [GOTO !bat_batchfile!:REPLACETEXT] %*
	!bat_logexec! set bat_targetdirfull=!bat_source_archivedfilesdir!
	!bat_logexec! set bat_targetdirname=!bat_source_archivedfilesdir!
	!bat_logexec! set bat_targetdirbase=!bat_source_cams2_basedir!
	!bat_logexec! set bat_detectfile=%~1
	!bat_log! '    bat_targetdirname=!bat_targetdirname!
	!bat_log! '    bat_targetdirbase=!bat_targetdirbase!

	set /a linecount=0
	set bat_fffolder=
	set bat_ffdirname=
	set bat_fffolder=
	set bat_ffbasepath=
	set bat_calfolder=
	set bat_calpath=

	if not exist "!bat_detectfile!" (
		!bat_echolog! '     ERROR - not exist: "!bat_detectfile!"
		set bat_returncode=1000
		goto :DONE
	)

	for /f "usebackq tokens=* skip=2" %%a in (`find /i "FF  folder" "!bat_detectfile!"`) do (
		set bat_inputline=%%~a&					REM "FF  folder = existing path"
		set bat_fffolder=!bat_inputline:~13!&	REM "FF  folder = "
		set bat_fffolder=!bat_fffolder:~0,-1!&	REM The path without the trailing "\"
		REM At this point, bat_fffolder is the original inputline without the trailing backslash
	)

	if defined bat_fffolder (
		rem Separate dirname from ArchivedFiles dir
		!bat_CALLecho!! !bat_exedir!\ParseDir.bat" "!bat_fffolder!"
		set bat_ffdirname=!bat_retval2!
		rem Separate ArchivedFiles from basepath
		call :PARSEDIR "!bat_retval1!"
		set bat_ffbasepath=!bat_retval1!
		set bat_outputline=!bat_targetdirfull!
		rem echo     to      : "!bat_fffolder!"


		!bat_pushlog!
			!bat_logexeclog! call "!bat_exedir!\ReplaceText.exe" -i "!bat_detectfile!" "!bat_fffolder!" "!bat_source_archivedfilesdir!"
			set /a bat_returncode=!bat_logexec_returncode!*100
		!bat_poplog!
	)

	!bat_log! '    bat_fffolder=!bat_outputline!

	for /f "usebackq tokens=* skip=2" %%a in (`find /i "CAL folder" "!bat_detectfile!"`) do (
		set bat_inputline=%%~a
		set bat_calfolder=!bat_inputline:~13!
		set bat_calfolder=!bat_calfolder:~0,-1!

	)

	!bat_log! if defined bat_calfolder...
	if defined bat_calfolder (
		rem Separate dirname from ArchivedFiles dir
		call :PARSEDIR "!bat_calfolder!"
		set bat_calpath=!bat_targetdirbase!\Cal
		set bat_outputline=!bat_calpath!
		rem echo     to:     : "!bat_calpath!"

		!bat_pushlog!
			!bat_logexeclog! call "!bat_exedir!\ReplaceText.exe" -i "!bat_detectfile!" "!bat_calfolder!" "!bat_source_cams2_caldir!"
			set /a bat_returncode=!bat_logexec_returncode!+!bat_returncode!&	rem Number of changed occurences
		!bat_poplog!
	)
	
	!bat_log! '    bat_calfolder=!bat_outputline!
:REPLACETEXT_END
	
	
:FIXDETECTPATHS_END
!bat_popecho! [RETURN !bat_batchfile!:FIXDETECTPATHS] ["%~1", "%~2"]
!bat_log!
!bat_return! !bat_retval!






	REM #############################################################################################
	REM 
:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<source_cams2^>"  "^<destination_cams1^>"  "^<capture session^>"  "^<first camera^>" ["^<cams2 cal dir^>"]
	echo.
	echo.Undoes what the "Migrate_CamsGUI2_to_AutoCams.bat" script does.  Essentially, converts the 
	echo.specified Cams1 [converted from a Cams2 capture session] back to Cams2.
	echo.
	echo.Note: The command line arguments have been configured so that the same command line arguments
	echo.      related to source and destination are identical to those used for 
	echo.      
	echo.
	echo.Where:
	echo.
	echo.   source_cams2              The "source_cams2" directory is a base directory that contains 
	echo.                             the Cams2 CapturedFiles, ArchivedFiles, and Cal directories. 
	echo.                             If you are un-migrating a Cams2 capture session that is in the 
	echo.                             SubmissionFiles state, then it migrates the CapturedFiles, 
	echo.                             ArchivedFiles, and Cal files back to that base directory from the 
	echo.                             corresponding Cams 1 working dirs specified in the 
	echo.                             "destination_cams1" argument. 
	echo.   destination_cams1         This argument specifies the base dir of the target Cams1 
	echo.                             working dirs.  Remember, this script is  
	echo.   capture session           This is the date and time of the start of the capture session.
	echo.   first camera              First camera for this capture session
	echo.   cams2 cal dir             Option - Cams2 Cal dir.  Useful for SubmissionFiles and other
	echo.                             kinds of Cams2 source where the Cal directory isn't directly
	echo.                             under the base dir.
	echo.
	echo.Note: When the "source_cams2" argument is going to refer to a Cams2 SubmissionFiles session, 
	echo.      then you must specify the path to the base dir of the SubmissionFiles session that houses the 
	echo.      CapturedFiles, ArchivedFiles, and Cal dirs.  
	echo.
	echo.      When the "source_cams2" argument is going to refer to a Cams2 working dirs session, 
	echo.      Then you must specify the path to the base of the Cams2 directory (example "C:\Cams2_0\CAMS").
	echo.
	echo.Examples:
	echo.    call "%~0"   "C:\Cams2_0\CAMS\SubmissionFiles\2017_09_17_000250_02_46_10\000250"  "C:\cams16\CAMS" "2017_09_17_02_46_10"
	echo.     -or-
	echo.    call "%~0"   "C:\Cams2_0\CAMS\"  "C:\cams16\CAMS"
	echo.     -or-
	echo.    call "%~0"   "C:\Cams2_0\CAMS\
	echo.
	echo.    Does the following:
	echo.      - Moves all the CapturedFiles, ArchivedFiles, and Cal files that pertain to "C:\Cams2_0" 
	echo.        SubmissionFiles to the working dirs under "C:\cams16\CAMS"
	echo.      - Renames all the "FF_000???_*.bin" files in the Archived dir to "FF???_*.bin"
	echo.      - Renames the detect file from "FTPdetectinfo_000^<first camera^>???000^<last camera^>_*.txt" 
	echo.        to "FTPdetectinfo_^<first camera^>_*.txt"
	echo.      - Adjusts the detect file as follows:
	echo.        - Adjusts the "FF  folder" path to match where the file is sitting
	echo.        - Adjusts the "CAL folder" path to match where the 1.x Cal files are
	echo.        - Replaces all instances of "FF_000" with "FF"
	echo.        - Replaces all instances of "CAL_000" with "CAL"
	echo.      - Deletes the Cams2 "CapturedFiles\GCFC.log" file
	echo.      - Deletes the Cams2 "CapturedFiles\"GetFirstLastFF_filenames.txt" 
	echo.      - Renames all the "FF_000???_*.bin" files in the Archived dir to "FF???_*.bin"
	echo.      - Converts all 2.x cal files to 1.x by calling "autocal_migrate2x_to_1x.bat"
	echo.
	echo.Example 2:
	echo.    call "%~0"   "C:\Cams2_0\CAMS\SubmissionFiles\2017_09_17_000250_02_46_10\000250"  "C:\cams16\CAMS"
	echo.
	echo.
	echo.
	echo.
exit /b 99



	REM #####################################
:DONE



