@echo off
setlocal enableextensions enabledelayedexpansion

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
	
	!bat_logexeclog! set /a bat_wait_time_mins=!bat_CAPTURE.number.of.cameras! * 2



		REM ===============================================================
		REM These next few lines pertain to locking the AutoCams menu options
		REM from being selected until AutoCal_LocalDownload.bat (remote autocal
		REM phase 3) is complete.  When it's done, it will unlock the 
		REM "RemoteSession_Busy.txt" file and then lock the "AutoCams_Busy.txt"
		REM file to prevent "AutoCal_LocalDownload.bat" from running at the
		REM same time.
		REM
		REM echo.!time!>"!bat_camsdir!\Temp\autocams_busy.txt"
		REM start MonitorDir ... "!bat_camsdir!\Temp\RemoteSession_Busy.txt"
		REM 
	!bat_log! echo.[!date! !time!] Locked by: "%~dp0AutoCams.bat"} "!bat_AutoCams_lock_full!"
	          echo.[!date! !time!] Locked by: "%~dp0AutoCams.bat"> "!bat_AutoCams_lock_full!"


	if exist "!bat_RemoteSession_Busy_lock_full!" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `NOTICE: AutoCams menu options have been blocked while remote calibration
		!bat_echolog! `        runs. This is to avoid multiple instances of AutoCams from 
		!bat_echolog! `        interfering with each other.
		!bat_echolog! `        
		!bat_echolog! `        The wait time should be less than [!bat_wait_time_mins!] minutes.
		!bat_echolog! `
		!bat_echolog! `        Please be patient and wait for remote calibration to finish.
		!bat_echolog! `
		!bat_echolog! `DO NOT CLOSE: MonitorDir or the other instance of AutoCams.
		!bat_echolog! `
		!bat_echolog! `Your choices are to:
		!bat_echolog! `    Abort   - Force the remote autocal to wait for you
		!bat_echolog! `    Default - Wait a couple of minutes for the remote autocal to finish first. 
		!bat_echolog! `
		
		set bat_AutoCams_Lock_abort=

		CHOICE /T 10 /C YN /D N /N /M "Do you want to Abort the wait? [Y/N] "
		set bat_returncode=!errorlevel!
		
		!bat_log! Continuing...
		
			REM Y
		if !bat_returncode! equ 1 (
				REM Unlock: "!bat_RemoteSession_Busy_lock_full!"
			!bat_logexeclog! DEL /q "!bat_RemoteSession_Busy_lock_full!"
			goto :DONE
			
		)

			REM N
		if !bat_returncode! equ 2 (
			!bat_echolog!
			!bat_echolog! "waiting for autocams finished"
			!bat_echolog!

				REM Wait for 
			!bat_echolog! start "MonitorDir - [!bat_RemoteSession_Busy_lock_full!]" /WAIT /low /min "!bat_exedir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_camsdir!\Temp" "!bat_RemoteSession_Busy_lock_full!"
				      start "MonitorDir - [!bat_RemoteSession_Busy_lock_full!]" /WAIT /low /min "!bat_exedir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_camsdir!\Temp" "!bat_RemoteSession_Busy_lock_full!"

			!bat_logexec! DEL /q "!bat_RemoteSession_Busy_lock_full!"

		)
		
	) 

:DONE
	!bat_pop!
	!bat_log! [!bat_batchfile!:DONE] Done with %0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

