@echo off
setlocal enableextensions enabledelayedexpansion

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_log! ======================================================
	!bat_log! [!bat_current_date! !time!] %0 %*
	!bat_log!
	!bat_push!
	

	
	!bat_logexeclog! set /a bat_wait_time_mins=!bat_CAPTURE.number.of.cameras! * 2

	set bat_captureddatetime=
	if /i "%~1" neq "" (
		set bat_captureddatetime=%~1
	)
	
		REM Since AutoCal_LocalDownload.bat runs in a subdir, this section
		REM fetches the bat_cams_root
	!bat_logexeclog! set bat_cams_root=!bat_camsdir!




		REM ===============================================================
		REM These next few lines pertain to AutoCal_LocalDownload.bat blocking 
		REM until the currently running AutoCams menu options ends. 
		REM 
		REM When the Autocams.bat user gets back to the menu, the "!bat_AutoCams_lock_full!"
		REM flag file is deleted, which unlocks this script to allow the continuation of the
		REM AutoCal_LocalDownload.bat [that's the Remote Calibration Download script] to 
		REM finish..
		REM
		REM echo.!time! ^>"!bat_RemoteSession_Busy_lock_full!"
		REM start MonitorDir ... "!bat_AutoCams_lock_full!"
		REM 
	!bat_log! echo.!bat_captureddatetime!, [!date! !time!] Locked by: "%~dp0AutoCams.bat"} "!bat_RemoteSession_Busy_lock_full!"
	          echo.!bat_captureddatetime!, [!date! !time!] Locked by: "%~dp0AutoCams.bat"> "!bat_RemoteSession_Busy_lock_full!"


	if exist "!bat_RemoteSession_Busy_lock_full!" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `NOTICE: AutoCal_LocalDownload.bat is locking the autocams menu options until
		!bat_echolog! `        the remote calibration is done.
		!bat_echolog! `        
		!bat_echolog! `        The wait time should be less than [!bat_wait_time_mins!] minutes.
		!bat_echolog! `
		!bat_echolog! `        Please be patient and wait for remote calibration to finish.
		!bat_echolog! `
		!bat_echolog! `        If an autocams menu option is currently running, this will block
		!bat_echolog! `        until that menu option is done.
		!bat_echolog! `
		!bat_echolog! `DO NOT CLOSE: MonitorDir or the other instance of AutoCams.
		!bat_echolog! `
		
		!bat_echolog!
		!bat_echolog! "Waiting for autocams menu option to finish..."
		!bat_echolog!

		if not exist "!bat_AutoCams_lock_full!" (
			!bat_logexeclog! set bat_retry=:RETRY
		) else (
			!bat_logexeclog! set bat_retry=:DONE
		)

:RETRY
			REM Wait for 
		!bat_echolog! start "MonitorDir - [!bat_AutoCams_lock_full!]" /WAIT /low /min "!bat_exedir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_cams_root!\Temp" "!bat_AutoCams_lock_full!"
					  start "MonitorDir - [!bat_AutoCams_lock_full!]" /WAIT /low /min "!bat_exedir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_cams_root!\Temp" "!bat_AutoCams_lock_full!"

		!bat_WAIT! 60 "Waiting 1 minute to give an active user a chance to launch another menu command."

		if exist "!bat_AutoCams_lock_full!" (
			REM The user returned to the menu, but after 60 seconds, they are running a new command, 
			REM So we need to try it until, after a 60 second wait, the autocams menu is not active.
			goto !bat_retry!
		)

	) 

:DONE
	!bat_pop!
	!bat_log! [!bat_batchfile!:DONE] Done with %0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

