@echo off
setlocal enableextensions enabledelayedexpansion

	REM ********************************************************************
	REM 
:CHECKHELP
	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
    

	REM ********************************************************************
	REM 
:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_title! 
	
	CALL "!bat_exedir!\ReadParams.bat"
	CALL "!bat_exedir!\ReadConfig.bat"
	
	!bat_title!

	!bat_logexeclog! set bat_startlocation=!bat_camsdir!
	!bat_echo! bat_STAGE.MaxDaysToKeep=!bat_STAGE.MaxDaysToKeep!

goto :MAIN %*




	REM ********************************************************************
	REM 
:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	!bat_CALL! "!bat_exedir!\ListDrives.bat" 
	%bat_WAIT% 3

	set bat_returncode=0
	
	!bat_logexeclog! set bat_MADZ_captureddate_save=!bat_captureddate!

	
	set bat_date_prev=2011_01_01
	set /a bat_daycount=0
	set /a bat_count=0

	!bat_echolog! dir "!bat_exedir!\SubmissionFiles\CapturedFiles" /ad /s/b /o-n][sort /r
	              dir "!bat_exedir!\SubmissionFiles\CapturedFiles" /ad /s/b /o-n|sort /r
	!bat_echolog!

	rem First, create a directory list in descending date order...
	rem Example, one of the results would be something like this: 
	rem    D:\cams16\cams\submissionfiles\2015_11_18_000258_01_28_40\000258\CapturedFiles
    !bat_pushlog! for /f "usebackq tokens=*"  ..a in ^(`dir "!bat_camsdir!\SubmissionFiles\CapturedFiles" /ad /s/b /o-n][sort /r`^) do ...
    for               /f "usebackq tokens=*"  %%a in  (`dir "!bat_camsdir!\SubmissionFiles\CapturedFiles" /ad /s/b /o-n^|sort /r`) do (

		rem Should list a single dir...More if there have been manual manipulations to the directory
		!bat_logexec! dir "%%a\????_??_??_??_??_??" /s/b /ad
		set bat_returncode=!bat_logexec_returncode!
		
		if !bat_returncode! equ 0 (
			rem For each capture session folder in descending order, the loop variable [%%a] will be the actual dir name [capture session].
			rem Example, for "D:\cams16\cams\submissionfiles\2015_11_18_000258_01_28_40\000258\CapturedFiles" 
			rem from the outer loop, the resulting inner loop variable would be:
			rem     D:\cams16\cams\submissionfiles\2015_11_18_000258_01_28_40\000258\CapturedFiles\2015_11_18_01_28_40
			!bat_pushlog! for /f "usebackq tokens=*" ..b in ^(`dir "%%a\????_??_??_??_??_??" /s/b /ad`^) do ...
			for               /f "usebackq tokens=*" %%b in  (`dir "%%a\????_??_??_??_??_??" /s/b /ad`) do (

				!bat_logexeclog! set bat_dirfull=%%b
				!bat_logexeclog! set bat_temp_file=%%~nxb

				set bat_date_current=!bat_temp_file:~0,10!
				set bat_captureddate=!bat_date_current!
				!bat_echolog! bat_date_current=!bat_date_current!, %%b

				rem Since there may be multiple capture sessions per date, we only want to count
				rem dates, not dirs.  However, if there are some dates missing, for example
				rem 2015_11_18, 2015_11_10, the missing dates don't count toward the "n" in
				rem "n" days to keep.  The reason for this is because we are only really concerned with
				rem disk space management and it wouldn't help to do disk space management on missing
				rem dirs.  
				if /i "!bat_date_current!" neq "!bat_date_prev!" (
							   set /a bat_count+=1
					!bat_echo! set /a !bat_count!
					set bat_date_prev=!bat_date_current!
				)

				!bat_pushlog! if /i !bat_count! GTR !bat_STAGE.MaxDaysToKeep!...
				if /i !bat_count! GTR !bat_STAGE.MaxDaysToKeep! (
					if exist "!bat_dirfull!\*.bin" (
						if /i "!bat_STAGE.DeleteBinFiles!" equ "delete" (
							!bat_echolog! ........[!bat_count!:!bat_STAGE.MaxDaysToKeep!] DEL /s /q "!bat_dirfull!\*.bin"
							DEL /s /q "!bat_dirfull!\*.bin"
							echo.
						) else (
							!bat_echolog! *.bin files already deleted. 
						)
					)


					!bat_logexeclog! set bat_zip_output_fullname=
					!bat_logexeclog! set bat_zipped_dirname=

					call :MAKEARCHIVEDATEZIP "!bat_dirfull!" "!bat_temp_file!" "!bat_captureddate!"

					call :MOVEZIPTOARCHIVE

				) else (
					!bat_echolog! ........[!bat_count!:!bat_STAGE.MaxDaysToKeep!] NOT DELETING "!bat_dirfull!\*.bin"
					ECHO.
				)
				!bat_poplog!

				!bat_echolog! =================================================== !bat_dirful!
				!bat_echolog!
				!bat_echolog!
			)
			!bat_poplog!
		) else (
			!bat_echolog! SKIPPING due to error getting a dir listing: %%a
			!bat_echolog! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			!bat_echolog! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			!bat_echolog! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			!bat_echolog!
			!bat_echolog!
		)

	)
	!bat_poplog!

	!bat_CALL! "!bat_exedir!\ListDrives.bat" 

	!bat_logexeclog! set bat_captureddate=!bat_MADZ_captureddate_save!

	!bat_WAIT! 10
goto :DONE

	

:MAIN_END
!bat_log! [END-!bat_batchfile!:MAIN] [bat_var_firstfile="!bat_var_firstfile!", bat_var_lastfile="!bat_var_lastfile!"]
!bat_log! - goto :DONE
!bat_log!

echo.%~1=%bat_var_firstfile%>"!bat_tempfile_full!"
echo.%~2=%bat_var_lastfile%>>"!bat_tempfile_full!"

!bat_log! goto %~nx0:DONE [!bat_returncode!]
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


( ENDLOCAL & (
	rem echo.SET %~1=%bat_var_firstfile%
	rem echo.SET %~2=%bat_var_lastfile%

	SET %~1=%bat_var_firstfile%
	SET %~2=%bat_var_lastfile%
	set bat_returncode=%bat_returncode%
	)
)

goto :DONE2






	REM ********************************************************************
	REM 
	rem 61u. MakeArchiveDateZip.bat ****************************
	rem called using: call :MAKEARCHIVEDATEZIP "c:\CAMS\Submissionfiles\2015_01_01_000266_01_38_18\266\CapturedFiles\2015_01_01_01_38_18" "2015_01_01_01_38_18" "2015_01_01"
:MAKEARCHIVEDATEZIP   ["!bat_dirfull!" "!bat_temp_file!" "!bat_captureddate!"
!bat_pushlog! call :!bat_batchfile!:MAKEARCHIVEDATEZIP] %*

	!bat_logexeclog! set bat_MADZ_captureddate_save=!bat_captureddate!

	!bat_logexeclog! set bat_temp_submissiondir=%~1
	!bat_logexeclog! set bat_temp_captureddatetime=%~2
	!bat_logexeclog! set bat_captureddate=%~3

	call :GETSUBMISSIONROOT !bat_temp_submissiondir!
	

	rem !bat_logexeclog! set bat_zipdir_filespec=!bat_retval1!

	goto :MAKEARCHIVEDATEZIP2



:MAKEARCHIVEDATEZIP2
!bat_log! GOTO :!bat_batchfile!:MAKEARCHIVEDATEZIP2] %*
	!bat_logexeclog! set bat_abort=false

	if not defined bat_STAGE.DeleteBinFiles (
		!bat_logexeclog! set bat_STAGE.DeleteBinFiles=keep
	)
	
	set bat_delete_bin_files=!bat_STAGE.DeleteBinFiles!


	rem Iterate through the files matching the targeted/specified date
	rem Remember, if there are multiple capture/submission sessions for that date, they will all
	rem be handled by this loop. 
	!bat_pushlog! for /f "usebackq tokens=*" ..c in ^(`dir "!bat_zipdir_filespec!" /b /ad /on`^) do ^(
	for               /f "usebackq tokens=*" %%c in  (`dir "!bat_zipdir_filespec!" /b /ad /on`) do (
		!bat_log! ..c=%%c
		!bat_log! if /i "!bat_abort!" equ "false"...
		if           /i "!bat_abort!" equ "false" (
			!bat_logexeclog! set bat_temp=%%c

			!bat_log! if /i "!bat_temp:~-7!" neq "_zipped" ^(
			if /i "!bat_temp:~-7!" neq "_zipped" (
			
				rem For each matching submission dir found, look for the number of files using the localized "File(s)"
				rem part of the dir results and log the number of files and bytes BEFORE zipping.
				set bat_dir_total=
				!bat_pushecho! for /f "usebackq tokens=1*" ..d in ^(`dir "!bat_startlocation!\SubmissionFiles\!bat_temp!" /s][find /i "!bat_LOCALIZE.dir.files!"`^) do ^(
				for                /f "usebackq tokens=1*" %%d in  (`dir "!bat_startlocation!\SubmissionFiles\!bat_temp!" /s^|find /i "!bat_LOCALIZE.dir.files!"`) do (
					!bat_logexeclog! set bat_dir_total=%%d
				)
				!bat_popecho! ^)
				!bat_echolog! ===========================================================
				!bat_echolog! [Total Files in all subdirs:!bat_dir_total!]   ["!bat_startlocation!\SubmissionFiles\!bat_temp!"]
				!bat_logexeclog! set bat_zip_output_fullname=!bat_startlocation!\SubmissionFiles\!bat_temp!.zip
				!bat_logexeclog! set bat_zipped_sourcedir=!bat_startlocation!\SubmissionFiles\!bat_temp!_zipped
				!bat_logexeclog! set bat_zipped_targetdir=!bat_STAGE.ArchivePath_zip!\!bat_temp!.zip
				!bat_echolog! [Zip file name: "!bat_zip_output_fullname!"]


				rem Call the zip script and then check for the resulting return code
				!bat_log! !bat_CALL! "!bat_exedir!\ZipDir_7za.bat" "!bat_startlocation!\SubmissionFiles\!bat_temp!" !bat_delete_bin_files!
				          !bat_CALL! "!bat_exedir!\ZipDir_7za.bat" "!bat_startlocation!\SubmissionFiles\!bat_temp!" !bat_delete_bin_files!
				set bat_returncode=!errorlevel!
				!bat_log! bat_returncode=!bat_returncode!

				if "!bat_returncode!" equ "99" (
					!bat_logexeclog! set bat_abort=true
				)

				if "!bat_returncode!" neq "0" (
					!bat_echolog! `    ERROR - failed to zip %a
				)
				
				!bat_logexeclog! set bat_zipped_dirname=!bat_startlocation!\SubmissionFiles\!bat_temp!
			) else (
				!bat_echolog! Already zipped: %%a
			)
		)
	)
	!bat_poplog! ^)
	
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! The result of this operation is a zip file for each session matching the
	!bat_echolog! selected date range.  In addition, the original directory is renamed
	!bat_echolog! with a "_zipped" suffix in order to make the ones that have been 
	!bat_echolog! zipped easily identifiable.  
	!bat_echolog!
	!bat_echolog! The next step is to manually archive to DVD the ZIP files.
	!bat_echolog!
	!bat_echolog! Only after the ZIP files have been successfully archived is it safe to 
	!bat_echolog! delete the original directories tagged with the "_zipped" suffix. 
	!bat_echolog!

	goto :MAKEARCHIVEDATEZIP_END
	
:MAKEARCHIVEDATEZIP_END
!bat_poplog! [RETURN !bat_batchfile!:MAKEARCHIVEDATEZIP] []
!bat_log!
set bat_abort=
!bat_logexeclog! set bat_captureddate=!bat_MADZ_captureddate_save!

!bat_return!




	REM ********************************************************************
	REM 
:GETSUBMISSIONROOT
!bat_pushlog! [CALL !bat_batchfile!:GETSUBMISSIONROOT] [%*]
	
	rem return "C:\CAMS\SubmissionFiles\2015_01_01_266_01_38_18\266\CapturedFiles"
	!bat_CALL! "!bat_exedir!\ParseDir.bat" %~1
	
	rem return "C:\CAMS\SubmissionFiles\2015_01_01_266_01_38_18\266"
	!bat_CALL! "!bat_exedir!\ParseDir.bat" !bat_retval1!
	
	rem return "C:\CAMS\SubmissionFiles\2015_01_01_266_01_38_18
	!bat_CALL! "!bat_exedir!\ParseDir.bat" !bat_retval1!
	set bat_retval1=!bat_retval1:~0,-2!??
	!bat_logexeclog! set bat_zipdir_filespec=!bat_retval1!
	!bat_logexeclog! set bat_temp_camera=!bat_retval2!
	
	rem return "C:\CAMS\SubmissionFiles
	!bat_CALL! "!bat_exedir!\ParseDir.bat" !bat_retval1!
	
:GETSUBMISSIONROOT_END
!bat_poplog! [RETURN !bat_batchfile!:GETSUBMISSIONROOT] [retval=!bat_retval!, 
!bat_log! `                                              retval1=bat_SubmissionFilesDir=!bat_retval1!, 
!bat_log! `                                              retval2=SubmissionFiles dir=!bat_retval2!
!bat_log! `                                              bat_temp_camera=!bat_temp_camera!]
!bat_log!
!bat_return!




	REM ********************************************************************
	REM 
:MOVEZIPTOARCHIVE
	
!bat_pushlog! [CALL !bat_batchfile!:MOVEZIPTOARCHIVE] %*


	if not defined bat_STAGE.ArchivePath_zip (
		!bat_echolog! ERROR - Skipping archive because [STAGE].ArchivePath_zip is not defined in autocams.params.ini. 
		goto :MOVEZIPTOARCHIVE_END
	)

	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_zip_output_fullname!"
	!bat_logexec! set bat_zip_output_filename=!bat_retval2!
	
	if not exist "!bat_STAGE.ArchivePath_zip!" (
		md "!bat_STAGE.ArchivePath_zip!"
	)

	!bat_logexec! MOVE /Y "!bat_zip_output_fullname!" "!bat_STAGE.ArchivePath_zip!"
	
	
	!bat_echolog! Getting ready to delete the _zipped dir...
	
		!bat_pushlog! if exist "!bat_STAGE.ArchivePath_zip!\!bat_zip_output_filename!" [target zip file should be there] ...
		if exist "!bat_STAGE.ArchivePath_zip!\!bat_zip_output_filename!" (
			!bat_pushlog! if exist "!bat_zipped_sourcedir!" [The source "_zipped" dir should still exist] ...
			if exist "!bat_zipped_sourcedir!" (
				!bat_logexeclog! RD /S /Q "!bat_zipped_sourcedir!"
			)
			!bat_poplog! ")"
		)
		!bat_poplog! ")"




:MOVEZIPTOARCHIVE_END
!bat_poplog! [RETURN !bat_batchfile!:MOVEZIPTOARCHIVE] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!













	REM ********************************************************************
	REM 
:STRIPWHITESPACE
	set %~1=!%~1!
!BAT_RETURN!








	REM ********************************************************************
	REM 
:HELP
	echo %~0      Batch Script
	echo.
	echo.     Usage %~0 
	echo.
	echo.     This script is designed to free up some disk space AND archive sessions in
	echo.     SubmissionFiles.  It essentially works like this...
	echo.      1.  Perform the function of the "keep_n_CapturedFiles.bat" script, which
	echo.          iterates backward through the SubmissionFiles sessions.  It counts
	echo.          as it iterates the directories.  When the count reaches the 
	echo.          bat_STAGE.MaxDaysToKeep AutoCams.Params.ini value, it clears that 
	echo.          CapturedFiles directory of just the FF.bin files in that directory 
	echo.          [leaving the .bin files] in the ArchivedFiles and  the ConfirmedFiles 
	echo.          directories untouched.
	echo.      2.  After clearing the FF*.bin files, but before moving on to the next 
	echo.          SubmissionFiles dir, it performs the function of AutoCams 61 [Archive].
	echo.          That function creates a .zip file of the one SubmissionFiles dir and
	echo.          renames the source directory with a "_zipped" suffix. Directories that
	echo.          have a "_zipped" suffix are free to delete, but only once the matching
	echo.      3.  Then it uses the bat_STAGE.ArchivePath_zip AutoCams.Params.ini  var to 
	echo.          "move" the zip file to the ArchivePath location.  This should be an 
	echo.          external drive used for archiving.  
	echo.      4.  Upon successful moving of the zip file, the "_zipped" dir and its contents 
	echo.          are deleted.
	echo.          
	echo. Requires:
	echo.      1.  External hard drive to archive to.  Probably 3 TB or larger.
	echo.      2.  AutoCams.Params.ini file setting: [STAGE] MaxDaysToKeep
	echo.      3.  AutoCams.Params.ini file setting: [STAGE] ArchivePath_zip
	echo.      4.  Windows Scheduled Task to launch this script once each day.
	echo. Troubleshooting:  
	echo.    - One of the issues found is that this script requires that the CapturedFiles dir
	echo.      must have a subdirectory that follows this naming construct: yyyy_mm_dd_hh_mm_ss.
	echo.
exit /b 99



	REM ********************************************************************
	REM 
:DONE
	!bat_log! goto %~nx0:DONE [!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:DONE2
	exit /b %bat_returncode%
