  @echo off
setlocal enabledelayedexpansion enableextensions

	rem NEEDS:
	rem       - 13. If submit.email.bat fails to create a Submit dir, then abort.

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	REM #########################################################################
	REM 

:CHECKHELP_END
goto :SETUP %*

	Flowchart:


	
	REM #########################################################################
	REM 

:SETUP

		rem set bat_logdir= blanks out the bat_logdir variable, triggering it to be
		rem use "..\Logs".  
	set bat_logdir=
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	if not defined bat_ftppassword (
		set bat_ftppassword=.
	)


	call "!bat_exedir!\ReadParams.bat"
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	set bat_startlocation=!bat_camsdir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	set bat_ftp_dest_dir=!bat_camsdir!\Temp
	
rem	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
rem		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
rem		exit /b 1
rem	)
	
	set bat_caldir=!bat_camsdir!\Cal
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log


	!bat_logexeclog! call "!bat_exedir!\ReadConfig.bat"

	set bat_returncode=0

	!bat_logexeclog! type "!bat_paramsfile!"
	!bat_logexeclog! type "!bat_configfile!"
	!bat_logexeclog! set bat_

	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	
	call :PARSEARGS %*

	goto :MAIN
	
goto :MAIN




:MAIN
	call :DOWNLOADFTP
:MAIN_END
goto :DONE
!bat_return!

	
:PARSEARGS
	echo.%*|find /i "autonomous"
	if !errorlevel! equ 0 (set bat_autonomous=autonomous)

!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [!bat_getdirname!, !bat_mainspec!]
!bat_log!
!bat_return!






	rem 17. Upload Zip via FTP ************************************
:DOWNLOADFTP
!bat_pushlog! [CALL !bat_batchfile!:DOWNLOADFTP] %*
	set bat_retval=failed

		rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
		rem and the question won't be asked again.
	if /i "!bat_ftppassword!" equ "" (
		if not defined bat_autonomous (
			!bat_echolog!
			!bat_echolog!
			set bat_choice=
			!bat_prompt! Enter your email address as the anonymous FTP password: 

			set bat_ftppassword=!bat_choice!
			!bat_logexeclog! set bat_ftppassword=!bat_choice!

			call :SAVECONFIG
		)
	)

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt

		rem Handle the case where the FTP file has already been downloaded. 
		rem No sense in downloaded over the top of an existing file.  
		rem So, we need to list all the existing 
		rem zip files on the server (in ascending date order), check each
		rem against whether it exists locally, then download the remaining ones.
	!bat_logexeclog! set bat_zipfile=CALSTARS??????_????_??_??_??_??_??*.zip
	!bat_logexeclog! set bat_zip=!bat_zipfile!

	call :FTPTRANSFER
	
		rem Do a second download of the Sunnyvale files...
	!bat_logexeclog! set bat_zipfile=CAMS_Svl_FTPdetectinfo_????_??_??*.zip
	!bat_logexeclog! set bat_zip=!bat_zipfile!
	call :FTPTRANSFER

:DOWNLOADFTP_END
!bat_poplog! [RETURN !bat_batchfile!:DOWNLOADFTP] [!bat_retval!, !bat_returncode!, "!bat_zipfile!" !bat_recent_error_msg!]
	if not defined bat_autonomous (pause)
!bat_log!
!bat_return!









	rem Check for existing files on the server and download only those
	rem that don't match file names locally. 
:FTPTRANSFER
!bat_pushlog! [CALL !bat_batchfile!:FTPTRANSFER
	!bat_logexeclog! set bat_retval=failed

		rem The downloaded files go to this dir.
	if not exist "!bat_exedir!\Temp" (
		!bat_logexeclog! md "!bat_exedir!\Temp"
	)


		REM Create the ftp command file for listing the existing
		REM files that match the spec.
	!bat_logexeclog! set bat_ftpfile2=!bat_ftpfile:~0,-4!_2.txt
	if exist "!bat_ftpfile2!" (
		 if defined bat_ftpfile2 (
			!bat_logexeclog! del /q "!bat_ftpfile2!"
		 ) else (
		 	!bat_echolog! ERROR [!bat_batchfile!:FTPTRANSFER] Dangerous command: del /q "!bat_ftpfile2!"
		 )
	)
	
	!bat_echolog! "!bat_ftpfile2!"
	!bat_echolog!

	!bat_echolog! Now download a list of files using the "ls" ftp command file "!bat_ftpfile!"...
	!bat_pushecho!
	!bat_log! '    Note: Building the .ftp.temp_2.txt" file...
	
		echo user !bat_ftpuser!>"!bat_ftpfile!"
		echo !bat_ftppassword!>>"!bat_ftpfile!"
		echo bin>>"!bat_ftpfile!"
		echo cd !bat_ftpdir!>>"!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo ls "!bat_zipfile!">>!bat_ftpfile!"
		echo quit>>"!bat_ftpfile!"
		

			rem I had to come up with a workaround for a silly problem where the 
			rem creation of the listing file has 0D 0D 0A instead of 0D 0A.
			rem Therefore, I had to use a delimited file...
		!bat_pushecho! for /f "usebackq tokens=* skip=1" ..a in ^(`call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!][find /i ".zip"`^) do ^(
		for                /f "usebackq tokens=* skip=1" %%a in  (`call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!^|find /i ".zip"`) do (
			set bat_temp=%%a
			set bat_temp=!bat_temp:~0,-1!
			echo.!bat_temp!^^!0 >>"ftp.temp_2.txt"
		)
		!bat_popecho! ^)
		
		if not exist "ftp.temp_2.txt" (
			!bat_echolog! No matching files on server: "!bat_zipfile!"
			!bat_popecho! ^)
			goto :FTPTRANSFER_END
		)

		if exist "ftp.temp_3.txt" (
			!bat_logexeclog! del /q "ftp.temp_3.txt"
		)

		!bat_pushecho! for /f "usebackq tokens=1 delims=!" ..a in ^("ftp.temp_2.txt"^) do ^(
		for                /f "usebackq tokens=1 delims=!" %%a in ("ftp.temp_2.txt") do (
			echo.%%a>>"ftp.temp_3.txt"
		)
		!bat_popecho! ^)
		
		!bat_logexeclog! move /y "ftp.temp_3.txt" "ftp.temp_2.txt"

		!bat_pushecho! for /f "usebackq" ..a in ^("ftp.temp_2.txt"^) do ^(
		for                /f "usebackq" %%a in ("ftp.temp_2.txt") do (
			!bat_echolog! %%a
		)
		!bat_popecho! ^)

	!bat_popecho!

rem !bat_pause! CHECK THE ZIP FILES AND THE ZIP DIR
	!bat_echolog! Now download the files that don't exist locally to ".\Temp" and test them...
	!bat_pushecho!
		set /a bat_count=0
		for /f "usebackq tokens=*" %%a in (`type "!bat_ftpfile2!"`) do (
			if not exist "!bat_exedir!\Temp\%%a" (
				set /a bat_count+=1
				!bat_pushecho! Downloading "!bat_exedir!\Temp\%%a"...
					echo user !bat_ftpuser!>"!bat_ftpfile!"
					echo !bat_ftppassword!>>"!bat_ftpfile!"
					echo bin>>"!bat_ftpfile!"
					echo cd !bat_ftpdir!>>"!bat_ftpfile!"
					echo literal pasv>>"!bat_ftpfile!"
					echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
					echo literal pasv>>"!bat_ftpfile!"
					echo get "%%a">>!bat_ftpfile!"
					echo quit>>"!bat_ftpfile!"

					!bat_logexec! type "!bat_ftpfile!"

					!bat_echolog! '..............................................

					!bat_logexec! call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
					set bat_returncode=!bat_logexec_returncode!

					!bat_echolog!
					!bat_echolog! '    FTP exit code=!bat_returncode!
					!bat_echolog!

					call :CHECK_GET "!bat_exedir!\Temp\%%a" "%%a"
				!bat_pop!
			) else (
				!bat_echolog! Already exists - Skipping redundant download for: "!bat_exedir!\Temp\%%a"
				
				rem call :CHECK_GET "!bat_exedir!\Temp\%%a" "%%a"
				if /i "!bat_retval!" equ "failed" (
					rem 
				)
			)
			
			!bat_echolog!
			!bat_echolog! Done with downloading the new files: %%a
			!bat_echolog!
rem !bat_pause! CHECK THE TEMP DIR [type "!bat_exedir!\Temp\!bat_zipfile!]
		)

	                   
	!bat_popecho!
rem !bat_pause! CHECK THE TEMP DIR [type "!bat_exedir!\Temp\!bat_zipfile!]
goto :FTPTRANSFER_END	

:FTPTRANSFER_END
!bat_poplog! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
!bat_return!





:CHECK_GET "!bat_exedir!\Temp\!bat_zip!" "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:CHECK_GET] %*
	!bat_logexeclog! set bat_checkget_zip=%~1
	!bat_logexeclog! set bat_checkget_zipfile=%~nx1
	
	if not exist "!bat_checkget_zip!" (
		set bat_recent_error_msg=17.ERROR - Failed FTP download of "!bat_checkget_zipfile!" - can't find it in "!bat_exedir!\Temp".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	)

	if not exist "!bat_exedir!\Temp\Zip" (
		md "!bat_exedir!\Temp\Zip"
	)

	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
			!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
		)
	)
	
	!bat_logexeclog! md "!bat_exedir!\Temp\Zip"
rem !bat_pause! Check if this dir exists: "!bat_exedir!\Temp\Zip"
	!bat_logexeclog! copy /y "!bat_checkget_zip!" "!bat_exedir!\Temp\Zip"
rem !bat_pause! Check if this file exists: "!bat_exedir!\Temp\Zip\!bat_checkget_zipfile!"


	call :FTP_TESTZIP "!bat_exedir!\Temp\Zip\!bat_checkget_zipfile!"
	if /i "!bat_returncode!" neq "0" (
	
		if defined bat_exedir (
			if defined bat_checkget_zip (
				del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
			)
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
		)
		goto :CHECK_GET_END
	)


	!bat_log!

	set bat_retval=success
	set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! '    !bat_recent_error_msg!
	!bat_echolog!
	!bat_echolog!


:CHECK_GET_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_GET] []
!bat_return!






:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

	!bat_echolog! 'Test the zip file before uploading to ensure that it's good.
	!bat_echolog! 'The test involves:
	!bat_echolog! '  - The zip file must exist;
	!bat_echolog! '  - The hash code must not be the empty zip file hash
	!bat_echolog! '    If so, the zip file will be deleted.
	!bat_echolog! '  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
	!bat_echolog! '    is cleaned out before unzipping]
	!bat_echolog! '  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
	!bat_echolog! '  - If there are no other errors, the 

	if not exist "%~1" (
		set bat_returncode=98
		set bat_recent_error_msg=17.ERROR - Not found: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

	call :FTPHASH "%~1"
	
		rem The hash code below is a hash for an empty 22 byte zip file. 
	if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
		set bat_returncode=99
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		
		if "%~1" neq "" (
			!bat_logexec! del /q "%~1"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /q "%~1"
		)
		goto :FTP_TESTZIP_END
	) else (
		!bat_echolog! '    OK - because it's not a blank zip file...
	)

%BAT_COMMENT_BEGIN%	
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
			!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
		)
	)
%BAT_COMMENT_END%

	!bat_log!
	!bat_log! // Unzipping the file to "..\Temp\Zip" and checking the errorlevel.  If the errorlevel
	!bat_log! // is not "0", then it's a corrupt zip file. [There is also the possibility that it's encrypted]

	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
	set bat_returncode=!bat_logexec_returncode!
	!bat_echolog! bat_returncode=!bat_returncode!

	!bat_log! // Cleanup after unzipping...
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_logexeclog! move /y "%~1" "!bat_exedir!\Temp"
		
		if defined bat_exedir (
			!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
			!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
		)
	)

	!bat_log! // Comparing the hash codes...
	if /i !bat_returncode! equ 0 (
		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - Zip file is OK as it is not empty, and not corrupt: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
	) else (
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Corrupt zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
!bat_return!







	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)
		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
	)

	if exist "!bat_exedir!\Logs\md5.output.log" (
		if defined bat_exedir (
			!bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:FTPHASH] Dangerous command: del /q "!bat_exedir!\Logs\md5.output.log"
		)
	)

:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!
















	rem 48. Save Configuration ************************************
:SAVECONFIG

	!bat_logexeclog! call "!bat_exedir!\SaveConfig.bat"

!bat_return!










:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0 [autonomous]
	echo.
	echo.Downloads the zip files from the ftp server for all files that
	echo.aren't already downloaded. 
	echo.
	echo.It works by first using the FTP "ls" command to list all the files 
	echo.matching the "????_??_??_*.zip" filespec. Then it iterates through
	echo.that list of files, looking for the same file in the ".\Temp" dir.
	echo.
	echo.
	echo.There could be an option to be able to specify a filespec, which might reduce
	echo.the traffic. Post to the seticams if this is needed...
	echo.
	echo.
exit /b -99


:DONE
!bat_pop!
	!bat_popecho!
	!bat_echolog! [!date! !time!] !bat_batchfile!:DONE with %0 %* [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!