# in the bat file I added this:
# :MAILCARL
# SET ThisScriptsDirectory=%~dp0
# SET PowerShellScriptPath=%ThisScriptsDirectory%mailCarl.ps1
# PowerShell -NoProfile - ExecutionPolicy Bypass -File %PowerShellScriptPath% "!bat_exedir!" "!bat_catptureddate!"
# !bat_return! 

	write-host [string]$args

	# Parse the command line arguments
	
	$path=[string]$args[0]
	
	# $dateString is actually !bat_captureddatetime!
	$datetimeString=[string]$args[1]
	$dateString=$datetimeString.substring(0,10);
	
	$submissionFilesDir=[string]$args[2]
	
	$detectFile=[string]$args[3]
	
	#autonomous=[string]$args[4]
	
	
	write-host path=$path
	write-host datestring=$dateString
	write-host submissionfilesdir=$submissionFilesDir
	write-host detectfile=$detectFile
	write-host autonomous=$autonomous
	
	
	New-PSDrive -Name camsdir -PSProvider FileSystem -Root "$path"
	Set-Location camsdir:
	write-host "-----------------"
	
	# Read the contents of Autocams.params.ini and create an array of variables
	# from the key=value pairs.
	#
	#### WARNING: In .ini files, you can have multiple instances of the same
	####          key name within a section.
	####          Also, keys in one section are made unique by their section
	####          name [SECTION].  So if there is a variable in [CAPTURE].count=10
	####          it should be treated different from [CONFIRMATION].count=30.
	#Get-Content "AutoCams.Params.ini" 
	write-host XXXXXXXXXXXXXXXXXXXXXXXXXX
	
	$section_name=""
	
    Get-Content "AutoCams.Params.ini" | ForEach-Object { 
    	if ( ($_.CompareTo("") -ne 0) ) 
    	{
			if ( ($_.StartsWith("//") -ne $True) -and ($_.StartsWith("#") -ne $True)) 
			{
				if ($_.StartsWith("[") -eq $True) 
				{
					$sectionName="bat_"+$_.Trim("[","]")+"_";
				} 
				else 
				{
					$var=[regex]::split($_,'=');
					$var[0]=$var[0].trim();
					$var[0]=$sectionName+$var[0]

					New-Variable -Name $var[0] -Value $var[1];
					#write-host "....Setting:"$var[0]'='$var[1]'<<<'
				}
    		}
    	}
    }
    
    write-host "============================"

	
	#Get-Content "AutoCams.Params.ini" | Foreach-Object {
	#	write-host $_
	#	if ($var[0] -ne "") {
	#		New-Variable -Name $var[0] - Value $var[1]
	#		write-host INI: $var[0]=$var[1]
	#	}
	#}
	
	
	# This section uses the [CAPTURE].cameralist variable and parses into
	# an array of cameras.  Then it creates the $FTPcameralist var with
	# leading zeros, like this: 02130216 
	write-host $bat_CAPTURE_cameralist
	$Array_cameralist = $bat_CAPTURE_cameralist.Split(' ')
	$FTPcameralist=""
	
	foreach ($cameranow in $Array_cameralist)
	{
		$FTPcameralist=$FTPcameralist+$cameranow.PadLeft(4,'0')
	}
	
	# $zipCamera is the first camera in the list
	$zipCamera=$Array_cameralist[0]
	
	write-host "dateString="$dateString
	$dtmDate=[datetime]::ParseExact($dateString,'yyyy_MM_dd', $null)
	$submissionFilesBaseDir=$path+'\SubmissionFiles'
	
	# $filename='FTPdetectinfo_'+$FTPcameralist+'_'+dtmDate.ToString("yyyy_MM_dd")+'*_confirmed.txt'
	$filename=$detectfile
	$filesearch='LASTSETTINGS.txt'
	write-host submissionfilesbasedir=$submissionFilesBaseDir
	write-host filename=$filename
	
	
	$filenameFTP=$submissionFilesDir+'\'+$detectFile
	write-host $filenameFTP
	
	$DirTime=$datetimeString.substring($datetimeString.length - 8, 8)
	
	################################################################
		write-host '####################'
   		$bat_CapturedFilesDir=$submissionFilesDir+'\'+'CapturedFiles'+'\'+$datetimeString
		$bat_GCFC_file=$bat_CapturedFilesDir+'\GCFC.log'
		
		write-host bat_CapturedfilesDir=$bat_CapturedfilesDir
		write-host bat_GCFC_file=$bat_GCFC_file
		
		$cameraList_Captured = Get-Content $bat_GCFC_file
		
		
		$cameralist=""
		ForEach ($c in $cameraList_Captured )
		{
			$cameralist=$cameralist+$c+" "
			write-host c=$c
		}
		
		write-host cameraList=$cameralist
	
	###############################################################
	
	
	$zipexe=$path+'\7za.exe'
	#$zipDir=split-path $filenameFTP -Parent
	$zipDir=$path+'\Submitted'
	
 	$dest=$zipDir+'\'+$dateString+'_'+$zipCamera+"_"+$DirTime+'.zip'
	
	$emailFilesDir=$SubmissionFilesDir+"\EmailFiles"
	$detectFileFull=$emailFilesDir+'\'+$detectFile
	
	write-host ~~~~~~~~~~~~~~~~
	write-host filenameFTP=$filenameFTP
	write-host DirTime=$DirTime
	write-host zipDir=$zipDir
	write-host dest=$dest
	write-host submissionfilesbasedir=$SubmissionFilesBaseDir
	write-host emailFilesDir=$EmailFilesDir
	write-host detectFileFull=$detectFileFull
	
	
	Set-Location -Path $zipDir
	
	# WARNING - Should delete the $dest before starting the zipping.  Otherwise
	#           if it's run a second time, you'll double-up the zip contents.
	
	#Each of these zipexe commands appends the referenced files to the same $dest zip file.
	write-host $zipexe a -tzip $dest $detectFileFull
	&$zipexe a -tzip $dest $detectFileFull
	
	$temp=$EmailFilesDir+"\"+'comments*.txt'
	write-host $zipexe a -tzip $dest $temp
	&$zipexe a -tzip $dest $temp
	
	$temp=$EmailFilesDir+"\"+'CameraTimeOffsets.txt'
	write-host $zipexe a -tzip $dest $temp
	&$zipexe a -tzip $dest $temp
	
	$temp=$submissionFilesDir+"\cal\Cal*.txt"
	write-host $zipexe a -tzip $dest $temp
	&$zipexe a -tzip $dest $temp
	
	#foreach ($cameranow in $Array_cameralist )
	#{
	#	$strCalDir=$zipdir+"\Cal-'+cameralist )
	#	Set-Location -Path $strCalDir
	#	&$zipexe a -tzip $dest 'CAL*.txt'
	#}
	
	
	Set-Location -Path $path
	
	$SMTPServer = $bat_MAIL_smtpserver
	$BoolSSL=[System.Convert]::ToBoolean($bat_MAIL_smtpSSL)
	$SMTPClient = New-Object Net.Mail.SMTPClient( $bat_MAIL_SmtpServer, $bat_MAIL_smtpPort )
	$SMTPClient.EnableSSL = $BoolSSL
	$SMTPClient.Credentials = New-Object System.Net.NetworkCredential( $bat_MAIL_loginmail, $bat_MAIL_passwrdmail );
	
	$Arry_EmailAttachments=$dest
	
	[String]$EmailFrom = $bat_MAIL_fromEmail
	[String[]]$Arry_EmailTo = $bat_MAIL_ownEmail, $bat_MAIL_coordinator1Email, $bat_MAIL_Coordinator2Email
	[String]$EmailSubj='Cams: '+$cameralist+'on: '+$datetimeString;
	[String]$EmailBody='Email Submission for:'+$cameralist+'on: '+$datetimeString;
	#[String[]]$Arry_EmailAttachments
	
	
	$emailMessage = New-Object System.Net.Mail.MailMessage
	$emailMessage.From = $EmailFrom
	
	foreach ( $recipient in $Arry_EmailTo )
	{
		$emailMessage.To.Add( $recipient )
	}
	
	$emailMessage.Subject = $EmailSubj
	$emailMessage.Body = $EmailBody
	# Do we have any attachments?
	# If yes, then add them, if not, do nothing
	$emailMessage.Attachments.Add($dest)
	
	$SMTPClient.Send( $emailMessage )
	
	write-host Sent to: 
	foreach ($temp in $Arry_EmailTo )
	{
		write-host '   ' $temp
	}
	write-host From: $EmailFrom
	write-host Subject: $EmailSubj
	write-host Email Message Body: $EmailBody
	write-host Attachments: $dest
	write-host
	


