  @echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2015:
		
	
:SETUP

	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	set bat_pushstring=

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"


	call :GETARGS %*
	
	call :MAIN %*
goto :DONE





:GETARGS
!bat_pushlog! [CALL !bat_batchfile!:GETARGS] %*

	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!
	
	set bat_tempdir=!bat_exedir!\Temp
	set bat_tempfile=!bat_tempdir!\emailErrors_temp.txt
	set bat_tempfile2=!bat_tempdir!\emailErrors_temp2.txt


	rem SET bat_ThisScriptsDirectory=%~dp0
	!bat_logexeclog! SET bat_PowerShellScriptPath=!bat_exedir!\emailErrors.ps1

:GETARGS_END
!bat_poplog! [RETURN !bat_batchfile!:GETARGS_END] [bat_PowerShellScriptPath=!bat_PowerShellScriptPath!,
!bat_log! `                                      bat_exedir=!bat_exedir!]
!bat_return!



:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %*
!bat_push!

	set bat_returncode=0
	
	rem Clear the temporary file
	call :CLEARTEMP
	
	rem Add list of CapturedFiles directories to Temp File
	call :ADDCAPTURED
	
	rem Add list of untransmitted SubmissionFiles to Temp file
	call :ADDSUBMISSION
	
	rem Sort the Temp file
	call :SORTTEMP
	
	rem Process Temp file
	call :PROCESSTEMP
	
goto :MAIN_END
	
	rem Email the Temp file to the Site Operator[s]	
	call :MAILERRORS 
	if "!errorlevel!" neq 0 (
		!bat_echolog! PowerShell script failed: "%PowerShellScriptPath%"
		goto :MAIN_END
	)

:MAIN_END
!bat_pop!
!bat_pop!
!bat_poplog! [RETURN !bat_batchfile!:MAIN_END] [!date! !time! - exit /b !bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b !bat_returncode!



	rem Clear the Temporary file
:CLEARTEMP
!bat_pushlog! [CALL !bat_batchfile!:CLEARTEMP] %*
	if not exist "!bat_tempdir!" (
		md "!bat_tempdir!"
	)
	
	del /q "!bat_tempfile!"
	del /q "!bat_tempfile2!"
	


:CLEARTEMP_END
!bat_poplog! [RETURN !bat_batchfile!:CLEARTEMP] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!



	rem Add list of CapturedFiles dirs to Temp file
:ADDCAPTURED
!bat_pushlog! [CALL !bat_batchfile!:ADDCAPTURED] %*

	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\CapturedFiles" /b /ad`) do (
		echo.%%a>>"!bat_tempfile!"
	)

:ADDCAPTURED_END
!bat_poplog! [RETURN !bat_batchfile!:ADDCAPTURED] [bat_returncode=!bat_returncode!]
!bat_loglog!
!bat_return! !bat_returncode!


	rem Add list of untransmitted SubmissionFiles to Temp file.
	rem You can tell if it's untransmitted, you have to correlate with
	rem the Transmitted dir.  If it's in the SubmissionFiles dir but
	rem it is not in the Transmitted dir, then it's untransmitted.
:ADDSUBMISSION
!bat_pushlog! [CALL !bat_batchfile!:ADDSUBMISSION] %*

	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\SubmissionFiles" /b /ad`) do (
		if not exist "!bat_exedir!\Transmitted\%%a" (
			set bat_submissiondir=%%a
			set bat_submissiondir_date=!bat_submissiondir:~0,10!
			set bat_submissiondir_time=!bat_submissiondir:~-8!
			set bat_submissiondir_camera=!bat_submissiondir:~11,3!
			
			echo.!bat_submissiondir_date!_!bat_submissiondir_time!>>"!bat_tempfile!"
			rem !bat_logexec! set bat_submissiondir_
		)
	)


:ADDSUBMISSION_END
!bat_poplog! [RETURN !bat_batchfile!:ADDSUBMISSION] [bat_returncode=!bat_returncode!,
!bat_log! `                                     bat_submissiondir=!bat_submissiondir!,
!bat_log! `                                     bat_submissiondir_camera=!bat_submissiondir_camera!]
!bat_log!
!bat_return! !bat_returncode!


	rem Sort the Temp file
:SORTTEMP
!bat_pushlog! [CALL !bat_batchfile!:SORTTEMP] %*

	if not exist "!bat_tempfile!" (
		!bat_echolog! ERROR - Temp file not found: "!bat_tempfile!"
		goto :SORTTEMP_END
	)

	sort "!bat_tempfile!" /o "!bat_tempfile2!"

:SORTTEMP_END
!bat_poplog! [RETURN !bat_batchfile!:SORTTEMP] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!



:PROCESSTEMP
!bat_pushlog! [CALL !bat_batchfile!:PROCESSTEMP] %*

		echo.[!date! !time!]>"!bat_tempfile!"
!bat_logexeclog! type "!bat_tempfile2!"
		echo.Capture session         Captured Autocal Submission Autocal Transmitted Cal Files>>"!bat_tempfile!"
		echo.----------------------- -------- ------- ---------- ------- ----------- ------------------------------>>"!bat_tempfile!"
		echo.Capture session         Captured Autocal Submission Autocal Transmitted Cal Files
		echo.----------------------- -------- ------- ---------- ------- ----------- ------------------------------
	
	rem Loop through the temp file that contains capture sessions and iterate 
	rem through them to display whether they are bad or not.
	
	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "!bat_tempfile2!"`^) do ^(
	for           /f "usebackq tokens=*" %%a in  (`type "!bat_tempfile2!"`) do (
		set bat_outputstring=

		rem !bat_echolog! Capture session         Captured Autocal Submission Autocal Cal Files
		rem !bat_echolog! ----------------------- -------- ------- ---------- ------- ------------------------------
		
		!bat_logexeclog! set bat_captureddatetime=%%a
		!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
		!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!
		
		set bat_yyyy=!bat_captureddate:~0,4!
		set bat_mm=!bat_captureddate:~5,2!
		set bat_dd=!bat_captureddate:~-2!
		set bat_calfiledate=!bat_yyyy!!bat_mm!!bat_dd!
		
		!bat_logexeclog! set bat_outputstring=%%a

		rem There should NOT be any CapturedFiles dirs
		if EXIST "!bat_exedir!\CapturedFiles\!bat_captureddatetime!" (
			set bat_outputstring=!bat_outputstring!     C       

			rem There SHOULD be a AutoCalUpdate.log file
			if exist "!bat_exedir!\CapturedFiles\!bat_captureddatetime!\AutoCalUpdate.log" (
				set bat_outputstring=!bat_outputstring! A      
				
				rem Need to validate the ArchivedFiles and ConfirmedFiles dirs too
			) else (
				set bat_outputstring=!bat_outputstring!        
			)
			
			!bat_log! if EXIST "!bat_exedir!\Cal\CAL_??????_!bat_calfiledate!_*.txt" (
			if           EXIST "!bat_exedir!\Cal\CAL_??????_!bat_calfiledate!_*.txt" (
				set /a bat_countcal=0
rem				!bat_log! for /f "usebackq tokens=*" ..d in ^(`dir "!bat_exedir!\Cal\CAL_??????_!bat_calfiledate!_*.txt" /b /a-d`^) do ^(
				for           /f "usebackq tokens=*" %%d in  (`dir "!bat_exedir!\Cal\CAL_??????_!bat_calfiledate!_*.txt" /b /a-d`) do (
					set /a bat_countcal+=1

					if !bat_countcal! equ 1 (
						set bat_outputstring=!bat_outputstring!                                %%d
						echo.!bat_outputstring!>>"!bat_tempfile!"
						echo.!bat_outputstring!
						set bat_outputstring=
					) else (
						set bat_outputstring=                                                                        %%d
						echo.!bat_outputstring!>>"!bat_tempfile!"
						echo.!bat_outputstring!
						set bat_outputstring=
					)
				)
			) else (
				echo.!bat_outputstring!>>"!bat_tempfile!"
				echo.!bat_outputstring!
				set bat_outputstring=
			)


		) else (
			set bat_outputstring=!bat_outputstring!             
		)
		

		
		rem Each SubmissionFiles dir must have a matching Transmitted zip file
		rem These are parallel to the CapturedFiles dir.  Remember, when 
		rem a capture session is processed and packaged for submission, the
		rem CapturedFiles, ArchivedFiles, and ConfirmedFiles dirs are
		rem "moved" to the SubmissionFiles dir under two subdir deep
		rem hierarchy.  The second level is the camera number. 
		
		if EXIST "!bat_exedir!\SubmissionFiles\!bat_captureddate!_???_!bat_capturedtime!" (
			if NOT exist "!bat_exedir!\Transmitted\!bat_captureddate!_???_!bat_capturedtime!.zip" (
				set bat_outputstring=!bat_outputstring!         S         
				rem For each capture session dir under SubmissionFiles, we only want
				rem to list it if it does NOT have a matching Transmitted zip file

				set /a bat_count=0
rem				!bat_echolog! for /f "usebackq tokens=*" ..b in ^(`dir "!bat_exedir!\SubmissionFiles\!bat_captureddate!_???_!bat_capturedtime!" /s/b /ad`^) do ^(
				for               /f "usebackq tokens=*" %%b in  (`dir "!bat_exedir!\SubmissionFiles\!bat_captureddate!_???_!bat_capturedtime!" /s/b /ad`) do (

					rem fetch the full path of  the autocalupdate.log file.  This loop results
					rem in a %%c var that contains the full SubmissionFiles path, including the
					rem intermediate camera number
rem					!bat_echolog! for /f "usebackq tokens=*" ..c in ^(`dir "%%b\CapturedFiles" /s/b /ad`^) do ^(
					for               /f "usebackq tokens=*" %%c in  (`dir "%%b\CapturedFiles" /s/b /ad`) do (
						set /a bat_count+=1

						rem extract/remove the dir path up until the camera dir
						set bat_temppath=%%c

						call :REMOVETEMPPATH "!bat_exedir!\SubmissionFiles\!bat_captureddate!" "!bat_temppath!"

						if NOT EXIST "!bat_temppath!\AutoCalUpdate.log" (
							if /i "!bat_count!" equ "1" (
								set bat_outputstring=!bat_outputstring! !bat_camera_temp!    
							) else (
								set bat_outputstring=                                        !bat_camera_temp!    
							)
						)
						
						if EXIST "%%b\!bat_camera_temp!\Cal\CAL_??????_*.txt" (
							set /a bat_countcal=0
rem							!bat_echolog! for /f "usebackq tokens=*" ..d in ^(`dir "%%b\!bat_camera_temp!\Cal\CAL_??????_*.txt" /b /a-d`^) do ^(
							for               /f "usebackq tokens=*" %%d in  (`dir "%%b\!bat_camera_temp!\Cal\CAL_??????_*.txt" /b /a-d`) do (
								set /a bat_countcal+=1

								if !bat_countcal! equ 1 (
									set bat_outputstring=!bat_outputstring!             %%d
									echo.!bat_outputstring!>>"!bat_tempfile!"
									echo.!bat_outputstring!
									set bat_outputstring=
								) else (
									set bat_outputstring=                                                                        %%d
									echo.!bat_outputstring!>>"!bat_tempfile!"
									echo.!bat_outputstring!
									set bat_outputstring=
								)
							)
						)

					) & rem for /f "usebackq tokens=*" ..c in ^(`dir "%%b\CapturedFiles" /s/b /ad`^) do ^(

				) & rem if NOT exist "!bat_exedir!\Transmitted\!bat_captureddate!_???_!bat_capturedtime!.zip"
			) else (
				rem set bat_outputstring=!bat_outputstring! ----------------------- -------- ------- ---------- ----------- 
			)
		
		) else (
			rem
		) & rem if exist "!bat_exedir!\SubmissionFiles\!bat_captureddate!_???_!bat_capturedtime!"
	)

:PROCESSTEMP_END
!bat_poplog! [RETURN !bat_batchfile!:PROCESSTEMP] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return! !bat_returncode!



:REMOVETEMPPATH [in]"!bat_exedir!\SubmissionFiles\!bat_captureddatetime!" [in]"%%c"
	rem        [out] camera
!bat_pushlog! [CALL !bat_batchfile!:REMOVETEMPPATH] %*

	set bat_sourcepath=%~2
	set bat_pattern=%~1_
	
	set bat_temppath=!bat_sourcepath:%bat_pattern%=!
	
	set bat_camera_temp=!bat_temppath:~0,3!

:REMOVETEMPPATH_END
!bat_poplog! [RETURN !bat_batchfile!:REMOVETEMPPATH] [bat_returncode=!bat_returncode!
!bat_log! `                                       bat_camera_temp=!bat_camera_temp!,
!bat_log! `                                       bat_temppath=!bat_temppath!]
!bat_log!
!bat_return! !bat_returncode!



:MAILERRORS
!bat_pushecho! [CALL !bat_batchfile!:MAILERRORS] %*

	set bat_returncode=0
	rem           PowerShell -NoProfile -ExecutionPolicy Bypass -File "%bat_PowerShellScriptPath%" "!bat_exedir!" "!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!" "!bat_FTP_detectfile!" !bat_camera !bat_autonomous!
	!bat_logexec! PowerShell -NoProfile -ExecutionPolicy Bypass -File "%bat_PowerShellScriptPath%" "!bat_exedir!" "!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!" "!bat_FTP_detectfile!" !bat_camera !bat_autonomous!
	set bat_returncode=!bat_logexec_returncode!
	
	


:MAILERRORS_END
!bat_popecho! [RETURN !bat_batchfile!:MAILERRORS] [bat_returncode=!bat_returncode!,
!bat_echolog! `                                      bat_ThisScriptsDirectory=!bat_ThisScriptsDirectory!,
!bat_echolog! `                                      bat_PowerShellScriptPath=!bat_PowerShellScriptPath!]
!bat_echolog!
!bat_return! !bat_returncode!




	rem This routine returns the name of the detect file as either the "_confirmed" version or the "_scanned" version. 
:GETDETECTFILE
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_returncode=0
	rem !bat_logexec! set bat_

	set bat_FTP_detectfile=
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_confirmed*.txt" /b`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_confirmed*.txt" /b`) do (
		!bat_logexeclog! set bat_FTP_detectfile=%%~nxa
	)
	
	if not defined bat_FTP_detectfile (
		!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir !bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_scanned*.txt /b`^) do ^(
		for               /f "usebackq tokens=*" %%a in  (`dir !bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_scanned*.txt /b`) do (
			!bat_logexeclog! set bat_FTP_detectfile=%%~nxa
		)
	)
	
	!bat_echolog! if not defined !bat_FTP_detectfile! ^(
	if               not defined  bat_FTP_detectfile (
		!bat_echolog! WARNING - missing detect file in "!bat_submissionfilesdir!\!bat_camera!\EmailFiles"
		set bat_returncode=1
		goto :GETDETECTFILE_END
	)

:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode!, bat_FTP_detectfile=!bat_FTP_detectfile!]
!bat_log!
!bat_return! /b !bat_returncode!





:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 
    echo.
    echo.    This script attempts to email the operator to make them aware
    echo.    of possible issues that need to be addressed.  
    echo.
    echo.    Example:
    echo.       %~nx0 
    echo.
    echo.    Might result in the following report:
    echo.
    echo.       Capture session         Captured Autocal Submission Autocal Transmitted Cal Files
	echo.       ----------------------- -------- ------- ---------- ------- ----------- ------------------------------
	echo.       2015_11_20_01_31_59                      S          266                 CAL266_20151120_064319_061.txt
	echo.                                                                               CAL998_20151120_064319_061.txt
	echo.       2015_12_10_01_00_43     C        A                                      CAL266_20151210_035621_099.txt
	echo.                                                                               CAL267_20151210_035058_454.txt
	echo.       2015_12_10_01_00_43     C        A                                      CAL266_20151210_035621_099.txt
	echo.                                                                               CAL267_20151210_035058_454.txt
	echo.       2015_12_12_02_15_07     C
	echo.
    echo.    Where the columns are used as follows:
    echo.      Capture session = Captured Date/Time from the capture session, not necessarily the directory name. 
    echo.                        For CapturedFiles dirs, it is the same, but for SubmissionFiles, the camera
    echo.                        number shown under the Autocal column is  the camera value in the directory
    echo.                        name of the SubmissionFiles session.  
    echo.      Captured =        If it is blank, it's most likely a SubmissionFiles listing.  If it shows C, 
    echo.                        then it is a CapturedFiles session that hasn't been thoroughly processed.
    echo.      Autocal  =        The first Autocal column will show an A if there is an AutoCalUpdates.log file
    echo.                        in the CapturedFiles dir.  Thereby indicating that the scripts got so far as
    echo.                        to having started the autocal routine.  
    echo.      Submission =      If there is and S under this column, the session was processed, but there may 
    echo.                        have been an issue with either the submission routine, zip routine, or 
    echo.                        FTP routine.  Sessions that have a matching Transmitted directory are not
    echo.                        listed. 
    echo.      Autocal =         This column shows the directory name under the submissionFiles dir
    echo.                        where the rest of the session files can be found.  In the example above, 
    echo.                        capture session 2015_11_20_01_31_59 correlates with the SubmissionFiles dir
    echo.                        of 2015_11_20_266_01_31_59.  Notice  the camera number 266 in the directory name.
    echo.                        Also, directly under that dir is another dir named after the camera.  If a 
    echo.                        camera number appears under that Autocal column, it tells you that there is
    echo.                        an AutoCalUpdate.log file in that SubmissionFiles' CapturedFiles dir.  Telling
    echo.                        you that there is calibration in the submission files.  
    echo.      Transmitted =     No implemented
    echo.      Cal Files =       Lists the Cal file, if any, related to the date of this session.  This is
    echo.                        similar to the AutoCams 7f option. 
    echo.
EXIT /b 99
    
goto :DONE


:DONE
!bat_echolog! [%date% %time%] DONE !bat_batchfile! [!bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog!
echo Waiting...&!bat_WAIT!  10
exit /b !bat_returncode!
