@echo off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	!bat_log! bat_exedir=!bat_exedir!

	if /i "%bat_exedir%" EQU ""  (
		echo.
		echo.   ERROR - bat_exedir not defined.  Try running from TestScript.bat. 
		echo.
		exit /b 1
	)

:CHECKHELP_END
goto :FTPHASH


        rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*

	set bat_returncode=0
	
        set bat_retval=
        set bat_hash=
        
        set bat_sourcefilefull=%~1
        set bat_sourcefile_name=%~nx1
        
        set bat_sourcedir=%~dp1::
        set bat_sourcedir=!bat_sourcedir:\::=!
        set bat_sourcedir=!bat_sourcedir:::=!
        
        set bat_targetfile_full=!bat_sourcedir!\!bat_sourcefile_name!.md5.txt

        if not exist "!bat_sourcefilefull!" (
                set bat_retval=1
                goto :FTPHASH_END
        )

	!bat_log! Current DIR before PUSHD=!CD!
	
	!bat_logexeclog! PUSHD "!bat_sourcedir!"
	
		!bat_log! Current DIR after PUSHD=!CD!


        !bat_logexeclog! call "!bat_exedir!\md5.exe" -o"!bat_targetfile_full!" "!bat_sourcefile_name!"
        set bat_retval=!bat_logexec_returncode!

	POPD
	
	!bat_log! Current DIR after POPD=!CD!
	
        
        if !bat_retval! equ 0 (
        		REM Now read the output file to obtain the hash string
                for /f "usebackq tokens=1*" %%X in ("!bat_targetfile_full!") do (
                        !bat_logexeclog! set bat_hash=%%X
                )
                
                if not defined bat_RetVal1 (
                        set bat_retval=3
                )
        ) else (
        	set bat_returncode=2
        	set bat_retval=2
        	
        	!bat_echolog!
        	!bat_echolog! `   ERROR [!bat_returncode!] - Failed: CALL "!bat_exedir!\md5.exe" -o"!bat_targetfile_full!" "!bat_sourcefilefull!"
        	!bat_echolog!
        	goto :FTPHASH_END
        )

%bat_COMMENT_BEGIN%
        if exist "!bat_targetfile_full!" (
                if defined bat_logdir (
                        !bat_logexeclog! del /q "!bat_targetfile_full!"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPHASH] Dangerous command: del /q "!bat_targetfile_full!"
                )
        )
%bat_COMMENT_END%

:FTPHASH_END
!bat_poplog!  [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
	!bat_log! ` ENDLOCAL & (
	!bat_log! ` 	SET bat_hash=%bat_hash%
	!bat_log! ` 	SET bat_retval=%bat_retval%
	!bat_log! ` 	)
	!bat_log! `exit /b !bat_retval!


ENDLOCAL & (

	SET bat_hash=%bat_hash%
	SET bat_retval=%bat_retval%
	)

!bat_return! !bat_retval!


	REM ###############################################################
	REM 
	REM

:HELP
	echo %~0      Batch Script
	echo.
	echo.Usage %~0 ^<file^>
	echo.
	echo.
	echo.
	echo.Expects to be called from an environment that has autocams.setup.bat and indent_setup.bat
	echo.environments set.  If you are running it standalone, you might be able to run it from
	echo.TestScript.bat.  
	echo.
	echo.Returns in ENDLOCAL bat_hash and bat_retval.  
	echo.
exit /b





