@echo off
setlocal enableextensions enabledelayedexpansion


	REM ########################################################################
:CHECKHELP
	rem CONSTANTS

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP


	REM ########################################################################
:SETUP



	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!



	set bat_returncode=99

	set bat_moveToTransmitted=true
	if /i "%~2" neq "" (
		set bat_zipfile=%~2
		set bat_zip=%~nx2
		set bat_moveToTransmitted=false
	)
	
	set bat_ftpfile=ftp.temp.txt

:SETUP_END
goto :MAIN







	REM ########################################################################
:MAIN
		REM %1 will likely be FTPTRANSFER
	call :%~1



:MAIN_END
GOTO :DONE





	REM ########################################################################
:FTPTRANSFER
!bat_pushecho! [CALL !bat_batchfile!:FTPTRANSFER
        set bat_retval=failed

                REM Part of the FTP transfer session uploads with a PUT and then
                REM immediately downloads with a GET.  The downloaded file is
                REM temporarily placed in the Temp dir, so the dir needs to be there.
        if not exist "!bat_camsdir!\Temp" (
                !bat_logexeclog! md "!bat_camsdir!\Temp"
        )

                REM Test the zip before uploaded to ensure that it's good...
        call :FTP_TESTZIP "!bat_zipfile!"
        if /i "!bat_returncode!" neq "0" (
        		set bat_returncode=11
                goto :FTPTRANSFER_END
        )

        !bat_echolog! Now get ready to upload the file and then download it to ".\Temp" to test it 
        !bat_echolog! for validity...
        !bat_echolog!
        
        	REM Do a DIR command so that the user can preview the size of the file...
        dir "!bat_zipfile!"|find /i ".zip"
        !bat_logexeclog! dir "!bat_zipfile!"
        
        
        	REM Now create the ftp command file that contains all the commands to execute after
        	REM connecting to the ftp server...
        !bat_pushecho!

set bat_ftp

                echo user !bat_ftpuser!>"!bat_ftpfile!"
                echo !bat_ftppassword!>>"!bat_ftpfile!"
                echo bin>>"!bat_ftpfile!"
                echo cd !bat_ftpdir!>>"!bat_ftpfile!"
                echo literal pasv>>"!bat_ftpfile!"
                echo put "!bat_zipfile!">>"!bat_ftpfile!"
                echo lcd "!bat_camsdir!\Temp">>!bat_ftpfile!"
                echo literal pasv>>"!bat_ftpfile!"
                echo ls "!bat_zip!">>!bat_ftpfile!"
                echo get "!bat_zip!">>!bat_ftpfile!"
                echo quit>>"!bat_ftpfile!"

					REM Display and log the new command file contents so that there is 
					REM a track record of what will be attempted...
                !bat_logexec! type "!bat_ftpfile!"
                           
                !bat_echolog! `..............................................
        !bat_popecho!

        if /i "!bat_SIMULATION.ftp!" equ "true" (
			!bat_pushecho! SIMULATION - 
				!bat_logexeclog! md "!bat_camsdir!\Temp\SimulatedFTP"
				!bat_logexeclog! copy /y "!bat_zipfile!" "!bat_camsdir!\Temp\SimulatedFTP"
				!bat_logexeclog! copy /y "!bat_camsdir!\Temp\SimulatedFTP\!bat_zip!" "!bat_camsdir!\Temp"
			!bat_popecho!
			set bat_returncode=0
        ) else (
        
				REM ================================================================
				REM Execute the FTP command file...
				REM 
				REM Remember, the FTP upload should always also have a download so
				REM that we can check and compare and validate. 
				REM 
        	!bat_pushecho! Execute the FTP command file...==========================

 
 					REM *************** TEMPORARY ************************
%BAT_COMMENT_BEGIN%
 !bat_WAIT! 6   "CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!"
 
				!bat_logexec! COPY /Y "!bat_zipfile!"   "!bat_camsdir!\Temp"
 						
				set bat_returncode=0
%BAT_COMMENT_END%
 					REM *************** TEMPORARY ************************

			!bat_logexec! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
			set bat_returncode=!bat_logexec_returncode!

                
				REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			!bat_popecho! ...DONE~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        )

        !bat_echolog!
        !bat_echolog! '    FTP exit code=!bat_returncode!
        !bat_echolog!

::CHECK_GET
		!bat_log! [!bat_batchfile!::CHECK_GET]
		
        if not exist "!bat_camsdir!\Temp\!bat_zip!" (
			!bat_log! [!bat_batchfile::CHECK_GET] if not exist "!bat_camsdir!\Temp\!bat_zip!" ...
        		set bat_returncode=12
                set bat_recent_error_msg=17.ERROR [!bat_returncode!] - Failed FTP upload of "!bat_zipfile!" - can't find it in "!bat_camsdir!\Temp".
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                !bat_echolog!
                goto :FTPTRANSFER_END
        ) else (
			!bat_log! [!bat_batchfile::CHECK_GET] if EXIST "!bat_camsdir!\Temp\!bat_zip!" ...
			
			
			
			!bat_CALL! "!bat_exedir!\FTPHASH.bat" "!bat_zipfile!"
			set bat_hash_before=!bat_hash!

				set bat_zip2=!bat_zip:"=!
				echo !bat_zip2!
				
			!bat_CALL! "!bat_exedir!\FTPHASH.bat" "!bat_camsdir!\Temp\!bat_zip!"
			set bat_hash_after=!bat_hash!

                if /i "!bat_hash_after!" neq "!bat_hash_before!" (
						set bat_returncode=13
                        set bat_recent_error_msg=17.FAILED [!bat_returncode!] - target is different from the source. Something went wrong between uploading the file and downloading it again to check.  The file exists on the FTP server, but when it is downloaded from the FTP server it is different from the original.
                        !bat_echolog!
                        !bat_echolog!
                        !bat_echolog! '    !bat_recent_error_msg!
                        !bat_echolog!
                        !bat_echolog!
                ) else (
                        set bat_recent_error_msg=17.SUCCESS - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
                        !bat_echolog!
                        !bat_echolog!
                        !bat_echolog! '    !bat_recent_error_msg!
                        !bat_echolog!
                        !bat_echolog!
                        !bat_logexeclog! set bat_moveToTransmitted=true
                )
                
                !bat_pushecho! Deleting the test download...
                if defined bat_camsdir (
                        !bat_logexec! del /q "!bat_camsdir!\Temp\!bat_zip!"
                ) else (
						set bat_returncode=14
                        !bat_echolog! ERROR [!bat_returncode!] [!bat_batchfile!:CHECK_GET] Dangerous command: del /q "!bat_camsdir!\Temp\!bat_zip!"
                )
                !bat_popecho!

                !bat_log! if /i "bat_moveToTransmitted=!bat_moveToTransmitted!" equ "true"...
				if           /i "!bat_moveToTransmitted!" equ "true" (
					!bat_CALL! "!bat_exedir!\MoveTransmit.bat" "!bat_zipfile!"
				)


                if /i "!bat_hash_after!" neq "!bat_hash_before!" (
        		set bat_returncode=15
                        goto :FTPTRANSFER_END
                )

                !bat_log!
                !bat_logexec! copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"

                set bat_retval=success
                set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                !bat_echolog!
        )

:FTPTRANSFER_END
!bat_poplog! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
!bat_return! !bat_returncode!





	REM ########################################################################
    REM Do an MD5 hash of the zip file for comparison
	REM ########################################################################
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
        set bat_retval=
        set bat_hash=

        if not exist "%~1" (
                set bat_retval=1
				!bat_echolog! "File does not exist"
                goto :FTPHASH_END
        )

        !bat_logexeclog! call md5 -o"!bat_camsdir!\Logs\md5.output.log" "%~1"
        set bat_retval=!bat_logexec_returncode!
        
        if !bat_retval! equ 0 (
                for /f "usebackq tokens=1,*" %%X in ("!bat_camsdir!\Logs\md5.output.log") do (
                        set bat_hash=%%X
                )
                
                if not defined bat_RetVal1 (
                        set bat_retval=3
                )
        )

        if exist "!bat_camsdir!\Logs\md5.output.log" (
                if defined bat_camsdir (
                        !bat_logexeclog! del /q "!bat_camsdir!\Logs\md5.output.log"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPHASH] Dangerous command: del /q "!bat_exedir!\Logs\md5.output.log"
                )
        )

:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!







	REM ########################################################################
:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

        !bat_echolog! 'Test the zip file before uploading to ensure that it's good.
        !bat_echolog! 'The test involves:
        !bat_echolog! '  - The zip file must exist;
        !bat_echolog! '  - The hash code must not be the empty zip file hash
        !bat_echolog! '    If so, the zip file will be deleted.
        !bat_echolog! '  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
        !bat_echolog! '    is cleaned out before unzipping]
        !bat_echolog! '  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
        !bat_echolog! '  - If there are no other errors, the test returns success

			REM The zip file must exist...
        if not exist "%~1" (
                set bat_returncode=98
                set bat_recent_error_msg=17.ERROR - Not found: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                goto :FTP_TESTZIP_END
        )

			REM The hash code must not be the empty zip file hash...
        call :FTPHASH "%~1"
        if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
                set bat_returncode=99
                set bat_retval=failed
                set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                
                if "%~1" neq "" (
                        !bat_logexec! del /q "%~1"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /q "%~1"
                )
                goto :FTP_TESTZIP_END
        ) else (
                !bat_echolog! '    not a blank zip file...
        )
        
			REM Clean out the temp target that we will zip to to avoid any problems...
        if exist "!bat_camsdir!\Temp\Zip" (
                !bat_log! // Cleaning up before unzipping...
                if defined bat_camsdir (
                        !bat_logexeclog! del /s /q "!bat_camsdir!\Temp\Zip"
                        !bat_logexeclog! rd /s /q "!bat_camsdir!\Temp\Zip"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPTESTZIP] Dangerous command: del /s /q "!bat_camsdir!\Temp\Zip"
                        !bat_pause!
                        exit /b -98
                )
        )

			REM Unzip the file to the temp dir and capture  the ERRORLEVEL return code
        !bat_log! // Unzip the file to "..\Temp\Zip" and check for errorlevel

        !bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_camsdir!\Temp\Zip" "%~1" "*.*"
        set bat_returncode=!bat_logexec_returncode!

			REM Clean up by removing the temp dir whether there was an error code or not...
        !bat_log! // Cleanup after unzipping...
        if exist "!bat_camsdir!\Temp\Zip" (
                if defined bat_camsdir (
                        !bat_logexeclog! del /s /q "!bat_camsdir!\Temp\Zip"
                        !bat_logexeclog! rd /s /q "!bat_camsdir!\Temp\Zip"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPTESTZIP] Dangerous command: del /s /q "!bat_camsdir!\Temp\Zip"
                        !bat_pause!
                        exit /b -98
                )
        )

			REM Compare the 
        !bat_log! // If the zip successfully unzipped without 7zip returning an error code, then its ok...
        if /i !bat_returncode! equ 0 (
                set bat_retval=success
                set bat_recent_error_msg=17.SUCCESS - Zip file is OK and ready to upload: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
        ) else (
                set bat_retval=failed
                set bat_recent_error_msg=17.ERROR - Corrupt zip file: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                goto :FTP_TESTZIP_END
        )

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
!bat_return!


	REM ########################################################################
:HELP
	echo.%~0 - Batch Script
	echo.
	echo.Usage: %~0 FTPTRANSFER ["bat_zipfile"]
	echo.
	echo.This script uploads the zip file named in the bat_zipfile variable.  It 
	echo.performs several checks to ensure that it is not uploaded unless it is 
	echo.a valid non-empty zip file.  
	echo.
	echo.This script was designed to be called by AutoCams.bat because it depends
	echo.on all the environment variables to be set.  However, you can try running
	echo.it from TestScript.bat
	echo.
	echo.The first argument FTPTRANSFER is the name of the subroutine to call when
	echo.the script starts.
	echo.
	echo.The second argument, bat_zipfile, is an optional argument.  It identifies
	echo.the fully qualified file name of the zip file to upload. 
	echo.
	echo.
exit /b 100


	REM ########################################################################
:DONE
exit /b !bat_returncode!

