@echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	if "%~1" equ "" goto :HELP

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	CALL "!bat_exedir!\ReadParams.bat"

		rem Get the bat_capturedfilesdir value
	call "!bat_exedir!\ReadConfig.bat"
	
	call "!bat_exedir!\ReadCams2Global.bat"

	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_log! set bat_boards_max=!bat_boards_max!

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	!bat_logexeclog! set bat_ftpfile2=!bat_exedir!\ftp.temp2.txt
	!bat_logexeclog! set bat_ftpfile3=!bat_exedir!\ftp.temp3.txt

	!bat_logexeclog! set bat_winscpfile=!bat_exedir!\winscp.ftp.temp.txt
	
		rem bat_zipfilename=2017_12_24_000525_01_28_10_01.zip
		rem All these files exist under the queue dir
	!bat_logexeclog! set bat_zipfilename=%~1
	!bat_logexeclog! set bat_zipfilefull=%~1
	!bat_logexeclog! set bat_zipfile=%~1
	!bat_logexeclog! set bat_zipfile_name=%~nx1
	!bat_logexeclog! set bat_zipfile_ext=%~x1
		set bat_zipfiledir=%~dp1::
		set bat_zipfiledir=!bat_zipfiledir:\::=!
	set bat_zipfiledir=!bat_zipfiledir:::=!
	
rem	!bat_logexeclog! set bat_ftpfile2=!bat_CAMS2QUEUE.queue_dir!\Temp\ftp.temp_ls.txt
rem	!bat_logexeclog! set bat_ftpfile3=!bat_CAMS2QUEUE.queue_dir!\Temp\ftp.temp_ls2.txt

	if /i "!bat_zipfile_ext!" neq ".zip" (
		!bat_logexeclog! set bat_ziptype=-tzip.split
	) else (
		!bat_logexeclog! set bat_ziptype=-tzip
	)
	
	
	
goto :MAIN %*





	REM #########################################################################
	REM This script is designed to work from the RunFolder dir. "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\"
	REM
	REM Technically, it should work from any directory, but it is designed to use 
	REM the Queue directory and temporary directories from the queue dir for validity
	REM checks and so forth. 
	REM 


:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %1    %2
!bat_TITLE! [GOTO !bat_batchfile!:MAIN] %1    %2

	if /i "!bat_CAMS2UPLOAD.sequence!" equ "true" (
		rem	Test if the file exists on the server for the purpose of 
		rem 	determining if the file needs to be sequenced before uploading.
		CALL :CHECK_EXIST_ON_SERVER "!bat_zipfilefull!"
		set bat_returncode=!errorlevel!

rem !bat_pause! after CALL :CHECK_EXIST_ON_SERVER_END
		if "!bat_returncode!" neq "0" goto :MAIN_END

	)


	rem     1. Make a "!bat_camsdir!\Temp" dir if it doesn't already exist. :MAKETEMPDIR
	CALL :MAKETEMPDIR "!bat_zipfilefull!"

	rem     2. Test the ZIP by unzipping it to the Temp dir and checking the return code	:TESTZIP
	CALL :TESTZIP "!bat_zipfilefull!"
		rem At this point, a new zip file creation should be triggered.
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     2a. Check the Totals file this month.  Skip uploading this file if the size of the new zip is larger than
	rem         the monthly alottment, if !bat_CAMS2LIMITS.enabled!=true
	CALL :CHECKTOTALSFILE
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     3. Create the command file [!bat_ftpfile!].  It should include the upload for just the ZIP but not the download. :CREATEUPLOADCMDFILE
	CALL :CREATEUPLOADCMDFILE "!bat_zipfilefull!"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     4. Execute the command to upload the ZIP	:UPLOADFILE
	CALL :UPLOADFILE "!bat_zipfilefull!"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     5. Create the download command file for downloading the ZIP file back to the Temp dir. 	:CREATEDOWNLOADCMDFILE
	CALL :CREATEDOWNLOADCMDFILE "!bat_zipfilefull!"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     6. Execute the command to download the ZIP to the Temp dir	:DOWNLOADTOTEMP
	CALL :DOWNLOADTOTEMP "!bat_zipfilefull!"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     7. Check to try to validate the ZIP file downloaded is the same as the one uploaded	:VALIDATEZIP
		rem         - It should exist
		rem         - Try to unzip the temp\*zip* file to the Temp\ziptest dir and check the return code
		rem         - Get the hash of the temp\*zip* file
		rem         - Compare the HASH values

		rem     If any of this fails, wait the !bat_CAMS2UPLOAD.retry_delay! time and retry starting at [3]. 
	CALL :VALIDATEZIP "!bat_zipfilefull!"
	if "!bat_returncode!" neq "0" goto :MAIN_END
	


	rem Repeat all these step for the MD5 file:
	rem     21. Create the command file [!bat_ftpfile!].  It can include the upload AND download of the MD5 file back to the Temp dir. 	:CREATEUPLOADCMDFILE
	CALL :CREATEUPLOADCMDFILE "!bat_zipfilefull!.md5.txt"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     22. Execute the upload/download command file 	:UPLOADFILE
	CALL :UPLOADFILE "!bat_zipfilefull!.md5.txt"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     23. Compare the original MD5 file and the Temp\MD5 file		:COMPAREMD5
	CALL :COMPAREMD5 "!bat_zipfilefull!.md5.txt"    "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     23b. Hash the returned zip file and compare the md5 files
	

	rem     24. If anything fails, start over at 21.	

	rem     25. Delete the ..\Temp\*zip* file and the MD5 file and cleanup		:CLEANUPTEMP
	CALL :CLEANUPTEMP "!bat_zipfilefull!
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     26. MOVE the zip file and its MD5 file to the Transmitted dir		:MOVETOTRANSMITTED
	CALL :MOVETOTRANSMITTED "!bat_zipfilefull!"   "!bat_zipfilefull!.md5.txt"
	if "!bat_returncode!" neq "0" goto :MAIN_END

	rem     27. Exit with success/fail error code.

	
:MAIN_END
!bat_poplog! [:MAIN_END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:MAIN_END
!bat_TITLE! - %~nx0
goto :DONE






	REM #########################################################################
	REM CHECK_EXIST_ON_SERVER - 
	REM Uses the "ftp.temp3.txt" file, which is an already downloaded list of all files on the server,
	REM to determine if the current file should be uploaded.  It also performs
	REM the file sequencing if that INI file setting is enabled. 
	REM
	REM 2017_12_10_000525_06_29_10_01.zip if exists, transforms to:
	REM 2017_12_10_000525_06_29_10_02.zip
	REM
	REM 2017_12_10_000525_06_29_10_01.zip.001 if exists, transforms to:
	REM 2017_12_10_000525_06_29_10_02.zip.001
	REM
	REM See ftp_upload_seti.bat for example
	REM
	REM Dave: Make sure you accommodate: 
	REM [CAMS2UPLOAD]
	REM overwrite_enabled=true
	REM delete_enabled=true
	REM sequence=true
	REM
	REM Returns:
	REM    bat_returncode              0=go ahead and upload it
	REM                                All other values means skip the file 
	REM
	
:CHECK_EXIST_ON_SERVER [IN] "!bat_zipfilefull!"
!bat_pushlog! [CALL !bat_batchfile!:CHECK_EXIST_ON_SERVER]  %1
!bat_TITLE! [!bat_batchfile!:CHECK_EXIST_ON_SERVER]  %1

rem setlocal enableextensions enabledelayedexpansion

	set bat_tempzipfilefull=%~1&				rem D:\cams2_queue\2017_12_10_000525_06_29_10_01.zip

	set bat_tempzipfiledir=!bat_zipfiledir!&	rem D:\cams2_queue
	set bat_tempzipfile_name=%~nx1&				rem 2017_12_10_000525_06_29_10_01.zip
	set bat_tempzipfile_nameonly=%~n1&			rem 2017_12_10_000525_06_29_10_01
	if /i "!bat_tempzipfile_nameonly:~-4!" equ ".zip" (
		set bat_tempzipfile_nameonly=!bat_tempzipfile_nameonly:~0,-4!
	)
	
	set bat_tempzipfile_ext=!bat_tempzipfile_name:~-8!
	if /i "!bat_tempzipfile_ext:~0,5!" equ ".zip." (
		!bat_logexec! set bat_tempzipfile_ext=!bat_tempzipfile_ext:~1!&	rem zip.001
	) else (
		!bat_logexec! set bat_tempzipfile_ext=!bat_tempzipfile_name:~-3!&	rem zip
	)
	echo.********** bat_tempzipfile_ext=!bat_tempzipfile_ext!
	
	
	set bat_tempzipfile_nameroot=!bat_tempzipfile_nameonly:~0,-3!&	rem 2017_12_10_000525_06_29_10
	
	set bat_tempmd5filefull=%~1.md5.txt&			rem D:\cams2_queue\2017_12_10_000525_06_29_10_01.zip.md5.txt
	set bat_tempmd5file_name=%~nx1.md5.txt&			rem 2017_12_10_000525_06_29_10_01.zip.md5.txt
	
	set bat_tempcaptureddate=!bat_tempzipfile_nameonly:~0,10!&	rem 2017_12_10
	set bat_tempcapturedtime=!bat_tempzipfile_nameonly:~18,8!&	rem 06_29_10
	set bat_temp_camera=!bat_tempzipfile_nameonly:~11,6!&		rem 000525
	set bat_temp_capturesession=!bat_tempcaptureddate!_!bat_tempcapturedtime!
	set bat_temp_submissionsession=!bat_tempcaptureddate!_!bat_temp_camera!_!bat_tempcapturedtime!

	set /a bat_temp2counter=1



	REM ***************************************************************************
	REM This section is a loop that performs the sequencing.  
	REM
	REM See "!bat_CAMS2UPLOAD.sequence!"
	REM
	REM If a matching file is found in certain various locations, then it either 
	REM needs to be sequenced or skipped. 
	REM
	
:CHECK_EXIST_ON_SERVER2
!bat_log! [!bat_batchfile!:CHECK_EXIST_ON_SERVER2]  %1

	!bat_logexeclog! set bat_temp2zipname=!bat_temp_submissionsession!

	                 set bat_temp2counter_str=00!bat_temp2counter!
	!bat_logexeclog! set bat_temp2counter_str=!bat_temp2counter_str:~-2!

	!bat_logexeclog! set bat_temp2zipfilename=!bat_temp2zipname!_!bat_temp2counter_str!.!bat_tempzipfile_ext!
	!bat_logexeclog! set bat_temp2zipfilefull=!bat_tempzipfiledir!\!bat_temp2zipfilename!

	!bat_echolog! set bat_temp2zipfilefull=!bat_temp2zipfilefull!
rem !bat_pause! 	set bat_temp2zipfilefull=!bat_tempzipfiledir!\!bat_temp2zipfilename!

		!bat_logexeclog! MOVE /Y "!bat_tempzipfilefull!"           "!bat_temp2zipfilefull!"
		!bat_logexeclog! MOVE /Y "!bat_tempzipfilefull!.md5.txt"   "!bat_temp2zipfilefull!.md5.txt"

	!bat_logexeclog! set bat_tempzipfilefull=!bat_temp2zipfilefull!
	!bat_logexeclog! set bat_tempzipfile_name=!bat_temp2zipfilename!
	!bat_logexeclog! set bat_tempzipfile_nameonly=!bat_temp2zipname!_!bat_temp2counter_str!
	
	!bat_logexeclog! set bat_tempmd5file_name=!bat_temp2zipfilename!.md5.txt
	!bat_logexeclog! set bat_tempmd5filefull=!bat_temp2zipfilefull!.md5.txt
	
	!bat_logexeclog! set bat_zipfilefull=!bat_temp2zipfilefull!
	!bat_logexeclog! set bat_zipfilename=!bat_temp2zipfilefull!
	!bat_logexeclog! set bat_zipfile=!bat_temp2zipfilefull!
	!bat_logexeclog! set bat_zipfile_name=!bat_temp2zipfilename!
	

	set /a bat_found=0
	
		REM Skip uploading this file if it's already in the Transmitted dir
	!bat_log! dir /b "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_temp2zipfilename!.md5.txt" 
	(         dir /b "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_temp2zipfilename!.md5.txt" >nul: 2>&1) && (
		set /a bat_found+=1
	) || (
		!bat_log! ` *** NOT FOUND *** "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_temp2zipfilename!.md5.txt"
	)
	
rem	(dir /b "!bat_CAMS2QUEUE.queue_dir!\!bat_temp2zipfilename!.md5.txt!" >nul: 2>&1) && (
rem		set /a bat_found+=1
rem	)

		rem If the files are still in Submitted, it can't really upload them from there.
		rem So, let the next time ZipCams2FromFTP runs to fix that.
		
rem	(dir /b "!bat_camsdir!\Submitted\!bat_temp2zipfilename!.md5.txt!" >nul: 2>&1) && (
rem		set /a bat_found+=1
rem	)

	
	!bat_echolog! bat_found=!bat_found! =====================================

	if /i "!bat_found!" GTR "0" (
	
		!bat_echolog! ***********  Already exists: "!bat_temp2zipfilefull!"

		set /a bat_temp2counter+=1

		goto :CHECK_EXIST_ON_SERVER2
	)

	if /i "!bat_CAMS2UPLOAD.sequence!" equ "true" (
	
rem !bat_pause! if /i "!bat_CAMS2UPLOAD.sequence!" equ "true" type "!bat_ftpfile3!":

		for /f "usebackq tokens=*" %%a in (`type "!bat_ftpfile3!"`) do (
			if /i "%%a" equ "!bat_temp2zipfilename!" (
				
				!bat_echolog! ***********  Already exists: "!bat_temp2zipfilefull!"

				set /a bat_temp2counter+=1
				
				!bat_echolog! set /a bat_temp2counter+=1=!bat_temp2counter!

				goto :CHECK_EXIST_ON_SERVER2
			)
		)
	)

	
	if /i "!bat_returncode!" equ "2" (
		!bat_logexec! set !bat_temp2zipfilename!=!bat_tempfile_name!
		set bat_returncode=0&	rem Signal to keep going and upload.
	)
	


:CHECK_EXIST_ON_SERVER_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_EXIST_ON_SERVER_END] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:CHECK_EXIST_ON_SERVER_END_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!







	REM #########################################################################
	REM Test if the file exists on the server for the purpose of 	:TEST_EXIST_ON_SERVER    :TESTEXISTONSERVER
	REM determining if the file needs to be sequenced before uploading.
	REM
	REM     Can be used for any file.
	REM
	REM At this point, we're done checking if the file exists in any of the local
	REM locations.  Now this TEST_MD5_ONSERVER routine will check for a match
	REM on the SERVER. 
	REM
	REM If it exists on the server and !bat_CAMS2UPLOAD.sequence!=true, then
	REM if needs to increment the sequence number.  
	REM
	REM bat_returncode=0 means to skip this file. 
	REM
	REM Returns:
	REM    bat_returncode              2=means to go ahead and upload the file
	REM                                0=Skip the file and don't upload it. 
	REM                                1=error, so skip the file. 
	REM Uses "!bat_ftpfile2!".  
	REM Uses "!bat_ftpfile3!".  
	REM

:TEST_MD5_ONSERVER [IN] "file name"
!bat_pushecho! [CALL !bat_batchfile!:TEST_MD5_ONSERVER] %1
!bat_TITLE! [!bat_batchfile!:TEST_MD5_ONSERVER] %1

	set bat_returncode=1
	
	set bat_tempfilename=%~1
	set bat_tempfile_name=%~nx1


:TEST_MD5_ONSERVER_10

	if exist "!bat_ftpfile2!" (
		DEL /Q "!bat_ftpfile2!"
		if !errorlevel! neq 0 (
			!bat_WAIT! 5   "ERROR - Can't delete.  Retrying in..."
			goto :TEST_MD5_ONSERVER_10
		)
	)

	!bat_echolog!
	!bat_echolog! Now download a LIST of files using the "ls" FTP command file "!bat_ftpfile!"...
	!bat_echolog! and save the results into "!bat_ftpfile2!"
	!bat_pushecho!
	!bat_log! '    Note: Building the command file: "!bat_ftpfile!" 
	
									echo user !bat_ftpuser!>"!bat_ftpfile!"
									echo !bat_ftppassword!>>"!bat_ftpfile!"
									echo bin>>"!bat_ftpfile!"

									echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>!bat_ftpfile!"
									echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_ftpfile!"
									echo literal pasv>>"!bat_ftpfile!"

									echo dir "!bat_tempfile_name!.md5.txt">>!bat_ftpfile!"
									echo quit>>"!bat_ftpfile!"

									!bat_logexec! type "!bat_ftpfile!"

		if not exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
			MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
		)

			!bat_echolog!
			!bat_echolog!


			echo open ftp://!bat_ftpuser!:!bat_ftppassword!@!bat_ftpsite!>"!bat_winscpfile!"
			echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_winscpfile!"
			echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>"!bat_winscpfile!"
			echo stat "!bat_tempfile_name!.md5.txt">>"!bat_winscpfile!"
			echo bye>>"!bat_winscpfile!"

			!bat_logexec! type "!bat_winscpfile!"

		if exist "!bat_ftpfile2!" (
			!bat_logexeclog! DEL /Q "!bat_ftpfile2!" 
		)

		set bat_size_server=
		set bat_temp=
		
			rem EXECUTE the FTP ls/dir listing and read the outcome, scanning for a line that contains
			rem the file name along with "-rw-", which is the one that has the file size on the server. 
			rem
			rem I had to come up with a workaround for a silly problem where the 
			rem creation of the listing file has 0D 0D 0A instead of 0D 0A.
			rem Therefore, I had to use a delimited file using exclamation point as the delimiter...
			rem The outcome of  this file is the "!bat_ftpfile2!". 
			
		!bat_log! call "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"][find /i "!bat_tempfile_name!"][findstr /i /c:"-rw" }"!bat_exedir!\winscp.temp2.txt"
		call           "!bat_exedir!\winscp.com" /script="!bat_winscpfile!" |find /i "!bat_tempfile_name!" |findstr /i /c:"-rw"> "!bat_exedir!\winscp.temp2.txt"
			
rem		!bat_pushecho! for  /f "usebackq tokens=5-10*" ..a in ^(`call FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!][find /i "!bat_tempfile_name!"[]findstr /i /c:"-rw"`^) do ^(
rem		for                 /f "usebackq tokens=5-10*" %%a in  (`call FTP -n -s:"!bat_ftpfile!"  !bat_ftpsite!^|find /i "!bat_tempfile_name!"^|findstr /i /c:"-rw"`) do (
		!bat_pushecho! for  /f "usebackq tokens=1-10*" ..a in ^(`type "!bat_exedir!\winscp.temp2.txt"`^) do ^(
		for                 /f "usebackq tokens=1-10*" %%a in  (`type "!bat_exedir!\winscp.temp2.txt"`) do (

			set bat_size_server=%%e
			set bat_temp=%%j
			
rem			set bat_temp=%%e
rem			!bat_logexec! set bat_temp=!bat_temp:~0,-1!
rem								echo.!bat_temp!^^!>>"!bat_ftpfile2!"
			!bat_echolog! bat_temp=!bat_temp!, bat_size_server=!bat_size_server!
			
			echo.!bat_temp!>>"!bat_ftpfile2!"
		)
		!bat_popecho! ^)
		
			rem If the file didn't get created, then it doesn't exist on the server, which is what we are looking for...  
		if not exist "!bat_ftpfile2!" (
			!bat_echolog!
			!bat_echolog! No matching files on server: "!bat_tempfile_name!"
			!bat_echolog!     *** IT IS SAFE TO UPLOAD THIS FILE***
			!bat_echolog!
			set bat_returncode=2
rem !bat_pop! ^)
			goto :TEST_MD5_ONSERVER_END
		)

			rem cleanup
		if exist "!bat_ftpfile3!" (
			!bat_logexeclog! DEL /Q "!bat_ftpfile3!"
		)

			rem Display the file[s] that exist...
			
		!bat_pushecho! for /f "usebackq" ..a in ^("!bat_ftpfile2!"^) do ^(
		for                /f "usebackq" %%a in  ("!bat_ftpfile2!") do (
			!bat_echolog! %%a
		)
		!bat_popecho!
		
			rem Since the file was found, we signal to skip uploading it.
		set bat_returncode=0

	!bat_popecho!


:TEST_MD5_ONSERVER_END
!bat_poplog! [RETURN !bat_batchfile!:TEST_MD5_ONSERVER] [bat_returncode=!bat_returncode!, bat_size_server=!bat_size_server!, bat_tempfile_name=!bat_tempfile_name!]
!bat_log!
rem !bat_WAIT! 0	:TEST_MD5_ONSERVER_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!







	REM #########################################################################
	REM 1. Make a "!bat_camsdir!\Temp" dir if it doesn't already exist. :MAKETEMPDIR
	REM
	REM Also need to make a ..\Temp\Zip dir, which is deleted first before using it. 
	REM
	REM This ..\Temp dir will be the base directory for all the testing.  

:MAKETEMPDIR [in] "!bat_zipfilefull!"
!bat_pushlog! [CALL !bat_batchfile!:MAKETEMPDIR] %1
!bat_TITLE! [!bat_batchfile!:MAKETEMPDIR]  %1

	set bat_returncode=0

	if exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
		!bat_logexec! DEL /Q /S "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip\*.*"
		!bat_logexec! RD  /Q /S "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip"
	)
	
	!bat_logexec! MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
	set bat_returncode=!errorlevel!

:MAKETEMPDIR_END
!bat_poplog! [RETURN !bat_batchfile!:MAKETEMPDIR] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:MAKETEMPDIR_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!




	REM #########################################################################
	REM 2. Test the original ZIP by unzipping it to the Temp dir and checking the return code	:TESTZIP
	REM
	REM Returns:
	REM    bat_returncode              0=ok.  All other values means fail - don't attempt to upload it. 
	REM
	REM Question remains - what to do with the bad zip file?  At this point, a new one needs to be created...

:TESTZIP [in] "!bat_zipfilefull!"
!bat_pushlog! [CALL !bat_batchfile!:TESTZIP]  %1
!bat_TITLE! [!bat_batchfile!:TESTZIP]  %1
	set bat_returncode=1
	
	set bat_tempfilename=%~1


		REM ***********************************
		REM Unzip the zip file using 7zip and capture the exit code. Can't test a single split zip sequence file without the other files.
		
	if /i "!bat_zipfile_ext!" equ ".zip" (
		!bat_logexeclog! "!bat_exedir!\7za.exe" x !bat_ziptype! -y  -r   "!bat_tempfilename!" "-o"!bat_CAMS2QUEUE.queue_dir!\Temp\zip\test""   *
		set bat_returncode=!errorlevel!
		
			REM Whether it succeeds or not, cleanup the unzipped info.  
		if exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
			!bat_logexec! DEL /Q /S "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\*.*"
			!bat_logexec! RD  /Q /S "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
			!bat_logexec! MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:TESTZIP] Dangerous command: del /s /q "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\*.*"
			!bat_WAIT! 60     "!bat_batchfile!:TESTZIP"

			set bat_returncode=3
			goto :TESTZIP_END
		)
	) else (
		!bat_echolog! `        Can't test a single split zip sequence file without the other files.
		set bat_returncode=0
	)
	

:TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:TESTZIP] [bat_returncode=!bat_returncode!, 
!bat_log! `                            target="!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_tempfilename!,
!bat_log! `                            targetdir="!bat_CAMS2QUEUE.queue_dir!\Temp\zip\test"]
!bat_log!
rem !bat_WAIT! 0	:TESTZIP_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!





	REM #########################################################################
	REM 2a. CHECKTOTALSFILE
	REM
	REM Check the Totals file this month.  Skip this file if the size of the new zip is larger than
	REM the monthly alottment, if !bat_CAMS2LIMITS.enabled!=true
	REM
	REM [CAMS2LIMITS]
	REM enabled=true
	REM MaxBytesPerMonth=1073741824
	REM TotalsFile=d:\cams2_queue\BytesThisBillingCycle.txt
	REM
	REM The totals file is a file in the queue dir that keeps track of how many bytes are transmitted
	REM in a calendar month.  The 
	REM
	REM This [CAMS2LIMITS] section is to govern the amount of data that can be sent
	REM per billing period.  It should reset on the same day of each
	REM month.  The totals are stored in the TotalsFile.  
	REM 
	REM If "enabled"=false, then these options and limits will not be used. 
	REM 
	REM This was designed to support limited wireless carrier data plans so
	REM that they don't accidentally overrun their limits.  It will not tally
	REM uploads that are done manually.  Nor will it tally data used against the
	REM plan for other uses, such as remote sessions.  
	REM 
	REM Use the FTP dir command to get the bytes actually transferred. 
	REM The format of the BytesThisBillingCycle.txt will be:
	REM    MM=bytes
	REM where: MM is the month the bytes pertain to.  If the current month
	REM        is different, then move the file to BytesThisBillingCycle.MM.txt so that
	REM        it is circular and the records can be available. 

:CHECKTOTALSFILE
!bat_pushlog! [CALL !bat_batchfile!:CHECKTOTALSFILE] %1
!bat_TITLE! [!bat_batchfile!:CHECKTOTALSFILE] %1

	set bat_returncode=0
	
	if not defined bat_CAMS2LIMITS.enabled (goto :CHECKTOTALSFILE_END)
	if "!bat_CAMS2LIMITS.enabled!" equ "false" (goto :CHECKTOTALSFILE_END)

	!bat_CALL! "!bat_exedir!\GetDate2.bat"&	REM returns bat_currmm
	!bat_echolog! bat_currmm=!bat_currmm!
	
	if not exist "!bat_CAMS2LIMITS.TotalsFile!" (
		echo.!bat_currmm!=0>"!bat_CAMS2LIMITS.TotalsFile!"
	) else (
		(FIND /i "!bat_currmm!=" "!bat_CAMS2LIMITS.TotalsFile!" >nul: 2>&1) && (

			set bat_currentBytesTotal=0
			
			REM Current month is in the file
			for /f "usebackq tokens=2 delims== skip=2" %%a in (`FIND /i "!bat_currmm!="  "!bat_CAMS2LIMITS.TotalsFile!"`) do (
echo.%%a			
				!bat_logexeclog! set bat_currentBytesTotal=%%a
			)

			if not defined bat_currentBytesTotal (
				set bat_returncode=1
				goto :CHECKTOTALSFILE_END
			)


				REM Decide whether to skip uploading this file because of upload limits...
				REM This uses a workaround of a problem with Batch numbers... they can't
				REM exceed 99,999,999.  Therefore, we will subtract the MaxBytesPerMonth from 
				REM the CurrentBytesTotal.  If the first digit of the result is "-", then
				REM it's negative and you've gone over the max.
				
			!bat_CALL! "!bat_exedir!\str_math.bat" !bat_CAMS2LIMITS.MaxBytesPerMonth! - !bat_currentBytesTotal!
			!bat_log! !bat_CAMS2LIMITS.MaxBytesPerMonth! - !bat_currentBytesTotal! = !bat_RetVal!

				REM If the subtraction results in a negative, then skip uploading this file. 
			if /i "!bat_RetVal:~0,1!" EQU "-" (
				REM You are over the limits, so we have to skip this file. 
				
				set bat_returncode=2
				!bat_echolog!
				!bat_echolog! `   ERROR [!bat_returncode!] - You have exceeded the [CAMS2LIMITS].MaxBytesPerMonth=!bat_CAMS2LIMITS.MaxBytesPerMonth! limit.
				!bat_echolog! `                              The current total is bat_currentBytesTotal=!bat_currentBytesTotal!.
				!bat_echolog!
				!bat_echolog! `                              The setting is in the "Cams2Global.ini" file [CAMS2LIMITS].MaxBytesPerMonth value.
				!bat_echolog!
				goto :CHECKTOTALSFILE_END
			)
		) || (

			REM Current month is NOT in the file
			echo.!bat_currmm!=0>>"!bat_CAMS2LIMITS.TotalsFile!"
		)
	)&	rem else

:CHECKTOTALSFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CHECKTOTALSFILE] [bat_returncode=!bat_returncode!, 
!bat_log! `                            bat_CAMS2LIMITS.enabled="!bat_CAMS2LIMITS.enabled!",
!bat_log! `                            bat_CAMS2LIMITS.TotalsFile="!bat_CAMS2LIMITS.TotalsFile!",
!bat_log! `                            bat_CAMS2LIMITS.MaxBytesPerMonth="!bat_CAMS2LIMITS.MaxBytesPerMonth!"
!bat_log! `                            bat_currentBytesTotal=!bat_currentBytesTotal!]
!bat_log!
rem !bat_WAIT! 0	:CHECKTOTALSFILE_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!








	REM #########################################################################
	REM 3. Create the command file [!bat_ftpfile!].  It should include the upload for 
	REM    just the ZIP but not the download. :CREATEUPLOADCMDFILE
	REM
	REM This routine is coded to create the command file to upload the specified file 
	REM ONLY from the "queue" dir. 
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail - the ftp.temp.txt file couldn't be created. 
	REM
	
:CREATEUPLOADCMDFILE [in] "!bat_zipfilefull!"
!bat_pushlog! [CALL !bat_batchfile!:CREATEUPLOADCMDFILE]  %1
!bat_TITLE! [!bat_batchfile!:CREATEUPLOADCMDFILE]  %1

	set bat_returncode=1
	
	set bat_tempfilename=%~1
	set bat_tempfile=%~nx1
	
	set bat_lcd=%~dp1::
	set bat_lcd=!bat_lcd:\::=!
	set bat_lcd=!bat_lcd:::=!

:CREATEUPLOADCMDFILE_10
	if exist "!bat_ftpfile2!" (
		DEL /Q "!bat_ftpfile2!"
		if !errorlevel! neq 0 (
			!bat_WAIT! 5   "ERROR - Can't delete "!bat_ftpfile2!".  Retrying in 5 seconds..."
			goto :CREATEUPLOADCMDFILE_10
		)
	)

        !bat_echolog! Now upload the "!bat_tempfilename!" file to the "!bat_ftpdir!" folder on the "!bat_ftpsite!" server...
        !bat_pushecho!

%BAT_COMMENT_BEGIN%
								echo user !bat_ftpuser!>"!bat_ftpfile!"
								echo !bat_ftppassword!>>"!bat_ftpfile!"
								echo bin>>"!bat_ftpfile!"
								echo lcd "!bat_lcd!">>"!bat_ftpfile!"
								echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_ftpfile!"
								echo literal pasv>>"!bat_ftpfile!"

								echo put "!bat_tempfile!">>"!bat_ftpfile!"

								echo quit>>"!bat_ftpfile!"

								!bat_logexec! type "!bat_ftpfile!"

%BAT_COMMENT_END%

		if not exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
			MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
		)



			!bat_echolog!
			!bat_echolog!


			echo open ftp://!bat_ftpuser!:!bat_ftppassword!@!bat_ftpsite!>"!bat_winscpfile!"
			echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_winscpfile!"
			echo lcd "!bat_lcd!">>"!bat_winscpfile!"
			echo put -transfer=binary  "!bat_tempfile!">>"!bat_winscpfile!"
			
			!bat_logexeclog! set bat_ctl_file=!bat_tempfile:~0,-4!.ctl.txt
			
			!bat_echolog! if /i "!bat_tempfile:~-4!" equ ".001"   ========= "!bat_ctl_file!"

			if /i "!bat_tempfile:~-4!" equ ".001" (
			
				!bat_echolog! if exist "!bat_CAMS2QUEUE.queue_dir!\!bat_ctl_file!"
				if exist "!bat_CAMS2QUEUE.queue_dir!\!bat_ctl_file!" (

					echo put -transfer=binary  "!bat_ctl_file!">>"!bat_winscpfile!"

				)
			)

			echo bye>>"!bat_winscpfile!"

			!bat_logexec! type "!bat_winscpfile!"

		!bat_echolog! '..............................................
        !bat_popecho!

	set bat_returncode=0

:CREATEUPLOADCMDFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CREATEUPLOADCMDFILE] [bat_returncode=!bat_returncode!, output=!bat_ftpfile!]
!bat_log!
rem !bat_WAIT! 0	:CREATEUPLOADCMDFILE_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 4. Execute the command to upload the ZIP	:UPLOADFILE
	REM
	REM Essentially, this routine is designed only to execute the bat_ftpfile command. 
	REM Then it tests if it exists on the server.  If it does not exist on the server,
	REM then it continues to retry until it succeeds or it's terminated. 
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means failed create a file on the 
	REM                                server with the same name or couldn't  connect to
	REM                                the server to check if the file exists. 
	REM

:UPLOADFILE [IN "!bat_zipfilefull!"]
!bat_pushlog! [CALL !bat_batchfile!:UPLOADFILE]  %1
!bat_TITLE! [!bat_batchfile!:UPLOADFILE]  %1

	set bat_returncode=0
	
	!bat_logexeclog! set bat_tempfilename=%~1


	!bat_logexec! type "!bat_winscpfile!"


rem	!bat_echolog! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
rem	!bat_logexec! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!

	!bat_echolog!  "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"
	!bat_logexec!  "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"
	set bat_returncode=!bat_logexec_returncode!

	!bat_WAIT! 10 [!bat_batchfile:UPLOADFILE][!bat_returncode!] "!bat_winscpfile!"
rem !bat_pause! 10 [!bat_batchfile:UPLOADFILE][!bat_returncode!] "!bat_winscpfile!"
	
	CALL :TESTEXISTONSERVER "!bat_tempfilename!"
	set bat_returncode=%errorlevel%
	
	if "!bat_returncode!" neq "0" (
		set bat_returncode=1
		!bat_echolog! `     ERROR [!bat_returncode!] - FTP failed to upload the file "!bat_tempfilename!".  
		goto :UPLOADZIP_END
	)
	
	!bat_echolog!
	!bat_echolog! ` The file should be uploaded "!bat_tempfilename!"

:UPLOADFILE_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADFILE] [bat_returncode=!bat_returncode!, bat_tempfilename="!bat_tempfilename!"]
!bat_log!
rem !bat_WAIT! 0	:UPLOADFILE_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!







	REM #########################################################################
	REM 4a. Test if the file exists on the server. 	:TEST_EXIST_ON_SERVER    :TESTEXISTONSERVER
	REM
	REM     Can be used for any file.
	REM
	REM If, after uploading to the server, if we can't find it, then the upload failed. 
	REM If, after uploading to the server, we CAN find it, it still may have failed, so more testing is required. 
	REM
	REM This routine should also update the !bat_CAMS2LIMITS.TotalsFile! [BytesThisBillingCycle.txt].  
	REM The totals file has a value in it: MM=bytes, where MM equals the calendar month those 
	REM totals pertain to.  When the MM does not match the current month, then the totals file gets
	REM moved to BytesThisBillingCycle.MM.txt so that it is circular and the records can be available, 
	REM and a new totals file is created with the new bytes.
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means failed to find the file on the server. 
	REM Uses "!bat_ftpfile2!".  
	REM Uses "!bat_ftpfile3!".  
	REM

:TESTEXISTONSERVER [IN] "file name"
!bat_pushlog! [CALL !bat_batchfile!:TESTEXISTONSERVER] %1
!bat_TITLE! [!bat_batchfile!:TESTEXISTONSERVER] %1

	set bat_returncode=1
	
	set bat_tempfilename=%~1
	set bat_tempfile_name=%~nx1


:TESTEXISTONSERVER_10

	echo."!bat_ftpfile2!"
	if exist "!bat_ftpfile2!" (
		DEL /Q "!bat_ftpfile2!"
		if !errorlevel! neq 0 (
			!bat_WAIT! 5   "ERROR - Can't delete.  Retrying in..."
			goto :TESTEXISTONSERVER_10
		)
	)

	!bat_echolog!
	!bat_echolog! Test if "!bat_tempfilename!" exists on the server.
	!bat_echolog! Now download a LIST of files using the "ls" FTP command file "!bat_ftpfile!"...
	!bat_echolog! and save the results into "!bat_ftpfile2!"
	!bat_pushecho!
	!bat_log! `    Note: Building the command file: "!bat_ftpfile!" 
	
										echo user !bat_ftpuser!>"!bat_ftpfile!"
										echo !bat_ftppassword!>>"!bat_ftpfile!"
										echo bin>>"!bat_ftpfile!"

										echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>!bat_ftpfile!"
										echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_ftpfile!"

										echo literal pasv>>"!bat_ftpfile!"

										echo dir "!bat_tempfile_name!">>!bat_ftpfile!"

										echo quit>>"!bat_ftpfile!"
		

		if not exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
			MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
		)


			!bat_echolog!
			!bat_echolog!

			echo open ftp://!bat_ftpuser!:!bat_ftppassword!@!bat_ftpsite!>"!bat_winscpfile!"
			echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_winscpfile!"
			echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>"!bat_winscpfile!"
			echo stat "!bat_tempfile_name!">>"!bat_winscpfile!"
			echo bye>>"!bat_winscpfile!"

			!bat_echolog!
			!bat_echolog!
			
		!bat_logexec! type "!bat_winscpfile!"


			!bat_echolog!
			!bat_echolog!

		
		set bat_size_server=
		
			rem EXECUTE the FTP ls/dir listing...
			rem
			rem I had to come up with a workaround for a silly problem where the 
			rem creation of the listing file has 0D 0D 0A instead of 0D 0A.
			rem Therefore, I had to use a delimited file using exclamation point as the delimiter...
			rem The outcome of  this file is the "!bat_ftpfile2!". 

		!bat_log! CALL  "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"][find /i "!bat_tempfile_name!"][findstr /i /c:"-rw" }"!bat_exedir!\winscp.temp2.txt"
		CALL            "!bat_exedir!\winscp.com" /script="!bat_winscpfile!" |find /i "!bat_tempfile_name!" |findstr /i /c:"-rw" >"!bat_exedir!\winscp.temp2.txt"
		
		!bat_logexeclog! type "!bat_exedir!\winscp.temp2.txt"
			
rem		!bat_pushlog! for  /f "usebackq tokens=5-10*" ..a in ^(`call FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!][find /i "!bat_tempfile_name!"[]findstr /i /c:"-rw"`^) do ^(
rem		for                /f "usebackq tokens=5-10*" %%a in  (`call FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!^|find /i "!bat_tempfile_name!"^|findstr /i /c:"-rw"`) do (
		!bat_pushlog! for  /f "usebackq tokens=1-10*" ..a in ^(`type "!bat_exedir!\winscp.temp2.txt"^) do ^(
		for                /f "usebackq tokens=1-10*" %%a in  (`type "!bat_exedir!\winscp.temp2.txt"`) do (

			!bat_logexeclog! set bat_size_server=%%e
			!bat_logexeclog! set bat_temp=%%j
rem			!bat_logexeclog! set bat_temp=%%e
rem			!bat_logexeclog! set bat_temp=!bat_temp:~0,-1!
rem								echo.!bat_temp!^^!>>"!bat_ftpfile2!"
			echo.!bat_temp!>>"!bat_ftpfile2!"
		)
		!bat_poplog! ^)
		
		
			rem If the file didn't get created in the previous for loop, then it doesn't exist on the server and the upload failed.  
		if not exist "!bat_ftpfile2!" (
			!bat_echolog!
			!bat_echolog! No matching files on server: "!bat_tempfile_name!"
			!bat_echolog!
			set bat_returncode=2
	!bat_poplog! ^)
			goto :TESTEXISTONSERVER_END
		)

		if exist "!bat_ftpfile3!" (
			!bat_logexeclog! DEL /Q "!bat_ftpfile3!"
		)

%bat_COMMENT_BEGIN%
		!bat_pushecho! for /f "usebackq tokens=1 delims=!" ..a in ^("!bat_ftpfile2!"^) do ^(
		for                /f "usebackq tokens=1 delims=!" %%a in ("!bat_ftpfile2!") do (
			echo.%%a>>"!bat_ftpfile3!"
		)
		!bat_popecho! ^)
		
		!bat_logexeclog! MOVE /Y "!bat_ftpfile3!" "!bat_ftpfile2!"
%bat_COMMENT_END%

		!bat_pushecho! for /f "usebackq" ..a in ^("!bat_ftpfile2!"^) do ^(
		for                /f "usebackq" %%a in  ("!bat_ftpfile2!") do (
			!bat_echolog! %%a
		)
		!bat_popecho! ^)
		
	call :UPDATETOTALSFILE !bat_currmm!  !bat_size_server!

			rem signal success
		set bat_returncode=0

	!bat_popecho!


:TESTEXISTONSERVER_END
!bat_poplog! [RETURN !bat_batchfile!:TESTEXISTONSERVER] [bat_returncode=!bat_returncode!, bat_size=!bat_size!]
!bat_log!
rem !bat_WAIT! 0	:TESTEXISTONSERVER_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!








	REM #########################################################################
	REM 4b. Update the Totals file - :UPDATETOTALSFILE
	REM
	REM Updates the d:\cams2_queue\BytesThisBillingCycle.txt file with this month's
	REM limits by adding bat_currentBytesTotal.  
	REM
	REM The update of this file only if the sent file exists on the server.  We do
	REM this even if the sent file doesn't pass the validity test. 
	REM
	REM Arguments:
	REM    %~1			   is the current month from GetDate2.bat
	REM    %~2			   is the size of the matching file on the server
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:UPDATETOTALSFILE [IN bat_currmm IN bat_size_server]
!bat_pushlog! [CALL !bat_batchfile!:UPDATETOTALSFILE] %1    %2

	set bat_returncode=1
	
	REM Scan the value for the current calendar month from BytesThisBillingCycle.txt file
	REM and add it to the existing value.  Then replace the entry using ReplaceText.exe. 

	!bat_CALL! "!bat_exedir!\GetDate2.bat"

		REM Get the entire line for the find string to replace
	set bat_findstr_c=
	!bat_log! for /f "usebackq tokens=* delims== skip=2"  %a in ^(`find /i "!bat_currmm!=" "!bat_CAMS2LIMITS.TotalsFile!"`^) do ^(
	for           /f "usebackq tokens=* delims== skip=2" %%a in  (`find /i "!bat_currmm!=" "!bat_CAMS2LIMITS.TotalsFile!"`) do (
		echo.%%a
		set bat_findstr_c=%%a
	)

	if not defined bat_findstr_c (
		goto :UPDATETOTALSFILE_END
	)

	set /a bat_size_server=%~2
	set bat_replstr_c=
	set bat_temp_total=
	set bat_temp_filesize=
	
		rem Add the new size to the current size on the server [%~2]
	set /a bat_temp_filesize=%~2
	
	!bat_CALL! "!bat_exedir!\str_math.bat" !bat_currentBytesTotal! + %~2
	set bat_currentBytesTotal=!bat_RetVal!
	
	!bat_logexeclog! set bat_replstr_c=!bat_currmm!=!bat_currentBytesTotal!
	
	if NOT defined bat_replstr_c (
		set bat_returncode=3
		goto :UPDATETOTALSFILE_END
	)
	
	!bat_CALL! "!bat_exedir!\ReplaceText.exe" -iCV "!bat_CAMS2LIMITS.TotalsFile!" "!bat_findstr_c!" "!bat_replstr_c!"
	


:UPDATETOTALSFILE_END
!bat_poplog! [RETURN !bat_batchfile!:UPDATETOTALSFILE] [bat_returncode=!bat_returncode!, 
!bat_log! `                                          bat_currentBytesTotal=!bat_currentBytesTotal!
!bat_log! `                                          bat_replstr_c=!bat_replstr_c!
!bat_log! ` ]
!bat_log!
rem !bat_WAIT! 0	:UPDATETOTALSFILE_END
!bat_return! !bat_returncode!





	REM #########################################################################
	REM 5. Create the download command file for downloading the ZIP file back to the Temp dir. 	:CREATEDOWNLOADCMDFILE
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:CREATEDOWNLOADCMDFILE [IN filename]
!bat_pushlog! [CALL !bat_batchfile!:CREATEDOWNLOADCMDFILE] %1    %2

	set bat_returncode=1
	
	set bat_tempfilefull=%~1
	set bat_tempfile_name=%~nx1

:CREATEDOWNLOADFILECMDFILE_10
	echo.>"!bat_ftpfile2!"
	if exist "!bat_ftpfile2!" (
		!bat_logexeclog! DEL /Q "!bat_ftpfile2!"
		if !errorlevel! neq 0 (
			!bat_WAIT! 5   "ERROR - Can't delete.  Retrying in...": "!bat_ftpfile2!"
			goto :CREATEDOWNLOADCMDFILE_10
		)
	)
	
	if not exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
		!bat_logexeclog! MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" >nul: 2>&1
	)

        !bat_echolog! Now download the file to .\Temp to test it for validity...
        
        !bat_pushecho!

		echo user !bat_ftpuser!>"!bat_ftpfile!"
		echo !bat_ftppassword!>>"!bat_ftpfile!"
		echo bin>>"!bat_ftpfile!"
		echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_ftpfile!"
		echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo get "!bat_tempfile_name!">>!bat_ftpfile!"

		echo quit>>"!bat_ftpfile!"

		!bat_logexec! type "!bat_ftpfile!"


			!bat_echolog!
			!bat_echolog!


			echo open ftp://!bat_ftpuser!:!bat_ftppassword!@!bat_ftpsite!>"!bat_winscpfile!"
			echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_winscpfile!"
			echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>"!bat_winscpfile!"
			echo get -transfer=binary "!bat_tempfile_name!">>"!bat_winscpfile!"
			echo bye>>"!bat_winscpfile!"

			!bat_logexec! type "!bat_winscpfile!"

				   
		!bat_echolog! '..............................................
        !bat_popecho!
        
	set bat_returncode=0

:CREATEDOWNLOADCMDFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CREATEDOWNLOADCMDFILE] [bat_returncode=!bat_returncode!, 
!bat_log! `                           download target:"!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_tempfile_name!"]
!bat_log!
rem !bat_WAIT! 0	:CREATEDOWNLOADCMDFILE_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 6. Execute the command to download the ZIP to the Temp dir	:DOWNLOADZIPTOTEMP
	rem
	rem    can be used for zip or md5 file.
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:DOWNLOADTOTEMP [IN] "!bat_zipfilefull!"]
!bat_pushlog! [CALL !bat_batchfile!:DOWNLOADTOTEMP] %1    %2

	set bat_returncode=0
	
	set bat_tempfilefull=%~1
	set bat_tempfile_name=%~nx1

		REM EXECUTE THE DOWNLOAD --------------------------------------
rem	!bat_echolog! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
rem	!bat_logexec! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
	!bat_echolog! "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"
	!bat_logexec! "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"
	set bat_returncode=!bat_logexec_returncode!
	
	if not exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_tempfile_name!" (
		set bat_returncode=4
		!echolog!
		!bat_echolog! `     ERROR [!bat_returncode!] - FTP failed to download the file "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_tempfile_name!".  
		!echolog!
		goto :DOWNLOADTOTEMP_END
	)
	
	!bat_echolog!
	!bat_echolog! ` The file should now be downloaded "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_tempfile_name!"


:DOWNLOADTOTEMP_END
!bat_poplog! [RETURN !bat_batchfile!:DOWNLOADTOTEMP] [bat_returncode=!bat_returncode!, 
!bat_log! `                                      bat_tempfilename="!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_tempfile_name!"]
!bat_log!
rem !bat_WAIT! 0	:DOWNLOADTOTEMP_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 7. Check to try to validate the ZIP file downloaded is the same as the one uploaded	:VALIDATEZIP
	REM
	REM    7a. It should exist
	REM    7b. Create the Hash for the downloaded temp\zip\*.zip file
	REM    7e. Compare the HASH values
	REM    7c. Try to unzip the temp\*zip* file to the Temp\ziptest dir and check the return code
	REM
	REM    If any of this fails, wait the !bat_CAMS2UPLOAD.retry_delay! time and retry starting at [3]. 
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:VALIDATEZIP [IN] "!bat_zipfilefull!"]
!bat_pushlog! [CALL !bat_batchfile!:VALIDATEZIP] %1    %2

	set bat_returncode=1
	
	set bat_zipfilefull=%~1
	set bat_zipfile=%~n1
	set bat_zipfile_name=%~nx1
	set bat_tempfilefull=!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_zipfile_name!

		REM 7a. The temp downloaded zip should exist
	if not exist "!bat_tempfilefull!" (
		set bat_returncode=2
		!bat_echolog!
		!bat_echolog! `   ERROR [!bat_batchfile!:VALIDATEZIP:!bat_returncode!] - File did NOT download: "!bat_tempfilefull!"
		!bat_echolog!
		goto :VALIDATEZIP_END
	)
	
		REM 7b. Create the Hash file for the downloaded temp\zip\*.zip file
	!bat_CALL! "!bat_exedir!\ftpHash.bat" "!bat_tempfilefull!"
	set bat_returncode=!errorlevel!
	if !bat_returncode! NEQ 0 (
		set bat_returncode=8
		
		!bat_echolog!
		!bat_echolog! `   ERROR [!bat_batchfile!:VALIDATEZIP:!bat_returncode!] - FAILED: "ftpHash.bat" "!bat_tempfilefull!"
		!bat_echolog!
		goto :VALIDATEZIP_END
	)
	
	!bat_logexeclog! set bat_hash_temp=!bat_hash!
	
		REM Create the Hash file for the downloaded original .zip file
	!bat_CALL! "!bat_exedir!\MD5CreateFile.bat" "!bat_zipfilefull!"
	set bat_returncode=!errorlevel!
	if !bat_returncode! NEQ 0 (
		
		set bat_returncode=9
		
		!bat_echolog!
		!bat_echolog! `   ERROR [!bat_batchfile!:VALIDATEZIP:!bat_returncode!] - FAILED: "MD5CreateFile.bat" "!bat_zipfilefull!"
		!bat_echolog!
		goto :VALIDATEZIP_END
	)
	
	!bat_logexeclog! set bat_hash_orig=!bat_hash!
	
	
	
		REM Test the zip by unzipping the temp downloaded file and then deleting 
		REM the temp zip and its unzipped files.  
		REM
		REM The routine also returns non-zero if either the zipping 
		REM exe fails or returns a code or if the hash codes either don't match
		REM or it's an empty zip hash.

		REM ***********************************
		REM Unzip the zip file using 7zip and capture the exit code.   
	
	if /i "!bat_zipext!" equ ".zip" (
	
		!bat_logexec! "!bat_exedir!\7za.exe" x !bat_ziptype! -y  -r   "!bat_tempfilename!" "-o"!bat_CAMS2QUEUE.queue_dir!\Temp\zip\test""   *
		set bat_returncode=!errorlevel!
		
		if !bat_returncode! neq 0 (
			set bat_returncode=7
			!bat_echolog!
			!bat_echolog! `    ERROR [!bat_batchfile!:VALIDATEZIP:!bat_returncode!] - failed to unzip the zip file: "!bat_tempfilename!"
			!bat_echolog!

			goto :VALIDATEZIP_END
		)
	) else (
		set bat_returncode=0
	)
	
	
	if /i "!bat_hash_orig!" neq "!bat_hash_temp!" (
		
		set bat_returncode=6
		!bat_echolog!
		!bat_echolog! `    ERROR [!bat_batchfile!:VALIDATEZIP:!bat_returncode!] - Hash codes don't match: "!bat_hash_orig!" neq "!bat_hash_temp!"
		!bat_echolog!
		
		goto :VALIDATEZIP_END
	)
		

	set bat_returncode=0

	!bat_echolog!
	!bat_echolog!  SUCCESS - Upload of Zip file was SUCCESSFULL - No need to retry. 
	!bat_echolog!


:VALIDATEZIP_END
!bat_poplog! [RETURN !bat_batchfile!:VALIDATEZIP] [bat_returncode=!bat_returncode!, bat_tempfilename=!bat_tempfilename!, bat_hash_temp=!bat_hash_temp!,
!bat_log! `                                        bat_zipfilefull=!bat_zipfilefull!, bat_hash_orig=!bat_hash_orig!]
!bat_log!
rem !bat_WAIT! 0	:VALIDATEZIP_END
!bat_return! !bat_returncode!







	REM #########################################################################
	REM 7b. Hash the newly downloaded zip in the temp dir.	:HASHTEMPZIP
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:HASHTEMPZIP [IN "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\!bat_zipfilename!"]
!bat_pushlog! [CALL !bat_batchfile!:HASHTEMPZIP] %1    %2

	set bat_returncode=0
	
	set bat_tempfilename=%~1

	!bat_CALL! "!bat_exedir!\MD5CreateFile.bat" "!bat_tempfilename!"
	set bat_returncode=!errorlevel!
	
	if "!bat_returncode!" equ "0" (
		!bat_echolog!
		!bat_echolog!  Upload of Zip file was SUCCESSFULL - No need to retry. 
		!bat_echolog!
	)


:HASHTEMPZIP_END
!bat_poplog! [RETURN !bat_batchfile!:HASHTEMPZIP] [bat_returncode=!bat_returncode!, 
!bat_log `                                      bat_tempfilename="!bat_tempfilename!"]
!bat_log!
rem !bat_WAIT! 0	:HASHTEMPZIP_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 21. Create the command file [!bat_ftpfile!] to upload the MD5 file.  :CREATEUPLOADMD5CMDFILE
	REM
	REM     It can include the upload AND download of the MD5 file back to the 
	REM     Temp dir. 	
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:CREATEUPLOADMD5CMDFILE [IN "!bat_zipfilename!.md5.txt"]
!bat_pushlog! [CALL !bat_batchfile!:CREATEUPLOADMD5CMDFILE] %1    %2

	set bat_returncode=1
	
	set bat_tempfilename=%~1
	set bat_tempfile=%~n1

:CREATEUPLOADMD5CMDFILE_10
	if exist "!bat_ftpfile2!" (
		DEL /Q "!bat_ftpfile2!"
		if !errorlevel! neq 0 (
			!bat_WAIT! 5   "ERROR - Can't delete "!bat_ftpfile2!".  Retrying in 5 seconds..."
			goto :CREATEUPLOADMD5CMDFILE_10
		)
	)
	
	if NOT EXIST                "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip" (
		!bat_logexeclog! MD "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip"
	)

	!bat_echolog!
        !bat_echolog! Now upload the "!bat_tempfilename!" file to the "!bat_ftpdir!" folder on the "!bat_ftpsite!" server...
        !bat_pushecho!

														echo user !bat_ftpuser!>"!bat_ftpfile!"
														echo !bat_ftppassword!>>"!bat_ftpfile!"
														echo bin>>"!bat_ftpfile!"
														echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_ftpfile!"
														echo literal pasv>>"!bat_ftpfile!"

														echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip">>!bat_ftpfile!"

														echo put "!bat_tempfile!">>"!bat_ftpfile!"

														echo quit>>"!bat_ftpfile!"

		!bat_logexec! type "!bat_ftpfile!"

			!bat_echolog!
			!bat_echolog!


			echo open ftp://!bat_ftpuser!:!bat_ftppassword!@!bat_ftpsite!>"!bat_winscpfile!"
			echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_winscpfile!"
			echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip">>"!bat_winscpfile!"
			echo put -transfer=binary "!bat_tempfile!">>"!bat_winscpfile!"
			echo bye>>"!bat_winscpfile!"

			!bat_logexec! type "!bat_winscpfile!"

				   
		!bat_echolog! '..............................................
        !bat_popecho!

	set bat_returncode=0

:CREATEUPLOADMD5CMDFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CREATEUPLOADMD5CMDFILE] [bat_returncode=!bat_returncode!, bat_tempfilename=!bat_tempfilename!]
!bat_log!
rem !bat_WAIT! 0	:CREATEUPLOADMD5CMDFILE_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 22. Execute the upload/download command file 	:UPLOADDOWNLOADMD5
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:UPLOADDOWNLOADMD5 [in] "!bat_tempfilename!"
!bat_pushlog! [CALL !bat_batchfile!:UPLOADDOWNLOADMD5] %1

	set bat_returncode=0
	
	set bat_tempfilename=%~1

		REM Execute the FTP command file to upload/download MD5 file...
															rem	!bat_echolog! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
															rem	!bat_logexec! CALL FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!
	!bat_echolog! "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"
	!bat_logexec! "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"
	set bat_returncode=!bat_logexec_returncode!
	
		REM Test that it exists on the server by executing a FTP ls/dir command and 
		REM then extracting the bat_size_server variable.  Also calls UpdateTotalsFile. 
		REM
	CALL :TESTEXISTONSERVER "!bat_tempfilename!"
	
	if "!bat_returncode!" neq "0" (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog! `     ERROR [!bat_batchfile!:VALIDATEZIP:!bat_returncode!] - FTP failed to upload the file "!bat_tempfilename!".  
		!bat_echolog!
		goto :UPLOADDOWNLOADMD5_END
	)
	
	!bat_echolog!
	!bat_echolog! ` The file should now be uploaded "!bat_zipfilename!"
	!bat_echolog!

:UPLOADDOWNLOADMD5_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADDOWNLOADMD5] [bat_returncode=!bat_returncode!, bat_tempfilename=!bat_tempfilename!]
!bat_log!
rem !bat_WAIT! 0	:UPLOADDOWNLOADMD5_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 23. Compare the original MD5 file and the Temp\MD5 file		:COMPAREMD5
	REM
	REM This routine needs to compare the original/source MD5 file with the temp MD5 
	REM file that was just downloaded to the "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip" dir.
	REM
	REM A problem will happen when we start using the -tzip.split option to split the
	REM zip file into numerous files of the same size.  Something else will have to
	REM happen if we implement that. I think the current design plan is to have each
	REM split sequence file to be uploaded separately, therefore each split sequence
	REM file will have it's own associated ".md5.txt" file that will also be uploaded
	REM separately. 
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:COMPAREMD5 [IN] !bat_sourcefilefull!   [IN] !bat_tempfilepath!]
!bat_pushlog! [CALL !bat_batchfile!:COMPAREMD5] %1   %2

	set bat_returncode=1

	!bat_logexeclog! set bat_sourcefilefull=%~1
	!bat_logexeclog! set bat_tempfile_name=%~nx1
	!bat_logexeclog! set bat_tempfilepath=%~2
	!bat_logexeclog! set bat_tempfilefull=!bat_tempfilepath!\!bat_tempfile_name!
	
		REM **************************************************
		REM COMPARE THE FILES USING THE MICROSOFT "FC.EXE" COMMAND
		
	!bat_logexeclog! FC "!bat_sourcefilefull!"  "!bat_tempfilefull!"
	set bat_returncode=!errorlevel!
	
	if /i "!bat_returncode!" neq "0" (
		set bat_returncode=2
		!bat_echolog!
		!bat_echolog! `    ERROR [!bat_batchfile!:COMPAREMD5:!bat_returncode!] - Files are different. 
		!bat_echolog!
		!bat_echolog! `          Should NOT retry the upload. 
		goto :COMPAREMD5_END
	)
	
	
		REM The hashes are equal so OK. 
	set bat_returncode=0
	
	!bat_echolog! `      ****  SUCCESS [!bat_batchfile!:COMPAREMD5:!bat_returncode!] - Files are the same. 
	
:COMPAREMD5_END
!bat_poplog! [RETURN !bat_batchfile!:COMPAREMD5] [bat_returncode=!bat_returncode!, 
!bat_log! `                            bat_sourcefilefull="!bat_sourcefilefull!",
!bat_log! `                            bat_tempfilefull="!bat_tempfilefull!"]
!bat_log!
rem !bat_WAIT! 0	:COMPAREMD5_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 25. Delete the ..\Temp\*zip* file and the MD5 file and cleanup		:CLEANUPTEMP
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:CLEANUPTEMP
!bat_pushlog! [CALL !bat_batchfile!:CLEANUPTEMP %1

	set bat_returncode=0

	if exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
		!bat_logexec! DEL /Q /S "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip\*.*"
		!bat_logexec! RD  /Q /S "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip"

		!bat_logexec! MD "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip"
		
	) else (
		!bat_echolog!
		!bat_echolog! ERROR [!bat_batchfile!:CLEANUPTEMP:!bat_returncode!] Dangerous command: del /s /q "!bat_CAMS2QUEUE.queue_dir!\Temp\Zip\*.*"
		!bat_echolog!
		!bat_WAIT! 60     "!bat_batchfile!:CLEANUPTEMP"
		
		set bat_returncode=7
		goto :CLEANUPTEMP_END
	)
	

:CLEANUPTEMP_END
!bat_poplog! [RETURN !bat_batchfile!:CLEANUPTEMP] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:CLEANUPTEMP_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 26. MOVE the zip file and its MD5 file to the Transmitted dir		:MOVETOTRANSMITTED
	REM
	REM     There is an issue that arrises here.  The problem is that we don't
	REM     know which CAMS Instance [essentially based on the board number]
	REM     the file originates from.  It may be necessary to create a queue 
	REM     file that identifies the CAMSDIR of the original file.  That way,
	REM     we can move the file to the Transmitted dir of that instance.  The
	REM     only real reason to do this is to accommodate the archiving 
	REM     functions, which currently don't work from the queue subdirs.
	REM
	REM
	REM
	REM Returns:
	REM    bat_returncode              0=ok
	REM                                All other values means fail. 
	REM

:MOVETOTRANSMITTED [IN] "!bat_sourcefilefull!"  [IN] "!bat_md5filefull!"
!bat_pushlog! [CALL !bat_batchfile!:MOVETOTRANSMITTED] %1 %2

	set bat_returncode=0
	
	if not exist "!bat_CAMS2QUEUE.queue_dir!\Transmitted" (
		MD "!bat_CAMS2QUEUE.queue_dir!\Transmitted"
	)

	if exist "%~1" (
		!bat_logexec! MOVE /Y "%~1"    "!bat_CAMS2QUEUE.queue_dir!\Transmitted"
	)

	!bat_echolog! if /i "%~x1" equ ".001" 
	if /i "%~x1" equ ".001" (

		!bat_echolog! if exist "!bat_CAMS2QUEUE.queue_dir!\%~n1.ctl.txt"
		if               exist "!bat_CAMS2QUEUE.queue_dir!\%~n1.ctl.txt" (

			!bat_logexec! MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\%~n1.ctl.txt"    "!bat_CAMS2QUEUE.queue_dir!\Transmitted"

		)
	)

	
	if exist "%~1.ctl.txt" (
		!bat_logexec! MOVE /Y "%~1.ctl.txt"    "!bat_CAMS2QUEUE.queue_dir!\Transmitted"
	)
	
	if exist "%~2" (
		!bat_logexec! MOVE /Y "%~2"    "!bat_CAMS2QUEUE.queue_dir!\Transmitted"
	)

:MOVETOTRANSMITTED_END
!bat_poplog! [RETURN !bat_batchfile!:MOVETOTRANSMITTED] [bat_returncode=!bat_returncode!, %1]
!bat_log!
rem !bat_WAIT! 0	:MOVETOTRANSMITTED_END
!bat_return! !bat_returncode!









	REM #########################################################################
	REM 
	REM Note: Needs to include zip file sequence number.  I don't know how to
	REM       handle that for split zip sequence files.  test.zip becomes
	REM       test.zip.001-test.zip.018  For each of those, each attempt will
	REM       need to include an additional sequence number, therefore, we could 
	REM       expect to see, for example: test_01.zip.001, test_01.zip.002 [if it retries]
	REM       test_02.zip.002, test_01.zip.003, test_01.zip.004 [if it fails] test_02.zip.004
	REM       [if that fails] test_03.zip.004, and so on. 
	REM
	REM       Peter's scripts will need to only accept the last one that has an MD5 file for
	REM       each of the sequence files.  For each sequence file, there will be a matching 
	REM       MD5 file.  I'm not sure if those should be sequenced too.
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.    Usage %~0 ^<zipfilefull^> 
	echo.    
	echo.    Uploads ONE specified file at a time and retries if it fails.  
	echo.
	echo.    A separate command file "cmd_upload.exe" should be created to launch this asynchronously
	echo.    so that it can be terminated easily enough by a user via Task Manager. It will be 
	echo.    launched with a START "" /wait "cmd_ftp_upload_robust_seti.bat.exe" /c "ftp_upload_robust_seti.bat".
	echo.    
	echo.    In reality, this upload script will only be responsible for one upload at a time.
	echo.    That way, if the user decides to abort this particular upload, the calling script 
	echo.    [Submitted_LocalUpload.bat] can continue if a user aborts.  
	echo.    
	echo.    Also, The Submitted_LocalUpload.bat AND this "ftp_upload_robust_seti.bat" need to be added
	echo.    to the list of processes to terminate just before a new night of capture. 
	echo.    
	echo.    1. Make a "!bat_camsdir!\Temp" dir if it doesn't already exist. 
	echo.    
	echo.    2. Test the ZIP by unzipping it to the Temp dir and checking the return code
	echo.
	echo.    2a. Check the Totals file to ensure that not going over cell data plan limits
	echo.    
	echo.    3. Create the command file [!bat_ftpfile!].  It should include the upload for just the ZIP but not the download. 
	echo.    
	echo.    4. Execute the command to upload the ZIP
	echo.
	echo.       [See "autocal_Remote-doanload_seti.bat:FTPTRANSFER" for example of reading the FTP server]
	echo.       4a. Test if the file exists on the server. 	:TESTEXISTONSERVER
	echo.       4b. Update the !bat_CAMS2LIMITS.TotalsFile!
	echo.    
	echo.    5. Create the download command file for downloading the ZIP file back to the Temp dir. 
	echo.    
	echo.    6. Execute the command to download the ZIP to the Temp dir
	echo.    
	echo.    7. Check to try to validate the ZIP file downloaded is the same as the one uploaded
	echo.    
	echo.        - It should exist
	echo.        - Try to unzip the temp\*zip* file to the Temp\ziptest dir and check the return code
	echo.        - Get the hash of the temp\*zip* file
	echo.        - Compare the HASH values
	echo.    
	echo.    If any of this fails, wait the !bat_CAMS2UPLOAD.retry_delay! time and retry starting at [3]. 
	echo.    
	echo.    
	echo.Repeat all these steps for the MD5 file:
	echo.    21. Create the command file [!bat_ftpfile!].  It can include the upload AND download of the MD5 file back to the Temp dir. 
	echo.    
	echo.    22. Execute the upload/download command file 
	echo.    
	echo.    23. Compare the original MD5 file and the Temp\MD5 file
	echo.    
	echo.    24. If anything fails, start over at 21.
	echo.    
	echo.    25. Delete the ..\Temp\*zip* file and the MD5 file and cleanup
	echo.    
	echo.    26. MOVE the zip file and its MD5 file to the Transmitted dir
	echo.    
	echo.    27. Exit with success/fail error code.
	echo.
	echo.IMPORTANT: USE THE bat_CAMS2LIMITS.enabled and other settings of that section to keep within
	echo.           limited wireless data plan limits. 
	echo.
	echo.           Requires that the ftp.temp3.txt file to contain a list of files already on the server
	echo.           so that it can determine whether to sequence or to upload with overwrite. 
	echo.    
	echo.NOTE: We need to accommodate a split zip.  
	echo.      An example of a split zip would have the same root name, but with 3-digit sequence numbers.
	echo.      One problem with these files is that there is no way to know how many sequence files there are.
	echo.      However, the correct number of files should be able to be determined by the source.  It's just
	echo.      a question of how to determine if they are all there on the server end of things.  
	echo.      
	echo.      With regard to split zip files, each sequence file will have it's own matching "*.md5.txt" file.
	echo.      It could be done by adding them all into a single md5 file, but we are also using the presence of
	echo.      the md5 file as a means of determining, on the server end, that the file is done being uploaded.
	echo.      If the .md5.txt file is missing, then the fileset is not ready to be processed on the server end. 
	echo.
	echo.      So, perhaps we can loop through all of them given the main zip file name (without sequence .001).
	echo.      For example, if the original zip file is test.zip and it splits into 18 sequence files, only the 
	echo.      base zip file name "test.zip" needs to be passed as the first argument, but it will iterate, 
	echo.      always starting from ".001".  Another issue is the MD5 for each of the split sequence files. 
	echo.
	echo.      I think the final decision will be to call this routine for each of the sequence files separately.
	echo.
	echo.      Another thing to deal with is the sequence numbers of non-split files.  We will start with each
	echo.      zip file name will have a "_01.zip" suffix.  If it fails, it will change to "_02.zip" and so on. 
	echo.
	echo.      For split-zip files, they will have split-zip sequence numbers and sequence numbers not related.
	echo.      to split-zip files. 
	echo.
	echo.     Example: 
	echo.
	echo.Called by: upload_queue.bat
	echo.
	echo.DEPENDS ON:
	echo.   Cams2Global.ini
	echo.   autocams.params.ini
	echo.   GetDate2.bat
	echo.   MD5CreateFile.bat
	echo.   MoveTransmit.bat
	echo.   cmd_ftp_upload_robust_seti.bat.exe
	echo.   7za.exe
	echo.   autocams.setup.bat
	echo.   ftpHash.bat
	echo.   
	echo.   upload_queue.bat
	echo.   ZipCams2FromFTP.bat
	echo.
	
	
!bat_return 99


	REM #########################################################################
	REM 

:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!
exit /b !bat_returncode!

