  @echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

    if "%~3" equ "" goto :HELP

	TITLE %~0 %*
	echo Waiting to unlock the log files...
	start /w wait 6


	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
	set bat_pushstring=

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! ======================================================
	!bat_echolog! [!date! !time!] %0 %*
	!bat_echolog!
	!bat_push!
	
   	set bat_tempfile=%~0.junk.txt
	set bat_warningfile=%~0.warn.txt
	set bat_sunsettable=%~dp0!bat_sunsettablename!

	set bat_CD_no=0
	set bat_CD_copy=1
	set bat_CD_move=2
	set bat_CD_flag=!bat_CD_move!


	rem call :READPARAMS
	if defined bat_CAPTURE.archive_flag (
		set bat_CD_flag=!bat_CAPTURE.archive_flag!
	)

	call :GETARGS %*
	call :SETCAPTUREEXE %*
	
	call :TARGETLOCATION %*
	call :PARSEDATE %*
	call :GETSCHEDSTART %*
	call :GETWALLTIMEROFF %*
	call :PARSETIME %*
	call :NOTIFY %*
	call :ADJONDATE %*
	call :DAYOFWEEK %*
	call :GETSEARCHDIR %*
	call :GETSUNANGLE %*
	call :GETSTARTTIME %*


:SETUP_END
GOTO :MAIN


:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*
	call :CALCDURATION "!bat_ON!" "!bat_OFF!"

	call :REVIEW %*
	CALL :GETDELAY %*

goto :MAIN_END
	call :WAITDELAY %*

		REM NEED TO RECALCULATE THE DURATION BASED ON THE NEW TIME
		REM JUST IN CASE THE WAIT DELAY WAS ABORTED EARLY OR
		REM IN CASE THERE WAS SOME TIME LOSS DURING THE WAIT. 
		REM This ensures that the bat_OFF time is always
		REM honored.

rem	set bat_ON=!time:~0,8!
	call "!bat_exedir!\localize_GETONTIME1_!bat_AUTOCAMS.locale!.bat"

	call :CALCDURATION "!bat_ON!" "!bat_OFF!"

	call :CAPTURE %*

	!bat_log! %~dpnx0 %*
	!bat_log! [!date! !time!]

	call :VARIABLES_LOG bat_log

	if defined bat_warningfile (
		!bat_logexeclog! del "!bat_warningfile!"
	) else (
		!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command:  del "!bat_warningfile!"
	)

	
	if defined bat_tempfile (
		!bat_logexeclog! del "!bat_tempfile!"
	) else (
		!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del "!bat_tempfile!"
	)
	
:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] []
!bat_log!
goto :DONE


:GETARGS
!bat_pushlog! [CALL !bat_batchfile!:GETARGS] %*
	set bat_camera=%~1
	set bat_delaytemp=%~2
	
	set bat_targetlocation=%~dpnx3::
	set bat_targetlocation=!bat_targetlocation:\::=!
	set bat_targetlocation=!bat_targetlocation:::=!
	
	set bat_autonomous=
	if /i "%~4" equ "autonomous" (
		set bat_autonomous=autonomous
	)
	if /i "%~4" equ "auto" (
		set bat_autonomous=autonomous
	)

:GETARGS_END
!bat_poplog! [RETURN !bat_batchfile!:GETARGS] [!bat_camera!, !bat_delaytemp!, !bat_targetlocation!, !bat_autonomous!]
!bat_log!
!bat_return!



	

:TARGETLOCATION
!bat_pushlog! [CALL !bat_batchfile!:TARGETLOCATION] %*
	REM Ensures that if the last name of the specified directory
	rem contains "CAMS" or "CAMS\", then it removes that from
	rem the bat_targetlocation variable. 
	if /i "!bat_targetlocation:~-5!" equ "\CAMS" (
		set bat_targetlocation=!bat_targetlocation:~0,-5!
	) else (
		if /i "!bat_targetlocation:~-6!" equ "\CAMS\" (
			set bat_targetlocation=!bat_targetlocation:~0,-6!
		)
	)
	
	set bat_targetdrive=!bat_targetlocation:~0,2!

:TARGETLOCATION_END
!bat_poplog! [RETURN !bat_batchfile!:TARGETLOCATION] [!bat_targetdrive!, !bat_targetlocation!]
!bat_log!
!bat_return!




:PARSEDATE
!bat_pushlog! [CALL !bat_batchfile!:PARSEDATE] %*

	!bat_log! call "localize_PARSEDATE1_!bat_AUTOCAMS.locale!.bat"
	          call "localize_PARSEDATE1_!bat_AUTOCAMS.locale!.bat"
	          
	call :DATE2JDATE ftp_jd !ftp_year! !ftp_mo! !ftp_da!
	
	set /a bat_date_jd_tomorrow=!ftp_jd! + 1
	goto :PARSEDATE_END

	set ftp_wmdy=!date!
:PARSEDATE2
	set ftp_year=!ftp_wmdy:~-4!
	set ftp_mo=!ftp_wmdy:~4,2!
	set ftp_mo2=!ftp_mo!
	if !ftp_mo! LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=!ftp_wmdy:~7,2!
	set ftp_da2=!ftp_da!
	if !ftp_da! LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

:PARSEDATE_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEDATE] [!ftp_wmdy!, !ftp_year!, !ftp_mo!, !ftp_da!, !ftp_jd!, !bat_date_jd_tomorrow!]
!bat_log!
!bat_return!




:GETSCHEDSTART
!bat_pushlog! [CALL !bat_batchfile!:GETSCHEDSTART] %*
	set bat_scheduledstarttime=ERROR
	for /f "usebackq tokens=1-3* skip=2 delims=," %%a in (`find /i "Delay will be from the earliest start time hour" "!bat_sunsettable!"`) do (
		set bat_scheduledstarttime=%%a
	)

:GETSCHEDSTART_END
!bat_poplog! [RETURN !bat_batchfile!:GETSCHEDSTART] [Wall timer ON=!bat_scheduledstarttime!]
!bat_log!
!bat_return!



:GETWALLTIMEROFF
!bat_pushlog! [CALL !bat_batchfile!:GETWALLTIMEROFF] %*
	set bat_walltimeroff=ERROR
	for /f "usebackq tokens=1-3* skip=2 delims=," %%a in (`find /i "Wall Timer OFF" "!bat_sunsettable!"`) do (
		set bat_walltimeroff=%%a
	)

:GETWALLTIMEROFF_END
!bat_poplog! [RETURN !bat_batchfile!:GETSCHEDSTART] [Wall timer OFF=!bat_walltimeroff!]
!bat_log!
!bat_return!


:PARSETIME
!bat_pushlog! [CALL !bat_batchfile!:PARSETIME] %*


	!bat_logexeclog! set /a bat_midnightsecs=86400
	call "localize_PARSETIME1_!bat_AUTOCAMS.locale!.bat"

	goto :PARSETIME_END



	set ftp_hhmmssdd=!time!
	
	set ftp_hr=!ftp_hhmmssdd:~0,2!
	set ftp_hr=!ftp_hr: =!
	set ftp_hr=00!ftp_hr!
	set ftp_hr=!ftp_hr:~-2!

	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,2%
	set ftp_hhmmssdd=!ftp_hr!:!ftp_mi!:!ftp_se!

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	!bat_logexeclog! set /a bat_midnightsecs=86400
	
	if !ftp_hr! GTR 12 (
		set /a ftp_temp=ftp_hr-12
		set ftp_hhmmssdd_local=!ftp_temp!:!ftp_mi!:!ftp_se! PM
	) else (
		set ftp_hhmmssdd_local=!ftp_hhmmssdd! AM
	)

:PARSETIME_END
!bat_poplog! [RETURN !bat_batchfile!:PARSETIME] [!ftp_hhmmssdd!, !ftp_hr!, !ftp_mi!, !ftp_se!, %ftp_jd%]
!bat_log!
!bat_return!




:NOTIFY
	echo.
	echo     This script is designed to be launched at the same time of the day
	echo     all year ^(!bat_scheduledstarttime!^).  Then it waits a different number of seconds 
	echo     before starting capture, based on the calculation of dusk, which is 
	echo     based on your LAT/LONG. Then it launches !bat_captureexe! with the 
	echo     specified camera number, the calculated duration (dusk to dawn from 
	echo     the "!bat_sunsettable!" file), and the specified storage location. 
	echo.
	echo     If you are running this manually, check the "!bat_sunsettable!" file
	echo     for the dusk and dawn values and set the wall timer and duration 
	echo     according to the current launch time. CheckTwilight.bat is provided 
	echo     for this purpose. 
	echo.

:NOTIFY_END
!bat_return!



	
:ADJONDATE
!bat_pushlog! [CALL !bat_batchfile!:ADJONDATE] %*
	for /f "usebackq tokens=1-16 skip=2 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"`) do (
		set bat_on=%%c
		set bat_calcedon=%%c
		set bat_off=%%b
	)
	
	if "!ftp_hhmmssdd!" lss "!bat_off!" (
		set bat_on=!ftp_hhmmssdd:~0,8!
		set /a bat_midnightsecs=0
		set /a ftp_jd-=1
		call :jdate2date !ftp_jd! ftp_year ftp_mo2 ftp_da2
		set ftp_wmdy=dow !ftp_mo2!/!ftp_da2!/!ftp_year!
		set ftp_year=!ftp_wmdy:~-4!
		set ftp_mo=!ftp_wmdy:~4,2!
		set ftp_mo2=!ftp_mo!
		if !ftp_mo! LSS 10 (
			set ftp_mo2=!ftp_mo:~-1!
		)
		set ftp_da=!ftp_wmdy:~7,2!
		set ftp_da2=!ftp_da!
		if !ftp_da! LSS 10 (
			set ftp_da2=!ftp_da:~-1!
		)
	)
echo.dddddddddddddddddddddd !ftp_mo!/!ftp_da!/!ftp_year!
	
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2
echo.eeeeeeeeeeeeeeeeeeeeee !ftp_mo!/!ftp_da!/!ftp_year!
	call :CALCDELAY "!bat_on!" "!ftp_hhmmssdd!"
echo.fffffffffffffffffffffff !ftp_mo!/!ftp_da!/!ftp_year!



:ADJONDATE_END
!bat_poplog! [RETURN !bat_batchfile!:ADJONDATE] [bat_on=!bat_on!, ftp_hhmmssdd=!ftp_hhmmssdd!, bat_calcedon=!bat_calcedon!, bat_off=!bat_off!, !ftp_year!, !ftp_mo2!, !ftp_da2!]
!bat_log!
!bat_return!




:DAYOFWEEK
!bat_pushlog! [CALL !bat_batchfile!:DAYOFWEEK] %*
	call :date2jdate bat_JD !ftp_year! !ftp_mo2! !ftp_da2!
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd
	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)

:DAYOFWEEK_END
!bat_poplog! [RETURN !bat_batchfile!:DAYOFWEEK] [!bat_weekday!]
!bat_log!
!bat_return!




:GETSEARCHDIR
!bat_pushlog! [CALL !bat_batchfile!:GETSEARCHDIR] %*
	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
:GETSEARCHDIR_END
!bat_poplog! [RETURN !bat_batchfile!:GETSEARCHDIR] [!ftp_searchdir!]
!bat_log!
!bat_return!


	

:GETSUNANGLE
!bat_pushlog! [CALL !bat_batchfile!:GETSUNANGLE] %*
	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dawn off offset" "!bat_sunsettable!"`) do (
		set bat_sa_off=%%d
		set bat_sunangleoff=           %%d
		set bat_sunangleoff=!bat_sunangleoff:~-7!
	)

	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dusk on offset" "!bat_sunsettable!"`) do (
		set bat_sa_on=%%d
		set bat_sunangleon=            %%d
		set bat_sunangleon=!bat_sunangleon:~-7!
	)
:GETSUNANGLE_END
!bat_poplog! [RETURN !bat_batchfile!:GETSUNANGLE] [on=!bat_sunangleon!, off=!bat_sunangleoff!]
!bat_log!
!bat_return!



	rem Get's the start time from the twilight file
:GETSTARTTIME
!bat_pushlog! [CALL !bat_batchfile!:GETSTARTTIME] %*
	for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"^|find /i /v "!bat_sunsettable!"`) do (
		if "%%a" neq "----------" (
			set bat_duration=%%d
			set bat_delay=%%e
			set bat_date=%%a
			set bat_off=%%b
			rem set bat_on=%%c
			set bat_dst=%%f
			set bat_duskutc=%%g
			set bat_dusklocal=%%h
			set bat_dawnutc=%%i
		)
	)
:GETSTARTTIME_END
!bat_poplog! [RETURN !bat_batchfile!:GETSTARTTIME] [bat_duration=!bat_duration!
!bat_log! '                                      bat_delay=!bat_delay!,
!bat_log! '                                      bat_date=!bat_date!,
!bat_log! '                                      bat_off=!bat_off!,
!bat_log! '                                      bat_dst=!bat_dst!,
!bat_log! '                                      bat_duskutc=!bat_duskutc!,
!bat_log! '                                      bat_dusklocal=!bat_dusklocal!,
!bat_log! '                                      bat_dawnutc=!bat_dawnutc!]
!bat_log!
!bat_return!



:REVIEW
!bat_pushlog! [CALL !bat_batchfile!:REVIEW] %*
	!bat_pushecho! find /i "Delay will be from the earliest" "!bat_sunsettable!"
		!bat_echolog!
		!bat_echolog! Task Scheduler Start Time=!bat_scheduledstarttime! ^(Wall timer ON local time^)
		!bat_echolog! Wall Timer OFF=!bat_walltimeroff! ^(local time^)
		!bat_echolog!

		set bat_duration=0
		rem Determine the duration by looking up in the !bat_sunsettable! file

		!bat_echolog! '                                                   Dusk     Dusk        Dawn						
		!bat_echolog! '                                                   (UTC at  (LDT at     (UTC at						
		!bat_echolog! '              Dawn OFF  Dusk ON   Dur-             !bat_sa_on! below  !bat_sa_on! below     !bat_sa_off! below						
		!bat_echolog! 'Date          !bat_sa_off! deg     !bat_sa_on! deg     ation Delay  DST horizon  horizon     horizon   date      sunrise  sunset      Day #
		!bat_echolog! '==========    ========  ========  =====  =====  =  =======  ==========  ========  ========  =======  ==========  =====
		for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"^|find /i /v "!bat_sunsettable!"`) do (
				!bat_echolog! '%%a    %%b  %%c  %%d  %%e   %%f  %%g  %%h  %%i  %%j  %%k  %%l  %%m
		)
		rem find /i "!bat_curm!/!bat_curd!/!bat_cury!" "sunsettable.txt"|find /i /v "!bat_sunsettable!"
		!bat_echolog!

		!bat_echolog! for /f "usebackq tokens=1-16 skip=2 delims=," ..a in ^(`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"`^) do ...
		!bat_push!
		for               /f "usebackq tokens=1-16 skip=2 delims=," %%a in  (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"`) do (
			!bat_echo!
			if "%%a" neq "----------" (
				!bat_echolog! Date=                %%a  - Date of these calculations ^(!bat_weekday!^)
				call :CALCDAYNUMBER %%m
				!bat_echolog! Day number=          !bat_res3!         - Day of the year 
				!bat_echolog! Task Sched Start     !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
				!bat_echolog! Current Time         !time:~0,8!    - Current local time
				!bat_echolog!
				!bat_echolog! Sunset Local=         %%l - Local sunset time
				!bat_echolog! Camera ON Local       %%h - Local time of the first frames, Use this to set our wall timer.
				!bat_echolog! Camera ON=           !bat_on!    - Local time Task Scheduler should start capture
				!bat_echolog! Camera ON UTC         %%g    - UTC time ^(camera time^) of the first frame
				!bat_echolog! Camera ON sun angle  !bat_sunangleon!     - degrees below horizon
				!bat_echolog!
				!bat_echolog! Camera OFF UTC       %%i    - UTC time ^(camera time^) of the last frame
				!bat_echolog! Camera OFF Local=    %%b    - Local time capture should end in the morning
				!bat_echolog! Sunrise Local=        %%k    - Local sunrise time ^(next morning^)
				!bat_echolog! Camera OFF sun angle!bat_sunangleoff!      - degrees below horizon
				!bat_echolog!
				!bat_echolog! Duration=            !bat_dur!       - Number of hours to capture ^(24:00:00 - ON + OFF^)
				!bat_echolog! Scheduled Delay=     %%es       - Number of seconds to delay from the scheduled start time ^(!bat_scheduledstartime!^)
				!bat_echolog! Actual Delay=        !bat_delaycalc!s       - Number of seconds to delay from the scheduled start time ^(!bat_scheduledstartime!^)
				!bat_echolog! DST=                 %%f           - 1 if this date uses DST.  0 if not
				!bat_echolog! '                                    Note: Dawn is calculated for the next morning

				set bat_duration=%%d
				set bat_delay=%%e
				set bat_date=%%a
				set bat_off=%%b
				rem set bat_on=%%c
				set bat_dst=%%f
				set bat_duskutc=%%g
				set bat_dusklocal=%%h
				set bat_dawnutc=%%j

				call :CALCREQDISK !bat_duration!
				if "!bat_SIMULATION.capture!" neq "true" (
					!bat_echolog!
					!bat_echolog! Disk Space Available !bat_freeMB! MB
					!bat_echolog! Disk Space Required= !bat_reqdisk! MB     - !bat_diskspacememo!
					!bat_echolog!
						if !bat_estSizeMB! gtr !bat_freeMB! (
							!bat_logexec! call :GETWINDOWSVER

							set /a bat_sizediff=!bat_estSizeMB!-!bat_freeMB!

							ECHO ********* WARNING! ************>!bat_warningfile!
							echo    You only have !bat_freeMB! MB free on drive !bat_targetdrive!. Within the >>!bat_warningfile!
							echo    next 14 days, you will require !bat_estSizeMB! MB.  You will need to free up>>!bat_warningfile!
							echo    !bat_sizediff! MB ASAP or the capture will fail.>>!bat_warningfile!
							echo.>>!bat_warningfile!
							echo    Tips ^(for Windows version !bat_winver!^):>>!bat_warningfile!
							echo      a^) Try specifying a different drive for capture >>!bat_warningfile!
							echo      b^) Try emptying the recycle bin >>!bat_warningfile!
							if "bat_winver" lss "6.0" (
								echo           ^(rd /s !bat_targetdrive!\recycler^)>>!bat_warningfile!
							) else (
								echo           ^(rd /s !bat_targetdrive!\$Recycle.Bin^)>>!bat_warningfile!
							)
							echo      c^) Use Disk Cleanup to free up temporary space and other areas.>>!bat_warningfile!
							echo      d^) Move "!bat_targetlocation!CAMS\SubmissionFiles" to an external hard drive.>>!bat_warningfile!
							echo      e^) Move "!bat_targetlocation!CAMS\CapturedFiles" to an external hard drive.>>!bat_warningfile!
							echo.
							!bat_logexec! type "!bat_warningfile!"

							if /i "!bat_freeMB!" neq "" (
								start /max notepad "!bat_warningfile!"
							)
						)& rem if !bat_estSizeMB!...
				)& rem "!bat_SIMULATION.capture!" neq "true"

			)& rem "%%a" neq "----------"...
		)& rem for /f "usebackq tokens=1-16 skip=2 delims=," ...
		!bat_pop!
	!bat_pop!

:REVIEW_END
!bat_poplog! [RETURN !bat_batchfile!:REVIEW] []
!bat_log!
!bat_return!





	rem start the execution of the meteor detection pass in background priority

	rem start /min sndrec32 /play /close %windir%\media\ding.wav

:GETDELAY
!bat_pushlog! [CALL !bat_batchfile!:GETDELAY] %*
	rem set /a bat_waituntil=!bat_delay!
	rem set /a bat_startmin=!ftp_mi!+1
	set /a bat_delayhh=!bat_delaycalc!/3600
	set bat_delayhh=00!bat_delayhh:~-2!
	set bat_delayhh=!bat_delayhh:~-2!
	call :STRIPZEROS !bat_delayhh! bat_delay_h
	set /a bat_delaymm=(!bat_delaycalc!-(!bat_delay_h!*3600))/60
	rem set /a bat_delaymm=(!bat_delaycalc!-(!bat_delayhh!*3600))/60
	set bat_delaymm=00!bat_delaymm:~-2!
	set bat_delaymm=!bat_delaymm:~-2!
	call :STRIPZEROS !bat_delaymm! bat_delay_m
	set /a bat_delayss=(!bat_delaycalc!-(!bat_delay_h!*3600))-(!bat_delay_m!*60)
	set bat_delayss=00!bat_delayss:~-2!
	set bat_delayss=!bat_delayss:~-2!

	set bat_unique=ftp_capture_!ftp_year!!ftp_mo!!ftp_da!!ftp_hr!!bat_startmin!

:GETDELAY_END
!bat_poplog! [RETURN !bat_batchfile!:GETDELAY] [!bat_delaycalc! seconds, bat_delayhh=!bat_delayhh!, bat_delaymm=!bat_delaymm!, bat_delayss=!bat_delayss!, bat_unique=!bat_unique!]
!bat_log!
!bat_return!




:WAITDELAY
!bat_pushlog! [CALL !bat_batchfile!:WAITDELAY] %*
	!bat_echolog!
	!bat_echolog! Waiting !bat_delaycalc! seconds ^(delay of !bat_delayhh!:!bat_delaymm!:!bat_delayss!^) from the current time of 
	!bat_echolog! !ftp_hhmmssdd_local! local time until !bat_date! !bat_dusklocal!.
	!bat_echolog!
	!bat_echolog! Then running: call "!bat_capturebat!" !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation!
	!bat_echolog!
	!bat_echolog! !bat_batchfile! - Waiting until !bat_dusklocal! for call "!bat_capturebat!" !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation!
	        title !bat_batchfile! - Waiting until !bat_dusklocal! for call "!bat_capturebat!" !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation!

	!bat_echolog!
	!bat_echolog! start /w wait !bat_delaycalc!
	
	set /a bat_tenth=(!bat_delaycalc!)/10

	call :VARIABLES_LOG bat_log

	if /i "!bat_CAPTURE.waitdelay!" equ "no wait" (
		!bat_echolog! '    SKIPPING WAITDELAY - CAPTURE.waitdelay=!bat_CAPTURE.waitdelay!
		goto :WAITDELAY_END
	)


	set bat_titlestring=Waiting until !bat_dusklocal! for call "!bat_capturebat!" !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation!
	if "!bat_SIMULATION.capture!" equ "true" (
		!bat_echolog! '    SIMULATION - SKIPPING WAITDELAY
		goto :WAITDELAY_END
	)& rem if "!bat_SIMULATION.capture!"...


	!bat_push!
			 title %0- ---------- !bat_titlestring!
			 !bat_echolog! '     %0- ---------- !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- #---------  !bat_titlestring!
			 !bat_echolog! '     %0- #---------  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- ##--------  !bat_titlestring!
			 !bat_echolog! '     %0- ##--------  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- ###-------  !bat_titlestring!
			 !bat_echolog! '     %0- ###-------  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- ####------  !bat_titlestring!
			 !bat_echolog! '     %0- ####------  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- #####-----  !bat_titlestring!
			 !bat_echolog! '     %0- #####-----  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- ######----  !bat_titlestring!
			 !bat_echolog! '     %0- ######----  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- #######---  !bat_titlestring!
			 !bat_echolog! '     %0- #######---  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- ########--  !bat_titlestring!
			 !bat_echolog! '     %0- ########--  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- #########-  !bat_titlestring!
			 !bat_echolog! '     %0- #########-  !bat_titlestring!
		 start /w wait !bat_tenth!
						   title %0- ##########  !bat_titlestring!
			 !bat_echolog! '     %0- ##########  !bat_titlestring!
	!bat_pop!

:WAITDELAY_END
!bat_poplog! [RETURN !bat_batchfile!:WAITDELAY] [!bat_delaycalc!]
!bat_log!
!bat_return!




:CAPTURE
!bat_pushlog! [CALL !bat_batchfile!:CAPTURE] %*

	!bat_logexeclog! set bat_


	!bat_log! if /i "!bat_CAPTURE.capture_mode!" equ "capturetwoanddetect" ^(
	if           /i "!bat_CAPTURE.capture_mode!" equ "capturetwoanddetect" (
		call :CAPTURETWO %*
		goto :CAPTURE_END
	)

	set bat_titlestring=!bat_captureexe! !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation! !bat_autonomous!
	!bat_echolog! [!date! !time!] start " " cmd /c ""!bat_capturebat!" !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation! !bat_autonomous!"
	                              start " " cmd /c ""!bat_capturebat!" !bat_CD_flag! !bat_camera! !bat_dur! !bat_targetlocation! !bat_autonomous!"

:CAPTURE_END
!bat_poplog! [RETURN !bat_batchfile!:CAPTURE] %*
!bat_log!
!bat_return!






:CAPTURETWO
!bat_pushlog! [CALL !bat_batchfile!:CAPTURETWO] 
	set bat_titlestring=!bat_capturebat! !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_dur! !bat_targetlocation! !bat_autonomous!
	!bat_echolog! !bat_titlestring!

	!bat_echolog! [!date! !time!] start " " cmd /c ""!bat_capturebat!" !bat_CD_flag! "!bat_CAPTURE.cameralist!" !bat_dur! !bat_targetlocation! !bat_autonomous!"
	                              start " " cmd /c ""!bat_capturebat!" !bat_CD_flag! "!bat_CAPTURE.cameralist!" !bat_dur! !bat_targetlocation! !bat_autonomous!"

:CAPTURETWO_END
!bat_poplog! [RETURN !bat_batchfile!:CAPTURETWO] [!bat_titlestring!]
!bat_log!
!bat_return!















:POSTCAPTURE
!bat_pushecho! [CALL !bat_batchfile!:POSTCAPTURE] %*
	call GETCAPTUREDIR %*
	call GETARCHIVEDDIR %*

:POSTCAPTURE_END
!bat_popecho! [RETURN !bat_batchfile!:POSTCAPTURE] [bat_captureddir="!bat_captureddir!", bat_archiveddir="!bat_archiveddir!", bat_captureddate=!bat_captureddate!]
!bat_log!
!bat_return!


	

:GETCAPTUREDIR
!bat_pushecho! [CALL !bat_batchfile!:GETCAPTUREDIR] %*
	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe/FTP_Capture.exe program.
	!bat_pushecho! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_log! bat_targetsearchdir=%%~a
					set bat_targetsearchdir=%%~a

					!bat_log! bat_captureddir=%%~a
					set bat_captureddir=%%~a

					!bat_log! set bat_captureddirname=%%~nxa
					set bat_captureddirname=%%~nxa

					set bat_capturedbasedir=%%~dpa::
					set bat_capturedbasedir=!bat_capturedbasedir:\::=!
					set bat_capturedbasedir=!bat_capturedbasedir:::=!
				)
			)
		)
	)
	!bat_pop!
	
	set bat_captureddate=!bat_captureddirname:~0,10!

	!bat_logexec! set bat_cap
:GETCAPTURE_END
!bat_popecho! [RETURN !bat_batchfile!:GETCAPTURE] [bat_captureddir=!bat_captureddir!]
!bat_log!
!bat_return!


:GETARCHIVEDDIR
!bat_pushecho! [CALL !bat_batchfile!:GETARCHIVEDDIR] %*
	set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe/FTP_Capture.exe program.
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_targetsearchdir=%%~a
					!bat_log! bat_targetsearchdir=%%~a

					set bat_archiveddir=%%~a
					!bat_log! bat_archiveddir=%%~a

					!bat_echolog! set bat_archiveddirname=%%~nxa
					set bat_archiveddirname=%%~nxa

					set bat_archivedbasedir=%%~dpa::
					set bat_archivedbasedir=!bat_archivedbasedir:\::=!
					set bat_archivedbasedir=!bat_archivedbasedir:::=!
				)
			)
		)
	)
	
	set bat_archiveddate=!bat_archiveddirname:~0,10!
	!bat_logexec! set bat_archived

	set bat_detectfile=!bat_archiveddir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	!bat_echolog! if not exist "!bat_detectfile!" ...
	if not exist "!bat_detectfile!" (
		!bat_echolog!
		!bat_echolog! ERROR - "!bat_detectfile!" not found...
		!bat_echolog!
		!bat_logexec! dir "!bat_archiveddir!\ftpdetect*.*" /s/b /a-d /od
		goto :POSTCAPTURE_END
	) else (
		REM move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"
	)

:GETARCHIVEDDIR
!bat_popecho! [RETURN !bat_batchfile!:GETARCHIVEDDIR] [bat_archiveddir=!bat_archiveddir!]
!bat_log!
!bat_return!







:MULTISCAN
!bat_pushecho! [CALL !bat_batchfile!:MULTISCAN] %*
	!bat_pushecho! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_log! bat_targetsearchdir=%%~a
					set bat_targetsearchdir=%%~a
					!bat_log! bat_captureddir=%%~a
					set bat_captureddir=%%~a
				)
			)
		)
	)
	!bat_pop!

	echo.>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo @echo off>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo setlocal enableextensions enabledelayedexpansion>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	for /f "usebackq tokens=*" %%a in (`set`) do (
		set %%a>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	)

	echo call makeCaseListing.bat "!bat_captureddir!">>"!bat_captureddir!\rerun_makeCaseListing.bat"

	!bat_logexec! call makeCaseListing.bat "!bat_captureddir!"

:MULTISCAN_END
!bat_popecho! [RETURN !bat_batchfile!:MULTISCAN] []
!bat_log!
!bat_return!



:WAITFORMULTISCAN
!bat_pushecho! [CALL !bat_batchfile!:WAITFORMULTISCAN] %*
	start /w wait 60

	set bat_archivedsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_archivedsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_log! bat_archiveddir=%%~a
					set bat_archiveddir=%%~a
				)
			)
		)
	)

	!bat_pushecho! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in (`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					call WaitForFile rw "%%a"
				)
			)
		)
	)
	!bat_pop!
	
:WAITFORMULTISCAN_END
!bat_popecho! [RETURN !bat_batchfile!:WAITFORMULTISCAN] %*
!bat_log!
!bat_return!


:POSTMULTISCAN
!bat_pushecho! [CALL !bat_batchfile!:POSTMULTISCAN] %*
	!bat_logexec! call PostMultiScanCalibration.bat "!bat_archiveddir!"

:POSTMULTISCAN_END
!bat_popecho! [RETURN !bat_batchfile!:POSTMULTISCAN] []
!bat_log!
!bat_return!


rem	EXIT

goto :DONE




:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat" %*
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat" %*
EXIT /b 0







:CALCDURATION
!bat_pushlog! [CALL !bat_batchfile!:CALCDURATION] %*
	call :PARSEOFFTIME "!bat_off!"
	call :PARSEONTIME "!bat_on!"
	

	rem set /a bat_temp=!bat_onsec!-!bat_offsec!
	
	rem                           bat_onh   bat_onm   bat_ons bat_offh  bat_offm  bat_offs
	rem                            %1        %2        %3        %4       %5         %6
	rem call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th4! !bat_tm4! !bat_ts4!
	
	!bat_log! set /a bat_durtotalsecs=(!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!
	          set /a bat_durtotalsecs=(!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!
	!bat_log! set /a                  (!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!
	          set /a                  (!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!
	
	!bat_push!
		!bat_push!
			!bat_echolog! Total duration=^(!bat_midnightsecs!-!bat_onsec!^)+!bat_offsec!=!bat_durtotalsecs! seconds

			set /a bat_temp=(!bat_durtotalsecs!*100)/3600
			set /a bat_temph=(!bat_durtotalsecs!)/3600
			set /a bat_tempm=!bat_temp:~-2!
			set bat_tempm=00!bat_tempm!
			set bat_tempm=!bat_tempm:~-2!
			set bat_dur=!bat_temph!.!bat_tempm!

			set /a bat_durh=!bat_durtotalsecs!/3600
			set /a bat_durm=(!bat_durtotalsecs!-(!bat_durh!*3600))/60
			set /a bat_durs=(!bat_durtotalsecs!-(!bat_durh!*3600))-(!bat_durm!*60)

			call :PADZERO bat_offh
			call :PADZERO bat_offm
			call :PADZERO bat_offs
			call :PADZERO bat_durh
			call :PADZERO bat_durm
			call :PADZERO bat_durs

			!bat_echolog! '   !bat_offh!:!bat_offm!:!bat_offs!	Camera OFF time ^(next morning^)
			!bat_echolog! '-  !bat_ONh!:!bat_ONm!:!bat_ONs!	Current ON time
			!bat_echolog! '-----------------
			!bat_echolog! '   !bat_durh!:!bat_durm!:!bat_durs!   !bat_msg! ^<---- duration h:mm:ss ^(!bat_dur! hours^)
			!bat_echolog!
		!bat_pop!
	!bat_pop!
	
	if /i "!bat_CAPTURE.sunangle!" equ "true" (
		set bat_dur=!bat_CAPTURE.sunangle_dusk!
		!bat_echolog! Using sun angle: [!bat_CAPTURE.sunangle_dusk!]
	)
	
:CALCDURATION_END
!bat_poplog! [RETURN !bat_batchfile!:CALDURATION] [bat_durtotalsecs=!bat_durtotalsecs!; 
!bat_log! '                                       ON=!bat_durh!, !bat_durm!, !bat_durs!;
!bat_log! '                                       OFF=!bat_offh!, !bat_offm!, !bat_offs!]
!bat_log!
!bat_return!





:CALCDELAY
!bat_pushlog! [CALL !bat_batchfile!:CALCDELAY] %*
	rem Usage: call :CALCDELAY "!bat_on!" "!ftp_hhmmssdd!"
	call :PARSECURTIME "%~2"
	call :PARSEONTIME "%~1"
	
	set /a bat_temp=!bat_onsec!-!bat_cursec!
	
	rem                       bat_onh   bat_onm   bat_ons bat_curh  bat_curm  bat_curs
	rem                        %1        %2        %3        %4       %5         %6
	call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th3! !bat_tm3! !bat_ts3!
	
	set /a bat_delay=!bat_newh!*3600+!bat_newm!*60+!bat_news!
	set bat_delaycalc=!bat_delay!
	set bat_msg= 
	
	!bat_push!
	if !bat_delay! lss 0 (
		rem                       bat_curh  bat_curm  bat_curs bat_onh   bat_onm   bat_ons
		rem                        %1        %2        %3        %4       %5         %6
		call :SUBTRACTONMINUSCUR !bat_th3! !bat_tm3! !bat_ts3! !bat_th1! !bat_tm1! !bat_ts1!
		set /a bat_delay=0
		set /a bat_delaycalc=0
		set bat_on=!ftp_hhmmssdd!
		!bat_log! Delay=!bat_delay! seconds
		set bat_msg=   IMMEDIATE [we're starting late]   
	) else (
		!bat_log! Delay=!bat_delaycalc! seconds
	)
	!bat_pop!
	
	call :PADZERO bat_ONh
	call :PADZERO bat_ONm
	call :PADZERO bat_ONs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
	
	call :DISPLAY

:CALCDELAY_END
!bat_poplog! [RETURN !bat_batchfile!:CALCDELAY] [bat_delay=!bat_delay!]
!bat_log!
!bat_return!




:PARSECURTIME
!bat_pushlog! [CALL !bat_batchfile!:PARSECURTIME] %*
	set bat_curtime=%~1
	set bat_curh=!bat_curtime:~0,2!
	set bat_curm=!bat_curtime:~3,2!
	set bat_curs=!bat_curtime:~6,2!!bat_curtime:~-2!

	rem strip zeros
	for /f "tokens=* delims=0" %%m in ("!bat_curs!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_curs=0
	) else (
		set bat_curs=!bat_nz!
	)

	rem round up to the next second
	set /a bat_curs=!bat_curs!+50
	set /a bat_curs/=100
	call :PADZERO bat_curs
	
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_curh! bat_th1
	
	set /a bat_cursec=!bat_th1!*3600+!bat_tm1!*60+!bat_ts1!	

:PARSECURTIME_END
!bat_poplog! [RETURN !bat_batchfile!:PARSECURTIME] [bat_cursec=!bat_cursec!]
!bat_log!
!bat_return!




:PARSEONTIME
!bat_pushlog! [CALL !bat_batchfile!:PARSEONTIME] %*
	set bat_ontime=%~1
	set bat_onh=!bat_ontime:~0,2!
	set bat_onm=!bat_ontime:~3,2!
	set bat_ons=!bat_ontime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_ons! bat_ts3
	call :STRIPZEROS !bat_onm! bat_tm3
	call :STRIPZEROS !bat_onh! bat_th3
	
	set /a bat_onsec=!bat_th3!*3600+!bat_tm3!*60+!bat_ts3!	

:PARSEONTIME_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEONTIME] [bat_onsec=!bat_onsec!]
!bat_log!
!bat_return!





:PARSEOFFTIME
!bat_pushlog! [CALL !bat_batchfile!:PARSEOFFTIME] %*
	set bat_offtime=%~1
	set bat_offh=!bat_offtime:~0,2!
	set bat_offm=!bat_offtime:~3,2!
	set bat_offs=!bat_offtime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_offs! bat_ts4
	call :STRIPZEROS !bat_offm! bat_tm4
	call :STRIPZEROS !bat_offh! bat_th4
	
	set /a bat_offsec=!bat_th4!*3600+!bat_tm4!*60+!bat_ts4!	
	
:PARSEOFFTIME_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEOFFTIME] [bat_offsec=!bat_offsec!]
!bat_log!
!bat_return!




:PARSEOFFSET
!bat_pushlog! [CALL !bat_batchfile!:PARSEOFFSET] %*
	set /a bat_delay=%~1
	set /a bat_OFFh=!bat_delay!/3600
	set /a bat_OFFr=!bat_delay!-(!bat_OFFh!*3600)
	set /a bat_OFFm=!bat_OFFr!/60
	set /a bat_OFFs=!bat_OFFr!-(!bat_OFFm!*60)
:PARSEOFFSET_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEOFFSET] [!bat_OFFh!, !bat_OFFr!, !bat_OFFm!, !bat_OFFs!
!bat_log!
!bat_return!




:SUBTRACTONMINUSCUR
!bat_pushlog! [CALL !bat_batchfile!:SUBTRACTIONMINUSCUR] %*
	rem echo :SUBTRACTONMINUSCUR %1:%2:%3    %4:%5:%6
	set /a bat_remainder=0

	set /a bat_news=%6-%3
	if !bat_news! lss 0 (
		set /a bat_news=!bat_news!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newm=%5-%2-!bat_borrow!
	if !bat_newm! lss 0 (
		set /a bat_newm=!bat_newm!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newh=%4-%1-!bat_borrow!
	if !bat_newh! lss 0 (
		set /a bat_newh=!bat_newh!
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
:SUBTRACTONMINUSCUR_END
!bat_poplog! [RETURN !bat_batchfile!:SUBTRACTIONMINUSCUR] [difference in h,m,s=!bat_newh!, !bat_newm!, !bat_news!]
!bat_log!
!bat_return!





:DISPLAY
!bat_pushlog! [CALL !bat_batchfile!:DISPLAY] %*
	!bat_echolog! '   !bat_ONh!:!bat_ONm!:!bat_ONs!	Camera ON time (adjusted from !bat_calcedon!)
	rem       echo +  !bat_OFFh!:!bat_OFFm!:!bat_OFFs!	Current Time
	!bat_echolog! '-  !bat_curh!:!bat_curm!:!bat_curs!	Current time
	!bat_echolog! '-----------------
	!bat_echolog! '   !bat_newh!:!bat_newm!:!bat_news! LT  !bat_msg! ^<---- Waiting h:mm:ss
	!bat_echolog!

:DISPLAY_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAY] []
!bat_log!
!bat_return!





:ADDTIMEPLUSOFFSET
!bat_pushlog! [CALL !bat_batchfile!:ADDTIMEPLUSOFFSET] %*
	set /a bat_remainder=0

	set bat_ts1=0&set bat_ts2=0
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_OFFs! bat_ts2

	set /a bat_news=!bat_ts1!+!bat_ts2!
	if !bat_news! gtr 59 (
		set /a bat_news=!bat_news!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_OFFm! bat_tm2
	set /a bat_newm=!bat_tm1!+!bat_carry!+!bat_tm2!
	if !bat_newm! gtr 59 (
		set /a bat_newm=!bat_newm!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curh! bat_th1
	call :STRIPZEROS !bat_OFFh! bat_th2
	set /a bat_newh=!bat_th1!+!bat_carry!+!bat_th2!
	if !bat_newh! gtr 23 (
		set /a bat_newh=!bat_newh!-24
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :PADZERO bat_OFFh
	call :PADZERO bat_OFFm
	call :PADZERO bat_OFFs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news

:ADDTIMEPLUSOFFSET_END
!bat_poplog! [RETURN !bat_batchfile!:ADDTIMEPLUSOFFSET] [!bat_OFFh!, !bat_OFFm!, !bat_OFFs!, !bat_newh!, !bat_newm!, !bat_news!]
!bat_log!
!bat_return!




:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)

:STRIPZEROS_END
EXIT /b


:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
:PADZERO_END
!bat_return!




:CALCDAYNUMBER
!bat_pushlog! [CALL !bat_batchfile!:CALCDAYNUMBER] %*

	rem Usage: call :CALCDAYNUMBER day
	rem   where day is the day number from the sunsettable.txt file.  In that file,
	rem   the day number in in the file for the first date (01/01/2011) has a value
	rem   of zero.  It should be reported as day 1 and 12/31/2011 is 365 and
	rem   01/01/2012 is day 365, which should be reported as day 1 of year 2012. 
	rem   The only thing that should be an issue between different people using this
	rem   is the bat_offset number below (109600), which may need to be adjusted 
	rem   depending how how many days of offset from a daylight savings date
	rem   is used as the base date.  
	
	set /a bat_day=%1*100
	set /a bat_offset=109600
	set /a bat_year=36525
	
	set /a bat_divide=(((!bat_day!+!bat_offset!)*10000)/!bat_year!)
	set /a bat_int=((!bat_day!+!bat_offset!)/36525)
	set /a bat_mod=!bat_divide!-(!bat_int!*10000)
	set /a bat_res1=!bat_mod!*36525
	set /a bat_res2=!bat_res1!+100000
	set /a bat_res3=(!bat_res2!/1000000)+1
	set bat_res3=!bat_res3!   
	set bat_res3=!bat_res3:~0,3!

:CALCDAYNUMBER_END
!bat_poplog! [RETURN !bat_batchfile!:CALCDAYNUMBER] [TodayJulian=!bat_res1!, TomorrowJulian!bat_res2!, Day of Year=!bat_res3!]
!bat_log!
!bat_return!


:CALCREQDISK
!bat_pushlog! [CALL !bat_batchfile!:CALCREQDISK] %*
	set bat_diskspacememo=OK
	call :CHECKDISKSPACE
	

	rem convert hours into seconds
	set /a bat_duration_secs=0
	for /f "usebackq tokens=1,2 delims=." %%a in ('!bat_duration!') do (
		echo a=%%a, b=%%b
		set bat_CRD_dec=%%b00
		set bat_CRD_dec=!bat_CRD_dec:~0,2!
		set bat_CRD_dec=00!bat_CRD_dec!
		set bat_CRD_dec=!bat_CRD_dec:~-2!
		set /a bat_duration_secs=%%a * 3600 + %%b
	)
	

	set /a bat_estCapFiles=!bat_duration_secs!00/(2560000 / !bat_CAPTURE.fps!)
	
	rem note: 1,228,820 bytes per ff*.bin file is 1.1719 MB per file
	rem       therefore, 4055 files * 11719mb/file / 10000 = 4752 MB or 4.752 GB
	set /a bat_estSizeMB=!bat_estCapFiles!*11719/10000

	!bat_log! Single camera one night file count   : !bat_estCapFiles! files
	!bat_log! Single camera one night requirements : !bat_estSizeMB! MB
	if defined bat_CAPTURE.number.of.cameras (
		set /a bat_estSizeMB=bat_estSizeMB * bat_CAPTURE.number.of.cameras
	)

	!bat_log! All cameras one night requirements   : !bat_estSizeMB! MB
	set /a bat_reqdisk=!bat_estSizeMB!*!bat_AUTOCAMS.diskspacewarning.days!
	set bat_freeMB=!bat_targetfreespace!
	
	!bat_log! All cameras !bat_AUTOCAMS.diskspacewarning.days! nights requirements   : !bat_reqdisk! MB
	set /a bat_sizediff=!bat_reqdisk!-!bat_freeMB!

	if !bat_reqdisk! GEQ !bat_freeMB! (
		set bat_diskspacememo=********* DISK SPACE WARNING! ************
	)


:CALCREQDISK_END
!bat_poplog! [RETURN !bat_batchfile!:CALCREQDISK] [bat_reqdisk=!bat_reqdisk!, bat_freeMB=!bat_freeMB!, bat_sizediff=!bat_sizediff!, bat_diskspacememo=!bat_diskspacememo!]
!bat_log!

!bat_return!



:CHECKDISKSPACE
!bat_pushlog! [CALL !bat_batchfile!:CHECKDISKSPACE] %*
	wmic /?>nul:
	if %errorlevel% equ 9009 (
		exit /b
		set bat_free=9999999
		set bat_size=9999999
		set bat_freeMB=999999999
	)

	set bat_targetdrive=!bat_targetlocation:~0,2!
	
	rem Note: We have to do it this way because WMIC outputs unicode and
	rem FINDSTR is not compatible with unicode strings.
	rem echo wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-2* skip=1" %%a in (`type "!bat_tempfile!"^|findstr /r /c:","`) do (
		set bat_free=%%b
		set bat_size=%%c
		if "!bat_free!" neq "" (
			set bat_freeMB=!bat_free:~0,-6!
			set bat_targetfreespace=!bat_freeMB!
		)
	)

:CHECKDISKSPACE_END
!bat_poplog! [RETURN !bat_batchfile!:CHECKDISKSPACE] [bat_freeMB=!bat_freeMB!, bat_targetfreespace=!bat_targetfreespace!]
!bat_log!
!bat_return!
	
	wmic logicaldisk where "name='!bat_targetdrive!'" get freespace /format:csv>"!bat_tempfile!"
	for /f "usebackq tokens=1-2 delims=," %%a in (`type "!bat_tempfile!"^|findstr /r /c:"%computername%"`) do (
		rem echo %%a, %%b
		set bat_targetfreespace=%%b
		set bat_freeMB=%%b
	)


:GETWINDOWSVER
!bat_pushlog! [CALL !bat_batchfile!:GETWINDOWSVER] %*
	wmic /?>nul:
	if %errorlevel% equ 9009 (
		exit /b
		set bat_free=9999999
		set bat_size=9999999
		set bat_freeMB=999999999
	)
	rem echo :GETWINDOWVER wmic os get version, caption, windowsdirectory /format:list^|findstr /r /c:"=" ... "!bat_tempfile!"
	wmic os get version, windowsdirectory /format:csv|findstr /r /c:",">"!bat_tempfile!"
	rem type "!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-4*" %%a in (`type "!bat_tempfile!"`) do (
		if "%%b" gtr "!" (
			set bat_winver=%%b
		)
	)
:GETWINDOWSVER_END
!bat_poplog! [RETURN !bat_batchfile!:GETWINDOWSVER] [!bat_winver!]
!bat_log!
!bat_return!


:CALCTIMEREM

:CALCTIMEREM_END
!bat_return!



:SETCAPTUREEXE
!bat_pushlog! [CALL !bat_batchfile!:SETCAPTUREEXE] %*
	rem [in]	
	rem [out]	bat_captureexesrc
	rem [out]	bat_captureexe
	rem	[out[	bat_capturebat
	rem [out]	bat_CD_flag

	rem These settings are now handled by the following parameters in the
	rem AutoCams.Params.ini file:
	rem  - capture_mode=capture, captureanddetect, or capturetwoanddetect
	rem  - bat_capturebat=FTP_Capture.bat, CaptureAndDetect.bat, or CaptureTwoAndDetect.bat
	rem  - bat_captureexe=FTP_Capture.exe, FTP_CaptureAndDetect.exe, or FTP_CaptureTwoAndDetect.exe
	rem  - bat_captureexesrc=FTP_Capture.exe, FTP_CaptureAndDetect.exe, or FTP_CaptureTwoAndDetect.exe
	rem  - archive_flag=-1, 0, 1, or 2
	rem  - cameralist=213, or 213 216

	if /i "!bat_CAPTURE.capture_mode!" equ "capture" (
		set bat_CD_flag=
		goto :SETCAPTUREEXE_END
	)
	

:SETCAPTUREEXE_END
		!bat_echolog! ' Capture mode in AutoCams.Params.ini is:
		!bat_echolog! '     "!bat_CAPTURE.capture_mode!" 
		!bat_echolog! '     so using:
		!bat_echolog! '       archive_flag=!bat_CAPTURE.archive_flag!
		!bat_echolog! '       cameralist=!bat_CAPTURE.cameralist!
		!bat_echolog! '       !bat_capturebat!
		!bat_echolog! '       !bat_captureexe!
		!bat_echolog! '       !bat_captureexesrc!
!bat_poplog! [RETURN !bat_batchfile!:SETCAPTUREEXE] [src=!bat_captureexesrc!, dest=!bat_captureexe!]
!bat_echolog!
!bat_return!





:COPYEXE
!bat_pushlog! [CALL !bat_batchfile!:COPYEXE] %*
	!bat_logexec! copy /y "!bat_exedir!\!bat_captureexesrc!" "!bat_exedir!\!bat_captureexe!"

:COPYEXE_END 
	!bat_poplog! [RETURN !bat_batchfile!:COPYEXE] [!bat_captureexe!]
!bat_log!
!bat_return!




:VARIABLES_LOG
!bat_pushlog! [CALL !bat_batchfile!:VARIABLES_LOG] []
	!%~1! set bat_
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`set bat_`) do (
		!%~1! %%a
	)
	!%~1!
	!bat_pop!

	!%~1! set ftp_
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`set ftp_`) do (
		!%~1! %%a
	)
	!%~1!
	!bat_pop!
:VARIABLES_LOG_END
!bat_poplog! [RETURN !bat_batchfile!:VARIABLES_LOG] []
!bat_log!
!bat_return!



:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_echolog! call "!bat_exedir!\ReadParams.bat"
				  CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!













:HELP
	echo ================================================================
    echo     %~nx0		batch file name
    echo.
    echo     Usage: %~nx0 cameranumber duration "targetdir" [autonomous] [/?]
    echo.
    echo   Where:
    echo     cameranumber     The camera number
    echo.
    echo     duration         The duration is only a dummy value that 
    echo                      is no longer used ^(enter any number, such as 
    echo                      0^).  Instead, the script was updated to 
    echo                      calculate the duration value from the launch 
    echo                      time and/or the !bat_sunsettable! file.  
    echo.
    echo     "targetdir"      You should put quotes around it just in case
    echo                      there are spaces in the dir/path.  This value
    echo                      should represent the parent dir of the CAMS
    echo                      directory.  For example: "C:\" if the CAMS
    echo                      directory is on "C:\CAMS".
    echo.
    echo     autonomous       This enables autonomous mode. In 
    echo                      autonomous mode, it performs all the
    echo                      processing steps after capture, including:
    echo                      autocal, apply cal, submission, zip, 
    echo                      and ^(in the future, ftp upload^)
    echo.
    echo   This script runs as follows:
    echo      1^) Looks up the dusk/dawn and other values from the 
    echo         "!bat_sunsettable!" file
    echo      2^) Calculates the duration
    echo      3^) Delays until the camera ON time
    echo      4^) Launches the "!bat_capturebat!" script. 
    echo.
    echo   %~n0 can be run by either of the following methods:
    echo       - Windows Task Scheduler
    echo       - Command-line
    echo       - AutoCams Utility menu
    echo.
    echo   It can't be launched by double-clicking on it from Windows
    echo   because the required arguements wouldn't be supplied.
    echo.
    echo   Preferably, %~n0 was designed to be launched from Windows Task
    echo   Scheduler with all the parameters supplied as command-line
    echo   arguments.  
    echo.
    echo   CheckTwilight.bat was provided for you to preview and validate 
    echo   the calculated times and durations.  You will set your wall 
    echo   timer and the Windows Task Scheduler according to the 
    echo   CheckTwilight.bat report. 
    echo.
    echo   If you run it from a command shell or batch script, you must
    echo   specify the camera number, duration, and target location as 
    echo   command-line arguments.  If the command-line arguments don't 
    echo   provide all the necessary parameters, this help text will be 
    echo   displayed.
    echo.
    echo   If it is executed after the scheduled Camera ON time, then 
    echo   there will be no delay and CaptureAndDetect.bat will be launced
    echo   immediately and the duration will be calculated based on that
    echo   start time.
    echo.
    echo   Example ^(assume this is run at 17:00:00 local and the 
    echo   "!bat_sunsettable!" Camera ON/OFF times are ON=18:51:09, OFF=
    echo   06:45:40^):
    echo.
    echo       %~n0 299 -1 "h:"          The camera capture is delayed for
    echo                                          1:51:09 hours until 
    echo                                          the Camera ON time, after
    echo                                          which, Capture is
    echo                                          launched with the calculated
    echo                                          duration value ^(11.91 hours^), 
    echo.
    echo   Example ^(assume this is run at 19:30:15 local and the 
    echo   "!bat_sunsettable!" Camera ON/OFF times are ON=18:51:09, OFF=
    echo   06:45:40^):
    echo.
    echo       %~n0 299 -1 "h:"          The camera capture is not delayed, 
    echo                                          19:30:15 will be substituted 
    echo                                          as the new camera ON time 
    echo                                          and Capture is launched with 
    echo                                          the calculated duration value 
    echo                                          ^(11.26 hours^), which will 
    echo                                          calculate an accurate duration 
    echo                                          based on the camera ON time and 
    echo                                          the camera OFF time.
    echo.
    echo.
    echo   See the CaptureAndDetect.bat or FTP_Capture.bat for more on the capture program.
    echo.
    echo   The AutoCams.Params.ini file contains settings that govern which
    echo   script that this script chains to for capture. 
    echo   The current capture script is: "!bat_capturebat!".
:HELP_END
EXIT /b -99
    
goto :DONE


:DONE
	!bat_pop!
	!bat_echolog! [!date!, !time!] !bat_batchfile!:DONE] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	rem Wait a few seconds to allow the user to view what's happening.
	!bat_echolog! start /w wait 5
rem                   start /w wait 5
	exit
:DONE2
	!bat_echolog! [!date!, !time!] !bat_batchfile!:DONE] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	exit /b
