@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    

:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_title! 
	
	echo.bat_STAGE.MaxDaysToKeep=!bat_STAGE.MaxDaysToKeep!

goto :MAIN %*




:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	!bat_call! "!bat_exedir!\ListDrives.bat" 
	%bat_WAIT% 10

	set bat_returncode=0
	
	set bat_date_prev=2011_01_01
	set /a bat_daycount=0

	rem First, create a directory list in descending date order...
	rem Example, one of the results would be something like this: 
	rem    D:\cams16\cams\submissionfiles\2015_11_18_258_01_28_40\258\CapturedFiles
    for /f "usebackq tokens=*"  %%a in (`dir "SubmissionFiles\CapturedFiles" /ad /s/b /o-n^|sort /r`) do (

		rem For each date in descending order, the loop variable will be the actual dir name.
		rem Example, for "D:\cams16\cams\submissionfiles\2015_11_18_258_01_28_40\258\CapturedFiles" 
		rem from the outer loop, the resulting inner loop variable would be:
		rem     D:\cams16\cams\submissionfiles\2015_11_18_258_01_28_40\258\CapturedFiles\2015_11_18_01_28_40
		for /f "usebackq tokens=*" %%b in (`dir "%%a\*" /s/b /ad`) do (
			
			set bat_dirfull=%%b
			set bat_temp_file=%%~nxb
		
			set bat_date_current=!bat_temp_file:~0,10!
			!bat_echolog! bat_date_current=!bat_date_current!, %%b

			rem Since there may be multiple capture sessions per date, we only want to count
			rem dates, not dirs.  However, if there are some dates missing, for example
			rem 2015_11_18, 2015_11_10, the missing dates don't count toward the "n" in
			rem "n" days to keep.  The reason for this is because we are only really concerned with
			rem disk space management and it wouldn't help to do disk space management on missing
			rem dirs.  
			if /i "!bat_date_current!" neq "!bat_date_prev!" (
				set /a bat_count+=1
				!bat_echo! set /a !bat_count!
				set bat_date_prev=!bat_date_current!
			)
			
			echo.if /i !bat_count! GTR !bat_STAGE.MaxDaysToKeep!...
			if /i !bat_count! GTR !bat_STAGE.MaxDaysToKeep! (
				!bat_echolog! ........[!bat_count!:!bat_STAGE.MaxDaysToKeep!] DEL /s /q "!bat_dirfull!\*.bin"
				DEL /s /q "!bat_dirfull!\*.bin"
				echo.
			) else (
				!bat_echolog! ........[!bat_count!:!bat_STAGE.MaxDaysToKeep!] NOT DELETING "!bat_dirfull!\*.bin"
				ECHO.
			)

		)
	)


	for /f "usebackq tokens=*"  %%a in (`dir "Submitted" /ad /s/b /o-n^|sort /r`) do (
		!bat_logexec! del /s /q "%%a"
	)

	

	!bat_call! "!bat_exedir!\ListDrives.bat" 


	!bat_WAIT! 90
goto :DONE

	
	(
rem		for /f "usebackq tokens=*" %%a in (`type "!bat_tempfile_full!"`) do (
rem			!bat_logexec! set %%a
rem		)
	)


	REM Leave the file there so it doesn't need to be recreated.
	if exist "!bat_tempfile_full!" (
rem		!bat_logexeclog! del /q "!bat_tempfile_full!"
	)

:MAIN_END
!bat_log! [END-!bat_batchfile!:MAIN] [bat_var_firstfile="!bat_var_firstfile!", bat_var_lastfile="!bat_var_lastfile!"]
!bat_log! - goto :DONE
!bat_log!

echo.%~1=%bat_var_firstfile%>"!bat_tempfile_full!"
echo.%~2=%bat_var_lastfile%>>"!bat_tempfile_full!"

!bat_log! goto %~nx0:DONE [!bat_returncode!]
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


( ENDLOCAL & (
	rem echo.SET %~1=%bat_var_firstfile%
	rem echo.SET %~2=%bat_var_lastfile%

	SET %~1=%bat_var_firstfile%
	SET %~2=%bat_var_lastfile%
	set bat_returncode=%bat_returncode%
	)
)

goto :DONE2









	rem *************************************************************
	rem ***** Routine to get first filename sorted REVERSE     ******
	rem *************************************************************
	
:GETFIRSTFILENAME [out var_firstfile] [out var_lastfile] [in path]
!bat_pushlog! [CALL !bat_batchfile!:GETFIRSTFILENAME] %*

	set bat_returncode=0

	
	if defined bat_camera_target (
		set bat_searchspec=FF!bat_camera_target!_*.bin
	) else (
		set bat_searchspec=FF_??????_*.bin
	)

	!bat_titlewait!
	
	!bat_log! dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /o-n^}"!bat_tempfile_full!"
			  dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /o-n>"!bat_tempfile_full!"

	!bat_title!
	
	              
	set /a bat_temp_filesize=0

	call :GETFILELEN "!bat_tempfile_full!"  "!bat_searchspec!"

	rem returns value in variable "%~1", such as bat_var_firstfile
	call :LOOP "%~1" "!bat_linecount!" "!bat_tempfile_full!"



:GETFIRSTFILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GETFIRSTFILENAME] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        %~1=!%~1!]
!bat_log!
!bat_return!








	rem *************************************************************
	rem ***** Routine to get first filename sorted FORWARD     ******
	rem *************************************************************
	
:GETLASTFILENAME [out var_firstfile] [out var_lastfile] [in path]
!bat_pushlog! [CALL !bat_batchfile!:GETLASTFILENAME] %*

	set bat_returncode=0

	if defined bat_camera_target (
		set bat_searchspec=FF!bat_camera_target!_*.bin
	) else (
		set bat_searchspec=FF_??????_*.bin
	)


	!bat_titlewait!

		!bat_log! dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /on^}"!bat_tempfile_full!"
		          dir "!bat_sourcedir!\!bat_searchspec!" /b /a-d /on>"!bat_tempfile_full!"
	              
	!bat_title!
	
	set /a bat_temp_filesize=0
	              
	call :GETFILELEN "!bat_tempfile_full!" "!bat_searchspec!"

	rem returns value in variable "%~1", such as bat_var_firstfile
	call :LOOP "%~1" "!bat_linecount!" "!bat_tempfile_full!"


:GETLASTFILENAME_END
!bat_poplog! [RETURN !bat_batchfile!:GETLASTFILENAME] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        %~1=!%~1!]
!bat_log!
!bat_return!




:GETFILELEN
!bat_pushlog! [CALL :GETFILELEN] [%*]

	!bat_titlewait!

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "%~1"][FIND /c /i ".bin"^) do ^(
	          for /f "usebackq tokens=*" %%a in  (`type "%~1"^|FIND /c /i ".bin"`)  do (
		set /a bat_linecount=%%~a
	)
	
	!bat_title!
	
	!bat_log! Matching entries: bat_linecount="!bat_linecount!"
	
:GETFILELEN_END
!bat_poplog! [RETURN !bat_batchfile!:GETFILELEN] [bat_returncode=!bat_returncode!, bat_linecount=!bat_linecount!]
!bat_log!
!bat_return!




:LOOP
!bat_pushlog! [CALL !bat_batchfile!:LOOP] [%*]
	set bat_returncode=0
	
	!bat_titlewait!

	!bat_log! for /f "usebackq tokens=*" ..a in ^(`type "%~3"`^) do ^(
	          for /f "usebackq tokens=*" %%a in  (`type "%~3"`)  do (
		set %~1=%%~a
	)

	!bat_title!
	
:LOOP_END
!bat_poplog! [RETURN !bat_batchfile!:LOOP] [bat_returncode=!bat_returncode!, %~1=!%~1!, %~3=!%~3!]
!bat_log!
!bat_return!






:STRIPWHITESPACE
	set %~1=!%~1!
!BAT_RETURN!




:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_logexeclog! call "!bat_exedir!\Readini.bat" "!bat_configfile!" "CAMSMENU" bat_capturedfilesdir /q
	if !bat_logexec_returncode! equ 0 (
		set bat_capturedfilesdir=!RetVal1!
	)

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [!bat_capturedfilesdir!]
!bat_log!
!bat_return!






:HELP
	echo %~0      Batch Script
	echo.
	echo.     Usage %~0 
	echo.
	echo.     This script is designed to free up some disk space from the drive by deleting
	echo.     *.bin files from the CapturedFiles dir of all but the [STAGE].MaxDaysToKeep
	echo.     days from the SubmissionFiles dir.  It does not count missing directories in
	echo.     the "n" days, since missing dates don't cause the hard drive to fill up.
	echo.
	echo.     The number of days to keep is governed by a variable defined in the 
	echo.     AutoCams.params.ini file, [STAGE] MaxDaysToKeep.  Modify the number of days
	echo.     to keep according to the size of your hard drive.  
	echo.
	echo.     Note, this is very crude and option 61 is a better approach.
	echo.
exit /b 99



:DONE
	!bat_log! goto %~nx0:DONE [!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:DONE2
	exit /b %bat_returncode%
