
   @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=

		call "!bat_exedir!\ReadParams.bat"
	)

	call :PARSEDATE


	rem Note: It isn't necessary to return the ftp_wmdy value
	ENDLOCAL & (
		rem SET ftp_wmdy=%ftp_wmdy%
		set ftp_year=%ftp_year%
		set ftp_mo=%ftp_mo%
		set ftp_mo2=%ftp_mo2%
		set ftp_da=%ftp_da%
		set ftp_da2=%ftp_da2%
		set bat_twilight_searchstr=%bat_twilight_searchstr%
	)

	REM Display the output.  Once you get this working, REM out this line
	rem SET ftp_

exit /b 0



   rem When run on 10/03/2013, it should result in:
   rem    ftp_da=03
   rem    ftp_mo=10
   rem    ftp_wmdy=Thu 10/03/2013
  rem    ftp_year=2013
:PARSEDATE
!bat_pushlog! [CALL !bat_batchfile!:PARSEDATE] %*
	SET ftp_wmdy=
	set ftp_year=
	set ftp_mo=
	set ftp_da=
	set bat_twilight_searchstr=

	REM LOCALIZERS - THIS IS THE SECTION TO TRANSLATE
	set ftp_wmdy=!date!
	set ftp_year=!ftp_wmdy:~-4!
	set ftp_mo=!ftp_wmdy:~3,2!
	set ftp_mo2=!ftp_mo!
	if !ftp_mo! LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=!ftp_wmdy:~0,2!
	set ftp_da2=!ftp_da!
	if !ftp_da! LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	!bat_logexec! set bat_twilight_searchstr=!ftp_mo!/!ftp_da!/!ftp_year!

:PARSEDATE_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEDATE] [!ftp_wmdy!, !ftp_year!, !ftp_mo!, !ftp_da!, searchstr=!bat_twilight_searchstr!]
!bat_log!
!bat_return!




:HELP
	echo.Usage: call "bat_exedir\localize_PARSEDATE1_en-NL.bat"
	echo.
	echo.Returns:
	echo.  environment variables: ftp_year, ftp_mo, ftp_da
	echo.
	echo.The returned date needs to be normalized to the "en-US" locale 
	echo.format where the local date is returned as: mm/dd/yyyy
	echo.
	echo.Example:
	echo.  If the date is October 5, 2013, this routine should result with:
	echo.    ftp_year=2013
	echo.    ftp_mo=10 or ftp_mo2 [for single-digit months]
	echo.    ftp_da=05 or ftp_da2 [for single-digit days]
	echo.
	echo.This is the "en-US" local version of this script and it will serve
	echo.as a template for others to develop localized versions of this script.
	echo.
	echo.The trick is in the construct of the ENDLOCAL command, where it passes
	echo.back variables that are local to this routine.
	echo.





