  @echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2011:
		
	
:SETUP

	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"


    set bat_tempfile=%~0.temp.txt

	rem bat_cpucount
	call :GETCPUCOUNT
	
	call :GETWINDOWSVER
	
	call :GETARGS %*
	call :CHECKALREADYPROCESSED %*
	if "!bat_returncode!" neq "0" (goto :DONE)

	!bat_logexeclog! set bat_

	call :CREATECASEFILES %*
	call :GETFILECOUNT %*
	call :PARSEDATE %*
	call :DAYOFWEEK %*
	call :GETSEARCHDIR %*

	call :MAIN %*
goto :DONE






:GETARGS
!bat_pushecho! [CALL !bat_batchfile!:GETARGS] %*

	set bat_capturedfilesdir=%~1
	set bat_targetlocation=%~1
	set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_temp=%~1

	set bat_reprocessoptions=%~2

	set bat_autonomous=
	(echo.%*|find /i "autonomous">nul:) && (
		set bat_autonomous=autonomous
	)
	

	rem echo.!bat_temp!^|find /i "^:"
	(echo.!bat_temp!|find /i ":">nul:) && (
		rem They specified the fullpath, such as:
		rem	   c:\CAMS\CapturedFiles\2011_10_21_##_##_##
		rem	   f:\x\y\z\CAMS\CapturedFiles\2011_10_21_##_##_##
		rem so keep bat_targetlocation as-is and the drive letter
		rem is the first 2 chars of the argument
		!bat_echolog! Found ":" so using: "f:\x\y\z\CAMS\CapturedFiles\yyyy_mm_dd_##_##_##"
		
		set bat_targetdrive=!bat_targetlocation:~0,2!
		
		rem It would be good to be able to use a share, but that may
		rem entail having to map a drive letter to the share.
	) || (
	
		set bat_targetdrive=!bat_exedrive!

		rem echo.!bat_temp!^|find /i "\cams\"
		(echo.!bat_temp!|find /i "\cams\">nul:) && (
			rem They specified the some other relative path without
			rem a drive letter, such as:
			rem	  \CAMS\CapturedFiles\2011_10_21_##_##_##
			rem	  ..\CAMS\CapturedFiles\2011_10_21_##_##_##
			rem	  \x\y\z\CAMS\CapturedFiles\2011_10_21_##_##_##
			rem So we need to determine the drive letter.  In this
			rem case, the drive letter is the same/current drive
			!bat_echolog! Found "\cams\" so using: "\x\y\z\CAMS\CapturedFiles\yyyy_mm_dd_##_##_##"
			
			if "!bat_temp:~0,3!" equ "..\" (
				set bat_targetlocation=!bat_exedrive!\!bat_targetlocation:~3!
			) else (
				if "!bat_temp:~0,1!" equ "\" (
					set bat_targetlocation=!bat_exedrive!\!bat_targetlocation:~1!
				)
			)
			
		) || (
			rem echo.!bat_temp!^|find /i "CapturedFiles\"
			(echo.!bat_temp!|find /i "CapturedFiles\">nul:) && (
				rem They specified relative:
				rem   CaptureFiles\2011_10_21_##_##_##
				rem   .\CapturedFiles\2011_10_21_##_##_##

				set bat_targetlocation=!bat_targetlocation:.\CapturedFiles\=CapturedFiles\!
				set bat_targetlocation=!bat_exedir!\!bat_targetlocation!
			) || (
				rem probably just the date/time subdir name
				rem	  2011_10_21_##_##_##
				set bat_targetlocation=!bat_exedir!\CapturedFiles\!bat_targetlocation!
			)
		)
	)
	
	!bat_logexeclog! set bat_captureddatetime=%~n1
	!bat_logexeclog! set bat_captureddate=!bat_captureddatetime:~0,10!
	!bat_logexeclog! set bat_capturedtime=!bat_captureddatetime:~-8!

:GETARGS_END
!bat_popecho! [RETURN !bat_batchfile!:GETARGS_END] [bat_targetlocation=!bat_targetlocation!,
!bat_echolog! `                                      bat_captureddatetime=!bat_captureddatetime!,
!bat_echolog! `                                      bat_captureddate=!bat_captureddate!,
!bat_echolog! `                                      bat_capturedtime=!bat_capturedtime!]
!bat_echolog!
!bat_return!






:CHECKALREADYPROCESSED
!bat_pushecho! [CALL !bat_batchfile!:CHECKALREADYPROCESSED] %* [bat_targetlocation=!bat_targetlocation!]

	set bat_returncode=0

	rem This section checks if there is already a directory named after
	rem the date/time of the first FF file in the CapturedFiles dir.
	rem If there is one, it will stop to ask if is ok to continue or
	rem quit.
	
	if not exist "!bat_capturedfilesdir!\*.bin" (
		set bat_returncode=1
		!bat_echolog! ERROR - no FF*.bin files in "!bat_targetlocation!\*.bin"
		goto :CHECKALREADYPROCESSED_END
	)

	rem set bat_capturedfilesdir=!bat_targetlocation!
	
	REM Cleanup the directory names and obtain the base directory
	rem of CapturedFiles
	for /f "usebackq tokens=*" %%a in ('"!bat_capturedfilesdir!"') do (
		set bat_basedir=%%~dpa::
		set bat_basedir=!bat_basedir:\::=!
		set bat_basedir=!bat_basedir:::=!
	)
	for /f "usebackq tokens=*" %%a in ('"!bat_basedir!"') do (
		set bat_basedir=%%~dpa::
		set bat_basedir=!bat_basedir:\::=!
		set bat_basedir=!bat_basedir:::=!
	)


	rem Get a dir listing of the CapturedFiles dir, in reverse order, to obtain
	rem the first FF*.bin file.  
	for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\FF_*_0000000.bin" /b /a-d /o-n`) do (
		set bat_firstfile=%%~nxa
		set bat_firstfilefull=!bat_capturedfilesdir!\%%~a
		
		set bat_camera_first=!bat_firstfile:~3,6!
	)
	
	!bat_logexec! set bat_captureddatetime=!bat_captureddate!_!bat_capturedtime!
	
	rem all this bat_filex stuff is for old style archivedfiles dirs when the name of 
	rem the archivedfiles dir was based on the first BIN file in the capturedfiles dir
	set bat_file1=!bat_firstfile:~10,4!
	set bat_file2=!bat_firstfile:~14,2!
	set bat_file3=!bat_firstfile:~16,2!
	set bat_file4=!bat_firstfile:~19,2!
	set bat_file5=!bat_firstfile:~21,2!
	set bat_file6=!bat_firstfile:~23,2!
	set bat_archdatedir=!bat_file1!_!bat_file2!_!bat_file3!_!bat_file4!_!bat_file5!_!bat_file6!
	
	rem set bat_archivedfilesdir=!bat_basedir!\ArchivedFiles\!bat_archdatedir!
	!bat_logexec! set bat_archivedfilesdir=!bat_basedir!\ArchivedFiles\!bat_captureddatetime!

	!bat_echolog! if exist "!bat_archivedfilesdir!"
	if exist "!bat_archivedfilesdir!" (
			!bat_echolog!
			!bat_echolog! '    WARNING - Directory Already exists.  
			!bat_echolog! '        You may have already performed the FTP_Reprocess procedure. 
			!bat_echolog! '        "!bat_archivedfilesdir!"
		if exist "!bat_archivedfilesdir!\ftpdetectinfo_*_!bat_captureddatetime!.txt" (
			!bat_echolog! for /f "usebackq tokens=1,2 delims== skip=2" ..a in ^(`find /i "Meteor Count" "!bat_archivedfilesdir!\ftpdetectinfo_*_!bat_captureddatetime!.txt"`^) do ^(
			for               /f "usebackq tokens=1,2 delims== skip=2" %%a in (`find /i "Meteor Count" "!bat_archivedfilesdir!\ftpdetectinfo_*_!bat_captureddatetime!.txt"`) do (
				set bat_meteorcount=%%b
			)
			!bat_echolog! "!bat_archivedfilesdir!\ftpdetectinfo_*_!bat_captureddatetime!.txt"   [Meteor Count=!bat_meteorcount!]
		)
		echo.
:CHECKALREADYPROCESSED2
		set bat_returncode=0
		if not defined bat_autonomous (
			set /p bat_choice=Are you sure you want to continue? Y/N 
			if /i "!bat_choice!" equ "n" (set bat_returncode=1&goto :CHECKALREADYPROCESSED_END)
			if /i "!bat_choice!" neq "y" (goto :CHECKALREADYPROCESSED2)
		)

		if exist "!bat_archivedfilesdir!\ftpdetectinfo_*_!bat_captureddatetime!.txt" (
			for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\ftpdetectinfo_*_!bat_captureddatetime!.txt" /b /a-d /on`) do (
				!bat_logexec! move /y "!bat_archivedfilesdir!\%%~nxa" "!bat_archivedfilesdir!\xxx%%~nxa"
			)
		)

	)
:CHECKALREADYPROCESSED_END
!bat_popecho! [RETURN !bat_batchfile!:CHECKALREADYPROCESSED] [bat_returncode=!bat_returncode!,
!bat_echolog! `                                               bat_archivedfilesdir=!bat_archivedfilesdir!]
!bat_echolog!
!bat_return!







:CREATECASEFILES
!bat_pushecho! [CALL !bat_batchfile!:CREATECASEFILES] %*
	set bat_temp=!bat_targetlocation!
	for /f "tokens=*" %%a in ("!bat_temp!") do (
		set bat_dirname=%%~nxa
		set bat_dirdate=!bat_dirname:~0,10!
	)
	!bat_echolog! bat_dirname=!bat_dirname!
	!bat_echolog! bat_dirdate=!bat_dirdate!

:CREATECASEFILES_END
!bat_popecho! [RETURN !bat_batchfile!:CREATECASEFILES] [bat_dirname=!bat_dirname!]
!bat_echolog!
!bat_return!










:GETFILECOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETFILECOUNT] %*
	if not exist "!bat_targetlocation!\*.bin" (
		!bat_echolog!
		!bat_echolog! ERROR - There are no FF*.bin files in the specified location:
		!bat_echolog! '        "!bat_targetlocation!"
		goto :DONE
	)

	set bat_filecount=0
	for /f "usebackq tokens=*" %%a in (`dir /b "!bat_targetlocation!\*.bin"^|find /c /i ".bin"`) do (
		set bat_filecount=%%a
	)
	
	if !bat_filecount! equ 0 (
		!bat_echolog!
		!bat_echolog! ERROR - There are no FF*.bin files in the specified location:
		!bat_echolog! '        "!bat_targetlocation!"
		goto :DONE
	) else (
		if !bat_filecount! lss 2500 (
			!bat_echolog! NOTICE - There are less than 6 hours of data in the specified directory. 
			!bat_echolog! '        "!bat_targetlocation!"  [Files=!bat_filecount!]
			!bat_echolog!
		)
	)

	set /a bat_filespercase=!bat_filecount!/!bat_cpucount!

:GETFILECOUNT_END
!bat_popecho! [RETURN !bat_batchfile!:GETFILECOUNT] [bat_filecount=!bat_filecount!, bat_filespercase=!bat_filespercase!]
!bat_echolog!
!bat_return!






:PARSEDATE
!bat_pushecho! [CALL !bat_batchfile!:PARSEDATE] %*
	set ftp_wmdy=!bat_dirdate!
:PARSEDATE2

	rem YEAR
	set ftp_year=!ftp_wmdy:~0,4!
	
	rem MONTH
	set ftp_mo=!ftp_wmdy:~5,2!
	set ftp_mo2=!ftp_mo!
	if !ftp_mo! LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	
	rem DAY
	set ftp_da=!ftp_wmdy:~8,2!
	set ftp_da2=!ftp_da!
	if !ftp_da! LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	call :date2jdate bat_JD !ftp_year! !ftp_mo2! !ftp_da2!

	call :jdate2date !bat_jd! ftp_year ftp_mo2 ftp_da2
:PARSEDATE_END
!bat_popecho! [RETURN !bat_batchfile!:PARSEDATE] [bat_JD=!bat_JD!, !ftp_year! !ftp_mo2! !ftp_da2!]
!bat_echolog!
!bat_return!






:DAYOFWEEK
!bat_pushecho! [CALL !bat_batchfile!:DAYOFWEEK] %*
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd
	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)
:DAYOFWEEK_END
!bat_popecho! [RETURN !bat_batchfile!:DAYOFWEEK] [bat_weekday=!bat_weekday!]
!bat_echolog!
!bat_return!





:GETSEARCHDIR
!bat_pushecho! [CALL !bat_batchfile!:GETSEARCHDIR] %*
	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
:GETSEARCHDIR_END
!bat_popecho! [RETURN !bat_batchfile!:GETSEARCHDIR] [!ftp_searchdir!]
!bat_echolog!
!bat_return!




:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] %*
!bat_push!


REM #############################################

	!bat_echolog! Make Case Lising [!bat_targetlocation!]

		REM You might be asked to navigate to this CapturedFiles directory: [!bat_targetlocation!]
	
	!bat_echolog! START "Multi-tasked Detect [CPU=!bat_cpucount!]" /wait "!bat_exedir!\FTP_DetectMultipleFF.exe" 1 !bat_DETECT.maxdetectionthreads! "!bat_capturedfilesdir!"
	              START "Multi-tasked Detect [CPU=!bat_cpucount!]" /wait "!bat_exedir!\FTP_DetectMultipleFF.exe" 1 !bat_DETECT.maxdetectionthreads! "!bat_capturedfilesdir!"

	if exist "!bat_archivedfilesdir!\FTPdetectinfo_????????????_????_??_??_??_??_??.txt" (

		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /on "!bat_archivedfilesdir!\FTPdetectinfo_????????????_????_??_??_??_??_??.txt"`) do (

			set bat_temp=%%a
			set bat_temp_file=%%~na
			set bat_temp_camera=!bat_temp:~14,6!
			set bat_temp_capturesession=!bat_archivedfilesdir:~-19!
			
			!bat_logexec! MOVE /Y "!bat_archivedfilesdir!\%%a" "!bat_archivedfilesdir!\FTPdetectinfo_!bat_temp_camera!_!bat_temp_capturesession!.txt"
		)
		
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /on "!bat_archivedfilesdir!\FTPdetectinfo_*_Subset.txt"`) do (
			set bat_temp_file=%%~na
			
			!bat_logexec! MOVE /Y "!bat_archivedfilesdir!\%%a" "!bat_archivedfilesdir!\zzz!bat_temp_file!.txt"
		)
		
	) else (
			REM Now combine the resulting FTPdetectinfo_??????_Subset.txt into a real detectfile:
			REM This tool creates the file as "FTPdetectinfo_000000_YYYY_MM_DD_hh_mm_ss.txt" 
			REM Where: 
			REM     000000                      is a hard-coded "000000" for the camera number.  It needs to be changed to the first camera number
			REM     YYYY_MM_DD_hh_mm_ss         is the name of the directory/capture session dir name. Yes, even if the dir name has text suffix.
			REM
		!bat_CALL! "!bat_exedir!\FTP_CombineDetectinfo.exe" "!bat_archivedfilesdir!"
	)

		REM 1. Rename all the FTPdetectinfo_00000?_Subset.txt file to xxxFTPdetectinfo_00000?_Subset.txt
		REM
		REM 2. Adjust the name of the detect file in the bat_archivedfiles dir to match the current naming convention:
		REM    "FTPdetectinfo_0ccc_YYYY_MM_DD_hh_mm_ss.txt"
		REM       Where: 0ccc    is the first camera in the list of cameras from the bat_capturedfilesdir
		REM
		REM 3. Get variables: bat_camera_first, bat_camera_last, 
		REM                   bat_detectfile, bat_detectfileDir, bat_detectfileFile, bat_detectfileName, bat_detectfileFull
		REM 
		REM 4. 
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" bat_detectfile "!bat_archivedfilesdir!"
	!bat_logexeclog! set bat_detectfileFull=!bat_detectfile!

%bat_COMMENT_BEGIN%
	if not defined bat_camera_first (set bat_camera_first=!bat_camera!)

	if defined bat_camera_first (
		for /f "usebackq tokens=1-12 delims=_" %%a in ('"!bat_detectfileFile!"') do (
		
				REM Rename: "C:\CAMS\ArchivedFiles\2016_02_10_02_16_13\FTPdetectinfo_02660267_2016_02_10_02_16_13.txt" 
				REM to:     "C:\CAMS\ArchivedFiles\2016_02_10_02_16_13\FTPdetectinfo_0266_2016_02_10_02_16_13.txt" 
				REM                                                                                         y   m   d   h   m   s
			!bat_log! a=%%a, %%b, %%c, %%d, %%e, %%f, %%g, %%h, %%i, %%j, %%k
			!bat_logexeclog! MOVE /Y "!bat_detectfileFull!"   "!bat_detectfileDir!\FTPdetectinfo_!bat_camera_first!_%%~c_%%~d_%%~e_%%~f_%%~g_%%~h.txt"
		)
	)

%BAT_COMMENT_END%

goto :MAIN_END

REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~






	set bat_returncode=1

	set bat_lastffname=.
	set /a bat_loopcount=0
	set /a bat_filecountstop=0
	set /a bat_case=0

			!bat_echolog!
			!bat_echolog! Windows Vers:		!bat_winver!
			!bat_echolog!
			!bat_echolog! Day of week:		!bat_weekday!
			!bat_echolog! Folder date:		!bat_dirdate!
			!bat_echolog! Folder name:		!bat_dirname!
			!bat_echolog! Drive:			!bat_targetdrive!
			!bat_echolog! CAMS dir:		!bat_exedir!
			!bat_echolog! Cal dir:		!bat_exedir!\Cal
			!bat_echolog! Directory: 		!bat_targetlocation!
			!bat_echolog! Total Files:		!bat_filecount!
			!bat_echolog! Number of CPUs:	!bat_cpucount!
			!bat_echolog! Files per case:	!bat_filespercase!	^(files per CPU^)
			!bat_echolog!

	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\*.bin" /b /a-d /on`^) do ...
	!bat_pushecho!
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\*.bin" /b /a-d /on`) do (
		set /a bat_loopcount+=1
		set /a bat_casecount+=1
		
		TITLE MakeCaseListing.bat [!bat_casecount!][!bat_loopcount!] "%%a"

		if !bat_loopcount! GTR !bat_filecountstop! (
			set /a bat_case+=1

			set /a bat_filecountstop+=bat_filespercase
			set /a bat_casecount=1

			rem This block prevents the problem when the bat_cpucount doesn't
			rem divide evenly into the 
			if !bat_case! equ 1 (
				set /a bat_filecountstop+=bat_cpucount
			)

			set bat_temp=000!bat_case!
			set bat_temp=!bat_temp:~-3!
			set bat_caselisting=FFdirectorylisting_!bat_temp!.txt
			
			if defined bat_targetlocation (
				if defined bat_caselisting (
					 del "!bat_targetlocation!\!bat_caselisting!" 2>nul:
				) else (
					!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del "!bat_targetlocation!\!bat_caselisting!"
				)
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del "!bat_targetlocation!\!bat_caselisting!"
			)

			set bat_firstcasefile=%%a
			!bat_pop!
			!bat_echolog! CASE !bat_case! - !bat_targetlocation!\!bat_caselisting!...
			!bat_pushecho!
		)
		
		set bat_outputstring=%%a

		echo !bat_outputstring!>>"!bat_targetlocation!\!bat_caselisting!"

		if !bat_loopcount! GEQ !bat_filecountstop! (
			set bat_casetitle=FTP_Reprocess !bat_case! !bat_casecount! First:!bat_firstcasefile:~3,6!-!bat_firstcasefile:~15,6!  Last:!bat_outputstring:~3,6!-!bat_outputstring:~15,6!

			!bat_echolog! First file in case !bat_case!:	!bat_firstcasefile!
			!bat_echolog! Last file in case !bat_case!:	    !bat_outputstring!
			!bat_echolog! Total files in case !bat_case!:   !bat_casecount!

			!bat_echolog! copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe"
			              copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe" 1>2>nul:

rem			call :SETAFFINITY !bat_case!
			if !bat_winver! GEQ 6.0 (
				!bat_echolog! start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
rem					          start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
					          start "!bat_casetitle!" /low                          ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  

			) else (
				!bat_echolog! start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
					          start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  

				!bat_WAIT! 

%bat_COMMENT_BEGIN%
				!bat_echolog! call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask!
				              call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask! 1>2>nul:
%bat_COMMENT_END%
			)
			!bat_echolog! !bat_WAIT! 10
			!bat_echolog!

			!bat_WAIT! 10
		)
	)
	!bat_echolog!

	set bat_casetitle=FTP_Reprocess !bat_case! !bat_casecount! First:!bat_firstcasefile:~3,6!-!bat_firstcasefile:~15,6!  Last:!bat_outputstring:~3,6!-!bat_outputstring:~15,6!

	!bat_echolog! First file in case !bat_case!:	!bat_firstcasefile!
	!bat_echolog! Last file in case !bat_case!:	!bat_outputstring!
	!bat_echolog! Total files in case !bat_case!: !bat_casecount!
	!bat_echolog!
	!bat_echolog! copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe"
		          copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe" 1>2>nul:
rem	call :SETAFFINITY !bat_case!
	!bat_popecho! ^) // for...
	!bat_echolog!
	
	if !bat_winver! GEQ 6.0 (
		!bat_echolog! start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case! !bat_reprocessoptions!
rem			          start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
			          start "!bat_casetitle!" /low                          ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
	) else (
		!bat_echolog! start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case! !bat_reprocessoptions!
			          start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
		!bat_WAIT!   1
%bat_COMMENT_BEGIN%
		!bat_echolog! call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask!
		              call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask! 1>2>nul:
%bat_COMMENT_END%
	)
	
	set bat_returncode=0

	!bat_echolog!
	
	call :WAITFORMULTISCAN

:MAIN_END
!bat_pop!
!bat_pop!
!bat_popecho! [END !bat_batchfile!:MAIN_END] [!date! !time! - exit /b !bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b !bat_returncode!



goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	!bat_CALL! "!bat_exedir!\Date2JDate.bat" bat_JD !ftp_year! !ftp_mo! !ftp_da!
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	!bat_CALL! "!bat_exedir!\JDate2Date.bat" !bat_JD! ftp_year ftp_mo ftp_da
EXIT /b 0




:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b




:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
goto :EOF





:CALCREQDISK
	set bat_diskspacememo=OK
	call :CHECKDISKSPACE
	set /a bat_estCapFiles=!bat_durtotalseconds/8
	set /a bat_reqdisk=!bat_durtotalsecs!/8*1229/1024
	set /a bat_estSizeMB=!bat_reqdisk!
	set bat_freeMB=!bat_targetfreespace!
	
	set bat_sizediff=!bat_estSizeMB!-!bat_freeMB!

	if !bat_estSizeMB! gtr !bat_freeMB! (
		set bat_diskspacememo=********* DISK SPACE WARNING! ************
	)
goto :EOF




:CHECKDISKSPACE
	set bat_targetdrive=!bat_targetlocation:~0,2!
	
	rem Note: We have to do it this way because WMIC outputs unicode and
	rem FINDSTR is not compatible with unicode strings.
	wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-2* skip=1" %%a in (`type "!bat_tempfile!"^|findstr /r /c:","`) do (
		set bat_free=%%b
		set bat_size=%%c
		if "!bat_free!" neq "" (
			set bat_freeMB=!bat_free:~0,-6!
			set bat_targetfreespace=!bat_freeMB!
		)
	)
	
	if exist "!bat_tempfile!" (
		if defined bat_tempfile (
			del "!bat_tempfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECKDISKSPACE] Dangerous command: del "!bat_tempfile!"
		)
	)
!bat_return!


	wmic logicaldisk where "name='!bat_targetdrive!'" get freespace /format:csv>"!bat_tempfile!"
	for /f "usebackq tokens=1-2 delims=," %%a in (`type "!bat_tempfile!"^|findstr /r /c:"%computername%"`) do (
		rem echo %%a, %%b
		set bat_targetfreespace=%%b
		set bat_freeMB=%%b
	)
	if exist "!bat_tempfile!" (
		if defined bat_tempfile (
			del "!bat_tempfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECKDISKSPACE] Dangerous command: del "!bat_tempfile!"
		)
	)








:GETCPUCOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETCPUCOUNT] %*
	set /a bat_cpucount=!NUMBER_OF_PROCESSORS!
	if !bat_cpucount! gtr !bat_DETECT.maxdetectionthreads! (
		set bat_cpucount=!bat_DETECT.maxdetectionthreads!
	)
:GETCPUCOUNT_END
!bat_popecho! [RETURN !bat_batchfile!:GETCPUCOUNT] [bat_cpucount=!bat_cpucount!]
!bat_echolog!
!bat_return!





:SETAFFINITY
!bat_pushecho! [CALL !bat_batchfile!:SETAFFINITY] %*
	rem Usage: call :SETAFFINITY count
	set /a bat_affinity=1
	set bat_temp=10000000000000000000000000000000
	
	rem logical shift. e.g. 1"<<=(3-1)" yields 4; 1"<<=(1-1)" yields 1
	set /a "bat_affinity=1<<(%~1-1)"
	set bat_affinitymask=!bat_temp:~0,%~1!
:SETAFFINITY_END
!bat_popecho! [RETURN !bat_batchfile!:SETAFFINITY] [bat_affinitymask=!bat_affinitymask!]
!bat_echolog!
!bat_return!







Note: If this is XP, then the Process.exe command has to be used using and 
      the bat_affinitymask variable is used.
      Operating System Version Number 
		Operating System						Version Number			Other Information 
		Windows 1.0 							1.04   
		Windows 2.0 							2.11   
		Windows 3.0 							3   
		Windows NT 3.1 							3.10.528   
		Windows for Workgroups 3.11 			3.11   
		Windows NT Workstation 3.5 				3.5.807   
		Windows NT Workstation 3.51 			3.51.1057   
		Windows 95 								4.0.950   
		Windows NT Workstation 4.0 				4.0.1381   
		Windows 98 								4.1.1998   
		Windows 98 Second Edition 				4.1.2222   
		Windows Me 								4.90.3000   
		Windows 2000 Professional 				5.0.2195   
		Windows XP 								5.1.2600 				Current SP3 
		Windows XP Professional x64 Edition 	5.2.3790   
		Windows Vista 							6.0.6000 				Current Version changed to 6.0.6002 with SP2 
		Windows 7 								6.1.7600 				RTM 

      if !bat_winver! LEQ 6.0.6000
%bat_COMMENT_BEGIN%
	process -a ftp_reprocess_1.exe !bat_affinitymask!
%bat_COMMENT_END%

:GETWINDOWSVER
!bat_pushecho! [CALL !bat_batchfile!:GETWINDOWSVER] %*

	if defined bat_AUTOCAMS.winver (
		set bat_winver=!bat_AUTOCAMS.winver!
		goto :GETWINDOWSVER_END
	)

	wmic os get version /format:csv>"!bat_tempfile!"
	rem type "!bat_tempfile!"
	for /f "usebackq tokens=1-3 skip=2 delims=," %%a in (`type "!bat_tempfile!"`) do (
		if "%%b" gtr "!" (
			set bat_winver=%%b
		)
	)
	
	if exist "!bat_tempfile!" (
		if defined bat_tempfile (
			del "!bat_tempfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:GETWINDOWSVER] Dangerous command: del "!bat_tempfile!"
		)
	)
:GETWINDOWSVER_END
!bat_popecho! [RETURN !bat_batchfile!:GETWINDOWSVER] [bat_winver=!bat_winver!]
!bat_echolog!
!bat_return!




:WAITFORMULTISCAN
!bat_pushecho! [CALL !bat_batchfile!:WAITFORMULTISCAN] %*
	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`) do (
		!bat_echoecho! Waiting for FTP_Reprocess to release the file: "!bat_archivedfilesdir!\%%a"
		!bat_logexec! call WaitForFile.exe rw "!bat_archivedfilesdir!\%%a"
	)
	!bat_popecho!

:WAITFORMULTISCAN_END
!bat_popecho! [RETURN !bat_batchfile!:WAITFORMULTISCAN] []
!bat_echo!
!bat_return!










:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 "sourcedirectory" [autonomous] [/?]
    echo.
    echo     Creates the case/instance files for running FTP_Reprocess.exe in 
    echo     multi-tasking mode. A case/instance file will be created for each
    echo     CPU in the specified CapturedFiles subdir with the following format:
    echo         FFdirectorylisting_00#.txt
    echo.
    echo     Then, it launches FTP_Reprocess.exe with the priority set to LOW and
    echo     the processor affinity set to 1:1, 2:2, 3:4, 4:8, 5:16, 6:32, 7:64, 8:128
    echo.
    echo     WARNING - The path must be in all upper case.
    echo.
    echo     Examples: %~nx0 "2011_11_10_01_38_20"
    echo               %~nx0 "CapturedFiles\2011_11_10_01_38_20"
    echo               %~nx0 ".\CapturedFiles\2011_11_10_01_38_20"
    echo               %~nx0 "C:\CAMS\CapturedFiles\2011_11_10_01_38_20"
    echo.
    echo     Note: Requires the following additional utilities:
    echo              - Process.exe
    echo              - Wait.exe
    echo              - wmic.exe
    echo              - find.exe
    echo              - FindStr.exe
    echo              - autocams.params.ini bat_AUTOCAMS.winver
    echo.
EXIT /b 99
    
goto :DONE


:DONE
!bat_echolog! [%date% %time%] DONE !bat_batchfile! [!bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog!
echo Waiting...&!bat_WAIT!  10
exit /b !bat_returncode!
