@echo off
setlocal enableextensions enabledelayedexpansion

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	set bat_logdir=!bat_exedir!\Logs
	set bat_pushstring=  


	rem Wait for LaunchCapture.bat to finish...
	!bat_WAIT! 10

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_CALL! "%~dp0ReadParams.bat"
	!bat_CALLecho!  "!bat_exedir!\ReadParams_capture16.bat"

	if not defined bat_RUN.number_of_boards (
		set bat_number_of_boards=1
	)


	if /i "%~1" equ "" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! .    ERROR - missing duration argument.  Try using -8
		!bat_echolog!
		goto :DONE
	)

	!bat_logexec! set bat_duration=%~1

	(echo. %*|findstr /L /i /c:" autonomous">nul: 2>&1) && (
		!bat_logexec! set bat_autonomous=autonomous) || (
		!bat_logexec! set bat_autonomous=)
	
	!bat_logexec! set bat_process_cmd=%~dp0Process.exe&	rem "!bat_process_cmd!"


goto :MAIN !bat_duration!





:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] [%*]

	REM ================================================================
	REM =====       BOARD 0                                        =====
	REM ================================================================
	
	!bat_logexec! set bat_board=0
	call :LAUNCH_CAPTURE8_BAT
	set bat_returncode=!errorlevel!
	
	if !bat_returncode! neq 0 (
		!bat_echolog!
		!bat_echolog! `    #### !bat_batchfile!:MAIN[!bat_board!] - ERROR - Couldn't start "!bat_capture8_exe_filename!".
		!bat_echolog!
	)

	!bat_logexec! set bat_cmd_0=!bat_cmd_Capture8_exe_filename!
	set bat_cmd_process_handle_0=
	!bat_logexec! set bat_capture_exe_0=!bat_ftp_capture8_%bat_board%!
	


	rem NOTE: THERE IS NOW A 30 SECOND WAIT TIMER INSIDE OF THE :LAUNCH_CAPTURE8_BAT routine.
	rem !bat_echolog! [!bat_batchfile!] Wait 30
	rem !bat_WAIT!  30 /nobreak

	REM ================================================================
	REM =====       BOARD 1                                        =====
	REM ================================================================
	
	if /i "!bat_RUN.number_of_boards!" GEQ 1 (
		!bat_logexec! set bat_board=1
		call :LAUNCH_CAPTURE8_BAT
		set bat_returncode=!errorlevel!

		if !bat_returncode! neq 0 (
			!bat_echolog!
			!bat_echolog! `    #### !bat_batchfile!:MAIN[!bat_board!] - ERROR - Couldn't start "!bat_capture8_exe_filename!".
			!bat_echolog!
		)

		!bat_logexec! set bat_cmd_1=!bat_cmd_Capture8_exe_filename!
		set bat_cmd_process_handle_1=
		!bat_logexec! set bat_capture_exe_1=!bat_ftp_capture8_%bat_board%!


		REM NOTE: THERE IS NOW A 30 SECOND WAIT TIMER INSIDE THE :LAUNCH_CAPTURE_BAT routine.
		rem !bat_echolog! !bat_batchfile! Wait 30
		rem !bat_WAIT!  30 /nobreak
	)

	REM ================================================================
	REM =====       BOARD 2                                        =====
	REM ================================================================

	if /i "!bat_RUN.number_of_boards!" GEQ 2 (
		!bat_logexec! set bat_board=2
		call :LAUNCH_CAPTURE8_BAT
		set bat_returncode=!errorlevel!

		if !bat_returncode! neq 0 (
			!bat_echolog!
			!bat_echolog! `    #### !bat_batchfile!:MAIN[!bat_board!] - ERROR - Couldn't start "!bat_capture8_exe_filename!".
			!bat_echolog!
		)

		!bat_logexec! set bat_cmd_2=!bat_cmd_Capture8_exe_filename!
		set bat_cmd_process_handle_2=
		!bat_logexec! set bat_capture_exe_2=!bat_ftp_capture8_%bat_board%!


		REM NOTE: THERE IS NOW A 30 SECOND WAIT TIMER INSIDE THE :LAUNCH_CAPTURE_BAT routine.
		rem !bat_echolog! !bat_batchfile! Wait 30
		rem !bat_WAIT!  30 /nobreak
	)
	


	REM ================================================================
	REM =====       WAIT FOR BOARD 0 CAPTURE TO FINISH             =====
	rem 
	rem wait for the FTP_Capture8AndDetect_0.exe to finish
	rem
	rem At this point, we'll do two WAIT_FOR_BOARD_CAP_EXE_FINISH.
	rem One for board 0, then immediately another for board 1.  Its 
	rem a good reminder to point out that each Capture8_ReturnCode.bat 
	rem script will suspend itself as soon as its capture is done.
	REM ================================================================

	
	!bat_logexec! set bat_board=0
	CALL :WAIT_FOR_BOARD_CAP_EXE_FINISH "!bat_capture_exe_0!"
	
	
	rem Note, At this point, the capture is finished, and the 
	rem Capture8_ReturnCode.bat [0] is suspending itself.

	REM ================================================================
	REM =====       WAIT FOR BOARD 1 CAPTURE TO FINISH             =====
	rem 
	rem wait for the FTP_Capture8AndDetect_1.exe to finish
	REM ================================================================

	if /i "!bat_RUN.number_of_boards!" GEQ 1 (
		!bat_logexec! set bat_board=1
		CALL :WAIT_FOR_BOARD_CAP_EXE_FINISH "!bat_capture_exe_1!"

		rem Note, At this point, the capture is finished, and the 
		rem Capture8_ReturnCode.bat [1] is suspending itself.
	)
	
	REM ================================================================
	REM =====       WAIT FOR BOARD 2 CAPTURE TO FINISH             =====
	rem 
	rem wait for the FTP_Capture8AndDetect_1.exe to finish
	REM ================================================================

	if /i "!bat_RUN.number_of_boards!" GEQ 2 (
		!bat_logexec! set bat_board=2
		CALL :WAIT_FOR_BOARD_CAP_EXE_FINISH "!bat_capture_exe_2!"

		rem Note, At this point, the capture is finished, and the 
		rem Capture8_ReturnCode.bat [2] is suspending itself.
	)
	
	!bat_echolog! [!bat_batchfile!:MAIN] -----------------------------------------------------------------
	!bat_echolog! [!bat_batchfile!:MAIN] -----------------------------------------------------------------
	!bat_echolog! [!bat_batchfile!:MAIN] -----------------------------------------------------------------
	!bat_echolog! [!bat_batchfile!:MAIN] [!date! !time!] Capture Finished
	!bat_echolog! [!bat_batchfile!:MAIN] Both Capture8_ReturnCode.bat scripts should be suspended...
	!bat_echolog!



	REM ================================================================
	REM =====       RESUME BOARD 0's CMD SHELL                     =====
	REM ================================================================
	
	set bat_board=0
	CALL :RESUME_CMD_SHELL "!bat_cmd_0!"
	
	REM ================================================================
	REM =====     RESUME BOARD 0'S PostCaptureProcessing           =====
	REM =====                                                      =====
	rem By this point, we will have awaken the Capture8_ReturnCode.bat 
	rem script and it would have commenced to perform its post capture 
	rem processing by calling "Capture8_PostCaptureProcessing.bat" with 
	rem all the variables corresponding to its capture session.  When 
	rem it's done, the CMD will end.  
	REM ================================================================


	REM ================================================================
	REM =====   WAIT FOR CMD 0 PostCaptureProcessing TO FINISH     =====
	REM ================================================================
	
	set bat_board=0
	CALL :WAIT_FOR_CMD_FINISH "!bat_cmd_0!"
	
	
	
	
	REM ================================================================
	REM =====       RESUME BOARD 1's CMD SHELL                     =====
	REM =====                                                      =====
	REM At this point, board 0 is completely finished and we're ready
	REM to do the post capture processing for board 1.  The CMD
	REM for board 1 has suspended itself waiting for this script to
	REM awaken it. 
	REM ================================================================
	
	set bat_board=1
	CALL :RESUME_CMD_SHELL "!bat_cmd_1!"

	
	REM ================================================================
	REM =====       WAIT FOR BOARD 1's CMD TO FINISH               =====
	rem 
	rem When the board's command shell is finished, we know it's done 
	rem doing its post capture processing. 
	REM ================================================================
	
	set bat_board=1
	CALL :WAIT_FOR_CMD_FINISH "!bat_cmd_1!"
	
	
	REM ================================================================
	REM =====       WAIT FOR BOARD 2's CMD TO FINISH               =====
	rem 
	rem When the board's command shell is finished, we know it's done 
	rem doing its post capture processing. 
	REM ================================================================
	
	set bat_board=2
	CALL :WAIT_FOR_CMD_FINISH "!bat_cmd_2!"
	
	!bat_echolog! [!bat_batchfile!:MAIN] XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	!bat_echolog! [!bat_batchfile!:MAIN] XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	!bat_echolog! [!bat_batchfile!:MAIN] XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	!bat_echolog! [!bat_batchfile!:MAIN] [!date! !time!] Start16Cameras.bat all Finished
	!bat_echolog!



:MAIN_END
!bat_popecho! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE







	
	REM ****************************************************************
	REM *****       LAUNCH_CAPTURE8_BAT                            *****
	REM
	REM Launches the "Capture8_ReturnCode.bat" script asynchronously
	rem for the given board number [in bat_board].  Then as a workaround
	rem for a bug in the capture16 code, it sets the processor affinity
	rem so that the detections threads can run in ANY cpu.  
	rem
	rem The new process is run within a unique copy of the cmd.exe
	rem program, which is copied from the windows\system32 directory. 
	rem This technique allows one of the other scripts in another 
	rem thread to wait for the process to end, at which point, it can
	rem finish up the post-processing work. 
	rem
	rem Also, the actual capture program [FTP_Capture8AndDetect.exe] is
	rem run as a unique trackable copy.  
	REM ****************************************************************

:LAUNCH_CAPTURE8_BAT
!bat_pushecho! [CALL !bat_batchfile!:LAUNCH_CAPTURE8_BAT] [%*]

	set bat_returncode=0

	!bat_logexec! set bat_capture8_exe_filename=FTP_Capture8AndDetect_!bat_board!.exe
	!bat_logexec! set bat_ftp_capture8_!bat_board!=!bat_capture8_exe_filename!
	!bat_logexec! set bat_capture8_exe_full=!bat_exedir!\!bat_capture8_exe_filename!
	
	!bat_logexec! set bat_cmd_Capture8_exe_filename=cmd_Capture8_board_!bat_board!.bat.exe
	!bat_logexec! set bat_cmd_Capture8_exe_full=!bat_exedir!\!bat_cmd_Capture8_exe_filename!
	
	REM Make a copy of the command processor so it's trackable, waitable, and so we can set affinity mask...
	

	!bat_logexec! copy /y "%windir%\system32\cmd.exe"     "!bat_exedir!\!bat_cmd_Capture8_exe_filename!"
	!bat_logexec! copy /y "%windir%\system32\!bat_LOCALIZE.locale!\cmd.exe.mui" "!bat_exedir!\!bat_LOCALIZE.locale!\!bat_cmd_Capture8_exe_filename!.mui"


	!bat_echolog! start  ""Capture8_ReturnCode.bat"  !bat_duration! !bat_board!"  "!bat_cmd_Capture8_exe_full!" /c  ""Capture8_ReturnCode.bat"  !bat_duration! !bat_board! !bat_autonomous!"
	              start  ""Capture8_ReturnCode.bat"  !bat_duration! !bat_board!"  "!bat_cmd_Capture8_exe_full!" /c  ""Capture8_ReturnCode.bat"  !bat_duration! !bat_board! !bat_autonomous!"

	rem We're now going to give the first capture program a chance to start and create the capture session
	rem directory in the CapturedFiles directory.  We do this before starting the second instance.
	
	!bat_echolog! [!bat_batchfile!_!bat_board!] Waiting 30 seconds for "!bat_capture8_exe_filename!" to be fully running
	!bat_WAIT!  30 /nobreak

	rem Set Affinity mask as a workaround for a problem that comes up when the capture program
	rem tends to limit itself to CPUs 4 and 5.

rem MAYBE PUT A LOOP IN HERE TO KEEP TESTING PROCESS -V | FIND /I "!bat_capture8_exe_filename!" UNTIL
REM IT FINDS ONE... THEN IT SHOULD PROCESS THIS LOOP.  

	set /a bat_process_count=0
	set /a bat_attempts=0
:LAUNCH_CAPTURE8_BAT 
	!bat_echolog! [!bat_batchfile!:LAUNCH_CAPTURE8_BAT_!bat_board!]["!bat_capture8_exe_filename!"] [bat_process_count=!bat_process_count!] [attempts=!bat_attempts!]

	set /a bat_attempts+=1

	!bat_echolog! for /f "usebackq tokens=1-3" ..a in ^(`!bat_process_cmd! ^| find /i "!bat_capture8_exe_filename!"`^) do ^(
		"!bat_process_cmd!" | find /i "!bat_capture8_exe_filename!"
	for               /f "usebackq tokens=1-3" %%a in  (`!bat_process_cmd! ^| find /i "!bat_capture8_exe_filename!"`) do (
		set /a bat_process_count+=1
		!bat_echolog! !bat_attempts!.!bat_process_count!.	"%%a" -a %%b !processor_affinity_mask!
		              "!bat_process_cmd!" -a %%b !processor_affinity_mask!
	)
	!bat_echolog! ^)

	if !bat_attempts! gtr 10 (
		set bat_returncode=1
		goto :LAUNCH_CAPTURE8_BAT_END
	)
	
	if !bat_process_count! equ 0 (
		!bat_echolog! 
		!bat_echolog! ****** COULDN'T FIND RUNNING PROCESS FOR: "!bat_capture8_exe_filename!". WAITING 1 SECOND AND TRYING AGAIN...
		!bat_WAIT! 1 /nobreak
		goto :LAUNCH_CAPTURE8_BAT
	)

:LAUNCH_CAPTURE8_BAT_END
!bat_popecho! [RETURN !bat_batchfile!:LAUNCH_CAPTURE8_BAT] [bat_returncode=!bat_returncode!, board=!bat_board!]
!bat_echolog!
exit /b !bat_returncode!
!BAT_RETURN!





	
	REM ****************************************************************
	REM *****       WAIT FOR BOARD x TO FINISH                     *****
	REM
	REM It waits on the process handle using the WaitForFile tool.
	REM It shouldn't awaken until morning.
	REM ****************************************************************

:WAIT_FOR_BOARD_CAP_EXE_FINISH [IN] "FTP_Capture8AndDetect_^<board^>.exe"
!bat_pushecho! [CALL !bat_batchfile!:WAIT_FOR_BOARD_CAP_EXE_FINISH] [%~1]


	!bat_echolog!
	!bat_echolog! !bat_batchfile!_!bat_board! Waiting for "%~1" to finish.......
	!bat_echolog! `                   See you in the morning...

	      call WaitForFile rw "%~1" >nul: 2>&1
	!bat_echolog!

	!bat_echolog! !bat_batchfile!_!bat_board! Wait 60
	!bat_wait! 60


:WAIT_FOR_BOARD_CAP_EXE_FINISH_END
!bat_popecho! [RETURN !bat_batchfile!:WAIT_FOR_BOARD_CAP_EXE_FINISH] [board=!bat_board!]
!bat_echolog!
!BAT_RETURN!





	REM ****************************************************************
	REM *****       WAIT FOR CMD Shell TO FINISH                  *****
	REM
	REM It waits on the process handle using the WaitForFile tool
	REM ****************************************************************

:WAIT_FOR_CMD_FINISH [IN] "cmd_Capture8..._^<board^>.exe"
!bat_pushecho! [CALL !bat_batchfile!:WAIT_FOR_CMD_FINISH] [%~1]

	!bat_echolog!
	!bat_echolog! !bat_batchfile!_!bat_board! Waiting for "%~1" to finish.......
	!bat_echolog!
	      call WaitForFile rw "%~1" >nul: 2>&1
	!bat_echolog!

	!bat_echolog! !bat_batchfile!_!bat_board! Wait 60
	!bat_wait! 60

:WAIT_FOR_CMD_FINISH_END
!bat_popecho! [RETURN !bat_batchfile!:WAIT_FOR_CMD_FINISH] [%~nx1]
!bat_echolog!
!BAT_RETURN!



	REM ****************************************************************
	REM *****       SUSPEND BOARD 1's CMD SHELL                    *****
	REM
	REM Suspends the given command shell so that it doesn't interfere
	REM with BOARD 0's processing.  Also, it could become a problem 
	REM if the logs for the scripts in the two command shells are
	REM being intermingled.
	REM 
	REM Returns:
	REM    bat_RetVal           The process handle that was suspended
	REM ****************************************************************

:SUSPEND_CMD_SHELL [IN] "!bat_cmd_1!"
!bat_pushecho! [CALL !bat_batchfile!:SUSPEND_CMD_SHELL] [%*]
	SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

	!bat_logexeclog! process -s %~1
		
	!bat_echolog! It's now suspended


:SUSPEND_CMD_SHELL_END
!bat_popecho! [RETURN !bat_batchfile!:SUSPEND_CMD_SHELL] [bat_process_handle=!bat_process_handle!]
!bat_echolog!
ENDLOCAL
exit /b %~1
	REM YOU'LL NEVER GET TO HERE...
!BAT_RETURN!




	REM ****************************************************************
	REM *****       RESUME BOARD 1's CMD SHELL                    *****
	REM
	REM Resumes the given command shell so that it doesn't interfere
	REM with BOARD 0's processing.  Also, it could become a problem 
	REM if the logs for the scripts in the two command shells are
	REM being intermingled.
	REM 
	REM Returns:
	REM    bat_RetVal           The process handle that was suspended
	REM ****************************************************************

:RESUME_CMD_SHELL [IN] "!bat_cmd_0!"
!bat_pushecho! [CALL !bat_batchfile!:RESUME_CMD_SHELL] [%*]
	SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

	!bat_logexeclog! process -r %~1
	
	
	!bat_echolog! [!bat_batchfile!_!board!] It's now resumed



:RESUME_CMD_SHELL_END
!bat_popecho! [RETURN !bat_batchfile!:RESUME_CMD_SHELL] [CMD=%~1]
!bat_echolog!
ENDLOCAL
exit /b %~1
	REM YOU'LL NEVER GET TO HERE...
!BAT_RETURN!




:GET_PROCESS_HANDLE [IN] 
!bat_pushecho! [CALL !bat_batchfile!:GET_PROCESS_HANDLE] [%*]

	SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

	!bat_logexec! set bat_process_name=%~nx1
	
	!bat_logexec! set bat_process_handle=-1

		REM find the process handle for the given process's name...
	for /f "usebackq tokens=1-7" %%a in (`process -c ^| find /i "!bat_process_name!"`) do (
		!bat_logexec! set bat_process_handle=%%b
	)


:GET_PROCESS_HANDLE_END
!bat_popecho! [RETURN !bat_batchfile!:GET_PROCESS_HANDLE] [bat_process_handle=!bat_process_handle!]
!bat_echolog!
exit /b !bat_process_handle!

!BAT_RETURN!




	Flowchart:

		This script was designed to be called by the LaunchCapture.bat script.
		However, you may call it directly by providing the duration as a positive number of
		hours or the sun angle as a negative number of degrees of the sun below the horizon
		to start/stop capture. 
		For example:
		   start16cameras.bat -8 autonomous
		will delay starting the capture recording until the sun is 8 degrees below the horizon (astronomical twilight).
	
	The flow of the program is as follows:
	    - LAUNCH_CAPTURE8_BAT
	      - Make a unique copy of the CMD exe for the batch script so that it's trackable,
	        waitable, and so we can set affinity mask. 
	      - Asynchronously start the CMD and have it launch the Capture8_ReturnCode instance
	        for board 0.
	        
	        - Capture8_ReturnCode.bat for board 0 does this:
		      - Capture8_ReturnCode.bat:GET_PRECAPTUREFOLDER
		      - Capture8_ReturnCode.bat:CAPTURE
		        - Make a unique copy of the capture EXE so that it's trackable, waitable, and
		          so we can set the affinity mask. 
		          
	            - Wait 2 seconds so that Start16Cameras.bat can set affinity mask of this shell

	      - Start16Cameras: Wait 3 seconds to give CMD to have a chance to get the capture EXE going.
	      - Start16Cameras: Set affinity mask of the CMD for all CPUs

		        - Asynchronously start the capture EXE. 
		          
		          The EXE will start, create a CapturedFiles dir, then create an ArchivedFiles dir
		          Then it starts capturing.  Finally, it starts launching instances of
		          FTP_DetectSingleFF.exe to do the multi-threaded background detection. 
		          Somewhere in all these sub-procedures, it goofs up the EXE by settings
		          its affinity mask to CPU 4 & 5.
		          It takes several seconds before its ready to change the affinity mask
		          so it's kind of trial and error at this point. 
		        
		        - Wait 15 seconds to give the capture EXE a chance to create the 
		          capture session dirs [which is imprtant] and to get to the point where 
		          we can set the affinity mask of the EXE and any child processes. 
		          
		        - Set affinity mask of EXE to all CPUs
		        - Set affinity mask of all FTP_DetectSingleFF.exe instances to all CPUs
		        
		      - Capture8_ReturnCode.bat:GET_POSTCAPTUREFOLDER
		        - Identify the newly created CaptureSession folder, from which we can get the 
		          unique capture session [bat_capturedfilesdir, bat_capturedsession, 
		          bat_capturedatetime, bat_captureddate, bat_camera, and bat_archivedfilesdir]
		      - Capture8_ReturnCode.bat:WAIT_CAPTURE_FINISH
		        - Wait for capture EXE to end and go no further until it does
		      ------------------- BOARD 0 WAITING FOR CAPTURE -------------------------------------

- LAUNCH_CAPTURE8_BAT
	Start unique copy of cmd.exe for board 0, which then launches the 
	Capture8_ReturnCode.bat script for board 0
- 
		    - Make a copy of the CMD processor so it's trackable, waitable, suspendable, etc.
		    - 
		    - Asynchronously Start a unique copy of CMD.EXE for board 0, which then starts the 
		      Capture8_ReturnCode.bat script for board 0
		      - GET_PRECAPTUREFOLDER
		        Get Pre-capture folder


:HELP
	echo.%~0	Batch Script
	echo.Usage: %~0 ^<duration^> ^<autonomous^>
	echo.
	echo.Where:
	echo.   duration        is either a positive number of hours to record or
	echo.                   a negative number representing the sun angle.  
	echo.                   Specifying a negative number causes the program to
	echo.                   use the absolute value of the sun angle as the number
	echo.                   of degrees below the horizon to start/stop capture.
	echo.
	echo.   autonomous      Sets the mode so that no prompts will be displayed 
	echo.                   waiting for user input in the middle of the night.
	echo.
	echo.Example:
	echo.   %~0   0.1          to capture both cameras for 6 minutes.
	echo.   %~0   -8           to capture when between astronomical dusk to dawn.
	echo.
exit /b -99



:DONE
	!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! Done with %0 %*
	!bat_echolog!
	
exit /b !bat_returncode!
