rem @ECHO Off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

:SETUP
	set bat_return=goto :EOF

	rem Value of PI
	set _bat_pi=3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679
	

	echo.%*|find /i "/?">nul:
	if !errorlevel! equ 0 (goto :HELP)
	rem if "%~3"=="" (
	rem 	goto :HELP
	rem )

	set bat_returncode=99

	if /i "%~1" equ "pi" (
		if /i "%~2" equ "" (
			echo !_bat_pi!
			( ENDLOCAL & REM RETURN VALUES
				set bat_returncode=0
				SET BAT_RETVAL=%_bat_pi%
			)
			goto :DONE
		)
	)
	


	for /f "usebackq tokens=*" %%a in (`powershell %*`) do (
		!bat_log! [%%a]  [exit code=!errorlevel!]
		set bat_returncode=0
		SET BAT_RETVAL=%%~a
	)

	(ENDLOCAL&	REM RETURN VALUES
		set bat_retval=%bat_retval%
		set bat_returncode=%bat_returncode%
	)

	goto :DONE






	
	rem Clear out all the script's variables
	rem Clear the script's variables
	set bat_1=dummy
	set _inp_1=dummy
	for /f "usebackq tokens=1* delims==" %%a in (`set bat_`) do (set %%a=)
	for /f "usebackq tokens=1* delims==" %%a in (`set _INP_`) do (set %%a=)

	for /f "tokens=1-4 delims=/*xX-+" %%a in ("%*") do (
		rem set _INP_NUM1=%%a
		rem set _INP_NUM2=%%b
		
		call :STRIPWHITESPACE _INP_NUM1 %%a
		call :STRIPWHITESPACE _INP_NUM2 %%b
	)


	rem set "_INP_NUM1=%~1"
	rem set "_INP_NUM2=%~3"
	
	
	rem THIS SECTION DETERMINS THE OPERATOR...
	rem set "_INP_OP=%~2"
	rem if /i "%~2" equ "*" (
	rem 	set _INP_OP=x
	rem )

	rem Addition
	echo.%*|find /i "+">nul:
	if !errorlevel! equ 0 (
		set _INP_OP=+
	)

	rem Subtraction
	echo.%*|find /i "-">nul:
	if !errorlevel! equ 0 (
		set _INP_OP=-
	)

	rem Multiplication
	echo.%*|find /i "x">nul:
	if !errorlevel! equ 0 (
		set _INP_OP=x
	)
	
	rem Multiplication
	echo.%*|find /i "*">nul:
	if !errorlevel! equ 0 (
		set _INP_OP=x
	)

	rem Division
	echo.%*|find /i "/">nul:
	if !errorlevel! equ 0 (
		set _INP_OP=/
	)
	
	if /i "!_INP_NUM1!" equ "pi" (
		set _INP_NUM1=!_bat_pi!
	)
	
	if /i "!_INP_NUM2!" equ "pi" (
		set _INP_NUM2=!_bat_pi!
	)


goto :MAIN %*


:MAIN

	rem ***** Start Input validation *****

	rem ***** DETERMINE THE NUMBER OF DIGITS *****
	rem Default number of digits
	set _DIV_DP=3

	if /i "%~3" equ "digits" (
		set _DIV_DP=%~2
		goto :MAIN2
	)

	if /i "%~4" equ "digits" (
		set _DIV_DP=%~3
		goto :MAIN2
	)

	if "%~2"=="/" if not "%~4"=="" (
		for /f "delims=0123456789 tokens=1*" %%a in ("A0%~4") do (
			if "%%b"=="" (
				for /f "tokens=1* delims=0" %%c in ("A0%~4") do (
					if "%%d"=="" (
						set _DIV_DP=0
					) else set _DIV_DP=%%d
				)
			) else 1>&2 Echo ERROR: "%~4" not detected as a valid number of decimal places  &exit /b 1
		)
		shift /4
	)
	rem ***** END - DETERMINE THE NUMBER OF DIGITS *****

:MAIN2
	if not "%~4"=="" 1>&2 echo ERROR: Too many arguments: "%~4"&exit /b 1
	if not defined _INP_NUM1 1>&2 echo ERROR: Invalid Input: "!_INP_NUM1!"&exit /b 1
	if not defined _INP_NUM2 1>&2 echo ERROR: Invalid Input: "!_INP_NUM2!"&exit /b 1
	if not defined _INP_OP 1>&2 echo ERROR: Invalid Operator: "!_INP_OP!"&exit /b 1
	if not "!_INP_OP:~1!"=="" 1>&2 echo ERROR: Invalid Operator: "!_INP_OP!"&exit /b 1 

	rem ***** / ***** Start Negitive input ***** \ *****
	for %%a in (1 2) do (
		if "!_INP_NUM%%a:~0,1!"=="-" if not "!_INP_NUM%%a:~1!"=="" (
			set _INP_NUM%%a=!_INP_NUM%%a:~1!
			set _INP_NEG%%a=-
		) else 1>&2 echo ERROR: Invalid input: "!_INP_NUM%%a!"&exit /b 1
	)
	rem ***** \ ***** End Negitive input ***** / *****

	for /f "tokens=1* delims=0123456789." %%a in ("A0!_INP_NUM1!!_INP_NUM2!") do (
		if not "%%b"=="" 1>&2 echo ERROR: Invalid input: "!_INP_NUM1!" **OR** "!_INP_NUM2!"&exit /b 1
	)
	for %%a in (1 2) do (
		for /f "tokens=1-3 delims=." %%b in ("0!_INP_NUM%%a!0") do (
			if not "%%d"=="" 1>&2 echo ERROR: Invalid input: "!_INP_NUM%%a!"&exit /b 1
		)
	)
	for /f "tokens=1* delims=/Xx+-" %%a in ("A+!_INP_OP!") do (
		if not "%%b"=="" 1>&2 echo ERROR: Invalid operator: "!_INP_OP!"&exit /b 1
	)
	
	rem ***** End input validation *****

	rem ***** Start Remove leading zero's / Return for zero sums  *****
	for %%a in (1 2) do (
		for /f "tokens=1* delims=0" %%b in ("A0!_INP_NUM%%a!") do (
			if "%%c"=="" (
				if /i "!_INP_OP!"=="x" echo 0
				if "!_INP_OP!"=="/" (
					if %%a==2 (
						1>&2 Echo ERROR: Divide by zero
						exit /b 1.
					) else echo 0
				)
				if "!_INP_OP!"=="-" (
					if %%a==1 (
						if defined _INP_NEG2 (
							echo !_INP_NUM2!
						) else echo -!_INP_NUM2!
					) else (
						echo !_INP_NEG1!!_INP_NUM1!
					)
				)
				if "!_INP_OP!"=="+" (
					if %%a==1 (
						echo !_INP_NEG2!!_INP_NUM2!
					) else echo !_INP_NEG1!!_INP_NUM1!
				)
				exit /b 0
			) else set _INP_NUM%%a=%%c
		)
	)
	rem ***** End Remove leading zero's / Return for zero sums *****

	rem ***** Start Floating point normalisation *****
	for %%a in (1 2) do (
		if "!_INP_NUM%%a:~0,1!"=="." set _INP_NUM%%a=0!_INP_NUM%%a!
		if "!_INP_NUM%%a:~-1!"=="." set _INP_NUM%%a=!_INP_NUM%%a!0
		for /l %%b in (0 1 9) do set _INP_NUM%%a=!_INP_NUM%%a:%%b=%%b !
		for %%c in (!_INP_NUM%%a!) do set /a _INP_LEN%%a+=1
		set _INP_NUM%%a=!_INP_NUM%%a: =!
		if "!_INP_NUM%%a!"=="!_INP_NUM%%a:.=!" (
			set _INP_DP%%a=0
		) else (
			for /l %%d in (!_INP_LEN%%a! -1 1) do (
				if not defined _INP_DP%%a if "!_INP_NUM%%a:~%%d,1!"=="." (
					set /a _INP_DP%%a=!_INP_LEN%%a! - %%d
				)
			)
		)
		set _INP_NUM%%a=!_INP_NUM%%a:.=!
	)

	if !_INP_DP1! gtr !_INP_DP2! (
		set /a _INP_DP=_INP_DP1 - 1
	) else set /a _INP_DP=_INP_DP2 - 1
	for /l %%a in (!_INP_DP1! 1 !_INP_DP!) do set _INP_NUM1=!_INP_NUM1!0
	for /l %%a in (!_INP_DP2! 1 !_INP_DP!) do set _INP_NUM2=!_INP_NUM2!0
	rem ***** End Floating point normalisation *****

	rem ***** Start Negitive output checking *****
	if /i "!_INP_OP!"=="x" (
		if "!_INP_NEG1!!_INP_NEG2!"=="-" set _INP_NEG=-
	) else if "!_INP_OP!"=="+" (
		if "!_INP_NEG1!!_INP_NEG2!"=="--" set _INP_NEG=-
		if defined _INP_NEG2 if not defined _INP_NEG1 (
			call :isgreater !_INP_NUM1! !_INP_NUM2!
			if "!_GTR_RES!"=="3" (
				set _INP_NUM1=%_INP_NUM2%
				set _INP_NUM2=%_INP_NUM1%
				set _INP_NEG=-
			)
			set _INP_OP=-
		)
		if defined _INP_NEG1 if not defined _INP_NEG2 (
			call :isgreater !_INP_NUM1! !_INP_NUM2!
			if "!_GTR_RES!"=="3" (
				set _INP_NUM1=%_INP_NUM2%
				set _INP_NUM2=%_INP_NUM1%
			) else if "!_GTR_RES!"=="1" set _INP_NEG=-
			set _INP_OP=-
		)
	) else if "!_INP_OP!"=="-" (
		if "!_INP_NEG1!!_INP_NEG2!"=="" (
			call :isgreater !_INP_NUM1! !_INP_NUM2!
			if "!_GTR_RES!"=="3" (
				set _INP_NUM1=%_INP_NUM2%
				set _INP_NUM2=%_INP_NUM1%
				set _INP_NEG=-
			)
		)
		if "!_INP_NEG1!!_INP_NEG2!"=="--" (
			call :isgreater !_INP_NUM1! !_INP_NUM2!
			if "!_GTR_RES!"=="3" (
				set _INP_NUM1=%_INP_NUM2%
				set _INP_NUM2=%_INP_NUM1%
			) else if "!_GTR_RES!"=="1" set _INP_NEG=-
		)
		if defined _INP_NEG2 if not defined _INP_NEG1 set _INP_OP=+
		if defined _INP_NEG1 if not defined _INP_NEG2 (
			set _INP_NEG=-
			set _INP_OP=+
		)
	) else if "!_INP_OP!"=="/" (
		if "!_INP_NEG1!!_INP_NEG2!"=="--" set _INP_NEG=
		if "!_INP_NEG1!!_INP_NEG2!"=="-"  set _INP_NEG=-
	)
	rem ***** End Negitive output checking *****

	if "!_INP_OP!"=="-" goto subtract
	if "!_INP_OP!"=="+" goto add
	if /i "!_INP_OP!"=="X" goto multiply
	if "!_INP_OP!"=="/" goto divide
	goto :HELP








:SUBTRACT
	if "%~1"=="@" (
		set _SUB_NUM1=%~2
		set _SUB_NUM2=%~3
	) else (
		set _SUB_NUM1=!_INP_NUM1!
		set _SUB_NUM2=!_INP_NUM2!
	)
	for %%a in (CHA RES LEN1 LEN2 CAR TOT) do set _SUB_%%a=
	for %%a in (1 2) do (
		for /l %%b in (0 1 9) do set _SUB_NUM%%a=!_SUB_NUM%%a:%%b=%%b !
		for %%c in (!_SUB_NUM%%a!) do set /a _SUB_LEN%%a+=1
		set _SUB_NUM%%a=!_SUB_NUM%%a: =!
	)
	if !_SUB_LEN1! gtr !_SUB_LEN2! (
		set /a _SUB_LEN=_SUB_LEN1 - 1
	) else set /a _SUB_LEN=_SUB_LEN2 - 1
	for /l %%b in (!_SUB_LEN1! 1 !_SUB_LEN!) do set _SUB_NUM1=0!_SUB_NUM1!
	for /l %%b in (!_SUB_LEN2! 1 !_SUB_LEN!) do set _SUB_NUM2=0!_SUB_NUM2!
	for /l %%a in (!_SUB_LEN! -1 0) do (
		set /a _SUB_RES=!_SUB_NUM1:~%%a,1! - !_SUB_NUM2:~%%a,1!
		if !_SUB_RES! lss 0 (
			set _SUB_TAKE=
			for /l %%b in (%%a -1 0) do if not defined _SUB_TAKE (
				if not "%%b"=="%%a" (
					if not "!_SUB_NUM1:~%%b,1!"=="0" (
						set /a _SUB_CHA=!_SUB_NUM1:~%%b,1! - 1
						set /a _SUB_TAKE=%%b + 1
						for %%c in (!_SUB_TAKE!) do set _SUB_NUM1=!_SUB_NUM1:~0,%%b!!_SUB_CHA!!_SUB_NUM1:~%%c!
						set /a _SUB_RES=1!_SUB_NUM1:~%%a,1! - !_SUB_NUM2:~%%a,1!

					) else (
						set /a _SUB_CHA=%%b + 1
						for %%c in (!_SUB_CHA!) do set _SUB_NUM1=!_SUB_NUM1:~0,%%b!9!_SUB_NUM1:~%%c!
					)
				)
			)
		)
		set _SUB_TOT=!_SUB_RES!!_SUB_TOT!
	)
	for /f "tokens=1* delims=0" %%a in ("A0!_SUB_TOT!") do set _SUB_TOT=%%b
	if not defined _SUB_TOT set _SUB_TOT=0
	if not "%~1"=="@" (
		call :FINISH _SUB_TOT
		echo %_INP_NEG%!_SUB_TOT!
	)

	( ENDLOCAL & REM RETURN VALUES
		set bat_returncode=0
		SET BAT_RETVAL=%_FIN_NUM%
	)

goto :eof










:ADD
	if /I "%~1"=="@" (
		set _ADD_NUM1=%~2
		set _ADD_NUM2=%~3
	) else (
		set _ADD_NUM1=!_INP_NUM1!
		set _ADD_NUM2=!_INP_NUM2!
	)
	for %%a in (LEN1 LEN2 CAR TOT) do set _ADD_%%a=
	for %%a in (1 2) do (
		for /l %%b in (0 1 9) do set _ADD_NUM%%a=!_ADD_NUM%%a:%%b=%%b !
		for %%c in (!_ADD_NUM%%a!) do set /a _ADD_LEN%%a+=1
		set _ADD_NUM%%a=!_ADD_NUM%%a: =!
	)
	if !_ADD_LEN1! gtr !_ADD_LEN2! (
		set /a _ADD_LEN=_ADD_LEN1 - 1
	) else set /a _ADD_LEN=_ADD_LEN2 - 1
	for /l %%b in (!_ADD_LEN1! 1 !_ADD_LEN!) do set _ADD_NUM1=0!_ADD_NUM1!
	for /l %%b in (!_ADD_LEN2! 1 !_ADD_LEN!) do set _ADD_NUM2=0!_ADD_NUM2!
	for /l %%a in (!_ADD_LEN! -1 0) do (
		set /a _ADD_CAR=_ADD_CAR + !_ADD_NUM1:~%%a,1! + !_ADD_NUM2:~%%a,1!
		set _ADD_TOT=!_ADD_CAR:~-1!!_ADD_TOT!
		set _ADD_CAR=!_ADD_CAR:~0,-1!
		if not defined _ADD_CAR set _ADD_CAR=0
	)
	if !_ADD_CAR! gtr 0 set _ADD_TOT=!_ADD_CAR!!_ADD_TOT!
	if not "%~1"=="@" (
		Call :FINISH _ADD_TOT
		echo %_INP_NEG%!_ADD_TOT!
	)

	( ENDLOCAL & REM RETURN VALUES
		set bat_returncode=0
		SET BAT_RETVAL=%_FIN_NUM%
	)

goto :eof







:MULTIPLY
	set /a _INP_DP=(_INP_DP * 2) + 1
	set _MUL_NUM1=!_INP_NUM1!
	set _MUL_NUM2=!_INP_NUM2!
	for %%a in (CAR TOT) do set _MUL_%%a=0
	for %%a in (X10 REV1 REV2) do set _MUL_%%a=
	for %%a in (1 2) do (
		for /l %%b in (0 1 9) do set _MUL_NUM%%a=!_MUL_NUM%%a:%%b=%%b !
		for %%c in (!_MUL_NUM%%a!) do set _MUL_REV%%a=%%c !_MUL_REV%%a!
	)
	for %%a in (!_MUL_REV1!) do (
		set _MUL_ROW=!_MUL_X10!
		for %%b in (!_MUL_REV2!) do (
			set /a _MUL_CAR=^(%%a * %%b^) + _MUL_CAR
			set _MUL_ROW=!_MUL_CAR:~-1!!_MUL_ROW!
			set _MUL_CAR=!_MUL_CAR:~0,-1!
			if not defined _MUL_CAR set _MUL_CAR=0
		)
		for /f "tokens=1* delims=0" %%c in ("A0!_MUL_CAR!!_MUL_ROW!") do (
			if not "%%d"=="" (
				call :ADD @ %%d !_MUL_TOT!
				set _MUL_TOT=!_ADD_TOT!
			)
		)
		set _MUL_CAR=
		set _MUL_X10=!_MUL_X10!0
	)
	Call :FINISH _MUL_TOT
	echo %_INP_NEG%!_MUL_TOT!


	( ENDLOCAL & REM RETURN VALUES
		set bat_returncode=0
		SET BAT_RETVAL=%_FIN_NUM%
	)


goto :eof






:DIVIDE
	for %%a in (DONE LEN1 LEN2 X10 PAD) do set _DIV_%%a=
	for /l %%a in (1 1 %_DIV_DP%) do set _DIV_PAD=0!_DIV_PAD!
	set /a _INP_DP=_DIV_DP - 1
	set _DIV_NUM1=!_INP_NUM1!!_DIV_PAD!
	set _DIV_NUM2=!_INP_NUM2!
	set _DIV_TOT=0
	set _DIV_LOOP=10
	for %%a in (1 2) do (
		for /f "tokens=1* delims=0" %%d in ("A0!_DIV_NUM%%a!") do set _DIV_NUM%%a=%%e
		for /l %%b in (0 1 9) do set _DIV_NUM%%a=!_DIV_NUM%%a:%%b=%%b !
		for %%c in (!_DIV_NUM%%a!) do set /a _DIV_LEN%%a+=1
		set _DIV_NUM%%a=!_DIV_NUM%%a: =!
	)
	set /a _DIV_LEN1-=1
	for /l %%a in (!_DIV_LEN2! 1 !_DIV_LEN1!) do (
		set _DIV_X10=0!_DIV_X10!
		set /a _DIV_LOOP+=10
	)
	for /l %%a in (0 1 !_DIV_LOOP!) do (
		if not defined _DIV_DONE (
			call :ISGREATER !_DIV_NUM1! !_DIV_NUM2!!_DIV_X10!
			if !_GTR_RES! leq 2 (
				call :SUBTRACT @ !_DIV_NUM1! !_DIV_NUM2!!_DIV_X10!
				set _DIV_NUM1=!_SUB_TOT!
				call :ADD @ !_DIV_TOT! 1!_DIV_X10!
				set _DIV_TOT=!_ADD_TOT!
			) else if defined _DIV_X10 (
				set _DIV_X10=!_DIV_X10:~1!
			) else set _DIV_DONE=1
		)
	)
	Call :finish _DIV_TOT
	if "!_DIV_TOT!"=="0" (
		echo 0
		1>&2 echo ERROR: Insufficient decimal places^(!_DIV_DP!^)
	) else ( 
		echo !_INP_NEG!!_DIV_TOT!
	)

	( ENDLOCAL & REM RETURN VALUES
		set bat_returncode=0
		SET BAT_RETVAL=%_FIN_NUM%
	)


Goto :eof





:FINISH
	set _FIN_NUM=!%~1!
	set _FIN_FLAG=
	if not defined _INP_DP (
		set _INP_DP=0
	) else set /a _INP_DP+=1
	if not "!_INP_DP!"=="0" (
		for /l %%a in (1 1 !_INP_DP!) do if "!_FIN_NUM:~%_INP_DP%!"=="" set _FIN_NUM=0!_FIN_NUM!
		set _FIN_NUM=!_FIN_NUM:~0^,-%_INP_DP%!.!_FIN_NUM:~-%_INP_DP%!
		for /l %%a in (!_INP_DP! -1 1) do (
			if "!_FIN_NUM:~-1!"=="0" set _FIN_NUM=!_FIN_NUM:~0^,-1!
			if "!_FIN_NUM:~-1!"=="." set _FIN_NUM=!_FIN_NUM:~0^,-1!
		)
	)
	for /f "tokens=1* delims=0" %%a in ("A0!_FIN_NUM!") do (
		if "%%b"=="" (
			set _FIN_NUM=0
		) else set _FIN_NUM=%%b
	)
	if "!_FIN_NUM:~0,1!"=="." set _FIN_NUM=0!_FIN_NUM!
	IF NOT DEFINED _FIN_NUM SET _FIN_NUM=0
	set %1=!_FIN_NUM!
goto :eof


:ISGREATER
	for /f "tokens=1* delims=0" %%a in ("A0%~1") do (
		if "%%b"=="" (
			set _GTR_NUM1=0
		) else set _GTR_NUM1=%%b
	)
	for /f "tokens=1* delims=0" %%a in ("A0%~2") do (
		if "%%b"=="" (
			set _GTR_NUM2=0
		) else set _GTR_NUM2=%%b
	)
	for %%a in (RES lEN1 lEN2) do set _GTR_%%a=
	for %%a in (1 2) do (
		for /l %%b in (0 1 9) do set _GTR_NUM%%a=!_GTR_NUM%%a:%%b=%%b !
		for %%c in (!_GTR_NUM%%a!) do set /a _GTR_lEN%%a+=1
		set _GTR_NUM%%a=!_GTR_NUM%%a: =!
	)
	if !_GTR_lEN1! gtr !_GTR_lEN2! (
		set _GTR_RES=1
	) else if !_GTR_lEN2! gtr !_GTR_lEN1! (
		set _GTR_RES=3
	) else (
		set /a _GTR_lEN1-=1
		for /l %%a in (0 1 !_GTR_lEN1!) do (
			if not defined _GTR_RES (
				if !_GTR_NUM1:~%%a^,1! gtr !_GTR_NUM2:~%%a^,1! set _GTR_RES=1
				if !_GTR_NUM2:~%%a^,1! gtr !_GTR_NUM1:~%%a^,1! set _GTR_RES=3
			)
		)
	)
	if not defined _GTR_RES set _GTR_RES=2
goto :eof



:STRIPWHITESPACE
	set %~1=%~2
GOTO :EOF


:HELP
    echo STR_MATH.BAT v1.3
    echo.
    echo     Large number and floating point work around script
    echo     for Addition, Subtraction, Division and Multiplaction.
    echo     Floating point and negitive numbers supported.
    echo.
    echo     Usage:
    echo       STR_MATH.BAT {Number} {+} {Number}
    echo       STR_MATH.BAT {Number} {-} {Number}
    echo       STR_MATH.BAT {Number} [* or x] {Number} [n digits] 
    echo       STR_MATH.BAT {Number} / {Number} [n digits]
    echo       STR_MATH.BAT pi  returns pi to 100 digits
    echo.
    echo     Division defaults to a maximum three decimal places of output.
    echo     An optional user defined max can be input as the fourth number.
    echo     No rounding is performed on output of division, any remainder
    echo     is discarded.
    echo.
    echo     Output Will be echo'd, a "for /f" loop can be used to
    echo     capture the output.
    echo.
    echo     The result will be returned in the BAT_RETVAL variable. 
    echo.
    echo.Examples:
    echo.   "3 * 25 + 100"
    echo.   bat_RetVal=175
    echo.
    echo.   "3 * (25 + 100)"
    echo.   bat_RetVal=375
    echo.
    set /p =-Judago OCT - DEC 2011- Send bugs to strmathnew.t.remel<nul
    echo @antichef.com
    echo Provided "AS-IS"
    echo Only tested on XP
exit /b -99


:DONE
exit /b !bat_returncode!
