 @echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

rem	if "%~1" equ "" goto :HELP

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"

	call "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

goto :MAIN %*





	REM #########################################################################
	REM This script is designed to work from the RunFolder dir. 
	REM
	REM Technically, it should work from any directory, but it is designed to use 
	REM the Queue directory and temporary directories from the queue dir for validity
	REM checks and so forth. 
	REM 

:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] %1
!bat_TITLE! [!bat_batchfile!:MAIN] %1

	if not exist "!bat_exedir!\en-US" (
		MD "!bat_exedir!\en-US"
	)

	!bat_logexec! copy /y "%windir%\system32\cmd.exe"           "!bat_exedir!\cmd_ftp_upload_robust_seti.bat.exe"
	!bat_logexec! copy /y "%windir%\system32\en-US\cmd.exe.mui" "!bat_exedir!\en-US\cmd_ftp_upload_robust_seti.bat.exe.mui"

	set bat_loop_again=true

:MAIN_LOOP
!bat_log! [GOTO !bat_batchfile!:MAIN_LOOP] %1

	CALL "!bat_exedir!\ReadParams.bat"

		rem Get the bat_capturedfilesdir value
	call "!bat_exedir!\ReadConfig.bat"
	
	call "!bat_exedir!\ReadCams2Global.bat"

rem	set bat_cams2
	
	!bat_WAIT! 2	"[!bat_batchfile!:MAIN_LOOP] bat_CAMS2UPLOAD.upload_target_folder=!bat_CAMS2UPLOAD.upload_target_folder!"

	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_echolog! set bat_boards_max=!bat_boards_max!
	
	!bat_echolog! [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[ - calling ZipCams2FromFTP.bat
	!bat_echolog! [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	!bat_echolog!
	!bat_CALL! "!bat_exedir!\ZipCams2FromFTP.bat"
rem	if !errorlevel! neq 0 (goto :MAIN_LOOP_CONTINUE)
	!bat_echolog!
	!bat_echolog! ]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
	!bat_echolog! ]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]] - returned from ZipCams2FromFTP.bat
	

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	!bat_logexeclog! set bat_ftpfile2=!bat_exedir!\ftp.temp2.txt
	!bat_logexeclog! set bat_ftpfile3=!bat_exedir!\ftp.temp3.txt
	
	!bat_logexeclog! set bat_winscpfile=!bat_exedir!\winscp.ftp.temp.txt

		rem All these files exist under the queue dir
	
	!bat_logexeclog! set bat_queuefilefull=!bat_CAMS2QUEUE.queue_dir!\!bat_CAMS2QUEUE.queue_filename!


	rem     1. Loop through the queue directory. :CREATE_QUEUEFILE
	CALL :CREATE_QUEUEFILE 
	if !errorlevel! neq 0 (
			REM Queue is Empty - goto MAIN_LOOP to Re-read the queue
			
			CALL :CHECK_CAPTURED
				rem this section causes the looping to end.  We have determined there is not going to be any more work to do today...
			IF !errorlevel! neq 0 (
				if defined bat_loop_again (
					set bat_loop_again=
					goto :MAIN_LOOP_CONTINUE
				)
				GOTO :MAIN_END
			)
			
		goto :MAIN_LOOP_CONTINUE
	) else (
		if !errorlevel! equ 0 (
			set bat_loop_again=true
		)
	)

	rem     2. Get the last entry in the queue file	:GET_QUEUE_ENTRY
	CALL :GET_QUEUE_ENTRY
	
	if !errorlevel! equ 11 (
			REM goto MAIN to Re-read the queue
		goto :MAIN_LOOP_CONTINUE
	)

:MAIN_LOOP_CONTINUE
	!bat_TITLE! [!bat_batchfile!:MAIN_LOOP] %1
	!bat_WAIT! !bat_CAMS2UPLOAD.RETRY_DELAY!   "Waiting 60 seconds for new queue items..."
	!bat_poplog!
	goto :MAIN_LOOP
	
:MAIN_END
!bat_poplog! [:MAIN_END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:MAIN_END
goto :DONE




	REM #########################################################################
	REM 1. Create the queue file. :CREATE_QUEUEFILE
	REM
	REM Note: This will only add the zip file names to the queue list.  The MD5
	REM       files will be handled by the "ftp_upload_robust_seti.bat" script. 
	REM
	REM       We have to handle the sequence numbers to each zip file.  
	REM

:CREATE_QUEUEFILE
!bat_pushlog! [CALL !bat_batchfile!:CREATE_QUEUEFILE] %1
!bat_TITLE! [!bat_batchfile!:CREATE_QUEUEFILE] %1

	set bat_returncode=0

	if not exist "!bat_CAMS2QUEUE.queue_dir!" (
		MD "!bat_CAMS2QUEUE.queue_dir!"

		set bat_returncode=!errorlevel!
	)

%bat_COMMENT_BEGIN%	Removed because it's redundant with the new 0 byte file size check below 
	if not exist "!bat_CAMS2QUEUE.queue_dir!\*.zip*" (
		set bat_returncode=11
		!bat_echolog! 
		!bat_echolog! `   *** OK - Queue empty ***
		!bat_echolog!
	)
%bat_COMMENT_END%


	REM

		REM The following command "*.zip.???" will include "*.zip" and "*.zip.???"...
	!bat_logexeclog! dir /b /a-d /o-n "!bat_CAMS2QUEUE.queue_dir!\*.zip.???"
	                 dir /b /a-d /o-n "!bat_CAMS2QUEUE.queue_dir!\*.zip.???">"!bat_queuefilefull!"

	!bat_logexec! type "!bat_queuefilefull!"

	PUSHD "!bat_CAMS2QUEUE.queue_dir!"

		REM ****************************************************************
		REM This next section checks the size of the queue file. 
	set bat_empty=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir /b /a-d "!bat_queuefilefull!"`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir /b /a-d "!bat_queuefilefull!"`) do (
		if %%~za equ 0 (
			!bat_echolog! `     *** %%~za bytes   "!bat_queuefilefull!" 
			!bat_logexeclog! set bat_empty=true
		)
	)
	!bat_poplog! ^)
	
	POPD
	
	if defined bat_empty (
			rem If the queue is empty, then signal that we can stop
		set bat_returncode=1
	)


:CREATE_QUEUEFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CREATE_QUEUEFILE] [bat_returncode=!bat_returncode!, bat_queuefilefull="!bat_queuefilefull!"]
!bat_log!
rem !bat_WAIT! 0	:CREATE_QUEUEFILE_END
!bat_TITLE! [!bat_batchfile!:MAIN] %*
set bat_empty=
!bat_return! !bat_returncode!






	REM #########################################################################
	REM This script should end itself under the following circumstances:
	REM 1. All the CapturedFiles dirs for all the boards have no subdirs
	REM 2. The queue file is empty
	REM
	REM Returns:
	REM    bat_returncode              0=ok.  
	REM                                1=End the script
	REM

:CHECK_CAPTURED
!bat_pushlog! [CALL !bat_batchfile!:CHECK_CAPTURED] %1
!bat_TITLE! [!bat_batchfile!:CHECK_CAPTURED] %1

	set bat_returncode=0
	
	set bat_found=
	
	!bat_pushlog! for /L %%x in ^(0,1,!bat_boards_max!^) do ^(
	for               /L %%x in  (0,1,!bat_boards_max!) do (
		set bat_camsdir=!bat_CAMS2DIR.%%x!
		set bat_caldir=!bat_CAMS2DIR.%%x!\Cal
		
			REM If there are any files to do post-capture processing for, then signal to keep going...
		for /f "usebackq tokens=*" %%a in (`dir /b /ad "!bat_camsdir!\CapturedFiles"`) do (
				rem If you get here, then there is work to do. "true" means to signal a quit
			set bat_found=true
		)
	)
	
		REM If the queue is not empty, then signal to keep going...
	for /f "usebackq tokens=*" %%a in (`dir /b /a-d "!CAMS2QUEUE.queue_dir!\!CAMS2QUEUE.queue_dir.queue_filename!"`) do (
		if %%~za NEQ 0 (
			set bat_found=true
		)
	)
	
	if not defined bat_found (
		set bat_returncode=1
	)


:CHECK_CAPTURED_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_CAPTURED] [bat_returncode=!bat_returncode!, bat_queuefilefull="!bat_queuefilefull!"]
!bat_log!
rem !bat_WAIT! 0	:CHECK_CAPTURED_END
!bat_TITLE! [!bat_batchfile!:MAIN] %*
set bat_found=
!bat_return! !bat_returncode!









	REM #########################################################################
	REM 2. Gets the next file to process by reading the queue file and	:GET_QUEUE_ENTRY
	REM    returning the last entry in the file. 
	REM
	REM Returns:
	REM    bat_returncode              0=ok.  All other values means fail - don't attempt to upload it. 
	REM

:GET_QUEUE_ENTRY
!bat_pushlog! [CALL !bat_batchfile!:GET_QUEUE_ENTRY] %1
!bat_TITLE! [!bat_batchfile!:GET_QUEUE_ENTRY] %1

	set bat_returncode=0
	
	set bat_queue_empty=true
	set bat_tempfilefull=
	
		REM The queue needs to be re-read each time it finds a file.
		
	for /f "usebackq tokens=*" %%a in (`type "!bat_queuefilefull!"`) do (
		!bat_echolog! Queue file entry: %%a
		set bat_queue_empty=false
		set bat_tempfilefull=!bat_CAMS2QUEUE.queue_dir!\%%a
		set bat_tempfile_name=%%~nxa
		set bat_tempfile_nameonly=%%~na
		set bat_tempfile_ext=%%~xa
		set bat_tempfile_ext=!bat_tempfile_ext:~1!
		if /i "!bat_tempfile_ext!" equ "zip" (
			set bat_tempfile_nameroot=!bat_tempfile_nameonly:~0,-3!
		)
		if /i "!bat_tempfile_ext:~0,1!" equ "0" (
			set bat_tempfile_nameroot=!bat_tempfile_nameonly:~0,-7!
		)
		set bat_submissionsession=!bat_tempfile_nameroot!

		CALL :DOWNLOAD_SERVER_LIST 

		CALL :CHECK_ALREADY_TRANSMITTED "!bat_tempfilefull!"
		if !errorlevel! equ 0 (
				REM EXECUTES THIS IN ITS OWN COMMAND SHELL

			!bat_echolog! vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
			!bat_echolog! vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

			!bat_echolog! START "UPLOAD %%a" /W "!bat_exedir!\cmd_ftp_upload_robust_seti.bat.exe" /c ""!bat_exedir!\ftp_upload_robust_seti.bat" "!bat_tempfilefull!""
				      START "UPLOAD %%a" /W "!bat_exedir!\cmd_ftp_upload_robust_seti.bat.exe" /c ""!bat_exedir!\ftp_upload_robust_seti.bat" "!bat_tempfilefull!""

			!bat_echolog! AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
			!bat_echolog! AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

		)

	)
	
	if not defined bat_tempfilefull (
		set bat_queue_empty=true
		set bat_returncode=11
		!bat_echolog! 
		!bat_echolog! `   *** OK - Queue empty ***
		!bat_echolog!
	)
	

:GET_QUEUE_ENTRY_END
!bat_poplog! [RETURN !bat_batchfile!:GET_QUEUE_ENTRY] [bat_returncode=!bat_returncode!, 
!bat_log! `                            queue file="!bat_queuefilefull!",
!bat_log! `                            bat_queue_empty=!bat_queue_empty!,
!bat_log! `                            bat_tempfilefull="!bat_tempfilefull!"]
!bat_log!
rem !bat_WAIT! 0	:GET_QUEUE_ENTRY_END
!bat_TITLE! [!bat_batchfile!:MAIN] %*
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Download a list of all .md5.txt files on the server into !bat_ftpfile3! 	:DOWNLOAD_SERVER_LIST
	REM so that the list can be scanned locally to determine if a file needs to
	REM be sequenced.
	REM
	REM If it exists on the server and !bat_CAMS2UPLOAD.sequence!=true, then
	REM if needs to increment the sequence number before uploading.  
	REM
	REM If !bat_CAMS2UPLOAD.sequence! NEQ true, then it doesn't matter because
	REM we can just overwrite.  Ideally, it will also check for !bat_CAMS2UPLOAD.overwrite!=true
	REM but not sure if that check is necessary. 
	REM
	REM bat_returncode=0 means to skip this file. 
	REM
	REM Returns:
	REM    bat_returncode              0=means the bat_ftpfile3 was created or that it is not necessary because of sequence NEQ true
	REM                                1=means it failed to create the file
	REM                                2=means that it is not necessary
	REM Uses "!bat_ftpfile2!".  
	REM Uses "!bat_ftpfile3!".  
	REM

:DOWNLOAD_SERVER_LIST [IN] "file name"
!bat_pushecho! [CALL !bat_batchfile!:DOWNLOAD_SERVER_LIST] %1
!bat_TITLE! [!bat_batchfile!:DOWNLOAD_SERVER_LIST] %1

	set bat_returncode=0
	
	set bat_tempfilename=%~1
	set bat_tempfile_name=%~nx1


:DOWNLOAD_SERVER_LIST_10

	if exist "!bat_ftpfile2!" (
		DEL /Q "!bat_ftpfile2!"
		if !errorlevel! neq 0 (
			!bat_WAIT! 5   "ERROR - Can't delete.  Retrying in..."
			goto :TEST_MD5_ONSERVER_10
		)
	)


		if not exist "!bat_CAMS2QUEUE.queue_dir!\Temp\zip" (
			MD "!bat_CAMS2QUEUE.queue_dir!\Temp\zip"
		)


	!bat_echolog!
	!bat_echolog! Now download/caching a LIST of files using the "dir" FTP command file "!bat_ftpfile!"...
	!bat_echolog! and save the results into "!bat_ftpfile2!"
	!bat_pushecho! 
	
		echo user !bat_ftpuser!>"!bat_ftpfile!"
		echo !bat_ftppassword!>>"!bat_ftpfile!"
		echo bin>>"!bat_ftpfile!"
		
		echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>!bat_ftpfile!"
		echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		
		echo dir "*.*">>!bat_ftpfile!"
		echo quit>>"!bat_ftpfile!"
		
		!bat_logexec! type "!bat_ftpfile!"


			!bat_echolog!
			!bat_echolog!


			echo open ftp://!bat_ftpuser!:!bat_ftppassword!@!bat_ftpsite!>"!bat_winscpfile!"
			echo cd !bat_CAMS2UPLOAD.upload_target_folder!>>"!bat_winscpfile!"
			echo lcd "!bat_CAMS2QUEUE.queue_dir!\Temp\zip">>"!bat_winscpfile!"
			echo dir "*.*">>"!bat_winscpfile!"
			echo bye>>"!bat_winscpfile!"

			!bat_logexec! type "!bat_winscpfile!"


		
		if exist "!bat_ftpfile2!" (
			!bat_logexeclog! DEL /Q "!bat_ftpfile2!" 
		)

			rem cleanup
		if exist "!bat_ftpfile3!" (
			!bat_logexeclog! DEL /Q "!bat_ftpfile3!"
		)

		
		set bat_size_server=
		set bat_temp=
		
			rem EXECUTE the FTP ls/dir listing and read the outcome, scanning for a line that contains
			rem the file name along with "-rw-", which is the one that has the file size on the server. 
			rem
			rem I had to come up with a workaround for a silly problem where the 
			rem creation of the listing file has 0D 0D 0A instead of 0D 0A.
			rem Therefore, I had to use a delimited file using exclamation point as the delimiter...
			rem The outcome of  this file is the "!bat_ftpfile2!". 

		!bat_log! call "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"][findstr /i /c:"-rw"   }"!bat_exedir!\winscp.temp2.txt"

		call           "!bat_exedir!\winscp.com" /script="!bat_winscpfile!"|findstr /i /c:"-rw">   "!bat_exedir!\winscp.temp2.txt"
			
rem		!bat_pushecho! for  /f "usebackq tokens=1-10*" ..a in ^(`call FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!][findstr /i /c:"-rw"`^) do ^(
rem		for                 /f "usebackq tokens=1-10*" %%a in  (`call FTP -n -s:"!bat_ftpfile!" !bat_ftpsite!^|findstr /i /c:"-rw"`) do (

		!bat_pushecho! for  /f "usebackq tokens=1-10*" ..a in ^(`type "!bat_exedir!\winscp.temp2.txt"`^) do ^(
		for                 /f "usebackq tokens=1-10*" %%a in  (`type "!bat_exedir!\winscp.temp2.txt"`) do (

			set bat_size_server=%%e
rem			set bat_temp=%%e
			set bat_temp=%%j

			!bat_echolog! bat_temp=!bat_temp!, bat_size_server=!bat_size_server!, "%%a"
			
			echo.!bat_temp!>>"!bat_ftpfile3!"
		)
		!bat_popecho! ^)
		
			rem If the file didn't get created, there are no files on the server.   
		if not exist "!bat_ftpfile3!" (
			!bat_echolog!
			!bat_echolog! No files on server: "!bat_tempfile_name!"
			!bat_echolog!     *** IT IS SAFE TO UPLOAD THIS FILE*** "!bat_tempfile_name!"
			!bat_echolog!
			set bat_returncode=0
	!bat_popecho!
			goto :DOWNLOAD_SERVER_LIST_END
		)

	!bat_logexecLOG! SORT "!bat_ftpfile3!"
		
			rem Since the file was found, we signal to skip uploading it.
		set bat_returncode=0

	!bat_popecho!


:DOWNLOAD_SERVER_LIST_END
!bat_poplog! [RETURN !bat_batchfile!:DOWNLOAD_SERVER_LIST] [bat_returncode=!bat_returncode!, bat_size_server=!bat_size_server!, bat_tempfile_name=!bat_tempfile_name!]
!bat_log!
rem !bat_WAIT! 0	:DOWNLOAD_SERVER_LIST_END
!bat_TITLE! - %~nx0
!bat_return! !bat_returncode!





	REM #########################################################################
	REM  CHECK_ALREADY_TRANSMITTED
	REM
	REM Checks if the zip file has already been transmitted.  This is determined
	REM by...
	REM   1. It does not exist already in the Transmitted dir
	REM   2. It's associated md5.txt file is not in the Transmitted dir
	REM
	REM Returns:    0=Needs to transmit
	REM             Any other value means to skip
	REM   

:CHECK_ALREADY_TRANSMITTED [IN] "!bat_tempfilefull!"
!bat_pushlog! [CALL !bat_batchfile!:CHECK_ALREADY_TRANSMITTED] %1
!bat_TITLE! [!bat_batchfile!:CHECK_ALREADY_TRANSMITTED] %1

	set bat_returncode=0
	
	set bat_tempfilefull=%~1
	set bat_tempfile_name=%~nx1
	set bat_transmitteddir=!bat_CAMS2QUEUE.queue_dir!\Transmitted

	!bat_echolog! if not exist "!bat_tempfilefull!.md5.txt" 
	if not exist               "!bat_tempfilefull!.md5.txt" (
		set bat_returncode=1
		!bat_echolog! 
		!bat_echolog! `    ERROR [!bat_batchfile!:CHECK_ALREADY_TRANSMITTED:!bat_returncode!] - 
		!bat_echolog! `            Missing associated md5.txt file: "!bat_tempfilefull!.md5.txt"
		!bat_echolog! `            Might be an indication that it is still in the process of 
		!bat_echolog! `            being copied to this dir.
		!bat_echolog!
		goto :CHECK_ALREADY_TRANSMITTED_END
	)

	
	!bat_log! if exist "!bat_transmitteddir!\!bat_tempfile_name!" 
	if exist           "!bat_transmitteddir!\!bat_tempfile_name!" (
		set bat_returncode=2
		
		!bat_echolog! 
		!bat_echolog! `   [!bat_batchfile!:CHECK_ALREADY_TRANSMITTED:!bat_returncode!] - Already transmitted
		!bat_echolog!
		
		if /i "!bat_transmitteddir!\!bat_tempfile_name!" neq "" (
			!bat_echolog! ` **** Deleting "!bat_transmitteddir!\!bat_tempfile_name!"
			!bat_logexeclog! DEL /Y "!bat_transmitteddir!\!bat_tempfile_name!"
		)
		goto :CHECK_ALREADY_TRANSMITTED_END


		!bat_log! if exist "!bat_transmitteddir!\!bat_tempfile_name!.md5.txt" 
		if exist           "!bat_transmitteddir!\!bat_tempfile_name!.md5.txt" (
			set bat_returncode=3

			!bat_echolog! 
			!bat_echolog! `   [!bat_batchfile!:CHECK_ALREADY_TRANSMITTED:!bat_returncode!] - MD5 Already transmitted
			!bat_echolog!
			
			if /i "!bat_transmitteddir!\!bat_tempfile_name!.md5.txt" neq "" (
				!bat_logexeclog! DEL /Y "!bat_transmitteddir!\!bat_tempfile_name!.md5.txt"
				!bat_echolog! ` **** Deleting "!bat_transmitteddir!\!bat_tempfile_name!.md5.txt"
			)
			goto :CHECK_ALREADY_TRANSMITTED_10
		)
		
	)


	!bat_echolog! 
	!bat_echolog! `   Needs to ateempt to transmit [!bat_batchfile!:CHECK_ALREADY_TRANSMITTED:!bat_returncode!] - "!bat_tempfilefull! "
	!bat_echolog!
	
	goto :CHECK_ALREADY_TRANSMITTED_END


:CHECK_ALREADY_TRANSMITTED_10
!bat_log! [GOTO !bat_batchfile!:CHECK_ALREADY_TRANSMITTED] %1
	


:CHECK_ALREADY_TRANSMITTED_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_ALREADY_TRANSMITTED] [bat_returncode=!bat_returncode!, bat_tempfilefull=!bat_tempfilefull!]
!bat_log!
rem !bat_WAIT! 0	:CHECK_ALREADY_TRANSMITTED_END
!bat_TITLE! [!bat_batchfile!:MAIN] %*
!bat_return! !bat_returncode!











	REM #########################################################################
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.   Usage %~0 
	echo.    
	echo.   Performs the upload script on each file in the queue.  For each file
	echo.   it processes, it works on it until it succeeds by retrying if something
	echo.   goes wrong.  The "ftp_upload_robust_seti.bat" script performs the actual
	echo.   upload.
	echo.   
	echo.   The "queue" dir is specified in the "Cams2Global.ini" file.  Let's say
	echo.   that is "D:\cams2_queue".  A "..\Temp\ZIP" dir is made to facilitate testing and
	echo.   validating the zip and uploaded files.  
	echo.   
	echo.   It accommodates split zip files.
	echo.   
	echo.   The queue dir is populated from the various "...\CAMS\Submitted" dirs.  It 
	echo.   re-populates Submitted dirs from "...\SubmissionFiles\[session]\FTP" folders.  
	echo.   
	echo.   WORKFLOW:
	echo.     1. Build the queue file.  Populate it with "*.zip*", excluding "*.md5.txt"
	echo.        files.  Doing it this way will include all zip files as well as split
	echo.        zip files that have "*.zip.00n". 
	echo.
	echo.     2. Each zip file must have an associated "*.md5.txt" file.  Without that file,
	echo.        this script must assume that the zip file is still being copied and that
	echo.        it's not finished with that operation. 
	echo.
	echo.     3. 
	echo.   
	echo.   
	REM  DEPENDS ON:
	REM     Cams2Global.ini
	REM     autocams.params.ini
	REM     GetDate2.bat
	REM     MD5CreateFile.bat
	REM     MoveTransmit.bat
	REM     cmd_ftp_upload_robust_seti.bat.exe
	REM     7za.exe
	REM     autocams.setup.bat
	REM     ftpHash.bat
	REM     cmd_ftp_upload_robust_seti.bat.exe
	REM     en-US\cmd_ftp_upload_robust_seti.bat.exe.mui
	REM     "!bat_CAMS2QUEUE.queue_dir!\Temp\zip\"
	REM     LaunchCapture.exe
	REM    
	
!bat_return! 99


	REM #########################################################################
	REM 

:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!
exit /b !bat_returncode!

